#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 3180
#define SYMBOL_COUNT 147
#define ALIAS_COUNT 5
#define TOKEN_COUNT 92
#define EXTERNAL_TOKEN_COUNT 12
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_heredoc_start = 1,
  sym__simple_heredoc_body = 2,
  sym__heredoc_body_beginning = 3,
  sym__heredoc_body_middle = 4,
  sym__heredoc_body_end = 5,
  sym_file_descriptor = 6,
  sym__empty_value = 7,
  sym__concat = 8,
  sym_variable_name = 9,
  anon_sym_for = 10,
  anon_sym_in = 11,
  anon_sym_LPAREN_LPAREN = 12,
  anon_sym_RPAREN_RPAREN = 13,
  anon_sym_while = 14,
  anon_sym_do = 15,
  anon_sym_done = 16,
  anon_sym_if = 17,
  anon_sym_then = 18,
  anon_sym_fi = 19,
  anon_sym_elif = 20,
  anon_sym_else = 21,
  anon_sym_case = 22,
  anon_sym_esac = 23,
  anon_sym_PIPE = 24,
  anon_sym_RPAREN = 25,
  anon_sym_SEMI_SEMI = 26,
  anon_sym_function = 27,
  anon_sym_LPAREN = 28,
  anon_sym_LBRACE = 29,
  anon_sym_RBRACE = 30,
  anon_sym_PIPE_AMP = 31,
  anon_sym_AMP_AMP = 32,
  anon_sym_PIPE_PIPE = 33,
  anon_sym_BANG = 34,
  anon_sym_LBRACK = 35,
  anon_sym_RBRACK = 36,
  anon_sym_LBRACK_LBRACK = 37,
  anon_sym_RBRACK_RBRACK = 38,
  anon_sym_declare = 39,
  anon_sym_typeset = 40,
  anon_sym_export = 41,
  anon_sym_readonly = 42,
  anon_sym_local = 43,
  anon_sym_unset = 44,
  anon_sym_unsetenv = 45,
  anon_sym_EQ_TILDE = 46,
  anon_sym_EQ_EQ = 47,
  anon_sym_EQ = 48,
  anon_sym_PLUS_EQ = 49,
  anon_sym_LT = 50,
  anon_sym_GT = 51,
  anon_sym_GT_GT = 52,
  anon_sym_AMP_GT = 53,
  anon_sym_AMP_GT_GT = 54,
  anon_sym_LT_AMP = 55,
  anon_sym_GT_AMP = 56,
  anon_sym_LT_LT = 57,
  anon_sym_LT_LT_DASH = 58,
  anon_sym_LT_LT_LT = 59,
  anon_sym_BANG_EQ = 60,
  sym__special_characters = 61,
  anon_sym_DQUOTE = 62,
  anon_sym_DOLLAR = 63,
  sym__string_content = 64,
  sym_raw_string = 65,
  anon_sym_POUND = 66,
  anon_sym_DOLLAR_LBRACE = 67,
  anon_sym_SLASH = 68,
  anon_sym_COLON = 69,
  anon_sym_COLON_QMARK = 70,
  anon_sym_COLON_DASH = 71,
  anon_sym_PERCENT = 72,
  anon_sym_DASH = 73,
  anon_sym_DOLLAR_LPAREN = 74,
  anon_sym_BQUOTE = 75,
  anon_sym_LT_LPAREN = 76,
  anon_sym_GT_LPAREN = 77,
  sym_comment = 78,
  aux_sym_SLASH_BSLASHw_PLUS_SLASH = 79,
  anon_sym_STAR = 80,
  anon_sym_AT = 81,
  anon_sym_QMARK = 82,
  anon_sym_0 = 83,
  anon_sym__ = 84,
  sym_word = 85,
  sym_test_operator = 86,
  sym_regex = 87,
  sym_regex_without_right_brace = 88,
  anon_sym_SEMI = 89,
  anon_sym_LF = 90,
  anon_sym_AMP = 91,
  sym_program = 92,
  sym__terminated_statement = 93,
  sym_for_statement = 94,
  sym_c_style_for_statement = 95,
  sym_while_statement = 96,
  sym_do_group = 97,
  sym_if_statement = 98,
  sym_elif_clause = 99,
  sym_else_clause = 100,
  sym_case_statement = 101,
  sym_case_item = 102,
  sym_last_case_item = 103,
  sym_function_definition = 104,
  sym_compound_statement = 105,
  sym_subshell = 106,
  sym_pipeline = 107,
  sym_list = 108,
  sym_negated_command = 109,
  sym_test_command = 110,
  sym_declaration_command = 111,
  sym_unset_command = 112,
  sym_command = 113,
  sym_command_name = 114,
  sym_variable_assignment = 115,
  sym_subscript = 116,
  sym_file_redirect = 117,
  sym_heredoc_redirect = 118,
  sym_heredoc_body = 119,
  sym_herestring_redirect = 120,
  sym__expression = 121,
  sym_binary_expression = 122,
  sym_unary_expression = 123,
  sym_parenthesized_expression = 124,
  sym_concatenation = 125,
  sym_string = 126,
  sym_array = 127,
  sym_simple_expansion = 128,
  sym_string_expansion = 129,
  sym_expansion = 130,
  sym_command_substitution = 131,
  sym_process_substitution = 132,
  aux_sym_program_repeat1 = 133,
  aux_sym_for_statement_repeat1 = 134,
  aux_sym_while_statement_repeat1 = 135,
  aux_sym_if_statement_repeat1 = 136,
  aux_sym_case_statement_repeat1 = 137,
  aux_sym_case_item_repeat1 = 138,
  aux_sym_declaration_command_repeat1 = 139,
  aux_sym_unset_command_repeat1 = 140,
  aux_sym_command_repeat1 = 141,
  aux_sym_command_repeat2 = 142,
  aux_sym_heredoc_body_repeat1 = 143,
  aux_sym_concatenation_repeat1 = 144,
  aux_sym_string_repeat1 = 145,
  aux_sym_expansion_repeat1 = 146,
  alias_sym_case_item = 147,
  alias_sym_regex = 148,
  alias_sym_special_variable_name = 149,
  alias_sym_variable_name = 150,
  alias_sym_word = 151,
};

static const char *ts_symbol_names[] = {
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_LPAREN_LPAREN] = "((",
  [anon_sym_RPAREN_RPAREN] = "))",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_BANG_EQ] = "!=",
  [sym__special_characters] = "_special_characters",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DOLLAR] = "$",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH] = "-",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = "/\\w+/",
  [anon_sym_STAR] = "*",
  [anon_sym_AT] = "@",
  [anon_sym_QMARK] = "?",
  [anon_sym_0] = "0",
  [anon_sym__] = "_",
  [sym_word] = "word",
  [sym_test_operator] = "test_operator",
  [sym_regex] = "regex",
  [sym_regex_without_right_brace] = "regex_without_right_brace",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_c_style_for_statement] = "c_style_for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "last_case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_negated_command] = "negated_command",
  [sym_test_command] = "test_command",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_while_statement_repeat1] = "while_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_case_item] = "case_item",
  [alias_sym_regex] = "regex",
  [alias_sym_special_variable_name] = "special_variable_name",
  [alias_sym_variable_name] = "variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym__special_characters] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_test_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_without_right_brace] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_c_style_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_command] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_regex] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[23][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [0] = alias_sym_variable_name,
  },
  [3] = {
    [1] = alias_sym_word,
  },
  [4] = {
    [1] = alias_sym_special_variable_name,
  },
  [5] = {
    [1] = alias_sym_variable_name,
  },
  [6] = {
    [2] = alias_sym_word,
  },
  [7] = {
    [2] = alias_sym_special_variable_name,
  },
  [8] = {
    [2] = alias_sym_variable_name,
  },
  [9] = {
    [3] = alias_sym_word,
  },
  [10] = {
    [1] = alias_sym_special_variable_name,
    [3] = alias_sym_regex,
  },
  [11] = {
    [1] = alias_sym_variable_name,
    [3] = alias_sym_regex,
  },
  [12] = {
    [3] = alias_sym_regex,
  },
  [13] = {
    [1] = alias_sym_word,
    [4] = alias_sym_case_item,
  },
  [14] = {
    [4] = alias_sym_case_item,
  },
  [15] = {
    [4] = alias_sym_word,
  },
  [16] = {
    [2] = alias_sym_special_variable_name,
    [4] = alias_sym_regex,
  },
  [17] = {
    [2] = alias_sym_variable_name,
    [4] = alias_sym_regex,
  },
  [18] = {
    [4] = alias_sym_regex,
  },
  [19] = {
    [1] = alias_sym_word,
    [5] = alias_sym_case_item,
  },
  [20] = {
    [5] = alias_sym_case_item,
  },
  [21] = {
    [1] = alias_sym_word,
    [6] = alias_sym_case_item,
  },
  [22] = {
    [6] = alias_sym_case_item,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '*')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(23);
      if (lookahead == '/')
        ADVANCE(24);
      if (lookahead == '0')
        ADVANCE(25);
      if (lookahead == ':')
        ADVANCE(26);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(37);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '?')
        ADVANCE(44);
      if (lookahead == '@')
        ADVANCE(45);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(48);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '_')
        ADVANCE(50);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(52);
      if (lookahead == 'i')
        ADVANCE(56);
      if (lookahead == '{')
        ADVANCE(58);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(62);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      ADVANCE(5);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 4:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '{')
        ADVANCE(10);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(15);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 16:
      if (lookahead == '\'')
        ADVANCE(17);
      if (lookahead != 0)
        ADVANCE(16);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(22);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(27);
      if (lookahead == '?')
        ADVANCE(28);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(30);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(32);
      if (lookahead == '(')
        ADVANCE(33);
      if (lookahead == '<')
        ADVANCE(34);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(35);
      if (lookahead == '<')
        ADVANCE(36);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(38);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(39);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(41);
      if (lookahead == '(')
        ADVANCE(42);
      if (lookahead == '>')
        ADVANCE(43);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 48:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(53);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(54);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(55);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(60);
      if (lookahead == '|')
        ADVANCE(61);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 63:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(65);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(66);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(67);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(63);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(64);
      END_STATE();
    case 65:
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(32);
      if (lookahead == '(')
        ADVANCE(33);
      END_STATE();
    case 67:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(63);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym__special_characters);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      END_STATE();
    case 69:
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '+')
        ADVANCE(70);
      if (lookahead == '=')
        ADVANCE(72);
      if (lookahead == '[')
        ADVANCE(73);
      if (lookahead == '\\')
        SKIP(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(69);
      END_STATE();
    case 70:
      if (lookahead == '=')
        ADVANCE(71);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 74:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(69);
      END_STATE();
    case 75:
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '(')
        ADVANCE(76);
      if (lookahead == '\\')
        SKIP(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(79);
      END_STATE();
    case 76:
      if (lookahead == '(')
        ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LPAREN_LPAREN);
      END_STATE();
    case 78:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(75);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(79);
      END_STATE();
    case 80:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(65);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(66);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(81);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(80);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 81:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(80);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 82:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(65);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(66);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(83);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(82);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 83:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(82);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 84:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '-')
        ADVANCE(85);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(84);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 87:
      if (lookahead == '(')
        ADVANCE(33);
      END_STATE();
    case 88:
      if (lookahead == '(')
        ADVANCE(42);
      END_STATE();
    case 89:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(84);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 90:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(91);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(92);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(93);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 92:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(90);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 94:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(96);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(94);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(38);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(39);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 96:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(94);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 97:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(98);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\\')
        ADVANCE(102);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(103);
      if (lookahead != 0)
        ADVANCE(99);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(99);
      if (lookahead == '\\')
        ADVANCE(101);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(98);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(100);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(99);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(99);
      if (lookahead == '\\')
        ADVANCE(100);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(99);
      if (lookahead != 0)
        ADVANCE(99);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(99);
      if (lookahead == '\\')
        ADVANCE(101);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(98);
      if (lookahead != 0)
        ADVANCE(98);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(103);
      if (lookahead == '\\')
        ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(103);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(99);
      if (lookahead != 0)
        ADVANCE(99);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(98);
      if (lookahead == '\\')
        ADVANCE(102);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(103);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(99);
      END_STATE();
    case 104:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(105);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(106);
      if (lookahead == '-')
        ADVANCE(107);
      if (lookahead == '0')
        ADVANCE(108);
      if (lookahead == '?')
        ADVANCE(109);
      if (lookahead == '@')
        ADVANCE(110);
      if (lookahead == '\\')
        SKIP(111);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(104);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(79);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(79);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 111:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(104);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(79);
      END_STATE();
    case 113:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(105);
      if (lookahead == '*')
        ADVANCE(106);
      if (lookahead == '-')
        ADVANCE(107);
      if (lookahead == '0')
        ADVANCE(108);
      if (lookahead == '?')
        ADVANCE(109);
      if (lookahead == '@')
        ADVANCE(110);
      if (lookahead == '\\')
        SKIP(115);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(113);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(79);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 115:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(113);
      END_STATE();
    case 116:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(117);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(116);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 117:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(116);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 118:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '\\')
        SKIP(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(118);
      END_STATE();
    case 119:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(118);
      END_STATE();
    case 120:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(66);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(121);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(120);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 121:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(120);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 122:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(123);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(122);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 123:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(122);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 124:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(125);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(124);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 125:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(124);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 126:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(127);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(85);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(128);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(126);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 128:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(126);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 129:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(127);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(130);
      if (lookahead == 'i')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(129);
      END_STATE();
    case 130:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(129);
      END_STATE();
    case 131:
      if (lookahead == 'n')
        ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 133:
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(134);
      if (lookahead == '{')
        ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(133);
      END_STATE();
    case 134:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(133);
      END_STATE();
    case 135:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(91);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(136);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(135);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(93);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 136:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(135);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 137:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(138);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(137);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 138:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(137);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 139:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(66);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(140);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(139);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 140:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(139);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 141:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(91);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(142);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(141);
      END_STATE();
    case 142:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(141);
      END_STATE();
    case 143:
      if (lookahead == 's')
        ADVANCE(144);
      END_STATE();
    case 144:
      if (lookahead == 'a')
        ADVANCE(145);
      END_STATE();
    case 145:
      if (lookahead == 'c')
        ADVANCE(146);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 147:
      if (lookahead == '!')
        ADVANCE(148);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == '-')
        ADVANCE(151);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '=')
        ADVANCE(154);
      if (lookahead == '>')
        ADVANCE(157);
      if (lookahead == '\\')
        SKIP(158);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(147);
      END_STATE();
    case 148:
      if (lookahead == '=')
        ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 150:
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 151:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(155);
      if (lookahead == '~')
        ADVANCE(156);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 158:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(147);
      END_STATE();
    case 159:
      if (lookahead == '|')
        ADVANCE(61);
      END_STATE();
    case 160:
      if (lookahead == '!')
        ADVANCE(148);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == '-')
        ADVANCE(151);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '=')
        ADVANCE(154);
      if (lookahead == '>')
        ADVANCE(157);
      if (lookahead == '\\')
        SKIP(161);
      if (lookahead == ']')
        ADVANCE(162);
      if (lookahead == '|')
        ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(160);
      END_STATE();
    case 161:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(160);
      END_STATE();
    case 162:
      if (lookahead == ']')
        ADVANCE(163);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 164:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(105);
      if (lookahead == '*')
        ADVANCE(106);
      if (lookahead == '-')
        ADVANCE(107);
      if (lookahead == '0')
        ADVANCE(165);
      if (lookahead == '?')
        ADVANCE(109);
      if (lookahead == '@')
        ADVANCE(110);
      if (lookahead == '\\')
        ADVANCE(167);
      if (lookahead == '_')
        ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(168);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(166);
      if (lookahead != 0 &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(99);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(168);
      if (lookahead == '\\')
        ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(168);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(99);
      if (lookahead != 0)
        ADVANCE(99);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(106);
      if (lookahead == '-')
        ADVANCE(107);
      if (lookahead == '0')
        ADVANCE(165);
      if (lookahead == '?')
        ADVANCE(109);
      if (lookahead == '@')
        ADVANCE(110);
      if (lookahead == '\\')
        ADVANCE(167);
      if (lookahead == '_')
        ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(168);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(166);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(99);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(166);
      END_STATE();
    case 170:
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(105);
      if (lookahead == '*')
        ADVANCE(106);
      if (lookahead == '-')
        ADVANCE(107);
      if (lookahead == '0')
        ADVANCE(108);
      if (lookahead == '?')
        ADVANCE(109);
      if (lookahead == '@')
        ADVANCE(110);
      if (lookahead == '\\')
        SKIP(171);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(170);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(79);
      END_STATE();
    case 171:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(170);
      END_STATE();
    case 172:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(23);
      if (lookahead == '/')
        ADVANCE(24);
      if (lookahead == ':')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '=')
        ADVANCE(173);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(174);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(62);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 174:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 175:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(65);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(176);
      if (lookahead == '<')
        ADVANCE(66);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(177);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      if ((lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 176:
      if (lookahead == ';')
        ADVANCE(30);
      END_STATE();
    case 177:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 178:
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(179);
      if (lookahead == '\\')
        SKIP(180);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(10);
      END_STATE();
    case 180:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      END_STATE();
    case 181:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(182);
      if (lookahead == '$')
        ADVANCE(184);
      if (lookahead == '\'')
        ADVANCE(189);
      if (lookahead == '<')
        ADVANCE(192);
      if (lookahead == '>')
        ADVANCE(194);
      if (lookahead == '[')
        ADVANCE(196);
      if (lookahead == '\\')
        ADVANCE(197);
      if (lookahead == ']')
        ADVANCE(196);
      if (lookahead == '`')
        ADVANCE(203);
      if (lookahead == '{')
        ADVANCE(196);
      if (lookahead == '}')
        ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(187);
      if (lookahead != 0)
        ADVANCE(200);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(183);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(182);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(185);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead == '{')
        ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(187);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\'')
        ADVANCE(190);
      if (lookahead == '\\')
        ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(16);
      if (lookahead != 0)
        ADVANCE(189);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_raw_string);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\n')
        ADVANCE(16);
      if (lookahead == '\'')
        ADVANCE(190);
      if (lookahead == '\\')
        ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(189);
      if (lookahead != 0)
        ADVANCE(189);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '(')
        ADVANCE(193);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '(')
        ADVANCE(195);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '[')
        ADVANCE(196);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead == ']')
        ADVANCE(196);
      if (lookahead == '{')
        ADVANCE(196);
      if (lookahead == '}')
        ADVANCE(196);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(201);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(200);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(199);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(187);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(200);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(200);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(199);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(200);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\"')
        ADVANCE(202);
      if (lookahead == '#')
        ADVANCE(182);
      if (lookahead == '$')
        ADVANCE(184);
      if (lookahead == '\'')
        ADVANCE(189);
      if (lookahead == '<')
        ADVANCE(192);
      if (lookahead == '>')
        ADVANCE(194);
      if (lookahead == '[')
        ADVANCE(196);
      if (lookahead == '\\')
        ADVANCE(197);
      if (lookahead == ']')
        ADVANCE(196);
      if (lookahead == '`')
        ADVANCE(203);
      if (lookahead == '{')
        ADVANCE(196);
      if (lookahead == '}')
        ADVANCE(196);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(200);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 204:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(207);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(32);
      if (lookahead == '<')
        ADVANCE(34);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(41);
      if (lookahead == '>')
        ADVANCE(43);
      END_STATE();
    case 207:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(204);
      END_STATE();
    case 208:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(209);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(208);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 209:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(208);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 210:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(211);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 211:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 212:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(148);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(91);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '-')
        ADVANCE(151);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '=')
        ADVANCE(154);
      if (lookahead == '>')
        ADVANCE(157);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == '|')
        ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 213:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 214:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(65);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(66);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(215);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(62);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 215:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 216:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(217);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(218);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(32);
      END_STATE();
    case 218:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      END_STATE();
    case 219:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(65);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(66);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(220);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 220:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 221:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(222);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      END_STATE();
    case 222:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      END_STATE();
    case 223:
      if (lookahead == '!')
        ADVANCE(148);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '-')
        ADVANCE(151);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '=')
        ADVANCE(154);
      if (lookahead == '>')
        ADVANCE(157);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == '|')
        ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      END_STATE();
    case 224:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      END_STATE();
    case 225:
      if (lookahead == '!')
        ADVANCE(226);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(182);
      if (lookahead == '$')
        ADVANCE(184);
      if (lookahead == '\'')
        ADVANCE(189);
      if (lookahead == '(')
        ADVANCE(227);
      if (lookahead == '-')
        ADVANCE(228);
      if (lookahead == '<')
        ADVANCE(192);
      if (lookahead == '>')
        ADVANCE(194);
      if (lookahead == '[')
        ADVANCE(196);
      if (lookahead == '\\')
        ADVANCE(230);
      if (lookahead == ']')
        ADVANCE(196);
      if (lookahead == '`')
        ADVANCE(203);
      if (lookahead == '{')
        ADVANCE(196);
      if (lookahead == '}')
        ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(187);
      if (lookahead != 0)
        ADVANCE(200);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(199);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(200);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(199);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(187);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(229);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(200);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(229);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(231);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(200);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '!')
        ADVANCE(226);
      if (lookahead == '\"')
        ADVANCE(202);
      if (lookahead == '#')
        ADVANCE(182);
      if (lookahead == '$')
        ADVANCE(184);
      if (lookahead == '\'')
        ADVANCE(189);
      if (lookahead == '(')
        ADVANCE(227);
      if (lookahead == '-')
        ADVANCE(228);
      if (lookahead == '<')
        ADVANCE(192);
      if (lookahead == '>')
        ADVANCE(194);
      if (lookahead == '[')
        ADVANCE(196);
      if (lookahead == '\\')
        ADVANCE(230);
      if (lookahead == ']')
        ADVANCE(196);
      if (lookahead == '`')
        ADVANCE(203);
      if (lookahead == '{')
        ADVANCE(196);
      if (lookahead == '}')
        ADVANCE(196);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '$'))
        ADVANCE(200);
      END_STATE();
    case 232:
      if (lookahead == '!')
        ADVANCE(148);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '-')
        ADVANCE(151);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '=')
        ADVANCE(154);
      if (lookahead == '>')
        ADVANCE(157);
      if (lookahead == '\\')
        SKIP(233);
      if (lookahead == ']')
        ADVANCE(162);
      if (lookahead == '|')
        ADVANCE(234);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(232);
      END_STATE();
    case 233:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(232);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(61);
      END_STATE();
    case 235:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(236);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(62);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 236:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 237:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(23);
      if (lookahead == ':')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '=')
        ADVANCE(173);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(238);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(62);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 238:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 239:
      if (lookahead == '#')
        ADVANCE(240);
      if (lookahead == '\\')
        ADVANCE(242);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '}')
        ADVANCE(244);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(241);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(240);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(241);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '}')
        ADVANCE(240);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(240);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(243);
      if (lookahead == '}')
        ADVANCE(244);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(245);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(244);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(243);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '}')
        ADVANCE(244);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(244);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(243);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(244);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\"')
        ADVANCE(244);
      if (lookahead == '#')
        ADVANCE(240);
      if (lookahead == '\\')
        ADVANCE(242);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(244);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(247);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 247:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 248:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(249);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(248);
      END_STATE();
    case 249:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(248);
      END_STATE();
    case 250:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(251);
      if (lookahead == '-')
        ADVANCE(85);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(253);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(250);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 251:
      if (lookahead == ')')
        ADVANCE(252);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_RPAREN_RPAREN);
      END_STATE();
    case 253:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(250);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 254:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(148);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(91);
      if (lookahead == '-')
        ADVANCE(151);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '=')
        ADVANCE(154);
      if (lookahead == '>')
        ADVANCE(157);
      if (lookahead == '\\')
        SKIP(255);
      if (lookahead == 'e')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(254);
      END_STATE();
    case 255:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(254);
      END_STATE();
    case 256:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(127);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(257);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(256);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 257:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(256);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 258:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(259);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 259:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 260:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(217);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(261);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(260);
      END_STATE();
    case 261:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(260);
      END_STATE();
    case 262:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(217);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(263);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(262);
      END_STATE();
    case 263:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(262);
      END_STATE();
    case 264:
      if (lookahead == '!')
        ADVANCE(148);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '-')
        ADVANCE(151);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '=')
        ADVANCE(154);
      if (lookahead == '>')
        ADVANCE(157);
      if (lookahead == '\\')
        SKIP(265);
      if (lookahead == ']')
        ADVANCE(162);
      if (lookahead == '|')
        ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      END_STATE();
    case 265:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      END_STATE();
    case 266:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(217);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(267);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      END_STATE();
    case 267:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      END_STATE();
    case 268:
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '\\')
        ADVANCE(269);
      if (lookahead == '{')
        ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(268);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 269:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(268);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 270:
      if (lookahead == '!')
        ADVANCE(148);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == ')')
        ADVANCE(251);
      if (lookahead == '-')
        ADVANCE(151);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '=')
        ADVANCE(154);
      if (lookahead == '>')
        ADVANCE(157);
      if (lookahead == '\\')
        SKIP(271);
      if (lookahead == '|')
        ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      END_STATE();
    case 271:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      END_STATE();
    case 272:
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '\\')
        SKIP(273);
      if (lookahead == '|')
        ADVANCE(274);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(272);
      END_STATE();
    case 273:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(272);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 275:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(91);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(276);
      if (lookahead == 'e')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(275);
      END_STATE();
    case 276:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(275);
      END_STATE();
    case 277:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(65);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(176);
      if (lookahead == '<')
        ADVANCE(66);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(278);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(277);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 278:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(277);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 279:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(91);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(280);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(279);
      END_STATE();
    case 280:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(279);
      END_STATE();
    case 281:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(91);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(283);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(93);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 282:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(284);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(286);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 287:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(288);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(287);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 288:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(287);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 289:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(290);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(289);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 290:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(289);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 291:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(66);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(292);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '}')
        ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 292:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 293:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(294);
      if (lookahead == 'e')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(293);
      END_STATE();
    case 294:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(293);
      END_STATE();
    case 295:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(64);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(217);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(296);
      if (lookahead == 'e')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(295);
      END_STATE();
    case 296:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(295);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'c')
        ADVANCE(1);
      if (lookahead == 'd')
        ADVANCE(5);
      if (lookahead == 'e')
        ADVANCE(15);
      if (lookahead == 'f')
        ADVANCE(26);
      if (lookahead == 'i')
        ADVANCE(37);
      if (lookahead == 'l')
        ADVANCE(39);
      if (lookahead == 'r')
        ADVANCE(44);
      if (lookahead == 't')
        ADVANCE(52);
      if (lookahead == 'u')
        ADVANCE(62);
      if (lookahead == 'w')
        ADVANCE(70);
      END_STATE();
    case 1:
      if (lookahead == 'a')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 's')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'e')
        ADVANCE(4);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 5:
      if (lookahead == 'e')
        ADVANCE(6);
      if (lookahead == 'o')
        ADVANCE(12);
      END_STATE();
    case 6:
      if (lookahead == 'c')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'l')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'a')
        ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == 'r')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'e')
        ADVANCE(11);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(13);
      END_STATE();
    case 13:
      if (lookahead == 'e')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 15:
      if (lookahead == 'l')
        ADVANCE(16);
      if (lookahead == 'x')
        ADVANCE(21);
      END_STATE();
    case 16:
      if (lookahead == 'i')
        ADVANCE(17);
      if (lookahead == 's')
        ADVANCE(19);
      END_STATE();
    case 17:
      if (lookahead == 'f')
        ADVANCE(18);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 19:
      if (lookahead == 'e')
        ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 21:
      if (lookahead == 'p')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == 'o')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'r')
        ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == 't')
        ADVANCE(25);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 26:
      if (lookahead == 'i')
        ADVANCE(27);
      if (lookahead == 'o')
        ADVANCE(28);
      if (lookahead == 'u')
        ADVANCE(30);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 28:
      if (lookahead == 'r')
        ADVANCE(29);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 30:
      if (lookahead == 'n')
        ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'c')
        ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == 't')
        ADVANCE(33);
      END_STATE();
    case 33:
      if (lookahead == 'i')
        ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 'o')
        ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 'n')
        ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 37:
      if (lookahead == 'f')
        ADVANCE(38);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 39:
      if (lookahead == 'o')
        ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == 'c')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == 'a')
        ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == 'l')
        ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 44:
      if (lookahead == 'e')
        ADVANCE(45);
      END_STATE();
    case 45:
      if (lookahead == 'a')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 'd')
        ADVANCE(47);
      END_STATE();
    case 47:
      if (lookahead == 'o')
        ADVANCE(48);
      END_STATE();
    case 48:
      if (lookahead == 'n')
        ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 'l')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 'y')
        ADVANCE(51);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 52:
      if (lookahead == 'h')
        ADVANCE(53);
      if (lookahead == 'y')
        ADVANCE(56);
      END_STATE();
    case 53:
      if (lookahead == 'e')
        ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == 'n')
        ADVANCE(55);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 56:
      if (lookahead == 'p')
        ADVANCE(57);
      END_STATE();
    case 57:
      if (lookahead == 'e')
        ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == 's')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'e')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 't')
        ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_typeset);
      END_STATE();
    case 62:
      if (lookahead == 'n')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == 's')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'e')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 't')
        ADVANCE(66);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'n')
        ADVANCE(68);
      END_STATE();
    case 68:
      if (lookahead == 'v')
        ADVANCE(69);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      END_STATE();
    case 70:
      if (lookahead == 'h')
        ADVANCE(71);
      END_STATE();
    case 71:
      if (lookahead == 'i')
        ADVANCE(72);
      END_STATE();
    case 72:
      if (lookahead == 'l')
        ADVANCE(73);
      END_STATE();
    case 73:
      if (lookahead == 'e')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 63, .external_lex_state = 2},
  [2] = {.lex_state = 63},
  [3] = {.lex_state = 69},
  [4] = {.lex_state = 75},
  [5] = {.lex_state = 63, .external_lex_state = 2},
  [6] = {.lex_state = 63, .external_lex_state = 2},
  [7] = {.lex_state = 80},
  [8] = {.lex_state = 80},
  [9] = {.lex_state = 63, .external_lex_state = 2},
  [10] = {.lex_state = 82, .external_lex_state = 2},
  [11] = {.lex_state = 84},
  [12] = {.lex_state = 84},
  [13] = {.lex_state = 90, .external_lex_state = 3},
  [14] = {.lex_state = 90, .external_lex_state = 4},
  [15] = {.lex_state = 80},
  [16] = {.lex_state = 94, .external_lex_state = 5},
  [17] = {.lex_state = 97},
  [18] = {.lex_state = 104},
  [19] = {.lex_state = 94, .external_lex_state = 5},
  [20] = {.lex_state = 113, .external_lex_state = 6},
  [21] = {.lex_state = 63, .external_lex_state = 2},
  [22] = {.lex_state = 63, .external_lex_state = 2},
  [23] = {.lex_state = 63, .external_lex_state = 2},
  [24] = {.lex_state = 116, .external_lex_state = 5},
  [25] = {.lex_state = 118},
  [26] = {.lex_state = 90, .external_lex_state = 4},
  [27] = {.lex_state = 94, .external_lex_state = 7},
  [28] = {.lex_state = 120, .external_lex_state = 8},
  [29] = {.lex_state = 69},
  [30] = {.lex_state = 80, .external_lex_state = 2},
  [31] = {.lex_state = 122, .external_lex_state = 7},
  [32] = {.lex_state = 63, .external_lex_state = 2},
  [33] = {.lex_state = 80, .external_lex_state = 2},
  [34] = {.lex_state = 80},
  [35] = {.lex_state = 80},
  [36] = {.lex_state = 124, .external_lex_state = 9},
  [37] = {.lex_state = 126, .external_lex_state = 4},
  [38] = {.lex_state = 129, .external_lex_state = 4},
  [39] = {.lex_state = 80},
  [40] = {.lex_state = 90, .external_lex_state = 4},
  [41] = {.lex_state = 120, .external_lex_state = 8},
  [42] = {.lex_state = 80},
  [43] = {.lex_state = 129, .external_lex_state = 10},
  [44] = {.lex_state = 97},
  [45] = {.lex_state = 104},
  [46] = {.lex_state = 129, .external_lex_state = 10},
  [47] = {.lex_state = 113, .external_lex_state = 6},
  [48] = {.lex_state = 63, .external_lex_state = 2},
  [49] = {.lex_state = 63, .external_lex_state = 2},
  [50] = {.lex_state = 63, .external_lex_state = 2},
  [51] = {.lex_state = 129, .external_lex_state = 4},
  [52] = {.lex_state = 133},
  [53] = {.lex_state = 69},
  [54] = {.lex_state = 63, .external_lex_state = 2},
  [55] = {.lex_state = 80},
  [56] = {.lex_state = 82, .external_lex_state = 2},
  [57] = {.lex_state = 84},
  [58] = {.lex_state = 84},
  [59] = {.lex_state = 135, .external_lex_state = 3},
  [60] = {.lex_state = 135, .external_lex_state = 4},
  [61] = {.lex_state = 122, .external_lex_state = 5},
  [62] = {.lex_state = 122, .external_lex_state = 5},
  [63] = {.lex_state = 137, .external_lex_state = 5},
  [64] = {.lex_state = 135, .external_lex_state = 4},
  [65] = {.lex_state = 122, .external_lex_state = 7},
  [66] = {.lex_state = 139, .external_lex_state = 8},
  [67] = {.lex_state = 69},
  [68] = {.lex_state = 63, .external_lex_state = 2},
  [69] = {.lex_state = 80, .external_lex_state = 2},
  [70] = {.lex_state = 69},
  [71] = {.lex_state = 141, .external_lex_state = 4},
  [72] = {.lex_state = 69},
  [73] = {.lex_state = 84},
  [74] = {.lex_state = 84},
  [75] = {.lex_state = 147, .external_lex_state = 11},
  [76] = {.lex_state = 97},
  [77] = {.lex_state = 104},
  [78] = {.lex_state = 147, .external_lex_state = 11},
  [79] = {.lex_state = 113, .external_lex_state = 6},
  [80] = {.lex_state = 63, .external_lex_state = 2},
  [81] = {.lex_state = 63, .external_lex_state = 2},
  [82] = {.lex_state = 63, .external_lex_state = 2},
  [83] = {.lex_state = 147, .external_lex_state = 12},
  [84] = {.lex_state = 84},
  [85] = {.lex_state = 84},
  [86] = {.lex_state = 160, .external_lex_state = 13},
  [87] = {.lex_state = 97},
  [88] = {.lex_state = 104},
  [89] = {.lex_state = 160, .external_lex_state = 13},
  [90] = {.lex_state = 113, .external_lex_state = 6},
  [91] = {.lex_state = 63, .external_lex_state = 2},
  [92] = {.lex_state = 63, .external_lex_state = 2},
  [93] = {.lex_state = 63, .external_lex_state = 2},
  [94] = {.lex_state = 160},
  [95] = {.lex_state = 69},
  [96] = {.lex_state = 90, .external_lex_state = 14},
  [97] = {.lex_state = 97},
  [98] = {.lex_state = 104},
  [99] = {.lex_state = 90, .external_lex_state = 14},
  [100] = {.lex_state = 113, .external_lex_state = 6},
  [101] = {.lex_state = 63, .external_lex_state = 2},
  [102] = {.lex_state = 63, .external_lex_state = 2},
  [103] = {.lex_state = 63, .external_lex_state = 2},
  [104] = {.lex_state = 135, .external_lex_state = 3},
  [105] = {.lex_state = 69},
  [106] = {.lex_state = 90, .external_lex_state = 3},
  [107] = {.lex_state = 90, .external_lex_state = 10},
  [108] = {.lex_state = 97},
  [109] = {.lex_state = 104},
  [110] = {.lex_state = 90, .external_lex_state = 10},
  [111] = {.lex_state = 113, .external_lex_state = 6},
  [112] = {.lex_state = 63, .external_lex_state = 2},
  [113] = {.lex_state = 63, .external_lex_state = 2},
  [114] = {.lex_state = 63, .external_lex_state = 2},
  [115] = {.lex_state = 135, .external_lex_state = 4},
  [116] = {.lex_state = 90, .external_lex_state = 4},
  [117] = {.lex_state = 80, .external_lex_state = 15},
  [118] = {.lex_state = 97},
  [119] = {.lex_state = 104},
  [120] = {.lex_state = 80, .external_lex_state = 15},
  [121] = {.lex_state = 113, .external_lex_state = 6},
  [122] = {.lex_state = 63, .external_lex_state = 2},
  [123] = {.lex_state = 63, .external_lex_state = 2},
  [124] = {.lex_state = 63, .external_lex_state = 2},
  [125] = {.lex_state = 80, .external_lex_state = 2},
  [126] = {.lex_state = 80},
  [127] = {.lex_state = 94, .external_lex_state = 5},
  [128] = {.lex_state = 122, .external_lex_state = 5},
  [129] = {.lex_state = 164},
  [130] = {.lex_state = 97, .external_lex_state = 13},
  [131] = {.lex_state = 113, .external_lex_state = 6},
  [132] = {.lex_state = 63, .external_lex_state = 2},
  [133] = {.lex_state = 63, .external_lex_state = 2},
  [134] = {.lex_state = 97},
  [135] = {.lex_state = 122, .external_lex_state = 5},
  [136] = {.lex_state = 122, .external_lex_state = 5},
  [137] = {.lex_state = 122, .external_lex_state = 5},
  [138] = {.lex_state = 69},
  [139] = {.lex_state = 170, .external_lex_state = 6},
  [140] = {.lex_state = 172, .external_lex_state = 16},
  [141] = {.lex_state = 172, .external_lex_state = 16},
  [142] = {.lex_state = 172, .external_lex_state = 16},
  [143] = {.lex_state = 135, .external_lex_state = 4},
  [144] = {.lex_state = 139, .external_lex_state = 8},
  [145] = {.lex_state = 63, .external_lex_state = 2},
  [146] = {.lex_state = 63, .external_lex_state = 2},
  [147] = {.lex_state = 80},
  [148] = {.lex_state = 82, .external_lex_state = 2},
  [149] = {.lex_state = 84},
  [150] = {.lex_state = 84},
  [151] = {.lex_state = 90, .external_lex_state = 3},
  [152] = {.lex_state = 90, .external_lex_state = 4},
  [153] = {.lex_state = 116, .external_lex_state = 5},
  [154] = {.lex_state = 90, .external_lex_state = 4},
  [155] = {.lex_state = 94, .external_lex_state = 7},
  [156] = {.lex_state = 120, .external_lex_state = 8},
  [157] = {.lex_state = 63, .external_lex_state = 2},
  [158] = {.lex_state = 80, .external_lex_state = 2},
  [159] = {.lex_state = 135, .external_lex_state = 4},
  [160] = {.lex_state = 139, .external_lex_state = 8},
  [161] = {.lex_state = 63, .external_lex_state = 2},
  [162] = {.lex_state = 84},
  [163] = {.lex_state = 63, .external_lex_state = 2},
  [164] = {.lex_state = 175, .external_lex_state = 2},
  [165] = {.lex_state = 63, .external_lex_state = 2},
  [166] = {.lex_state = 141, .external_lex_state = 4},
  [167] = {.lex_state = 178, .external_lex_state = 17},
  [168] = {.lex_state = 63},
  [169] = {.lex_state = 181},
  [170] = {.lex_state = 80},
  [171] = {.lex_state = 63, .external_lex_state = 18},
  [172] = {.lex_state = 80},
  [173] = {.lex_state = 94, .external_lex_state = 5},
  [174] = {.lex_state = 94, .external_lex_state = 5},
  [175] = {.lex_state = 141, .external_lex_state = 4},
  [176] = {.lex_state = 204, .external_lex_state = 7},
  [177] = {.lex_state = 94, .external_lex_state = 7},
  [178] = {.lex_state = 63, .external_lex_state = 2},
  [179] = {.lex_state = 94, .external_lex_state = 7},
  [180] = {.lex_state = 80, .external_lex_state = 2},
  [181] = {.lex_state = 80, .external_lex_state = 15},
  [182] = {.lex_state = 80, .external_lex_state = 15},
  [183] = {.lex_state = 80, .external_lex_state = 2},
  [184] = {.lex_state = 208, .external_lex_state = 11},
  [185] = {.lex_state = 208, .external_lex_state = 11},
  [186] = {.lex_state = 208, .external_lex_state = 11},
  [187] = {.lex_state = 139, .external_lex_state = 8},
  [188] = {.lex_state = 210},
  [189] = {.lex_state = 120, .external_lex_state = 19},
  [190] = {.lex_state = 97},
  [191] = {.lex_state = 104},
  [192] = {.lex_state = 120, .external_lex_state = 19},
  [193] = {.lex_state = 113, .external_lex_state = 6},
  [194] = {.lex_state = 63, .external_lex_state = 2},
  [195] = {.lex_state = 63, .external_lex_state = 2},
  [196] = {.lex_state = 63, .external_lex_state = 2},
  [197] = {.lex_state = 126, .external_lex_state = 4},
  [198] = {.lex_state = 84},
  [199] = {.lex_state = 84},
  [200] = {.lex_state = 212, .external_lex_state = 10},
  [201] = {.lex_state = 97},
  [202] = {.lex_state = 104},
  [203] = {.lex_state = 212, .external_lex_state = 10},
  [204] = {.lex_state = 113, .external_lex_state = 6},
  [205] = {.lex_state = 63, .external_lex_state = 2},
  [206] = {.lex_state = 63, .external_lex_state = 2},
  [207] = {.lex_state = 63, .external_lex_state = 2},
  [208] = {.lex_state = 212, .external_lex_state = 4},
  [209] = {.lex_state = 80},
  [210] = {.lex_state = 80},
  [211] = {.lex_state = 63, .external_lex_state = 2},
  [212] = {.lex_state = 204, .external_lex_state = 7},
  [213] = {.lex_state = 80},
  [214] = {.lex_state = 63, .external_lex_state = 2},
  [215] = {.lex_state = 80},
  [216] = {.lex_state = 126, .external_lex_state = 4},
  [217] = {.lex_state = 129},
  [218] = {.lex_state = 129, .external_lex_state = 10},
  [219] = {.lex_state = 129, .external_lex_state = 10},
  [220] = {.lex_state = 164},
  [221] = {.lex_state = 97},
  [222] = {.lex_state = 129, .external_lex_state = 10},
  [223] = {.lex_state = 129, .external_lex_state = 10},
  [224] = {.lex_state = 129, .external_lex_state = 10},
  [225] = {.lex_state = 126, .external_lex_state = 4},
  [226] = {.lex_state = 129},
  [227] = {.lex_state = 69},
  [228] = {.lex_state = 170, .external_lex_state = 6},
  [229] = {.lex_state = 172, .external_lex_state = 16},
  [230] = {.lex_state = 172, .external_lex_state = 16},
  [231] = {.lex_state = 172, .external_lex_state = 16},
  [232] = {.lex_state = 135, .external_lex_state = 4},
  [233] = {.lex_state = 139, .external_lex_state = 8},
  [234] = {.lex_state = 63, .external_lex_state = 2},
  [235] = {.lex_state = 90, .external_lex_state = 4},
  [236] = {.lex_state = 120, .external_lex_state = 8},
  [237] = {.lex_state = 63, .external_lex_state = 2},
  [238] = {.lex_state = 135, .external_lex_state = 4},
  [239] = {.lex_state = 139, .external_lex_state = 8},
  [240] = {.lex_state = 63, .external_lex_state = 2},
  [241] = {.lex_state = 84},
  [242] = {.lex_state = 214, .external_lex_state = 20},
  [243] = {.lex_state = 216, .external_lex_state = 21},
  [244] = {.lex_state = 124, .external_lex_state = 9},
  [245] = {.lex_state = 80},
  [246] = {.lex_state = 133},
  [247] = {.lex_state = 147, .external_lex_state = 12},
  [248] = {.lex_state = 160},
  [249] = {.lex_state = 69},
  [250] = {.lex_state = 135, .external_lex_state = 14},
  [251] = {.lex_state = 135, .external_lex_state = 14},
  [252] = {.lex_state = 69},
  [253] = {.lex_state = 135, .external_lex_state = 3},
  [254] = {.lex_state = 135, .external_lex_state = 10},
  [255] = {.lex_state = 135, .external_lex_state = 10},
  [256] = {.lex_state = 135, .external_lex_state = 4},
  [257] = {.lex_state = 122, .external_lex_state = 5},
  [258] = {.lex_state = 84},
  [259] = {.lex_state = 63, .external_lex_state = 2},
  [260] = {.lex_state = 141, .external_lex_state = 4},
  [261] = {.lex_state = 219, .external_lex_state = 2},
  [262] = {.lex_state = 63, .external_lex_state = 2},
  [263] = {.lex_state = 63},
  [264] = {.lex_state = 181},
  [265] = {.lex_state = 80},
  [266] = {.lex_state = 80},
  [267] = {.lex_state = 122, .external_lex_state = 5},
  [268] = {.lex_state = 122, .external_lex_state = 5},
  [269] = {.lex_state = 221, .external_lex_state = 7},
  [270] = {.lex_state = 122, .external_lex_state = 7},
  [271] = {.lex_state = 135, .external_lex_state = 4},
  [272] = {.lex_state = 139, .external_lex_state = 8},
  [273] = {.lex_state = 63, .external_lex_state = 2},
  [274] = {.lex_state = 122, .external_lex_state = 7},
  [275] = {.lex_state = 124, .external_lex_state = 9},
  [276] = {.lex_state = 84},
  [277] = {.lex_state = 223, .external_lex_state = 13},
  [278] = {.lex_state = 223, .external_lex_state = 13},
  [279] = {.lex_state = 212},
  [280] = {.lex_state = 147, .external_lex_state = 12},
  [281] = {.lex_state = 80},
  [282] = {.lex_state = 147, .external_lex_state = 11},
  [283] = {.lex_state = 147, .external_lex_state = 11},
  [284] = {.lex_state = 164},
  [285] = {.lex_state = 97},
  [286] = {.lex_state = 147, .external_lex_state = 11},
  [287] = {.lex_state = 147, .external_lex_state = 11},
  [288] = {.lex_state = 147, .external_lex_state = 11},
  [289] = {.lex_state = 69},
  [290] = {.lex_state = 170, .external_lex_state = 6},
  [291] = {.lex_state = 172, .external_lex_state = 16},
  [292] = {.lex_state = 172, .external_lex_state = 16},
  [293] = {.lex_state = 172, .external_lex_state = 16},
  [294] = {.lex_state = 135, .external_lex_state = 4},
  [295] = {.lex_state = 139, .external_lex_state = 8},
  [296] = {.lex_state = 63, .external_lex_state = 2},
  [297] = {.lex_state = 90, .external_lex_state = 4},
  [298] = {.lex_state = 120, .external_lex_state = 8},
  [299] = {.lex_state = 63, .external_lex_state = 2},
  [300] = {.lex_state = 135, .external_lex_state = 4},
  [301] = {.lex_state = 139, .external_lex_state = 8},
  [302] = {.lex_state = 63, .external_lex_state = 2},
  [303] = {.lex_state = 84},
  [304] = {.lex_state = 204, .external_lex_state = 21},
  [305] = {.lex_state = 225},
  [306] = {.lex_state = 212},
  [307] = {.lex_state = 160},
  [308] = {.lex_state = 80},
  [309] = {.lex_state = 160, .external_lex_state = 13},
  [310] = {.lex_state = 232, .external_lex_state = 13},
  [311] = {.lex_state = 164},
  [312] = {.lex_state = 97},
  [313] = {.lex_state = 232, .external_lex_state = 13},
  [314] = {.lex_state = 232, .external_lex_state = 13},
  [315] = {.lex_state = 232, .external_lex_state = 13},
  [316] = {.lex_state = 69},
  [317] = {.lex_state = 170, .external_lex_state = 6},
  [318] = {.lex_state = 172, .external_lex_state = 16},
  [319] = {.lex_state = 172, .external_lex_state = 16},
  [320] = {.lex_state = 172, .external_lex_state = 16},
  [321] = {.lex_state = 135, .external_lex_state = 4},
  [322] = {.lex_state = 139, .external_lex_state = 8},
  [323] = {.lex_state = 63, .external_lex_state = 2},
  [324] = {.lex_state = 90, .external_lex_state = 4},
  [325] = {.lex_state = 120, .external_lex_state = 8},
  [326] = {.lex_state = 63, .external_lex_state = 2},
  [327] = {.lex_state = 135, .external_lex_state = 4},
  [328] = {.lex_state = 139, .external_lex_state = 8},
  [329] = {.lex_state = 63, .external_lex_state = 2},
  [330] = {.lex_state = 84},
  [331] = {.lex_state = 225},
  [332] = {.lex_state = 124, .external_lex_state = 9},
  [333] = {.lex_state = 80},
  [334] = {.lex_state = 90, .external_lex_state = 14},
  [335] = {.lex_state = 135, .external_lex_state = 14},
  [336] = {.lex_state = 164},
  [337] = {.lex_state = 97},
  [338] = {.lex_state = 135, .external_lex_state = 14},
  [339] = {.lex_state = 135, .external_lex_state = 14},
  [340] = {.lex_state = 135, .external_lex_state = 14},
  [341] = {.lex_state = 69},
  [342] = {.lex_state = 170, .external_lex_state = 6},
  [343] = {.lex_state = 172, .external_lex_state = 16},
  [344] = {.lex_state = 172, .external_lex_state = 16},
  [345] = {.lex_state = 172, .external_lex_state = 16},
  [346] = {.lex_state = 135, .external_lex_state = 4},
  [347] = {.lex_state = 139, .external_lex_state = 8},
  [348] = {.lex_state = 63, .external_lex_state = 2},
  [349] = {.lex_state = 90, .external_lex_state = 4},
  [350] = {.lex_state = 120, .external_lex_state = 8},
  [351] = {.lex_state = 63, .external_lex_state = 2},
  [352] = {.lex_state = 135, .external_lex_state = 4},
  [353] = {.lex_state = 139, .external_lex_state = 8},
  [354] = {.lex_state = 63, .external_lex_state = 2},
  [355] = {.lex_state = 90, .external_lex_state = 3},
  [356] = {.lex_state = 80},
  [357] = {.lex_state = 90, .external_lex_state = 10},
  [358] = {.lex_state = 135, .external_lex_state = 10},
  [359] = {.lex_state = 164},
  [360] = {.lex_state = 97},
  [361] = {.lex_state = 135, .external_lex_state = 10},
  [362] = {.lex_state = 135, .external_lex_state = 10},
  [363] = {.lex_state = 135, .external_lex_state = 10},
  [364] = {.lex_state = 69},
  [365] = {.lex_state = 170, .external_lex_state = 6},
  [366] = {.lex_state = 172, .external_lex_state = 16},
  [367] = {.lex_state = 172, .external_lex_state = 16},
  [368] = {.lex_state = 172, .external_lex_state = 16},
  [369] = {.lex_state = 135, .external_lex_state = 4},
  [370] = {.lex_state = 139, .external_lex_state = 8},
  [371] = {.lex_state = 63, .external_lex_state = 2},
  [372] = {.lex_state = 90, .external_lex_state = 4},
  [373] = {.lex_state = 120, .external_lex_state = 8},
  [374] = {.lex_state = 63, .external_lex_state = 2},
  [375] = {.lex_state = 135, .external_lex_state = 4},
  [376] = {.lex_state = 139, .external_lex_state = 8},
  [377] = {.lex_state = 63, .external_lex_state = 2},
  [378] = {.lex_state = 90, .external_lex_state = 4},
  [379] = {.lex_state = 80},
  [380] = {.lex_state = 80, .external_lex_state = 15},
  [381] = {.lex_state = 80, .external_lex_state = 15},
  [382] = {.lex_state = 164},
  [383] = {.lex_state = 97},
  [384] = {.lex_state = 80, .external_lex_state = 15},
  [385] = {.lex_state = 80, .external_lex_state = 15},
  [386] = {.lex_state = 80, .external_lex_state = 15},
  [387] = {.lex_state = 69},
  [388] = {.lex_state = 170, .external_lex_state = 6},
  [389] = {.lex_state = 172, .external_lex_state = 16},
  [390] = {.lex_state = 172, .external_lex_state = 16},
  [391] = {.lex_state = 172, .external_lex_state = 16},
  [392] = {.lex_state = 135, .external_lex_state = 4},
  [393] = {.lex_state = 139, .external_lex_state = 8},
  [394] = {.lex_state = 63, .external_lex_state = 2},
  [395] = {.lex_state = 90, .external_lex_state = 4},
  [396] = {.lex_state = 120, .external_lex_state = 8},
  [397] = {.lex_state = 63, .external_lex_state = 2},
  [398] = {.lex_state = 135, .external_lex_state = 4},
  [399] = {.lex_state = 139, .external_lex_state = 8},
  [400] = {.lex_state = 63, .external_lex_state = 2},
  [401] = {.lex_state = 122, .external_lex_state = 5},
  [402] = {.lex_state = 94, .external_lex_state = 5},
  [403] = {.lex_state = 122, .external_lex_state = 5},
  [404] = {.lex_state = 97, .external_lex_state = 13},
  [405] = {.lex_state = 97, .external_lex_state = 13},
  [406] = {.lex_state = 97, .external_lex_state = 13},
  [407] = {.lex_state = 97},
  [408] = {.lex_state = 69},
  [409] = {.lex_state = 170, .external_lex_state = 6},
  [410] = {.lex_state = 172, .external_lex_state = 16},
  [411] = {.lex_state = 172, .external_lex_state = 16},
  [412] = {.lex_state = 172, .external_lex_state = 16},
  [413] = {.lex_state = 135, .external_lex_state = 4},
  [414] = {.lex_state = 139, .external_lex_state = 8},
  [415] = {.lex_state = 63, .external_lex_state = 2},
  [416] = {.lex_state = 90, .external_lex_state = 4},
  [417] = {.lex_state = 120, .external_lex_state = 8},
  [418] = {.lex_state = 63, .external_lex_state = 2},
  [419] = {.lex_state = 164},
  [420] = {.lex_state = 97},
  [421] = {.lex_state = 80},
  [422] = {.lex_state = 235, .external_lex_state = 16},
  [423] = {.lex_state = 69},
  [424] = {.lex_state = 172, .external_lex_state = 16},
  [425] = {.lex_state = 172, .external_lex_state = 16},
  [426] = {.lex_state = 172, .external_lex_state = 16},
  [427] = {.lex_state = 122, .external_lex_state = 5},
  [428] = {.lex_state = 237, .external_lex_state = 22},
  [429] = {.lex_state = 97},
  [430] = {.lex_state = 104},
  [431] = {.lex_state = 237, .external_lex_state = 22},
  [432] = {.lex_state = 113, .external_lex_state = 6},
  [433] = {.lex_state = 239},
  [434] = {.lex_state = 63, .external_lex_state = 2},
  [435] = {.lex_state = 63, .external_lex_state = 2},
  [436] = {.lex_state = 63, .external_lex_state = 2},
  [437] = {.lex_state = 237, .external_lex_state = 16},
  [438] = {.lex_state = 122, .external_lex_state = 5},
  [439] = {.lex_state = 239},
  [440] = {.lex_state = 237, .external_lex_state = 16},
  [441] = {.lex_state = 122, .external_lex_state = 5},
  [442] = {.lex_state = 239},
  [443] = {.lex_state = 237, .external_lex_state = 16},
  [444] = {.lex_state = 122, .external_lex_state = 5},
  [445] = {.lex_state = 219, .external_lex_state = 2},
  [446] = {.lex_state = 135, .external_lex_state = 4},
  [447] = {.lex_state = 139, .external_lex_state = 8},
  [448] = {.lex_state = 80},
  [449] = {.lex_state = 133},
  [450] = {.lex_state = 147, .external_lex_state = 12},
  [451] = {.lex_state = 160},
  [452] = {.lex_state = 90, .external_lex_state = 3},
  [453] = {.lex_state = 90, .external_lex_state = 4},
  [454] = {.lex_state = 84},
  [455] = {.lex_state = 63, .external_lex_state = 2},
  [456] = {.lex_state = 63, .external_lex_state = 2},
  [457] = {.lex_state = 63, .external_lex_state = 2},
  [458] = {.lex_state = 63},
  [459] = {.lex_state = 80},
  [460] = {.lex_state = 80},
  [461] = {.lex_state = 246, .external_lex_state = 7},
  [462] = {.lex_state = 94, .external_lex_state = 7},
  [463] = {.lex_state = 90, .external_lex_state = 4},
  [464] = {.lex_state = 120, .external_lex_state = 8},
  [465] = {.lex_state = 94, .external_lex_state = 7},
  [466] = {.lex_state = 122, .external_lex_state = 5},
  [467] = {.lex_state = 219, .external_lex_state = 2},
  [468] = {.lex_state = 135, .external_lex_state = 4},
  [469] = {.lex_state = 139, .external_lex_state = 8},
  [470] = {.lex_state = 133},
  [471] = {.lex_state = 141, .external_lex_state = 4},
  [472] = {.lex_state = 139, .external_lex_state = 8},
  [473] = {.lex_state = 90, .external_lex_state = 4},
  [474] = {.lex_state = 120, .external_lex_state = 8},
  [475] = {.lex_state = 141, .external_lex_state = 4},
  [476] = {.lex_state = 104},
  [477] = {.lex_state = 113, .external_lex_state = 6},
  [478] = {.lex_state = 178, .external_lex_state = 17},
  [479] = {.lex_state = 80},
  [480] = {.lex_state = 94, .external_lex_state = 5},
  [481] = {.lex_state = 94, .external_lex_state = 5},
  [482] = {.lex_state = 122, .external_lex_state = 7},
  [483] = {.lex_state = 204, .external_lex_state = 5},
  [484] = {.lex_state = 204, .external_lex_state = 5},
  [485] = {.lex_state = 248, .external_lex_state = 7},
  [486] = {.lex_state = 248, .external_lex_state = 7},
  [487] = {.lex_state = 204, .external_lex_state = 5},
  [488] = {.lex_state = 204, .external_lex_state = 5},
  [489] = {.lex_state = 248, .external_lex_state = 7},
  [490] = {.lex_state = 141, .external_lex_state = 4},
  [491] = {.lex_state = 204, .external_lex_state = 7},
  [492] = {.lex_state = 204, .external_lex_state = 7},
  [493] = {.lex_state = 94, .external_lex_state = 7},
  [494] = {.lex_state = 94, .external_lex_state = 7},
  [495] = {.lex_state = 208, .external_lex_state = 12},
  [496] = {.lex_state = 69, .external_lex_state = 13},
  [497] = {.lex_state = 208, .external_lex_state = 11},
  [498] = {.lex_state = 208, .external_lex_state = 12},
  [499] = {.lex_state = 69, .external_lex_state = 13},
  [500] = {.lex_state = 147, .external_lex_state = 12},
  [501] = {.lex_state = 139, .external_lex_state = 8},
  [502] = {.lex_state = 210, .external_lex_state = 13},
  [503] = {.lex_state = 97},
  [504] = {.lex_state = 104},
  [505] = {.lex_state = 210, .external_lex_state = 13},
  [506] = {.lex_state = 113, .external_lex_state = 6},
  [507] = {.lex_state = 63, .external_lex_state = 2},
  [508] = {.lex_state = 63, .external_lex_state = 2},
  [509] = {.lex_state = 63, .external_lex_state = 2},
  [510] = {.lex_state = 210},
  [511] = {.lex_state = 80},
  [512] = {.lex_state = 120, .external_lex_state = 19},
  [513] = {.lex_state = 139, .external_lex_state = 19},
  [514] = {.lex_state = 164},
  [515] = {.lex_state = 97},
  [516] = {.lex_state = 139, .external_lex_state = 19},
  [517] = {.lex_state = 139, .external_lex_state = 19},
  [518] = {.lex_state = 139, .external_lex_state = 19},
  [519] = {.lex_state = 69},
  [520] = {.lex_state = 170, .external_lex_state = 6},
  [521] = {.lex_state = 172, .external_lex_state = 16},
  [522] = {.lex_state = 172, .external_lex_state = 16},
  [523] = {.lex_state = 172, .external_lex_state = 16},
  [524] = {.lex_state = 135, .external_lex_state = 4},
  [525] = {.lex_state = 139, .external_lex_state = 8},
  [526] = {.lex_state = 63, .external_lex_state = 2},
  [527] = {.lex_state = 90, .external_lex_state = 4},
  [528] = {.lex_state = 120, .external_lex_state = 8},
  [529] = {.lex_state = 63, .external_lex_state = 2},
  [530] = {.lex_state = 135, .external_lex_state = 4},
  [531] = {.lex_state = 139, .external_lex_state = 8},
  [532] = {.lex_state = 63, .external_lex_state = 2},
  [533] = {.lex_state = 250},
  [534] = {.lex_state = 212, .external_lex_state = 4},
  [535] = {.lex_state = 212},
  [536] = {.lex_state = 212, .external_lex_state = 4},
  [537] = {.lex_state = 80},
  [538] = {.lex_state = 212, .external_lex_state = 10},
  [539] = {.lex_state = 254, .external_lex_state = 10},
  [540] = {.lex_state = 164},
  [541] = {.lex_state = 97},
  [542] = {.lex_state = 254, .external_lex_state = 10},
  [543] = {.lex_state = 254, .external_lex_state = 10},
  [544] = {.lex_state = 254, .external_lex_state = 10},
  [545] = {.lex_state = 69},
  [546] = {.lex_state = 170, .external_lex_state = 6},
  [547] = {.lex_state = 172, .external_lex_state = 16},
  [548] = {.lex_state = 172, .external_lex_state = 16},
  [549] = {.lex_state = 172, .external_lex_state = 16},
  [550] = {.lex_state = 135, .external_lex_state = 4},
  [551] = {.lex_state = 139, .external_lex_state = 8},
  [552] = {.lex_state = 63, .external_lex_state = 2},
  [553] = {.lex_state = 90, .external_lex_state = 4},
  [554] = {.lex_state = 120, .external_lex_state = 8},
  [555] = {.lex_state = 63, .external_lex_state = 2},
  [556] = {.lex_state = 135, .external_lex_state = 4},
  [557] = {.lex_state = 139, .external_lex_state = 8},
  [558] = {.lex_state = 63, .external_lex_state = 2},
  [559] = {.lex_state = 126, .external_lex_state = 4},
  [560] = {.lex_state = 84},
  [561] = {.lex_state = 225},
  [562] = {.lex_state = 256, .external_lex_state = 10},
  [563] = {.lex_state = 97},
  [564] = {.lex_state = 104},
  [565] = {.lex_state = 256, .external_lex_state = 10},
  [566] = {.lex_state = 113, .external_lex_state = 6},
  [567] = {.lex_state = 63, .external_lex_state = 2},
  [568] = {.lex_state = 63, .external_lex_state = 2},
  [569] = {.lex_state = 63, .external_lex_state = 2},
  [570] = {.lex_state = 256, .external_lex_state = 4},
  [571] = {.lex_state = 63, .external_lex_state = 2},
  [572] = {.lex_state = 141, .external_lex_state = 4},
  [573] = {.lex_state = 248, .external_lex_state = 7},
  [574] = {.lex_state = 63, .external_lex_state = 2},
  [575] = {.lex_state = 141, .external_lex_state = 4},
  [576] = {.lex_state = 204, .external_lex_state = 7},
  [577] = {.lex_state = 141, .external_lex_state = 4},
  [578] = {.lex_state = 63, .external_lex_state = 2},
  [579] = {.lex_state = 63, .external_lex_state = 2},
  [580] = {.lex_state = 80},
  [581] = {.lex_state = 80},
  [582] = {.lex_state = 63, .external_lex_state = 2},
  [583] = {.lex_state = 80},
  [584] = {.lex_state = 129, .external_lex_state = 10},
  [585] = {.lex_state = 258},
  [586] = {.lex_state = 126, .external_lex_state = 4},
  [587] = {.lex_state = 129, .external_lex_state = 10},
  [588] = {.lex_state = 129, .external_lex_state = 10},
  [589] = {.lex_state = 164},
  [590] = {.lex_state = 258},
  [591] = {.lex_state = 126, .external_lex_state = 4},
  [592] = {.lex_state = 235, .external_lex_state = 16},
  [593] = {.lex_state = 69},
  [594] = {.lex_state = 172, .external_lex_state = 16},
  [595] = {.lex_state = 172, .external_lex_state = 16},
  [596] = {.lex_state = 172, .external_lex_state = 16},
  [597] = {.lex_state = 129, .external_lex_state = 10},
  [598] = {.lex_state = 239},
  [599] = {.lex_state = 237, .external_lex_state = 16},
  [600] = {.lex_state = 129, .external_lex_state = 10},
  [601] = {.lex_state = 239},
  [602] = {.lex_state = 237, .external_lex_state = 16},
  [603] = {.lex_state = 129, .external_lex_state = 10},
  [604] = {.lex_state = 239},
  [605] = {.lex_state = 237, .external_lex_state = 16},
  [606] = {.lex_state = 129, .external_lex_state = 10},
  [607] = {.lex_state = 219, .external_lex_state = 2},
  [608] = {.lex_state = 135, .external_lex_state = 4},
  [609] = {.lex_state = 139, .external_lex_state = 8},
  [610] = {.lex_state = 63, .external_lex_state = 2},
  [611] = {.lex_state = 90, .external_lex_state = 4},
  [612] = {.lex_state = 120, .external_lex_state = 8},
  [613] = {.lex_state = 129, .external_lex_state = 10},
  [614] = {.lex_state = 219, .external_lex_state = 2},
  [615] = {.lex_state = 135, .external_lex_state = 4},
  [616] = {.lex_state = 139, .external_lex_state = 8},
  [617] = {.lex_state = 133},
  [618] = {.lex_state = 260, .external_lex_state = 21},
  [619] = {.lex_state = 90, .external_lex_state = 4},
  [620] = {.lex_state = 120, .external_lex_state = 8},
  [621] = {.lex_state = 214, .external_lex_state = 20},
  [622] = {.lex_state = 63},
  [623] = {.lex_state = 80},
  [624] = {.lex_state = 141, .external_lex_state = 4},
  [625] = {.lex_state = 139, .external_lex_state = 19},
  [626] = {.lex_state = 139, .external_lex_state = 19},
  [627] = {.lex_state = 221, .external_lex_state = 7},
  [628] = {.lex_state = 84},
  [629] = {.lex_state = 262, .external_lex_state = 21},
  [630] = {.lex_state = 221, .external_lex_state = 21},
  [631] = {.lex_state = 124, .external_lex_state = 9},
  [632] = {.lex_state = 135, .external_lex_state = 14},
  [633] = {.lex_state = 135, .external_lex_state = 3},
  [634] = {.lex_state = 135, .external_lex_state = 10},
  [635] = {.lex_state = 135, .external_lex_state = 4},
  [636] = {.lex_state = 122, .external_lex_state = 5},
  [637] = {.lex_state = 133},
  [638] = {.lex_state = 141, .external_lex_state = 4},
  [639] = {.lex_state = 135, .external_lex_state = 4},
  [640] = {.lex_state = 139, .external_lex_state = 8},
  [641] = {.lex_state = 80},
  [642] = {.lex_state = 122, .external_lex_state = 5},
  [643] = {.lex_state = 122, .external_lex_state = 5},
  [644] = {.lex_state = 221, .external_lex_state = 5},
  [645] = {.lex_state = 221, .external_lex_state = 5},
  [646] = {.lex_state = 221, .external_lex_state = 5},
  [647] = {.lex_state = 221, .external_lex_state = 5},
  [648] = {.lex_state = 221, .external_lex_state = 7},
  [649] = {.lex_state = 221, .external_lex_state = 7},
  [650] = {.lex_state = 122, .external_lex_state = 7},
  [651] = {.lex_state = 219, .external_lex_state = 2},
  [652] = {.lex_state = 122, .external_lex_state = 7},
  [653] = {.lex_state = 80, .external_lex_state = 2},
  [654] = {.lex_state = 210},
  [655] = {.lex_state = 80, .external_lex_state = 15},
  [656] = {.lex_state = 80, .external_lex_state = 15},
  [657] = {.lex_state = 212},
  [658] = {.lex_state = 223, .external_lex_state = 13},
  [659] = {.lex_state = 147, .external_lex_state = 12},
  [660] = {.lex_state = 84},
  [661] = {.lex_state = 225},
  [662] = {.lex_state = 147, .external_lex_state = 11},
  [663] = {.lex_state = 147, .external_lex_state = 11},
  [664] = {.lex_state = 147, .external_lex_state = 11},
  [665] = {.lex_state = 164},
  [666] = {.lex_state = 235, .external_lex_state = 16},
  [667] = {.lex_state = 69},
  [668] = {.lex_state = 172, .external_lex_state = 16},
  [669] = {.lex_state = 172, .external_lex_state = 16},
  [670] = {.lex_state = 172, .external_lex_state = 16},
  [671] = {.lex_state = 147, .external_lex_state = 11},
  [672] = {.lex_state = 239},
  [673] = {.lex_state = 237, .external_lex_state = 16},
  [674] = {.lex_state = 147, .external_lex_state = 11},
  [675] = {.lex_state = 239},
  [676] = {.lex_state = 237, .external_lex_state = 16},
  [677] = {.lex_state = 147, .external_lex_state = 11},
  [678] = {.lex_state = 239},
  [679] = {.lex_state = 237, .external_lex_state = 16},
  [680] = {.lex_state = 147, .external_lex_state = 11},
  [681] = {.lex_state = 219, .external_lex_state = 2},
  [682] = {.lex_state = 135, .external_lex_state = 4},
  [683] = {.lex_state = 139, .external_lex_state = 8},
  [684] = {.lex_state = 63, .external_lex_state = 2},
  [685] = {.lex_state = 90, .external_lex_state = 4},
  [686] = {.lex_state = 120, .external_lex_state = 8},
  [687] = {.lex_state = 147, .external_lex_state = 11},
  [688] = {.lex_state = 219, .external_lex_state = 2},
  [689] = {.lex_state = 135, .external_lex_state = 4},
  [690] = {.lex_state = 139, .external_lex_state = 8},
  [691] = {.lex_state = 147, .external_lex_state = 12},
  [692] = {.lex_state = 63},
  [693] = {.lex_state = 80},
  [694] = {.lex_state = 63, .external_lex_state = 18},
  [695] = {.lex_state = 80},
  [696] = {.lex_state = 204, .external_lex_state = 21},
  [697] = {.lex_state = 147, .external_lex_state = 12},
  [698] = {.lex_state = 264},
  [699] = {.lex_state = 232, .external_lex_state = 13},
  [700] = {.lex_state = 160, .external_lex_state = 13},
  [701] = {.lex_state = 232, .external_lex_state = 13},
  [702] = {.lex_state = 164},
  [703] = {.lex_state = 235, .external_lex_state = 16},
  [704] = {.lex_state = 69},
  [705] = {.lex_state = 172, .external_lex_state = 16},
  [706] = {.lex_state = 172, .external_lex_state = 16},
  [707] = {.lex_state = 172, .external_lex_state = 16},
  [708] = {.lex_state = 232, .external_lex_state = 13},
  [709] = {.lex_state = 239},
  [710] = {.lex_state = 237, .external_lex_state = 16},
  [711] = {.lex_state = 232, .external_lex_state = 13},
  [712] = {.lex_state = 239},
  [713] = {.lex_state = 237, .external_lex_state = 16},
  [714] = {.lex_state = 232, .external_lex_state = 13},
  [715] = {.lex_state = 239},
  [716] = {.lex_state = 237, .external_lex_state = 16},
  [717] = {.lex_state = 232, .external_lex_state = 13},
  [718] = {.lex_state = 219, .external_lex_state = 2},
  [719] = {.lex_state = 135, .external_lex_state = 4},
  [720] = {.lex_state = 139, .external_lex_state = 8},
  [721] = {.lex_state = 63, .external_lex_state = 2},
  [722] = {.lex_state = 90, .external_lex_state = 4},
  [723] = {.lex_state = 120, .external_lex_state = 8},
  [724] = {.lex_state = 232, .external_lex_state = 13},
  [725] = {.lex_state = 219, .external_lex_state = 2},
  [726] = {.lex_state = 135, .external_lex_state = 4},
  [727] = {.lex_state = 139, .external_lex_state = 8},
  [728] = {.lex_state = 264},
  [729] = {.lex_state = 264},
  [730] = {.lex_state = 135, .external_lex_state = 3},
  [731] = {.lex_state = 210},
  [732] = {.lex_state = 90, .external_lex_state = 14},
  [733] = {.lex_state = 90, .external_lex_state = 14},
  [734] = {.lex_state = 135, .external_lex_state = 14},
  [735] = {.lex_state = 90, .external_lex_state = 14},
  [736] = {.lex_state = 135, .external_lex_state = 14},
  [737] = {.lex_state = 164},
  [738] = {.lex_state = 235, .external_lex_state = 16},
  [739] = {.lex_state = 69},
  [740] = {.lex_state = 172, .external_lex_state = 16},
  [741] = {.lex_state = 172, .external_lex_state = 16},
  [742] = {.lex_state = 172, .external_lex_state = 16},
  [743] = {.lex_state = 135, .external_lex_state = 14},
  [744] = {.lex_state = 239},
  [745] = {.lex_state = 237, .external_lex_state = 16},
  [746] = {.lex_state = 135, .external_lex_state = 14},
  [747] = {.lex_state = 239},
  [748] = {.lex_state = 237, .external_lex_state = 16},
  [749] = {.lex_state = 135, .external_lex_state = 14},
  [750] = {.lex_state = 239},
  [751] = {.lex_state = 237, .external_lex_state = 16},
  [752] = {.lex_state = 135, .external_lex_state = 14},
  [753] = {.lex_state = 219, .external_lex_state = 2},
  [754] = {.lex_state = 135, .external_lex_state = 4},
  [755] = {.lex_state = 139, .external_lex_state = 8},
  [756] = {.lex_state = 63, .external_lex_state = 2},
  [757] = {.lex_state = 90, .external_lex_state = 4},
  [758] = {.lex_state = 120, .external_lex_state = 8},
  [759] = {.lex_state = 135, .external_lex_state = 14},
  [760] = {.lex_state = 219, .external_lex_state = 2},
  [761] = {.lex_state = 135, .external_lex_state = 4},
  [762] = {.lex_state = 139, .external_lex_state = 8},
  [763] = {.lex_state = 135, .external_lex_state = 10},
  [764] = {.lex_state = 90, .external_lex_state = 10},
  [765] = {.lex_state = 135, .external_lex_state = 10},
  [766] = {.lex_state = 164},
  [767] = {.lex_state = 235, .external_lex_state = 16},
  [768] = {.lex_state = 69},
  [769] = {.lex_state = 172, .external_lex_state = 16},
  [770] = {.lex_state = 172, .external_lex_state = 16},
  [771] = {.lex_state = 172, .external_lex_state = 16},
  [772] = {.lex_state = 135, .external_lex_state = 10},
  [773] = {.lex_state = 239},
  [774] = {.lex_state = 237, .external_lex_state = 16},
  [775] = {.lex_state = 135, .external_lex_state = 10},
  [776] = {.lex_state = 239},
  [777] = {.lex_state = 237, .external_lex_state = 16},
  [778] = {.lex_state = 135, .external_lex_state = 10},
  [779] = {.lex_state = 239},
  [780] = {.lex_state = 237, .external_lex_state = 16},
  [781] = {.lex_state = 135, .external_lex_state = 10},
  [782] = {.lex_state = 219, .external_lex_state = 2},
  [783] = {.lex_state = 135, .external_lex_state = 4},
  [784] = {.lex_state = 139, .external_lex_state = 8},
  [785] = {.lex_state = 63, .external_lex_state = 2},
  [786] = {.lex_state = 90, .external_lex_state = 4},
  [787] = {.lex_state = 120, .external_lex_state = 8},
  [788] = {.lex_state = 135, .external_lex_state = 10},
  [789] = {.lex_state = 219, .external_lex_state = 2},
  [790] = {.lex_state = 135, .external_lex_state = 4},
  [791] = {.lex_state = 139, .external_lex_state = 8},
  [792] = {.lex_state = 80, .external_lex_state = 15},
  [793] = {.lex_state = 80, .external_lex_state = 15},
  [794] = {.lex_state = 80, .external_lex_state = 15},
  [795] = {.lex_state = 164},
  [796] = {.lex_state = 235, .external_lex_state = 16},
  [797] = {.lex_state = 69},
  [798] = {.lex_state = 172, .external_lex_state = 16},
  [799] = {.lex_state = 172, .external_lex_state = 16},
  [800] = {.lex_state = 172, .external_lex_state = 16},
  [801] = {.lex_state = 80, .external_lex_state = 15},
  [802] = {.lex_state = 239},
  [803] = {.lex_state = 237, .external_lex_state = 16},
  [804] = {.lex_state = 80, .external_lex_state = 15},
  [805] = {.lex_state = 239},
  [806] = {.lex_state = 237, .external_lex_state = 16},
  [807] = {.lex_state = 80, .external_lex_state = 15},
  [808] = {.lex_state = 239},
  [809] = {.lex_state = 237, .external_lex_state = 16},
  [810] = {.lex_state = 80, .external_lex_state = 15},
  [811] = {.lex_state = 219, .external_lex_state = 2},
  [812] = {.lex_state = 135, .external_lex_state = 4},
  [813] = {.lex_state = 139, .external_lex_state = 8},
  [814] = {.lex_state = 63, .external_lex_state = 2},
  [815] = {.lex_state = 90, .external_lex_state = 4},
  [816] = {.lex_state = 120, .external_lex_state = 8},
  [817] = {.lex_state = 80, .external_lex_state = 15},
  [818] = {.lex_state = 219, .external_lex_state = 2},
  [819] = {.lex_state = 135, .external_lex_state = 4},
  [820] = {.lex_state = 139, .external_lex_state = 8},
  [821] = {.lex_state = 97},
  [822] = {.lex_state = 235, .external_lex_state = 16},
  [823] = {.lex_state = 69},
  [824] = {.lex_state = 172, .external_lex_state = 16},
  [825] = {.lex_state = 172, .external_lex_state = 16},
  [826] = {.lex_state = 172, .external_lex_state = 16},
  [827] = {.lex_state = 97, .external_lex_state = 13},
  [828] = {.lex_state = 239},
  [829] = {.lex_state = 237, .external_lex_state = 16},
  [830] = {.lex_state = 97, .external_lex_state = 13},
  [831] = {.lex_state = 239},
  [832] = {.lex_state = 237, .external_lex_state = 16},
  [833] = {.lex_state = 97, .external_lex_state = 13},
  [834] = {.lex_state = 239},
  [835] = {.lex_state = 237, .external_lex_state = 16},
  [836] = {.lex_state = 97, .external_lex_state = 13},
  [837] = {.lex_state = 219, .external_lex_state = 2},
  [838] = {.lex_state = 135, .external_lex_state = 4},
  [839] = {.lex_state = 139, .external_lex_state = 8},
  [840] = {.lex_state = 63, .external_lex_state = 2},
  [841] = {.lex_state = 90, .external_lex_state = 4},
  [842] = {.lex_state = 120, .external_lex_state = 8},
  [843] = {.lex_state = 122, .external_lex_state = 5},
  [844] = {.lex_state = 164},
  [845] = {.lex_state = 208, .external_lex_state = 11},
  [846] = {.lex_state = 208, .external_lex_state = 11},
  [847] = {.lex_state = 208, .external_lex_state = 11},
  [848] = {.lex_state = 122, .external_lex_state = 5},
  [849] = {.lex_state = 214, .external_lex_state = 22},
  [850] = {.lex_state = 97},
  [851] = {.lex_state = 104},
  [852] = {.lex_state = 214, .external_lex_state = 22},
  [853] = {.lex_state = 113, .external_lex_state = 6},
  [854] = {.lex_state = 63, .external_lex_state = 2},
  [855] = {.lex_state = 63, .external_lex_state = 2},
  [856] = {.lex_state = 63, .external_lex_state = 2},
  [857] = {.lex_state = 214, .external_lex_state = 16},
  [858] = {.lex_state = 235, .external_lex_state = 16},
  [859] = {.lex_state = 122, .external_lex_state = 5},
  [860] = {.lex_state = 239},
  [861] = {.lex_state = 237, .external_lex_state = 16},
  [862] = {.lex_state = 122, .external_lex_state = 5},
  [863] = {.lex_state = 239},
  [864] = {.lex_state = 237, .external_lex_state = 16},
  [865] = {.lex_state = 239},
  [866] = {.lex_state = 237, .external_lex_state = 16},
  [867] = {.lex_state = 80},
  [868] = {.lex_state = 237, .external_lex_state = 22},
  [869] = {.lex_state = 237, .external_lex_state = 22},
  [870] = {.lex_state = 164},
  [871] = {.lex_state = 97},
  [872] = {.lex_state = 237, .external_lex_state = 22},
  [873] = {.lex_state = 237, .external_lex_state = 22},
  [874] = {.lex_state = 237, .external_lex_state = 22},
  [875] = {.lex_state = 69},
  [876] = {.lex_state = 170, .external_lex_state = 6},
  [877] = {.lex_state = 172, .external_lex_state = 16},
  [878] = {.lex_state = 172, .external_lex_state = 16},
  [879] = {.lex_state = 172, .external_lex_state = 16},
  [880] = {.lex_state = 237, .external_lex_state = 16},
  [881] = {.lex_state = 135, .external_lex_state = 4},
  [882] = {.lex_state = 139, .external_lex_state = 8},
  [883] = {.lex_state = 63, .external_lex_state = 2},
  [884] = {.lex_state = 90, .external_lex_state = 4},
  [885] = {.lex_state = 120, .external_lex_state = 8},
  [886] = {.lex_state = 63, .external_lex_state = 2},
  [887] = {.lex_state = 135, .external_lex_state = 4},
  [888] = {.lex_state = 139, .external_lex_state = 8},
  [889] = {.lex_state = 63, .external_lex_state = 2},
  [890] = {.lex_state = 122, .external_lex_state = 5},
  [891] = {.lex_state = 237, .external_lex_state = 16},
  [892] = {.lex_state = 237, .external_lex_state = 16},
  [893] = {.lex_state = 122, .external_lex_state = 5},
  [894] = {.lex_state = 237, .external_lex_state = 16},
  [895] = {.lex_state = 122, .external_lex_state = 5},
  [896] = {.lex_state = 219, .external_lex_state = 2},
  [897] = {.lex_state = 246, .external_lex_state = 7},
  [898] = {.lex_state = 84},
  [899] = {.lex_state = 266, .external_lex_state = 21},
  [900] = {.lex_state = 246, .external_lex_state = 21},
  [901] = {.lex_state = 133},
  [902] = {.lex_state = 120, .external_lex_state = 8},
  [903] = {.lex_state = 90, .external_lex_state = 4},
  [904] = {.lex_state = 120, .external_lex_state = 8},
  [905] = {.lex_state = 80},
  [906] = {.lex_state = 246, .external_lex_state = 5},
  [907] = {.lex_state = 246, .external_lex_state = 5},
  [908] = {.lex_state = 246, .external_lex_state = 5},
  [909] = {.lex_state = 246, .external_lex_state = 5},
  [910] = {.lex_state = 246, .external_lex_state = 7},
  [911] = {.lex_state = 246, .external_lex_state = 7},
  [912] = {.lex_state = 63, .external_lex_state = 2},
  [913] = {.lex_state = 94, .external_lex_state = 7},
  [914] = {.lex_state = 122, .external_lex_state = 5},
  [915] = {.lex_state = 219, .external_lex_state = 2},
  [916] = {.lex_state = 216, .external_lex_state = 21},
  [917] = {.lex_state = 178, .external_lex_state = 17},
  [918] = {.lex_state = 178, .external_lex_state = 17},
  [919] = {.lex_state = 69},
  [920] = {.lex_state = 170, .external_lex_state = 6},
  [921] = {.lex_state = 172, .external_lex_state = 16},
  [922] = {.lex_state = 172, .external_lex_state = 16},
  [923] = {.lex_state = 172, .external_lex_state = 16},
  [924] = {.lex_state = 141, .external_lex_state = 4},
  [925] = {.lex_state = 178, .external_lex_state = 17},
  [926] = {.lex_state = 204, .external_lex_state = 5},
  [927] = {.lex_state = 204, .external_lex_state = 5},
  [928] = {.lex_state = 248, .external_lex_state = 7},
  [929] = {.lex_state = 204, .external_lex_state = 5},
  [930] = {.lex_state = 141, .external_lex_state = 4},
  [931] = {.lex_state = 204, .external_lex_state = 7},
  [932] = {.lex_state = 69, .external_lex_state = 13},
  [933] = {.lex_state = 69},
  [934] = {.lex_state = 208, .external_lex_state = 11},
  [935] = {.lex_state = 69, .external_lex_state = 13},
  [936] = {.lex_state = 69},
  [937] = {.lex_state = 80},
  [938] = {.lex_state = 210, .external_lex_state = 13},
  [939] = {.lex_state = 210, .external_lex_state = 13},
  [940] = {.lex_state = 164},
  [941] = {.lex_state = 97},
  [942] = {.lex_state = 210, .external_lex_state = 13},
  [943] = {.lex_state = 210, .external_lex_state = 13},
  [944] = {.lex_state = 210, .external_lex_state = 13},
  [945] = {.lex_state = 69},
  [946] = {.lex_state = 170, .external_lex_state = 6},
  [947] = {.lex_state = 172, .external_lex_state = 16},
  [948] = {.lex_state = 172, .external_lex_state = 16},
  [949] = {.lex_state = 172, .external_lex_state = 16},
  [950] = {.lex_state = 135, .external_lex_state = 4},
  [951] = {.lex_state = 139, .external_lex_state = 8},
  [952] = {.lex_state = 63, .external_lex_state = 2},
  [953] = {.lex_state = 90, .external_lex_state = 4},
  [954] = {.lex_state = 120, .external_lex_state = 8},
  [955] = {.lex_state = 63, .external_lex_state = 2},
  [956] = {.lex_state = 135, .external_lex_state = 4},
  [957] = {.lex_state = 139, .external_lex_state = 8},
  [958] = {.lex_state = 63, .external_lex_state = 2},
  [959] = {.lex_state = 139, .external_lex_state = 8},
  [960] = {.lex_state = 210},
  [961] = {.lex_state = 139, .external_lex_state = 19},
  [962] = {.lex_state = 120, .external_lex_state = 19},
  [963] = {.lex_state = 139, .external_lex_state = 19},
  [964] = {.lex_state = 164},
  [965] = {.lex_state = 235, .external_lex_state = 16},
  [966] = {.lex_state = 69},
  [967] = {.lex_state = 172, .external_lex_state = 16},
  [968] = {.lex_state = 172, .external_lex_state = 16},
  [969] = {.lex_state = 172, .external_lex_state = 16},
  [970] = {.lex_state = 139, .external_lex_state = 19},
  [971] = {.lex_state = 239},
  [972] = {.lex_state = 237, .external_lex_state = 16},
  [973] = {.lex_state = 139, .external_lex_state = 19},
  [974] = {.lex_state = 239},
  [975] = {.lex_state = 237, .external_lex_state = 16},
  [976] = {.lex_state = 139, .external_lex_state = 19},
  [977] = {.lex_state = 239},
  [978] = {.lex_state = 237, .external_lex_state = 16},
  [979] = {.lex_state = 139, .external_lex_state = 19},
  [980] = {.lex_state = 219, .external_lex_state = 2},
  [981] = {.lex_state = 135, .external_lex_state = 4},
  [982] = {.lex_state = 139, .external_lex_state = 8},
  [983] = {.lex_state = 63, .external_lex_state = 2},
  [984] = {.lex_state = 90, .external_lex_state = 4},
  [985] = {.lex_state = 120, .external_lex_state = 8},
  [986] = {.lex_state = 139, .external_lex_state = 19},
  [987] = {.lex_state = 219, .external_lex_state = 2},
  [988] = {.lex_state = 135, .external_lex_state = 4},
  [989] = {.lex_state = 139, .external_lex_state = 8},
  [990] = {.lex_state = 268},
  [991] = {.lex_state = 84},
  [992] = {.lex_state = 84},
  [993] = {.lex_state = 270, .external_lex_state = 13},
  [994] = {.lex_state = 97},
  [995] = {.lex_state = 104},
  [996] = {.lex_state = 270, .external_lex_state = 13},
  [997] = {.lex_state = 113, .external_lex_state = 6},
  [998] = {.lex_state = 63, .external_lex_state = 2},
  [999] = {.lex_state = 63, .external_lex_state = 2},
  [1000] = {.lex_state = 63, .external_lex_state = 2},
  [1001] = {.lex_state = 270},
  [1002] = {.lex_state = 250},
  [1003] = {.lex_state = 212, .external_lex_state = 4},
  [1004] = {.lex_state = 254, .external_lex_state = 10},
  [1005] = {.lex_state = 212, .external_lex_state = 10},
  [1006] = {.lex_state = 254, .external_lex_state = 10},
  [1007] = {.lex_state = 164},
  [1008] = {.lex_state = 235, .external_lex_state = 16},
  [1009] = {.lex_state = 69},
  [1010] = {.lex_state = 172, .external_lex_state = 16},
  [1011] = {.lex_state = 172, .external_lex_state = 16},
  [1012] = {.lex_state = 172, .external_lex_state = 16},
  [1013] = {.lex_state = 254, .external_lex_state = 10},
  [1014] = {.lex_state = 239},
  [1015] = {.lex_state = 237, .external_lex_state = 16},
  [1016] = {.lex_state = 254, .external_lex_state = 10},
  [1017] = {.lex_state = 239},
  [1018] = {.lex_state = 237, .external_lex_state = 16},
  [1019] = {.lex_state = 254, .external_lex_state = 10},
  [1020] = {.lex_state = 239},
  [1021] = {.lex_state = 237, .external_lex_state = 16},
  [1022] = {.lex_state = 254, .external_lex_state = 10},
  [1023] = {.lex_state = 219, .external_lex_state = 2},
  [1024] = {.lex_state = 135, .external_lex_state = 4},
  [1025] = {.lex_state = 139, .external_lex_state = 8},
  [1026] = {.lex_state = 63, .external_lex_state = 2},
  [1027] = {.lex_state = 90, .external_lex_state = 4},
  [1028] = {.lex_state = 120, .external_lex_state = 8},
  [1029] = {.lex_state = 254, .external_lex_state = 10},
  [1030] = {.lex_state = 219, .external_lex_state = 2},
  [1031] = {.lex_state = 135, .external_lex_state = 4},
  [1032] = {.lex_state = 139, .external_lex_state = 8},
  [1033] = {.lex_state = 212, .external_lex_state = 4},
  [1034] = {.lex_state = 212, .external_lex_state = 4},
  [1035] = {.lex_state = 212, .external_lex_state = 4},
  [1036] = {.lex_state = 80},
  [1037] = {.lex_state = 256, .external_lex_state = 10},
  [1038] = {.lex_state = 256, .external_lex_state = 10},
  [1039] = {.lex_state = 164},
  [1040] = {.lex_state = 97},
  [1041] = {.lex_state = 256, .external_lex_state = 10},
  [1042] = {.lex_state = 256, .external_lex_state = 10},
  [1043] = {.lex_state = 256, .external_lex_state = 10},
  [1044] = {.lex_state = 69},
  [1045] = {.lex_state = 170, .external_lex_state = 6},
  [1046] = {.lex_state = 172, .external_lex_state = 16},
  [1047] = {.lex_state = 172, .external_lex_state = 16},
  [1048] = {.lex_state = 172, .external_lex_state = 16},
  [1049] = {.lex_state = 135, .external_lex_state = 4},
  [1050] = {.lex_state = 139, .external_lex_state = 8},
  [1051] = {.lex_state = 63, .external_lex_state = 2},
  [1052] = {.lex_state = 90, .external_lex_state = 4},
  [1053] = {.lex_state = 120, .external_lex_state = 8},
  [1054] = {.lex_state = 63, .external_lex_state = 2},
  [1055] = {.lex_state = 135, .external_lex_state = 4},
  [1056] = {.lex_state = 139, .external_lex_state = 8},
  [1057] = {.lex_state = 63, .external_lex_state = 2},
  [1058] = {.lex_state = 80},
  [1059] = {.lex_state = 256, .external_lex_state = 4},
  [1060] = {.lex_state = 141, .external_lex_state = 4},
  [1061] = {.lex_state = 63, .external_lex_state = 2},
  [1062] = {.lex_state = 248, .external_lex_state = 7},
  [1063] = {.lex_state = 63, .external_lex_state = 2},
  [1064] = {.lex_state = 141, .external_lex_state = 4},
  [1065] = {.lex_state = 80},
  [1066] = {.lex_state = 63, .external_lex_state = 2},
  [1067] = {.lex_state = 141, .external_lex_state = 4},
  [1068] = {.lex_state = 80},
  [1069] = {.lex_state = 63, .external_lex_state = 2},
  [1070] = {.lex_state = 80},
  [1071] = {.lex_state = 80},
  [1072] = {.lex_state = 141, .external_lex_state = 4},
  [1073] = {.lex_state = 272, .external_lex_state = 13},
  [1074] = {.lex_state = 272, .external_lex_state = 13},
  [1075] = {.lex_state = 275},
  [1076] = {.lex_state = 272},
  [1077] = {.lex_state = 80},
  [1078] = {.lex_state = 258},
  [1079] = {.lex_state = 129, .external_lex_state = 10},
  [1080] = {.lex_state = 141, .external_lex_state = 4},
  [1081] = {.lex_state = 275},
  [1082] = {.lex_state = 80},
  [1083] = {.lex_state = 258},
  [1084] = {.lex_state = 129, .external_lex_state = 10},
  [1085] = {.lex_state = 214, .external_lex_state = 22},
  [1086] = {.lex_state = 214, .external_lex_state = 22},
  [1087] = {.lex_state = 214, .external_lex_state = 16},
  [1088] = {.lex_state = 235, .external_lex_state = 16},
  [1089] = {.lex_state = 129, .external_lex_state = 10},
  [1090] = {.lex_state = 239},
  [1091] = {.lex_state = 237, .external_lex_state = 16},
  [1092] = {.lex_state = 129, .external_lex_state = 10},
  [1093] = {.lex_state = 239},
  [1094] = {.lex_state = 237, .external_lex_state = 16},
  [1095] = {.lex_state = 239},
  [1096] = {.lex_state = 237, .external_lex_state = 16},
  [1097] = {.lex_state = 237, .external_lex_state = 16},
  [1098] = {.lex_state = 129, .external_lex_state = 10},
  [1099] = {.lex_state = 237, .external_lex_state = 16},
  [1100] = {.lex_state = 129, .external_lex_state = 10},
  [1101] = {.lex_state = 237, .external_lex_state = 16},
  [1102] = {.lex_state = 129, .external_lex_state = 10},
  [1103] = {.lex_state = 219, .external_lex_state = 2},
  [1104] = {.lex_state = 63, .external_lex_state = 2},
  [1105] = {.lex_state = 129, .external_lex_state = 10},
  [1106] = {.lex_state = 219, .external_lex_state = 2},
  [1107] = {.lex_state = 216, .external_lex_state = 21},
  [1108] = {.lex_state = 214, .external_lex_state = 20},
  [1109] = {.lex_state = 260, .external_lex_state = 21},
  [1110] = {.lex_state = 214, .external_lex_state = 20},
  [1111] = {.lex_state = 80},
  [1112] = {.lex_state = 141, .external_lex_state = 10},
  [1113] = {.lex_state = 141, .external_lex_state = 10},
  [1114] = {.lex_state = 141, .external_lex_state = 4},
  [1115] = {.lex_state = 139, .external_lex_state = 19},
  [1116] = {.lex_state = 221, .external_lex_state = 7},
  [1117] = {.lex_state = 133},
  [1118] = {.lex_state = 63},
  [1119] = {.lex_state = 80},
  [1120] = {.lex_state = 63},
  [1121] = {.lex_state = 80},
  [1122] = {.lex_state = 80},
  [1123] = {.lex_state = 221, .external_lex_state = 21},
  [1124] = {.lex_state = 135, .external_lex_state = 14},
  [1125] = {.lex_state = 135, .external_lex_state = 14},
  [1126] = {.lex_state = 135, .external_lex_state = 14},
  [1127] = {.lex_state = 135, .external_lex_state = 10},
  [1128] = {.lex_state = 262, .external_lex_state = 21},
  [1129] = {.lex_state = 221, .external_lex_state = 5},
  [1130] = {.lex_state = 221, .external_lex_state = 5},
  [1131] = {.lex_state = 221, .external_lex_state = 5},
  [1132] = {.lex_state = 141, .external_lex_state = 4},
  [1133] = {.lex_state = 221, .external_lex_state = 7},
  [1134] = {.lex_state = 80, .external_lex_state = 2},
  [1135] = {.lex_state = 210},
  [1136] = {.lex_state = 223, .external_lex_state = 13},
  [1137] = {.lex_state = 147, .external_lex_state = 11},
  [1138] = {.lex_state = 147, .external_lex_state = 11},
  [1139] = {.lex_state = 214, .external_lex_state = 22},
  [1140] = {.lex_state = 214, .external_lex_state = 22},
  [1141] = {.lex_state = 214, .external_lex_state = 16},
  [1142] = {.lex_state = 235, .external_lex_state = 16},
  [1143] = {.lex_state = 147, .external_lex_state = 11},
  [1144] = {.lex_state = 239},
  [1145] = {.lex_state = 237, .external_lex_state = 16},
  [1146] = {.lex_state = 147, .external_lex_state = 11},
  [1147] = {.lex_state = 239},
  [1148] = {.lex_state = 237, .external_lex_state = 16},
  [1149] = {.lex_state = 239},
  [1150] = {.lex_state = 237, .external_lex_state = 16},
  [1151] = {.lex_state = 237, .external_lex_state = 16},
  [1152] = {.lex_state = 147, .external_lex_state = 11},
  [1153] = {.lex_state = 237, .external_lex_state = 16},
  [1154] = {.lex_state = 147, .external_lex_state = 11},
  [1155] = {.lex_state = 237, .external_lex_state = 16},
  [1156] = {.lex_state = 147, .external_lex_state = 11},
  [1157] = {.lex_state = 219, .external_lex_state = 2},
  [1158] = {.lex_state = 63, .external_lex_state = 2},
  [1159] = {.lex_state = 147, .external_lex_state = 11},
  [1160] = {.lex_state = 219, .external_lex_state = 2},
  [1161] = {.lex_state = 80},
  [1162] = {.lex_state = 204, .external_lex_state = 23},
  [1163] = {.lex_state = 97},
  [1164] = {.lex_state = 104},
  [1165] = {.lex_state = 204, .external_lex_state = 23},
  [1166] = {.lex_state = 113, .external_lex_state = 6},
  [1167] = {.lex_state = 63, .external_lex_state = 2},
  [1168] = {.lex_state = 63, .external_lex_state = 2},
  [1169] = {.lex_state = 63, .external_lex_state = 2},
  [1170] = {.lex_state = 248, .external_lex_state = 21},
  [1171] = {.lex_state = 248, .external_lex_state = 21},
  [1172] = {.lex_state = 204, .external_lex_state = 23},
  [1173] = {.lex_state = 204, .external_lex_state = 23},
  [1174] = {.lex_state = 248, .external_lex_state = 21},
  [1175] = {.lex_state = 204, .external_lex_state = 21},
  [1176] = {.lex_state = 232, .external_lex_state = 13},
  [1177] = {.lex_state = 232, .external_lex_state = 13},
  [1178] = {.lex_state = 214, .external_lex_state = 22},
  [1179] = {.lex_state = 214, .external_lex_state = 22},
  [1180] = {.lex_state = 214, .external_lex_state = 16},
  [1181] = {.lex_state = 235, .external_lex_state = 16},
  [1182] = {.lex_state = 232, .external_lex_state = 13},
  [1183] = {.lex_state = 239},
  [1184] = {.lex_state = 237, .external_lex_state = 16},
  [1185] = {.lex_state = 232, .external_lex_state = 13},
  [1186] = {.lex_state = 239},
  [1187] = {.lex_state = 237, .external_lex_state = 16},
  [1188] = {.lex_state = 239},
  [1189] = {.lex_state = 237, .external_lex_state = 16},
  [1190] = {.lex_state = 237, .external_lex_state = 16},
  [1191] = {.lex_state = 232, .external_lex_state = 13},
  [1192] = {.lex_state = 237, .external_lex_state = 16},
  [1193] = {.lex_state = 232, .external_lex_state = 13},
  [1194] = {.lex_state = 237, .external_lex_state = 16},
  [1195] = {.lex_state = 232, .external_lex_state = 13},
  [1196] = {.lex_state = 219, .external_lex_state = 2},
  [1197] = {.lex_state = 63, .external_lex_state = 2},
  [1198] = {.lex_state = 232, .external_lex_state = 13},
  [1199] = {.lex_state = 219, .external_lex_state = 2},
  [1200] = {.lex_state = 135, .external_lex_state = 3},
  [1201] = {.lex_state = 210},
  [1202] = {.lex_state = 135, .external_lex_state = 14},
  [1203] = {.lex_state = 135, .external_lex_state = 14},
  [1204] = {.lex_state = 214, .external_lex_state = 22},
  [1205] = {.lex_state = 214, .external_lex_state = 22},
  [1206] = {.lex_state = 214, .external_lex_state = 16},
  [1207] = {.lex_state = 235, .external_lex_state = 16},
  [1208] = {.lex_state = 135, .external_lex_state = 14},
  [1209] = {.lex_state = 239},
  [1210] = {.lex_state = 237, .external_lex_state = 16},
  [1211] = {.lex_state = 135, .external_lex_state = 14},
  [1212] = {.lex_state = 239},
  [1213] = {.lex_state = 237, .external_lex_state = 16},
  [1214] = {.lex_state = 239},
  [1215] = {.lex_state = 237, .external_lex_state = 16},
  [1216] = {.lex_state = 237, .external_lex_state = 16},
  [1217] = {.lex_state = 135, .external_lex_state = 14},
  [1218] = {.lex_state = 237, .external_lex_state = 16},
  [1219] = {.lex_state = 135, .external_lex_state = 14},
  [1220] = {.lex_state = 237, .external_lex_state = 16},
  [1221] = {.lex_state = 135, .external_lex_state = 14},
  [1222] = {.lex_state = 219, .external_lex_state = 2},
  [1223] = {.lex_state = 63, .external_lex_state = 2},
  [1224] = {.lex_state = 135, .external_lex_state = 14},
  [1225] = {.lex_state = 219, .external_lex_state = 2},
  [1226] = {.lex_state = 135, .external_lex_state = 10},
  [1227] = {.lex_state = 135, .external_lex_state = 10},
  [1228] = {.lex_state = 214, .external_lex_state = 22},
  [1229] = {.lex_state = 214, .external_lex_state = 22},
  [1230] = {.lex_state = 214, .external_lex_state = 16},
  [1231] = {.lex_state = 235, .external_lex_state = 16},
  [1232] = {.lex_state = 135, .external_lex_state = 10},
  [1233] = {.lex_state = 239},
  [1234] = {.lex_state = 237, .external_lex_state = 16},
  [1235] = {.lex_state = 135, .external_lex_state = 10},
  [1236] = {.lex_state = 239},
  [1237] = {.lex_state = 237, .external_lex_state = 16},
  [1238] = {.lex_state = 239},
  [1239] = {.lex_state = 237, .external_lex_state = 16},
  [1240] = {.lex_state = 237, .external_lex_state = 16},
  [1241] = {.lex_state = 135, .external_lex_state = 10},
  [1242] = {.lex_state = 237, .external_lex_state = 16},
  [1243] = {.lex_state = 135, .external_lex_state = 10},
  [1244] = {.lex_state = 237, .external_lex_state = 16},
  [1245] = {.lex_state = 135, .external_lex_state = 10},
  [1246] = {.lex_state = 219, .external_lex_state = 2},
  [1247] = {.lex_state = 63, .external_lex_state = 2},
  [1248] = {.lex_state = 135, .external_lex_state = 10},
  [1249] = {.lex_state = 219, .external_lex_state = 2},
  [1250] = {.lex_state = 80, .external_lex_state = 15},
  [1251] = {.lex_state = 80, .external_lex_state = 15},
  [1252] = {.lex_state = 214, .external_lex_state = 22},
  [1253] = {.lex_state = 214, .external_lex_state = 22},
  [1254] = {.lex_state = 214, .external_lex_state = 16},
  [1255] = {.lex_state = 235, .external_lex_state = 16},
  [1256] = {.lex_state = 80, .external_lex_state = 15},
  [1257] = {.lex_state = 239},
  [1258] = {.lex_state = 237, .external_lex_state = 16},
  [1259] = {.lex_state = 80, .external_lex_state = 15},
  [1260] = {.lex_state = 239},
  [1261] = {.lex_state = 237, .external_lex_state = 16},
  [1262] = {.lex_state = 239},
  [1263] = {.lex_state = 237, .external_lex_state = 16},
  [1264] = {.lex_state = 237, .external_lex_state = 16},
  [1265] = {.lex_state = 80, .external_lex_state = 15},
  [1266] = {.lex_state = 237, .external_lex_state = 16},
  [1267] = {.lex_state = 80, .external_lex_state = 15},
  [1268] = {.lex_state = 237, .external_lex_state = 16},
  [1269] = {.lex_state = 80, .external_lex_state = 15},
  [1270] = {.lex_state = 219, .external_lex_state = 2},
  [1271] = {.lex_state = 63, .external_lex_state = 2},
  [1272] = {.lex_state = 80, .external_lex_state = 15},
  [1273] = {.lex_state = 219, .external_lex_state = 2},
  [1274] = {.lex_state = 97, .external_lex_state = 13},
  [1275] = {.lex_state = 214, .external_lex_state = 22},
  [1276] = {.lex_state = 214, .external_lex_state = 22},
  [1277] = {.lex_state = 214, .external_lex_state = 16},
  [1278] = {.lex_state = 235, .external_lex_state = 16},
  [1279] = {.lex_state = 97, .external_lex_state = 13},
  [1280] = {.lex_state = 239},
  [1281] = {.lex_state = 237, .external_lex_state = 16},
  [1282] = {.lex_state = 97, .external_lex_state = 13},
  [1283] = {.lex_state = 239},
  [1284] = {.lex_state = 237, .external_lex_state = 16},
  [1285] = {.lex_state = 239},
  [1286] = {.lex_state = 237, .external_lex_state = 16},
  [1287] = {.lex_state = 237, .external_lex_state = 16},
  [1288] = {.lex_state = 97, .external_lex_state = 13},
  [1289] = {.lex_state = 237, .external_lex_state = 16},
  [1290] = {.lex_state = 97, .external_lex_state = 13},
  [1291] = {.lex_state = 237, .external_lex_state = 16},
  [1292] = {.lex_state = 97, .external_lex_state = 13},
  [1293] = {.lex_state = 219, .external_lex_state = 2},
  [1294] = {.lex_state = 63, .external_lex_state = 2},
  [1295] = {.lex_state = 208, .external_lex_state = 12},
  [1296] = {.lex_state = 172, .external_lex_state = 22},
  [1297] = {.lex_state = 208, .external_lex_state = 12},
  [1298] = {.lex_state = 172, .external_lex_state = 22},
  [1299] = {.lex_state = 147, .external_lex_state = 12},
  [1300] = {.lex_state = 80},
  [1301] = {.lex_state = 122, .external_lex_state = 5},
  [1302] = {.lex_state = 214, .external_lex_state = 22},
  [1303] = {.lex_state = 214, .external_lex_state = 22},
  [1304] = {.lex_state = 164},
  [1305] = {.lex_state = 97},
  [1306] = {.lex_state = 214, .external_lex_state = 22},
  [1307] = {.lex_state = 214, .external_lex_state = 22},
  [1308] = {.lex_state = 214, .external_lex_state = 22},
  [1309] = {.lex_state = 122, .external_lex_state = 5},
  [1310] = {.lex_state = 69},
  [1311] = {.lex_state = 170, .external_lex_state = 6},
  [1312] = {.lex_state = 172, .external_lex_state = 16},
  [1313] = {.lex_state = 172, .external_lex_state = 16},
  [1314] = {.lex_state = 172, .external_lex_state = 16},
  [1315] = {.lex_state = 135, .external_lex_state = 4},
  [1316] = {.lex_state = 139, .external_lex_state = 8},
  [1317] = {.lex_state = 63, .external_lex_state = 2},
  [1318] = {.lex_state = 90, .external_lex_state = 4},
  [1319] = {.lex_state = 120, .external_lex_state = 8},
  [1320] = {.lex_state = 63, .external_lex_state = 2},
  [1321] = {.lex_state = 135, .external_lex_state = 4},
  [1322] = {.lex_state = 139, .external_lex_state = 8},
  [1323] = {.lex_state = 63, .external_lex_state = 2},
  [1324] = {.lex_state = 214, .external_lex_state = 22},
  [1325] = {.lex_state = 214, .external_lex_state = 22},
  [1326] = {.lex_state = 214, .external_lex_state = 16},
  [1327] = {.lex_state = 237, .external_lex_state = 16},
  [1328] = {.lex_state = 122, .external_lex_state = 5},
  [1329] = {.lex_state = 237, .external_lex_state = 16},
  [1330] = {.lex_state = 122, .external_lex_state = 5},
  [1331] = {.lex_state = 237, .external_lex_state = 16},
  [1332] = {.lex_state = 237, .external_lex_state = 22},
  [1333] = {.lex_state = 237, .external_lex_state = 22},
  [1334] = {.lex_state = 237, .external_lex_state = 22},
  [1335] = {.lex_state = 164},
  [1336] = {.lex_state = 235, .external_lex_state = 16},
  [1337] = {.lex_state = 69},
  [1338] = {.lex_state = 172, .external_lex_state = 16},
  [1339] = {.lex_state = 172, .external_lex_state = 16},
  [1340] = {.lex_state = 172, .external_lex_state = 16},
  [1341] = {.lex_state = 237, .external_lex_state = 22},
  [1342] = {.lex_state = 239},
  [1343] = {.lex_state = 237, .external_lex_state = 16},
  [1344] = {.lex_state = 237, .external_lex_state = 22},
  [1345] = {.lex_state = 239},
  [1346] = {.lex_state = 237, .external_lex_state = 16},
  [1347] = {.lex_state = 237, .external_lex_state = 22},
  [1348] = {.lex_state = 239},
  [1349] = {.lex_state = 237, .external_lex_state = 16},
  [1350] = {.lex_state = 122, .external_lex_state = 5},
  [1351] = {.lex_state = 237, .external_lex_state = 16},
  [1352] = {.lex_state = 237, .external_lex_state = 22},
  [1353] = {.lex_state = 219, .external_lex_state = 2},
  [1354] = {.lex_state = 135, .external_lex_state = 4},
  [1355] = {.lex_state = 139, .external_lex_state = 8},
  [1356] = {.lex_state = 63, .external_lex_state = 2},
  [1357] = {.lex_state = 90, .external_lex_state = 4},
  [1358] = {.lex_state = 120, .external_lex_state = 8},
  [1359] = {.lex_state = 237, .external_lex_state = 22},
  [1360] = {.lex_state = 219, .external_lex_state = 2},
  [1361] = {.lex_state = 135, .external_lex_state = 4},
  [1362] = {.lex_state = 139, .external_lex_state = 8},
  [1363] = {.lex_state = 122, .external_lex_state = 5},
  [1364] = {.lex_state = 237, .external_lex_state = 16},
  [1365] = {.lex_state = 122, .external_lex_state = 5},
  [1366] = {.lex_state = 237, .external_lex_state = 16},
  [1367] = {.lex_state = 122, .external_lex_state = 5},
  [1368] = {.lex_state = 246, .external_lex_state = 7},
  [1369] = {.lex_state = 133},
  [1370] = {.lex_state = 63},
  [1371] = {.lex_state = 80},
  [1372] = {.lex_state = 63},
  [1373] = {.lex_state = 80},
  [1374] = {.lex_state = 80},
  [1375] = {.lex_state = 246, .external_lex_state = 21},
  [1376] = {.lex_state = 266, .external_lex_state = 21},
  [1377] = {.lex_state = 246, .external_lex_state = 5},
  [1378] = {.lex_state = 246, .external_lex_state = 5},
  [1379] = {.lex_state = 246, .external_lex_state = 5},
  [1380] = {.lex_state = 246, .external_lex_state = 7},
  [1381] = {.lex_state = 122, .external_lex_state = 5},
  [1382] = {.lex_state = 141, .external_lex_state = 4},
  [1383] = {.lex_state = 235, .external_lex_state = 16},
  [1384] = {.lex_state = 69},
  [1385] = {.lex_state = 172, .external_lex_state = 16},
  [1386] = {.lex_state = 172, .external_lex_state = 16},
  [1387] = {.lex_state = 172, .external_lex_state = 16},
  [1388] = {.lex_state = 178, .external_lex_state = 17},
  [1389] = {.lex_state = 239},
  [1390] = {.lex_state = 237, .external_lex_state = 16},
  [1391] = {.lex_state = 178, .external_lex_state = 17},
  [1392] = {.lex_state = 239},
  [1393] = {.lex_state = 237, .external_lex_state = 16},
  [1394] = {.lex_state = 178, .external_lex_state = 17},
  [1395] = {.lex_state = 239},
  [1396] = {.lex_state = 237, .external_lex_state = 16},
  [1397] = {.lex_state = 204, .external_lex_state = 5},
  [1398] = {.lex_state = 141, .external_lex_state = 4},
  [1399] = {.lex_state = 69},
  [1400] = {.lex_state = 69},
  [1401] = {.lex_state = 210, .external_lex_state = 13},
  [1402] = {.lex_state = 210, .external_lex_state = 13},
  [1403] = {.lex_state = 210, .external_lex_state = 13},
  [1404] = {.lex_state = 164},
  [1405] = {.lex_state = 235, .external_lex_state = 16},
  [1406] = {.lex_state = 69},
  [1407] = {.lex_state = 172, .external_lex_state = 16},
  [1408] = {.lex_state = 172, .external_lex_state = 16},
  [1409] = {.lex_state = 172, .external_lex_state = 16},
  [1410] = {.lex_state = 210, .external_lex_state = 13},
  [1411] = {.lex_state = 239},
  [1412] = {.lex_state = 237, .external_lex_state = 16},
  [1413] = {.lex_state = 210, .external_lex_state = 13},
  [1414] = {.lex_state = 239},
  [1415] = {.lex_state = 237, .external_lex_state = 16},
  [1416] = {.lex_state = 210, .external_lex_state = 13},
  [1417] = {.lex_state = 239},
  [1418] = {.lex_state = 237, .external_lex_state = 16},
  [1419] = {.lex_state = 210, .external_lex_state = 13},
  [1420] = {.lex_state = 219, .external_lex_state = 2},
  [1421] = {.lex_state = 135, .external_lex_state = 4},
  [1422] = {.lex_state = 139, .external_lex_state = 8},
  [1423] = {.lex_state = 63, .external_lex_state = 2},
  [1424] = {.lex_state = 90, .external_lex_state = 4},
  [1425] = {.lex_state = 120, .external_lex_state = 8},
  [1426] = {.lex_state = 210, .external_lex_state = 13},
  [1427] = {.lex_state = 219, .external_lex_state = 2},
  [1428] = {.lex_state = 135, .external_lex_state = 4},
  [1429] = {.lex_state = 139, .external_lex_state = 8},
  [1430] = {.lex_state = 139, .external_lex_state = 19},
  [1431] = {.lex_state = 139, .external_lex_state = 19},
  [1432] = {.lex_state = 214, .external_lex_state = 22},
  [1433] = {.lex_state = 214, .external_lex_state = 22},
  [1434] = {.lex_state = 214, .external_lex_state = 16},
  [1435] = {.lex_state = 235, .external_lex_state = 16},
  [1436] = {.lex_state = 139, .external_lex_state = 19},
  [1437] = {.lex_state = 239},
  [1438] = {.lex_state = 237, .external_lex_state = 16},
  [1439] = {.lex_state = 139, .external_lex_state = 19},
  [1440] = {.lex_state = 239},
  [1441] = {.lex_state = 237, .external_lex_state = 16},
  [1442] = {.lex_state = 239},
  [1443] = {.lex_state = 237, .external_lex_state = 16},
  [1444] = {.lex_state = 237, .external_lex_state = 16},
  [1445] = {.lex_state = 139, .external_lex_state = 19},
  [1446] = {.lex_state = 237, .external_lex_state = 16},
  [1447] = {.lex_state = 139, .external_lex_state = 19},
  [1448] = {.lex_state = 237, .external_lex_state = 16},
  [1449] = {.lex_state = 139, .external_lex_state = 19},
  [1450] = {.lex_state = 219, .external_lex_state = 2},
  [1451] = {.lex_state = 63, .external_lex_state = 2},
  [1452] = {.lex_state = 139, .external_lex_state = 19},
  [1453] = {.lex_state = 219, .external_lex_state = 2},
  [1454] = {.lex_state = 214, .external_lex_state = 20},
  [1455] = {.lex_state = 141, .external_lex_state = 4},
  [1456] = {.lex_state = 212},
  [1457] = {.lex_state = 270},
  [1458] = {.lex_state = 80},
  [1459] = {.lex_state = 270, .external_lex_state = 13},
  [1460] = {.lex_state = 270, .external_lex_state = 13},
  [1461] = {.lex_state = 164},
  [1462] = {.lex_state = 97},
  [1463] = {.lex_state = 270, .external_lex_state = 13},
  [1464] = {.lex_state = 270, .external_lex_state = 13},
  [1465] = {.lex_state = 270, .external_lex_state = 13},
  [1466] = {.lex_state = 69},
  [1467] = {.lex_state = 170, .external_lex_state = 6},
  [1468] = {.lex_state = 172, .external_lex_state = 16},
  [1469] = {.lex_state = 172, .external_lex_state = 16},
  [1470] = {.lex_state = 172, .external_lex_state = 16},
  [1471] = {.lex_state = 135, .external_lex_state = 4},
  [1472] = {.lex_state = 139, .external_lex_state = 8},
  [1473] = {.lex_state = 63, .external_lex_state = 2},
  [1474] = {.lex_state = 90, .external_lex_state = 4},
  [1475] = {.lex_state = 120, .external_lex_state = 8},
  [1476] = {.lex_state = 63, .external_lex_state = 2},
  [1477] = {.lex_state = 135, .external_lex_state = 4},
  [1478] = {.lex_state = 139, .external_lex_state = 8},
  [1479] = {.lex_state = 63, .external_lex_state = 2},
  [1480] = {.lex_state = 268},
  [1481] = {.lex_state = 84},
  [1482] = {.lex_state = 225},
  [1483] = {.lex_state = 270},
  [1484] = {.lex_state = 254, .external_lex_state = 10},
  [1485] = {.lex_state = 254, .external_lex_state = 10},
  [1486] = {.lex_state = 214, .external_lex_state = 22},
  [1487] = {.lex_state = 214, .external_lex_state = 22},
  [1488] = {.lex_state = 214, .external_lex_state = 16},
  [1489] = {.lex_state = 235, .external_lex_state = 16},
  [1490] = {.lex_state = 254, .external_lex_state = 10},
  [1491] = {.lex_state = 239},
  [1492] = {.lex_state = 237, .external_lex_state = 16},
  [1493] = {.lex_state = 254, .external_lex_state = 10},
  [1494] = {.lex_state = 239},
  [1495] = {.lex_state = 237, .external_lex_state = 16},
  [1496] = {.lex_state = 239},
  [1497] = {.lex_state = 237, .external_lex_state = 16},
  [1498] = {.lex_state = 237, .external_lex_state = 16},
  [1499] = {.lex_state = 254, .external_lex_state = 10},
  [1500] = {.lex_state = 237, .external_lex_state = 16},
  [1501] = {.lex_state = 254, .external_lex_state = 10},
  [1502] = {.lex_state = 237, .external_lex_state = 16},
  [1503] = {.lex_state = 254, .external_lex_state = 10},
  [1504] = {.lex_state = 219, .external_lex_state = 2},
  [1505] = {.lex_state = 63, .external_lex_state = 2},
  [1506] = {.lex_state = 254, .external_lex_state = 10},
  [1507] = {.lex_state = 219, .external_lex_state = 2},
  [1508] = {.lex_state = 250},
  [1509] = {.lex_state = 256, .external_lex_state = 10},
  [1510] = {.lex_state = 256, .external_lex_state = 10},
  [1511] = {.lex_state = 256, .external_lex_state = 10},
  [1512] = {.lex_state = 164},
  [1513] = {.lex_state = 235, .external_lex_state = 16},
  [1514] = {.lex_state = 69},
  [1515] = {.lex_state = 172, .external_lex_state = 16},
  [1516] = {.lex_state = 172, .external_lex_state = 16},
  [1517] = {.lex_state = 172, .external_lex_state = 16},
  [1518] = {.lex_state = 256, .external_lex_state = 10},
  [1519] = {.lex_state = 239},
  [1520] = {.lex_state = 237, .external_lex_state = 16},
  [1521] = {.lex_state = 256, .external_lex_state = 10},
  [1522] = {.lex_state = 239},
  [1523] = {.lex_state = 237, .external_lex_state = 16},
  [1524] = {.lex_state = 256, .external_lex_state = 10},
  [1525] = {.lex_state = 239},
  [1526] = {.lex_state = 237, .external_lex_state = 16},
  [1527] = {.lex_state = 256, .external_lex_state = 10},
  [1528] = {.lex_state = 219, .external_lex_state = 2},
  [1529] = {.lex_state = 135, .external_lex_state = 4},
  [1530] = {.lex_state = 139, .external_lex_state = 8},
  [1531] = {.lex_state = 63, .external_lex_state = 2},
  [1532] = {.lex_state = 90, .external_lex_state = 4},
  [1533] = {.lex_state = 120, .external_lex_state = 8},
  [1534] = {.lex_state = 256, .external_lex_state = 10},
  [1535] = {.lex_state = 219, .external_lex_state = 2},
  [1536] = {.lex_state = 135, .external_lex_state = 4},
  [1537] = {.lex_state = 139, .external_lex_state = 8},
  [1538] = {.lex_state = 141, .external_lex_state = 4},
  [1539] = {.lex_state = 141, .external_lex_state = 4},
  [1540] = {.lex_state = 63, .external_lex_state = 2},
  [1541] = {.lex_state = 63, .external_lex_state = 2},
  [1542] = {.lex_state = 141, .external_lex_state = 4},
  [1543] = {.lex_state = 80},
  [1544] = {.lex_state = 80},
  [1545] = {.lex_state = 277, .external_lex_state = 2},
  [1546] = {.lex_state = 272},
  [1547] = {.lex_state = 272, .external_lex_state = 13},
  [1548] = {.lex_state = 277, .external_lex_state = 2},
  [1549] = {.lex_state = 272},
  [1550] = {.lex_state = 141, .external_lex_state = 4},
  [1551] = {.lex_state = 275},
  [1552] = {.lex_state = 80},
  [1553] = {.lex_state = 141, .external_lex_state = 4},
  [1554] = {.lex_state = 80},
  [1555] = {.lex_state = 141, .external_lex_state = 4},
  [1556] = {.lex_state = 275},
  [1557] = {.lex_state = 141, .external_lex_state = 4},
  [1558] = {.lex_state = 80},
  [1559] = {.lex_state = 129, .external_lex_state = 10},
  [1560] = {.lex_state = 129, .external_lex_state = 10},
  [1561] = {.lex_state = 214, .external_lex_state = 22},
  [1562] = {.lex_state = 214, .external_lex_state = 22},
  [1563] = {.lex_state = 214, .external_lex_state = 16},
  [1564] = {.lex_state = 237, .external_lex_state = 16},
  [1565] = {.lex_state = 129, .external_lex_state = 10},
  [1566] = {.lex_state = 237, .external_lex_state = 16},
  [1567] = {.lex_state = 129, .external_lex_state = 10},
  [1568] = {.lex_state = 237, .external_lex_state = 16},
  [1569] = {.lex_state = 129, .external_lex_state = 10},
  [1570] = {.lex_state = 237, .external_lex_state = 16},
  [1571] = {.lex_state = 129, .external_lex_state = 10},
  [1572] = {.lex_state = 237, .external_lex_state = 16},
  [1573] = {.lex_state = 129, .external_lex_state = 10},
  [1574] = {.lex_state = 237, .external_lex_state = 16},
  [1575] = {.lex_state = 129, .external_lex_state = 10},
  [1576] = {.lex_state = 129, .external_lex_state = 10},
  [1577] = {.lex_state = 141, .external_lex_state = 4},
  [1578] = {.lex_state = 141, .external_lex_state = 10},
  [1579] = {.lex_state = 141, .external_lex_state = 10},
  [1580] = {.lex_state = 141, .external_lex_state = 4},
  [1581] = {.lex_state = 141, .external_lex_state = 10},
  [1582] = {.lex_state = 139, .external_lex_state = 19},
  [1583] = {.lex_state = 262, .external_lex_state = 21},
  [1584] = {.lex_state = 80},
  [1585] = {.lex_state = 279, .external_lex_state = 10},
  [1586] = {.lex_state = 279, .external_lex_state = 10},
  [1587] = {.lex_state = 80},
  [1588] = {.lex_state = 221, .external_lex_state = 23},
  [1589] = {.lex_state = 221, .external_lex_state = 23},
  [1590] = {.lex_state = 221, .external_lex_state = 23},
  [1591] = {.lex_state = 221, .external_lex_state = 23},
  [1592] = {.lex_state = 221, .external_lex_state = 21},
  [1593] = {.lex_state = 221, .external_lex_state = 5},
  [1594] = {.lex_state = 80, .external_lex_state = 2},
  [1595] = {.lex_state = 147, .external_lex_state = 11},
  [1596] = {.lex_state = 147, .external_lex_state = 11},
  [1597] = {.lex_state = 214, .external_lex_state = 22},
  [1598] = {.lex_state = 214, .external_lex_state = 22},
  [1599] = {.lex_state = 214, .external_lex_state = 16},
  [1600] = {.lex_state = 237, .external_lex_state = 16},
  [1601] = {.lex_state = 147, .external_lex_state = 11},
  [1602] = {.lex_state = 237, .external_lex_state = 16},
  [1603] = {.lex_state = 147, .external_lex_state = 11},
  [1604] = {.lex_state = 237, .external_lex_state = 16},
  [1605] = {.lex_state = 147, .external_lex_state = 11},
  [1606] = {.lex_state = 237, .external_lex_state = 16},
  [1607] = {.lex_state = 147, .external_lex_state = 11},
  [1608] = {.lex_state = 237, .external_lex_state = 16},
  [1609] = {.lex_state = 147, .external_lex_state = 11},
  [1610] = {.lex_state = 237, .external_lex_state = 16},
  [1611] = {.lex_state = 147, .external_lex_state = 11},
  [1612] = {.lex_state = 147, .external_lex_state = 11},
  [1613] = {.lex_state = 204, .external_lex_state = 23},
  [1614] = {.lex_state = 204, .external_lex_state = 23},
  [1615] = {.lex_state = 248, .external_lex_state = 21},
  [1616] = {.lex_state = 80},
  [1617] = {.lex_state = 204, .external_lex_state = 23},
  [1618] = {.lex_state = 248, .external_lex_state = 23},
  [1619] = {.lex_state = 164},
  [1620] = {.lex_state = 97},
  [1621] = {.lex_state = 248, .external_lex_state = 23},
  [1622] = {.lex_state = 248, .external_lex_state = 23},
  [1623] = {.lex_state = 248, .external_lex_state = 23},
  [1624] = {.lex_state = 69},
  [1625] = {.lex_state = 170, .external_lex_state = 6},
  [1626] = {.lex_state = 172, .external_lex_state = 16},
  [1627] = {.lex_state = 172, .external_lex_state = 16},
  [1628] = {.lex_state = 172, .external_lex_state = 16},
  [1629] = {.lex_state = 135, .external_lex_state = 4},
  [1630] = {.lex_state = 139, .external_lex_state = 8},
  [1631] = {.lex_state = 63, .external_lex_state = 2},
  [1632] = {.lex_state = 90, .external_lex_state = 4},
  [1633] = {.lex_state = 120, .external_lex_state = 8},
  [1634] = {.lex_state = 63, .external_lex_state = 2},
  [1635] = {.lex_state = 135, .external_lex_state = 4},
  [1636] = {.lex_state = 139, .external_lex_state = 8},
  [1637] = {.lex_state = 63, .external_lex_state = 2},
  [1638] = {.lex_state = 232, .external_lex_state = 13},
  [1639] = {.lex_state = 232, .external_lex_state = 13},
  [1640] = {.lex_state = 214, .external_lex_state = 22},
  [1641] = {.lex_state = 214, .external_lex_state = 22},
  [1642] = {.lex_state = 214, .external_lex_state = 16},
  [1643] = {.lex_state = 237, .external_lex_state = 16},
  [1644] = {.lex_state = 232, .external_lex_state = 13},
  [1645] = {.lex_state = 237, .external_lex_state = 16},
  [1646] = {.lex_state = 232, .external_lex_state = 13},
  [1647] = {.lex_state = 237, .external_lex_state = 16},
  [1648] = {.lex_state = 232, .external_lex_state = 13},
  [1649] = {.lex_state = 237, .external_lex_state = 16},
  [1650] = {.lex_state = 232, .external_lex_state = 13},
  [1651] = {.lex_state = 237, .external_lex_state = 16},
  [1652] = {.lex_state = 232, .external_lex_state = 13},
  [1653] = {.lex_state = 237, .external_lex_state = 16},
  [1654] = {.lex_state = 232, .external_lex_state = 13},
  [1655] = {.lex_state = 232, .external_lex_state = 13},
  [1656] = {.lex_state = 135, .external_lex_state = 3},
  [1657] = {.lex_state = 135, .external_lex_state = 14},
  [1658] = {.lex_state = 135, .external_lex_state = 14},
  [1659] = {.lex_state = 214, .external_lex_state = 22},
  [1660] = {.lex_state = 214, .external_lex_state = 22},
  [1661] = {.lex_state = 214, .external_lex_state = 16},
  [1662] = {.lex_state = 237, .external_lex_state = 16},
  [1663] = {.lex_state = 135, .external_lex_state = 14},
  [1664] = {.lex_state = 237, .external_lex_state = 16},
  [1665] = {.lex_state = 135, .external_lex_state = 14},
  [1666] = {.lex_state = 237, .external_lex_state = 16},
  [1667] = {.lex_state = 135, .external_lex_state = 14},
  [1668] = {.lex_state = 237, .external_lex_state = 16},
  [1669] = {.lex_state = 135, .external_lex_state = 14},
  [1670] = {.lex_state = 237, .external_lex_state = 16},
  [1671] = {.lex_state = 135, .external_lex_state = 14},
  [1672] = {.lex_state = 237, .external_lex_state = 16},
  [1673] = {.lex_state = 135, .external_lex_state = 14},
  [1674] = {.lex_state = 135, .external_lex_state = 14},
  [1675] = {.lex_state = 135, .external_lex_state = 10},
  [1676] = {.lex_state = 135, .external_lex_state = 10},
  [1677] = {.lex_state = 214, .external_lex_state = 22},
  [1678] = {.lex_state = 214, .external_lex_state = 22},
  [1679] = {.lex_state = 214, .external_lex_state = 16},
  [1680] = {.lex_state = 237, .external_lex_state = 16},
  [1681] = {.lex_state = 135, .external_lex_state = 10},
  [1682] = {.lex_state = 237, .external_lex_state = 16},
  [1683] = {.lex_state = 135, .external_lex_state = 10},
  [1684] = {.lex_state = 237, .external_lex_state = 16},
  [1685] = {.lex_state = 135, .external_lex_state = 10},
  [1686] = {.lex_state = 237, .external_lex_state = 16},
  [1687] = {.lex_state = 135, .external_lex_state = 10},
  [1688] = {.lex_state = 237, .external_lex_state = 16},
  [1689] = {.lex_state = 135, .external_lex_state = 10},
  [1690] = {.lex_state = 237, .external_lex_state = 16},
  [1691] = {.lex_state = 135, .external_lex_state = 10},
  [1692] = {.lex_state = 135, .external_lex_state = 10},
  [1693] = {.lex_state = 80, .external_lex_state = 15},
  [1694] = {.lex_state = 80, .external_lex_state = 15},
  [1695] = {.lex_state = 214, .external_lex_state = 22},
  [1696] = {.lex_state = 214, .external_lex_state = 22},
  [1697] = {.lex_state = 214, .external_lex_state = 16},
  [1698] = {.lex_state = 237, .external_lex_state = 16},
  [1699] = {.lex_state = 80, .external_lex_state = 15},
  [1700] = {.lex_state = 237, .external_lex_state = 16},
  [1701] = {.lex_state = 80, .external_lex_state = 15},
  [1702] = {.lex_state = 237, .external_lex_state = 16},
  [1703] = {.lex_state = 80, .external_lex_state = 15},
  [1704] = {.lex_state = 237, .external_lex_state = 16},
  [1705] = {.lex_state = 80, .external_lex_state = 15},
  [1706] = {.lex_state = 237, .external_lex_state = 16},
  [1707] = {.lex_state = 80, .external_lex_state = 15},
  [1708] = {.lex_state = 237, .external_lex_state = 16},
  [1709] = {.lex_state = 80, .external_lex_state = 15},
  [1710] = {.lex_state = 80, .external_lex_state = 15},
  [1711] = {.lex_state = 97, .external_lex_state = 13},
  [1712] = {.lex_state = 97, .external_lex_state = 13},
  [1713] = {.lex_state = 214, .external_lex_state = 22},
  [1714] = {.lex_state = 214, .external_lex_state = 22},
  [1715] = {.lex_state = 214, .external_lex_state = 16},
  [1716] = {.lex_state = 237, .external_lex_state = 16},
  [1717] = {.lex_state = 97, .external_lex_state = 13},
  [1718] = {.lex_state = 237, .external_lex_state = 16},
  [1719] = {.lex_state = 97, .external_lex_state = 13},
  [1720] = {.lex_state = 237, .external_lex_state = 16},
  [1721] = {.lex_state = 97, .external_lex_state = 13},
  [1722] = {.lex_state = 237, .external_lex_state = 16},
  [1723] = {.lex_state = 97, .external_lex_state = 13},
  [1724] = {.lex_state = 237, .external_lex_state = 16},
  [1725] = {.lex_state = 97, .external_lex_state = 13},
  [1726] = {.lex_state = 237, .external_lex_state = 16},
  [1727] = {.lex_state = 97, .external_lex_state = 13},
  [1728] = {.lex_state = 172, .external_lex_state = 22},
  [1729] = {.lex_state = 172, .external_lex_state = 16},
  [1730] = {.lex_state = 172, .external_lex_state = 22},
  [1731] = {.lex_state = 172, .external_lex_state = 16},
  [1732] = {.lex_state = 214, .external_lex_state = 22},
  [1733] = {.lex_state = 214, .external_lex_state = 22},
  [1734] = {.lex_state = 214, .external_lex_state = 22},
  [1735] = {.lex_state = 164},
  [1736] = {.lex_state = 235, .external_lex_state = 16},
  [1737] = {.lex_state = 69},
  [1738] = {.lex_state = 172, .external_lex_state = 16},
  [1739] = {.lex_state = 172, .external_lex_state = 16},
  [1740] = {.lex_state = 172, .external_lex_state = 16},
  [1741] = {.lex_state = 214, .external_lex_state = 22},
  [1742] = {.lex_state = 239},
  [1743] = {.lex_state = 237, .external_lex_state = 16},
  [1744] = {.lex_state = 214, .external_lex_state = 22},
  [1745] = {.lex_state = 239},
  [1746] = {.lex_state = 237, .external_lex_state = 16},
  [1747] = {.lex_state = 214, .external_lex_state = 22},
  [1748] = {.lex_state = 239},
  [1749] = {.lex_state = 237, .external_lex_state = 16},
  [1750] = {.lex_state = 214, .external_lex_state = 22},
  [1751] = {.lex_state = 219, .external_lex_state = 2},
  [1752] = {.lex_state = 135, .external_lex_state = 4},
  [1753] = {.lex_state = 139, .external_lex_state = 8},
  [1754] = {.lex_state = 63, .external_lex_state = 2},
  [1755] = {.lex_state = 90, .external_lex_state = 4},
  [1756] = {.lex_state = 120, .external_lex_state = 8},
  [1757] = {.lex_state = 214, .external_lex_state = 22},
  [1758] = {.lex_state = 219, .external_lex_state = 2},
  [1759] = {.lex_state = 135, .external_lex_state = 4},
  [1760] = {.lex_state = 139, .external_lex_state = 8},
  [1761] = {.lex_state = 122, .external_lex_state = 5},
  [1762] = {.lex_state = 122, .external_lex_state = 5},
  [1763] = {.lex_state = 122, .external_lex_state = 5},
  [1764] = {.lex_state = 237, .external_lex_state = 16},
  [1765] = {.lex_state = 122, .external_lex_state = 5},
  [1766] = {.lex_state = 237, .external_lex_state = 16},
  [1767] = {.lex_state = 122, .external_lex_state = 5},
  [1768] = {.lex_state = 237, .external_lex_state = 16},
  [1769] = {.lex_state = 237, .external_lex_state = 22},
  [1770] = {.lex_state = 237, .external_lex_state = 22},
  [1771] = {.lex_state = 214, .external_lex_state = 22},
  [1772] = {.lex_state = 214, .external_lex_state = 22},
  [1773] = {.lex_state = 214, .external_lex_state = 16},
  [1774] = {.lex_state = 235, .external_lex_state = 16},
  [1775] = {.lex_state = 237, .external_lex_state = 22},
  [1776] = {.lex_state = 239},
  [1777] = {.lex_state = 237, .external_lex_state = 16},
  [1778] = {.lex_state = 237, .external_lex_state = 22},
  [1779] = {.lex_state = 239},
  [1780] = {.lex_state = 237, .external_lex_state = 16},
  [1781] = {.lex_state = 239},
  [1782] = {.lex_state = 237, .external_lex_state = 16},
  [1783] = {.lex_state = 237, .external_lex_state = 16},
  [1784] = {.lex_state = 237, .external_lex_state = 22},
  [1785] = {.lex_state = 237, .external_lex_state = 16},
  [1786] = {.lex_state = 237, .external_lex_state = 22},
  [1787] = {.lex_state = 237, .external_lex_state = 16},
  [1788] = {.lex_state = 122, .external_lex_state = 5},
  [1789] = {.lex_state = 237, .external_lex_state = 22},
  [1790] = {.lex_state = 219, .external_lex_state = 2},
  [1791] = {.lex_state = 63, .external_lex_state = 2},
  [1792] = {.lex_state = 237, .external_lex_state = 22},
  [1793] = {.lex_state = 219, .external_lex_state = 2},
  [1794] = {.lex_state = 122, .external_lex_state = 5},
  [1795] = {.lex_state = 122, .external_lex_state = 5},
  [1796] = {.lex_state = 266, .external_lex_state = 21},
  [1797] = {.lex_state = 80},
  [1798] = {.lex_state = 141, .external_lex_state = 10},
  [1799] = {.lex_state = 141, .external_lex_state = 10},
  [1800] = {.lex_state = 80},
  [1801] = {.lex_state = 246, .external_lex_state = 23},
  [1802] = {.lex_state = 246, .external_lex_state = 23},
  [1803] = {.lex_state = 246, .external_lex_state = 23},
  [1804] = {.lex_state = 246, .external_lex_state = 23},
  [1805] = {.lex_state = 246, .external_lex_state = 21},
  [1806] = {.lex_state = 246, .external_lex_state = 5},
  [1807] = {.lex_state = 178, .external_lex_state = 17},
  [1808] = {.lex_state = 214, .external_lex_state = 22},
  [1809] = {.lex_state = 214, .external_lex_state = 22},
  [1810] = {.lex_state = 214, .external_lex_state = 16},
  [1811] = {.lex_state = 235, .external_lex_state = 16},
  [1812] = {.lex_state = 178, .external_lex_state = 17},
  [1813] = {.lex_state = 239},
  [1814] = {.lex_state = 237, .external_lex_state = 16},
  [1815] = {.lex_state = 178, .external_lex_state = 17},
  [1816] = {.lex_state = 239},
  [1817] = {.lex_state = 237, .external_lex_state = 16},
  [1818] = {.lex_state = 239},
  [1819] = {.lex_state = 237, .external_lex_state = 16},
  [1820] = {.lex_state = 237, .external_lex_state = 16},
  [1821] = {.lex_state = 178, .external_lex_state = 17},
  [1822] = {.lex_state = 237, .external_lex_state = 16},
  [1823] = {.lex_state = 178, .external_lex_state = 17},
  [1824] = {.lex_state = 237, .external_lex_state = 16},
  [1825] = {.lex_state = 210, .external_lex_state = 13},
  [1826] = {.lex_state = 210, .external_lex_state = 13},
  [1827] = {.lex_state = 214, .external_lex_state = 22},
  [1828] = {.lex_state = 214, .external_lex_state = 22},
  [1829] = {.lex_state = 214, .external_lex_state = 16},
  [1830] = {.lex_state = 235, .external_lex_state = 16},
  [1831] = {.lex_state = 210, .external_lex_state = 13},
  [1832] = {.lex_state = 239},
  [1833] = {.lex_state = 237, .external_lex_state = 16},
  [1834] = {.lex_state = 210, .external_lex_state = 13},
  [1835] = {.lex_state = 239},
  [1836] = {.lex_state = 237, .external_lex_state = 16},
  [1837] = {.lex_state = 239},
  [1838] = {.lex_state = 237, .external_lex_state = 16},
  [1839] = {.lex_state = 237, .external_lex_state = 16},
  [1840] = {.lex_state = 210, .external_lex_state = 13},
  [1841] = {.lex_state = 237, .external_lex_state = 16},
  [1842] = {.lex_state = 210, .external_lex_state = 13},
  [1843] = {.lex_state = 237, .external_lex_state = 16},
  [1844] = {.lex_state = 210, .external_lex_state = 13},
  [1845] = {.lex_state = 219, .external_lex_state = 2},
  [1846] = {.lex_state = 63, .external_lex_state = 2},
  [1847] = {.lex_state = 210, .external_lex_state = 13},
  [1848] = {.lex_state = 219, .external_lex_state = 2},
  [1849] = {.lex_state = 139, .external_lex_state = 19},
  [1850] = {.lex_state = 139, .external_lex_state = 19},
  [1851] = {.lex_state = 214, .external_lex_state = 22},
  [1852] = {.lex_state = 214, .external_lex_state = 22},
  [1853] = {.lex_state = 214, .external_lex_state = 16},
  [1854] = {.lex_state = 237, .external_lex_state = 16},
  [1855] = {.lex_state = 139, .external_lex_state = 19},
  [1856] = {.lex_state = 237, .external_lex_state = 16},
  [1857] = {.lex_state = 139, .external_lex_state = 19},
  [1858] = {.lex_state = 237, .external_lex_state = 16},
  [1859] = {.lex_state = 139, .external_lex_state = 19},
  [1860] = {.lex_state = 237, .external_lex_state = 16},
  [1861] = {.lex_state = 139, .external_lex_state = 19},
  [1862] = {.lex_state = 237, .external_lex_state = 16},
  [1863] = {.lex_state = 139, .external_lex_state = 19},
  [1864] = {.lex_state = 237, .external_lex_state = 16},
  [1865] = {.lex_state = 139, .external_lex_state = 19},
  [1866] = {.lex_state = 139, .external_lex_state = 19},
  [1867] = {.lex_state = 141, .external_lex_state = 4},
  [1868] = {.lex_state = 214, .external_lex_state = 20},
  [1869] = {.lex_state = 270},
  [1870] = {.lex_state = 270, .external_lex_state = 13},
  [1871] = {.lex_state = 270, .external_lex_state = 13},
  [1872] = {.lex_state = 270, .external_lex_state = 13},
  [1873] = {.lex_state = 164},
  [1874] = {.lex_state = 235, .external_lex_state = 16},
  [1875] = {.lex_state = 69},
  [1876] = {.lex_state = 172, .external_lex_state = 16},
  [1877] = {.lex_state = 172, .external_lex_state = 16},
  [1878] = {.lex_state = 172, .external_lex_state = 16},
  [1879] = {.lex_state = 270, .external_lex_state = 13},
  [1880] = {.lex_state = 239},
  [1881] = {.lex_state = 237, .external_lex_state = 16},
  [1882] = {.lex_state = 270, .external_lex_state = 13},
  [1883] = {.lex_state = 239},
  [1884] = {.lex_state = 237, .external_lex_state = 16},
  [1885] = {.lex_state = 270, .external_lex_state = 13},
  [1886] = {.lex_state = 239},
  [1887] = {.lex_state = 237, .external_lex_state = 16},
  [1888] = {.lex_state = 270, .external_lex_state = 13},
  [1889] = {.lex_state = 219, .external_lex_state = 2},
  [1890] = {.lex_state = 135, .external_lex_state = 4},
  [1891] = {.lex_state = 139, .external_lex_state = 8},
  [1892] = {.lex_state = 63, .external_lex_state = 2},
  [1893] = {.lex_state = 90, .external_lex_state = 4},
  [1894] = {.lex_state = 120, .external_lex_state = 8},
  [1895] = {.lex_state = 270, .external_lex_state = 13},
  [1896] = {.lex_state = 219, .external_lex_state = 2},
  [1897] = {.lex_state = 135, .external_lex_state = 4},
  [1898] = {.lex_state = 139, .external_lex_state = 8},
  [1899] = {.lex_state = 141, .external_lex_state = 4},
  [1900] = {.lex_state = 270},
  [1901] = {.lex_state = 270},
  [1902] = {.lex_state = 268},
  [1903] = {.lex_state = 254, .external_lex_state = 10},
  [1904] = {.lex_state = 254, .external_lex_state = 10},
  [1905] = {.lex_state = 214, .external_lex_state = 22},
  [1906] = {.lex_state = 214, .external_lex_state = 22},
  [1907] = {.lex_state = 214, .external_lex_state = 16},
  [1908] = {.lex_state = 237, .external_lex_state = 16},
  [1909] = {.lex_state = 254, .external_lex_state = 10},
  [1910] = {.lex_state = 237, .external_lex_state = 16},
  [1911] = {.lex_state = 254, .external_lex_state = 10},
  [1912] = {.lex_state = 237, .external_lex_state = 16},
  [1913] = {.lex_state = 254, .external_lex_state = 10},
  [1914] = {.lex_state = 237, .external_lex_state = 16},
  [1915] = {.lex_state = 254, .external_lex_state = 10},
  [1916] = {.lex_state = 237, .external_lex_state = 16},
  [1917] = {.lex_state = 254, .external_lex_state = 10},
  [1918] = {.lex_state = 237, .external_lex_state = 16},
  [1919] = {.lex_state = 254, .external_lex_state = 10},
  [1920] = {.lex_state = 254, .external_lex_state = 10},
  [1921] = {.lex_state = 270},
  [1922] = {.lex_state = 256, .external_lex_state = 10},
  [1923] = {.lex_state = 256, .external_lex_state = 10},
  [1924] = {.lex_state = 214, .external_lex_state = 22},
  [1925] = {.lex_state = 214, .external_lex_state = 22},
  [1926] = {.lex_state = 214, .external_lex_state = 16},
  [1927] = {.lex_state = 235, .external_lex_state = 16},
  [1928] = {.lex_state = 256, .external_lex_state = 10},
  [1929] = {.lex_state = 239},
  [1930] = {.lex_state = 237, .external_lex_state = 16},
  [1931] = {.lex_state = 256, .external_lex_state = 10},
  [1932] = {.lex_state = 239},
  [1933] = {.lex_state = 237, .external_lex_state = 16},
  [1934] = {.lex_state = 239},
  [1935] = {.lex_state = 237, .external_lex_state = 16},
  [1936] = {.lex_state = 237, .external_lex_state = 16},
  [1937] = {.lex_state = 256, .external_lex_state = 10},
  [1938] = {.lex_state = 237, .external_lex_state = 16},
  [1939] = {.lex_state = 256, .external_lex_state = 10},
  [1940] = {.lex_state = 237, .external_lex_state = 16},
  [1941] = {.lex_state = 256, .external_lex_state = 10},
  [1942] = {.lex_state = 219, .external_lex_state = 2},
  [1943] = {.lex_state = 63, .external_lex_state = 2},
  [1944] = {.lex_state = 256, .external_lex_state = 10},
  [1945] = {.lex_state = 219, .external_lex_state = 2},
  [1946] = {.lex_state = 63, .external_lex_state = 2},
  [1947] = {.lex_state = 141, .external_lex_state = 4},
  [1948] = {.lex_state = 272, .external_lex_state = 13},
  [1949] = {.lex_state = 272, .external_lex_state = 13},
  [1950] = {.lex_state = 272},
  [1951] = {.lex_state = 69},
  [1952] = {.lex_state = 63, .external_lex_state = 2},
  [1953] = {.lex_state = 258},
  [1954] = {.lex_state = 80},
  [1955] = {.lex_state = 82, .external_lex_state = 2},
  [1956] = {.lex_state = 84},
  [1957] = {.lex_state = 84},
  [1958] = {.lex_state = 281, .external_lex_state = 3},
  [1959] = {.lex_state = 281, .external_lex_state = 4},
  [1960] = {.lex_state = 287, .external_lex_state = 5},
  [1961] = {.lex_state = 97},
  [1962] = {.lex_state = 104},
  [1963] = {.lex_state = 287, .external_lex_state = 5},
  [1964] = {.lex_state = 113, .external_lex_state = 6},
  [1965] = {.lex_state = 63, .external_lex_state = 2},
  [1966] = {.lex_state = 63, .external_lex_state = 2},
  [1967] = {.lex_state = 63, .external_lex_state = 2},
  [1968] = {.lex_state = 289, .external_lex_state = 5},
  [1969] = {.lex_state = 275, .external_lex_state = 4},
  [1970] = {.lex_state = 287, .external_lex_state = 7},
  [1971] = {.lex_state = 291, .external_lex_state = 8},
  [1972] = {.lex_state = 69},
  [1973] = {.lex_state = 287, .external_lex_state = 7},
  [1974] = {.lex_state = 277, .external_lex_state = 2},
  [1975] = {.lex_state = 80, .external_lex_state = 2},
  [1976] = {.lex_state = 277, .external_lex_state = 2},
  [1977] = {.lex_state = 272},
  [1978] = {.lex_state = 272, .external_lex_state = 13},
  [1979] = {.lex_state = 258},
  [1980] = {.lex_state = 275, .external_lex_state = 4},
  [1981] = {.lex_state = 291, .external_lex_state = 8},
  [1982] = {.lex_state = 277, .external_lex_state = 2},
  [1983] = {.lex_state = 277, .external_lex_state = 2},
  [1984] = {.lex_state = 141, .external_lex_state = 4},
  [1985] = {.lex_state = 272, .external_lex_state = 13},
  [1986] = {.lex_state = 272, .external_lex_state = 13},
  [1987] = {.lex_state = 272},
  [1988] = {.lex_state = 275},
  [1989] = {.lex_state = 141, .external_lex_state = 4},
  [1990] = {.lex_state = 275},
  [1991] = {.lex_state = 129, .external_lex_state = 10},
  [1992] = {.lex_state = 129, .external_lex_state = 10},
  [1993] = {.lex_state = 129, .external_lex_state = 10},
  [1994] = {.lex_state = 237, .external_lex_state = 16},
  [1995] = {.lex_state = 129, .external_lex_state = 10},
  [1996] = {.lex_state = 237, .external_lex_state = 16},
  [1997] = {.lex_state = 129, .external_lex_state = 10},
  [1998] = {.lex_state = 237, .external_lex_state = 16},
  [1999] = {.lex_state = 129, .external_lex_state = 10},
  [2000] = {.lex_state = 129, .external_lex_state = 10},
  [2001] = {.lex_state = 129, .external_lex_state = 10},
  [2002] = {.lex_state = 141, .external_lex_state = 10},
  [2003] = {.lex_state = 279, .external_lex_state = 10},
  [2004] = {.lex_state = 279, .external_lex_state = 10},
  [2005] = {.lex_state = 279, .external_lex_state = 10},
  [2006] = {.lex_state = 221, .external_lex_state = 23},
  [2007] = {.lex_state = 221, .external_lex_state = 23},
  [2008] = {.lex_state = 221, .external_lex_state = 23},
  [2009] = {.lex_state = 147, .external_lex_state = 11},
  [2010] = {.lex_state = 147, .external_lex_state = 11},
  [2011] = {.lex_state = 147, .external_lex_state = 11},
  [2012] = {.lex_state = 237, .external_lex_state = 16},
  [2013] = {.lex_state = 147, .external_lex_state = 11},
  [2014] = {.lex_state = 237, .external_lex_state = 16},
  [2015] = {.lex_state = 147, .external_lex_state = 11},
  [2016] = {.lex_state = 237, .external_lex_state = 16},
  [2017] = {.lex_state = 147, .external_lex_state = 11},
  [2018] = {.lex_state = 147, .external_lex_state = 11},
  [2019] = {.lex_state = 147, .external_lex_state = 11},
  [2020] = {.lex_state = 248, .external_lex_state = 23},
  [2021] = {.lex_state = 204, .external_lex_state = 23},
  [2022] = {.lex_state = 248, .external_lex_state = 23},
  [2023] = {.lex_state = 164},
  [2024] = {.lex_state = 235, .external_lex_state = 16},
  [2025] = {.lex_state = 69},
  [2026] = {.lex_state = 172, .external_lex_state = 16},
  [2027] = {.lex_state = 172, .external_lex_state = 16},
  [2028] = {.lex_state = 172, .external_lex_state = 16},
  [2029] = {.lex_state = 248, .external_lex_state = 23},
  [2030] = {.lex_state = 239},
  [2031] = {.lex_state = 237, .external_lex_state = 16},
  [2032] = {.lex_state = 248, .external_lex_state = 23},
  [2033] = {.lex_state = 239},
  [2034] = {.lex_state = 237, .external_lex_state = 16},
  [2035] = {.lex_state = 248, .external_lex_state = 23},
  [2036] = {.lex_state = 239},
  [2037] = {.lex_state = 237, .external_lex_state = 16},
  [2038] = {.lex_state = 248, .external_lex_state = 23},
  [2039] = {.lex_state = 219, .external_lex_state = 2},
  [2040] = {.lex_state = 135, .external_lex_state = 4},
  [2041] = {.lex_state = 139, .external_lex_state = 8},
  [2042] = {.lex_state = 63, .external_lex_state = 2},
  [2043] = {.lex_state = 90, .external_lex_state = 4},
  [2044] = {.lex_state = 120, .external_lex_state = 8},
  [2045] = {.lex_state = 248, .external_lex_state = 23},
  [2046] = {.lex_state = 219, .external_lex_state = 2},
  [2047] = {.lex_state = 135, .external_lex_state = 4},
  [2048] = {.lex_state = 139, .external_lex_state = 8},
  [2049] = {.lex_state = 232, .external_lex_state = 13},
  [2050] = {.lex_state = 232, .external_lex_state = 13},
  [2051] = {.lex_state = 232, .external_lex_state = 13},
  [2052] = {.lex_state = 237, .external_lex_state = 16},
  [2053] = {.lex_state = 232, .external_lex_state = 13},
  [2054] = {.lex_state = 237, .external_lex_state = 16},
  [2055] = {.lex_state = 232, .external_lex_state = 13},
  [2056] = {.lex_state = 237, .external_lex_state = 16},
  [2057] = {.lex_state = 232, .external_lex_state = 13},
  [2058] = {.lex_state = 232, .external_lex_state = 13},
  [2059] = {.lex_state = 232, .external_lex_state = 13},
  [2060] = {.lex_state = 135, .external_lex_state = 14},
  [2061] = {.lex_state = 135, .external_lex_state = 14},
  [2062] = {.lex_state = 135, .external_lex_state = 14},
  [2063] = {.lex_state = 237, .external_lex_state = 16},
  [2064] = {.lex_state = 135, .external_lex_state = 14},
  [2065] = {.lex_state = 237, .external_lex_state = 16},
  [2066] = {.lex_state = 135, .external_lex_state = 14},
  [2067] = {.lex_state = 237, .external_lex_state = 16},
  [2068] = {.lex_state = 135, .external_lex_state = 14},
  [2069] = {.lex_state = 135, .external_lex_state = 14},
  [2070] = {.lex_state = 135, .external_lex_state = 14},
  [2071] = {.lex_state = 135, .external_lex_state = 10},
  [2072] = {.lex_state = 135, .external_lex_state = 10},
  [2073] = {.lex_state = 135, .external_lex_state = 10},
  [2074] = {.lex_state = 237, .external_lex_state = 16},
  [2075] = {.lex_state = 135, .external_lex_state = 10},
  [2076] = {.lex_state = 237, .external_lex_state = 16},
  [2077] = {.lex_state = 135, .external_lex_state = 10},
  [2078] = {.lex_state = 237, .external_lex_state = 16},
  [2079] = {.lex_state = 135, .external_lex_state = 10},
  [2080] = {.lex_state = 135, .external_lex_state = 10},
  [2081] = {.lex_state = 135, .external_lex_state = 10},
  [2082] = {.lex_state = 80, .external_lex_state = 15},
  [2083] = {.lex_state = 80, .external_lex_state = 15},
  [2084] = {.lex_state = 80, .external_lex_state = 15},
  [2085] = {.lex_state = 237, .external_lex_state = 16},
  [2086] = {.lex_state = 80, .external_lex_state = 15},
  [2087] = {.lex_state = 237, .external_lex_state = 16},
  [2088] = {.lex_state = 80, .external_lex_state = 15},
  [2089] = {.lex_state = 237, .external_lex_state = 16},
  [2090] = {.lex_state = 80, .external_lex_state = 15},
  [2091] = {.lex_state = 80, .external_lex_state = 15},
  [2092] = {.lex_state = 80, .external_lex_state = 15},
  [2093] = {.lex_state = 97, .external_lex_state = 13},
  [2094] = {.lex_state = 97, .external_lex_state = 13},
  [2095] = {.lex_state = 97, .external_lex_state = 13},
  [2096] = {.lex_state = 237, .external_lex_state = 16},
  [2097] = {.lex_state = 97, .external_lex_state = 13},
  [2098] = {.lex_state = 237, .external_lex_state = 16},
  [2099] = {.lex_state = 97, .external_lex_state = 13},
  [2100] = {.lex_state = 237, .external_lex_state = 16},
  [2101] = {.lex_state = 97, .external_lex_state = 13},
  [2102] = {.lex_state = 97, .external_lex_state = 13},
  [2103] = {.lex_state = 97, .external_lex_state = 13},
  [2104] = {.lex_state = 172, .external_lex_state = 16},
  [2105] = {.lex_state = 172, .external_lex_state = 16},
  [2106] = {.lex_state = 214, .external_lex_state = 22},
  [2107] = {.lex_state = 214, .external_lex_state = 22},
  [2108] = {.lex_state = 214, .external_lex_state = 22},
  [2109] = {.lex_state = 214, .external_lex_state = 22},
  [2110] = {.lex_state = 214, .external_lex_state = 16},
  [2111] = {.lex_state = 235, .external_lex_state = 16},
  [2112] = {.lex_state = 214, .external_lex_state = 22},
  [2113] = {.lex_state = 239},
  [2114] = {.lex_state = 237, .external_lex_state = 16},
  [2115] = {.lex_state = 214, .external_lex_state = 22},
  [2116] = {.lex_state = 239},
  [2117] = {.lex_state = 237, .external_lex_state = 16},
  [2118] = {.lex_state = 239},
  [2119] = {.lex_state = 237, .external_lex_state = 16},
  [2120] = {.lex_state = 237, .external_lex_state = 16},
  [2121] = {.lex_state = 214, .external_lex_state = 22},
  [2122] = {.lex_state = 237, .external_lex_state = 16},
  [2123] = {.lex_state = 214, .external_lex_state = 22},
  [2124] = {.lex_state = 237, .external_lex_state = 16},
  [2125] = {.lex_state = 214, .external_lex_state = 22},
  [2126] = {.lex_state = 219, .external_lex_state = 2},
  [2127] = {.lex_state = 63, .external_lex_state = 2},
  [2128] = {.lex_state = 214, .external_lex_state = 22},
  [2129] = {.lex_state = 219, .external_lex_state = 2},
  [2130] = {.lex_state = 122, .external_lex_state = 5},
  [2131] = {.lex_state = 122, .external_lex_state = 5},
  [2132] = {.lex_state = 122, .external_lex_state = 5},
  [2133] = {.lex_state = 237, .external_lex_state = 22},
  [2134] = {.lex_state = 237, .external_lex_state = 22},
  [2135] = {.lex_state = 214, .external_lex_state = 22},
  [2136] = {.lex_state = 214, .external_lex_state = 22},
  [2137] = {.lex_state = 214, .external_lex_state = 16},
  [2138] = {.lex_state = 237, .external_lex_state = 16},
  [2139] = {.lex_state = 237, .external_lex_state = 22},
  [2140] = {.lex_state = 237, .external_lex_state = 16},
  [2141] = {.lex_state = 237, .external_lex_state = 22},
  [2142] = {.lex_state = 237, .external_lex_state = 16},
  [2143] = {.lex_state = 237, .external_lex_state = 22},
  [2144] = {.lex_state = 237, .external_lex_state = 16},
  [2145] = {.lex_state = 237, .external_lex_state = 22},
  [2146] = {.lex_state = 237, .external_lex_state = 16},
  [2147] = {.lex_state = 237, .external_lex_state = 22},
  [2148] = {.lex_state = 237, .external_lex_state = 16},
  [2149] = {.lex_state = 237, .external_lex_state = 22},
  [2150] = {.lex_state = 237, .external_lex_state = 22},
  [2151] = {.lex_state = 141, .external_lex_state = 10},
  [2152] = {.lex_state = 141, .external_lex_state = 10},
  [2153] = {.lex_state = 141, .external_lex_state = 10},
  [2154] = {.lex_state = 246, .external_lex_state = 23},
  [2155] = {.lex_state = 246, .external_lex_state = 23},
  [2156] = {.lex_state = 246, .external_lex_state = 23},
  [2157] = {.lex_state = 178, .external_lex_state = 17},
  [2158] = {.lex_state = 178, .external_lex_state = 17},
  [2159] = {.lex_state = 214, .external_lex_state = 22},
  [2160] = {.lex_state = 214, .external_lex_state = 22},
  [2161] = {.lex_state = 214, .external_lex_state = 16},
  [2162] = {.lex_state = 237, .external_lex_state = 16},
  [2163] = {.lex_state = 178, .external_lex_state = 17},
  [2164] = {.lex_state = 237, .external_lex_state = 16},
  [2165] = {.lex_state = 178, .external_lex_state = 17},
  [2166] = {.lex_state = 237, .external_lex_state = 16},
  [2167] = {.lex_state = 178, .external_lex_state = 17},
  [2168] = {.lex_state = 237, .external_lex_state = 16},
  [2169] = {.lex_state = 178, .external_lex_state = 17},
  [2170] = {.lex_state = 237, .external_lex_state = 16},
  [2171] = {.lex_state = 178, .external_lex_state = 17},
  [2172] = {.lex_state = 237, .external_lex_state = 16},
  [2173] = {.lex_state = 210, .external_lex_state = 13},
  [2174] = {.lex_state = 210, .external_lex_state = 13},
  [2175] = {.lex_state = 214, .external_lex_state = 22},
  [2176] = {.lex_state = 214, .external_lex_state = 22},
  [2177] = {.lex_state = 214, .external_lex_state = 16},
  [2178] = {.lex_state = 237, .external_lex_state = 16},
  [2179] = {.lex_state = 210, .external_lex_state = 13},
  [2180] = {.lex_state = 237, .external_lex_state = 16},
  [2181] = {.lex_state = 210, .external_lex_state = 13},
  [2182] = {.lex_state = 237, .external_lex_state = 16},
  [2183] = {.lex_state = 210, .external_lex_state = 13},
  [2184] = {.lex_state = 237, .external_lex_state = 16},
  [2185] = {.lex_state = 210, .external_lex_state = 13},
  [2186] = {.lex_state = 237, .external_lex_state = 16},
  [2187] = {.lex_state = 210, .external_lex_state = 13},
  [2188] = {.lex_state = 237, .external_lex_state = 16},
  [2189] = {.lex_state = 210, .external_lex_state = 13},
  [2190] = {.lex_state = 210, .external_lex_state = 13},
  [2191] = {.lex_state = 139, .external_lex_state = 19},
  [2192] = {.lex_state = 139, .external_lex_state = 19},
  [2193] = {.lex_state = 139, .external_lex_state = 19},
  [2194] = {.lex_state = 237, .external_lex_state = 16},
  [2195] = {.lex_state = 139, .external_lex_state = 19},
  [2196] = {.lex_state = 237, .external_lex_state = 16},
  [2197] = {.lex_state = 139, .external_lex_state = 19},
  [2198] = {.lex_state = 237, .external_lex_state = 16},
  [2199] = {.lex_state = 139, .external_lex_state = 19},
  [2200] = {.lex_state = 139, .external_lex_state = 19},
  [2201] = {.lex_state = 139, .external_lex_state = 19},
  [2202] = {.lex_state = 141, .external_lex_state = 4},
  [2203] = {.lex_state = 270, .external_lex_state = 13},
  [2204] = {.lex_state = 270, .external_lex_state = 13},
  [2205] = {.lex_state = 214, .external_lex_state = 22},
  [2206] = {.lex_state = 214, .external_lex_state = 22},
  [2207] = {.lex_state = 214, .external_lex_state = 16},
  [2208] = {.lex_state = 235, .external_lex_state = 16},
  [2209] = {.lex_state = 270, .external_lex_state = 13},
  [2210] = {.lex_state = 239},
  [2211] = {.lex_state = 237, .external_lex_state = 16},
  [2212] = {.lex_state = 270, .external_lex_state = 13},
  [2213] = {.lex_state = 239},
  [2214] = {.lex_state = 237, .external_lex_state = 16},
  [2215] = {.lex_state = 239},
  [2216] = {.lex_state = 237, .external_lex_state = 16},
  [2217] = {.lex_state = 237, .external_lex_state = 16},
  [2218] = {.lex_state = 270, .external_lex_state = 13},
  [2219] = {.lex_state = 237, .external_lex_state = 16},
  [2220] = {.lex_state = 270, .external_lex_state = 13},
  [2221] = {.lex_state = 237, .external_lex_state = 16},
  [2222] = {.lex_state = 270, .external_lex_state = 13},
  [2223] = {.lex_state = 219, .external_lex_state = 2},
  [2224] = {.lex_state = 63, .external_lex_state = 2},
  [2225] = {.lex_state = 270, .external_lex_state = 13},
  [2226] = {.lex_state = 219, .external_lex_state = 2},
  [2227] = {.lex_state = 141, .external_lex_state = 4},
  [2228] = {.lex_state = 254, .external_lex_state = 10},
  [2229] = {.lex_state = 254, .external_lex_state = 10},
  [2230] = {.lex_state = 254, .external_lex_state = 10},
  [2231] = {.lex_state = 237, .external_lex_state = 16},
  [2232] = {.lex_state = 254, .external_lex_state = 10},
  [2233] = {.lex_state = 237, .external_lex_state = 16},
  [2234] = {.lex_state = 254, .external_lex_state = 10},
  [2235] = {.lex_state = 237, .external_lex_state = 16},
  [2236] = {.lex_state = 254, .external_lex_state = 10},
  [2237] = {.lex_state = 254, .external_lex_state = 10},
  [2238] = {.lex_state = 254, .external_lex_state = 10},
  [2239] = {.lex_state = 268},
  [2240] = {.lex_state = 256, .external_lex_state = 10},
  [2241] = {.lex_state = 256, .external_lex_state = 10},
  [2242] = {.lex_state = 214, .external_lex_state = 22},
  [2243] = {.lex_state = 214, .external_lex_state = 22},
  [2244] = {.lex_state = 214, .external_lex_state = 16},
  [2245] = {.lex_state = 237, .external_lex_state = 16},
  [2246] = {.lex_state = 256, .external_lex_state = 10},
  [2247] = {.lex_state = 237, .external_lex_state = 16},
  [2248] = {.lex_state = 256, .external_lex_state = 10},
  [2249] = {.lex_state = 237, .external_lex_state = 16},
  [2250] = {.lex_state = 256, .external_lex_state = 10},
  [2251] = {.lex_state = 237, .external_lex_state = 16},
  [2252] = {.lex_state = 256, .external_lex_state = 10},
  [2253] = {.lex_state = 237, .external_lex_state = 16},
  [2254] = {.lex_state = 256, .external_lex_state = 10},
  [2255] = {.lex_state = 237, .external_lex_state = 16},
  [2256] = {.lex_state = 256, .external_lex_state = 10},
  [2257] = {.lex_state = 256, .external_lex_state = 10},
  [2258] = {.lex_state = 124, .external_lex_state = 9},
  [2259] = {.lex_state = 80},
  [2260] = {.lex_state = 133},
  [2261] = {.lex_state = 147, .external_lex_state = 12},
  [2262] = {.lex_state = 160},
  [2263] = {.lex_state = 69},
  [2264] = {.lex_state = 281, .external_lex_state = 14},
  [2265] = {.lex_state = 97},
  [2266] = {.lex_state = 104},
  [2267] = {.lex_state = 281, .external_lex_state = 14},
  [2268] = {.lex_state = 113, .external_lex_state = 6},
  [2269] = {.lex_state = 63, .external_lex_state = 2},
  [2270] = {.lex_state = 63, .external_lex_state = 2},
  [2271] = {.lex_state = 63, .external_lex_state = 2},
  [2272] = {.lex_state = 281, .external_lex_state = 3},
  [2273] = {.lex_state = 69},
  [2274] = {.lex_state = 281, .external_lex_state = 3},
  [2275] = {.lex_state = 281, .external_lex_state = 10},
  [2276] = {.lex_state = 97},
  [2277] = {.lex_state = 104},
  [2278] = {.lex_state = 281, .external_lex_state = 10},
  [2279] = {.lex_state = 113, .external_lex_state = 6},
  [2280] = {.lex_state = 63, .external_lex_state = 2},
  [2281] = {.lex_state = 63, .external_lex_state = 2},
  [2282] = {.lex_state = 63, .external_lex_state = 2},
  [2283] = {.lex_state = 281, .external_lex_state = 4},
  [2284] = {.lex_state = 281, .external_lex_state = 4},
  [2285] = {.lex_state = 80},
  [2286] = {.lex_state = 287, .external_lex_state = 5},
  [2287] = {.lex_state = 287, .external_lex_state = 5},
  [2288] = {.lex_state = 164},
  [2289] = {.lex_state = 97},
  [2290] = {.lex_state = 287, .external_lex_state = 5},
  [2291] = {.lex_state = 287, .external_lex_state = 5},
  [2292] = {.lex_state = 287, .external_lex_state = 5},
  [2293] = {.lex_state = 69},
  [2294] = {.lex_state = 170, .external_lex_state = 6},
  [2295] = {.lex_state = 172, .external_lex_state = 16},
  [2296] = {.lex_state = 172, .external_lex_state = 16},
  [2297] = {.lex_state = 172, .external_lex_state = 16},
  [2298] = {.lex_state = 135, .external_lex_state = 4},
  [2299] = {.lex_state = 139, .external_lex_state = 8},
  [2300] = {.lex_state = 63, .external_lex_state = 2},
  [2301] = {.lex_state = 90, .external_lex_state = 4},
  [2302] = {.lex_state = 120, .external_lex_state = 8},
  [2303] = {.lex_state = 63, .external_lex_state = 2},
  [2304] = {.lex_state = 135, .external_lex_state = 4},
  [2305] = {.lex_state = 139, .external_lex_state = 8},
  [2306] = {.lex_state = 63, .external_lex_state = 2},
  [2307] = {.lex_state = 84},
  [2308] = {.lex_state = 63, .external_lex_state = 2},
  [2309] = {.lex_state = 277, .external_lex_state = 2},
  [2310] = {.lex_state = 63, .external_lex_state = 2},
  [2311] = {.lex_state = 277, .external_lex_state = 2},
  [2312] = {.lex_state = 63},
  [2313] = {.lex_state = 181},
  [2314] = {.lex_state = 80},
  [2315] = {.lex_state = 80},
  [2316] = {.lex_state = 287, .external_lex_state = 5},
  [2317] = {.lex_state = 287, .external_lex_state = 5},
  [2318] = {.lex_state = 293, .external_lex_state = 7},
  [2319] = {.lex_state = 287, .external_lex_state = 7},
  [2320] = {.lex_state = 258},
  [2321] = {.lex_state = 275, .external_lex_state = 4},
  [2322] = {.lex_state = 291, .external_lex_state = 8},
  [2323] = {.lex_state = 277, .external_lex_state = 2},
  [2324] = {.lex_state = 287, .external_lex_state = 7},
  [2325] = {.lex_state = 277, .external_lex_state = 2},
  [2326] = {.lex_state = 277, .external_lex_state = 2},
  [2327] = {.lex_state = 258},
  [2328] = {.lex_state = 275, .external_lex_state = 4},
  [2329] = {.lex_state = 291, .external_lex_state = 8},
  [2330] = {.lex_state = 277, .external_lex_state = 2},
  [2331] = {.lex_state = 175, .external_lex_state = 2},
  [2332] = {.lex_state = 272},
  [2333] = {.lex_state = 175, .external_lex_state = 2},
  [2334] = {.lex_state = 272},
  [2335] = {.lex_state = 141, .external_lex_state = 4},
  [2336] = {.lex_state = 141, .external_lex_state = 4},
  [2337] = {.lex_state = 129, .external_lex_state = 10},
  [2338] = {.lex_state = 129, .external_lex_state = 10},
  [2339] = {.lex_state = 129, .external_lex_state = 10},
  [2340] = {.lex_state = 279, .external_lex_state = 10},
  [2341] = {.lex_state = 221, .external_lex_state = 23},
  [2342] = {.lex_state = 147, .external_lex_state = 11},
  [2343] = {.lex_state = 147, .external_lex_state = 11},
  [2344] = {.lex_state = 147, .external_lex_state = 11},
  [2345] = {.lex_state = 248, .external_lex_state = 23},
  [2346] = {.lex_state = 248, .external_lex_state = 23},
  [2347] = {.lex_state = 214, .external_lex_state = 22},
  [2348] = {.lex_state = 214, .external_lex_state = 22},
  [2349] = {.lex_state = 214, .external_lex_state = 16},
  [2350] = {.lex_state = 235, .external_lex_state = 16},
  [2351] = {.lex_state = 248, .external_lex_state = 23},
  [2352] = {.lex_state = 239},
  [2353] = {.lex_state = 237, .external_lex_state = 16},
  [2354] = {.lex_state = 248, .external_lex_state = 23},
  [2355] = {.lex_state = 239},
  [2356] = {.lex_state = 237, .external_lex_state = 16},
  [2357] = {.lex_state = 239},
  [2358] = {.lex_state = 237, .external_lex_state = 16},
  [2359] = {.lex_state = 237, .external_lex_state = 16},
  [2360] = {.lex_state = 248, .external_lex_state = 23},
  [2361] = {.lex_state = 237, .external_lex_state = 16},
  [2362] = {.lex_state = 248, .external_lex_state = 23},
  [2363] = {.lex_state = 237, .external_lex_state = 16},
  [2364] = {.lex_state = 248, .external_lex_state = 23},
  [2365] = {.lex_state = 219, .external_lex_state = 2},
  [2366] = {.lex_state = 63, .external_lex_state = 2},
  [2367] = {.lex_state = 248, .external_lex_state = 23},
  [2368] = {.lex_state = 219, .external_lex_state = 2},
  [2369] = {.lex_state = 232, .external_lex_state = 13},
  [2370] = {.lex_state = 232, .external_lex_state = 13},
  [2371] = {.lex_state = 232, .external_lex_state = 13},
  [2372] = {.lex_state = 135, .external_lex_state = 14},
  [2373] = {.lex_state = 135, .external_lex_state = 14},
  [2374] = {.lex_state = 135, .external_lex_state = 14},
  [2375] = {.lex_state = 135, .external_lex_state = 10},
  [2376] = {.lex_state = 135, .external_lex_state = 10},
  [2377] = {.lex_state = 135, .external_lex_state = 10},
  [2378] = {.lex_state = 80, .external_lex_state = 15},
  [2379] = {.lex_state = 80, .external_lex_state = 15},
  [2380] = {.lex_state = 80, .external_lex_state = 15},
  [2381] = {.lex_state = 97, .external_lex_state = 13},
  [2382] = {.lex_state = 97, .external_lex_state = 13},
  [2383] = {.lex_state = 97, .external_lex_state = 13},
  [2384] = {.lex_state = 214, .external_lex_state = 22},
  [2385] = {.lex_state = 214, .external_lex_state = 22},
  [2386] = {.lex_state = 214, .external_lex_state = 22},
  [2387] = {.lex_state = 214, .external_lex_state = 22},
  [2388] = {.lex_state = 214, .external_lex_state = 16},
  [2389] = {.lex_state = 237, .external_lex_state = 16},
  [2390] = {.lex_state = 214, .external_lex_state = 22},
  [2391] = {.lex_state = 237, .external_lex_state = 16},
  [2392] = {.lex_state = 214, .external_lex_state = 22},
  [2393] = {.lex_state = 237, .external_lex_state = 16},
  [2394] = {.lex_state = 214, .external_lex_state = 22},
  [2395] = {.lex_state = 237, .external_lex_state = 16},
  [2396] = {.lex_state = 214, .external_lex_state = 22},
  [2397] = {.lex_state = 237, .external_lex_state = 16},
  [2398] = {.lex_state = 214, .external_lex_state = 22},
  [2399] = {.lex_state = 237, .external_lex_state = 16},
  [2400] = {.lex_state = 214, .external_lex_state = 22},
  [2401] = {.lex_state = 214, .external_lex_state = 22},
  [2402] = {.lex_state = 237, .external_lex_state = 22},
  [2403] = {.lex_state = 237, .external_lex_state = 22},
  [2404] = {.lex_state = 237, .external_lex_state = 22},
  [2405] = {.lex_state = 237, .external_lex_state = 16},
  [2406] = {.lex_state = 237, .external_lex_state = 22},
  [2407] = {.lex_state = 237, .external_lex_state = 16},
  [2408] = {.lex_state = 237, .external_lex_state = 22},
  [2409] = {.lex_state = 237, .external_lex_state = 16},
  [2410] = {.lex_state = 237, .external_lex_state = 22},
  [2411] = {.lex_state = 237, .external_lex_state = 22},
  [2412] = {.lex_state = 237, .external_lex_state = 22},
  [2413] = {.lex_state = 141, .external_lex_state = 10},
  [2414] = {.lex_state = 246, .external_lex_state = 23},
  [2415] = {.lex_state = 178, .external_lex_state = 17},
  [2416] = {.lex_state = 178, .external_lex_state = 17},
  [2417] = {.lex_state = 178, .external_lex_state = 17},
  [2418] = {.lex_state = 237, .external_lex_state = 16},
  [2419] = {.lex_state = 178, .external_lex_state = 17},
  [2420] = {.lex_state = 237, .external_lex_state = 16},
  [2421] = {.lex_state = 178, .external_lex_state = 17},
  [2422] = {.lex_state = 237, .external_lex_state = 16},
  [2423] = {.lex_state = 178, .external_lex_state = 17},
  [2424] = {.lex_state = 178, .external_lex_state = 17},
  [2425] = {.lex_state = 178, .external_lex_state = 17},
  [2426] = {.lex_state = 210, .external_lex_state = 13},
  [2427] = {.lex_state = 210, .external_lex_state = 13},
  [2428] = {.lex_state = 210, .external_lex_state = 13},
  [2429] = {.lex_state = 237, .external_lex_state = 16},
  [2430] = {.lex_state = 210, .external_lex_state = 13},
  [2431] = {.lex_state = 237, .external_lex_state = 16},
  [2432] = {.lex_state = 210, .external_lex_state = 13},
  [2433] = {.lex_state = 237, .external_lex_state = 16},
  [2434] = {.lex_state = 210, .external_lex_state = 13},
  [2435] = {.lex_state = 210, .external_lex_state = 13},
  [2436] = {.lex_state = 210, .external_lex_state = 13},
  [2437] = {.lex_state = 139, .external_lex_state = 19},
  [2438] = {.lex_state = 139, .external_lex_state = 19},
  [2439] = {.lex_state = 139, .external_lex_state = 19},
  [2440] = {.lex_state = 270, .external_lex_state = 13},
  [2441] = {.lex_state = 270, .external_lex_state = 13},
  [2442] = {.lex_state = 214, .external_lex_state = 22},
  [2443] = {.lex_state = 214, .external_lex_state = 22},
  [2444] = {.lex_state = 214, .external_lex_state = 16},
  [2445] = {.lex_state = 237, .external_lex_state = 16},
  [2446] = {.lex_state = 270, .external_lex_state = 13},
  [2447] = {.lex_state = 237, .external_lex_state = 16},
  [2448] = {.lex_state = 270, .external_lex_state = 13},
  [2449] = {.lex_state = 237, .external_lex_state = 16},
  [2450] = {.lex_state = 270, .external_lex_state = 13},
  [2451] = {.lex_state = 237, .external_lex_state = 16},
  [2452] = {.lex_state = 270, .external_lex_state = 13},
  [2453] = {.lex_state = 237, .external_lex_state = 16},
  [2454] = {.lex_state = 270, .external_lex_state = 13},
  [2455] = {.lex_state = 237, .external_lex_state = 16},
  [2456] = {.lex_state = 270, .external_lex_state = 13},
  [2457] = {.lex_state = 270, .external_lex_state = 13},
  [2458] = {.lex_state = 254, .external_lex_state = 10},
  [2459] = {.lex_state = 254, .external_lex_state = 10},
  [2460] = {.lex_state = 254, .external_lex_state = 10},
  [2461] = {.lex_state = 141, .external_lex_state = 4},
  [2462] = {.lex_state = 256, .external_lex_state = 10},
  [2463] = {.lex_state = 256, .external_lex_state = 10},
  [2464] = {.lex_state = 256, .external_lex_state = 10},
  [2465] = {.lex_state = 237, .external_lex_state = 16},
  [2466] = {.lex_state = 256, .external_lex_state = 10},
  [2467] = {.lex_state = 237, .external_lex_state = 16},
  [2468] = {.lex_state = 256, .external_lex_state = 10},
  [2469] = {.lex_state = 237, .external_lex_state = 16},
  [2470] = {.lex_state = 256, .external_lex_state = 10},
  [2471] = {.lex_state = 256, .external_lex_state = 10},
  [2472] = {.lex_state = 256, .external_lex_state = 10},
  [2473] = {.lex_state = 291, .external_lex_state = 8},
  [2474] = {.lex_state = 210},
  [2475] = {.lex_state = 291, .external_lex_state = 19},
  [2476] = {.lex_state = 97},
  [2477] = {.lex_state = 104},
  [2478] = {.lex_state = 291, .external_lex_state = 19},
  [2479] = {.lex_state = 113, .external_lex_state = 6},
  [2480] = {.lex_state = 63, .external_lex_state = 2},
  [2481] = {.lex_state = 63, .external_lex_state = 2},
  [2482] = {.lex_state = 63, .external_lex_state = 2},
  [2483] = {.lex_state = 293, .external_lex_state = 7},
  [2484] = {.lex_state = 84},
  [2485] = {.lex_state = 295, .external_lex_state = 21},
  [2486] = {.lex_state = 293, .external_lex_state = 21},
  [2487] = {.lex_state = 124, .external_lex_state = 9},
  [2488] = {.lex_state = 80},
  [2489] = {.lex_state = 281, .external_lex_state = 14},
  [2490] = {.lex_state = 281, .external_lex_state = 14},
  [2491] = {.lex_state = 164},
  [2492] = {.lex_state = 97},
  [2493] = {.lex_state = 281, .external_lex_state = 14},
  [2494] = {.lex_state = 281, .external_lex_state = 14},
  [2495] = {.lex_state = 281, .external_lex_state = 14},
  [2496] = {.lex_state = 69},
  [2497] = {.lex_state = 170, .external_lex_state = 6},
  [2498] = {.lex_state = 172, .external_lex_state = 16},
  [2499] = {.lex_state = 172, .external_lex_state = 16},
  [2500] = {.lex_state = 172, .external_lex_state = 16},
  [2501] = {.lex_state = 135, .external_lex_state = 4},
  [2502] = {.lex_state = 139, .external_lex_state = 8},
  [2503] = {.lex_state = 63, .external_lex_state = 2},
  [2504] = {.lex_state = 90, .external_lex_state = 4},
  [2505] = {.lex_state = 120, .external_lex_state = 8},
  [2506] = {.lex_state = 63, .external_lex_state = 2},
  [2507] = {.lex_state = 135, .external_lex_state = 4},
  [2508] = {.lex_state = 139, .external_lex_state = 8},
  [2509] = {.lex_state = 63, .external_lex_state = 2},
  [2510] = {.lex_state = 281, .external_lex_state = 3},
  [2511] = {.lex_state = 80},
  [2512] = {.lex_state = 281, .external_lex_state = 10},
  [2513] = {.lex_state = 281, .external_lex_state = 10},
  [2514] = {.lex_state = 164},
  [2515] = {.lex_state = 97},
  [2516] = {.lex_state = 281, .external_lex_state = 10},
  [2517] = {.lex_state = 281, .external_lex_state = 10},
  [2518] = {.lex_state = 281, .external_lex_state = 10},
  [2519] = {.lex_state = 69},
  [2520] = {.lex_state = 170, .external_lex_state = 6},
  [2521] = {.lex_state = 172, .external_lex_state = 16},
  [2522] = {.lex_state = 172, .external_lex_state = 16},
  [2523] = {.lex_state = 172, .external_lex_state = 16},
  [2524] = {.lex_state = 135, .external_lex_state = 4},
  [2525] = {.lex_state = 139, .external_lex_state = 8},
  [2526] = {.lex_state = 63, .external_lex_state = 2},
  [2527] = {.lex_state = 90, .external_lex_state = 4},
  [2528] = {.lex_state = 120, .external_lex_state = 8},
  [2529] = {.lex_state = 63, .external_lex_state = 2},
  [2530] = {.lex_state = 135, .external_lex_state = 4},
  [2531] = {.lex_state = 139, .external_lex_state = 8},
  [2532] = {.lex_state = 63, .external_lex_state = 2},
  [2533] = {.lex_state = 281, .external_lex_state = 4},
  [2534] = {.lex_state = 287, .external_lex_state = 5},
  [2535] = {.lex_state = 287, .external_lex_state = 5},
  [2536] = {.lex_state = 287, .external_lex_state = 5},
  [2537] = {.lex_state = 164},
  [2538] = {.lex_state = 235, .external_lex_state = 16},
  [2539] = {.lex_state = 69},
  [2540] = {.lex_state = 172, .external_lex_state = 16},
  [2541] = {.lex_state = 172, .external_lex_state = 16},
  [2542] = {.lex_state = 172, .external_lex_state = 16},
  [2543] = {.lex_state = 287, .external_lex_state = 5},
  [2544] = {.lex_state = 239},
  [2545] = {.lex_state = 237, .external_lex_state = 16},
  [2546] = {.lex_state = 287, .external_lex_state = 5},
  [2547] = {.lex_state = 239},
  [2548] = {.lex_state = 237, .external_lex_state = 16},
  [2549] = {.lex_state = 287, .external_lex_state = 5},
  [2550] = {.lex_state = 239},
  [2551] = {.lex_state = 237, .external_lex_state = 16},
  [2552] = {.lex_state = 287, .external_lex_state = 5},
  [2553] = {.lex_state = 219, .external_lex_state = 2},
  [2554] = {.lex_state = 135, .external_lex_state = 4},
  [2555] = {.lex_state = 139, .external_lex_state = 8},
  [2556] = {.lex_state = 63, .external_lex_state = 2},
  [2557] = {.lex_state = 90, .external_lex_state = 4},
  [2558] = {.lex_state = 120, .external_lex_state = 8},
  [2559] = {.lex_state = 287, .external_lex_state = 5},
  [2560] = {.lex_state = 219, .external_lex_state = 2},
  [2561] = {.lex_state = 135, .external_lex_state = 4},
  [2562] = {.lex_state = 139, .external_lex_state = 8},
  [2563] = {.lex_state = 133},
  [2564] = {.lex_state = 291, .external_lex_state = 8},
  [2565] = {.lex_state = 275, .external_lex_state = 4},
  [2566] = {.lex_state = 291, .external_lex_state = 8},
  [2567] = {.lex_state = 80},
  [2568] = {.lex_state = 287, .external_lex_state = 5},
  [2569] = {.lex_state = 287, .external_lex_state = 5},
  [2570] = {.lex_state = 287, .external_lex_state = 7},
  [2571] = {.lex_state = 293, .external_lex_state = 5},
  [2572] = {.lex_state = 97},
  [2573] = {.lex_state = 104},
  [2574] = {.lex_state = 293, .external_lex_state = 5},
  [2575] = {.lex_state = 113, .external_lex_state = 6},
  [2576] = {.lex_state = 63, .external_lex_state = 2},
  [2577] = {.lex_state = 63, .external_lex_state = 2},
  [2578] = {.lex_state = 63, .external_lex_state = 2},
  [2579] = {.lex_state = 293, .external_lex_state = 5},
  [2580] = {.lex_state = 293, .external_lex_state = 5},
  [2581] = {.lex_state = 293, .external_lex_state = 7},
  [2582] = {.lex_state = 293, .external_lex_state = 7},
  [2583] = {.lex_state = 287, .external_lex_state = 7},
  [2584] = {.lex_state = 277, .external_lex_state = 2},
  [2585] = {.lex_state = 90, .external_lex_state = 4},
  [2586] = {.lex_state = 120, .external_lex_state = 8},
  [2587] = {.lex_state = 287, .external_lex_state = 7},
  [2588] = {.lex_state = 258},
  [2589] = {.lex_state = 275, .external_lex_state = 4},
  [2590] = {.lex_state = 291, .external_lex_state = 8},
  [2591] = {.lex_state = 277, .external_lex_state = 2},
  [2592] = {.lex_state = 258},
  [2593] = {.lex_state = 275, .external_lex_state = 4},
  [2594] = {.lex_state = 291, .external_lex_state = 8},
  [2595] = {.lex_state = 80},
  [2596] = {.lex_state = 90, .external_lex_state = 4},
  [2597] = {.lex_state = 120, .external_lex_state = 8},
  [2598] = {.lex_state = 175, .external_lex_state = 2},
  [2599] = {.lex_state = 175, .external_lex_state = 2},
  [2600] = {.lex_state = 80},
  [2601] = {.lex_state = 90, .external_lex_state = 4},
  [2602] = {.lex_state = 120, .external_lex_state = 8},
  [2603] = {.lex_state = 175, .external_lex_state = 2},
  [2604] = {.lex_state = 175, .external_lex_state = 2},
  [2605] = {.lex_state = 248, .external_lex_state = 23},
  [2606] = {.lex_state = 248, .external_lex_state = 23},
  [2607] = {.lex_state = 214, .external_lex_state = 22},
  [2608] = {.lex_state = 214, .external_lex_state = 22},
  [2609] = {.lex_state = 214, .external_lex_state = 16},
  [2610] = {.lex_state = 237, .external_lex_state = 16},
  [2611] = {.lex_state = 248, .external_lex_state = 23},
  [2612] = {.lex_state = 237, .external_lex_state = 16},
  [2613] = {.lex_state = 248, .external_lex_state = 23},
  [2614] = {.lex_state = 237, .external_lex_state = 16},
  [2615] = {.lex_state = 248, .external_lex_state = 23},
  [2616] = {.lex_state = 237, .external_lex_state = 16},
  [2617] = {.lex_state = 248, .external_lex_state = 23},
  [2618] = {.lex_state = 237, .external_lex_state = 16},
  [2619] = {.lex_state = 248, .external_lex_state = 23},
  [2620] = {.lex_state = 237, .external_lex_state = 16},
  [2621] = {.lex_state = 248, .external_lex_state = 23},
  [2622] = {.lex_state = 248, .external_lex_state = 23},
  [2623] = {.lex_state = 214, .external_lex_state = 22},
  [2624] = {.lex_state = 214, .external_lex_state = 22},
  [2625] = {.lex_state = 214, .external_lex_state = 22},
  [2626] = {.lex_state = 237, .external_lex_state = 16},
  [2627] = {.lex_state = 214, .external_lex_state = 22},
  [2628] = {.lex_state = 237, .external_lex_state = 16},
  [2629] = {.lex_state = 214, .external_lex_state = 22},
  [2630] = {.lex_state = 237, .external_lex_state = 16},
  [2631] = {.lex_state = 214, .external_lex_state = 22},
  [2632] = {.lex_state = 214, .external_lex_state = 22},
  [2633] = {.lex_state = 214, .external_lex_state = 22},
  [2634] = {.lex_state = 237, .external_lex_state = 22},
  [2635] = {.lex_state = 237, .external_lex_state = 22},
  [2636] = {.lex_state = 237, .external_lex_state = 22},
  [2637] = {.lex_state = 178, .external_lex_state = 17},
  [2638] = {.lex_state = 178, .external_lex_state = 17},
  [2639] = {.lex_state = 178, .external_lex_state = 17},
  [2640] = {.lex_state = 210, .external_lex_state = 13},
  [2641] = {.lex_state = 210, .external_lex_state = 13},
  [2642] = {.lex_state = 210, .external_lex_state = 13},
  [2643] = {.lex_state = 270, .external_lex_state = 13},
  [2644] = {.lex_state = 270, .external_lex_state = 13},
  [2645] = {.lex_state = 270, .external_lex_state = 13},
  [2646] = {.lex_state = 237, .external_lex_state = 16},
  [2647] = {.lex_state = 270, .external_lex_state = 13},
  [2648] = {.lex_state = 237, .external_lex_state = 16},
  [2649] = {.lex_state = 270, .external_lex_state = 13},
  [2650] = {.lex_state = 237, .external_lex_state = 16},
  [2651] = {.lex_state = 270, .external_lex_state = 13},
  [2652] = {.lex_state = 270, .external_lex_state = 13},
  [2653] = {.lex_state = 270, .external_lex_state = 13},
  [2654] = {.lex_state = 256, .external_lex_state = 10},
  [2655] = {.lex_state = 256, .external_lex_state = 10},
  [2656] = {.lex_state = 256, .external_lex_state = 10},
  [2657] = {.lex_state = 291, .external_lex_state = 8},
  [2658] = {.lex_state = 210},
  [2659] = {.lex_state = 80},
  [2660] = {.lex_state = 291, .external_lex_state = 19},
  [2661] = {.lex_state = 291, .external_lex_state = 19},
  [2662] = {.lex_state = 164},
  [2663] = {.lex_state = 97},
  [2664] = {.lex_state = 291, .external_lex_state = 19},
  [2665] = {.lex_state = 291, .external_lex_state = 19},
  [2666] = {.lex_state = 291, .external_lex_state = 19},
  [2667] = {.lex_state = 69},
  [2668] = {.lex_state = 170, .external_lex_state = 6},
  [2669] = {.lex_state = 172, .external_lex_state = 16},
  [2670] = {.lex_state = 172, .external_lex_state = 16},
  [2671] = {.lex_state = 172, .external_lex_state = 16},
  [2672] = {.lex_state = 135, .external_lex_state = 4},
  [2673] = {.lex_state = 139, .external_lex_state = 8},
  [2674] = {.lex_state = 63, .external_lex_state = 2},
  [2675] = {.lex_state = 90, .external_lex_state = 4},
  [2676] = {.lex_state = 120, .external_lex_state = 8},
  [2677] = {.lex_state = 63, .external_lex_state = 2},
  [2678] = {.lex_state = 135, .external_lex_state = 4},
  [2679] = {.lex_state = 139, .external_lex_state = 8},
  [2680] = {.lex_state = 63, .external_lex_state = 2},
  [2681] = {.lex_state = 293, .external_lex_state = 7},
  [2682] = {.lex_state = 133},
  [2683] = {.lex_state = 63},
  [2684] = {.lex_state = 80},
  [2685] = {.lex_state = 63},
  [2686] = {.lex_state = 80},
  [2687] = {.lex_state = 80},
  [2688] = {.lex_state = 293, .external_lex_state = 21},
  [2689] = {.lex_state = 281, .external_lex_state = 3},
  [2690] = {.lex_state = 210},
  [2691] = {.lex_state = 281, .external_lex_state = 14},
  [2692] = {.lex_state = 281, .external_lex_state = 14},
  [2693] = {.lex_state = 281, .external_lex_state = 14},
  [2694] = {.lex_state = 281, .external_lex_state = 14},
  [2695] = {.lex_state = 281, .external_lex_state = 14},
  [2696] = {.lex_state = 164},
  [2697] = {.lex_state = 235, .external_lex_state = 16},
  [2698] = {.lex_state = 69},
  [2699] = {.lex_state = 172, .external_lex_state = 16},
  [2700] = {.lex_state = 172, .external_lex_state = 16},
  [2701] = {.lex_state = 172, .external_lex_state = 16},
  [2702] = {.lex_state = 281, .external_lex_state = 14},
  [2703] = {.lex_state = 239},
  [2704] = {.lex_state = 237, .external_lex_state = 16},
  [2705] = {.lex_state = 281, .external_lex_state = 14},
  [2706] = {.lex_state = 239},
  [2707] = {.lex_state = 237, .external_lex_state = 16},
  [2708] = {.lex_state = 281, .external_lex_state = 14},
  [2709] = {.lex_state = 239},
  [2710] = {.lex_state = 237, .external_lex_state = 16},
  [2711] = {.lex_state = 281, .external_lex_state = 14},
  [2712] = {.lex_state = 219, .external_lex_state = 2},
  [2713] = {.lex_state = 135, .external_lex_state = 4},
  [2714] = {.lex_state = 139, .external_lex_state = 8},
  [2715] = {.lex_state = 63, .external_lex_state = 2},
  [2716] = {.lex_state = 90, .external_lex_state = 4},
  [2717] = {.lex_state = 120, .external_lex_state = 8},
  [2718] = {.lex_state = 281, .external_lex_state = 14},
  [2719] = {.lex_state = 219, .external_lex_state = 2},
  [2720] = {.lex_state = 135, .external_lex_state = 4},
  [2721] = {.lex_state = 139, .external_lex_state = 8},
  [2722] = {.lex_state = 281, .external_lex_state = 10},
  [2723] = {.lex_state = 281, .external_lex_state = 10},
  [2724] = {.lex_state = 281, .external_lex_state = 10},
  [2725] = {.lex_state = 164},
  [2726] = {.lex_state = 235, .external_lex_state = 16},
  [2727] = {.lex_state = 69},
  [2728] = {.lex_state = 172, .external_lex_state = 16},
  [2729] = {.lex_state = 172, .external_lex_state = 16},
  [2730] = {.lex_state = 172, .external_lex_state = 16},
  [2731] = {.lex_state = 281, .external_lex_state = 10},
  [2732] = {.lex_state = 239},
  [2733] = {.lex_state = 237, .external_lex_state = 16},
  [2734] = {.lex_state = 281, .external_lex_state = 10},
  [2735] = {.lex_state = 239},
  [2736] = {.lex_state = 237, .external_lex_state = 16},
  [2737] = {.lex_state = 281, .external_lex_state = 10},
  [2738] = {.lex_state = 239},
  [2739] = {.lex_state = 237, .external_lex_state = 16},
  [2740] = {.lex_state = 281, .external_lex_state = 10},
  [2741] = {.lex_state = 219, .external_lex_state = 2},
  [2742] = {.lex_state = 135, .external_lex_state = 4},
  [2743] = {.lex_state = 139, .external_lex_state = 8},
  [2744] = {.lex_state = 63, .external_lex_state = 2},
  [2745] = {.lex_state = 90, .external_lex_state = 4},
  [2746] = {.lex_state = 120, .external_lex_state = 8},
  [2747] = {.lex_state = 281, .external_lex_state = 10},
  [2748] = {.lex_state = 219, .external_lex_state = 2},
  [2749] = {.lex_state = 135, .external_lex_state = 4},
  [2750] = {.lex_state = 139, .external_lex_state = 8},
  [2751] = {.lex_state = 287, .external_lex_state = 5},
  [2752] = {.lex_state = 287, .external_lex_state = 5},
  [2753] = {.lex_state = 214, .external_lex_state = 22},
  [2754] = {.lex_state = 214, .external_lex_state = 22},
  [2755] = {.lex_state = 214, .external_lex_state = 16},
  [2756] = {.lex_state = 235, .external_lex_state = 16},
  [2757] = {.lex_state = 287, .external_lex_state = 5},
  [2758] = {.lex_state = 239},
  [2759] = {.lex_state = 237, .external_lex_state = 16},
  [2760] = {.lex_state = 287, .external_lex_state = 5},
  [2761] = {.lex_state = 239},
  [2762] = {.lex_state = 237, .external_lex_state = 16},
  [2763] = {.lex_state = 239},
  [2764] = {.lex_state = 237, .external_lex_state = 16},
  [2765] = {.lex_state = 237, .external_lex_state = 16},
  [2766] = {.lex_state = 287, .external_lex_state = 5},
  [2767] = {.lex_state = 237, .external_lex_state = 16},
  [2768] = {.lex_state = 287, .external_lex_state = 5},
  [2769] = {.lex_state = 237, .external_lex_state = 16},
  [2770] = {.lex_state = 287, .external_lex_state = 5},
  [2771] = {.lex_state = 219, .external_lex_state = 2},
  [2772] = {.lex_state = 63, .external_lex_state = 2},
  [2773] = {.lex_state = 287, .external_lex_state = 5},
  [2774] = {.lex_state = 219, .external_lex_state = 2},
  [2775] = {.lex_state = 295, .external_lex_state = 21},
  [2776] = {.lex_state = 293, .external_lex_state = 5},
  [2777] = {.lex_state = 293, .external_lex_state = 5},
  [2778] = {.lex_state = 80},
  [2779] = {.lex_state = 293, .external_lex_state = 5},
  [2780] = {.lex_state = 293, .external_lex_state = 5},
  [2781] = {.lex_state = 164},
  [2782] = {.lex_state = 97},
  [2783] = {.lex_state = 293, .external_lex_state = 5},
  [2784] = {.lex_state = 293, .external_lex_state = 5},
  [2785] = {.lex_state = 293, .external_lex_state = 5},
  [2786] = {.lex_state = 69},
  [2787] = {.lex_state = 170, .external_lex_state = 6},
  [2788] = {.lex_state = 172, .external_lex_state = 16},
  [2789] = {.lex_state = 172, .external_lex_state = 16},
  [2790] = {.lex_state = 172, .external_lex_state = 16},
  [2791] = {.lex_state = 135, .external_lex_state = 4},
  [2792] = {.lex_state = 139, .external_lex_state = 8},
  [2793] = {.lex_state = 63, .external_lex_state = 2},
  [2794] = {.lex_state = 90, .external_lex_state = 4},
  [2795] = {.lex_state = 120, .external_lex_state = 8},
  [2796] = {.lex_state = 63, .external_lex_state = 2},
  [2797] = {.lex_state = 135, .external_lex_state = 4},
  [2798] = {.lex_state = 139, .external_lex_state = 8},
  [2799] = {.lex_state = 63, .external_lex_state = 2},
  [2800] = {.lex_state = 293, .external_lex_state = 7},
  [2801] = {.lex_state = 277, .external_lex_state = 2},
  [2802] = {.lex_state = 277, .external_lex_state = 2},
  [2803] = {.lex_state = 175, .external_lex_state = 2},
  [2804] = {.lex_state = 80},
  [2805] = {.lex_state = 90, .external_lex_state = 4},
  [2806] = {.lex_state = 120, .external_lex_state = 8},
  [2807] = {.lex_state = 175, .external_lex_state = 2},
  [2808] = {.lex_state = 175, .external_lex_state = 2},
  [2809] = {.lex_state = 175, .external_lex_state = 2},
  [2810] = {.lex_state = 80},
  [2811] = {.lex_state = 90, .external_lex_state = 4},
  [2812] = {.lex_state = 120, .external_lex_state = 8},
  [2813] = {.lex_state = 175, .external_lex_state = 2},
  [2814] = {.lex_state = 248, .external_lex_state = 23},
  [2815] = {.lex_state = 248, .external_lex_state = 23},
  [2816] = {.lex_state = 248, .external_lex_state = 23},
  [2817] = {.lex_state = 237, .external_lex_state = 16},
  [2818] = {.lex_state = 248, .external_lex_state = 23},
  [2819] = {.lex_state = 237, .external_lex_state = 16},
  [2820] = {.lex_state = 248, .external_lex_state = 23},
  [2821] = {.lex_state = 237, .external_lex_state = 16},
  [2822] = {.lex_state = 248, .external_lex_state = 23},
  [2823] = {.lex_state = 248, .external_lex_state = 23},
  [2824] = {.lex_state = 248, .external_lex_state = 23},
  [2825] = {.lex_state = 214, .external_lex_state = 22},
  [2826] = {.lex_state = 214, .external_lex_state = 22},
  [2827] = {.lex_state = 214, .external_lex_state = 22},
  [2828] = {.lex_state = 270, .external_lex_state = 13},
  [2829] = {.lex_state = 270, .external_lex_state = 13},
  [2830] = {.lex_state = 270, .external_lex_state = 13},
  [2831] = {.lex_state = 291, .external_lex_state = 8},
  [2832] = {.lex_state = 291, .external_lex_state = 19},
  [2833] = {.lex_state = 291, .external_lex_state = 19},
  [2834] = {.lex_state = 291, .external_lex_state = 19},
  [2835] = {.lex_state = 164},
  [2836] = {.lex_state = 235, .external_lex_state = 16},
  [2837] = {.lex_state = 69},
  [2838] = {.lex_state = 172, .external_lex_state = 16},
  [2839] = {.lex_state = 172, .external_lex_state = 16},
  [2840] = {.lex_state = 172, .external_lex_state = 16},
  [2841] = {.lex_state = 291, .external_lex_state = 19},
  [2842] = {.lex_state = 239},
  [2843] = {.lex_state = 237, .external_lex_state = 16},
  [2844] = {.lex_state = 291, .external_lex_state = 19},
  [2845] = {.lex_state = 239},
  [2846] = {.lex_state = 237, .external_lex_state = 16},
  [2847] = {.lex_state = 291, .external_lex_state = 19},
  [2848] = {.lex_state = 239},
  [2849] = {.lex_state = 237, .external_lex_state = 16},
  [2850] = {.lex_state = 291, .external_lex_state = 19},
  [2851] = {.lex_state = 219, .external_lex_state = 2},
  [2852] = {.lex_state = 135, .external_lex_state = 4},
  [2853] = {.lex_state = 139, .external_lex_state = 8},
  [2854] = {.lex_state = 63, .external_lex_state = 2},
  [2855] = {.lex_state = 90, .external_lex_state = 4},
  [2856] = {.lex_state = 120, .external_lex_state = 8},
  [2857] = {.lex_state = 291, .external_lex_state = 19},
  [2858] = {.lex_state = 219, .external_lex_state = 2},
  [2859] = {.lex_state = 135, .external_lex_state = 4},
  [2860] = {.lex_state = 139, .external_lex_state = 8},
  [2861] = {.lex_state = 295, .external_lex_state = 21},
  [2862] = {.lex_state = 80},
  [2863] = {.lex_state = 275, .external_lex_state = 10},
  [2864] = {.lex_state = 275, .external_lex_state = 10},
  [2865] = {.lex_state = 80},
  [2866] = {.lex_state = 293, .external_lex_state = 23},
  [2867] = {.lex_state = 293, .external_lex_state = 23},
  [2868] = {.lex_state = 293, .external_lex_state = 23},
  [2869] = {.lex_state = 293, .external_lex_state = 23},
  [2870] = {.lex_state = 293, .external_lex_state = 21},
  [2871] = {.lex_state = 281, .external_lex_state = 3},
  [2872] = {.lex_state = 210},
  [2873] = {.lex_state = 281, .external_lex_state = 14},
  [2874] = {.lex_state = 281, .external_lex_state = 14},
  [2875] = {.lex_state = 214, .external_lex_state = 22},
  [2876] = {.lex_state = 214, .external_lex_state = 22},
  [2877] = {.lex_state = 214, .external_lex_state = 16},
  [2878] = {.lex_state = 235, .external_lex_state = 16},
  [2879] = {.lex_state = 281, .external_lex_state = 14},
  [2880] = {.lex_state = 239},
  [2881] = {.lex_state = 237, .external_lex_state = 16},
  [2882] = {.lex_state = 281, .external_lex_state = 14},
  [2883] = {.lex_state = 239},
  [2884] = {.lex_state = 237, .external_lex_state = 16},
  [2885] = {.lex_state = 239},
  [2886] = {.lex_state = 237, .external_lex_state = 16},
  [2887] = {.lex_state = 237, .external_lex_state = 16},
  [2888] = {.lex_state = 281, .external_lex_state = 14},
  [2889] = {.lex_state = 237, .external_lex_state = 16},
  [2890] = {.lex_state = 281, .external_lex_state = 14},
  [2891] = {.lex_state = 237, .external_lex_state = 16},
  [2892] = {.lex_state = 281, .external_lex_state = 14},
  [2893] = {.lex_state = 219, .external_lex_state = 2},
  [2894] = {.lex_state = 63, .external_lex_state = 2},
  [2895] = {.lex_state = 281, .external_lex_state = 14},
  [2896] = {.lex_state = 219, .external_lex_state = 2},
  [2897] = {.lex_state = 281, .external_lex_state = 10},
  [2898] = {.lex_state = 281, .external_lex_state = 10},
  [2899] = {.lex_state = 214, .external_lex_state = 22},
  [2900] = {.lex_state = 214, .external_lex_state = 22},
  [2901] = {.lex_state = 214, .external_lex_state = 16},
  [2902] = {.lex_state = 235, .external_lex_state = 16},
  [2903] = {.lex_state = 281, .external_lex_state = 10},
  [2904] = {.lex_state = 239},
  [2905] = {.lex_state = 237, .external_lex_state = 16},
  [2906] = {.lex_state = 281, .external_lex_state = 10},
  [2907] = {.lex_state = 239},
  [2908] = {.lex_state = 237, .external_lex_state = 16},
  [2909] = {.lex_state = 239},
  [2910] = {.lex_state = 237, .external_lex_state = 16},
  [2911] = {.lex_state = 237, .external_lex_state = 16},
  [2912] = {.lex_state = 281, .external_lex_state = 10},
  [2913] = {.lex_state = 237, .external_lex_state = 16},
  [2914] = {.lex_state = 281, .external_lex_state = 10},
  [2915] = {.lex_state = 237, .external_lex_state = 16},
  [2916] = {.lex_state = 281, .external_lex_state = 10},
  [2917] = {.lex_state = 219, .external_lex_state = 2},
  [2918] = {.lex_state = 63, .external_lex_state = 2},
  [2919] = {.lex_state = 281, .external_lex_state = 10},
  [2920] = {.lex_state = 219, .external_lex_state = 2},
  [2921] = {.lex_state = 287, .external_lex_state = 5},
  [2922] = {.lex_state = 287, .external_lex_state = 5},
  [2923] = {.lex_state = 214, .external_lex_state = 22},
  [2924] = {.lex_state = 214, .external_lex_state = 22},
  [2925] = {.lex_state = 214, .external_lex_state = 16},
  [2926] = {.lex_state = 237, .external_lex_state = 16},
  [2927] = {.lex_state = 287, .external_lex_state = 5},
  [2928] = {.lex_state = 237, .external_lex_state = 16},
  [2929] = {.lex_state = 287, .external_lex_state = 5},
  [2930] = {.lex_state = 237, .external_lex_state = 16},
  [2931] = {.lex_state = 287, .external_lex_state = 5},
  [2932] = {.lex_state = 237, .external_lex_state = 16},
  [2933] = {.lex_state = 287, .external_lex_state = 5},
  [2934] = {.lex_state = 237, .external_lex_state = 16},
  [2935] = {.lex_state = 287, .external_lex_state = 5},
  [2936] = {.lex_state = 237, .external_lex_state = 16},
  [2937] = {.lex_state = 287, .external_lex_state = 5},
  [2938] = {.lex_state = 287, .external_lex_state = 5},
  [2939] = {.lex_state = 293, .external_lex_state = 5},
  [2940] = {.lex_state = 293, .external_lex_state = 5},
  [2941] = {.lex_state = 293, .external_lex_state = 5},
  [2942] = {.lex_state = 164},
  [2943] = {.lex_state = 235, .external_lex_state = 16},
  [2944] = {.lex_state = 69},
  [2945] = {.lex_state = 172, .external_lex_state = 16},
  [2946] = {.lex_state = 172, .external_lex_state = 16},
  [2947] = {.lex_state = 172, .external_lex_state = 16},
  [2948] = {.lex_state = 293, .external_lex_state = 5},
  [2949] = {.lex_state = 239},
  [2950] = {.lex_state = 237, .external_lex_state = 16},
  [2951] = {.lex_state = 293, .external_lex_state = 5},
  [2952] = {.lex_state = 239},
  [2953] = {.lex_state = 237, .external_lex_state = 16},
  [2954] = {.lex_state = 293, .external_lex_state = 5},
  [2955] = {.lex_state = 239},
  [2956] = {.lex_state = 237, .external_lex_state = 16},
  [2957] = {.lex_state = 293, .external_lex_state = 5},
  [2958] = {.lex_state = 219, .external_lex_state = 2},
  [2959] = {.lex_state = 135, .external_lex_state = 4},
  [2960] = {.lex_state = 139, .external_lex_state = 8},
  [2961] = {.lex_state = 63, .external_lex_state = 2},
  [2962] = {.lex_state = 90, .external_lex_state = 4},
  [2963] = {.lex_state = 120, .external_lex_state = 8},
  [2964] = {.lex_state = 293, .external_lex_state = 5},
  [2965] = {.lex_state = 219, .external_lex_state = 2},
  [2966] = {.lex_state = 135, .external_lex_state = 4},
  [2967] = {.lex_state = 139, .external_lex_state = 8},
  [2968] = {.lex_state = 175, .external_lex_state = 2},
  [2969] = {.lex_state = 80},
  [2970] = {.lex_state = 90, .external_lex_state = 4},
  [2971] = {.lex_state = 120, .external_lex_state = 8},
  [2972] = {.lex_state = 175, .external_lex_state = 2},
  [2973] = {.lex_state = 80},
  [2974] = {.lex_state = 90, .external_lex_state = 4},
  [2975] = {.lex_state = 120, .external_lex_state = 8},
  [2976] = {.lex_state = 248, .external_lex_state = 23},
  [2977] = {.lex_state = 248, .external_lex_state = 23},
  [2978] = {.lex_state = 248, .external_lex_state = 23},
  [2979] = {.lex_state = 291, .external_lex_state = 19},
  [2980] = {.lex_state = 291, .external_lex_state = 19},
  [2981] = {.lex_state = 214, .external_lex_state = 22},
  [2982] = {.lex_state = 214, .external_lex_state = 22},
  [2983] = {.lex_state = 214, .external_lex_state = 16},
  [2984] = {.lex_state = 235, .external_lex_state = 16},
  [2985] = {.lex_state = 291, .external_lex_state = 19},
  [2986] = {.lex_state = 239},
  [2987] = {.lex_state = 237, .external_lex_state = 16},
  [2988] = {.lex_state = 291, .external_lex_state = 19},
  [2989] = {.lex_state = 239},
  [2990] = {.lex_state = 237, .external_lex_state = 16},
  [2991] = {.lex_state = 239},
  [2992] = {.lex_state = 237, .external_lex_state = 16},
  [2993] = {.lex_state = 237, .external_lex_state = 16},
  [2994] = {.lex_state = 291, .external_lex_state = 19},
  [2995] = {.lex_state = 237, .external_lex_state = 16},
  [2996] = {.lex_state = 291, .external_lex_state = 19},
  [2997] = {.lex_state = 237, .external_lex_state = 16},
  [2998] = {.lex_state = 291, .external_lex_state = 19},
  [2999] = {.lex_state = 219, .external_lex_state = 2},
  [3000] = {.lex_state = 63, .external_lex_state = 2},
  [3001] = {.lex_state = 291, .external_lex_state = 19},
  [3002] = {.lex_state = 219, .external_lex_state = 2},
  [3003] = {.lex_state = 275, .external_lex_state = 10},
  [3004] = {.lex_state = 275, .external_lex_state = 10},
  [3005] = {.lex_state = 275, .external_lex_state = 10},
  [3006] = {.lex_state = 293, .external_lex_state = 23},
  [3007] = {.lex_state = 293, .external_lex_state = 23},
  [3008] = {.lex_state = 293, .external_lex_state = 23},
  [3009] = {.lex_state = 281, .external_lex_state = 3},
  [3010] = {.lex_state = 281, .external_lex_state = 14},
  [3011] = {.lex_state = 281, .external_lex_state = 14},
  [3012] = {.lex_state = 214, .external_lex_state = 22},
  [3013] = {.lex_state = 214, .external_lex_state = 22},
  [3014] = {.lex_state = 214, .external_lex_state = 16},
  [3015] = {.lex_state = 237, .external_lex_state = 16},
  [3016] = {.lex_state = 281, .external_lex_state = 14},
  [3017] = {.lex_state = 237, .external_lex_state = 16},
  [3018] = {.lex_state = 281, .external_lex_state = 14},
  [3019] = {.lex_state = 237, .external_lex_state = 16},
  [3020] = {.lex_state = 281, .external_lex_state = 14},
  [3021] = {.lex_state = 237, .external_lex_state = 16},
  [3022] = {.lex_state = 281, .external_lex_state = 14},
  [3023] = {.lex_state = 237, .external_lex_state = 16},
  [3024] = {.lex_state = 281, .external_lex_state = 14},
  [3025] = {.lex_state = 237, .external_lex_state = 16},
  [3026] = {.lex_state = 281, .external_lex_state = 14},
  [3027] = {.lex_state = 281, .external_lex_state = 14},
  [3028] = {.lex_state = 281, .external_lex_state = 10},
  [3029] = {.lex_state = 281, .external_lex_state = 10},
  [3030] = {.lex_state = 214, .external_lex_state = 22},
  [3031] = {.lex_state = 214, .external_lex_state = 22},
  [3032] = {.lex_state = 214, .external_lex_state = 16},
  [3033] = {.lex_state = 237, .external_lex_state = 16},
  [3034] = {.lex_state = 281, .external_lex_state = 10},
  [3035] = {.lex_state = 237, .external_lex_state = 16},
  [3036] = {.lex_state = 281, .external_lex_state = 10},
  [3037] = {.lex_state = 237, .external_lex_state = 16},
  [3038] = {.lex_state = 281, .external_lex_state = 10},
  [3039] = {.lex_state = 237, .external_lex_state = 16},
  [3040] = {.lex_state = 281, .external_lex_state = 10},
  [3041] = {.lex_state = 237, .external_lex_state = 16},
  [3042] = {.lex_state = 281, .external_lex_state = 10},
  [3043] = {.lex_state = 237, .external_lex_state = 16},
  [3044] = {.lex_state = 281, .external_lex_state = 10},
  [3045] = {.lex_state = 281, .external_lex_state = 10},
  [3046] = {.lex_state = 287, .external_lex_state = 5},
  [3047] = {.lex_state = 287, .external_lex_state = 5},
  [3048] = {.lex_state = 287, .external_lex_state = 5},
  [3049] = {.lex_state = 237, .external_lex_state = 16},
  [3050] = {.lex_state = 287, .external_lex_state = 5},
  [3051] = {.lex_state = 237, .external_lex_state = 16},
  [3052] = {.lex_state = 287, .external_lex_state = 5},
  [3053] = {.lex_state = 237, .external_lex_state = 16},
  [3054] = {.lex_state = 287, .external_lex_state = 5},
  [3055] = {.lex_state = 287, .external_lex_state = 5},
  [3056] = {.lex_state = 287, .external_lex_state = 5},
  [3057] = {.lex_state = 293, .external_lex_state = 5},
  [3058] = {.lex_state = 293, .external_lex_state = 5},
  [3059] = {.lex_state = 214, .external_lex_state = 22},
  [3060] = {.lex_state = 214, .external_lex_state = 22},
  [3061] = {.lex_state = 214, .external_lex_state = 16},
  [3062] = {.lex_state = 235, .external_lex_state = 16},
  [3063] = {.lex_state = 293, .external_lex_state = 5},
  [3064] = {.lex_state = 239},
  [3065] = {.lex_state = 237, .external_lex_state = 16},
  [3066] = {.lex_state = 293, .external_lex_state = 5},
  [3067] = {.lex_state = 239},
  [3068] = {.lex_state = 237, .external_lex_state = 16},
  [3069] = {.lex_state = 239},
  [3070] = {.lex_state = 237, .external_lex_state = 16},
  [3071] = {.lex_state = 237, .external_lex_state = 16},
  [3072] = {.lex_state = 293, .external_lex_state = 5},
  [3073] = {.lex_state = 237, .external_lex_state = 16},
  [3074] = {.lex_state = 293, .external_lex_state = 5},
  [3075] = {.lex_state = 237, .external_lex_state = 16},
  [3076] = {.lex_state = 293, .external_lex_state = 5},
  [3077] = {.lex_state = 219, .external_lex_state = 2},
  [3078] = {.lex_state = 63, .external_lex_state = 2},
  [3079] = {.lex_state = 293, .external_lex_state = 5},
  [3080] = {.lex_state = 219, .external_lex_state = 2},
  [3081] = {.lex_state = 175, .external_lex_state = 2},
  [3082] = {.lex_state = 175, .external_lex_state = 2},
  [3083] = {.lex_state = 291, .external_lex_state = 19},
  [3084] = {.lex_state = 291, .external_lex_state = 19},
  [3085] = {.lex_state = 214, .external_lex_state = 22},
  [3086] = {.lex_state = 214, .external_lex_state = 22},
  [3087] = {.lex_state = 214, .external_lex_state = 16},
  [3088] = {.lex_state = 237, .external_lex_state = 16},
  [3089] = {.lex_state = 291, .external_lex_state = 19},
  [3090] = {.lex_state = 237, .external_lex_state = 16},
  [3091] = {.lex_state = 291, .external_lex_state = 19},
  [3092] = {.lex_state = 237, .external_lex_state = 16},
  [3093] = {.lex_state = 291, .external_lex_state = 19},
  [3094] = {.lex_state = 237, .external_lex_state = 16},
  [3095] = {.lex_state = 291, .external_lex_state = 19},
  [3096] = {.lex_state = 237, .external_lex_state = 16},
  [3097] = {.lex_state = 291, .external_lex_state = 19},
  [3098] = {.lex_state = 237, .external_lex_state = 16},
  [3099] = {.lex_state = 291, .external_lex_state = 19},
  [3100] = {.lex_state = 291, .external_lex_state = 19},
  [3101] = {.lex_state = 275, .external_lex_state = 10},
  [3102] = {.lex_state = 293, .external_lex_state = 23},
  [3103] = {.lex_state = 281, .external_lex_state = 14},
  [3104] = {.lex_state = 281, .external_lex_state = 14},
  [3105] = {.lex_state = 281, .external_lex_state = 14},
  [3106] = {.lex_state = 237, .external_lex_state = 16},
  [3107] = {.lex_state = 281, .external_lex_state = 14},
  [3108] = {.lex_state = 237, .external_lex_state = 16},
  [3109] = {.lex_state = 281, .external_lex_state = 14},
  [3110] = {.lex_state = 237, .external_lex_state = 16},
  [3111] = {.lex_state = 281, .external_lex_state = 14},
  [3112] = {.lex_state = 281, .external_lex_state = 14},
  [3113] = {.lex_state = 281, .external_lex_state = 14},
  [3114] = {.lex_state = 281, .external_lex_state = 10},
  [3115] = {.lex_state = 281, .external_lex_state = 10},
  [3116] = {.lex_state = 281, .external_lex_state = 10},
  [3117] = {.lex_state = 237, .external_lex_state = 16},
  [3118] = {.lex_state = 281, .external_lex_state = 10},
  [3119] = {.lex_state = 237, .external_lex_state = 16},
  [3120] = {.lex_state = 281, .external_lex_state = 10},
  [3121] = {.lex_state = 237, .external_lex_state = 16},
  [3122] = {.lex_state = 281, .external_lex_state = 10},
  [3123] = {.lex_state = 281, .external_lex_state = 10},
  [3124] = {.lex_state = 281, .external_lex_state = 10},
  [3125] = {.lex_state = 287, .external_lex_state = 5},
  [3126] = {.lex_state = 287, .external_lex_state = 5},
  [3127] = {.lex_state = 287, .external_lex_state = 5},
  [3128] = {.lex_state = 293, .external_lex_state = 5},
  [3129] = {.lex_state = 293, .external_lex_state = 5},
  [3130] = {.lex_state = 214, .external_lex_state = 22},
  [3131] = {.lex_state = 214, .external_lex_state = 22},
  [3132] = {.lex_state = 214, .external_lex_state = 16},
  [3133] = {.lex_state = 237, .external_lex_state = 16},
  [3134] = {.lex_state = 293, .external_lex_state = 5},
  [3135] = {.lex_state = 237, .external_lex_state = 16},
  [3136] = {.lex_state = 293, .external_lex_state = 5},
  [3137] = {.lex_state = 237, .external_lex_state = 16},
  [3138] = {.lex_state = 293, .external_lex_state = 5},
  [3139] = {.lex_state = 237, .external_lex_state = 16},
  [3140] = {.lex_state = 293, .external_lex_state = 5},
  [3141] = {.lex_state = 237, .external_lex_state = 16},
  [3142] = {.lex_state = 293, .external_lex_state = 5},
  [3143] = {.lex_state = 237, .external_lex_state = 16},
  [3144] = {.lex_state = 293, .external_lex_state = 5},
  [3145] = {.lex_state = 293, .external_lex_state = 5},
  [3146] = {.lex_state = 291, .external_lex_state = 19},
  [3147] = {.lex_state = 291, .external_lex_state = 19},
  [3148] = {.lex_state = 291, .external_lex_state = 19},
  [3149] = {.lex_state = 237, .external_lex_state = 16},
  [3150] = {.lex_state = 291, .external_lex_state = 19},
  [3151] = {.lex_state = 237, .external_lex_state = 16},
  [3152] = {.lex_state = 291, .external_lex_state = 19},
  [3153] = {.lex_state = 237, .external_lex_state = 16},
  [3154] = {.lex_state = 291, .external_lex_state = 19},
  [3155] = {.lex_state = 291, .external_lex_state = 19},
  [3156] = {.lex_state = 291, .external_lex_state = 19},
  [3157] = {.lex_state = 281, .external_lex_state = 14},
  [3158] = {.lex_state = 281, .external_lex_state = 14},
  [3159] = {.lex_state = 281, .external_lex_state = 14},
  [3160] = {.lex_state = 281, .external_lex_state = 10},
  [3161] = {.lex_state = 281, .external_lex_state = 10},
  [3162] = {.lex_state = 281, .external_lex_state = 10},
  [3163] = {.lex_state = 293, .external_lex_state = 5},
  [3164] = {.lex_state = 293, .external_lex_state = 5},
  [3165] = {.lex_state = 293, .external_lex_state = 5},
  [3166] = {.lex_state = 237, .external_lex_state = 16},
  [3167] = {.lex_state = 293, .external_lex_state = 5},
  [3168] = {.lex_state = 237, .external_lex_state = 16},
  [3169] = {.lex_state = 293, .external_lex_state = 5},
  [3170] = {.lex_state = 237, .external_lex_state = 16},
  [3171] = {.lex_state = 293, .external_lex_state = 5},
  [3172] = {.lex_state = 293, .external_lex_state = 5},
  [3173] = {.lex_state = 293, .external_lex_state = 5},
  [3174] = {.lex_state = 291, .external_lex_state = 19},
  [3175] = {.lex_state = 291, .external_lex_state = 19},
  [3176] = {.lex_state = 291, .external_lex_state = 19},
  [3177] = {.lex_state = 293, .external_lex_state = 5},
  [3178] = {.lex_state = 293, .external_lex_state = 5},
  [3179] = {.lex_state = 293, .external_lex_state = 5},
};

enum {
  ts_external_token_heredoc_start,
  ts_external_token__simple_heredoc_body,
  ts_external_token__heredoc_body_beginning,
  ts_external_token__heredoc_body_middle,
  ts_external_token__heredoc_body_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_RBRACE,
  ts_external_token_RBRACK,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[24][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_LF] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token_variable_name] = true,
  },
  [7] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [9] = {
    [ts_external_token__empty_value] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [11] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [12] = {
    [ts_external_token_RBRACK] = true,
  },
  [13] = {
    [ts_external_token__concat] = true,
  },
  [14] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [16] = {
    [ts_external_token_RBRACE] = true,
  },
  [17] = {
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
  },
  [18] = {
    [ts_external_token_heredoc_start] = true,
  },
  [19] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [20] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [21] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [22] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [23] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_start] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_done] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_fi] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_esac] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_typeset] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(3),
    [anon_sym_unsetenv] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [sym__special_characters] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(25),
    [sym__terminated_statement] = STATE(32),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(32),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(57),
    [anon_sym_GT] = ACTIONS(57),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_AMP_GT] = ACTIONS(57),
    [anon_sym_AMP_GT_GT] = ACTIONS(59),
    [anon_sym_LT_AMP] = ACTIONS(59),
    [anon_sym_GT_AMP] = ACTIONS(59),
    [sym_comment] = ACTIONS(53),
  },
  [3] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(63),
    [anon_sym_PLUS_EQ] = ACTIONS(63),
    [sym_comment] = ACTIONS(53),
  },
  [4] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(65),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(67),
  },
  [5] = {
    [sym__terminated_statement] = STATE(39),
    [sym_for_statement] = STATE(40),
    [sym_c_style_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_subshell] = STATE(40),
    [sym_pipeline] = STATE(40),
    [sym_list] = STATE(40),
    [sym_negated_command] = STATE(40),
    [sym_test_command] = STATE(40),
    [sym_declaration_command] = STATE(40),
    [sym_unset_command] = STATE(40),
    [sym_command] = STATE(40),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(41),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [6] = {
    [sym__terminated_statement] = STATE(42),
    [sym_for_statement] = STATE(40),
    [sym_c_style_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_subshell] = STATE(40),
    [sym_pipeline] = STATE(40),
    [sym_list] = STATE(40),
    [sym_negated_command] = STATE(40),
    [sym_test_command] = STATE(40),
    [sym_declaration_command] = STATE(40),
    [sym_unset_command] = STATE(40),
    [sym_command] = STATE(40),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(41),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [7] = {
    [sym_concatenation] = STATE(51),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [sym__special_characters] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [anon_sym_DOLLAR] = ACTIONS(73),
    [sym_raw_string] = ACTIONS(75),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(77),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(79),
    [anon_sym_BQUOTE] = ACTIONS(81),
    [anon_sym_LT_LPAREN] = ACTIONS(83),
    [anon_sym_GT_LPAREN] = ACTIONS(83),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(75),
  },
  [8] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(85),
  },
  [9] = {
    [sym__terminated_statement] = STATE(68),
    [sym_for_statement] = STATE(64),
    [sym_c_style_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_if_statement] = STATE(64),
    [sym_case_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_pipeline] = STATE(64),
    [sym_list] = STATE(64),
    [sym_negated_command] = STATE(64),
    [sym_test_command] = STATE(64),
    [sym_declaration_command] = STATE(64),
    [sym_unset_command] = STATE(64),
    [sym_command] = STATE(64),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(66),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(68),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [10] = {
    [sym_subshell] = STATE(71),
    [sym_test_command] = STATE(71),
    [sym_command] = STATE(71),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(72),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(43),
  },
  [11] = {
    [sym__expression] = STATE(83),
    [sym_binary_expression] = STATE(83),
    [sym_unary_expression] = STATE(83),
    [sym_parenthesized_expression] = STATE(83),
    [sym_concatenation] = STATE(83),
    [sym_string] = STATE(78),
    [sym_simple_expansion] = STATE(78),
    [sym_string_expansion] = STATE(78),
    [sym_expansion] = STATE(78),
    [sym_command_substitution] = STATE(78),
    [sym_process_substitution] = STATE(78),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [sym__special_characters] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(131),
    [sym_test_operator] = ACTIONS(133),
  },
  [12] = {
    [sym__expression] = STATE(94),
    [sym_binary_expression] = STATE(94),
    [sym_unary_expression] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_concatenation] = STATE(94),
    [sym_string] = STATE(89),
    [sym_simple_expansion] = STATE(89),
    [sym_string_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [sym_process_substitution] = STATE(89),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [sym__special_characters] = ACTIONS(139),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(155),
    [sym_test_operator] = ACTIONS(157),
  },
  [13] = {
    [sym_variable_assignment] = STATE(106),
    [sym_subscript] = STATE(105),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(99),
    [sym_simple_expansion] = STATE(99),
    [sym_string_expansion] = STATE(99),
    [sym_expansion] = STATE(99),
    [sym_command_substitution] = STATE(99),
    [sym_process_substitution] = STATE(99),
    [aux_sym_declaration_command_repeat1] = STATE(106),
    [sym_variable_name] = ACTIONS(159),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_SEMI_SEMI] = ACTIONS(163),
    [anon_sym_PIPE_AMP] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [sym__special_characters] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(169),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(181),
    [sym_word] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_LF] = ACTIONS(163),
    [anon_sym_AMP] = ACTIONS(161),
  },
  [14] = {
    [sym_concatenation] = STATE(116),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_string_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_unset_command_repeat1] = STATE(116),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym__special_characters] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(195),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(205),
    [sym_word] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_LF] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [15] = {
    [sym_concatenation] = STATE(125),
    [sym_string] = STATE(120),
    [sym_simple_expansion] = STATE(120),
    [sym_string_expansion] = STATE(120),
    [sym_expansion] = STATE(120),
    [sym_command_substitution] = STATE(120),
    [sym_process_substitution] = STATE(120),
    [sym__special_characters] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(213),
    [sym_raw_string] = ACTIONS(215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(223),
    [anon_sym_GT_LPAREN] = ACTIONS(223),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(215),
  },
  [16] = {
    [aux_sym_concatenation_repeat1] = STATE(127),
    [sym__simple_heredoc_body] = ACTIONS(225),
    [sym__heredoc_body_beginning] = ACTIONS(225),
    [sym_file_descriptor] = ACTIONS(225),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(229),
    [anon_sym_SEMI_SEMI] = ACTIONS(225),
    [anon_sym_PIPE_AMP] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_EQ_TILDE] = ACTIONS(229),
    [anon_sym_EQ_EQ] = ACTIONS(229),
    [anon_sym_LT] = ACTIONS(229),
    [anon_sym_GT] = ACTIONS(229),
    [anon_sym_GT_GT] = ACTIONS(225),
    [anon_sym_AMP_GT] = ACTIONS(229),
    [anon_sym_AMP_GT_GT] = ACTIONS(225),
    [anon_sym_LT_AMP] = ACTIONS(225),
    [anon_sym_GT_AMP] = ACTIONS(225),
    [anon_sym_LT_LT] = ACTIONS(229),
    [anon_sym_LT_LT_DASH] = ACTIONS(225),
    [anon_sym_LT_LT_LT] = ACTIONS(225),
    [sym__special_characters] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(229),
    [anon_sym_LF] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(229),
  },
  [17] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(134),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [18] = {
    [sym_string] = STATE(136),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_POUND] = ACTIONS(245),
    [anon_sym_DASH] = ACTIONS(245),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(249),
    [anon_sym_STAR] = ACTIONS(245),
    [anon_sym_AT] = ACTIONS(245),
    [anon_sym_QMARK] = ACTIONS(245),
    [anon_sym_0] = ACTIONS(251),
    [anon_sym__] = ACTIONS(251),
  },
  [19] = {
    [aux_sym_concatenation_repeat1] = STATE(127),
    [sym__simple_heredoc_body] = ACTIONS(253),
    [sym__heredoc_body_beginning] = ACTIONS(253),
    [sym_file_descriptor] = ACTIONS(253),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(255),
    [anon_sym_SEMI_SEMI] = ACTIONS(253),
    [anon_sym_PIPE_AMP] = ACTIONS(253),
    [anon_sym_AMP_AMP] = ACTIONS(253),
    [anon_sym_PIPE_PIPE] = ACTIONS(253),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(255),
    [anon_sym_GT] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(253),
    [anon_sym_AMP_GT] = ACTIONS(255),
    [anon_sym_AMP_GT_GT] = ACTIONS(253),
    [anon_sym_LT_AMP] = ACTIONS(253),
    [anon_sym_GT_AMP] = ACTIONS(253),
    [anon_sym_LT_LT] = ACTIONS(255),
    [anon_sym_LT_LT_DASH] = ACTIONS(253),
    [anon_sym_LT_LT_LT] = ACTIONS(253),
    [sym__special_characters] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(255),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(253),
    [anon_sym_LT_LPAREN] = ACTIONS(253),
    [anon_sym_GT_LPAREN] = ACTIONS(253),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LF] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(255),
  },
  [20] = {
    [sym_subscript] = STATE(142),
    [sym_variable_name] = ACTIONS(257),
    [anon_sym_BANG] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_POUND] = ACTIONS(259),
    [anon_sym_DASH] = ACTIONS(261),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_0] = ACTIONS(265),
    [anon_sym__] = ACTIONS(265),
  },
  [21] = {
    [sym__terminated_statement] = STATE(145),
    [sym_for_statement] = STATE(143),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_if_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(145),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [22] = {
    [sym__terminated_statement] = STATE(157),
    [sym_for_statement] = STATE(154),
    [sym_c_style_for_statement] = STATE(154),
    [sym_while_statement] = STATE(154),
    [sym_if_statement] = STATE(154),
    [sym_case_statement] = STATE(154),
    [sym_function_definition] = STATE(154),
    [sym_subshell] = STATE(154),
    [sym_pipeline] = STATE(154),
    [sym_list] = STATE(154),
    [sym_negated_command] = STATE(154),
    [sym_test_command] = STATE(154),
    [sym_declaration_command] = STATE(154),
    [sym_unset_command] = STATE(154),
    [sym_command] = STATE(154),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(156),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(157),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [23] = {
    [sym__terminated_statement] = STATE(161),
    [sym_for_statement] = STATE(159),
    [sym_c_style_for_statement] = STATE(159),
    [sym_while_statement] = STATE(159),
    [sym_if_statement] = STATE(159),
    [sym_case_statement] = STATE(159),
    [sym_function_definition] = STATE(159),
    [sym_subshell] = STATE(159),
    [sym_pipeline] = STATE(159),
    [sym_list] = STATE(159),
    [sym_negated_command] = STATE(159),
    [sym_test_command] = STATE(159),
    [sym_declaration_command] = STATE(159),
    [sym_unset_command] = STATE(159),
    [sym_command] = STATE(159),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(160),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(161),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [24] = {
    [aux_sym_concatenation_repeat1] = STATE(127),
    [sym__simple_heredoc_body] = ACTIONS(253),
    [sym__heredoc_body_beginning] = ACTIONS(253),
    [sym_file_descriptor] = ACTIONS(253),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(255),
    [anon_sym_SEMI_SEMI] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(283),
    [anon_sym_PIPE_AMP] = ACTIONS(253),
    [anon_sym_AMP_AMP] = ACTIONS(253),
    [anon_sym_PIPE_PIPE] = ACTIONS(253),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(255),
    [anon_sym_GT] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(253),
    [anon_sym_AMP_GT] = ACTIONS(255),
    [anon_sym_AMP_GT_GT] = ACTIONS(253),
    [anon_sym_LT_AMP] = ACTIONS(253),
    [anon_sym_GT_AMP] = ACTIONS(253),
    [anon_sym_LT_LT] = ACTIONS(255),
    [anon_sym_LT_LT_DASH] = ACTIONS(253),
    [anon_sym_LT_LT_LT] = ACTIONS(253),
    [sym__special_characters] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(255),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(253),
    [anon_sym_LT_LPAREN] = ACTIONS(253),
    [anon_sym_GT_LPAREN] = ACTIONS(253),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LF] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(255),
  },
  [25] = {
    [ts_builtin_sym_end] = ACTIONS(285),
    [sym_comment] = ACTIONS(53),
  },
  [26] = {
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(289),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [27] = {
    [sym_file_redirect] = STATE(176),
    [sym_heredoc_redirect] = STATE(176),
    [sym_heredoc_body] = STATE(175),
    [sym_herestring_redirect] = STATE(176),
    [sym_concatenation] = STATE(177),
    [sym_string] = STATE(174),
    [sym_simple_expansion] = STATE(174),
    [sym_string_expansion] = STATE(174),
    [sym_expansion] = STATE(174),
    [sym_command_substitution] = STATE(174),
    [sym_process_substitution] = STATE(174),
    [aux_sym_while_statement_repeat1] = STATE(176),
    [aux_sym_command_repeat2] = STATE(177),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_SEMI_SEMI] = ACTIONS(305),
    [anon_sym_PIPE_AMP] = ACTIONS(305),
    [anon_sym_AMP_AMP] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(305),
    [anon_sym_EQ_TILDE] = ACTIONS(307),
    [anon_sym_EQ_EQ] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(309),
    [anon_sym_GT_GT] = ACTIONS(311),
    [anon_sym_AMP_GT] = ACTIONS(309),
    [anon_sym_AMP_GT_GT] = ACTIONS(311),
    [anon_sym_LT_AMP] = ACTIONS(311),
    [anon_sym_GT_AMP] = ACTIONS(311),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_LF] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(303),
  },
  [28] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(289),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [29] = {
    [anon_sym_EQ] = ACTIONS(63),
    [anon_sym_PLUS_EQ] = ACTIONS(63),
    [sym_comment] = ACTIONS(53),
  },
  [30] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(325),
  },
  [31] = {
    [sym__simple_heredoc_body] = ACTIONS(253),
    [sym__heredoc_body_beginning] = ACTIONS(253),
    [sym_file_descriptor] = ACTIONS(253),
    [anon_sym_PIPE] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(253),
    [anon_sym_SEMI_SEMI] = ACTIONS(253),
    [anon_sym_PIPE_AMP] = ACTIONS(253),
    [anon_sym_AMP_AMP] = ACTIONS(253),
    [anon_sym_PIPE_PIPE] = ACTIONS(253),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(255),
    [anon_sym_GT] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(253),
    [anon_sym_AMP_GT] = ACTIONS(255),
    [anon_sym_AMP_GT_GT] = ACTIONS(253),
    [anon_sym_LT_AMP] = ACTIONS(253),
    [anon_sym_GT_AMP] = ACTIONS(253),
    [anon_sym_LT_LT] = ACTIONS(255),
    [anon_sym_LT_LT_DASH] = ACTIONS(253),
    [anon_sym_LT_LT_LT] = ACTIONS(253),
    [sym__special_characters] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(255),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(253),
    [anon_sym_LT_LPAREN] = ACTIONS(253),
    [anon_sym_GT_LPAREN] = ACTIONS(253),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LF] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(255),
  },
  [32] = {
    [sym__terminated_statement] = STATE(178),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(178),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [33] = {
    [sym_command_name] = STATE(179),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(72),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(180),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(331),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(43),
  },
  [34] = {
    [sym_concatenation] = STATE(183),
    [sym_string] = STATE(182),
    [sym_simple_expansion] = STATE(182),
    [sym_string_expansion] = STATE(182),
    [sym_expansion] = STATE(182),
    [sym_command_substitution] = STATE(182),
    [sym_process_substitution] = STATE(182),
    [sym__special_characters] = ACTIONS(333),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(213),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(223),
    [anon_sym_GT_LPAREN] = ACTIONS(223),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(335),
  },
  [35] = {
    [sym_concatenation] = STATE(186),
    [sym_string] = STATE(185),
    [sym_simple_expansion] = STATE(185),
    [sym_string_expansion] = STATE(185),
    [sym_expansion] = STATE(185),
    [sym_command_substitution] = STATE(185),
    [sym_process_substitution] = STATE(185),
    [sym__special_characters] = ACTIONS(337),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(339),
  },
  [36] = {
    [sym_concatenation] = STATE(187),
    [sym_string] = STATE(192),
    [sym_array] = STATE(187),
    [sym_simple_expansion] = STATE(192),
    [sym_string_expansion] = STATE(192),
    [sym_expansion] = STATE(192),
    [sym_command_substitution] = STATE(192),
    [sym_process_substitution] = STATE(192),
    [sym__empty_value] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [sym__special_characters] = ACTIONS(345),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR] = ACTIONS(349),
    [sym_raw_string] = ACTIONS(351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(355),
    [anon_sym_BQUOTE] = ACTIONS(357),
    [anon_sym_LT_LPAREN] = ACTIONS(359),
    [anon_sym_GT_LPAREN] = ACTIONS(359),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
  },
  [37] = {
    [sym__expression] = STATE(208),
    [sym_binary_expression] = STATE(208),
    [sym_unary_expression] = STATE(208),
    [sym_parenthesized_expression] = STATE(208),
    [sym_concatenation] = STATE(208),
    [sym_string] = STATE(203),
    [sym_simple_expansion] = STATE(203),
    [sym_string_expansion] = STATE(203),
    [sym_expansion] = STATE(203),
    [sym_command_substitution] = STATE(203),
    [sym_process_substitution] = STATE(203),
    [anon_sym_SEMI_SEMI] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_BANG] = ACTIONS(365),
    [sym__special_characters] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(383),
    [sym_test_operator] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(387),
    [anon_sym_LF] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
  },
  [38] = {
    [anon_sym_in] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(391),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(393),
    [anon_sym_LF] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
  },
  [39] = {
    [sym_do_group] = STATE(212),
    [anon_sym_do] = ACTIONS(395),
    [sym_comment] = ACTIONS(53),
  },
  [40] = {
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(397),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(399),
    [anon_sym_LF] = ACTIONS(397),
    [anon_sym_AMP] = ACTIONS(399),
  },
  [41] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(397),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(399),
    [anon_sym_LF] = ACTIONS(397),
    [anon_sym_AMP] = ACTIONS(399),
  },
  [42] = {
    [anon_sym_then] = ACTIONS(401),
    [sym_comment] = ACTIONS(53),
  },
  [43] = {
    [aux_sym_concatenation_repeat1] = STATE(218),
    [sym__concat] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(407),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(407),
  },
  [44] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(221),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [anon_sym_DOLLAR] = ACTIONS(413),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [45] = {
    [sym_string] = STATE(223),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(417),
    [anon_sym_POUND] = ACTIONS(415),
    [anon_sym_DASH] = ACTIONS(415),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(415),
    [anon_sym_0] = ACTIONS(421),
    [anon_sym__] = ACTIONS(421),
  },
  [46] = {
    [aux_sym_concatenation_repeat1] = STATE(218),
    [sym__concat] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(425),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_LF] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
  },
  [47] = {
    [sym_subscript] = STATE(231),
    [sym_variable_name] = ACTIONS(429),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_DOLLAR] = ACTIONS(433),
    [anon_sym_POUND] = ACTIONS(431),
    [anon_sym_DASH] = ACTIONS(433),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(435),
    [anon_sym_STAR] = ACTIONS(433),
    [anon_sym_AT] = ACTIONS(433),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_0] = ACTIONS(437),
    [anon_sym__] = ACTIONS(437),
  },
  [48] = {
    [sym__terminated_statement] = STATE(234),
    [sym_for_statement] = STATE(232),
    [sym_c_style_for_statement] = STATE(232),
    [sym_while_statement] = STATE(232),
    [sym_if_statement] = STATE(232),
    [sym_case_statement] = STATE(232),
    [sym_function_definition] = STATE(232),
    [sym_subshell] = STATE(232),
    [sym_pipeline] = STATE(232),
    [sym_list] = STATE(232),
    [sym_negated_command] = STATE(232),
    [sym_test_command] = STATE(232),
    [sym_declaration_command] = STATE(232),
    [sym_unset_command] = STATE(232),
    [sym_command] = STATE(232),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(233),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(234),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [49] = {
    [sym__terminated_statement] = STATE(237),
    [sym_for_statement] = STATE(235),
    [sym_c_style_for_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_function_definition] = STATE(235),
    [sym_subshell] = STATE(235),
    [sym_pipeline] = STATE(235),
    [sym_list] = STATE(235),
    [sym_negated_command] = STATE(235),
    [sym_test_command] = STATE(235),
    [sym_declaration_command] = STATE(235),
    [sym_unset_command] = STATE(235),
    [sym_command] = STATE(235),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(236),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(237),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [50] = {
    [sym__terminated_statement] = STATE(240),
    [sym_for_statement] = STATE(238),
    [sym_c_style_for_statement] = STATE(238),
    [sym_while_statement] = STATE(238),
    [sym_if_statement] = STATE(238),
    [sym_case_statement] = STATE(238),
    [sym_function_definition] = STATE(238),
    [sym_subshell] = STATE(238),
    [sym_pipeline] = STATE(238),
    [sym_list] = STATE(238),
    [sym_negated_command] = STATE(238),
    [sym_test_command] = STATE(238),
    [sym_declaration_command] = STATE(238),
    [sym_unset_command] = STATE(238),
    [sym_command] = STATE(238),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(239),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(240),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [51] = {
    [anon_sym_in] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(425),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_LF] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
  },
  [52] = {
    [sym_compound_statement] = STATE(243),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [53] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_PLUS_EQ] = ACTIONS(443),
    [sym_comment] = ACTIONS(53),
  },
  [54] = {
    [sym__terminated_statement] = STATE(245),
    [sym_for_statement] = STATE(40),
    [sym_c_style_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_subshell] = STATE(40),
    [sym_pipeline] = STATE(40),
    [sym_list] = STATE(40),
    [sym_negated_command] = STATE(40),
    [sym_test_command] = STATE(40),
    [sym_declaration_command] = STATE(40),
    [sym_unset_command] = STATE(40),
    [sym_command] = STATE(40),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(41),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [55] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(445),
  },
  [56] = {
    [sym_subshell] = STATE(71),
    [sym_test_command] = STATE(71),
    [sym_command] = STATE(71),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(72),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [57] = {
    [sym__expression] = STATE(247),
    [sym_binary_expression] = STATE(247),
    [sym_unary_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_concatenation] = STATE(247),
    [sym_string] = STATE(78),
    [sym_simple_expansion] = STATE(78),
    [sym_string_expansion] = STATE(78),
    [sym_expansion] = STATE(78),
    [sym_command_substitution] = STATE(78),
    [sym_process_substitution] = STATE(78),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [sym__special_characters] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(131),
    [sym_test_operator] = ACTIONS(133),
  },
  [58] = {
    [sym__expression] = STATE(248),
    [sym_binary_expression] = STATE(248),
    [sym_unary_expression] = STATE(248),
    [sym_parenthesized_expression] = STATE(248),
    [sym_concatenation] = STATE(248),
    [sym_string] = STATE(89),
    [sym_simple_expansion] = STATE(89),
    [sym_string_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [sym_process_substitution] = STATE(89),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [sym__special_characters] = ACTIONS(139),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(155),
    [sym_test_operator] = ACTIONS(157),
  },
  [59] = {
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(252),
    [sym_concatenation] = STATE(253),
    [sym_string] = STATE(251),
    [sym_simple_expansion] = STATE(251),
    [sym_string_expansion] = STATE(251),
    [sym_expansion] = STATE(251),
    [sym_command_substitution] = STATE(251),
    [sym_process_substitution] = STATE(251),
    [aux_sym_declaration_command_repeat1] = STATE(253),
    [sym_variable_name] = ACTIONS(447),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_SEMI_SEMI] = ACTIONS(163),
    [anon_sym_PIPE_AMP] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [sym__special_characters] = ACTIONS(449),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(169),
    [sym_raw_string] = ACTIONS(451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(181),
    [sym_word] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_LF] = ACTIONS(163),
    [anon_sym_AMP] = ACTIONS(161),
  },
  [60] = {
    [sym_concatenation] = STATE(256),
    [sym_string] = STATE(255),
    [sym_simple_expansion] = STATE(255),
    [sym_string_expansion] = STATE(255),
    [sym_expansion] = STATE(255),
    [sym_command_substitution] = STATE(255),
    [sym_process_substitution] = STATE(255),
    [aux_sym_unset_command_repeat1] = STATE(256),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_RPAREN] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym__special_characters] = ACTIONS(455),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(205),
    [sym_word] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_LF] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [61] = {
    [aux_sym_concatenation_repeat1] = STATE(257),
    [sym__simple_heredoc_body] = ACTIONS(225),
    [sym__heredoc_body_beginning] = ACTIONS(225),
    [sym_file_descriptor] = ACTIONS(225),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(229),
    [anon_sym_RPAREN] = ACTIONS(225),
    [anon_sym_SEMI_SEMI] = ACTIONS(225),
    [anon_sym_PIPE_AMP] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_EQ_TILDE] = ACTIONS(229),
    [anon_sym_EQ_EQ] = ACTIONS(229),
    [anon_sym_LT] = ACTIONS(229),
    [anon_sym_GT] = ACTIONS(229),
    [anon_sym_GT_GT] = ACTIONS(225),
    [anon_sym_AMP_GT] = ACTIONS(229),
    [anon_sym_AMP_GT_GT] = ACTIONS(225),
    [anon_sym_LT_AMP] = ACTIONS(225),
    [anon_sym_GT_AMP] = ACTIONS(225),
    [anon_sym_LT_LT] = ACTIONS(229),
    [anon_sym_LT_LT_DASH] = ACTIONS(225),
    [anon_sym_LT_LT_LT] = ACTIONS(225),
    [sym__special_characters] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(229),
    [anon_sym_LF] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(229),
  },
  [62] = {
    [aux_sym_concatenation_repeat1] = STATE(257),
    [sym__simple_heredoc_body] = ACTIONS(253),
    [sym__heredoc_body_beginning] = ACTIONS(253),
    [sym_file_descriptor] = ACTIONS(253),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(253),
    [anon_sym_SEMI_SEMI] = ACTIONS(253),
    [anon_sym_PIPE_AMP] = ACTIONS(253),
    [anon_sym_AMP_AMP] = ACTIONS(253),
    [anon_sym_PIPE_PIPE] = ACTIONS(253),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(255),
    [anon_sym_GT] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(253),
    [anon_sym_AMP_GT] = ACTIONS(255),
    [anon_sym_AMP_GT_GT] = ACTIONS(253),
    [anon_sym_LT_AMP] = ACTIONS(253),
    [anon_sym_GT_AMP] = ACTIONS(253),
    [anon_sym_LT_LT] = ACTIONS(255),
    [anon_sym_LT_LT_DASH] = ACTIONS(253),
    [anon_sym_LT_LT_LT] = ACTIONS(253),
    [sym__special_characters] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(255),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(253),
    [anon_sym_LT_LPAREN] = ACTIONS(253),
    [anon_sym_GT_LPAREN] = ACTIONS(253),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LF] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(255),
  },
  [63] = {
    [aux_sym_concatenation_repeat1] = STATE(257),
    [sym__simple_heredoc_body] = ACTIONS(253),
    [sym__heredoc_body_beginning] = ACTIONS(253),
    [sym_file_descriptor] = ACTIONS(253),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(253),
    [anon_sym_SEMI_SEMI] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(253),
    [anon_sym_AMP_AMP] = ACTIONS(253),
    [anon_sym_PIPE_PIPE] = ACTIONS(253),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(255),
    [anon_sym_GT] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(253),
    [anon_sym_AMP_GT] = ACTIONS(255),
    [anon_sym_AMP_GT_GT] = ACTIONS(253),
    [anon_sym_LT_AMP] = ACTIONS(253),
    [anon_sym_GT_AMP] = ACTIONS(253),
    [anon_sym_LT_LT] = ACTIONS(255),
    [anon_sym_LT_LT_DASH] = ACTIONS(253),
    [anon_sym_LT_LT_LT] = ACTIONS(253),
    [sym__special_characters] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(255),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(253),
    [anon_sym_LT_LPAREN] = ACTIONS(253),
    [anon_sym_GT_LPAREN] = ACTIONS(253),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LF] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(255),
  },
  [64] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(467),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_LF] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(473),
  },
  [65] = {
    [sym_file_redirect] = STATE(269),
    [sym_heredoc_redirect] = STATE(269),
    [sym_heredoc_body] = STATE(175),
    [sym_herestring_redirect] = STATE(269),
    [sym_concatenation] = STATE(270),
    [sym_string] = STATE(268),
    [sym_simple_expansion] = STATE(268),
    [sym_string_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [aux_sym_while_statement_repeat1] = STATE(269),
    [aux_sym_command_repeat2] = STATE(270),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_RPAREN] = ACTIONS(305),
    [anon_sym_SEMI_SEMI] = ACTIONS(305),
    [anon_sym_PIPE_AMP] = ACTIONS(305),
    [anon_sym_AMP_AMP] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(305),
    [anon_sym_EQ_TILDE] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(483),
    [sym__special_characters] = ACTIONS(485),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(489),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_LF] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(303),
  },
  [66] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(467),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_LF] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(473),
  },
  [67] = {
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_PLUS_EQ] = ACTIONS(443),
    [sym_comment] = ACTIONS(53),
  },
  [68] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(271),
    [sym_c_style_for_statement] = STATE(271),
    [sym_while_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_case_statement] = STATE(271),
    [sym_function_definition] = STATE(271),
    [sym_subshell] = STATE(271),
    [sym_pipeline] = STATE(271),
    [sym_list] = STATE(271),
    [sym_negated_command] = STATE(271),
    [sym_test_command] = STATE(271),
    [sym_declaration_command] = STATE(271),
    [sym_unset_command] = STATE(271),
    [sym_command] = STATE(271),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(272),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [69] = {
    [sym_command_name] = STATE(274),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(72),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_command_repeat1] = STATE(180),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(491),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [70] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_PLUS_EQ] = ACTIONS(493),
    [sym_comment] = ACTIONS(53),
  },
  [71] = {
    [anon_sym_esac] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(497),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_SEMI_SEMI] = ACTIONS(495),
    [anon_sym_PIPE_AMP] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [anon_sym_BQUOTE] = ACTIONS(495),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(497),
    [anon_sym_LF] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(497),
  },
  [72] = {
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_PLUS_EQ] = ACTIONS(493),
    [sym_comment] = ACTIONS(53),
  },
  [73] = {
    [sym__expression] = STATE(279),
    [sym_binary_expression] = STATE(279),
    [sym_unary_expression] = STATE(279),
    [sym_parenthesized_expression] = STATE(279),
    [sym_concatenation] = STATE(279),
    [sym_string] = STATE(278),
    [sym_simple_expansion] = STATE(278),
    [sym_string_expansion] = STATE(278),
    [sym_expansion] = STATE(278),
    [sym_command_substitution] = STATE(278),
    [sym_process_substitution] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(499),
    [sym__special_characters] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(505),
    [sym_test_operator] = ACTIONS(507),
  },
  [74] = {
    [sym__expression] = STATE(280),
    [sym_binary_expression] = STATE(280),
    [sym_unary_expression] = STATE(280),
    [sym_parenthesized_expression] = STATE(280),
    [sym_concatenation] = STATE(280),
    [sym_string] = STATE(78),
    [sym_simple_expansion] = STATE(78),
    [sym_string_expansion] = STATE(78),
    [sym_expansion] = STATE(78),
    [sym_command_substitution] = STATE(78),
    [sym_process_substitution] = STATE(78),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [sym__special_characters] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(131),
    [sym_test_operator] = ACTIONS(133),
  },
  [75] = {
    [aux_sym_concatenation_repeat1] = STATE(282),
    [sym__concat] = ACTIONS(509),
    [anon_sym_AMP_AMP] = ACTIONS(511),
    [anon_sym_PIPE_PIPE] = ACTIONS(511),
    [anon_sym_RBRACK] = ACTIONS(511),
    [anon_sym_EQ_TILDE] = ACTIONS(511),
    [anon_sym_EQ_EQ] = ACTIONS(511),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(511),
  },
  [76] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(285),
    [anon_sym_DQUOTE] = ACTIONS(515),
    [anon_sym_DOLLAR] = ACTIONS(517),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [77] = {
    [sym_string] = STATE(287),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(521),
    [anon_sym_POUND] = ACTIONS(519),
    [anon_sym_DASH] = ACTIONS(519),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(523),
    [anon_sym_STAR] = ACTIONS(519),
    [anon_sym_AT] = ACTIONS(519),
    [anon_sym_QMARK] = ACTIONS(519),
    [anon_sym_0] = ACTIONS(525),
    [anon_sym__] = ACTIONS(525),
  },
  [78] = {
    [aux_sym_concatenation_repeat1] = STATE(282),
    [sym__concat] = ACTIONS(509),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_RBRACK] = ACTIONS(527),
    [anon_sym_EQ_TILDE] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(527),
  },
  [79] = {
    [sym_subscript] = STATE(293),
    [sym_variable_name] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(535),
    [anon_sym_POUND] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(537),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(535),
    [anon_sym_QMARK] = ACTIONS(535),
    [anon_sym_0] = ACTIONS(539),
    [anon_sym__] = ACTIONS(539),
  },
  [80] = {
    [sym__terminated_statement] = STATE(296),
    [sym_for_statement] = STATE(294),
    [sym_c_style_for_statement] = STATE(294),
    [sym_while_statement] = STATE(294),
    [sym_if_statement] = STATE(294),
    [sym_case_statement] = STATE(294),
    [sym_function_definition] = STATE(294),
    [sym_subshell] = STATE(294),
    [sym_pipeline] = STATE(294),
    [sym_list] = STATE(294),
    [sym_negated_command] = STATE(294),
    [sym_test_command] = STATE(294),
    [sym_declaration_command] = STATE(294),
    [sym_unset_command] = STATE(294),
    [sym_command] = STATE(294),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(295),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(296),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [81] = {
    [sym__terminated_statement] = STATE(299),
    [sym_for_statement] = STATE(297),
    [sym_c_style_for_statement] = STATE(297),
    [sym_while_statement] = STATE(297),
    [sym_if_statement] = STATE(297),
    [sym_case_statement] = STATE(297),
    [sym_function_definition] = STATE(297),
    [sym_subshell] = STATE(297),
    [sym_pipeline] = STATE(297),
    [sym_list] = STATE(297),
    [sym_negated_command] = STATE(297),
    [sym_test_command] = STATE(297),
    [sym_declaration_command] = STATE(297),
    [sym_unset_command] = STATE(297),
    [sym_command] = STATE(297),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(298),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(299),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [82] = {
    [sym__terminated_statement] = STATE(302),
    [sym_for_statement] = STATE(300),
    [sym_c_style_for_statement] = STATE(300),
    [sym_while_statement] = STATE(300),
    [sym_if_statement] = STATE(300),
    [sym_case_statement] = STATE(300),
    [sym_function_definition] = STATE(300),
    [sym_subshell] = STATE(300),
    [sym_pipeline] = STATE(300),
    [sym_list] = STATE(300),
    [sym_negated_command] = STATE(300),
    [sym_test_command] = STATE(300),
    [sym_declaration_command] = STATE(300),
    [sym_unset_command] = STATE(300),
    [sym_command] = STATE(300),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(301),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(302),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [83] = {
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(543),
    [anon_sym_EQ_TILDE] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_EQ] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(541),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(541),
  },
  [84] = {
    [sym__expression] = STATE(306),
    [sym_binary_expression] = STATE(306),
    [sym_unary_expression] = STATE(306),
    [sym_parenthesized_expression] = STATE(306),
    [sym_concatenation] = STATE(306),
    [sym_string] = STATE(278),
    [sym_simple_expansion] = STATE(278),
    [sym_string_expansion] = STATE(278),
    [sym_expansion] = STATE(278),
    [sym_command_substitution] = STATE(278),
    [sym_process_substitution] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(499),
    [sym__special_characters] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(505),
    [sym_test_operator] = ACTIONS(507),
  },
  [85] = {
    [sym__expression] = STATE(307),
    [sym_binary_expression] = STATE(307),
    [sym_unary_expression] = STATE(307),
    [sym_parenthesized_expression] = STATE(307),
    [sym_concatenation] = STATE(307),
    [sym_string] = STATE(89),
    [sym_simple_expansion] = STATE(89),
    [sym_string_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [sym_process_substitution] = STATE(89),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [sym__special_characters] = ACTIONS(139),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(155),
    [sym_test_operator] = ACTIONS(157),
  },
  [86] = {
    [aux_sym_concatenation_repeat1] = STATE(309),
    [sym__concat] = ACTIONS(549),
    [anon_sym_AMP_AMP] = ACTIONS(511),
    [anon_sym_PIPE_PIPE] = ACTIONS(511),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(511),
    [anon_sym_EQ_TILDE] = ACTIONS(511),
    [anon_sym_EQ_EQ] = ACTIONS(511),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(511),
  },
  [87] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(312),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(553),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [88] = {
    [sym_string] = STATE(314),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(557),
    [anon_sym_POUND] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(555),
    [anon_sym_AT] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_0] = ACTIONS(561),
    [anon_sym__] = ACTIONS(561),
  },
  [89] = {
    [aux_sym_concatenation_repeat1] = STATE(309),
    [sym__concat] = ACTIONS(549),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(527),
    [anon_sym_EQ_TILDE] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(527),
  },
  [90] = {
    [sym_subscript] = STATE(320),
    [sym_variable_name] = ACTIONS(563),
    [anon_sym_BANG] = ACTIONS(565),
    [anon_sym_DOLLAR] = ACTIONS(567),
    [anon_sym_POUND] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(567),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(567),
    [anon_sym_AT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(567),
    [anon_sym_0] = ACTIONS(571),
    [anon_sym__] = ACTIONS(571),
  },
  [91] = {
    [sym__terminated_statement] = STATE(323),
    [sym_for_statement] = STATE(321),
    [sym_c_style_for_statement] = STATE(321),
    [sym_while_statement] = STATE(321),
    [sym_if_statement] = STATE(321),
    [sym_case_statement] = STATE(321),
    [sym_function_definition] = STATE(321),
    [sym_subshell] = STATE(321),
    [sym_pipeline] = STATE(321),
    [sym_list] = STATE(321),
    [sym_negated_command] = STATE(321),
    [sym_test_command] = STATE(321),
    [sym_declaration_command] = STATE(321),
    [sym_unset_command] = STATE(321),
    [sym_command] = STATE(321),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(322),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(323),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [92] = {
    [sym__terminated_statement] = STATE(326),
    [sym_for_statement] = STATE(324),
    [sym_c_style_for_statement] = STATE(324),
    [sym_while_statement] = STATE(324),
    [sym_if_statement] = STATE(324),
    [sym_case_statement] = STATE(324),
    [sym_function_definition] = STATE(324),
    [sym_subshell] = STATE(324),
    [sym_pipeline] = STATE(324),
    [sym_list] = STATE(324),
    [sym_negated_command] = STATE(324),
    [sym_test_command] = STATE(324),
    [sym_declaration_command] = STATE(324),
    [sym_unset_command] = STATE(324),
    [sym_command] = STATE(324),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(325),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(326),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [93] = {
    [sym__terminated_statement] = STATE(329),
    [sym_for_statement] = STATE(327),
    [sym_c_style_for_statement] = STATE(327),
    [sym_while_statement] = STATE(327),
    [sym_if_statement] = STATE(327),
    [sym_case_statement] = STATE(327),
    [sym_function_definition] = STATE(327),
    [sym_subshell] = STATE(327),
    [sym_pipeline] = STATE(327),
    [sym_list] = STATE(327),
    [sym_negated_command] = STATE(327),
    [sym_test_command] = STATE(327),
    [sym_declaration_command] = STATE(327),
    [sym_unset_command] = STATE(327),
    [sym_command] = STATE(327),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(328),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(329),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [94] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(543),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [95] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(579),
    [sym_comment] = ACTIONS(53),
  },
  [96] = {
    [aux_sym_concatenation_repeat1] = STATE(334),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym__special_characters] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(585),
  },
  [97] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(337),
    [anon_sym_DQUOTE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [98] = {
    [sym_string] = STATE(339),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [sym_raw_string] = ACTIONS(593),
    [anon_sym_POUND] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(591),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(595),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [anon_sym_QMARK] = ACTIONS(591),
    [anon_sym_0] = ACTIONS(597),
    [anon_sym__] = ACTIONS(597),
  },
  [99] = {
    [aux_sym_concatenation_repeat1] = STATE(334),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(599),
    [anon_sym_PIPE_AMP] = ACTIONS(599),
    [anon_sym_AMP_AMP] = ACTIONS(599),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [sym__special_characters] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(599),
    [anon_sym_BQUOTE] = ACTIONS(599),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [100] = {
    [sym_subscript] = STATE(345),
    [sym_variable_name] = ACTIONS(603),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_DOLLAR] = ACTIONS(607),
    [anon_sym_POUND] = ACTIONS(605),
    [anon_sym_DASH] = ACTIONS(607),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(609),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(607),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_0] = ACTIONS(611),
    [anon_sym__] = ACTIONS(611),
  },
  [101] = {
    [sym__terminated_statement] = STATE(348),
    [sym_for_statement] = STATE(346),
    [sym_c_style_for_statement] = STATE(346),
    [sym_while_statement] = STATE(346),
    [sym_if_statement] = STATE(346),
    [sym_case_statement] = STATE(346),
    [sym_function_definition] = STATE(346),
    [sym_subshell] = STATE(346),
    [sym_pipeline] = STATE(346),
    [sym_list] = STATE(346),
    [sym_negated_command] = STATE(346),
    [sym_test_command] = STATE(346),
    [sym_declaration_command] = STATE(346),
    [sym_unset_command] = STATE(346),
    [sym_command] = STATE(346),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(347),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(348),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [102] = {
    [sym__terminated_statement] = STATE(351),
    [sym_for_statement] = STATE(349),
    [sym_c_style_for_statement] = STATE(349),
    [sym_while_statement] = STATE(349),
    [sym_if_statement] = STATE(349),
    [sym_case_statement] = STATE(349),
    [sym_function_definition] = STATE(349),
    [sym_subshell] = STATE(349),
    [sym_pipeline] = STATE(349),
    [sym_list] = STATE(349),
    [sym_negated_command] = STATE(349),
    [sym_test_command] = STATE(349),
    [sym_declaration_command] = STATE(349),
    [sym_unset_command] = STATE(349),
    [sym_command] = STATE(349),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(350),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(351),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [103] = {
    [sym__terminated_statement] = STATE(354),
    [sym_for_statement] = STATE(352),
    [sym_c_style_for_statement] = STATE(352),
    [sym_while_statement] = STATE(352),
    [sym_if_statement] = STATE(352),
    [sym_case_statement] = STATE(352),
    [sym_function_definition] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_pipeline] = STATE(352),
    [sym_list] = STATE(352),
    [sym_negated_command] = STATE(352),
    [sym_test_command] = STATE(352),
    [sym_declaration_command] = STATE(352),
    [sym_unset_command] = STATE(352),
    [sym_command] = STATE(352),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(353),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(354),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [104] = {
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(613),
    [anon_sym_SEMI_SEMI] = ACTIONS(613),
    [anon_sym_PIPE_AMP] = ACTIONS(613),
    [anon_sym_AMP_AMP] = ACTIONS(613),
    [anon_sym_PIPE_PIPE] = ACTIONS(613),
    [sym__special_characters] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [sym_raw_string] = ACTIONS(613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(613),
    [anon_sym_LT_LPAREN] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(613),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(615),
    [sym_word] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(615),
    [anon_sym_LF] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(615),
  },
  [105] = {
    [anon_sym_EQ] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(579),
    [sym_comment] = ACTIONS(53),
  },
  [106] = {
    [sym_variable_assignment] = STATE(355),
    [sym_subscript] = STATE(105),
    [sym_concatenation] = STATE(355),
    [sym_string] = STATE(99),
    [sym_simple_expansion] = STATE(99),
    [sym_string_expansion] = STATE(99),
    [sym_expansion] = STATE(99),
    [sym_command_substitution] = STATE(99),
    [sym_process_substitution] = STATE(99),
    [aux_sym_declaration_command_repeat1] = STATE(355),
    [sym_variable_name] = ACTIONS(159),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(619),
    [anon_sym_PIPE_AMP] = ACTIONS(619),
    [anon_sym_AMP_AMP] = ACTIONS(619),
    [anon_sym_PIPE_PIPE] = ACTIONS(619),
    [sym__special_characters] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(169),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(181),
    [sym_word] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [107] = {
    [aux_sym_concatenation_repeat1] = STATE(357),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(625),
    [anon_sym_PIPE_AMP] = ACTIONS(625),
    [anon_sym_AMP_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(625),
    [sym__special_characters] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(625),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LT_LPAREN] = ACTIONS(625),
    [anon_sym_GT_LPAREN] = ACTIONS(625),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(623),
  },
  [108] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(360),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(629),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [109] = {
    [sym_string] = STATE(362),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(631),
    [sym_raw_string] = ACTIONS(633),
    [anon_sym_POUND] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(631),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(635),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(631),
    [anon_sym_QMARK] = ACTIONS(631),
    [anon_sym_0] = ACTIONS(637),
    [anon_sym__] = ACTIONS(637),
  },
  [110] = {
    [aux_sym_concatenation_repeat1] = STATE(357),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_SEMI_SEMI] = ACTIONS(641),
    [anon_sym_PIPE_AMP] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [sym__special_characters] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(641),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [anon_sym_LT_LPAREN] = ACTIONS(641),
    [anon_sym_GT_LPAREN] = ACTIONS(641),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_LF] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(639),
  },
  [111] = {
    [sym_subscript] = STATE(368),
    [sym_variable_name] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(645),
    [anon_sym_DOLLAR] = ACTIONS(647),
    [anon_sym_POUND] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_AT] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_0] = ACTIONS(651),
    [anon_sym__] = ACTIONS(651),
  },
  [112] = {
    [sym__terminated_statement] = STATE(371),
    [sym_for_statement] = STATE(369),
    [sym_c_style_for_statement] = STATE(369),
    [sym_while_statement] = STATE(369),
    [sym_if_statement] = STATE(369),
    [sym_case_statement] = STATE(369),
    [sym_function_definition] = STATE(369),
    [sym_subshell] = STATE(369),
    [sym_pipeline] = STATE(369),
    [sym_list] = STATE(369),
    [sym_negated_command] = STATE(369),
    [sym_test_command] = STATE(369),
    [sym_declaration_command] = STATE(369),
    [sym_unset_command] = STATE(369),
    [sym_command] = STATE(369),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(370),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(371),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [113] = {
    [sym__terminated_statement] = STATE(374),
    [sym_for_statement] = STATE(372),
    [sym_c_style_for_statement] = STATE(372),
    [sym_while_statement] = STATE(372),
    [sym_if_statement] = STATE(372),
    [sym_case_statement] = STATE(372),
    [sym_function_definition] = STATE(372),
    [sym_subshell] = STATE(372),
    [sym_pipeline] = STATE(372),
    [sym_list] = STATE(372),
    [sym_negated_command] = STATE(372),
    [sym_test_command] = STATE(372),
    [sym_declaration_command] = STATE(372),
    [sym_unset_command] = STATE(372),
    [sym_command] = STATE(372),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(373),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(374),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [114] = {
    [sym__terminated_statement] = STATE(377),
    [sym_for_statement] = STATE(375),
    [sym_c_style_for_statement] = STATE(375),
    [sym_while_statement] = STATE(375),
    [sym_if_statement] = STATE(375),
    [sym_case_statement] = STATE(375),
    [sym_function_definition] = STATE(375),
    [sym_subshell] = STATE(375),
    [sym_pipeline] = STATE(375),
    [sym_list] = STATE(375),
    [sym_negated_command] = STATE(375),
    [sym_test_command] = STATE(375),
    [sym_declaration_command] = STATE(375),
    [sym_unset_command] = STATE(375),
    [sym_command] = STATE(375),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(376),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(377),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [115] = {
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(655),
    [anon_sym_SEMI_SEMI] = ACTIONS(655),
    [anon_sym_PIPE_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(655),
    [sym__special_characters] = ACTIONS(655),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [sym_raw_string] = ACTIONS(655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(655),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_LT_LPAREN] = ACTIONS(655),
    [anon_sym_GT_LPAREN] = ACTIONS(655),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(653),
    [sym_word] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LF] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(653),
  },
  [116] = {
    [sym_concatenation] = STATE(378),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_string_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_unset_command_repeat1] = STATE(378),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(659),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [sym__special_characters] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(195),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(205),
    [sym_word] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(657),
  },
  [117] = {
    [aux_sym_concatenation_repeat1] = STATE(380),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [sym__special_characters] = ACTIONS(661),
    [anon_sym_DQUOTE] = ACTIONS(661),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [sym_raw_string] = ACTIONS(661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [anon_sym_LT_LPAREN] = ACTIONS(661),
    [anon_sym_GT_LPAREN] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(661),
  },
  [118] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(383),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(669),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [119] = {
    [sym_string] = STATE(385),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [sym_raw_string] = ACTIONS(673),
    [anon_sym_POUND] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(675),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(671),
    [anon_sym_QMARK] = ACTIONS(671),
    [anon_sym_0] = ACTIONS(677),
    [anon_sym__] = ACTIONS(677),
  },
  [120] = {
    [aux_sym_concatenation_repeat1] = STATE(380),
    [sym_file_descriptor] = ACTIONS(679),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [sym__special_characters] = ACTIONS(679),
    [anon_sym_DQUOTE] = ACTIONS(679),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [anon_sym_LT_LPAREN] = ACTIONS(679),
    [anon_sym_GT_LPAREN] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(679),
  },
  [121] = {
    [sym_subscript] = STATE(391),
    [sym_variable_name] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DOLLAR] = ACTIONS(687),
    [anon_sym_POUND] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(687),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(689),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_AT] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(687),
    [anon_sym_0] = ACTIONS(691),
    [anon_sym__] = ACTIONS(691),
  },
  [122] = {
    [sym__terminated_statement] = STATE(394),
    [sym_for_statement] = STATE(392),
    [sym_c_style_for_statement] = STATE(392),
    [sym_while_statement] = STATE(392),
    [sym_if_statement] = STATE(392),
    [sym_case_statement] = STATE(392),
    [sym_function_definition] = STATE(392),
    [sym_subshell] = STATE(392),
    [sym_pipeline] = STATE(392),
    [sym_list] = STATE(392),
    [sym_negated_command] = STATE(392),
    [sym_test_command] = STATE(392),
    [sym_declaration_command] = STATE(392),
    [sym_unset_command] = STATE(392),
    [sym_command] = STATE(392),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(393),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(394),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [123] = {
    [sym__terminated_statement] = STATE(397),
    [sym_for_statement] = STATE(395),
    [sym_c_style_for_statement] = STATE(395),
    [sym_while_statement] = STATE(395),
    [sym_if_statement] = STATE(395),
    [sym_case_statement] = STATE(395),
    [sym_function_definition] = STATE(395),
    [sym_subshell] = STATE(395),
    [sym_pipeline] = STATE(395),
    [sym_list] = STATE(395),
    [sym_negated_command] = STATE(395),
    [sym_test_command] = STATE(395),
    [sym_declaration_command] = STATE(395),
    [sym_unset_command] = STATE(395),
    [sym_command] = STATE(395),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(396),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(397),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [124] = {
    [sym__terminated_statement] = STATE(400),
    [sym_for_statement] = STATE(398),
    [sym_c_style_for_statement] = STATE(398),
    [sym_while_statement] = STATE(398),
    [sym_if_statement] = STATE(398),
    [sym_case_statement] = STATE(398),
    [sym_function_definition] = STATE(398),
    [sym_subshell] = STATE(398),
    [sym_pipeline] = STATE(398),
    [sym_list] = STATE(398),
    [sym_negated_command] = STATE(398),
    [sym_test_command] = STATE(398),
    [sym_declaration_command] = STATE(398),
    [sym_unset_command] = STATE(398),
    [sym_command] = STATE(398),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(399),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(400),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [125] = {
    [sym_file_descriptor] = ACTIONS(679),
    [sym_variable_name] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [sym__special_characters] = ACTIONS(679),
    [anon_sym_DQUOTE] = ACTIONS(679),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [anon_sym_LT_LPAREN] = ACTIONS(679),
    [anon_sym_GT_LPAREN] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(679),
  },
  [126] = {
    [sym_string] = STATE(401),
    [sym_simple_expansion] = STATE(401),
    [sym_string_expansion] = STATE(401),
    [sym_expansion] = STATE(401),
    [sym_command_substitution] = STATE(401),
    [sym_process_substitution] = STATE(401),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(693),
  },
  [127] = {
    [aux_sym_concatenation_repeat1] = STATE(402),
    [sym__simple_heredoc_body] = ACTIONS(695),
    [sym__heredoc_body_beginning] = ACTIONS(695),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [128] = {
    [sym__simple_heredoc_body] = ACTIONS(699),
    [sym__heredoc_body_beginning] = ACTIONS(699),
    [sym_file_descriptor] = ACTIONS(699),
    [sym__concat] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_EQ_TILDE] = ACTIONS(701),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(701),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_LT_LT_DASH] = ACTIONS(699),
    [anon_sym_LT_LT_LT] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
  },
  [129] = {
    [anon_sym_DQUOTE] = ACTIONS(703),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [130] = {
    [sym__concat] = ACTIONS(713),
    [anon_sym_DQUOTE] = ACTIONS(715),
    [anon_sym_DOLLAR] = ACTIONS(715),
    [sym__string_content] = ACTIONS(717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(715),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(715),
    [anon_sym_BQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(243),
  },
  [131] = {
    [sym_subscript] = STATE(412),
    [sym_variable_name] = ACTIONS(719),
    [anon_sym_BANG] = ACTIONS(721),
    [anon_sym_DOLLAR] = ACTIONS(723),
    [anon_sym_POUND] = ACTIONS(721),
    [anon_sym_DASH] = ACTIONS(723),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(723),
    [anon_sym_AT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_0] = ACTIONS(727),
    [anon_sym__] = ACTIONS(727),
  },
  [132] = {
    [sym__terminated_statement] = STATE(415),
    [sym_for_statement] = STATE(413),
    [sym_c_style_for_statement] = STATE(413),
    [sym_while_statement] = STATE(413),
    [sym_if_statement] = STATE(413),
    [sym_case_statement] = STATE(413),
    [sym_function_definition] = STATE(413),
    [sym_subshell] = STATE(413),
    [sym_pipeline] = STATE(413),
    [sym_list] = STATE(413),
    [sym_negated_command] = STATE(413),
    [sym_test_command] = STATE(413),
    [sym_declaration_command] = STATE(413),
    [sym_unset_command] = STATE(413),
    [sym_command] = STATE(413),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(414),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(415),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [133] = {
    [sym__terminated_statement] = STATE(418),
    [sym_for_statement] = STATE(416),
    [sym_c_style_for_statement] = STATE(416),
    [sym_while_statement] = STATE(416),
    [sym_if_statement] = STATE(416),
    [sym_case_statement] = STATE(416),
    [sym_function_definition] = STATE(416),
    [sym_subshell] = STATE(416),
    [sym_pipeline] = STATE(416),
    [sym_list] = STATE(416),
    [sym_negated_command] = STATE(416),
    [sym_test_command] = STATE(416),
    [sym_declaration_command] = STATE(416),
    [sym_unset_command] = STATE(416),
    [sym_command] = STATE(416),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(417),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(418),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [134] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(703),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [135] = {
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [136] = {
    [sym__simple_heredoc_body] = ACTIONS(735),
    [sym__heredoc_body_beginning] = ACTIONS(735),
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(735),
    [anon_sym_LT_LT_LT] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [137] = {
    [sym__simple_heredoc_body] = ACTIONS(739),
    [sym__heredoc_body_beginning] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(739),
    [sym__concat] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_EQ_TILDE] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_LT_LT_DASH] = ACTIONS(739),
    [anon_sym_LT_LT_LT] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [138] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(745),
    [sym_comment] = ACTIONS(53),
  },
  [139] = {
    [sym_subscript] = STATE(426),
    [sym_variable_name] = ACTIONS(747),
    [anon_sym_DOLLAR] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_AT] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(749),
    [anon_sym_0] = ACTIONS(753),
    [anon_sym__] = ACTIONS(753),
  },
  [140] = {
    [sym_concatenation] = STATE(437),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(437),
    [anon_sym_RBRACE] = ACTIONS(755),
    [anon_sym_EQ] = ACTIONS(757),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_COLON] = ACTIONS(757),
    [anon_sym_COLON_QMARK] = ACTIONS(757),
    [anon_sym_COLON_DASH] = ACTIONS(757),
    [anon_sym_PERCENT] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [141] = {
    [sym_concatenation] = STATE(440),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(440),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_EQ] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(785),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(787),
    [anon_sym_COLON] = ACTIONS(783),
    [anon_sym_COLON_QMARK] = ACTIONS(783),
    [anon_sym_COLON_DASH] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(783),
    [anon_sym_DASH] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [142] = {
    [sym_concatenation] = STATE(443),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(443),
    [anon_sym_RBRACE] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(791),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(795),
    [anon_sym_COLON] = ACTIONS(791),
    [anon_sym_COLON_QMARK] = ACTIONS(791),
    [anon_sym_COLON_DASH] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [143] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(797),
    [anon_sym_SEMI_SEMI] = ACTIONS(799),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_LF] = ACTIONS(799),
    [anon_sym_AMP] = ACTIONS(801),
  },
  [144] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(797),
    [anon_sym_SEMI_SEMI] = ACTIONS(799),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_LF] = ACTIONS(799),
    [anon_sym_AMP] = ACTIONS(801),
  },
  [145] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(446),
    [sym_c_style_for_statement] = STATE(446),
    [sym_while_statement] = STATE(446),
    [sym_if_statement] = STATE(446),
    [sym_case_statement] = STATE(446),
    [sym_function_definition] = STATE(446),
    [sym_subshell] = STATE(446),
    [sym_pipeline] = STATE(446),
    [sym_list] = STATE(446),
    [sym_negated_command] = STATE(446),
    [sym_test_command] = STATE(446),
    [sym_declaration_command] = STATE(446),
    [sym_unset_command] = STATE(446),
    [sym_command] = STATE(446),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(447),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [146] = {
    [sym__terminated_statement] = STATE(448),
    [sym_for_statement] = STATE(40),
    [sym_c_style_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_subshell] = STATE(40),
    [sym_pipeline] = STATE(40),
    [sym_list] = STATE(40),
    [sym_negated_command] = STATE(40),
    [sym_test_command] = STATE(40),
    [sym_declaration_command] = STATE(40),
    [sym_unset_command] = STATE(40),
    [sym_command] = STATE(40),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(41),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [147] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(803),
  },
  [148] = {
    [sym_subshell] = STATE(71),
    [sym_test_command] = STATE(71),
    [sym_command] = STATE(71),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(72),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(43),
  },
  [149] = {
    [sym__expression] = STATE(450),
    [sym_binary_expression] = STATE(450),
    [sym_unary_expression] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_concatenation] = STATE(450),
    [sym_string] = STATE(78),
    [sym_simple_expansion] = STATE(78),
    [sym_string_expansion] = STATE(78),
    [sym_expansion] = STATE(78),
    [sym_command_substitution] = STATE(78),
    [sym_process_substitution] = STATE(78),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [sym__special_characters] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(131),
    [sym_test_operator] = ACTIONS(133),
  },
  [150] = {
    [sym__expression] = STATE(451),
    [sym_binary_expression] = STATE(451),
    [sym_unary_expression] = STATE(451),
    [sym_parenthesized_expression] = STATE(451),
    [sym_concatenation] = STATE(451),
    [sym_string] = STATE(89),
    [sym_simple_expansion] = STATE(89),
    [sym_string_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [sym_process_substitution] = STATE(89),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [sym__special_characters] = ACTIONS(139),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(155),
    [sym_test_operator] = ACTIONS(157),
  },
  [151] = {
    [sym_variable_assignment] = STATE(452),
    [sym_subscript] = STATE(105),
    [sym_concatenation] = STATE(452),
    [sym_string] = STATE(99),
    [sym_simple_expansion] = STATE(99),
    [sym_string_expansion] = STATE(99),
    [sym_expansion] = STATE(99),
    [sym_command_substitution] = STATE(99),
    [sym_process_substitution] = STATE(99),
    [aux_sym_declaration_command_repeat1] = STATE(452),
    [sym_variable_name] = ACTIONS(159),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_SEMI_SEMI] = ACTIONS(163),
    [anon_sym_PIPE_AMP] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [sym__special_characters] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(169),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(181),
    [sym_word] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_LF] = ACTIONS(163),
    [anon_sym_AMP] = ACTIONS(161),
  },
  [152] = {
    [sym_concatenation] = STATE(453),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_string_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_unset_command_repeat1] = STATE(453),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym__special_characters] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(195),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(205),
    [sym_word] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_LF] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [153] = {
    [aux_sym_concatenation_repeat1] = STATE(127),
    [sym__simple_heredoc_body] = ACTIONS(253),
    [sym__heredoc_body_beginning] = ACTIONS(253),
    [sym_file_descriptor] = ACTIONS(253),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(255),
    [anon_sym_SEMI_SEMI] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(805),
    [anon_sym_PIPE_AMP] = ACTIONS(253),
    [anon_sym_AMP_AMP] = ACTIONS(253),
    [anon_sym_PIPE_PIPE] = ACTIONS(253),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(255),
    [anon_sym_GT] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(253),
    [anon_sym_AMP_GT] = ACTIONS(255),
    [anon_sym_AMP_GT_GT] = ACTIONS(253),
    [anon_sym_LT_AMP] = ACTIONS(253),
    [anon_sym_GT_AMP] = ACTIONS(253),
    [anon_sym_LT_LT] = ACTIONS(255),
    [anon_sym_LT_LT_DASH] = ACTIONS(253),
    [anon_sym_LT_LT_LT] = ACTIONS(253),
    [sym__special_characters] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(255),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(253),
    [anon_sym_LT_LPAREN] = ACTIONS(253),
    [anon_sym_GT_LPAREN] = ACTIONS(253),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LF] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(255),
  },
  [154] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(809),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(797),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_LF] = ACTIONS(809),
    [anon_sym_AMP] = ACTIONS(815),
  },
  [155] = {
    [sym_file_redirect] = STATE(461),
    [sym_heredoc_redirect] = STATE(461),
    [sym_heredoc_body] = STATE(175),
    [sym_herestring_redirect] = STATE(461),
    [sym_concatenation] = STATE(462),
    [sym_string] = STATE(174),
    [sym_simple_expansion] = STATE(174),
    [sym_string_expansion] = STATE(174),
    [sym_expansion] = STATE(174),
    [sym_command_substitution] = STATE(174),
    [sym_process_substitution] = STATE(174),
    [aux_sym_while_statement_repeat1] = STATE(461),
    [aux_sym_command_repeat2] = STATE(462),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_SEMI_SEMI] = ACTIONS(305),
    [anon_sym_PIPE_AMP] = ACTIONS(305),
    [anon_sym_AMP_AMP] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(305),
    [anon_sym_EQ_TILDE] = ACTIONS(307),
    [anon_sym_EQ_EQ] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(823),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(305),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_LF] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(303),
  },
  [156] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(809),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(797),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_LF] = ACTIONS(809),
    [anon_sym_AMP] = ACTIONS(815),
  },
  [157] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(463),
    [sym_c_style_for_statement] = STATE(463),
    [sym_while_statement] = STATE(463),
    [sym_if_statement] = STATE(463),
    [sym_case_statement] = STATE(463),
    [sym_function_definition] = STATE(463),
    [sym_subshell] = STATE(463),
    [sym_pipeline] = STATE(463),
    [sym_list] = STATE(463),
    [sym_negated_command] = STATE(463),
    [sym_test_command] = STATE(463),
    [sym_declaration_command] = STATE(463),
    [sym_unset_command] = STATE(463),
    [sym_command] = STATE(463),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(464),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [158] = {
    [sym_command_name] = STATE(465),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(72),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(180),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(331),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(43),
  },
  [159] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(825),
    [anon_sym_SEMI_SEMI] = ACTIONS(827),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(829),
    [anon_sym_LF] = ACTIONS(827),
    [anon_sym_AMP] = ACTIONS(829),
  },
  [160] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(825),
    [anon_sym_SEMI_SEMI] = ACTIONS(827),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(829),
    [anon_sym_LF] = ACTIONS(827),
    [anon_sym_AMP] = ACTIONS(829),
  },
  [161] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(468),
    [sym_c_style_for_statement] = STATE(468),
    [sym_while_statement] = STATE(468),
    [sym_if_statement] = STATE(468),
    [sym_case_statement] = STATE(468),
    [sym_function_definition] = STATE(468),
    [sym_subshell] = STATE(468),
    [sym_pipeline] = STATE(468),
    [sym_list] = STATE(468),
    [sym_negated_command] = STATE(468),
    [sym_test_command] = STATE(468),
    [sym_declaration_command] = STATE(468),
    [sym_unset_command] = STATE(468),
    [sym_command] = STATE(468),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(469),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [162] = {
    [anon_sym_RPAREN] = ACTIONS(831),
    [sym_comment] = ACTIONS(53),
  },
  [163] = {
    [sym_for_statement] = STATE(471),
    [sym_c_style_for_statement] = STATE(471),
    [sym_while_statement] = STATE(471),
    [sym_if_statement] = STATE(471),
    [sym_case_statement] = STATE(471),
    [sym_function_definition] = STATE(471),
    [sym_subshell] = STATE(471),
    [sym_pipeline] = STATE(471),
    [sym_list] = STATE(471),
    [sym_negated_command] = STATE(471),
    [sym_test_command] = STATE(471),
    [sym_declaration_command] = STATE(471),
    [sym_unset_command] = STATE(471),
    [sym_command] = STATE(471),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(472),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [164] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [ts_builtin_sym_end] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_done] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_fi] = ACTIONS(835),
    [anon_sym_elif] = ACTIONS(835),
    [anon_sym_else] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [165] = {
    [sym_for_statement] = STATE(473),
    [sym_c_style_for_statement] = STATE(473),
    [sym_while_statement] = STATE(473),
    [sym_if_statement] = STATE(473),
    [sym_case_statement] = STATE(473),
    [sym_function_definition] = STATE(473),
    [sym_subshell] = STATE(473),
    [sym_pipeline] = STATE(473),
    [sym_list] = STATE(473),
    [sym_negated_command] = STATE(473),
    [sym_test_command] = STATE(473),
    [sym_declaration_command] = STATE(473),
    [sym_unset_command] = STATE(473),
    [sym_command] = STATE(473),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(474),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [166] = {
    [anon_sym_esac] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [anon_sym_PIPE_AMP] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(839),
  },
  [167] = {
    [sym_simple_expansion] = STATE(478),
    [sym_expansion] = STATE(478),
    [aux_sym_heredoc_body_repeat1] = STATE(478),
    [sym__heredoc_body_middle] = ACTIONS(841),
    [sym__heredoc_body_end] = ACTIONS(843),
    [anon_sym_DOLLAR] = ACTIONS(845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(847),
    [sym_comment] = ACTIONS(53),
  },
  [168] = {
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_GT] = ACTIONS(849),
    [anon_sym_AMP_GT_GT] = ACTIONS(851),
    [anon_sym_LT_AMP] = ACTIONS(851),
    [anon_sym_GT_AMP] = ACTIONS(851),
    [sym_comment] = ACTIONS(53),
  },
  [169] = {
    [sym_concatenation] = STATE(482),
    [sym_string] = STATE(481),
    [sym_simple_expansion] = STATE(481),
    [sym_string_expansion] = STATE(481),
    [sym_expansion] = STATE(481),
    [sym_command_substitution] = STATE(481),
    [sym_process_substitution] = STATE(481),
    [sym__special_characters] = ACTIONS(853),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(859),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(865),
    [anon_sym_GT_LPAREN] = ACTIONS(865),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(857),
    [sym_regex] = ACTIONS(867),
  },
  [170] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(484),
    [sym_simple_expansion] = STATE(484),
    [sym_string_expansion] = STATE(484),
    [sym_expansion] = STATE(484),
    [sym_command_substitution] = STATE(484),
    [sym_process_substitution] = STATE(484),
    [sym__special_characters] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(871),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(871),
  },
  [171] = {
    [sym_heredoc_start] = ACTIONS(873),
    [sym_comment] = ACTIONS(53),
  },
  [172] = {
    [sym_concatenation] = STATE(489),
    [sym_string] = STATE(488),
    [sym_simple_expansion] = STATE(488),
    [sym_string_expansion] = STATE(488),
    [sym_expansion] = STATE(488),
    [sym_command_substitution] = STATE(488),
    [sym_process_substitution] = STATE(488),
    [sym__special_characters] = ACTIONS(875),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(877),
  },
  [173] = {
    [aux_sym_concatenation_repeat1] = STATE(127),
    [sym__simple_heredoc_body] = ACTIONS(879),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(879),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(881),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(881),
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [sym__special_characters] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(881),
    [sym_raw_string] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_LF] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(881),
  },
  [174] = {
    [aux_sym_concatenation_repeat1] = STATE(127),
    [sym__simple_heredoc_body] = ACTIONS(883),
    [sym__heredoc_body_beginning] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(883),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(885),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_EQ_TILDE] = ACTIONS(885),
    [anon_sym_EQ_EQ] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(885),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [sym__special_characters] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(885),
    [anon_sym_LF] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(885),
  },
  [175] = {
    [anon_sym_esac] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_BQUOTE] = ACTIONS(887),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [176] = {
    [sym_file_redirect] = STATE(491),
    [sym_heredoc_redirect] = STATE(491),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(491),
    [aux_sym_while_statement_repeat1] = STATE(491),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(309),
    [anon_sym_GT_GT] = ACTIONS(311),
    [anon_sym_AMP_GT] = ACTIONS(309),
    [anon_sym_AMP_GT_GT] = ACTIONS(311),
    [anon_sym_LT_AMP] = ACTIONS(311),
    [anon_sym_GT_AMP] = ACTIONS(311),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [177] = {
    [sym_file_redirect] = STATE(492),
    [sym_heredoc_redirect] = STATE(492),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(492),
    [sym_concatenation] = STATE(493),
    [sym_string] = STATE(174),
    [sym_simple_expansion] = STATE(174),
    [sym_string_expansion] = STATE(174),
    [sym_expansion] = STATE(174),
    [sym_command_substitution] = STATE(174),
    [sym_process_substitution] = STATE(174),
    [aux_sym_while_statement_repeat1] = STATE(492),
    [aux_sym_command_repeat2] = STATE(493),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(307),
    [anon_sym_EQ_EQ] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(309),
    [anon_sym_GT_GT] = ACTIONS(311),
    [anon_sym_AMP_GT] = ACTIONS(309),
    [anon_sym_AMP_GT_GT] = ACTIONS(311),
    [anon_sym_LT_AMP] = ACTIONS(311),
    [anon_sym_GT_AMP] = ACTIONS(311),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [178] = {
    [sym__terminated_statement] = STATE(178),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(178),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(891),
    [sym_variable_name] = ACTIONS(894),
    [ts_builtin_sym_end] = ACTIONS(897),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(923),
    [anon_sym_declare] = ACTIONS(926),
    [anon_sym_typeset] = ACTIONS(926),
    [anon_sym_export] = ACTIONS(926),
    [anon_sym_readonly] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym_unset] = ACTIONS(929),
    [anon_sym_unsetenv] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [sym_raw_string] = ACTIONS(947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [anon_sym_LT_LPAREN] = ACTIONS(959),
    [anon_sym_GT_LPAREN] = ACTIONS(959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(962),
  },
  [179] = {
    [sym_file_redirect] = STATE(492),
    [sym_heredoc_redirect] = STATE(492),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(492),
    [sym_concatenation] = STATE(494),
    [sym_string] = STATE(174),
    [sym_simple_expansion] = STATE(174),
    [sym_string_expansion] = STATE(174),
    [sym_expansion] = STATE(174),
    [sym_command_substitution] = STATE(174),
    [sym_process_substitution] = STATE(174),
    [aux_sym_while_statement_repeat1] = STATE(492),
    [aux_sym_command_repeat2] = STATE(494),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(307),
    [anon_sym_EQ_EQ] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(309),
    [anon_sym_GT_GT] = ACTIONS(311),
    [anon_sym_AMP_GT] = ACTIONS(309),
    [anon_sym_AMP_GT_GT] = ACTIONS(311),
    [anon_sym_LT_AMP] = ACTIONS(311),
    [anon_sym_GT_AMP] = ACTIONS(311),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [180] = {
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(72),
    [sym_file_redirect] = STATE(30),
    [aux_sym_command_repeat1] = STATE(180),
    [sym_file_descriptor] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(968),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_GT_GT] = ACTIONS(974),
    [anon_sym_AMP_GT] = ACTIONS(971),
    [anon_sym_AMP_GT_GT] = ACTIONS(974),
    [anon_sym_LT_AMP] = ACTIONS(974),
    [anon_sym_GT_AMP] = ACTIONS(974),
    [sym__special_characters] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(977),
  },
  [181] = {
    [aux_sym_concatenation_repeat1] = STATE(380),
    [sym_file_descriptor] = ACTIONS(981),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(981),
    [anon_sym_LT_AMP] = ACTIONS(981),
    [anon_sym_GT_AMP] = ACTIONS(981),
    [sym__special_characters] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(981),
    [anon_sym_DOLLAR] = ACTIONS(983),
    [sym_raw_string] = ACTIONS(981),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(981),
    [anon_sym_BQUOTE] = ACTIONS(981),
    [anon_sym_LT_LPAREN] = ACTIONS(981),
    [anon_sym_GT_LPAREN] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(981),
  },
  [182] = {
    [aux_sym_concatenation_repeat1] = STATE(380),
    [sym_file_descriptor] = ACTIONS(985),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [sym__special_characters] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [anon_sym_DOLLAR] = ACTIONS(987),
    [sym_raw_string] = ACTIONS(985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(985),
    [anon_sym_BQUOTE] = ACTIONS(985),
    [anon_sym_LT_LPAREN] = ACTIONS(985),
    [anon_sym_GT_LPAREN] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(985),
  },
  [183] = {
    [sym_file_descriptor] = ACTIONS(985),
    [sym_variable_name] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [sym__special_characters] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [anon_sym_DOLLAR] = ACTIONS(987),
    [sym_raw_string] = ACTIONS(985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(985),
    [anon_sym_BQUOTE] = ACTIONS(985),
    [anon_sym_LT_LPAREN] = ACTIONS(985),
    [anon_sym_GT_LPAREN] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(985),
  },
  [184] = {
    [aux_sym_concatenation_repeat1] = STATE(497),
    [sym__concat] = ACTIONS(989),
    [anon_sym_RBRACK] = ACTIONS(991),
    [sym_comment] = ACTIONS(53),
  },
  [185] = {
    [aux_sym_concatenation_repeat1] = STATE(497),
    [sym__concat] = ACTIONS(993),
    [anon_sym_RBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(53),
  },
  [186] = {
    [sym__concat] = ACTIONS(997),
    [anon_sym_RBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(53),
  },
  [187] = {
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(999),
    [anon_sym_PIPE_AMP] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1001),
    [anon_sym_GT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_AMP_GT] = ACTIONS(1001),
    [anon_sym_AMP_GT_GT] = ACTIONS(999),
    [anon_sym_LT_AMP] = ACTIONS(999),
    [anon_sym_GT_AMP] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LF] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(1001),
  },
  [188] = {
    [sym_concatenation] = STATE(510),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_string_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [aux_sym_for_statement_repeat1] = STATE(510),
    [anon_sym_RPAREN] = ACTIONS(1003),
    [sym__special_characters] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [sym_raw_string] = ACTIONS(1011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1019),
    [anon_sym_GT_LPAREN] = ACTIONS(1019),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1011),
  },
  [189] = {
    [aux_sym_concatenation_repeat1] = STATE(512),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1025),
    [anon_sym_SEMI_SEMI] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(1025),
    [anon_sym_GT] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1025),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1025),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1025),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_LF] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1025),
  },
  [190] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(515),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1029),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [191] = {
    [sym_string] = STATE(517),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR] = ACTIONS(1031),
    [sym_raw_string] = ACTIONS(1033),
    [anon_sym_POUND] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1035),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1031),
    [anon_sym_0] = ACTIONS(1037),
    [anon_sym__] = ACTIONS(1037),
  },
  [192] = {
    [aux_sym_concatenation_repeat1] = STATE(512),
    [sym_file_descriptor] = ACTIONS(999),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_SEMI_SEMI] = ACTIONS(999),
    [anon_sym_PIPE_AMP] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1001),
    [anon_sym_GT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_AMP_GT] = ACTIONS(1001),
    [anon_sym_AMP_GT_GT] = ACTIONS(999),
    [anon_sym_LT_AMP] = ACTIONS(999),
    [anon_sym_GT_AMP] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LF] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(1001),
  },
  [193] = {
    [sym_subscript] = STATE(523),
    [sym_variable_name] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [anon_sym_POUND] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1043),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_0] = ACTIONS(1047),
    [anon_sym__] = ACTIONS(1047),
  },
  [194] = {
    [sym__terminated_statement] = STATE(526),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(526),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [195] = {
    [sym__terminated_statement] = STATE(529),
    [sym_for_statement] = STATE(527),
    [sym_c_style_for_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_if_statement] = STATE(527),
    [sym_case_statement] = STATE(527),
    [sym_function_definition] = STATE(527),
    [sym_subshell] = STATE(527),
    [sym_pipeline] = STATE(527),
    [sym_list] = STATE(527),
    [sym_negated_command] = STATE(527),
    [sym_test_command] = STATE(527),
    [sym_declaration_command] = STATE(527),
    [sym_unset_command] = STATE(527),
    [sym_command] = STATE(527),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(528),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(529),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [196] = {
    [sym__terminated_statement] = STATE(532),
    [sym_for_statement] = STATE(530),
    [sym_c_style_for_statement] = STATE(530),
    [sym_while_statement] = STATE(530),
    [sym_if_statement] = STATE(530),
    [sym_case_statement] = STATE(530),
    [sym_function_definition] = STATE(530),
    [sym_subshell] = STATE(530),
    [sym_pipeline] = STATE(530),
    [sym_list] = STATE(530),
    [sym_negated_command] = STATE(530),
    [sym_test_command] = STATE(530),
    [sym_declaration_command] = STATE(530),
    [sym_unset_command] = STATE(530),
    [sym_command] = STATE(530),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(531),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(532),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [197] = {
    [sym__expression] = STATE(534),
    [sym_binary_expression] = STATE(534),
    [sym_unary_expression] = STATE(534),
    [sym_parenthesized_expression] = STATE(534),
    [sym_concatenation] = STATE(534),
    [sym_string] = STATE(203),
    [sym_simple_expansion] = STATE(203),
    [sym_string_expansion] = STATE(203),
    [sym_expansion] = STATE(203),
    [sym_command_substitution] = STATE(203),
    [sym_process_substitution] = STATE(203),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_BANG] = ACTIONS(365),
    [sym__special_characters] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(383),
    [sym_test_operator] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1049),
  },
  [198] = {
    [sym__expression] = STATE(535),
    [sym_binary_expression] = STATE(535),
    [sym_unary_expression] = STATE(535),
    [sym_parenthesized_expression] = STATE(535),
    [sym_concatenation] = STATE(535),
    [sym_string] = STATE(278),
    [sym_simple_expansion] = STATE(278),
    [sym_string_expansion] = STATE(278),
    [sym_expansion] = STATE(278),
    [sym_command_substitution] = STATE(278),
    [sym_process_substitution] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(499),
    [sym__special_characters] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(505),
    [sym_test_operator] = ACTIONS(507),
  },
  [199] = {
    [sym__expression] = STATE(536),
    [sym_binary_expression] = STATE(536),
    [sym_unary_expression] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_concatenation] = STATE(536),
    [sym_string] = STATE(203),
    [sym_simple_expansion] = STATE(203),
    [sym_string_expansion] = STATE(203),
    [sym_expansion] = STATE(203),
    [sym_command_substitution] = STATE(203),
    [sym_process_substitution] = STATE(203),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_BANG] = ACTIONS(365),
    [sym__special_characters] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(383),
    [sym_test_operator] = ACTIONS(385),
  },
  [200] = {
    [aux_sym_concatenation_repeat1] = STATE(538),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(511),
    [anon_sym_AMP_AMP] = ACTIONS(511),
    [anon_sym_PIPE_PIPE] = ACTIONS(511),
    [anon_sym_EQ_TILDE] = ACTIONS(511),
    [anon_sym_EQ_EQ] = ACTIONS(511),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
  },
  [201] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(541),
    [anon_sym_DQUOTE] = ACTIONS(1055),
    [anon_sym_DOLLAR] = ACTIONS(1057),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [202] = {
    [sym_string] = STATE(543),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_POUND] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [203] = {
    [aux_sym_concatenation_repeat1] = STATE(538),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_EQ_TILDE] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(527),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_LF] = ACTIONS(527),
    [anon_sym_AMP] = ACTIONS(529),
  },
  [204] = {
    [sym_subscript] = STATE(549),
    [sym_variable_name] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [anon_sym_POUND] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [205] = {
    [sym__terminated_statement] = STATE(552),
    [sym_for_statement] = STATE(550),
    [sym_c_style_for_statement] = STATE(550),
    [sym_while_statement] = STATE(550),
    [sym_if_statement] = STATE(550),
    [sym_case_statement] = STATE(550),
    [sym_function_definition] = STATE(550),
    [sym_subshell] = STATE(550),
    [sym_pipeline] = STATE(550),
    [sym_list] = STATE(550),
    [sym_negated_command] = STATE(550),
    [sym_test_command] = STATE(550),
    [sym_declaration_command] = STATE(550),
    [sym_unset_command] = STATE(550),
    [sym_command] = STATE(550),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(551),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(552),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [206] = {
    [sym__terminated_statement] = STATE(555),
    [sym_for_statement] = STATE(553),
    [sym_c_style_for_statement] = STATE(553),
    [sym_while_statement] = STATE(553),
    [sym_if_statement] = STATE(553),
    [sym_case_statement] = STATE(553),
    [sym_function_definition] = STATE(553),
    [sym_subshell] = STATE(553),
    [sym_pipeline] = STATE(553),
    [sym_list] = STATE(553),
    [sym_negated_command] = STATE(553),
    [sym_test_command] = STATE(553),
    [sym_declaration_command] = STATE(553),
    [sym_unset_command] = STATE(553),
    [sym_command] = STATE(553),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(554),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(555),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [207] = {
    [sym__terminated_statement] = STATE(558),
    [sym_for_statement] = STATE(556),
    [sym_c_style_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_case_statement] = STATE(556),
    [sym_function_definition] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_pipeline] = STATE(556),
    [sym_list] = STATE(556),
    [sym_negated_command] = STATE(556),
    [sym_test_command] = STATE(556),
    [sym_declaration_command] = STATE(556),
    [sym_unset_command] = STATE(556),
    [sym_command] = STATE(556),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(557),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(558),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [208] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_EQ_TILDE] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_BANG_EQ] = ACTIONS(1079),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1079),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [209] = {
    [sym_concatenation] = STATE(570),
    [sym_string] = STATE(565),
    [sym_simple_expansion] = STATE(565),
    [sym_string_expansion] = STATE(565),
    [sym_expansion] = STATE(565),
    [sym_command_substitution] = STATE(565),
    [sym_process_substitution] = STATE(565),
    [aux_sym_for_statement_repeat1] = STATE(570),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1093),
  },
  [210] = {
    [sym_do_group] = STATE(572),
    [anon_sym_do] = ACTIONS(1103),
    [sym_comment] = ACTIONS(53),
  },
  [211] = {
    [sym__terminated_statement] = STATE(574),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(574),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(1105),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [212] = {
    [sym_file_redirect] = STATE(576),
    [sym_heredoc_redirect] = STATE(576),
    [sym_heredoc_body] = STATE(575),
    [sym_herestring_redirect] = STATE(576),
    [aux_sym_while_statement_repeat1] = STATE(576),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(309),
    [anon_sym_GT_GT] = ACTIONS(311),
    [anon_sym_AMP_GT] = ACTIONS(309),
    [anon_sym_AMP_GT_GT] = ACTIONS(311),
    [anon_sym_LT_AMP] = ACTIONS(311),
    [anon_sym_GT_AMP] = ACTIONS(311),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [213] = {
    [anon_sym_do] = ACTIONS(833),
    [anon_sym_then] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
  },
  [214] = {
    [sym__terminated_statement] = STATE(582),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_elif_clause] = STATE(580),
    [sym_else_clause] = STATE(581),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(582),
    [aux_sym_if_statement_repeat1] = STATE(583),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(1111),
    [anon_sym_elif] = ACTIONS(1113),
    [anon_sym_else] = ACTIONS(1115),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [215] = {
    [sym_string] = STATE(584),
    [sym_simple_expansion] = STATE(584),
    [sym_string_expansion] = STATE(584),
    [sym_expansion] = STATE(584),
    [sym_command_substitution] = STATE(584),
    [sym_process_substitution] = STATE(584),
    [sym__special_characters] = ACTIONS(1117),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [anon_sym_DOLLAR] = ACTIONS(73),
    [sym_raw_string] = ACTIONS(1117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(77),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(79),
    [anon_sym_BQUOTE] = ACTIONS(81),
    [anon_sym_LT_LPAREN] = ACTIONS(83),
    [anon_sym_GT_LPAREN] = ACTIONS(83),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1117),
  },
  [216] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1119),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1121),
    [anon_sym_LF] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1119),
  },
  [217] = {
    [anon_sym_in] = ACTIONS(1123),
    [sym_comment] = ACTIONS(53),
  },
  [218] = {
    [aux_sym_concatenation_repeat1] = STATE(587),
    [sym__concat] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [219] = {
    [sym__concat] = ACTIONS(699),
    [anon_sym_in] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [220] = {
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [221] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [222] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_in] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
  },
  [223] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_in] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [224] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_in] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(739),
  },
  [225] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1129),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
  },
  [226] = {
    [anon_sym_in] = ACTIONS(1133),
    [sym_comment] = ACTIONS(53),
  },
  [227] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(1135),
    [sym_comment] = ACTIONS(53),
  },
  [228] = {
    [sym_subscript] = STATE(596),
    [sym_variable_name] = ACTIONS(1137),
    [anon_sym_DOLLAR] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(1139),
    [anon_sym_QMARK] = ACTIONS(1139),
    [anon_sym_0] = ACTIONS(1143),
    [anon_sym__] = ACTIONS(1143),
  },
  [229] = {
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(599),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_EQ] = ACTIONS(1147),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_COLON] = ACTIONS(1147),
    [anon_sym_COLON_QMARK] = ACTIONS(1147),
    [anon_sym_COLON_DASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [230] = {
    [sym_concatenation] = STATE(602),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(602),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym_EQ] = ACTIONS(1155),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1159),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_COLON_QMARK] = ACTIONS(1155),
    [anon_sym_COLON_DASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [231] = {
    [sym_concatenation] = STATE(605),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(605),
    [anon_sym_RBRACE] = ACTIONS(1161),
    [anon_sym_EQ] = ACTIONS(1163),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(1163),
    [anon_sym_COLON_QMARK] = ACTIONS(1163),
    [anon_sym_COLON_DASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [232] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1169),
    [anon_sym_SEMI_SEMI] = ACTIONS(1171),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
  },
  [233] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1169),
    [anon_sym_SEMI_SEMI] = ACTIONS(1171),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
  },
  [234] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(608),
    [sym_c_style_for_statement] = STATE(608),
    [sym_while_statement] = STATE(608),
    [sym_if_statement] = STATE(608),
    [sym_case_statement] = STATE(608),
    [sym_function_definition] = STATE(608),
    [sym_subshell] = STATE(608),
    [sym_pipeline] = STATE(608),
    [sym_list] = STATE(608),
    [sym_negated_command] = STATE(608),
    [sym_test_command] = STATE(608),
    [sym_declaration_command] = STATE(608),
    [sym_unset_command] = STATE(608),
    [sym_command] = STATE(608),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(609),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [235] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1175),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1177),
    [anon_sym_LF] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1177),
  },
  [236] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1175),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1177),
    [anon_sym_LF] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1177),
  },
  [237] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(611),
    [sym_c_style_for_statement] = STATE(611),
    [sym_while_statement] = STATE(611),
    [sym_if_statement] = STATE(611),
    [sym_case_statement] = STATE(611),
    [sym_function_definition] = STATE(611),
    [sym_subshell] = STATE(611),
    [sym_pipeline] = STATE(611),
    [sym_list] = STATE(611),
    [sym_negated_command] = STATE(611),
    [sym_test_command] = STATE(611),
    [sym_declaration_command] = STATE(611),
    [sym_unset_command] = STATE(611),
    [sym_command] = STATE(611),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(612),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [238] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1179),
    [anon_sym_SEMI_SEMI] = ACTIONS(1181),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1183),
    [anon_sym_LF] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1183),
  },
  [239] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1179),
    [anon_sym_SEMI_SEMI] = ACTIONS(1181),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1183),
    [anon_sym_LF] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1183),
  },
  [240] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(615),
    [sym_c_style_for_statement] = STATE(615),
    [sym_while_statement] = STATE(615),
    [sym_if_statement] = STATE(615),
    [sym_case_statement] = STATE(615),
    [sym_function_definition] = STATE(615),
    [sym_subshell] = STATE(615),
    [sym_pipeline] = STATE(615),
    [sym_list] = STATE(615),
    [sym_negated_command] = STATE(615),
    [sym_test_command] = STATE(615),
    [sym_declaration_command] = STATE(615),
    [sym_unset_command] = STATE(615),
    [sym_command] = STATE(615),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(616),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [241] = {
    [anon_sym_RPAREN] = ACTIONS(1185),
    [sym_comment] = ACTIONS(53),
  },
  [242] = {
    [sym__terminated_statement] = STATE(621),
    [sym_for_statement] = STATE(619),
    [sym_c_style_for_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_case_statement] = STATE(619),
    [sym_function_definition] = STATE(619),
    [sym_subshell] = STATE(619),
    [sym_pipeline] = STATE(619),
    [sym_list] = STATE(619),
    [sym_negated_command] = STATE(619),
    [sym_test_command] = STATE(619),
    [sym_declaration_command] = STATE(619),
    [sym_unset_command] = STATE(619),
    [sym_command] = STATE(619),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(620),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(621),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [243] = {
    [sym_file_redirect] = STATE(624),
    [sym_file_descriptor] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_SEMI_SEMI] = ACTIONS(1193),
    [anon_sym_PIPE_AMP] = ACTIONS(1193),
    [anon_sym_AMP_AMP] = ACTIONS(1193),
    [anon_sym_PIPE_PIPE] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_GT] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_AMP_GT] = ACTIONS(1195),
    [anon_sym_AMP_GT_GT] = ACTIONS(1197),
    [anon_sym_LT_AMP] = ACTIONS(1197),
    [anon_sym_GT_AMP] = ACTIONS(1197),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym_LF] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1191),
  },
  [244] = {
    [sym_concatenation] = STATE(187),
    [sym_string] = STATE(626),
    [sym_array] = STATE(187),
    [sym_simple_expansion] = STATE(626),
    [sym_string_expansion] = STATE(626),
    [sym_expansion] = STATE(626),
    [sym_command_substitution] = STATE(626),
    [sym_process_substitution] = STATE(626),
    [sym__empty_value] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [sym__special_characters] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR] = ACTIONS(349),
    [sym_raw_string] = ACTIONS(1201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(355),
    [anon_sym_BQUOTE] = ACTIONS(357),
    [anon_sym_LT_LPAREN] = ACTIONS(359),
    [anon_sym_GT_LPAREN] = ACTIONS(359),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1201),
  },
  [245] = {
    [sym_do_group] = STATE(627),
    [anon_sym_do] = ACTIONS(395),
    [sym_comment] = ACTIONS(53),
  },
  [246] = {
    [sym_compound_statement] = STATE(629),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [247] = {
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(1205),
    [anon_sym_EQ_TILDE] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_EQ] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(541),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(541),
  },
  [248] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1205),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [249] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_PLUS_EQ] = ACTIONS(1207),
    [sym_comment] = ACTIONS(53),
  },
  [250] = {
    [aux_sym_concatenation_repeat1] = STATE(632),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym__special_characters] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(585),
  },
  [251] = {
    [aux_sym_concatenation_repeat1] = STATE(632),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_RPAREN] = ACTIONS(599),
    [anon_sym_SEMI_SEMI] = ACTIONS(599),
    [anon_sym_PIPE_AMP] = ACTIONS(599),
    [anon_sym_AMP_AMP] = ACTIONS(599),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [sym__special_characters] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(599),
    [anon_sym_BQUOTE] = ACTIONS(599),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [252] = {
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_PLUS_EQ] = ACTIONS(1207),
    [sym_comment] = ACTIONS(53),
  },
  [253] = {
    [sym_variable_assignment] = STATE(633),
    [sym_subscript] = STATE(252),
    [sym_concatenation] = STATE(633),
    [sym_string] = STATE(251),
    [sym_simple_expansion] = STATE(251),
    [sym_string_expansion] = STATE(251),
    [sym_expansion] = STATE(251),
    [sym_command_substitution] = STATE(251),
    [sym_process_substitution] = STATE(251),
    [aux_sym_declaration_command_repeat1] = STATE(633),
    [sym_variable_name] = ACTIONS(447),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_SEMI_SEMI] = ACTIONS(619),
    [anon_sym_PIPE_AMP] = ACTIONS(619),
    [anon_sym_AMP_AMP] = ACTIONS(619),
    [anon_sym_PIPE_PIPE] = ACTIONS(619),
    [sym__special_characters] = ACTIONS(449),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(169),
    [sym_raw_string] = ACTIONS(451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(181),
    [sym_word] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [254] = {
    [aux_sym_concatenation_repeat1] = STATE(634),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(625),
    [anon_sym_SEMI_SEMI] = ACTIONS(625),
    [anon_sym_PIPE_AMP] = ACTIONS(625),
    [anon_sym_AMP_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(625),
    [sym__special_characters] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(625),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LT_LPAREN] = ACTIONS(625),
    [anon_sym_GT_LPAREN] = ACTIONS(625),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(623),
  },
  [255] = {
    [aux_sym_concatenation_repeat1] = STATE(634),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(641),
    [anon_sym_SEMI_SEMI] = ACTIONS(641),
    [anon_sym_PIPE_AMP] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [sym__special_characters] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(641),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [anon_sym_LT_LPAREN] = ACTIONS(641),
    [anon_sym_GT_LPAREN] = ACTIONS(641),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_LF] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(639),
  },
  [256] = {
    [sym_concatenation] = STATE(635),
    [sym_string] = STATE(255),
    [sym_simple_expansion] = STATE(255),
    [sym_string_expansion] = STATE(255),
    [sym_expansion] = STATE(255),
    [sym_command_substitution] = STATE(255),
    [sym_process_substitution] = STATE(255),
    [aux_sym_unset_command_repeat1] = STATE(635),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_SEMI_SEMI] = ACTIONS(659),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [sym__special_characters] = ACTIONS(455),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(205),
    [sym_word] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(657),
  },
  [257] = {
    [aux_sym_concatenation_repeat1] = STATE(636),
    [sym__simple_heredoc_body] = ACTIONS(695),
    [sym__heredoc_body_beginning] = ACTIONS(695),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [258] = {
    [anon_sym_RPAREN] = ACTIONS(1209),
    [sym_comment] = ACTIONS(53),
  },
  [259] = {
    [sym_for_statement] = STATE(471),
    [sym_c_style_for_statement] = STATE(471),
    [sym_while_statement] = STATE(471),
    [sym_if_statement] = STATE(471),
    [sym_case_statement] = STATE(471),
    [sym_function_definition] = STATE(471),
    [sym_subshell] = STATE(471),
    [sym_pipeline] = STATE(471),
    [sym_list] = STATE(471),
    [sym_negated_command] = STATE(471),
    [sym_test_command] = STATE(471),
    [sym_declaration_command] = STATE(471),
    [sym_unset_command] = STATE(471),
    [sym_command] = STATE(471),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(472),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [260] = {
    [anon_sym_esac] = ACTIONS(1211),
    [anon_sym_PIPE] = ACTIONS(1213),
    [anon_sym_RPAREN] = ACTIONS(1211),
    [anon_sym_SEMI_SEMI] = ACTIONS(1211),
    [anon_sym_PIPE_AMP] = ACTIONS(1211),
    [anon_sym_AMP_AMP] = ACTIONS(1211),
    [anon_sym_PIPE_PIPE] = ACTIONS(1211),
    [anon_sym_BQUOTE] = ACTIONS(1211),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_LF] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(1213),
  },
  [261] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [262] = {
    [sym_for_statement] = STATE(639),
    [sym_c_style_for_statement] = STATE(639),
    [sym_while_statement] = STATE(639),
    [sym_if_statement] = STATE(639),
    [sym_case_statement] = STATE(639),
    [sym_function_definition] = STATE(639),
    [sym_subshell] = STATE(639),
    [sym_pipeline] = STATE(639),
    [sym_list] = STATE(639),
    [sym_negated_command] = STATE(639),
    [sym_test_command] = STATE(639),
    [sym_declaration_command] = STATE(639),
    [sym_unset_command] = STATE(639),
    [sym_command] = STATE(639),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(640),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [263] = {
    [anon_sym_LT] = ACTIONS(1217),
    [anon_sym_GT] = ACTIONS(1217),
    [anon_sym_GT_GT] = ACTIONS(1219),
    [anon_sym_AMP_GT] = ACTIONS(1217),
    [anon_sym_AMP_GT_GT] = ACTIONS(1219),
    [anon_sym_LT_AMP] = ACTIONS(1219),
    [anon_sym_GT_AMP] = ACTIONS(1219),
    [sym_comment] = ACTIONS(53),
  },
  [264] = {
    [sym_concatenation] = STATE(482),
    [sym_string] = STATE(643),
    [sym_simple_expansion] = STATE(643),
    [sym_string_expansion] = STATE(643),
    [sym_expansion] = STATE(643),
    [sym_command_substitution] = STATE(643),
    [sym_process_substitution] = STATE(643),
    [sym__special_characters] = ACTIONS(1221),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1223),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(859),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(865),
    [anon_sym_GT_LPAREN] = ACTIONS(865),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(1223),
    [sym_regex] = ACTIONS(867),
  },
  [265] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(645),
    [sym_simple_expansion] = STATE(645),
    [sym_string_expansion] = STATE(645),
    [sym_expansion] = STATE(645),
    [sym_command_substitution] = STATE(645),
    [sym_process_substitution] = STATE(645),
    [sym__special_characters] = ACTIONS(1225),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1227),
  },
  [266] = {
    [sym_concatenation] = STATE(489),
    [sym_string] = STATE(647),
    [sym_simple_expansion] = STATE(647),
    [sym_string_expansion] = STATE(647),
    [sym_expansion] = STATE(647),
    [sym_command_substitution] = STATE(647),
    [sym_process_substitution] = STATE(647),
    [sym__special_characters] = ACTIONS(1229),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1231),
  },
  [267] = {
    [aux_sym_concatenation_repeat1] = STATE(257),
    [sym__simple_heredoc_body] = ACTIONS(879),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(879),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(881),
    [anon_sym_RPAREN] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(881),
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [sym__special_characters] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(881),
    [sym_raw_string] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_LF] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(881),
  },
  [268] = {
    [aux_sym_concatenation_repeat1] = STATE(257),
    [sym__simple_heredoc_body] = ACTIONS(883),
    [sym__heredoc_body_beginning] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(883),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(885),
    [anon_sym_RPAREN] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_EQ_TILDE] = ACTIONS(885),
    [anon_sym_EQ_EQ] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(885),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [sym__special_characters] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(885),
    [anon_sym_LF] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(885),
  },
  [269] = {
    [sym_file_redirect] = STATE(648),
    [sym_heredoc_redirect] = STATE(648),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(648),
    [aux_sym_while_statement_repeat1] = STATE(648),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(483),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [270] = {
    [sym_file_redirect] = STATE(649),
    [sym_heredoc_redirect] = STATE(649),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(649),
    [sym_concatenation] = STATE(650),
    [sym_string] = STATE(268),
    [sym_simple_expansion] = STATE(268),
    [sym_string_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [aux_sym_while_statement_repeat1] = STATE(649),
    [aux_sym_command_repeat2] = STATE(650),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(483),
    [sym__special_characters] = ACTIONS(485),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(489),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [271] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1215),
    [anon_sym_SEMI_SEMI] = ACTIONS(1233),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_LF] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
  },
  [272] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1215),
    [anon_sym_SEMI_SEMI] = ACTIONS(1233),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_LF] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
  },
  [273] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(891),
    [sym_variable_name] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(923),
    [anon_sym_declare] = ACTIONS(926),
    [anon_sym_typeset] = ACTIONS(926),
    [anon_sym_export] = ACTIONS(926),
    [anon_sym_readonly] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym_unset] = ACTIONS(929),
    [anon_sym_unsetenv] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [sym_raw_string] = ACTIONS(947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [anon_sym_LT_LPAREN] = ACTIONS(959),
    [anon_sym_GT_LPAREN] = ACTIONS(959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(962),
  },
  [274] = {
    [sym_file_redirect] = STATE(649),
    [sym_heredoc_redirect] = STATE(649),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(649),
    [sym_concatenation] = STATE(652),
    [sym_string] = STATE(268),
    [sym_simple_expansion] = STATE(268),
    [sym_string_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [aux_sym_while_statement_repeat1] = STATE(649),
    [aux_sym_command_repeat2] = STATE(652),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(483),
    [sym__special_characters] = ACTIONS(485),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(489),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [275] = {
    [sym_concatenation] = STATE(653),
    [sym_string] = STATE(656),
    [sym_array] = STATE(653),
    [sym_simple_expansion] = STATE(656),
    [sym_string_expansion] = STATE(656),
    [sym_expansion] = STATE(656),
    [sym_command_substitution] = STATE(656),
    [sym_process_substitution] = STATE(656),
    [sym__empty_value] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [sym__special_characters] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(213),
    [sym_raw_string] = ACTIONS(1243),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(223),
    [anon_sym_GT_LPAREN] = ACTIONS(223),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1243),
  },
  [276] = {
    [sym__expression] = STATE(657),
    [sym_binary_expression] = STATE(657),
    [sym_unary_expression] = STATE(657),
    [sym_parenthesized_expression] = STATE(657),
    [sym_concatenation] = STATE(657),
    [sym_string] = STATE(278),
    [sym_simple_expansion] = STATE(278),
    [sym_string_expansion] = STATE(278),
    [sym_expansion] = STATE(278),
    [sym_command_substitution] = STATE(278),
    [sym_process_substitution] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(499),
    [sym__special_characters] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(505),
    [sym_test_operator] = ACTIONS(507),
  },
  [277] = {
    [aux_sym_concatenation_repeat1] = STATE(658),
    [sym__concat] = ACTIONS(549),
    [anon_sym_RPAREN] = ACTIONS(511),
    [anon_sym_AMP_AMP] = ACTIONS(511),
    [anon_sym_PIPE_PIPE] = ACTIONS(511),
    [anon_sym_EQ_TILDE] = ACTIONS(511),
    [anon_sym_EQ_EQ] = ACTIONS(511),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(511),
  },
  [278] = {
    [aux_sym_concatenation_repeat1] = STATE(658),
    [sym__concat] = ACTIONS(549),
    [anon_sym_RPAREN] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_EQ_TILDE] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(527),
  },
  [279] = {
    [anon_sym_RPAREN] = ACTIONS(1245),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_EQ_TILDE] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1249),
    [anon_sym_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1247),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1247),
  },
  [280] = {
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(1253),
    [anon_sym_EQ_TILDE] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_EQ] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(541),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(541),
  },
  [281] = {
    [sym_string] = STATE(662),
    [sym_simple_expansion] = STATE(662),
    [sym_string_expansion] = STATE(662),
    [sym_expansion] = STATE(662),
    [sym_command_substitution] = STATE(662),
    [sym_process_substitution] = STATE(662),
    [sym__special_characters] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1255),
  },
  [282] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__concat] = ACTIONS(509),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_RBRACK] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_EQ] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_BANG_EQ] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(695),
  },
  [283] = {
    [sym__concat] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(699),
    [anon_sym_EQ_TILDE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_EQ] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(699),
  },
  [284] = {
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [285] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [286] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_RBRACK] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(731),
  },
  [287] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_RBRACK] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(735),
  },
  [288] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_RBRACK] = ACTIONS(739),
    [anon_sym_EQ_TILDE] = ACTIONS(739),
    [anon_sym_EQ_EQ] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(739),
    [anon_sym_BANG_EQ] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(739),
  },
  [289] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(1261),
    [sym_comment] = ACTIONS(53),
  },
  [290] = {
    [sym_subscript] = STATE(670),
    [sym_variable_name] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1265),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_0] = ACTIONS(1269),
    [anon_sym__] = ACTIONS(1269),
  },
  [291] = {
    [sym_concatenation] = STATE(673),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(673),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_EQ] = ACTIONS(1273),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1277),
    [anon_sym_COLON] = ACTIONS(1273),
    [anon_sym_COLON_QMARK] = ACTIONS(1273),
    [anon_sym_COLON_DASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [292] = {
    [sym_concatenation] = STATE(676),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(676),
    [anon_sym_RBRACE] = ACTIONS(1279),
    [anon_sym_EQ] = ACTIONS(1281),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_COLON] = ACTIONS(1281),
    [anon_sym_COLON_QMARK] = ACTIONS(1281),
    [anon_sym_COLON_DASH] = ACTIONS(1281),
    [anon_sym_PERCENT] = ACTIONS(1281),
    [anon_sym_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [293] = {
    [sym_concatenation] = STATE(679),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(679),
    [anon_sym_RBRACE] = ACTIONS(1287),
    [anon_sym_EQ] = ACTIONS(1289),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1293),
    [anon_sym_COLON] = ACTIONS(1289),
    [anon_sym_COLON_QMARK] = ACTIONS(1289),
    [anon_sym_COLON_DASH] = ACTIONS(1289),
    [anon_sym_PERCENT] = ACTIONS(1289),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [294] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1295),
    [anon_sym_SEMI_SEMI] = ACTIONS(1297),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_LF] = ACTIONS(1297),
    [anon_sym_AMP] = ACTIONS(1299),
  },
  [295] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1295),
    [anon_sym_SEMI_SEMI] = ACTIONS(1297),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_LF] = ACTIONS(1297),
    [anon_sym_AMP] = ACTIONS(1299),
  },
  [296] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(682),
    [sym_c_style_for_statement] = STATE(682),
    [sym_while_statement] = STATE(682),
    [sym_if_statement] = STATE(682),
    [sym_case_statement] = STATE(682),
    [sym_function_definition] = STATE(682),
    [sym_subshell] = STATE(682),
    [sym_pipeline] = STATE(682),
    [sym_list] = STATE(682),
    [sym_negated_command] = STATE(682),
    [sym_test_command] = STATE(682),
    [sym_declaration_command] = STATE(682),
    [sym_unset_command] = STATE(682),
    [sym_command] = STATE(682),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(683),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [297] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1301),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_LF] = ACTIONS(1301),
    [anon_sym_AMP] = ACTIONS(1303),
  },
  [298] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1301),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_LF] = ACTIONS(1301),
    [anon_sym_AMP] = ACTIONS(1303),
  },
  [299] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(685),
    [sym_c_style_for_statement] = STATE(685),
    [sym_while_statement] = STATE(685),
    [sym_if_statement] = STATE(685),
    [sym_case_statement] = STATE(685),
    [sym_function_definition] = STATE(685),
    [sym_subshell] = STATE(685),
    [sym_pipeline] = STATE(685),
    [sym_list] = STATE(685),
    [sym_negated_command] = STATE(685),
    [sym_test_command] = STATE(685),
    [sym_declaration_command] = STATE(685),
    [sym_unset_command] = STATE(685),
    [sym_command] = STATE(685),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(686),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [300] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_SEMI_SEMI] = ACTIONS(1307),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1309),
    [anon_sym_LF] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1309),
  },
  [301] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_SEMI_SEMI] = ACTIONS(1307),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1309),
    [anon_sym_LF] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1309),
  },
  [302] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(689),
    [sym_c_style_for_statement] = STATE(689),
    [sym_while_statement] = STATE(689),
    [sym_if_statement] = STATE(689),
    [sym_case_statement] = STATE(689),
    [sym_function_definition] = STATE(689),
    [sym_subshell] = STATE(689),
    [sym_pipeline] = STATE(689),
    [sym_list] = STATE(689),
    [sym_negated_command] = STATE(689),
    [sym_test_command] = STATE(689),
    [sym_declaration_command] = STATE(689),
    [sym_unset_command] = STATE(689),
    [sym_command] = STATE(689),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(690),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [303] = {
    [sym__expression] = STATE(691),
    [sym_binary_expression] = STATE(691),
    [sym_unary_expression] = STATE(691),
    [sym_parenthesized_expression] = STATE(691),
    [sym_concatenation] = STATE(691),
    [sym_string] = STATE(78),
    [sym_simple_expansion] = STATE(78),
    [sym_string_expansion] = STATE(78),
    [sym_expansion] = STATE(78),
    [sym_command_substitution] = STATE(78),
    [sym_process_substitution] = STATE(78),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [sym__special_characters] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(131),
    [sym_test_operator] = ACTIONS(133),
  },
  [304] = {
    [sym_file_redirect] = STATE(696),
    [sym_heredoc_redirect] = STATE(696),
    [sym_herestring_redirect] = STATE(696),
    [aux_sym_while_statement_repeat1] = STATE(696),
    [sym_file_descriptor] = ACTIONS(1311),
    [anon_sym_PIPE] = ACTIONS(1313),
    [anon_sym_SEMI_SEMI] = ACTIONS(1315),
    [anon_sym_PIPE_AMP] = ACTIONS(1315),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1317),
    [anon_sym_GT] = ACTIONS(1317),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_AMP_GT] = ACTIONS(1317),
    [anon_sym_AMP_GT_GT] = ACTIONS(1319),
    [anon_sym_LT_AMP] = ACTIONS(1319),
    [anon_sym_GT_AMP] = ACTIONS(1319),
    [anon_sym_LT_LT] = ACTIONS(1321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1323),
    [anon_sym_LT_LT_LT] = ACTIONS(1325),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1313),
    [anon_sym_LF] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1313),
  },
  [305] = {
    [sym__expression] = STATE(691),
    [sym_binary_expression] = STATE(691),
    [sym_unary_expression] = STATE(691),
    [sym_parenthesized_expression] = STATE(691),
    [sym_concatenation] = STATE(691),
    [sym_string] = STATE(78),
    [sym_simple_expansion] = STATE(78),
    [sym_string_expansion] = STATE(78),
    [sym_expansion] = STATE(78),
    [sym_command_substitution] = STATE(78),
    [sym_process_substitution] = STATE(78),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(113),
    [sym__special_characters] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1335),
    [anon_sym_BQUOTE] = ACTIONS(1337),
    [anon_sym_LT_LPAREN] = ACTIONS(1339),
    [anon_sym_GT_LPAREN] = ACTIONS(1339),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(131),
    [sym_test_operator] = ACTIONS(113),
    [sym_regex] = ACTIONS(1341),
  },
  [306] = {
    [anon_sym_RPAREN] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_EQ_TILDE] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1249),
    [anon_sym_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1247),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1247),
  },
  [307] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1253),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [308] = {
    [sym_string] = STATE(699),
    [sym_simple_expansion] = STATE(699),
    [sym_string_expansion] = STATE(699),
    [sym_expansion] = STATE(699),
    [sym_command_substitution] = STATE(699),
    [sym_process_substitution] = STATE(699),
    [sym__special_characters] = ACTIONS(1345),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(1345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1345),
  },
  [309] = {
    [aux_sym_concatenation_repeat1] = STATE(700),
    [sym__concat] = ACTIONS(549),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_EQ] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_BANG_EQ] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(695),
  },
  [310] = {
    [sym__concat] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(699),
    [anon_sym_EQ_TILDE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_EQ] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(699),
  },
  [311] = {
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [312] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [313] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(731),
  },
  [314] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(735),
  },
  [315] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(739),
    [anon_sym_EQ_TILDE] = ACTIONS(739),
    [anon_sym_EQ_EQ] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(739),
    [anon_sym_BANG_EQ] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(739),
  },
  [316] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(1351),
    [sym_comment] = ACTIONS(53),
  },
  [317] = {
    [sym_subscript] = STATE(707),
    [sym_variable_name] = ACTIONS(1353),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1355),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_0] = ACTIONS(1359),
    [anon_sym__] = ACTIONS(1359),
  },
  [318] = {
    [sym_concatenation] = STATE(710),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(710),
    [anon_sym_RBRACE] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1363),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1367),
    [anon_sym_COLON] = ACTIONS(1363),
    [anon_sym_COLON_QMARK] = ACTIONS(1363),
    [anon_sym_COLON_DASH] = ACTIONS(1363),
    [anon_sym_PERCENT] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [319] = {
    [sym_concatenation] = STATE(713),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(713),
    [anon_sym_RBRACE] = ACTIONS(1369),
    [anon_sym_EQ] = ACTIONS(1371),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1375),
    [anon_sym_COLON] = ACTIONS(1371),
    [anon_sym_COLON_QMARK] = ACTIONS(1371),
    [anon_sym_COLON_DASH] = ACTIONS(1371),
    [anon_sym_PERCENT] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [320] = {
    [sym_concatenation] = STATE(716),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(716),
    [anon_sym_RBRACE] = ACTIONS(1377),
    [anon_sym_EQ] = ACTIONS(1379),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1383),
    [anon_sym_COLON] = ACTIONS(1379),
    [anon_sym_COLON_QMARK] = ACTIONS(1379),
    [anon_sym_COLON_DASH] = ACTIONS(1379),
    [anon_sym_PERCENT] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [321] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1389),
    [anon_sym_LF] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1389),
  },
  [322] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1389),
    [anon_sym_LF] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1389),
  },
  [323] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(719),
    [sym_c_style_for_statement] = STATE(719),
    [sym_while_statement] = STATE(719),
    [sym_if_statement] = STATE(719),
    [sym_case_statement] = STATE(719),
    [sym_function_definition] = STATE(719),
    [sym_subshell] = STATE(719),
    [sym_pipeline] = STATE(719),
    [sym_list] = STATE(719),
    [sym_negated_command] = STATE(719),
    [sym_test_command] = STATE(719),
    [sym_declaration_command] = STATE(719),
    [sym_unset_command] = STATE(719),
    [sym_command] = STATE(719),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(720),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [324] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1391),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_LF] = ACTIONS(1391),
    [anon_sym_AMP] = ACTIONS(1393),
  },
  [325] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1391),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_LF] = ACTIONS(1391),
    [anon_sym_AMP] = ACTIONS(1393),
  },
  [326] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(722),
    [sym_c_style_for_statement] = STATE(722),
    [sym_while_statement] = STATE(722),
    [sym_if_statement] = STATE(722),
    [sym_case_statement] = STATE(722),
    [sym_function_definition] = STATE(722),
    [sym_subshell] = STATE(722),
    [sym_pipeline] = STATE(722),
    [sym_list] = STATE(722),
    [sym_negated_command] = STATE(722),
    [sym_test_command] = STATE(722),
    [sym_declaration_command] = STATE(722),
    [sym_unset_command] = STATE(722),
    [sym_command] = STATE(722),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(723),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [327] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1395),
    [anon_sym_SEMI_SEMI] = ACTIONS(1397),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_LF] = ACTIONS(1397),
    [anon_sym_AMP] = ACTIONS(1399),
  },
  [328] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1395),
    [anon_sym_SEMI_SEMI] = ACTIONS(1397),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_LF] = ACTIONS(1397),
    [anon_sym_AMP] = ACTIONS(1399),
  },
  [329] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(726),
    [sym_c_style_for_statement] = STATE(726),
    [sym_while_statement] = STATE(726),
    [sym_if_statement] = STATE(726),
    [sym_case_statement] = STATE(726),
    [sym_function_definition] = STATE(726),
    [sym_subshell] = STATE(726),
    [sym_pipeline] = STATE(726),
    [sym_list] = STATE(726),
    [sym_negated_command] = STATE(726),
    [sym_test_command] = STATE(726),
    [sym_declaration_command] = STATE(726),
    [sym_unset_command] = STATE(726),
    [sym_command] = STATE(726),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(727),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [330] = {
    [sym__expression] = STATE(728),
    [sym_binary_expression] = STATE(728),
    [sym_unary_expression] = STATE(728),
    [sym_parenthesized_expression] = STATE(728),
    [sym_concatenation] = STATE(728),
    [sym_string] = STATE(89),
    [sym_simple_expansion] = STATE(89),
    [sym_string_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [sym_process_substitution] = STATE(89),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [sym__special_characters] = ACTIONS(139),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(155),
    [sym_test_operator] = ACTIONS(157),
  },
  [331] = {
    [sym__expression] = STATE(728),
    [sym_binary_expression] = STATE(728),
    [sym_unary_expression] = STATE(728),
    [sym_parenthesized_expression] = STATE(728),
    [sym_concatenation] = STATE(728),
    [sym_string] = STATE(89),
    [sym_simple_expansion] = STATE(89),
    [sym_string_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [sym_process_substitution] = STATE(89),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(137),
    [sym__special_characters] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(1405),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(155),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1411),
    [anon_sym_LT_LPAREN] = ACTIONS(1413),
    [anon_sym_GT_LPAREN] = ACTIONS(1413),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(155),
    [sym_test_operator] = ACTIONS(137),
    [sym_regex] = ACTIONS(1415),
  },
  [332] = {
    [sym_concatenation] = STATE(730),
    [sym_string] = STATE(733),
    [sym_array] = STATE(730),
    [sym_simple_expansion] = STATE(733),
    [sym_string_expansion] = STATE(733),
    [sym_expansion] = STATE(733),
    [sym_command_substitution] = STATE(733),
    [sym_process_substitution] = STATE(733),
    [sym__empty_value] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [sym__special_characters] = ACTIONS(1421),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(169),
    [sym_raw_string] = ACTIONS(1423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1423),
  },
  [333] = {
    [sym_string] = STATE(734),
    [sym_simple_expansion] = STATE(734),
    [sym_string_expansion] = STATE(734),
    [sym_expansion] = STATE(734),
    [sym_command_substitution] = STATE(734),
    [sym_process_substitution] = STATE(734),
    [sym__special_characters] = ACTIONS(1425),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(169),
    [sym_raw_string] = ACTIONS(1425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1425),
  },
  [334] = {
    [aux_sym_concatenation_repeat1] = STATE(735),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [335] = {
    [sym__concat] = ACTIONS(699),
    [sym_variable_name] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(701),
    [sym_word] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
  },
  [336] = {
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [337] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(1429),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [338] = {
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [339] = {
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [340] = {
    [sym__concat] = ACTIONS(739),
    [sym_variable_name] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(741),
    [sym_word] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [341] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(1431),
    [sym_comment] = ACTIONS(53),
  },
  [342] = {
    [sym_subscript] = STATE(742),
    [sym_variable_name] = ACTIONS(1433),
    [anon_sym_DOLLAR] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1435),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AT] = ACTIONS(1435),
    [anon_sym_QMARK] = ACTIONS(1435),
    [anon_sym_0] = ACTIONS(1439),
    [anon_sym__] = ACTIONS(1439),
  },
  [343] = {
    [sym_concatenation] = STATE(745),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(745),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_EQ] = ACTIONS(1443),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1447),
    [anon_sym_COLON] = ACTIONS(1443),
    [anon_sym_COLON_QMARK] = ACTIONS(1443),
    [anon_sym_COLON_DASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_DASH] = ACTIONS(1443),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [344] = {
    [sym_concatenation] = STATE(748),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(748),
    [anon_sym_RBRACE] = ACTIONS(1449),
    [anon_sym_EQ] = ACTIONS(1451),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1455),
    [anon_sym_COLON] = ACTIONS(1451),
    [anon_sym_COLON_QMARK] = ACTIONS(1451),
    [anon_sym_COLON_DASH] = ACTIONS(1451),
    [anon_sym_PERCENT] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [345] = {
    [sym_concatenation] = STATE(751),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(751),
    [anon_sym_RBRACE] = ACTIONS(1457),
    [anon_sym_EQ] = ACTIONS(1459),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1463),
    [anon_sym_COLON] = ACTIONS(1459),
    [anon_sym_COLON_QMARK] = ACTIONS(1459),
    [anon_sym_COLON_DASH] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [346] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [anon_sym_SEMI_SEMI] = ACTIONS(1467),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_LF] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1469),
  },
  [347] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [anon_sym_SEMI_SEMI] = ACTIONS(1467),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_LF] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1469),
  },
  [348] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(754),
    [sym_c_style_for_statement] = STATE(754),
    [sym_while_statement] = STATE(754),
    [sym_if_statement] = STATE(754),
    [sym_case_statement] = STATE(754),
    [sym_function_definition] = STATE(754),
    [sym_subshell] = STATE(754),
    [sym_pipeline] = STATE(754),
    [sym_list] = STATE(754),
    [sym_negated_command] = STATE(754),
    [sym_test_command] = STATE(754),
    [sym_declaration_command] = STATE(754),
    [sym_unset_command] = STATE(754),
    [sym_command] = STATE(754),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(755),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [349] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1471),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_LF] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1473),
  },
  [350] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1471),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_LF] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1473),
  },
  [351] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(757),
    [sym_c_style_for_statement] = STATE(757),
    [sym_while_statement] = STATE(757),
    [sym_if_statement] = STATE(757),
    [sym_case_statement] = STATE(757),
    [sym_function_definition] = STATE(757),
    [sym_subshell] = STATE(757),
    [sym_pipeline] = STATE(757),
    [sym_list] = STATE(757),
    [sym_negated_command] = STATE(757),
    [sym_test_command] = STATE(757),
    [sym_declaration_command] = STATE(757),
    [sym_unset_command] = STATE(757),
    [sym_command] = STATE(757),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(758),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [352] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_SEMI_SEMI] = ACTIONS(1477),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_LF] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
  },
  [353] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_SEMI_SEMI] = ACTIONS(1477),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_LF] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
  },
  [354] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(761),
    [sym_c_style_for_statement] = STATE(761),
    [sym_while_statement] = STATE(761),
    [sym_if_statement] = STATE(761),
    [sym_case_statement] = STATE(761),
    [sym_function_definition] = STATE(761),
    [sym_subshell] = STATE(761),
    [sym_pipeline] = STATE(761),
    [sym_list] = STATE(761),
    [sym_negated_command] = STATE(761),
    [sym_test_command] = STATE(761),
    [sym_declaration_command] = STATE(761),
    [sym_unset_command] = STATE(761),
    [sym_command] = STATE(761),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(762),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [355] = {
    [sym_variable_assignment] = STATE(355),
    [sym_subscript] = STATE(105),
    [sym_concatenation] = STATE(355),
    [sym_string] = STATE(99),
    [sym_simple_expansion] = STATE(99),
    [sym_string_expansion] = STATE(99),
    [sym_expansion] = STATE(99),
    [sym_command_substitution] = STATE(99),
    [sym_process_substitution] = STATE(99),
    [aux_sym_declaration_command_repeat1] = STATE(355),
    [sym_variable_name] = ACTIONS(1481),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_SEMI_SEMI] = ACTIONS(1486),
    [anon_sym_PIPE_AMP] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [sym__special_characters] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(1491),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [sym_raw_string] = ACTIONS(1497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1503),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LPAREN] = ACTIONS(1509),
    [anon_sym_GT_LPAREN] = ACTIONS(1509),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1512),
    [sym_word] = ACTIONS(1515),
    [anon_sym_SEMI] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1484),
  },
  [356] = {
    [sym_string] = STATE(763),
    [sym_simple_expansion] = STATE(763),
    [sym_string_expansion] = STATE(763),
    [sym_expansion] = STATE(763),
    [sym_command_substitution] = STATE(763),
    [sym_process_substitution] = STATE(763),
    [sym__special_characters] = ACTIONS(1518),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1518),
  },
  [357] = {
    [aux_sym_concatenation_repeat1] = STATE(764),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [358] = {
    [sym__concat] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(701),
    [sym_word] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
  },
  [359] = {
    [anon_sym_DQUOTE] = ACTIONS(1520),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [360] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(1520),
    [anon_sym_DOLLAR] = ACTIONS(1522),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [361] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [362] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [363] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(741),
    [sym_word] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [364] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(1524),
    [sym_comment] = ACTIONS(53),
  },
  [365] = {
    [sym_subscript] = STATE(771),
    [sym_variable_name] = ACTIONS(1526),
    [anon_sym_DOLLAR] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1528),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(1528),
    [anon_sym_AT] = ACTIONS(1528),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_0] = ACTIONS(1532),
    [anon_sym__] = ACTIONS(1532),
  },
  [366] = {
    [sym_concatenation] = STATE(774),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(774),
    [anon_sym_RBRACE] = ACTIONS(1534),
    [anon_sym_EQ] = ACTIONS(1536),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_COLON] = ACTIONS(1536),
    [anon_sym_COLON_QMARK] = ACTIONS(1536),
    [anon_sym_COLON_DASH] = ACTIONS(1536),
    [anon_sym_PERCENT] = ACTIONS(1536),
    [anon_sym_DASH] = ACTIONS(1536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [367] = {
    [sym_concatenation] = STATE(777),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(777),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1544),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1548),
    [anon_sym_COLON] = ACTIONS(1544),
    [anon_sym_COLON_QMARK] = ACTIONS(1544),
    [anon_sym_COLON_DASH] = ACTIONS(1544),
    [anon_sym_PERCENT] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [368] = {
    [sym_concatenation] = STATE(780),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(780),
    [anon_sym_RBRACE] = ACTIONS(1550),
    [anon_sym_EQ] = ACTIONS(1552),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1556),
    [anon_sym_COLON] = ACTIONS(1552),
    [anon_sym_COLON_QMARK] = ACTIONS(1552),
    [anon_sym_COLON_DASH] = ACTIONS(1552),
    [anon_sym_PERCENT] = ACTIONS(1552),
    [anon_sym_DASH] = ACTIONS(1552),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [369] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1558),
    [anon_sym_SEMI_SEMI] = ACTIONS(1560),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1562),
    [anon_sym_LF] = ACTIONS(1560),
    [anon_sym_AMP] = ACTIONS(1562),
  },
  [370] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1558),
    [anon_sym_SEMI_SEMI] = ACTIONS(1560),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1562),
    [anon_sym_LF] = ACTIONS(1560),
    [anon_sym_AMP] = ACTIONS(1562),
  },
  [371] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(783),
    [sym_c_style_for_statement] = STATE(783),
    [sym_while_statement] = STATE(783),
    [sym_if_statement] = STATE(783),
    [sym_case_statement] = STATE(783),
    [sym_function_definition] = STATE(783),
    [sym_subshell] = STATE(783),
    [sym_pipeline] = STATE(783),
    [sym_list] = STATE(783),
    [sym_negated_command] = STATE(783),
    [sym_test_command] = STATE(783),
    [sym_declaration_command] = STATE(783),
    [sym_unset_command] = STATE(783),
    [sym_command] = STATE(783),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(784),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [372] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1564),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(1558),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1566),
    [anon_sym_LF] = ACTIONS(1564),
    [anon_sym_AMP] = ACTIONS(1566),
  },
  [373] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1564),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(1558),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1566),
    [anon_sym_LF] = ACTIONS(1564),
    [anon_sym_AMP] = ACTIONS(1566),
  },
  [374] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(786),
    [sym_c_style_for_statement] = STATE(786),
    [sym_while_statement] = STATE(786),
    [sym_if_statement] = STATE(786),
    [sym_case_statement] = STATE(786),
    [sym_function_definition] = STATE(786),
    [sym_subshell] = STATE(786),
    [sym_pipeline] = STATE(786),
    [sym_list] = STATE(786),
    [sym_negated_command] = STATE(786),
    [sym_test_command] = STATE(786),
    [sym_declaration_command] = STATE(786),
    [sym_unset_command] = STATE(786),
    [sym_command] = STATE(786),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(787),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [375] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1568),
    [anon_sym_SEMI_SEMI] = ACTIONS(1570),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1572),
    [anon_sym_LF] = ACTIONS(1570),
    [anon_sym_AMP] = ACTIONS(1572),
  },
  [376] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1568),
    [anon_sym_SEMI_SEMI] = ACTIONS(1570),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1572),
    [anon_sym_LF] = ACTIONS(1570),
    [anon_sym_AMP] = ACTIONS(1572),
  },
  [377] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(790),
    [sym_c_style_for_statement] = STATE(790),
    [sym_while_statement] = STATE(790),
    [sym_if_statement] = STATE(790),
    [sym_case_statement] = STATE(790),
    [sym_function_definition] = STATE(790),
    [sym_subshell] = STATE(790),
    [sym_pipeline] = STATE(790),
    [sym_list] = STATE(790),
    [sym_negated_command] = STATE(790),
    [sym_test_command] = STATE(790),
    [sym_declaration_command] = STATE(790),
    [sym_unset_command] = STATE(790),
    [sym_command] = STATE(790),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(791),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [378] = {
    [sym_concatenation] = STATE(378),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_string_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_unset_command_repeat1] = STATE(378),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_SEMI_SEMI] = ACTIONS(1576),
    [anon_sym_PIPE_AMP] = ACTIONS(1576),
    [anon_sym_AMP_AMP] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1576),
    [sym__special_characters] = ACTIONS(1578),
    [anon_sym_DQUOTE] = ACTIONS(1581),
    [anon_sym_DOLLAR] = ACTIONS(1584),
    [sym_raw_string] = ACTIONS(1587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1593),
    [anon_sym_BQUOTE] = ACTIONS(1596),
    [anon_sym_LT_LPAREN] = ACTIONS(1599),
    [anon_sym_GT_LPAREN] = ACTIONS(1599),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1602),
    [sym_word] = ACTIONS(1605),
    [anon_sym_SEMI] = ACTIONS(1574),
    [anon_sym_LF] = ACTIONS(1576),
    [anon_sym_AMP] = ACTIONS(1574),
  },
  [379] = {
    [sym_string] = STATE(792),
    [sym_simple_expansion] = STATE(792),
    [sym_string_expansion] = STATE(792),
    [sym_expansion] = STATE(792),
    [sym_command_substitution] = STATE(792),
    [sym_process_substitution] = STATE(792),
    [sym__special_characters] = ACTIONS(1608),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(213),
    [sym_raw_string] = ACTIONS(1608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(223),
    [anon_sym_GT_LPAREN] = ACTIONS(223),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1608),
  },
  [380] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(695),
  },
  [381] = {
    [sym_file_descriptor] = ACTIONS(699),
    [sym__concat] = ACTIONS(699),
    [sym_variable_name] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(701),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(699),
  },
  [382] = {
    [anon_sym_DQUOTE] = ACTIONS(1610),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [383] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(1610),
    [anon_sym_DOLLAR] = ACTIONS(1612),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [384] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(731),
  },
  [385] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(735),
  },
  [386] = {
    [sym_file_descriptor] = ACTIONS(739),
    [sym__concat] = ACTIONS(739),
    [sym_variable_name] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(739),
  },
  [387] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(1614),
    [sym_comment] = ACTIONS(53),
  },
  [388] = {
    [sym_subscript] = STATE(800),
    [sym_variable_name] = ACTIONS(1616),
    [anon_sym_DOLLAR] = ACTIONS(1618),
    [anon_sym_DASH] = ACTIONS(1618),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1620),
    [anon_sym_STAR] = ACTIONS(1618),
    [anon_sym_AT] = ACTIONS(1618),
    [anon_sym_QMARK] = ACTIONS(1618),
    [anon_sym_0] = ACTIONS(1622),
    [anon_sym__] = ACTIONS(1622),
  },
  [389] = {
    [sym_concatenation] = STATE(803),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(803),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_EQ] = ACTIONS(1626),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1628),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1630),
    [anon_sym_COLON] = ACTIONS(1626),
    [anon_sym_COLON_QMARK] = ACTIONS(1626),
    [anon_sym_COLON_DASH] = ACTIONS(1626),
    [anon_sym_PERCENT] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [390] = {
    [sym_concatenation] = STATE(806),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(806),
    [anon_sym_RBRACE] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(1634),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1638),
    [anon_sym_COLON] = ACTIONS(1634),
    [anon_sym_COLON_QMARK] = ACTIONS(1634),
    [anon_sym_COLON_DASH] = ACTIONS(1634),
    [anon_sym_PERCENT] = ACTIONS(1634),
    [anon_sym_DASH] = ACTIONS(1634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [391] = {
    [sym_concatenation] = STATE(809),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(809),
    [anon_sym_RBRACE] = ACTIONS(1640),
    [anon_sym_EQ] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1646),
    [anon_sym_COLON] = ACTIONS(1642),
    [anon_sym_COLON_QMARK] = ACTIONS(1642),
    [anon_sym_COLON_DASH] = ACTIONS(1642),
    [anon_sym_PERCENT] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [392] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1652),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1652),
  },
  [393] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1652),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1652),
  },
  [394] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(812),
    [sym_c_style_for_statement] = STATE(812),
    [sym_while_statement] = STATE(812),
    [sym_if_statement] = STATE(812),
    [sym_case_statement] = STATE(812),
    [sym_function_definition] = STATE(812),
    [sym_subshell] = STATE(812),
    [sym_pipeline] = STATE(812),
    [sym_list] = STATE(812),
    [sym_negated_command] = STATE(812),
    [sym_test_command] = STATE(812),
    [sym_declaration_command] = STATE(812),
    [sym_unset_command] = STATE(812),
    [sym_command] = STATE(812),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(813),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [395] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [396] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [397] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(815),
    [sym_c_style_for_statement] = STATE(815),
    [sym_while_statement] = STATE(815),
    [sym_if_statement] = STATE(815),
    [sym_case_statement] = STATE(815),
    [sym_function_definition] = STATE(815),
    [sym_subshell] = STATE(815),
    [sym_pipeline] = STATE(815),
    [sym_list] = STATE(815),
    [sym_negated_command] = STATE(815),
    [sym_test_command] = STATE(815),
    [sym_declaration_command] = STATE(815),
    [sym_unset_command] = STATE(815),
    [sym_command] = STATE(815),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(816),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [398] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1658),
    [anon_sym_SEMI_SEMI] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [399] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1658),
    [anon_sym_SEMI_SEMI] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [400] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(819),
    [sym_c_style_for_statement] = STATE(819),
    [sym_while_statement] = STATE(819),
    [sym_if_statement] = STATE(819),
    [sym_case_statement] = STATE(819),
    [sym_function_definition] = STATE(819),
    [sym_subshell] = STATE(819),
    [sym_pipeline] = STATE(819),
    [sym_list] = STATE(819),
    [sym_negated_command] = STATE(819),
    [sym_test_command] = STATE(819),
    [sym_declaration_command] = STATE(819),
    [sym_unset_command] = STATE(819),
    [sym_command] = STATE(819),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(820),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [401] = {
    [sym__simple_heredoc_body] = ACTIONS(1664),
    [sym__heredoc_body_beginning] = ACTIONS(1664),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1666),
    [anon_sym_EQ_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [402] = {
    [aux_sym_concatenation_repeat1] = STATE(402),
    [sym__simple_heredoc_body] = ACTIONS(1664),
    [sym__heredoc_body_beginning] = ACTIONS(1664),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1668),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1666),
    [anon_sym_EQ_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [403] = {
    [sym__simple_heredoc_body] = ACTIONS(1671),
    [sym__heredoc_body_beginning] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_EQ_TILDE] = ACTIONS(1673),
    [anon_sym_EQ_EQ] = ACTIONS(1673),
    [anon_sym_LT] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1673),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1673),
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1673),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1673),
  },
  [404] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym__string_content] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(243),
  },
  [405] = {
    [sym__concat] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1677),
    [anon_sym_DOLLAR] = ACTIONS(1677),
    [sym__string_content] = ACTIONS(1679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1677),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_comment] = ACTIONS(243),
  },
  [406] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(741),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym__string_content] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(741),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(741),
    [anon_sym_BQUOTE] = ACTIONS(741),
    [sym_comment] = ACTIONS(243),
  },
  [407] = {
    [anon_sym_DQUOTE] = ACTIONS(1677),
    [anon_sym_DOLLAR] = ACTIONS(1677),
    [sym__string_content] = ACTIONS(1679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1677),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_comment] = ACTIONS(243),
  },
  [408] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(1681),
    [sym_comment] = ACTIONS(53),
  },
  [409] = {
    [sym_subscript] = STATE(826),
    [sym_variable_name] = ACTIONS(1683),
    [anon_sym_DOLLAR] = ACTIONS(1685),
    [anon_sym_DASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1687),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_AT] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1685),
    [anon_sym_0] = ACTIONS(1689),
    [anon_sym__] = ACTIONS(1689),
  },
  [410] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(1691),
    [anon_sym_EQ] = ACTIONS(1693),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1697),
    [anon_sym_COLON] = ACTIONS(1693),
    [anon_sym_COLON_QMARK] = ACTIONS(1693),
    [anon_sym_COLON_DASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [411] = {
    [sym_concatenation] = STATE(832),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(832),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_EQ] = ACTIONS(1701),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1703),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1705),
    [anon_sym_COLON] = ACTIONS(1701),
    [anon_sym_COLON_QMARK] = ACTIONS(1701),
    [anon_sym_COLON_DASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [anon_sym_DASH] = ACTIONS(1701),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [412] = {
    [sym_concatenation] = STATE(835),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(835),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1709),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1713),
    [anon_sym_COLON] = ACTIONS(1709),
    [anon_sym_COLON_QMARK] = ACTIONS(1709),
    [anon_sym_COLON_DASH] = ACTIONS(1709),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [413] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1715),
    [anon_sym_SEMI_SEMI] = ACTIONS(1717),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_LF] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1719),
  },
  [414] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1715),
    [anon_sym_SEMI_SEMI] = ACTIONS(1717),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_LF] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1719),
  },
  [415] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(838),
    [sym_c_style_for_statement] = STATE(838),
    [sym_while_statement] = STATE(838),
    [sym_if_statement] = STATE(838),
    [sym_case_statement] = STATE(838),
    [sym_function_definition] = STATE(838),
    [sym_subshell] = STATE(838),
    [sym_pipeline] = STATE(838),
    [sym_list] = STATE(838),
    [sym_negated_command] = STATE(838),
    [sym_test_command] = STATE(838),
    [sym_declaration_command] = STATE(838),
    [sym_unset_command] = STATE(838),
    [sym_command] = STATE(838),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(839),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [416] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1721),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(1715),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_LF] = ACTIONS(1721),
    [anon_sym_AMP] = ACTIONS(1723),
  },
  [417] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1721),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(1715),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_LF] = ACTIONS(1721),
    [anon_sym_AMP] = ACTIONS(1723),
  },
  [418] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(841),
    [sym_c_style_for_statement] = STATE(841),
    [sym_while_statement] = STATE(841),
    [sym_if_statement] = STATE(841),
    [sym_case_statement] = STATE(841),
    [sym_function_definition] = STATE(841),
    [sym_subshell] = STATE(841),
    [sym_pipeline] = STATE(841),
    [sym_list] = STATE(841),
    [sym_negated_command] = STATE(841),
    [sym_test_command] = STATE(841),
    [sym_declaration_command] = STATE(841),
    [sym_unset_command] = STATE(841),
    [sym_command] = STATE(841),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(842),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [419] = {
    [anon_sym_DQUOTE] = ACTIONS(1725),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [420] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(1677),
    [anon_sym_DOLLAR] = ACTIONS(1727),
    [sym__string_content] = ACTIONS(1730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1736),
    [anon_sym_BQUOTE] = ACTIONS(1739),
    [sym_comment] = ACTIONS(243),
  },
  [421] = {
    [sym_concatenation] = STATE(847),
    [sym_string] = STATE(846),
    [sym_simple_expansion] = STATE(846),
    [sym_string_expansion] = STATE(846),
    [sym_expansion] = STATE(846),
    [sym_command_substitution] = STATE(846),
    [sym_process_substitution] = STATE(846),
    [sym__special_characters] = ACTIONS(1742),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(1744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1744),
  },
  [422] = {
    [sym_concatenation] = STATE(857),
    [sym_string] = STATE(852),
    [sym_simple_expansion] = STATE(852),
    [sym_string_expansion] = STATE(852),
    [sym_expansion] = STATE(852),
    [sym_command_substitution] = STATE(852),
    [sym_process_substitution] = STATE(852),
    [anon_sym_RBRACE] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1748),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1754),
  },
  [423] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(1764),
    [sym_comment] = ACTIONS(53),
  },
  [424] = {
    [sym_concatenation] = STATE(861),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(861),
    [anon_sym_RBRACE] = ACTIONS(1766),
    [anon_sym_EQ] = ACTIONS(1768),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_COLON] = ACTIONS(1768),
    [anon_sym_COLON_QMARK] = ACTIONS(1768),
    [anon_sym_COLON_DASH] = ACTIONS(1768),
    [anon_sym_PERCENT] = ACTIONS(1768),
    [anon_sym_DASH] = ACTIONS(1768),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [425] = {
    [sym_concatenation] = STATE(864),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(864),
    [anon_sym_RBRACE] = ACTIONS(1774),
    [anon_sym_EQ] = ACTIONS(1776),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1780),
    [anon_sym_COLON] = ACTIONS(1776),
    [anon_sym_COLON_QMARK] = ACTIONS(1776),
    [anon_sym_COLON_DASH] = ACTIONS(1776),
    [anon_sym_PERCENT] = ACTIONS(1776),
    [anon_sym_DASH] = ACTIONS(1776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [426] = {
    [sym_concatenation] = STATE(866),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(866),
    [anon_sym_RBRACE] = ACTIONS(1746),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(1786),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [427] = {
    [sym__simple_heredoc_body] = ACTIONS(1788),
    [sym__heredoc_body_beginning] = ACTIONS(1788),
    [sym_file_descriptor] = ACTIONS(1788),
    [sym__concat] = ACTIONS(1788),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1788),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [anon_sym_PIPE_AMP] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [anon_sym_EQ_TILDE] = ACTIONS(1790),
    [anon_sym_EQ_EQ] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(1790),
    [anon_sym_GT] = ACTIONS(1790),
    [anon_sym_GT_GT] = ACTIONS(1788),
    [anon_sym_AMP_GT] = ACTIONS(1790),
    [anon_sym_AMP_GT_GT] = ACTIONS(1788),
    [anon_sym_LT_AMP] = ACTIONS(1788),
    [anon_sym_GT_AMP] = ACTIONS(1788),
    [anon_sym_LT_LT] = ACTIONS(1790),
    [anon_sym_LT_LT_DASH] = ACTIONS(1788),
    [anon_sym_LT_LT_LT] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1790),
  },
  [428] = {
    [aux_sym_concatenation_repeat1] = STATE(868),
    [sym__concat] = ACTIONS(1792),
    [anon_sym_RBRACE] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(1796),
    [sym__special_characters] = ACTIONS(1796),
    [anon_sym_DQUOTE] = ACTIONS(1794),
    [anon_sym_DOLLAR] = ACTIONS(1796),
    [sym_raw_string] = ACTIONS(1794),
    [anon_sym_POUND] = ACTIONS(1794),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1794),
    [anon_sym_COLON] = ACTIONS(1796),
    [anon_sym_COLON_QMARK] = ACTIONS(1796),
    [anon_sym_COLON_DASH] = ACTIONS(1796),
    [anon_sym_PERCENT] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1794),
    [anon_sym_BQUOTE] = ACTIONS(1794),
    [anon_sym_LT_LPAREN] = ACTIONS(1794),
    [anon_sym_GT_LPAREN] = ACTIONS(1794),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(1796),
  },
  [429] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(871),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [430] = {
    [sym_string] = STATE(873),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(1802),
    [sym_raw_string] = ACTIONS(1804),
    [anon_sym_POUND] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(1802),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1806),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_AT] = ACTIONS(1802),
    [anon_sym_QMARK] = ACTIONS(1802),
    [anon_sym_0] = ACTIONS(1808),
    [anon_sym__] = ACTIONS(1808),
  },
  [431] = {
    [aux_sym_concatenation_repeat1] = STATE(868),
    [sym__concat] = ACTIONS(1792),
    [anon_sym_RBRACE] = ACTIONS(1810),
    [anon_sym_EQ] = ACTIONS(1812),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1810),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1810),
    [anon_sym_POUND] = ACTIONS(1810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_COLON] = ACTIONS(1812),
    [anon_sym_COLON_QMARK] = ACTIONS(1812),
    [anon_sym_COLON_DASH] = ACTIONS(1812),
    [anon_sym_PERCENT] = ACTIONS(1812),
    [anon_sym_DASH] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1810),
    [anon_sym_LT_LPAREN] = ACTIONS(1810),
    [anon_sym_GT_LPAREN] = ACTIONS(1810),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(1812),
  },
  [432] = {
    [sym_subscript] = STATE(879),
    [sym_variable_name] = ACTIONS(1814),
    [anon_sym_BANG] = ACTIONS(1816),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [anon_sym_POUND] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1818),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1820),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_AT] = ACTIONS(1818),
    [anon_sym_QMARK] = ACTIONS(1818),
    [anon_sym_0] = ACTIONS(1822),
    [anon_sym__] = ACTIONS(1822),
  },
  [433] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(1824),
  },
  [434] = {
    [sym__terminated_statement] = STATE(883),
    [sym_for_statement] = STATE(881),
    [sym_c_style_for_statement] = STATE(881),
    [sym_while_statement] = STATE(881),
    [sym_if_statement] = STATE(881),
    [sym_case_statement] = STATE(881),
    [sym_function_definition] = STATE(881),
    [sym_subshell] = STATE(881),
    [sym_pipeline] = STATE(881),
    [sym_list] = STATE(881),
    [sym_negated_command] = STATE(881),
    [sym_test_command] = STATE(881),
    [sym_declaration_command] = STATE(881),
    [sym_unset_command] = STATE(881),
    [sym_command] = STATE(881),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(882),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(883),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [435] = {
    [sym__terminated_statement] = STATE(886),
    [sym_for_statement] = STATE(884),
    [sym_c_style_for_statement] = STATE(884),
    [sym_while_statement] = STATE(884),
    [sym_if_statement] = STATE(884),
    [sym_case_statement] = STATE(884),
    [sym_function_definition] = STATE(884),
    [sym_subshell] = STATE(884),
    [sym_pipeline] = STATE(884),
    [sym_list] = STATE(884),
    [sym_negated_command] = STATE(884),
    [sym_test_command] = STATE(884),
    [sym_declaration_command] = STATE(884),
    [sym_unset_command] = STATE(884),
    [sym_command] = STATE(884),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(885),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(886),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [436] = {
    [sym__terminated_statement] = STATE(889),
    [sym_for_statement] = STATE(887),
    [sym_c_style_for_statement] = STATE(887),
    [sym_while_statement] = STATE(887),
    [sym_if_statement] = STATE(887),
    [sym_case_statement] = STATE(887),
    [sym_function_definition] = STATE(887),
    [sym_subshell] = STATE(887),
    [sym_pipeline] = STATE(887),
    [sym_list] = STATE(887),
    [sym_negated_command] = STATE(887),
    [sym_test_command] = STATE(887),
    [sym_declaration_command] = STATE(887),
    [sym_unset_command] = STATE(887),
    [sym_command] = STATE(887),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(888),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(889),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [437] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [438] = {
    [sym__simple_heredoc_body] = ACTIONS(1832),
    [sym__heredoc_body_beginning] = ACTIONS(1832),
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1834),
    [anon_sym_EQ_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [anon_sym_LT_LT] = ACTIONS(1834),
    [anon_sym_LT_LT_DASH] = ACTIONS(1832),
    [anon_sym_LT_LT_LT] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [439] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(1836),
  },
  [440] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(1838),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [441] = {
    [sym__simple_heredoc_body] = ACTIONS(1840),
    [sym__heredoc_body_beginning] = ACTIONS(1840),
    [sym_file_descriptor] = ACTIONS(1840),
    [sym__concat] = ACTIONS(1840),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [anon_sym_PIPE_AMP] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_EQ_TILDE] = ACTIONS(1842),
    [anon_sym_EQ_EQ] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_GT] = ACTIONS(1842),
    [anon_sym_GT_GT] = ACTIONS(1840),
    [anon_sym_AMP_GT] = ACTIONS(1842),
    [anon_sym_AMP_GT_GT] = ACTIONS(1840),
    [anon_sym_LT_AMP] = ACTIONS(1840),
    [anon_sym_GT_AMP] = ACTIONS(1840),
    [anon_sym_LT_LT] = ACTIONS(1842),
    [anon_sym_LT_LT_DASH] = ACTIONS(1840),
    [anon_sym_LT_LT_LT] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [442] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(1844),
  },
  [443] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(1746),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [444] = {
    [sym__simple_heredoc_body] = ACTIONS(1846),
    [sym__heredoc_body_beginning] = ACTIONS(1846),
    [sym_file_descriptor] = ACTIONS(1846),
    [sym__concat] = ACTIONS(1846),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_EQ_TILDE] = ACTIONS(1848),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT] = ACTIONS(1848),
    [anon_sym_AMP_GT_GT] = ACTIONS(1846),
    [anon_sym_LT_AMP] = ACTIONS(1846),
    [anon_sym_GT_AMP] = ACTIONS(1846),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_LT_LT_DASH] = ACTIONS(1846),
    [anon_sym_LT_LT_LT] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1848),
  },
  [445] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(1850),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [446] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1850),
    [anon_sym_SEMI_SEMI] = ACTIONS(1852),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1854),
    [anon_sym_LF] = ACTIONS(1852),
    [anon_sym_AMP] = ACTIONS(1854),
  },
  [447] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1850),
    [anon_sym_SEMI_SEMI] = ACTIONS(1852),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1854),
    [anon_sym_LF] = ACTIONS(1852),
    [anon_sym_AMP] = ACTIONS(1854),
  },
  [448] = {
    [sym_do_group] = STATE(897),
    [anon_sym_do] = ACTIONS(395),
    [sym_comment] = ACTIONS(53),
  },
  [449] = {
    [sym_compound_statement] = STATE(899),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [450] = {
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(1858),
    [anon_sym_EQ_TILDE] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_EQ] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(541),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(541),
  },
  [451] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1858),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [452] = {
    [sym_variable_assignment] = STATE(355),
    [sym_subscript] = STATE(105),
    [sym_concatenation] = STATE(355),
    [sym_string] = STATE(99),
    [sym_simple_expansion] = STATE(99),
    [sym_string_expansion] = STATE(99),
    [sym_expansion] = STATE(99),
    [sym_command_substitution] = STATE(99),
    [sym_process_substitution] = STATE(99),
    [aux_sym_declaration_command_repeat1] = STATE(355),
    [sym_variable_name] = ACTIONS(159),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(619),
    [anon_sym_PIPE_AMP] = ACTIONS(619),
    [anon_sym_AMP_AMP] = ACTIONS(619),
    [anon_sym_PIPE_PIPE] = ACTIONS(619),
    [sym__special_characters] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(169),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(619),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(181),
    [sym_word] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [453] = {
    [sym_concatenation] = STATE(378),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_string_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_unset_command_repeat1] = STATE(378),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(659),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [sym__special_characters] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(195),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(659),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(205),
    [sym_word] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(657),
  },
  [454] = {
    [anon_sym_RPAREN] = ACTIONS(1860),
    [sym_comment] = ACTIONS(53),
  },
  [455] = {
    [sym_for_statement] = STATE(471),
    [sym_c_style_for_statement] = STATE(471),
    [sym_while_statement] = STATE(471),
    [sym_if_statement] = STATE(471),
    [sym_case_statement] = STATE(471),
    [sym_function_definition] = STATE(471),
    [sym_subshell] = STATE(471),
    [sym_pipeline] = STATE(471),
    [sym_list] = STATE(471),
    [sym_negated_command] = STATE(471),
    [sym_test_command] = STATE(471),
    [sym_declaration_command] = STATE(471),
    [sym_unset_command] = STATE(471),
    [sym_command] = STATE(471),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(902),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [456] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(1850),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [457] = {
    [sym_for_statement] = STATE(903),
    [sym_c_style_for_statement] = STATE(903),
    [sym_while_statement] = STATE(903),
    [sym_if_statement] = STATE(903),
    [sym_case_statement] = STATE(903),
    [sym_function_definition] = STATE(903),
    [sym_subshell] = STATE(903),
    [sym_pipeline] = STATE(903),
    [sym_list] = STATE(903),
    [sym_negated_command] = STATE(903),
    [sym_test_command] = STATE(903),
    [sym_declaration_command] = STATE(903),
    [sym_unset_command] = STATE(903),
    [sym_command] = STATE(903),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(904),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [458] = {
    [anon_sym_LT] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1862),
    [anon_sym_GT_GT] = ACTIONS(1864),
    [anon_sym_AMP_GT] = ACTIONS(1862),
    [anon_sym_AMP_GT_GT] = ACTIONS(1864),
    [anon_sym_LT_AMP] = ACTIONS(1864),
    [anon_sym_GT_AMP] = ACTIONS(1864),
    [sym_comment] = ACTIONS(53),
  },
  [459] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(907),
    [sym_simple_expansion] = STATE(907),
    [sym_string_expansion] = STATE(907),
    [sym_expansion] = STATE(907),
    [sym_command_substitution] = STATE(907),
    [sym_process_substitution] = STATE(907),
    [sym__special_characters] = ACTIONS(1866),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1868),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1868),
  },
  [460] = {
    [sym_concatenation] = STATE(489),
    [sym_string] = STATE(909),
    [sym_simple_expansion] = STATE(909),
    [sym_string_expansion] = STATE(909),
    [sym_expansion] = STATE(909),
    [sym_command_substitution] = STATE(909),
    [sym_process_substitution] = STATE(909),
    [sym__special_characters] = ACTIONS(1870),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1872),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1872),
  },
  [461] = {
    [sym_file_redirect] = STATE(910),
    [sym_heredoc_redirect] = STATE(910),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(910),
    [aux_sym_while_statement_repeat1] = STATE(910),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(887),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [462] = {
    [sym_file_redirect] = STATE(911),
    [sym_heredoc_redirect] = STATE(911),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(911),
    [sym_concatenation] = STATE(493),
    [sym_string] = STATE(174),
    [sym_simple_expansion] = STATE(174),
    [sym_string_expansion] = STATE(174),
    [sym_expansion] = STATE(174),
    [sym_command_substitution] = STATE(174),
    [sym_process_substitution] = STATE(174),
    [aux_sym_while_statement_repeat1] = STATE(911),
    [aux_sym_command_repeat2] = STATE(493),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(307),
    [anon_sym_EQ_EQ] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(823),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(887),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [463] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1874),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(1850),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1876),
    [anon_sym_LF] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1876),
  },
  [464] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1874),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(1850),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1876),
    [anon_sym_LF] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1876),
  },
  [465] = {
    [sym_file_redirect] = STATE(911),
    [sym_heredoc_redirect] = STATE(911),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(911),
    [sym_concatenation] = STATE(913),
    [sym_string] = STATE(174),
    [sym_simple_expansion] = STATE(174),
    [sym_string_expansion] = STATE(174),
    [sym_expansion] = STATE(174),
    [sym_command_substitution] = STATE(174),
    [sym_process_substitution] = STATE(174),
    [aux_sym_while_statement_repeat1] = STATE(911),
    [aux_sym_command_repeat2] = STATE(913),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(307),
    [anon_sym_EQ_EQ] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(823),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(887),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [466] = {
    [sym__simple_heredoc_body] = ACTIONS(1878),
    [sym__heredoc_body_beginning] = ACTIONS(1878),
    [sym_file_descriptor] = ACTIONS(1878),
    [sym__concat] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_RPAREN] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_EQ_TILDE] = ACTIONS(1880),
    [anon_sym_EQ_EQ] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1880),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT] = ACTIONS(1880),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [anon_sym_LT_LT] = ACTIONS(1880),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1880),
  },
  [467] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [468] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [469] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [470] = {
    [sym_compound_statement] = STATE(916),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [471] = {
    [anon_sym_esac] = ACTIONS(1888),
    [anon_sym_PIPE] = ACTIONS(1890),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_SEMI_SEMI] = ACTIONS(1888),
    [anon_sym_PIPE_AMP] = ACTIONS(1888),
    [anon_sym_AMP_AMP] = ACTIONS(1888),
    [anon_sym_PIPE_PIPE] = ACTIONS(1888),
    [anon_sym_BQUOTE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1890),
    [anon_sym_LF] = ACTIONS(1888),
    [anon_sym_AMP] = ACTIONS(1890),
  },
  [472] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(1890),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_SEMI_SEMI] = ACTIONS(1888),
    [anon_sym_PIPE_AMP] = ACTIONS(1888),
    [anon_sym_AMP_AMP] = ACTIONS(1888),
    [anon_sym_PIPE_PIPE] = ACTIONS(1888),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1890),
    [anon_sym_LF] = ACTIONS(1888),
    [anon_sym_AMP] = ACTIONS(1890),
  },
  [473] = {
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(1892),
    [anon_sym_PIPE_PIPE] = ACTIONS(1892),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_LF] = ACTIONS(1892),
    [anon_sym_AMP] = ACTIONS(1894),
  },
  [474] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(1892),
    [anon_sym_PIPE_PIPE] = ACTIONS(1892),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_LF] = ACTIONS(1892),
    [anon_sym_AMP] = ACTIONS(1894),
  },
  [475] = {
    [anon_sym_esac] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_RPAREN] = ACTIONS(1896),
    [anon_sym_SEMI_SEMI] = ACTIONS(1896),
    [anon_sym_PIPE_AMP] = ACTIONS(1896),
    [anon_sym_AMP_AMP] = ACTIONS(1896),
    [anon_sym_PIPE_PIPE] = ACTIONS(1896),
    [anon_sym_BQUOTE] = ACTIONS(1896),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_LF] = ACTIONS(1896),
    [anon_sym_AMP] = ACTIONS(1898),
  },
  [476] = {
    [anon_sym_DOLLAR] = ACTIONS(1900),
    [anon_sym_POUND] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1902),
    [anon_sym_STAR] = ACTIONS(1900),
    [anon_sym_AT] = ACTIONS(1900),
    [anon_sym_QMARK] = ACTIONS(1900),
    [anon_sym_0] = ACTIONS(1904),
    [anon_sym__] = ACTIONS(1904),
  },
  [477] = {
    [sym_subscript] = STATE(923),
    [sym_variable_name] = ACTIONS(1906),
    [anon_sym_BANG] = ACTIONS(1908),
    [anon_sym_DOLLAR] = ACTIONS(1910),
    [anon_sym_POUND] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1910),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1910),
    [anon_sym_AT] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_0] = ACTIONS(1914),
    [anon_sym__] = ACTIONS(1914),
  },
  [478] = {
    [sym_simple_expansion] = STATE(925),
    [sym_expansion] = STATE(925),
    [aux_sym_heredoc_body_repeat1] = STATE(925),
    [sym__heredoc_body_middle] = ACTIONS(1916),
    [sym__heredoc_body_end] = ACTIONS(1918),
    [anon_sym_DOLLAR] = ACTIONS(845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(847),
    [sym_comment] = ACTIONS(53),
  },
  [479] = {
    [sym_concatenation] = STATE(928),
    [sym_string] = STATE(927),
    [sym_simple_expansion] = STATE(927),
    [sym_string_expansion] = STATE(927),
    [sym_expansion] = STATE(927),
    [sym_command_substitution] = STATE(927),
    [sym_process_substitution] = STATE(927),
    [sym__special_characters] = ACTIONS(1920),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1922),
  },
  [480] = {
    [aux_sym_concatenation_repeat1] = STATE(127),
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_EQ_TILDE] = ACTIONS(1926),
    [anon_sym_EQ_EQ] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [481] = {
    [aux_sym_concatenation_repeat1] = STATE(127),
    [sym__simple_heredoc_body] = ACTIONS(1928),
    [sym__heredoc_body_beginning] = ACTIONS(1928),
    [sym_file_descriptor] = ACTIONS(1928),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(1930),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_EQ_TILDE] = ACTIONS(1930),
    [anon_sym_EQ_EQ] = ACTIONS(1930),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_GT] = ACTIONS(1930),
    [anon_sym_GT_GT] = ACTIONS(1928),
    [anon_sym_AMP_GT] = ACTIONS(1930),
    [anon_sym_AMP_GT_GT] = ACTIONS(1928),
    [anon_sym_LT_AMP] = ACTIONS(1928),
    [anon_sym_GT_AMP] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(1930),
    [anon_sym_LT_LT_DASH] = ACTIONS(1928),
    [anon_sym_LT_LT_LT] = ACTIONS(1928),
    [sym__special_characters] = ACTIONS(1928),
    [anon_sym_DQUOTE] = ACTIONS(1928),
    [anon_sym_DOLLAR] = ACTIONS(1930),
    [sym_raw_string] = ACTIONS(1928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1928),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [anon_sym_LT_LPAREN] = ACTIONS(1928),
    [anon_sym_GT_LPAREN] = ACTIONS(1928),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1930),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [482] = {
    [sym__simple_heredoc_body] = ACTIONS(1928),
    [sym__heredoc_body_beginning] = ACTIONS(1928),
    [sym_file_descriptor] = ACTIONS(1928),
    [anon_sym_PIPE] = ACTIONS(1930),
    [anon_sym_RPAREN] = ACTIONS(1928),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_EQ_TILDE] = ACTIONS(1930),
    [anon_sym_EQ_EQ] = ACTIONS(1930),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_GT] = ACTIONS(1930),
    [anon_sym_GT_GT] = ACTIONS(1928),
    [anon_sym_AMP_GT] = ACTIONS(1930),
    [anon_sym_AMP_GT_GT] = ACTIONS(1928),
    [anon_sym_LT_AMP] = ACTIONS(1928),
    [anon_sym_GT_AMP] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(1930),
    [anon_sym_LT_LT_DASH] = ACTIONS(1928),
    [anon_sym_LT_LT_LT] = ACTIONS(1928),
    [sym__special_characters] = ACTIONS(1928),
    [anon_sym_DQUOTE] = ACTIONS(1928),
    [anon_sym_DOLLAR] = ACTIONS(1930),
    [sym_raw_string] = ACTIONS(1928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1928),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [anon_sym_LT_LPAREN] = ACTIONS(1928),
    [anon_sym_GT_LPAREN] = ACTIONS(1928),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1930),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [483] = {
    [aux_sym_concatenation_repeat1] = STATE(929),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [484] = {
    [aux_sym_concatenation_repeat1] = STATE(929),
    [sym__simple_heredoc_body] = ACTIONS(679),
    [sym__heredoc_body_beginning] = ACTIONS(679),
    [sym_file_descriptor] = ACTIONS(679),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [485] = {
    [sym__simple_heredoc_body] = ACTIONS(679),
    [sym__heredoc_body_beginning] = ACTIONS(679),
    [sym_file_descriptor] = ACTIONS(679),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [486] = {
    [sym__simple_heredoc_body] = ACTIONS(1932),
    [sym__heredoc_body_beginning] = ACTIONS(1932),
    [sym_file_descriptor] = ACTIONS(1932),
    [anon_sym_esac] = ACTIONS(1932),
    [anon_sym_PIPE] = ACTIONS(1934),
    [anon_sym_RPAREN] = ACTIONS(1932),
    [anon_sym_SEMI_SEMI] = ACTIONS(1932),
    [anon_sym_PIPE_AMP] = ACTIONS(1932),
    [anon_sym_AMP_AMP] = ACTIONS(1932),
    [anon_sym_PIPE_PIPE] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1934),
    [anon_sym_GT] = ACTIONS(1934),
    [anon_sym_GT_GT] = ACTIONS(1932),
    [anon_sym_AMP_GT] = ACTIONS(1934),
    [anon_sym_AMP_GT_GT] = ACTIONS(1932),
    [anon_sym_LT_AMP] = ACTIONS(1932),
    [anon_sym_GT_AMP] = ACTIONS(1932),
    [anon_sym_LT_LT] = ACTIONS(1934),
    [anon_sym_LT_LT_DASH] = ACTIONS(1932),
    [anon_sym_LT_LT_LT] = ACTIONS(1932),
    [anon_sym_BQUOTE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym_LF] = ACTIONS(1932),
    [anon_sym_AMP] = ACTIONS(1934),
  },
  [487] = {
    [aux_sym_concatenation_repeat1] = STATE(929),
    [sym__simple_heredoc_body] = ACTIONS(1936),
    [sym__heredoc_body_beginning] = ACTIONS(1936),
    [sym_file_descriptor] = ACTIONS(1936),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(1938),
    [anon_sym_SEMI_SEMI] = ACTIONS(1936),
    [anon_sym_PIPE_AMP] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1938),
    [anon_sym_GT] = ACTIONS(1938),
    [anon_sym_GT_GT] = ACTIONS(1936),
    [anon_sym_AMP_GT] = ACTIONS(1938),
    [anon_sym_AMP_GT_GT] = ACTIONS(1936),
    [anon_sym_LT_AMP] = ACTIONS(1936),
    [anon_sym_GT_AMP] = ACTIONS(1936),
    [anon_sym_LT_LT] = ACTIONS(1938),
    [anon_sym_LT_LT_DASH] = ACTIONS(1936),
    [anon_sym_LT_LT_LT] = ACTIONS(1936),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_LF] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1938),
  },
  [488] = {
    [aux_sym_concatenation_repeat1] = STATE(929),
    [sym__simple_heredoc_body] = ACTIONS(1940),
    [sym__heredoc_body_beginning] = ACTIONS(1940),
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [489] = {
    [sym__simple_heredoc_body] = ACTIONS(1940),
    [sym__heredoc_body_beginning] = ACTIONS(1940),
    [sym_file_descriptor] = ACTIONS(1940),
    [anon_sym_esac] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [490] = {
    [anon_sym_esac] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(1944),
    [anon_sym_SEMI_SEMI] = ACTIONS(1944),
    [anon_sym_PIPE_AMP] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_BQUOTE] = ACTIONS(1944),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_LF] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1946),
  },
  [491] = {
    [sym_file_redirect] = STATE(491),
    [sym_heredoc_redirect] = STATE(491),
    [sym_herestring_redirect] = STATE(491),
    [aux_sym_while_statement_repeat1] = STATE(491),
    [sym__simple_heredoc_body] = ACTIONS(1948),
    [sym__heredoc_body_beginning] = ACTIONS(1948),
    [sym_file_descriptor] = ACTIONS(1950),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_SEMI_SEMI] = ACTIONS(1948),
    [anon_sym_PIPE_AMP] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_PIPE_PIPE] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(1955),
    [anon_sym_GT_GT] = ACTIONS(1958),
    [anon_sym_AMP_GT] = ACTIONS(1955),
    [anon_sym_AMP_GT_GT] = ACTIONS(1958),
    [anon_sym_LT_AMP] = ACTIONS(1958),
    [anon_sym_GT_AMP] = ACTIONS(1958),
    [anon_sym_LT_LT] = ACTIONS(1961),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1967),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_LF] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1953),
  },
  [492] = {
    [sym_file_redirect] = STATE(491),
    [sym_heredoc_redirect] = STATE(491),
    [sym_heredoc_body] = STATE(930),
    [sym_herestring_redirect] = STATE(491),
    [aux_sym_while_statement_repeat1] = STATE(491),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(1946),
    [anon_sym_SEMI_SEMI] = ACTIONS(1944),
    [anon_sym_PIPE_AMP] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(309),
    [anon_sym_GT_GT] = ACTIONS(311),
    [anon_sym_AMP_GT] = ACTIONS(309),
    [anon_sym_AMP_GT_GT] = ACTIONS(311),
    [anon_sym_LT_AMP] = ACTIONS(311),
    [anon_sym_GT_AMP] = ACTIONS(311),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_LF] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1946),
  },
  [493] = {
    [sym_concatenation] = STATE(493),
    [sym_string] = STATE(174),
    [sym_simple_expansion] = STATE(174),
    [sym_string_expansion] = STATE(174),
    [sym_expansion] = STATE(174),
    [sym_command_substitution] = STATE(174),
    [sym_process_substitution] = STATE(174),
    [aux_sym_command_repeat2] = STATE(493),
    [sym__simple_heredoc_body] = ACTIONS(1928),
    [sym__heredoc_body_beginning] = ACTIONS(1928),
    [sym_file_descriptor] = ACTIONS(1928),
    [anon_sym_PIPE] = ACTIONS(1930),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_EQ_TILDE] = ACTIONS(1970),
    [anon_sym_EQ_EQ] = ACTIONS(1970),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_GT] = ACTIONS(1930),
    [anon_sym_GT_GT] = ACTIONS(1928),
    [anon_sym_AMP_GT] = ACTIONS(1930),
    [anon_sym_AMP_GT_GT] = ACTIONS(1928),
    [anon_sym_LT_AMP] = ACTIONS(1928),
    [anon_sym_GT_AMP] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(1930),
    [anon_sym_LT_LT_DASH] = ACTIONS(1928),
    [anon_sym_LT_LT_LT] = ACTIONS(1928),
    [sym__special_characters] = ACTIONS(1973),
    [anon_sym_DQUOTE] = ACTIONS(1976),
    [anon_sym_DOLLAR] = ACTIONS(1979),
    [sym_raw_string] = ACTIONS(1982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1988),
    [anon_sym_BQUOTE] = ACTIONS(1991),
    [anon_sym_LT_LPAREN] = ACTIONS(1994),
    [anon_sym_GT_LPAREN] = ACTIONS(1994),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [494] = {
    [sym_file_redirect] = STATE(931),
    [sym_heredoc_redirect] = STATE(931),
    [sym_heredoc_body] = STATE(930),
    [sym_herestring_redirect] = STATE(931),
    [sym_concatenation] = STATE(493),
    [sym_string] = STATE(174),
    [sym_simple_expansion] = STATE(174),
    [sym_string_expansion] = STATE(174),
    [sym_expansion] = STATE(174),
    [sym_command_substitution] = STATE(174),
    [sym_process_substitution] = STATE(174),
    [aux_sym_while_statement_repeat1] = STATE(931),
    [aux_sym_command_repeat2] = STATE(493),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(1946),
    [anon_sym_SEMI_SEMI] = ACTIONS(1944),
    [anon_sym_PIPE_AMP] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_EQ_TILDE] = ACTIONS(307),
    [anon_sym_EQ_EQ] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(309),
    [anon_sym_GT_GT] = ACTIONS(311),
    [anon_sym_AMP_GT] = ACTIONS(309),
    [anon_sym_AMP_GT_GT] = ACTIONS(311),
    [anon_sym_LT_AMP] = ACTIONS(311),
    [anon_sym_GT_AMP] = ACTIONS(311),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_LF] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1946),
  },
  [495] = {
    [sym_string] = STATE(662),
    [sym_simple_expansion] = STATE(662),
    [sym_string_expansion] = STATE(662),
    [sym_expansion] = STATE(662),
    [sym_command_substitution] = STATE(662),
    [sym_process_substitution] = STATE(662),
    [anon_sym_RBRACK] = ACTIONS(2000),
    [sym__special_characters] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1255),
  },
  [496] = {
    [sym__concat] = ACTIONS(2004),
    [anon_sym_EQ] = ACTIONS(2006),
    [anon_sym_PLUS_EQ] = ACTIONS(2006),
    [sym_comment] = ACTIONS(53),
  },
  [497] = {
    [aux_sym_concatenation_repeat1] = STATE(934),
    [sym__concat] = ACTIONS(509),
    [anon_sym_RBRACK] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
  },
  [498] = {
    [sym_string] = STATE(662),
    [sym_simple_expansion] = STATE(662),
    [sym_string_expansion] = STATE(662),
    [sym_expansion] = STATE(662),
    [sym_command_substitution] = STATE(662),
    [sym_process_substitution] = STATE(662),
    [anon_sym_RBRACK] = ACTIONS(2008),
    [sym__special_characters] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1255),
  },
  [499] = {
    [sym__concat] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [sym_comment] = ACTIONS(53),
  },
  [500] = {
    [anon_sym_RBRACK] = ACTIONS(2008),
    [sym_comment] = ACTIONS(53),
  },
  [501] = {
    [sym_file_descriptor] = ACTIONS(2014),
    [sym_variable_name] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2016),
    [anon_sym_RPAREN] = ACTIONS(2014),
    [anon_sym_SEMI_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE_AMP] = ACTIONS(2014),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_PIPE_PIPE] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2016),
    [anon_sym_GT] = ACTIONS(2016),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT] = ACTIONS(2016),
    [anon_sym_AMP_GT_GT] = ACTIONS(2014),
    [anon_sym_LT_AMP] = ACTIONS(2014),
    [anon_sym_GT_AMP] = ACTIONS(2014),
    [sym__special_characters] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_DOLLAR] = ACTIONS(2016),
    [sym_raw_string] = ACTIONS(2014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2014),
    [anon_sym_BQUOTE] = ACTIONS(2014),
    [anon_sym_LT_LPAREN] = ACTIONS(2014),
    [anon_sym_GT_LPAREN] = ACTIONS(2014),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2016),
    [anon_sym_LF] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2016),
  },
  [502] = {
    [aux_sym_concatenation_repeat1] = STATE(938),
    [sym__concat] = ACTIONS(2018),
    [anon_sym_RPAREN] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_DOLLAR] = ACTIONS(2022),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [anon_sym_LT_LPAREN] = ACTIONS(2020),
    [anon_sym_GT_LPAREN] = ACTIONS(2020),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2020),
  },
  [503] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(941),
    [anon_sym_DQUOTE] = ACTIONS(2024),
    [anon_sym_DOLLAR] = ACTIONS(2026),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [504] = {
    [sym_string] = STATE(943),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2030),
    [anon_sym_POUND] = ACTIONS(2028),
    [anon_sym_DASH] = ACTIONS(2028),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2028),
    [anon_sym_AT] = ACTIONS(2028),
    [anon_sym_QMARK] = ACTIONS(2028),
    [anon_sym_0] = ACTIONS(2034),
    [anon_sym__] = ACTIONS(2034),
  },
  [505] = {
    [aux_sym_concatenation_repeat1] = STATE(938),
    [sym__concat] = ACTIONS(2018),
    [anon_sym_RPAREN] = ACTIONS(2036),
    [sym__special_characters] = ACTIONS(2036),
    [anon_sym_DQUOTE] = ACTIONS(2036),
    [anon_sym_DOLLAR] = ACTIONS(2038),
    [sym_raw_string] = ACTIONS(2036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2036),
    [anon_sym_BQUOTE] = ACTIONS(2036),
    [anon_sym_LT_LPAREN] = ACTIONS(2036),
    [anon_sym_GT_LPAREN] = ACTIONS(2036),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2036),
  },
  [506] = {
    [sym_subscript] = STATE(949),
    [sym_variable_name] = ACTIONS(2040),
    [anon_sym_BANG] = ACTIONS(2042),
    [anon_sym_DOLLAR] = ACTIONS(2044),
    [anon_sym_POUND] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2044),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(2044),
    [anon_sym_AT] = ACTIONS(2044),
    [anon_sym_QMARK] = ACTIONS(2044),
    [anon_sym_0] = ACTIONS(2048),
    [anon_sym__] = ACTIONS(2048),
  },
  [507] = {
    [sym__terminated_statement] = STATE(952),
    [sym_for_statement] = STATE(950),
    [sym_c_style_for_statement] = STATE(950),
    [sym_while_statement] = STATE(950),
    [sym_if_statement] = STATE(950),
    [sym_case_statement] = STATE(950),
    [sym_function_definition] = STATE(950),
    [sym_subshell] = STATE(950),
    [sym_pipeline] = STATE(950),
    [sym_list] = STATE(950),
    [sym_negated_command] = STATE(950),
    [sym_test_command] = STATE(950),
    [sym_declaration_command] = STATE(950),
    [sym_unset_command] = STATE(950),
    [sym_command] = STATE(950),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(951),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(952),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [508] = {
    [sym__terminated_statement] = STATE(955),
    [sym_for_statement] = STATE(953),
    [sym_c_style_for_statement] = STATE(953),
    [sym_while_statement] = STATE(953),
    [sym_if_statement] = STATE(953),
    [sym_case_statement] = STATE(953),
    [sym_function_definition] = STATE(953),
    [sym_subshell] = STATE(953),
    [sym_pipeline] = STATE(953),
    [sym_list] = STATE(953),
    [sym_negated_command] = STATE(953),
    [sym_test_command] = STATE(953),
    [sym_declaration_command] = STATE(953),
    [sym_unset_command] = STATE(953),
    [sym_command] = STATE(953),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(954),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(955),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [509] = {
    [sym__terminated_statement] = STATE(958),
    [sym_for_statement] = STATE(956),
    [sym_c_style_for_statement] = STATE(956),
    [sym_while_statement] = STATE(956),
    [sym_if_statement] = STATE(956),
    [sym_case_statement] = STATE(956),
    [sym_function_definition] = STATE(956),
    [sym_subshell] = STATE(956),
    [sym_pipeline] = STATE(956),
    [sym_list] = STATE(956),
    [sym_negated_command] = STATE(956),
    [sym_test_command] = STATE(956),
    [sym_declaration_command] = STATE(956),
    [sym_unset_command] = STATE(956),
    [sym_command] = STATE(956),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(957),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(958),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [510] = {
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_string_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [aux_sym_for_statement_repeat1] = STATE(960),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [sym__special_characters] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [sym_raw_string] = ACTIONS(1011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1019),
    [anon_sym_GT_LPAREN] = ACTIONS(1019),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1011),
  },
  [511] = {
    [sym_string] = STATE(961),
    [sym_simple_expansion] = STATE(961),
    [sym_string_expansion] = STATE(961),
    [sym_expansion] = STATE(961),
    [sym_command_substitution] = STATE(961),
    [sym_process_substitution] = STATE(961),
    [sym__special_characters] = ACTIONS(2052),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR] = ACTIONS(349),
    [sym_raw_string] = ACTIONS(2052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(355),
    [anon_sym_BQUOTE] = ACTIONS(357),
    [anon_sym_LT_LPAREN] = ACTIONS(359),
    [anon_sym_GT_LPAREN] = ACTIONS(359),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2052),
  },
  [512] = {
    [aux_sym_concatenation_repeat1] = STATE(962),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [513] = {
    [sym_file_descriptor] = ACTIONS(699),
    [sym__concat] = ACTIONS(699),
    [sym_variable_name] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(701),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
  },
  [514] = {
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [515] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [anon_sym_DOLLAR] = ACTIONS(2056),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [516] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [517] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [518] = {
    [sym_file_descriptor] = ACTIONS(739),
    [sym__concat] = ACTIONS(739),
    [sym_variable_name] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [519] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(2058),
    [sym_comment] = ACTIONS(53),
  },
  [520] = {
    [sym_subscript] = STATE(969),
    [sym_variable_name] = ACTIONS(2060),
    [anon_sym_DOLLAR] = ACTIONS(2062),
    [anon_sym_DASH] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2064),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_AT] = ACTIONS(2062),
    [anon_sym_QMARK] = ACTIONS(2062),
    [anon_sym_0] = ACTIONS(2066),
    [anon_sym__] = ACTIONS(2066),
  },
  [521] = {
    [sym_concatenation] = STATE(972),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(972),
    [anon_sym_RBRACE] = ACTIONS(2068),
    [anon_sym_EQ] = ACTIONS(2070),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2072),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2074),
    [anon_sym_COLON] = ACTIONS(2070),
    [anon_sym_COLON_QMARK] = ACTIONS(2070),
    [anon_sym_COLON_DASH] = ACTIONS(2070),
    [anon_sym_PERCENT] = ACTIONS(2070),
    [anon_sym_DASH] = ACTIONS(2070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [522] = {
    [sym_concatenation] = STATE(975),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(975),
    [anon_sym_RBRACE] = ACTIONS(2076),
    [anon_sym_EQ] = ACTIONS(2078),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2082),
    [anon_sym_COLON] = ACTIONS(2078),
    [anon_sym_COLON_QMARK] = ACTIONS(2078),
    [anon_sym_COLON_DASH] = ACTIONS(2078),
    [anon_sym_PERCENT] = ACTIONS(2078),
    [anon_sym_DASH] = ACTIONS(2078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [523] = {
    [sym_concatenation] = STATE(978),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(978),
    [anon_sym_RBRACE] = ACTIONS(2084),
    [anon_sym_EQ] = ACTIONS(2086),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2088),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2090),
    [anon_sym_COLON] = ACTIONS(2086),
    [anon_sym_COLON_QMARK] = ACTIONS(2086),
    [anon_sym_COLON_DASH] = ACTIONS(2086),
    [anon_sym_PERCENT] = ACTIONS(2086),
    [anon_sym_DASH] = ACTIONS(2086),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [524] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2092),
    [anon_sym_SEMI_SEMI] = ACTIONS(2094),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym_LF] = ACTIONS(2094),
    [anon_sym_AMP] = ACTIONS(2096),
  },
  [525] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2092),
    [anon_sym_SEMI_SEMI] = ACTIONS(2094),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym_LF] = ACTIONS(2094),
    [anon_sym_AMP] = ACTIONS(2096),
  },
  [526] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(981),
    [sym_c_style_for_statement] = STATE(981),
    [sym_while_statement] = STATE(981),
    [sym_if_statement] = STATE(981),
    [sym_case_statement] = STATE(981),
    [sym_function_definition] = STATE(981),
    [sym_subshell] = STATE(981),
    [sym_pipeline] = STATE(981),
    [sym_list] = STATE(981),
    [sym_negated_command] = STATE(981),
    [sym_test_command] = STATE(981),
    [sym_declaration_command] = STATE(981),
    [sym_unset_command] = STATE(981),
    [sym_command] = STATE(981),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(982),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [527] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2098),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(2092),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2100),
    [anon_sym_LF] = ACTIONS(2098),
    [anon_sym_AMP] = ACTIONS(2100),
  },
  [528] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2098),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(2092),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2100),
    [anon_sym_LF] = ACTIONS(2098),
    [anon_sym_AMP] = ACTIONS(2100),
  },
  [529] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(984),
    [sym_c_style_for_statement] = STATE(984),
    [sym_while_statement] = STATE(984),
    [sym_if_statement] = STATE(984),
    [sym_case_statement] = STATE(984),
    [sym_function_definition] = STATE(984),
    [sym_subshell] = STATE(984),
    [sym_pipeline] = STATE(984),
    [sym_list] = STATE(984),
    [sym_negated_command] = STATE(984),
    [sym_test_command] = STATE(984),
    [sym_declaration_command] = STATE(984),
    [sym_unset_command] = STATE(984),
    [sym_command] = STATE(984),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(985),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [530] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2102),
    [anon_sym_SEMI_SEMI] = ACTIONS(2104),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_LF] = ACTIONS(2104),
    [anon_sym_AMP] = ACTIONS(2106),
  },
  [531] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2102),
    [anon_sym_SEMI_SEMI] = ACTIONS(2104),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_LF] = ACTIONS(2104),
    [anon_sym_AMP] = ACTIONS(2106),
  },
  [532] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(988),
    [sym_c_style_for_statement] = STATE(988),
    [sym_while_statement] = STATE(988),
    [sym_if_statement] = STATE(988),
    [sym_case_statement] = STATE(988),
    [sym_function_definition] = STATE(988),
    [sym_subshell] = STATE(988),
    [sym_pipeline] = STATE(988),
    [sym_list] = STATE(988),
    [sym_negated_command] = STATE(988),
    [sym_test_command] = STATE(988),
    [sym_declaration_command] = STATE(988),
    [sym_unset_command] = STATE(988),
    [sym_command] = STATE(988),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(989),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [533] = {
    [sym__expression] = STATE(1001),
    [sym_binary_expression] = STATE(1001),
    [sym_unary_expression] = STATE(1001),
    [sym_parenthesized_expression] = STATE(1001),
    [sym_concatenation] = STATE(1001),
    [sym_string] = STATE(996),
    [sym_simple_expansion] = STATE(996),
    [sym_string_expansion] = STATE(996),
    [sym_expansion] = STATE(996),
    [sym_command_substitution] = STATE(996),
    [sym_process_substitution] = STATE(996),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_BANG] = ACTIONS(2112),
    [sym__special_characters] = ACTIONS(2114),
    [anon_sym_DQUOTE] = ACTIONS(2116),
    [anon_sym_DOLLAR] = ACTIONS(2118),
    [sym_raw_string] = ACTIONS(2120),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2124),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [anon_sym_LT_LPAREN] = ACTIONS(2128),
    [anon_sym_GT_LPAREN] = ACTIONS(2128),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2130),
    [sym_test_operator] = ACTIONS(2132),
  },
  [534] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2134),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_EQ_TILDE] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_BANG_EQ] = ACTIONS(1079),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1079),
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_LF] = ACTIONS(2134),
    [anon_sym_AMP] = ACTIONS(2136),
  },
  [535] = {
    [anon_sym_RPAREN] = ACTIONS(2138),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_EQ_TILDE] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1249),
    [anon_sym_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1247),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1247),
  },
  [536] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_EQ_TILDE] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_BANG_EQ] = ACTIONS(1079),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1079),
    [anon_sym_SEMI] = ACTIONS(2140),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(2140),
  },
  [537] = {
    [sym_string] = STATE(1004),
    [sym_simple_expansion] = STATE(1004),
    [sym_string_expansion] = STATE(1004),
    [sym_expansion] = STATE(1004),
    [sym_command_substitution] = STATE(1004),
    [sym_process_substitution] = STATE(1004),
    [sym__special_characters] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(2142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2142),
  },
  [538] = {
    [aux_sym_concatenation_repeat1] = STATE(1005),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_EQ] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_BANG_EQ] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [539] = {
    [sym__concat] = ACTIONS(699),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_EQ_TILDE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_EQ] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
  },
  [540] = {
    [anon_sym_DQUOTE] = ACTIONS(2144),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [541] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(2144),
    [anon_sym_DOLLAR] = ACTIONS(2146),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [542] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [543] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [544] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_esac] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_EQ_TILDE] = ACTIONS(739),
    [anon_sym_EQ_EQ] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(739),
    [anon_sym_BANG_EQ] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(739),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [545] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(2148),
    [sym_comment] = ACTIONS(53),
  },
  [546] = {
    [sym_subscript] = STATE(1012),
    [sym_variable_name] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2154),
    [anon_sym_STAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2152),
    [anon_sym_QMARK] = ACTIONS(2152),
    [anon_sym_0] = ACTIONS(2156),
    [anon_sym__] = ACTIONS(2156),
  },
  [547] = {
    [sym_concatenation] = STATE(1015),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1015),
    [anon_sym_RBRACE] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2164),
    [anon_sym_COLON] = ACTIONS(2160),
    [anon_sym_COLON_QMARK] = ACTIONS(2160),
    [anon_sym_COLON_DASH] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [548] = {
    [sym_concatenation] = STATE(1018),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1018),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_EQ] = ACTIONS(2168),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2168),
    [anon_sym_COLON_QMARK] = ACTIONS(2168),
    [anon_sym_COLON_DASH] = ACTIONS(2168),
    [anon_sym_PERCENT] = ACTIONS(2168),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [549] = {
    [sym_concatenation] = STATE(1021),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1021),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2176),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2180),
    [anon_sym_COLON] = ACTIONS(2176),
    [anon_sym_COLON_QMARK] = ACTIONS(2176),
    [anon_sym_COLON_DASH] = ACTIONS(2176),
    [anon_sym_PERCENT] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2176),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [550] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2182),
    [anon_sym_SEMI_SEMI] = ACTIONS(2184),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2184),
    [anon_sym_AMP] = ACTIONS(2186),
  },
  [551] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2182),
    [anon_sym_SEMI_SEMI] = ACTIONS(2184),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2184),
    [anon_sym_AMP] = ACTIONS(2186),
  },
  [552] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1024),
    [sym_c_style_for_statement] = STATE(1024),
    [sym_while_statement] = STATE(1024),
    [sym_if_statement] = STATE(1024),
    [sym_case_statement] = STATE(1024),
    [sym_function_definition] = STATE(1024),
    [sym_subshell] = STATE(1024),
    [sym_pipeline] = STATE(1024),
    [sym_list] = STATE(1024),
    [sym_negated_command] = STATE(1024),
    [sym_test_command] = STATE(1024),
    [sym_declaration_command] = STATE(1024),
    [sym_unset_command] = STATE(1024),
    [sym_command] = STATE(1024),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1025),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [553] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2188),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2190),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2190),
  },
  [554] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2188),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2190),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2190),
  },
  [555] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1027),
    [sym_c_style_for_statement] = STATE(1027),
    [sym_while_statement] = STATE(1027),
    [sym_if_statement] = STATE(1027),
    [sym_case_statement] = STATE(1027),
    [sym_function_definition] = STATE(1027),
    [sym_subshell] = STATE(1027),
    [sym_pipeline] = STATE(1027),
    [sym_list] = STATE(1027),
    [sym_negated_command] = STATE(1027),
    [sym_test_command] = STATE(1027),
    [sym_declaration_command] = STATE(1027),
    [sym_unset_command] = STATE(1027),
    [sym_command] = STATE(1027),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(1028),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [556] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_SEMI_SEMI] = ACTIONS(2194),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_LF] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2196),
  },
  [557] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_SEMI_SEMI] = ACTIONS(2194),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_LF] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2196),
  },
  [558] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1031),
    [sym_c_style_for_statement] = STATE(1031),
    [sym_while_statement] = STATE(1031),
    [sym_if_statement] = STATE(1031),
    [sym_case_statement] = STATE(1031),
    [sym_function_definition] = STATE(1031),
    [sym_subshell] = STATE(1031),
    [sym_pipeline] = STATE(1031),
    [sym_list] = STATE(1031),
    [sym_negated_command] = STATE(1031),
    [sym_test_command] = STATE(1031),
    [sym_declaration_command] = STATE(1031),
    [sym_unset_command] = STATE(1031),
    [sym_command] = STATE(1031),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1032),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [559] = {
    [sym__expression] = STATE(1033),
    [sym_binary_expression] = STATE(1033),
    [sym_unary_expression] = STATE(1033),
    [sym_parenthesized_expression] = STATE(1033),
    [sym_concatenation] = STATE(1033),
    [sym_string] = STATE(203),
    [sym_simple_expansion] = STATE(203),
    [sym_string_expansion] = STATE(203),
    [sym_expansion] = STATE(203),
    [sym_command_substitution] = STATE(203),
    [sym_process_substitution] = STATE(203),
    [anon_sym_SEMI_SEMI] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_BANG] = ACTIONS(365),
    [sym__special_characters] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(383),
    [sym_test_operator] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_LF] = ACTIONS(2134),
    [anon_sym_AMP] = ACTIONS(2134),
  },
  [560] = {
    [sym__expression] = STATE(1034),
    [sym_binary_expression] = STATE(1034),
    [sym_unary_expression] = STATE(1034),
    [sym_parenthesized_expression] = STATE(1034),
    [sym_concatenation] = STATE(1034),
    [sym_string] = STATE(203),
    [sym_simple_expansion] = STATE(203),
    [sym_string_expansion] = STATE(203),
    [sym_expansion] = STATE(203),
    [sym_command_substitution] = STATE(203),
    [sym_process_substitution] = STATE(203),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_BANG] = ACTIONS(365),
    [sym__special_characters] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(383),
    [sym_test_operator] = ACTIONS(385),
  },
  [561] = {
    [sym__expression] = STATE(1034),
    [sym_binary_expression] = STATE(1034),
    [sym_unary_expression] = STATE(1034),
    [sym_parenthesized_expression] = STATE(1034),
    [sym_concatenation] = STATE(1034),
    [sym_string] = STATE(203),
    [sym_simple_expansion] = STATE(203),
    [sym_string_expansion] = STATE(203),
    [sym_expansion] = STATE(203),
    [sym_command_substitution] = STATE(203),
    [sym_process_substitution] = STATE(203),
    [anon_sym_LPAREN] = ACTIONS(2198),
    [anon_sym_BANG] = ACTIONS(365),
    [sym__special_characters] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2202),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2206),
    [anon_sym_BQUOTE] = ACTIONS(2208),
    [anon_sym_LT_LPAREN] = ACTIONS(2210),
    [anon_sym_GT_LPAREN] = ACTIONS(2210),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(383),
    [sym_test_operator] = ACTIONS(365),
    [sym_regex] = ACTIONS(2212),
  },
  [562] = {
    [aux_sym_concatenation_repeat1] = STATE(1037),
    [sym__concat] = ACTIONS(2214),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_DOLLAR] = ACTIONS(2022),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [anon_sym_LT_LPAREN] = ACTIONS(2020),
    [anon_sym_GT_LPAREN] = ACTIONS(2020),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym_LF] = ACTIONS(2020),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [563] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(1040),
    [anon_sym_DQUOTE] = ACTIONS(2216),
    [anon_sym_DOLLAR] = ACTIONS(2218),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [564] = {
    [sym_string] = STATE(1042),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(2220),
    [sym_raw_string] = ACTIONS(2222),
    [anon_sym_POUND] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2220),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2220),
    [anon_sym_QMARK] = ACTIONS(2220),
    [anon_sym_0] = ACTIONS(2226),
    [anon_sym__] = ACTIONS(2226),
  },
  [565] = {
    [aux_sym_concatenation_repeat1] = STATE(1037),
    [sym__concat] = ACTIONS(2214),
    [anon_sym_SEMI_SEMI] = ACTIONS(2036),
    [sym__special_characters] = ACTIONS(2036),
    [anon_sym_DQUOTE] = ACTIONS(2036),
    [anon_sym_DOLLAR] = ACTIONS(2038),
    [sym_raw_string] = ACTIONS(2036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2036),
    [anon_sym_BQUOTE] = ACTIONS(2036),
    [anon_sym_LT_LPAREN] = ACTIONS(2036),
    [anon_sym_GT_LPAREN] = ACTIONS(2036),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_LF] = ACTIONS(2036),
    [anon_sym_AMP] = ACTIONS(2036),
  },
  [566] = {
    [sym_subscript] = STATE(1048),
    [sym_variable_name] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_POUND] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2232),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_AT] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2232),
    [anon_sym_0] = ACTIONS(2236),
    [anon_sym__] = ACTIONS(2236),
  },
  [567] = {
    [sym__terminated_statement] = STATE(1051),
    [sym_for_statement] = STATE(1049),
    [sym_c_style_for_statement] = STATE(1049),
    [sym_while_statement] = STATE(1049),
    [sym_if_statement] = STATE(1049),
    [sym_case_statement] = STATE(1049),
    [sym_function_definition] = STATE(1049),
    [sym_subshell] = STATE(1049),
    [sym_pipeline] = STATE(1049),
    [sym_list] = STATE(1049),
    [sym_negated_command] = STATE(1049),
    [sym_test_command] = STATE(1049),
    [sym_declaration_command] = STATE(1049),
    [sym_unset_command] = STATE(1049),
    [sym_command] = STATE(1049),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1050),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(1051),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [568] = {
    [sym__terminated_statement] = STATE(1054),
    [sym_for_statement] = STATE(1052),
    [sym_c_style_for_statement] = STATE(1052),
    [sym_while_statement] = STATE(1052),
    [sym_if_statement] = STATE(1052),
    [sym_case_statement] = STATE(1052),
    [sym_function_definition] = STATE(1052),
    [sym_subshell] = STATE(1052),
    [sym_pipeline] = STATE(1052),
    [sym_list] = STATE(1052),
    [sym_negated_command] = STATE(1052),
    [sym_test_command] = STATE(1052),
    [sym_declaration_command] = STATE(1052),
    [sym_unset_command] = STATE(1052),
    [sym_command] = STATE(1052),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(1053),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1054),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [569] = {
    [sym__terminated_statement] = STATE(1057),
    [sym_for_statement] = STATE(1055),
    [sym_c_style_for_statement] = STATE(1055),
    [sym_while_statement] = STATE(1055),
    [sym_if_statement] = STATE(1055),
    [sym_case_statement] = STATE(1055),
    [sym_function_definition] = STATE(1055),
    [sym_subshell] = STATE(1055),
    [sym_pipeline] = STATE(1055),
    [sym_list] = STATE(1055),
    [sym_negated_command] = STATE(1055),
    [sym_test_command] = STATE(1055),
    [sym_declaration_command] = STATE(1055),
    [sym_unset_command] = STATE(1055),
    [sym_command] = STATE(1055),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1056),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(1057),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [570] = {
    [sym_concatenation] = STATE(1059),
    [sym_string] = STATE(565),
    [sym_simple_expansion] = STATE(565),
    [sym_string_expansion] = STATE(565),
    [sym_expansion] = STATE(565),
    [sym_command_substitution] = STATE(565),
    [sym_process_substitution] = STATE(565),
    [aux_sym_for_statement_repeat1] = STATE(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(2238),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_LF] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2238),
  },
  [571] = {
    [sym__terminated_statement] = STATE(1061),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1061),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [572] = {
    [anon_sym_esac] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [anon_sym_SEMI_SEMI] = ACTIONS(2246),
    [anon_sym_PIPE_AMP] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BQUOTE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2248),
    [anon_sym_LF] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2248),
  },
  [573] = {
    [sym__simple_heredoc_body] = ACTIONS(2250),
    [sym__heredoc_body_beginning] = ACTIONS(2250),
    [sym_file_descriptor] = ACTIONS(2250),
    [anon_sym_esac] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_SEMI_SEMI] = ACTIONS(2250),
    [anon_sym_PIPE_AMP] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_GT] = ACTIONS(2250),
    [anon_sym_AMP_GT] = ACTIONS(2252),
    [anon_sym_AMP_GT_GT] = ACTIONS(2250),
    [anon_sym_LT_AMP] = ACTIONS(2250),
    [anon_sym_GT_AMP] = ACTIONS(2250),
    [anon_sym_LT_LT] = ACTIONS(2252),
    [anon_sym_LT_LT_DASH] = ACTIONS(2250),
    [anon_sym_LT_LT_LT] = ACTIONS(2250),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2252),
    [anon_sym_LF] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2252),
  },
  [574] = {
    [sym__terminated_statement] = STATE(1063),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1063),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(2254),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [575] = {
    [anon_sym_esac] = ACTIONS(2256),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2256),
    [anon_sym_SEMI_SEMI] = ACTIONS(2256),
    [anon_sym_PIPE_AMP] = ACTIONS(2256),
    [anon_sym_AMP_AMP] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2256),
    [anon_sym_BQUOTE] = ACTIONS(2256),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_LF] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2258),
  },
  [576] = {
    [sym_file_redirect] = STATE(491),
    [sym_heredoc_redirect] = STATE(491),
    [sym_heredoc_body] = STATE(1064),
    [sym_herestring_redirect] = STATE(491),
    [aux_sym_while_statement_repeat1] = STATE(491),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_SEMI_SEMI] = ACTIONS(2256),
    [anon_sym_PIPE_AMP] = ACTIONS(2256),
    [anon_sym_AMP_AMP] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(309),
    [anon_sym_GT_GT] = ACTIONS(311),
    [anon_sym_AMP_GT] = ACTIONS(309),
    [anon_sym_AMP_GT_GT] = ACTIONS(311),
    [anon_sym_LT_AMP] = ACTIONS(311),
    [anon_sym_GT_AMP] = ACTIONS(311),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_LF] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2258),
  },
  [577] = {
    [anon_sym_esac] = ACTIONS(2260),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(2260),
    [anon_sym_SEMI_SEMI] = ACTIONS(2260),
    [anon_sym_PIPE_AMP] = ACTIONS(2260),
    [anon_sym_AMP_AMP] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2260),
    [anon_sym_BQUOTE] = ACTIONS(2260),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_LF] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2262),
  },
  [578] = {
    [sym__terminated_statement] = STATE(1065),
    [sym_for_statement] = STATE(40),
    [sym_c_style_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_subshell] = STATE(40),
    [sym_pipeline] = STATE(40),
    [sym_list] = STATE(40),
    [sym_negated_command] = STATE(40),
    [sym_test_command] = STATE(40),
    [sym_declaration_command] = STATE(40),
    [sym_unset_command] = STATE(40),
    [sym_command] = STATE(40),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(41),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [579] = {
    [sym__terminated_statement] = STATE(1066),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1066),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [580] = {
    [anon_sym_fi] = ACTIONS(2266),
    [anon_sym_elif] = ACTIONS(2266),
    [anon_sym_else] = ACTIONS(2266),
    [sym_comment] = ACTIONS(53),
  },
  [581] = {
    [anon_sym_fi] = ACTIONS(2268),
    [sym_comment] = ACTIONS(53),
  },
  [582] = {
    [sym__terminated_statement] = STATE(1069),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_elif_clause] = STATE(580),
    [sym_else_clause] = STATE(1068),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1069),
    [aux_sym_if_statement_repeat1] = STATE(1070),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(2270),
    [anon_sym_elif] = ACTIONS(1113),
    [anon_sym_else] = ACTIONS(1115),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [583] = {
    [sym_elif_clause] = STATE(580),
    [sym_else_clause] = STATE(1068),
    [aux_sym_if_statement_repeat1] = STATE(1071),
    [anon_sym_fi] = ACTIONS(2268),
    [anon_sym_elif] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2274),
    [sym_comment] = ACTIONS(53),
  },
  [584] = {
    [sym__concat] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1664),
  },
  [585] = {
    [sym_case_item] = STATE(1077),
    [sym_last_case_item] = STATE(1075),
    [sym_concatenation] = STATE(1076),
    [sym_string] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [sym_command_substitution] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [aux_sym_case_statement_repeat1] = STATE(1077),
    [anon_sym_esac] = ACTIONS(2276),
    [sym__special_characters] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(2280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2282),
  },
  [586] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2284),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_LF] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2284),
  },
  [587] = {
    [aux_sym_concatenation_repeat1] = STATE(587),
    [sym__concat] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1664),
  },
  [588] = {
    [sym__concat] = ACTIONS(1671),
    [anon_sym_in] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
  },
  [589] = {
    [anon_sym_DQUOTE] = ACTIONS(2291),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [590] = {
    [sym_case_item] = STATE(1082),
    [sym_last_case_item] = STATE(1081),
    [sym_concatenation] = STATE(1076),
    [sym_string] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [sym_command_substitution] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [aux_sym_case_statement_repeat1] = STATE(1082),
    [anon_sym_esac] = ACTIONS(2293),
    [sym__special_characters] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(2280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2282),
  },
  [591] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_LF] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
  },
  [592] = {
    [sym_concatenation] = STATE(1087),
    [sym_string] = STATE(1086),
    [sym_simple_expansion] = STATE(1086),
    [sym_string_expansion] = STATE(1086),
    [sym_expansion] = STATE(1086),
    [sym_command_substitution] = STATE(1086),
    [sym_process_substitution] = STATE(1086),
    [anon_sym_RBRACE] = ACTIONS(2299),
    [sym__special_characters] = ACTIONS(2301),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(2303),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2303),
  },
  [593] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(2305),
    [sym_comment] = ACTIONS(53),
  },
  [594] = {
    [sym_concatenation] = STATE(1091),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1091),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_EQ] = ACTIONS(2309),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2313),
    [anon_sym_COLON] = ACTIONS(2309),
    [anon_sym_COLON_QMARK] = ACTIONS(2309),
    [anon_sym_COLON_DASH] = ACTIONS(2309),
    [anon_sym_PERCENT] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2309),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [595] = {
    [sym_concatenation] = STATE(1094),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1094),
    [anon_sym_RBRACE] = ACTIONS(2315),
    [anon_sym_EQ] = ACTIONS(2317),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2321),
    [anon_sym_COLON] = ACTIONS(2317),
    [anon_sym_COLON_QMARK] = ACTIONS(2317),
    [anon_sym_COLON_DASH] = ACTIONS(2317),
    [anon_sym_PERCENT] = ACTIONS(2317),
    [anon_sym_DASH] = ACTIONS(2317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [596] = {
    [sym_concatenation] = STATE(1096),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1096),
    [anon_sym_RBRACE] = ACTIONS(2299),
    [anon_sym_EQ] = ACTIONS(2323),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2327),
    [anon_sym_COLON] = ACTIONS(2323),
    [anon_sym_COLON_QMARK] = ACTIONS(2323),
    [anon_sym_COLON_DASH] = ACTIONS(2323),
    [anon_sym_PERCENT] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [597] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_in] = ACTIONS(1788),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1788),
  },
  [598] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2329),
  },
  [599] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2331),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [600] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_in] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1832),
  },
  [601] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2333),
  },
  [602] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2335),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [603] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_in] = ACTIONS(1840),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1840),
  },
  [604] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2337),
  },
  [605] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2299),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [606] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_in] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1846),
  },
  [607] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2339),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [608] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2339),
    [anon_sym_SEMI_SEMI] = ACTIONS(2341),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2343),
    [anon_sym_LF] = ACTIONS(2341),
    [anon_sym_AMP] = ACTIONS(2343),
  },
  [609] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2339),
    [anon_sym_SEMI_SEMI] = ACTIONS(2341),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2343),
    [anon_sym_LF] = ACTIONS(2341),
    [anon_sym_AMP] = ACTIONS(2343),
  },
  [610] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [611] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2345),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_LF] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2347),
  },
  [612] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2345),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_LF] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2347),
  },
  [613] = {
    [sym__concat] = ACTIONS(1878),
    [anon_sym_in] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [614] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2349),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [615] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2349),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [616] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2349),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [617] = {
    [sym_compound_statement] = STATE(1107),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [618] = {
    [sym_file_descriptor] = ACTIONS(2355),
    [anon_sym_esac] = ACTIONS(2355),
    [anon_sym_PIPE] = ACTIONS(2357),
    [anon_sym_RPAREN] = ACTIONS(2355),
    [anon_sym_SEMI_SEMI] = ACTIONS(2355),
    [anon_sym_PIPE_AMP] = ACTIONS(2355),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_PIPE_PIPE] = ACTIONS(2355),
    [anon_sym_LT] = ACTIONS(2357),
    [anon_sym_GT] = ACTIONS(2357),
    [anon_sym_GT_GT] = ACTIONS(2355),
    [anon_sym_AMP_GT] = ACTIONS(2357),
    [anon_sym_AMP_GT_GT] = ACTIONS(2355),
    [anon_sym_LT_AMP] = ACTIONS(2355),
    [anon_sym_GT_AMP] = ACTIONS(2355),
    [anon_sym_BQUOTE] = ACTIONS(2355),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2357),
    [anon_sym_LF] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
  },
  [619] = {
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(2359),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym_LF] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(2361),
  },
  [620] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(2359),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym_LF] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(2361),
  },
  [621] = {
    [sym__terminated_statement] = STATE(1110),
    [sym_for_statement] = STATE(619),
    [sym_c_style_for_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_case_statement] = STATE(619),
    [sym_function_definition] = STATE(619),
    [sym_subshell] = STATE(619),
    [sym_pipeline] = STATE(619),
    [sym_list] = STATE(619),
    [sym_negated_command] = STATE(619),
    [sym_test_command] = STATE(619),
    [sym_declaration_command] = STATE(619),
    [sym_unset_command] = STATE(619),
    [sym_command] = STATE(619),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(620),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1110),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [622] = {
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_GT] = ACTIONS(2365),
    [anon_sym_AMP_GT_GT] = ACTIONS(2367),
    [anon_sym_LT_AMP] = ACTIONS(2367),
    [anon_sym_GT_AMP] = ACTIONS(2367),
    [sym_comment] = ACTIONS(53),
  },
  [623] = {
    [sym_concatenation] = STATE(1114),
    [sym_string] = STATE(1113),
    [sym_simple_expansion] = STATE(1113),
    [sym_string_expansion] = STATE(1113),
    [sym_expansion] = STATE(1113),
    [sym_command_substitution] = STATE(1113),
    [sym_process_substitution] = STATE(1113),
    [sym__special_characters] = ACTIONS(2369),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2371),
  },
  [624] = {
    [anon_sym_esac] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2375),
    [anon_sym_RPAREN] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE_AMP] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_BQUOTE] = ACTIONS(2373),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2375),
  },
  [625] = {
    [aux_sym_concatenation_repeat1] = STATE(1115),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1025),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_SEMI_SEMI] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(1025),
    [anon_sym_GT] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1025),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1025),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1025),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_LF] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1025),
  },
  [626] = {
    [aux_sym_concatenation_repeat1] = STATE(1115),
    [sym_file_descriptor] = ACTIONS(999),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(999),
    [anon_sym_PIPE_AMP] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1001),
    [anon_sym_GT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_AMP_GT] = ACTIONS(1001),
    [anon_sym_AMP_GT_GT] = ACTIONS(999),
    [anon_sym_LT_AMP] = ACTIONS(999),
    [anon_sym_GT_AMP] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LF] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(1001),
  },
  [627] = {
    [sym_file_redirect] = STATE(1116),
    [sym_heredoc_redirect] = STATE(1116),
    [sym_heredoc_body] = STATE(575),
    [sym_herestring_redirect] = STATE(1116),
    [aux_sym_while_statement_repeat1] = STATE(1116),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(483),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [628] = {
    [anon_sym_RPAREN] = ACTIONS(2377),
    [sym_comment] = ACTIONS(53),
  },
  [629] = {
    [sym_file_redirect] = STATE(624),
    [sym_file_descriptor] = ACTIONS(2379),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_RPAREN] = ACTIONS(1193),
    [anon_sym_SEMI_SEMI] = ACTIONS(1193),
    [anon_sym_PIPE_AMP] = ACTIONS(1193),
    [anon_sym_AMP_AMP] = ACTIONS(1193),
    [anon_sym_PIPE_PIPE] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_GT] = ACTIONS(2381),
    [anon_sym_GT_GT] = ACTIONS(2383),
    [anon_sym_AMP_GT] = ACTIONS(2381),
    [anon_sym_AMP_GT_GT] = ACTIONS(2383),
    [anon_sym_LT_AMP] = ACTIONS(2383),
    [anon_sym_GT_AMP] = ACTIONS(2383),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym_LF] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1191),
  },
  [630] = {
    [sym_file_redirect] = STATE(1123),
    [sym_heredoc_redirect] = STATE(1123),
    [sym_herestring_redirect] = STATE(1123),
    [aux_sym_while_statement_repeat1] = STATE(1123),
    [sym_file_descriptor] = ACTIONS(2385),
    [anon_sym_PIPE] = ACTIONS(1313),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_SEMI_SEMI] = ACTIONS(1315),
    [anon_sym_PIPE_AMP] = ACTIONS(1315),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(2387),
    [anon_sym_GT] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2389),
    [anon_sym_AMP_GT] = ACTIONS(2387),
    [anon_sym_AMP_GT_GT] = ACTIONS(2389),
    [anon_sym_LT_AMP] = ACTIONS(2389),
    [anon_sym_GT_AMP] = ACTIONS(2389),
    [anon_sym_LT_LT] = ACTIONS(1321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1323),
    [anon_sym_LT_LT_LT] = ACTIONS(2391),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1313),
    [anon_sym_LF] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1313),
  },
  [631] = {
    [sym_concatenation] = STATE(730),
    [sym_string] = STATE(1125),
    [sym_array] = STATE(730),
    [sym_simple_expansion] = STATE(1125),
    [sym_string_expansion] = STATE(1125),
    [sym_expansion] = STATE(1125),
    [sym_command_substitution] = STATE(1125),
    [sym_process_substitution] = STATE(1125),
    [sym__empty_value] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [sym__special_characters] = ACTIONS(2393),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(169),
    [sym_raw_string] = ACTIONS(2395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2395),
  },
  [632] = {
    [aux_sym_concatenation_repeat1] = STATE(1126),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [633] = {
    [sym_variable_assignment] = STATE(633),
    [sym_subscript] = STATE(252),
    [sym_concatenation] = STATE(633),
    [sym_string] = STATE(251),
    [sym_simple_expansion] = STATE(251),
    [sym_string_expansion] = STATE(251),
    [sym_expansion] = STATE(251),
    [sym_command_substitution] = STATE(251),
    [sym_process_substitution] = STATE(251),
    [aux_sym_declaration_command_repeat1] = STATE(633),
    [sym_variable_name] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_RPAREN] = ACTIONS(1486),
    [anon_sym_SEMI_SEMI] = ACTIONS(1486),
    [anon_sym_PIPE_AMP] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [sym__special_characters] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(1491),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1503),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LPAREN] = ACTIONS(1509),
    [anon_sym_GT_LPAREN] = ACTIONS(1509),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1512),
    [sym_word] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1484),
  },
  [634] = {
    [aux_sym_concatenation_repeat1] = STATE(1127),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [635] = {
    [sym_concatenation] = STATE(635),
    [sym_string] = STATE(255),
    [sym_simple_expansion] = STATE(255),
    [sym_string_expansion] = STATE(255),
    [sym_expansion] = STATE(255),
    [sym_command_substitution] = STATE(255),
    [sym_process_substitution] = STATE(255),
    [aux_sym_unset_command_repeat1] = STATE(635),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1576),
    [anon_sym_SEMI_SEMI] = ACTIONS(1576),
    [anon_sym_PIPE_AMP] = ACTIONS(1576),
    [anon_sym_AMP_AMP] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1576),
    [sym__special_characters] = ACTIONS(2409),
    [anon_sym_DQUOTE] = ACTIONS(1581),
    [anon_sym_DOLLAR] = ACTIONS(1584),
    [sym_raw_string] = ACTIONS(2412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1593),
    [anon_sym_BQUOTE] = ACTIONS(1596),
    [anon_sym_LT_LPAREN] = ACTIONS(1599),
    [anon_sym_GT_LPAREN] = ACTIONS(1599),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1602),
    [sym_word] = ACTIONS(2415),
    [anon_sym_SEMI] = ACTIONS(1574),
    [anon_sym_LF] = ACTIONS(1576),
    [anon_sym_AMP] = ACTIONS(1574),
  },
  [636] = {
    [aux_sym_concatenation_repeat1] = STATE(636),
    [sym__simple_heredoc_body] = ACTIONS(1664),
    [sym__heredoc_body_beginning] = ACTIONS(1664),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1668),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1666),
    [anon_sym_EQ_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [637] = {
    [sym_compound_statement] = STATE(1128),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [638] = {
    [anon_sym_esac] = ACTIONS(2418),
    [anon_sym_PIPE] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2418),
    [anon_sym_SEMI_SEMI] = ACTIONS(2418),
    [anon_sym_PIPE_AMP] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BQUOTE] = ACTIONS(2418),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_LF] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2420),
  },
  [639] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1892),
    [anon_sym_SEMI_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(1892),
    [anon_sym_PIPE_PIPE] = ACTIONS(1892),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_LF] = ACTIONS(1892),
    [anon_sym_AMP] = ACTIONS(1894),
  },
  [640] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1892),
    [anon_sym_SEMI_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(1892),
    [anon_sym_PIPE_PIPE] = ACTIONS(1892),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_LF] = ACTIONS(1892),
    [anon_sym_AMP] = ACTIONS(1894),
  },
  [641] = {
    [sym_concatenation] = STATE(928),
    [sym_string] = STATE(1130),
    [sym_simple_expansion] = STATE(1130),
    [sym_string_expansion] = STATE(1130),
    [sym_expansion] = STATE(1130),
    [sym_command_substitution] = STATE(1130),
    [sym_process_substitution] = STATE(1130),
    [sym__special_characters] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(2424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2424),
  },
  [642] = {
    [aux_sym_concatenation_repeat1] = STATE(257),
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_EQ_TILDE] = ACTIONS(1926),
    [anon_sym_EQ_EQ] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [643] = {
    [aux_sym_concatenation_repeat1] = STATE(257),
    [sym__simple_heredoc_body] = ACTIONS(1928),
    [sym__heredoc_body_beginning] = ACTIONS(1928),
    [sym_file_descriptor] = ACTIONS(1928),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(1930),
    [anon_sym_RPAREN] = ACTIONS(1928),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_EQ_TILDE] = ACTIONS(1930),
    [anon_sym_EQ_EQ] = ACTIONS(1930),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_GT] = ACTIONS(1930),
    [anon_sym_GT_GT] = ACTIONS(1928),
    [anon_sym_AMP_GT] = ACTIONS(1930),
    [anon_sym_AMP_GT_GT] = ACTIONS(1928),
    [anon_sym_LT_AMP] = ACTIONS(1928),
    [anon_sym_GT_AMP] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(1930),
    [anon_sym_LT_LT_DASH] = ACTIONS(1928),
    [anon_sym_LT_LT_LT] = ACTIONS(1928),
    [sym__special_characters] = ACTIONS(1928),
    [anon_sym_DQUOTE] = ACTIONS(1928),
    [anon_sym_DOLLAR] = ACTIONS(1930),
    [sym_raw_string] = ACTIONS(1928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1928),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [anon_sym_LT_LPAREN] = ACTIONS(1928),
    [anon_sym_GT_LPAREN] = ACTIONS(1928),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1930),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [644] = {
    [aux_sym_concatenation_repeat1] = STATE(1131),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [645] = {
    [aux_sym_concatenation_repeat1] = STATE(1131),
    [sym__simple_heredoc_body] = ACTIONS(679),
    [sym__heredoc_body_beginning] = ACTIONS(679),
    [sym_file_descriptor] = ACTIONS(679),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [646] = {
    [aux_sym_concatenation_repeat1] = STATE(1131),
    [sym__simple_heredoc_body] = ACTIONS(1936),
    [sym__heredoc_body_beginning] = ACTIONS(1936),
    [sym_file_descriptor] = ACTIONS(1936),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(1938),
    [anon_sym_RPAREN] = ACTIONS(1936),
    [anon_sym_SEMI_SEMI] = ACTIONS(1936),
    [anon_sym_PIPE_AMP] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1938),
    [anon_sym_GT] = ACTIONS(1938),
    [anon_sym_GT_GT] = ACTIONS(1936),
    [anon_sym_AMP_GT] = ACTIONS(1938),
    [anon_sym_AMP_GT_GT] = ACTIONS(1936),
    [anon_sym_LT_AMP] = ACTIONS(1936),
    [anon_sym_GT_AMP] = ACTIONS(1936),
    [anon_sym_LT_LT] = ACTIONS(1938),
    [anon_sym_LT_LT_DASH] = ACTIONS(1936),
    [anon_sym_LT_LT_LT] = ACTIONS(1936),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_LF] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1938),
  },
  [647] = {
    [aux_sym_concatenation_repeat1] = STATE(1131),
    [sym__simple_heredoc_body] = ACTIONS(1940),
    [sym__heredoc_body_beginning] = ACTIONS(1940),
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [648] = {
    [sym_file_redirect] = STATE(648),
    [sym_heredoc_redirect] = STATE(648),
    [sym_herestring_redirect] = STATE(648),
    [aux_sym_while_statement_repeat1] = STATE(648),
    [sym__simple_heredoc_body] = ACTIONS(1948),
    [sym__heredoc_body_beginning] = ACTIONS(1948),
    [sym_file_descriptor] = ACTIONS(2426),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [anon_sym_SEMI_SEMI] = ACTIONS(1948),
    [anon_sym_PIPE_AMP] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_PIPE_PIPE] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2432),
    [anon_sym_AMP_GT] = ACTIONS(2429),
    [anon_sym_AMP_GT_GT] = ACTIONS(2432),
    [anon_sym_LT_AMP] = ACTIONS(2432),
    [anon_sym_GT_AMP] = ACTIONS(2432),
    [anon_sym_LT_LT] = ACTIONS(1961),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(2435),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_LF] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1953),
  },
  [649] = {
    [sym_file_redirect] = STATE(648),
    [sym_heredoc_redirect] = STATE(648),
    [sym_heredoc_body] = STATE(930),
    [sym_herestring_redirect] = STATE(648),
    [aux_sym_while_statement_repeat1] = STATE(648),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(1944),
    [anon_sym_SEMI_SEMI] = ACTIONS(1944),
    [anon_sym_PIPE_AMP] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(483),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_LF] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1946),
  },
  [650] = {
    [sym_concatenation] = STATE(650),
    [sym_string] = STATE(268),
    [sym_simple_expansion] = STATE(268),
    [sym_string_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [aux_sym_command_repeat2] = STATE(650),
    [sym__simple_heredoc_body] = ACTIONS(1928),
    [sym__heredoc_body_beginning] = ACTIONS(1928),
    [sym_file_descriptor] = ACTIONS(1928),
    [anon_sym_PIPE] = ACTIONS(1930),
    [anon_sym_RPAREN] = ACTIONS(1928),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_EQ_TILDE] = ACTIONS(2438),
    [anon_sym_EQ_EQ] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_GT] = ACTIONS(1930),
    [anon_sym_GT_GT] = ACTIONS(1928),
    [anon_sym_AMP_GT] = ACTIONS(1930),
    [anon_sym_AMP_GT_GT] = ACTIONS(1928),
    [anon_sym_LT_AMP] = ACTIONS(1928),
    [anon_sym_GT_AMP] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(1930),
    [anon_sym_LT_LT_DASH] = ACTIONS(1928),
    [anon_sym_LT_LT_LT] = ACTIONS(1928),
    [sym__special_characters] = ACTIONS(2441),
    [anon_sym_DQUOTE] = ACTIONS(1976),
    [anon_sym_DOLLAR] = ACTIONS(1979),
    [sym_raw_string] = ACTIONS(2444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1988),
    [anon_sym_BQUOTE] = ACTIONS(1991),
    [anon_sym_LT_LPAREN] = ACTIONS(1994),
    [anon_sym_GT_LPAREN] = ACTIONS(1994),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2447),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [651] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2450),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [652] = {
    [sym_file_redirect] = STATE(1133),
    [sym_heredoc_redirect] = STATE(1133),
    [sym_heredoc_body] = STATE(930),
    [sym_herestring_redirect] = STATE(1133),
    [sym_concatenation] = STATE(650),
    [sym_string] = STATE(268),
    [sym_simple_expansion] = STATE(268),
    [sym_string_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [aux_sym_while_statement_repeat1] = STATE(1133),
    [aux_sym_command_repeat2] = STATE(650),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(1944),
    [anon_sym_SEMI_SEMI] = ACTIONS(1944),
    [anon_sym_PIPE_AMP] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_EQ_TILDE] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(483),
    [sym__special_characters] = ACTIONS(485),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(489),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_LF] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1946),
  },
  [653] = {
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1001),
    [anon_sym_GT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_AMP_GT] = ACTIONS(1001),
    [anon_sym_AMP_GT_GT] = ACTIONS(999),
    [anon_sym_LT_AMP] = ACTIONS(999),
    [anon_sym_GT_AMP] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(999),
  },
  [654] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_string_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [aux_sym_for_statement_repeat1] = STATE(1135),
    [anon_sym_RPAREN] = ACTIONS(2452),
    [sym__special_characters] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [sym_raw_string] = ACTIONS(1011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1019),
    [anon_sym_GT_LPAREN] = ACTIONS(1019),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1011),
  },
  [655] = {
    [aux_sym_concatenation_repeat1] = STATE(380),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(1025),
    [anon_sym_GT] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1025),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1025),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1021),
  },
  [656] = {
    [aux_sym_concatenation_repeat1] = STATE(380),
    [sym_file_descriptor] = ACTIONS(999),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1001),
    [anon_sym_GT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_AMP_GT] = ACTIONS(1001),
    [anon_sym_AMP_GT_GT] = ACTIONS(999),
    [anon_sym_LT_AMP] = ACTIONS(999),
    [anon_sym_GT_AMP] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(999),
  },
  [657] = {
    [anon_sym_RPAREN] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_EQ_TILDE] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1249),
    [anon_sym_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1247),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1247),
  },
  [658] = {
    [aux_sym_concatenation_repeat1] = STATE(1136),
    [sym__concat] = ACTIONS(549),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_EQ] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_BANG_EQ] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(695),
  },
  [659] = {
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_RBRACK] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2454),
  },
  [660] = {
    [sym__expression] = STATE(728),
    [sym_binary_expression] = STATE(728),
    [sym_unary_expression] = STATE(728),
    [sym_parenthesized_expression] = STATE(728),
    [sym_concatenation] = STATE(728),
    [sym_string] = STATE(278),
    [sym_simple_expansion] = STATE(278),
    [sym_string_expansion] = STATE(278),
    [sym_expansion] = STATE(278),
    [sym_command_substitution] = STATE(278),
    [sym_process_substitution] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(499),
    [sym__special_characters] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(505),
    [sym_test_operator] = ACTIONS(507),
  },
  [661] = {
    [sym__expression] = STATE(728),
    [sym_binary_expression] = STATE(728),
    [sym_unary_expression] = STATE(728),
    [sym_parenthesized_expression] = STATE(728),
    [sym_concatenation] = STATE(728),
    [sym_string] = STATE(278),
    [sym_simple_expansion] = STATE(278),
    [sym_string_expansion] = STATE(278),
    [sym_expansion] = STATE(278),
    [sym_command_substitution] = STATE(278),
    [sym_process_substitution] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(499),
    [sym__special_characters] = ACTIONS(2458),
    [anon_sym_DQUOTE] = ACTIONS(1405),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1411),
    [anon_sym_LT_LPAREN] = ACTIONS(1413),
    [anon_sym_GT_LPAREN] = ACTIONS(1413),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(505),
    [sym_test_operator] = ACTIONS(499),
    [sym_regex] = ACTIONS(1415),
  },
  [662] = {
    [sym__concat] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_RBRACK] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1664),
    [anon_sym_EQ_EQ] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_BANG_EQ] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1664),
  },
  [663] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__concat] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_RBRACK] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1664),
    [anon_sym_EQ_EQ] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_BANG_EQ] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1664),
  },
  [664] = {
    [sym__concat] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_RBRACK] = ACTIONS(1671),
    [anon_sym_EQ_TILDE] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1673),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_BANG_EQ] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1671),
  },
  [665] = {
    [anon_sym_DQUOTE] = ACTIONS(2463),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [666] = {
    [sym_concatenation] = STATE(1141),
    [sym_string] = STATE(1140),
    [sym_simple_expansion] = STATE(1140),
    [sym_string_expansion] = STATE(1140),
    [sym_expansion] = STATE(1140),
    [sym_command_substitution] = STATE(1140),
    [sym_process_substitution] = STATE(1140),
    [anon_sym_RBRACE] = ACTIONS(2465),
    [sym__special_characters] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(2469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2469),
  },
  [667] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(2471),
    [sym_comment] = ACTIONS(53),
  },
  [668] = {
    [sym_concatenation] = STATE(1145),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1145),
    [anon_sym_RBRACE] = ACTIONS(2473),
    [anon_sym_EQ] = ACTIONS(2475),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2477),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2479),
    [anon_sym_COLON] = ACTIONS(2475),
    [anon_sym_COLON_QMARK] = ACTIONS(2475),
    [anon_sym_COLON_DASH] = ACTIONS(2475),
    [anon_sym_PERCENT] = ACTIONS(2475),
    [anon_sym_DASH] = ACTIONS(2475),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [669] = {
    [sym_concatenation] = STATE(1148),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1148),
    [anon_sym_RBRACE] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(2483),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2485),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2487),
    [anon_sym_COLON] = ACTIONS(2483),
    [anon_sym_COLON_QMARK] = ACTIONS(2483),
    [anon_sym_COLON_DASH] = ACTIONS(2483),
    [anon_sym_PERCENT] = ACTIONS(2483),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [670] = {
    [sym_concatenation] = STATE(1150),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1150),
    [anon_sym_RBRACE] = ACTIONS(2465),
    [anon_sym_EQ] = ACTIONS(2489),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2491),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2493),
    [anon_sym_COLON] = ACTIONS(2489),
    [anon_sym_COLON_QMARK] = ACTIONS(2489),
    [anon_sym_COLON_DASH] = ACTIONS(2489),
    [anon_sym_PERCENT] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [671] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [anon_sym_RBRACK] = ACTIONS(1788),
    [anon_sym_EQ_TILDE] = ACTIONS(1788),
    [anon_sym_EQ_EQ] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(1788),
    [anon_sym_GT] = ACTIONS(1788),
    [anon_sym_BANG_EQ] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1788),
  },
  [672] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2495),
  },
  [673] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2497),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [674] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_RBRACK] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1832),
    [anon_sym_EQ_EQ] = ACTIONS(1832),
    [anon_sym_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1832),
    [anon_sym_GT] = ACTIONS(1832),
    [anon_sym_BANG_EQ] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1832),
  },
  [675] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2499),
  },
  [676] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2501),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [677] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_RBRACK] = ACTIONS(1840),
    [anon_sym_EQ_TILDE] = ACTIONS(1840),
    [anon_sym_EQ_EQ] = ACTIONS(1840),
    [anon_sym_EQ] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1840),
    [anon_sym_GT] = ACTIONS(1840),
    [anon_sym_BANG_EQ] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1840),
  },
  [678] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2503),
  },
  [679] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2465),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [680] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_RBRACK] = ACTIONS(1846),
    [anon_sym_EQ_TILDE] = ACTIONS(1846),
    [anon_sym_EQ_EQ] = ACTIONS(1846),
    [anon_sym_EQ] = ACTIONS(1848),
    [anon_sym_LT] = ACTIONS(1846),
    [anon_sym_GT] = ACTIONS(1846),
    [anon_sym_BANG_EQ] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1846),
  },
  [681] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [682] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2505),
    [anon_sym_SEMI_SEMI] = ACTIONS(2507),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2509),
    [anon_sym_LF] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2509),
  },
  [683] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2505),
    [anon_sym_SEMI_SEMI] = ACTIONS(2507),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2509),
    [anon_sym_LF] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2509),
  },
  [684] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(2505),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [685] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2511),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(2505),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2513),
    [anon_sym_LF] = ACTIONS(2511),
    [anon_sym_AMP] = ACTIONS(2513),
  },
  [686] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2511),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(2505),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2513),
    [anon_sym_LF] = ACTIONS(2511),
    [anon_sym_AMP] = ACTIONS(2513),
  },
  [687] = {
    [sym__concat] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_RBRACK] = ACTIONS(1878),
    [anon_sym_EQ_TILDE] = ACTIONS(1878),
    [anon_sym_EQ_EQ] = ACTIONS(1878),
    [anon_sym_EQ] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_BANG_EQ] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1878),
  },
  [688] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [689] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_SEMI_SEMI] = ACTIONS(2517),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2519),
    [anon_sym_LF] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2519),
  },
  [690] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_SEMI_SEMI] = ACTIONS(2517),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2519),
    [anon_sym_LF] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2519),
  },
  [691] = {
    [anon_sym_AMP_AMP] = ACTIONS(2521),
    [anon_sym_PIPE_PIPE] = ACTIONS(2521),
    [anon_sym_RBRACK] = ACTIONS(2521),
    [anon_sym_EQ_TILDE] = ACTIONS(2521),
    [anon_sym_EQ_EQ] = ACTIONS(2521),
    [anon_sym_EQ] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_BANG_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2521),
  },
  [692] = {
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(2525),
    [anon_sym_GT_GT] = ACTIONS(2527),
    [anon_sym_AMP_GT] = ACTIONS(2525),
    [anon_sym_AMP_GT_GT] = ACTIONS(2527),
    [anon_sym_LT_AMP] = ACTIONS(2527),
    [anon_sym_GT_AMP] = ACTIONS(2527),
    [sym_comment] = ACTIONS(53),
  },
  [693] = {
    [sym_concatenation] = STATE(1170),
    [sym_string] = STATE(1165),
    [sym_simple_expansion] = STATE(1165),
    [sym_string_expansion] = STATE(1165),
    [sym_expansion] = STATE(1165),
    [sym_command_substitution] = STATE(1165),
    [sym_process_substitution] = STATE(1165),
    [sym__special_characters] = ACTIONS(2529),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(2535),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2535),
  },
  [694] = {
    [sym_heredoc_start] = ACTIONS(2545),
    [sym_comment] = ACTIONS(53),
  },
  [695] = {
    [sym_concatenation] = STATE(1174),
    [sym_string] = STATE(1173),
    [sym_simple_expansion] = STATE(1173),
    [sym_string_expansion] = STATE(1173),
    [sym_expansion] = STATE(1173),
    [sym_command_substitution] = STATE(1173),
    [sym_process_substitution] = STATE(1173),
    [sym__special_characters] = ACTIONS(2547),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(2549),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2549),
  },
  [696] = {
    [sym_file_redirect] = STATE(1175),
    [sym_heredoc_redirect] = STATE(1175),
    [sym_herestring_redirect] = STATE(1175),
    [aux_sym_while_statement_repeat1] = STATE(1175),
    [sym_file_descriptor] = ACTIONS(1311),
    [anon_sym_PIPE] = ACTIONS(2551),
    [anon_sym_SEMI_SEMI] = ACTIONS(2553),
    [anon_sym_PIPE_AMP] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(1317),
    [anon_sym_GT] = ACTIONS(1317),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_AMP_GT] = ACTIONS(1317),
    [anon_sym_AMP_GT_GT] = ACTIONS(1319),
    [anon_sym_LT_AMP] = ACTIONS(1319),
    [anon_sym_GT_AMP] = ACTIONS(1319),
    [anon_sym_LT_LT] = ACTIONS(1321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1323),
    [anon_sym_LT_LT_LT] = ACTIONS(1325),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2551),
    [anon_sym_LF] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2551),
  },
  [697] = {
    [anon_sym_AMP_AMP] = ACTIONS(2521),
    [anon_sym_PIPE_PIPE] = ACTIONS(2521),
    [anon_sym_RBRACK] = ACTIONS(2521),
    [anon_sym_EQ_TILDE] = ACTIONS(2521),
    [anon_sym_EQ_EQ] = ACTIONS(2521),
    [anon_sym_EQ] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_BANG_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2521),
  },
  [698] = {
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2454),
  },
  [699] = {
    [sym__concat] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1664),
    [anon_sym_EQ_EQ] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_BANG_EQ] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1664),
  },
  [700] = {
    [aux_sym_concatenation_repeat1] = STATE(700),
    [sym__concat] = ACTIONS(2555),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1664),
    [anon_sym_EQ_EQ] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_BANG_EQ] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1664),
  },
  [701] = {
    [sym__concat] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1671),
    [anon_sym_EQ_TILDE] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1673),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_BANG_EQ] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1671),
  },
  [702] = {
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [703] = {
    [sym_concatenation] = STATE(1180),
    [sym_string] = STATE(1179),
    [sym_simple_expansion] = STATE(1179),
    [sym_string_expansion] = STATE(1179),
    [sym_expansion] = STATE(1179),
    [sym_command_substitution] = STATE(1179),
    [sym_process_substitution] = STATE(1179),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(2564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2564),
  },
  [704] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(2566),
    [sym_comment] = ACTIONS(53),
  },
  [705] = {
    [sym_concatenation] = STATE(1184),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1184),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_EQ] = ACTIONS(2570),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_COLON] = ACTIONS(2570),
    [anon_sym_COLON_QMARK] = ACTIONS(2570),
    [anon_sym_COLON_DASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(2570),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [706] = {
    [sym_concatenation] = STATE(1187),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1187),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_EQ] = ACTIONS(2578),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2578),
    [anon_sym_COLON_QMARK] = ACTIONS(2578),
    [anon_sym_COLON_DASH] = ACTIONS(2578),
    [anon_sym_PERCENT] = ACTIONS(2578),
    [anon_sym_DASH] = ACTIONS(2578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [707] = {
    [sym_concatenation] = STATE(1189),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1189),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [anon_sym_EQ] = ACTIONS(2584),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_COLON] = ACTIONS(2584),
    [anon_sym_COLON_QMARK] = ACTIONS(2584),
    [anon_sym_COLON_DASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [708] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1788),
    [anon_sym_EQ_TILDE] = ACTIONS(1788),
    [anon_sym_EQ_EQ] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(1788),
    [anon_sym_GT] = ACTIONS(1788),
    [anon_sym_BANG_EQ] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1788),
  },
  [709] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2590),
  },
  [710] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2592),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [711] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1832),
    [anon_sym_EQ_EQ] = ACTIONS(1832),
    [anon_sym_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1832),
    [anon_sym_GT] = ACTIONS(1832),
    [anon_sym_BANG_EQ] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1832),
  },
  [712] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2594),
  },
  [713] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2596),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [714] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1840),
    [anon_sym_EQ_TILDE] = ACTIONS(1840),
    [anon_sym_EQ_EQ] = ACTIONS(1840),
    [anon_sym_EQ] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1840),
    [anon_sym_GT] = ACTIONS(1840),
    [anon_sym_BANG_EQ] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1840),
  },
  [715] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2598),
  },
  [716] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [717] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1846),
    [anon_sym_EQ_TILDE] = ACTIONS(1846),
    [anon_sym_EQ_EQ] = ACTIONS(1846),
    [anon_sym_EQ] = ACTIONS(1848),
    [anon_sym_LT] = ACTIONS(1846),
    [anon_sym_GT] = ACTIONS(1846),
    [anon_sym_BANG_EQ] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1846),
  },
  [718] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2600),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [719] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2600),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LF] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2604),
  },
  [720] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2600),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LF] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2604),
  },
  [721] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(2600),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [722] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2606),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(2600),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2608),
    [anon_sym_LF] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2608),
  },
  [723] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2606),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(2600),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2608),
    [anon_sym_LF] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2608),
  },
  [724] = {
    [sym__concat] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_RPAREN] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1878),
    [anon_sym_EQ_TILDE] = ACTIONS(1878),
    [anon_sym_EQ_EQ] = ACTIONS(1878),
    [anon_sym_EQ] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_BANG_EQ] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1878),
  },
  [725] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2610),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [726] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2610),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [727] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2610),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [728] = {
    [anon_sym_RPAREN] = ACTIONS(2521),
    [anon_sym_AMP_AMP] = ACTIONS(2521),
    [anon_sym_PIPE_PIPE] = ACTIONS(2521),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2521),
    [anon_sym_EQ_TILDE] = ACTIONS(2521),
    [anon_sym_EQ_EQ] = ACTIONS(2521),
    [anon_sym_EQ] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_BANG_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2521),
  },
  [729] = {
    [anon_sym_RPAREN] = ACTIONS(2521),
    [anon_sym_AMP_AMP] = ACTIONS(2521),
    [anon_sym_PIPE_PIPE] = ACTIONS(2521),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2521),
    [anon_sym_EQ_TILDE] = ACTIONS(2521),
    [anon_sym_EQ_EQ] = ACTIONS(2521),
    [anon_sym_EQ] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_BANG_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2521),
  },
  [730] = {
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(999),
    [anon_sym_PIPE_AMP] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1001),
    [sym_word] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LF] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(1001),
  },
  [731] = {
    [sym_concatenation] = STATE(1201),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_string_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [aux_sym_for_statement_repeat1] = STATE(1201),
    [anon_sym_RPAREN] = ACTIONS(2616),
    [sym__special_characters] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [sym_raw_string] = ACTIONS(1011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1019),
    [anon_sym_GT_LPAREN] = ACTIONS(1019),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1011),
  },
  [732] = {
    [aux_sym_concatenation_repeat1] = STATE(334),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1025),
    [anon_sym_SEMI_SEMI] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1025),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1025),
    [sym_word] = ACTIONS(1025),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_LF] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1025),
  },
  [733] = {
    [aux_sym_concatenation_repeat1] = STATE(334),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_SEMI_SEMI] = ACTIONS(999),
    [anon_sym_PIPE_AMP] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1001),
    [sym_word] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LF] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(1001),
  },
  [734] = {
    [sym__concat] = ACTIONS(1664),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1666),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [735] = {
    [aux_sym_concatenation_repeat1] = STATE(735),
    [sym__concat] = ACTIONS(2618),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1666),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [736] = {
    [sym__concat] = ACTIONS(1671),
    [sym_variable_name] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1673),
    [sym_word] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1673),
  },
  [737] = {
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [738] = {
    [sym_concatenation] = STATE(1206),
    [sym_string] = STATE(1205),
    [sym_simple_expansion] = STATE(1205),
    [sym_string_expansion] = STATE(1205),
    [sym_expansion] = STATE(1205),
    [sym_command_substitution] = STATE(1205),
    [sym_process_substitution] = STATE(1205),
    [anon_sym_RBRACE] = ACTIONS(2623),
    [sym__special_characters] = ACTIONS(2625),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(2627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2627),
  },
  [739] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(2629),
    [sym_comment] = ACTIONS(53),
  },
  [740] = {
    [sym_concatenation] = STATE(1210),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1210),
    [anon_sym_RBRACE] = ACTIONS(2631),
    [anon_sym_EQ] = ACTIONS(2633),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2637),
    [anon_sym_COLON] = ACTIONS(2633),
    [anon_sym_COLON_QMARK] = ACTIONS(2633),
    [anon_sym_COLON_DASH] = ACTIONS(2633),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [741] = {
    [sym_concatenation] = STATE(1213),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1213),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_EQ] = ACTIONS(2641),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2643),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2645),
    [anon_sym_COLON] = ACTIONS(2641),
    [anon_sym_COLON_QMARK] = ACTIONS(2641),
    [anon_sym_COLON_DASH] = ACTIONS(2641),
    [anon_sym_PERCENT] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [742] = {
    [sym_concatenation] = STATE(1215),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1215),
    [anon_sym_RBRACE] = ACTIONS(2623),
    [anon_sym_EQ] = ACTIONS(2647),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2649),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2651),
    [anon_sym_COLON] = ACTIONS(2647),
    [anon_sym_COLON_QMARK] = ACTIONS(2647),
    [anon_sym_COLON_DASH] = ACTIONS(2647),
    [anon_sym_PERCENT] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [743] = {
    [sym__concat] = ACTIONS(1788),
    [sym_variable_name] = ACTIONS(1788),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1788),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [anon_sym_PIPE_AMP] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1790),
    [sym_word] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1790),
  },
  [744] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2653),
  },
  [745] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [746] = {
    [sym__concat] = ACTIONS(1832),
    [sym_variable_name] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1834),
    [sym_word] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [747] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2657),
  },
  [748] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [749] = {
    [sym__concat] = ACTIONS(1840),
    [sym_variable_name] = ACTIONS(1840),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [anon_sym_PIPE_AMP] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1842),
    [sym_word] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [750] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2661),
  },
  [751] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2623),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [752] = {
    [sym__concat] = ACTIONS(1846),
    [sym_variable_name] = ACTIONS(1846),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1848),
    [sym_word] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1848),
  },
  [753] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2663),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [754] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2663),
    [anon_sym_SEMI_SEMI] = ACTIONS(2665),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2665),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [755] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2663),
    [anon_sym_SEMI_SEMI] = ACTIONS(2665),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2665),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [756] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(2663),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [757] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2669),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(2663),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym_LF] = ACTIONS(2669),
    [anon_sym_AMP] = ACTIONS(2671),
  },
  [758] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2669),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(2663),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym_LF] = ACTIONS(2669),
    [anon_sym_AMP] = ACTIONS(2671),
  },
  [759] = {
    [sym__concat] = ACTIONS(1878),
    [sym_variable_name] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_RPAREN] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1880),
    [sym_word] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1880),
  },
  [760] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2673),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [761] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2675),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2677),
    [anon_sym_LF] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2677),
  },
  [762] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2675),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2677),
    [anon_sym_LF] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2677),
  },
  [763] = {
    [sym__concat] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1666),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [764] = {
    [aux_sym_concatenation_repeat1] = STATE(764),
    [sym__concat] = ACTIONS(2679),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1666),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [765] = {
    [sym__concat] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1673),
    [sym_word] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1673),
  },
  [766] = {
    [anon_sym_DQUOTE] = ACTIONS(2682),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [767] = {
    [sym_concatenation] = STATE(1230),
    [sym_string] = STATE(1229),
    [sym_simple_expansion] = STATE(1229),
    [sym_string_expansion] = STATE(1229),
    [sym_expansion] = STATE(1229),
    [sym_command_substitution] = STATE(1229),
    [sym_process_substitution] = STATE(1229),
    [anon_sym_RBRACE] = ACTIONS(2684),
    [sym__special_characters] = ACTIONS(2686),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(2688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2688),
  },
  [768] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(2690),
    [sym_comment] = ACTIONS(53),
  },
  [769] = {
    [sym_concatenation] = STATE(1234),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1234),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_EQ] = ACTIONS(2694),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2698),
    [anon_sym_COLON] = ACTIONS(2694),
    [anon_sym_COLON_QMARK] = ACTIONS(2694),
    [anon_sym_COLON_DASH] = ACTIONS(2694),
    [anon_sym_PERCENT] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [770] = {
    [sym_concatenation] = STATE(1237),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1237),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_EQ] = ACTIONS(2702),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2706),
    [anon_sym_COLON] = ACTIONS(2702),
    [anon_sym_COLON_QMARK] = ACTIONS(2702),
    [anon_sym_COLON_DASH] = ACTIONS(2702),
    [anon_sym_PERCENT] = ACTIONS(2702),
    [anon_sym_DASH] = ACTIONS(2702),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [771] = {
    [sym_concatenation] = STATE(1239),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1239),
    [anon_sym_RBRACE] = ACTIONS(2684),
    [anon_sym_EQ] = ACTIONS(2708),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2712),
    [anon_sym_COLON] = ACTIONS(2708),
    [anon_sym_COLON_QMARK] = ACTIONS(2708),
    [anon_sym_COLON_DASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [772] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1788),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [anon_sym_PIPE_AMP] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1790),
    [sym_word] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1790),
  },
  [773] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2714),
  },
  [774] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2716),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [775] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1834),
    [sym_word] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [776] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2718),
  },
  [777] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2720),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [778] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [anon_sym_PIPE_AMP] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1842),
    [sym_word] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [779] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2722),
  },
  [780] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2684),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [781] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1848),
    [sym_word] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1848),
  },
  [782] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [783] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2724),
    [anon_sym_SEMI_SEMI] = ACTIONS(2726),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2726),
    [anon_sym_AMP] = ACTIONS(2728),
  },
  [784] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2724),
    [anon_sym_SEMI_SEMI] = ACTIONS(2726),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2726),
    [anon_sym_AMP] = ACTIONS(2728),
  },
  [785] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(2724),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [786] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2730),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(2724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_LF] = ACTIONS(2730),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [787] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2730),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(2724),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_LF] = ACTIONS(2730),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [788] = {
    [sym__concat] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_RPAREN] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1880),
    [sym_word] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1880),
  },
  [789] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [790] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_SEMI_SEMI] = ACTIONS(2736),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_LF] = ACTIONS(2736),
    [anon_sym_AMP] = ACTIONS(2738),
  },
  [791] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_SEMI_SEMI] = ACTIONS(2736),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_LF] = ACTIONS(2736),
    [anon_sym_AMP] = ACTIONS(2738),
  },
  [792] = {
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1664),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1664),
  },
  [793] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(2740),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1664),
  },
  [794] = {
    [sym_file_descriptor] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1671),
    [sym_variable_name] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1673),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1673),
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1671),
  },
  [795] = {
    [anon_sym_DQUOTE] = ACTIONS(2743),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [796] = {
    [sym_concatenation] = STATE(1254),
    [sym_string] = STATE(1253),
    [sym_simple_expansion] = STATE(1253),
    [sym_string_expansion] = STATE(1253),
    [sym_expansion] = STATE(1253),
    [sym_command_substitution] = STATE(1253),
    [sym_process_substitution] = STATE(1253),
    [anon_sym_RBRACE] = ACTIONS(2745),
    [sym__special_characters] = ACTIONS(2747),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(2749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2749),
  },
  [797] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(2751),
    [sym_comment] = ACTIONS(53),
  },
  [798] = {
    [sym_concatenation] = STATE(1258),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1258),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_EQ] = ACTIONS(2755),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2757),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_COLON] = ACTIONS(2755),
    [anon_sym_COLON_QMARK] = ACTIONS(2755),
    [anon_sym_COLON_DASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [799] = {
    [sym_concatenation] = STATE(1261),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1261),
    [anon_sym_RBRACE] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2763),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2767),
    [anon_sym_COLON] = ACTIONS(2763),
    [anon_sym_COLON_QMARK] = ACTIONS(2763),
    [anon_sym_COLON_DASH] = ACTIONS(2763),
    [anon_sym_PERCENT] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [800] = {
    [sym_concatenation] = STATE(1263),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1263),
    [anon_sym_RBRACE] = ACTIONS(2745),
    [anon_sym_EQ] = ACTIONS(2769),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2773),
    [anon_sym_COLON] = ACTIONS(2769),
    [anon_sym_COLON_QMARK] = ACTIONS(2769),
    [anon_sym_COLON_DASH] = ACTIONS(2769),
    [anon_sym_PERCENT] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [801] = {
    [sym_file_descriptor] = ACTIONS(1788),
    [sym__concat] = ACTIONS(1788),
    [sym_variable_name] = ACTIONS(1788),
    [anon_sym_LT] = ACTIONS(1790),
    [anon_sym_GT] = ACTIONS(1790),
    [anon_sym_GT_GT] = ACTIONS(1788),
    [anon_sym_AMP_GT] = ACTIONS(1790),
    [anon_sym_AMP_GT_GT] = ACTIONS(1788),
    [anon_sym_LT_AMP] = ACTIONS(1788),
    [anon_sym_GT_AMP] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1788),
  },
  [802] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2775),
  },
  [803] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [804] = {
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [sym_variable_name] = ACTIONS(1832),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1832),
  },
  [805] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2779),
  },
  [806] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [807] = {
    [sym_file_descriptor] = ACTIONS(1840),
    [sym__concat] = ACTIONS(1840),
    [sym_variable_name] = ACTIONS(1840),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_GT] = ACTIONS(1842),
    [anon_sym_GT_GT] = ACTIONS(1840),
    [anon_sym_AMP_GT] = ACTIONS(1842),
    [anon_sym_AMP_GT_GT] = ACTIONS(1840),
    [anon_sym_LT_AMP] = ACTIONS(1840),
    [anon_sym_GT_AMP] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1840),
  },
  [808] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2783),
  },
  [809] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2745),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [810] = {
    [sym_file_descriptor] = ACTIONS(1846),
    [sym__concat] = ACTIONS(1846),
    [sym_variable_name] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT] = ACTIONS(1848),
    [anon_sym_AMP_GT_GT] = ACTIONS(1846),
    [anon_sym_LT_AMP] = ACTIONS(1846),
    [anon_sym_GT_AMP] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1846),
  },
  [811] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [812] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2785),
    [anon_sym_SEMI_SEMI] = ACTIONS(2787),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_LF] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2789),
  },
  [813] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2785),
    [anon_sym_SEMI_SEMI] = ACTIONS(2787),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_LF] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2789),
  },
  [814] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(2785),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [815] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2791),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(2785),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym_LF] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2793),
  },
  [816] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2791),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(2785),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym_LF] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2793),
  },
  [817] = {
    [sym_file_descriptor] = ACTIONS(1878),
    [sym__concat] = ACTIONS(1878),
    [sym_variable_name] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1880),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT] = ACTIONS(1880),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1878),
  },
  [818] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2795),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [819] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2795),
    [anon_sym_SEMI_SEMI] = ACTIONS(2797),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym_LF] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2799),
  },
  [820] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2795),
    [anon_sym_SEMI_SEMI] = ACTIONS(2797),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym_LF] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2799),
  },
  [821] = {
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [anon_sym_DOLLAR] = ACTIONS(2801),
    [sym__string_content] = ACTIONS(2803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2801),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2801),
    [anon_sym_BQUOTE] = ACTIONS(2801),
    [sym_comment] = ACTIONS(243),
  },
  [822] = {
    [sym_concatenation] = STATE(1277),
    [sym_string] = STATE(1276),
    [sym_simple_expansion] = STATE(1276),
    [sym_string_expansion] = STATE(1276),
    [sym_expansion] = STATE(1276),
    [sym_command_substitution] = STATE(1276),
    [sym_process_substitution] = STATE(1276),
    [anon_sym_RBRACE] = ACTIONS(2805),
    [sym__special_characters] = ACTIONS(2807),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(2809),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2809),
  },
  [823] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(2811),
    [sym_comment] = ACTIONS(53),
  },
  [824] = {
    [sym_concatenation] = STATE(1281),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1281),
    [anon_sym_RBRACE] = ACTIONS(2813),
    [anon_sym_EQ] = ACTIONS(2815),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_COLON] = ACTIONS(2815),
    [anon_sym_COLON_QMARK] = ACTIONS(2815),
    [anon_sym_COLON_DASH] = ACTIONS(2815),
    [anon_sym_PERCENT] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2815),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [825] = {
    [sym_concatenation] = STATE(1284),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1284),
    [anon_sym_RBRACE] = ACTIONS(2821),
    [anon_sym_EQ] = ACTIONS(2823),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_COLON] = ACTIONS(2823),
    [anon_sym_COLON_QMARK] = ACTIONS(2823),
    [anon_sym_COLON_DASH] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [826] = {
    [sym_concatenation] = STATE(1286),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1286),
    [anon_sym_RBRACE] = ACTIONS(2805),
    [anon_sym_EQ] = ACTIONS(2829),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2829),
    [anon_sym_COLON_QMARK] = ACTIONS(2829),
    [anon_sym_COLON_DASH] = ACTIONS(2829),
    [anon_sym_PERCENT] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [827] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym__string_content] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1790),
    [anon_sym_BQUOTE] = ACTIONS(1790),
    [sym_comment] = ACTIONS(243),
  },
  [828] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2835),
  },
  [829] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [830] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym__string_content] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [sym_comment] = ACTIONS(243),
  },
  [831] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2839),
  },
  [832] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2841),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [833] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1842),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym__string_content] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1842),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1842),
    [anon_sym_BQUOTE] = ACTIONS(1842),
    [sym_comment] = ACTIONS(243),
  },
  [834] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2843),
  },
  [835] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2805),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [836] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1848),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym__string_content] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1848),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1848),
    [anon_sym_BQUOTE] = ACTIONS(1848),
    [sym_comment] = ACTIONS(243),
  },
  [837] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [838] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2845),
    [anon_sym_SEMI_SEMI] = ACTIONS(2847),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym_LF] = ACTIONS(2847),
    [anon_sym_AMP] = ACTIONS(2849),
  },
  [839] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2845),
    [anon_sym_SEMI_SEMI] = ACTIONS(2847),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym_LF] = ACTIONS(2847),
    [anon_sym_AMP] = ACTIONS(2849),
  },
  [840] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(2845),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [841] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2851),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(2845),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_LF] = ACTIONS(2851),
    [anon_sym_AMP] = ACTIONS(2853),
  },
  [842] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2851),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(2845),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_LF] = ACTIONS(2851),
    [anon_sym_AMP] = ACTIONS(2853),
  },
  [843] = {
    [sym__simple_heredoc_body] = ACTIONS(2855),
    [sym__heredoc_body_beginning] = ACTIONS(2855),
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_EQ_EQ] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2855),
    [anon_sym_LT_AMP] = ACTIONS(2855),
    [anon_sym_GT_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_LT_LT_DASH] = ACTIONS(2855),
    [anon_sym_LT_LT_LT] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [844] = {
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [845] = {
    [aux_sym_concatenation_repeat1] = STATE(497),
    [sym__concat] = ACTIONS(2859),
    [anon_sym_RBRACK] = ACTIONS(2861),
    [sym_comment] = ACTIONS(53),
  },
  [846] = {
    [aux_sym_concatenation_repeat1] = STATE(497),
    [sym__concat] = ACTIONS(2863),
    [anon_sym_RBRACK] = ACTIONS(2865),
    [sym_comment] = ACTIONS(53),
  },
  [847] = {
    [sym__concat] = ACTIONS(2867),
    [anon_sym_RBRACK] = ACTIONS(2865),
    [sym_comment] = ACTIONS(53),
  },
  [848] = {
    [sym__simple_heredoc_body] = ACTIONS(2869),
    [sym__heredoc_body_beginning] = ACTIONS(2869),
    [sym_file_descriptor] = ACTIONS(2869),
    [sym__concat] = ACTIONS(2869),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_RPAREN] = ACTIONS(2869),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [anon_sym_PIPE_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [anon_sym_EQ_TILDE] = ACTIONS(2871),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_GT_GT] = ACTIONS(2869),
    [anon_sym_AMP_GT] = ACTIONS(2871),
    [anon_sym_AMP_GT_GT] = ACTIONS(2869),
    [anon_sym_LT_AMP] = ACTIONS(2869),
    [anon_sym_GT_AMP] = ACTIONS(2869),
    [anon_sym_LT_LT] = ACTIONS(2871),
    [anon_sym_LT_LT_DASH] = ACTIONS(2869),
    [anon_sym_LT_LT_LT] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [849] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [sym_comment] = ACTIONS(53),
  },
  [850] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(1305),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_DOLLAR] = ACTIONS(2879),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [851] = {
    [sym_string] = STATE(1307),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [sym_raw_string] = ACTIONS(2883),
    [anon_sym_POUND] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AT] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_0] = ACTIONS(2887),
    [anon_sym__] = ACTIONS(2887),
  },
  [852] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [sym_comment] = ACTIONS(53),
  },
  [853] = {
    [sym_subscript] = STATE(1314),
    [sym_variable_name] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_POUND] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2895),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AT] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_0] = ACTIONS(2899),
    [anon_sym__] = ACTIONS(2899),
  },
  [854] = {
    [sym__terminated_statement] = STATE(1317),
    [sym_for_statement] = STATE(1315),
    [sym_c_style_for_statement] = STATE(1315),
    [sym_while_statement] = STATE(1315),
    [sym_if_statement] = STATE(1315),
    [sym_case_statement] = STATE(1315),
    [sym_function_definition] = STATE(1315),
    [sym_subshell] = STATE(1315),
    [sym_pipeline] = STATE(1315),
    [sym_list] = STATE(1315),
    [sym_negated_command] = STATE(1315),
    [sym_test_command] = STATE(1315),
    [sym_declaration_command] = STATE(1315),
    [sym_unset_command] = STATE(1315),
    [sym_command] = STATE(1315),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1316),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(1317),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [855] = {
    [sym__terminated_statement] = STATE(1320),
    [sym_for_statement] = STATE(1318),
    [sym_c_style_for_statement] = STATE(1318),
    [sym_while_statement] = STATE(1318),
    [sym_if_statement] = STATE(1318),
    [sym_case_statement] = STATE(1318),
    [sym_function_definition] = STATE(1318),
    [sym_subshell] = STATE(1318),
    [sym_pipeline] = STATE(1318),
    [sym_list] = STATE(1318),
    [sym_negated_command] = STATE(1318),
    [sym_test_command] = STATE(1318),
    [sym_declaration_command] = STATE(1318),
    [sym_unset_command] = STATE(1318),
    [sym_command] = STATE(1318),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(1319),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1320),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [856] = {
    [sym__terminated_statement] = STATE(1323),
    [sym_for_statement] = STATE(1321),
    [sym_c_style_for_statement] = STATE(1321),
    [sym_while_statement] = STATE(1321),
    [sym_if_statement] = STATE(1321),
    [sym_case_statement] = STATE(1321),
    [sym_function_definition] = STATE(1321),
    [sym_subshell] = STATE(1321),
    [sym_pipeline] = STATE(1321),
    [sym_list] = STATE(1321),
    [sym_negated_command] = STATE(1321),
    [sym_test_command] = STATE(1321),
    [sym_declaration_command] = STATE(1321),
    [sym_unset_command] = STATE(1321),
    [sym_command] = STATE(1321),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1322),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(1323),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [857] = {
    [anon_sym_RBRACE] = ACTIONS(2889),
    [sym_comment] = ACTIONS(53),
  },
  [858] = {
    [sym_concatenation] = STATE(1326),
    [sym_string] = STATE(1325),
    [sym_simple_expansion] = STATE(1325),
    [sym_string_expansion] = STATE(1325),
    [sym_expansion] = STATE(1325),
    [sym_command_substitution] = STATE(1325),
    [sym_process_substitution] = STATE(1325),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [sym__special_characters] = ACTIONS(2901),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(2903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2903),
  },
  [859] = {
    [sym__simple_heredoc_body] = ACTIONS(2905),
    [sym__heredoc_body_beginning] = ACTIONS(2905),
    [sym_file_descriptor] = ACTIONS(2905),
    [sym__concat] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [anon_sym_PIPE_AMP] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_EQ_EQ] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2907),
    [anon_sym_GT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2905),
    [anon_sym_AMP_GT] = ACTIONS(2907),
    [anon_sym_AMP_GT_GT] = ACTIONS(2905),
    [anon_sym_LT_AMP] = ACTIONS(2905),
    [anon_sym_GT_AMP] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_LT_LT_DASH] = ACTIONS(2905),
    [anon_sym_LT_LT_LT] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [860] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2909),
  },
  [861] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [862] = {
    [sym__simple_heredoc_body] = ACTIONS(2913),
    [sym__heredoc_body_beginning] = ACTIONS(2913),
    [sym_file_descriptor] = ACTIONS(2913),
    [sym__concat] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [anon_sym_PIPE_AMP] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_AMP_GT] = ACTIONS(2915),
    [anon_sym_AMP_GT_GT] = ACTIONS(2913),
    [anon_sym_LT_AMP] = ACTIONS(2913),
    [anon_sym_GT_AMP] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_LT_LT_DASH] = ACTIONS(2913),
    [anon_sym_LT_LT_LT] = ACTIONS(2913),
    [sym__special_characters] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [863] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2917),
  },
  [864] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [865] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(2921),
  },
  [866] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [867] = {
    [sym_string] = STATE(1332),
    [sym_simple_expansion] = STATE(1332),
    [sym_string_expansion] = STATE(1332),
    [sym_expansion] = STATE(1332),
    [sym_command_substitution] = STATE(1332),
    [sym_process_substitution] = STATE(1332),
    [sym__special_characters] = ACTIONS(2923),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(2923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2923),
  },
  [868] = {
    [aux_sym_concatenation_repeat1] = STATE(1333),
    [sym__concat] = ACTIONS(1792),
    [anon_sym_RBRACE] = ACTIONS(695),
    [anon_sym_EQ] = ACTIONS(697),
    [sym__special_characters] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_POUND] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_COLON] = ACTIONS(697),
    [anon_sym_COLON_QMARK] = ACTIONS(697),
    [anon_sym_COLON_DASH] = ACTIONS(697),
    [anon_sym_PERCENT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(697),
  },
  [869] = {
    [sym__concat] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_EQ] = ACTIONS(701),
    [sym__special_characters] = ACTIONS(701),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_COLON] = ACTIONS(701),
    [anon_sym_COLON_QMARK] = ACTIONS(701),
    [anon_sym_COLON_DASH] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(701),
  },
  [870] = {
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [871] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [872] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_POUND] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(733),
    [anon_sym_COLON_QMARK] = ACTIONS(733),
    [anon_sym_COLON_DASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(733),
  },
  [873] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_POUND] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_COLON] = ACTIONS(737),
    [anon_sym_COLON_QMARK] = ACTIONS(737),
    [anon_sym_COLON_DASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_DASH] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(737),
  },
  [874] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [sym__special_characters] = ACTIONS(741),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_POUND] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_COLON] = ACTIONS(741),
    [anon_sym_COLON_QMARK] = ACTIONS(741),
    [anon_sym_COLON_DASH] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_DASH] = ACTIONS(741),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(741),
  },
  [875] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(2929),
    [sym_comment] = ACTIONS(53),
  },
  [876] = {
    [sym_subscript] = STATE(1340),
    [sym_variable_name] = ACTIONS(2931),
    [anon_sym_DOLLAR] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2933),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_AT] = ACTIONS(2933),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_0] = ACTIONS(2937),
    [anon_sym__] = ACTIONS(2937),
  },
  [877] = {
    [sym_concatenation] = STATE(1343),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1343),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_EQ] = ACTIONS(2941),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2945),
    [anon_sym_COLON] = ACTIONS(2941),
    [anon_sym_COLON_QMARK] = ACTIONS(2941),
    [anon_sym_COLON_DASH] = ACTIONS(2941),
    [anon_sym_PERCENT] = ACTIONS(2941),
    [anon_sym_DASH] = ACTIONS(2941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [878] = {
    [sym_concatenation] = STATE(1346),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1346),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(2949),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2953),
    [anon_sym_COLON] = ACTIONS(2949),
    [anon_sym_COLON_QMARK] = ACTIONS(2949),
    [anon_sym_COLON_DASH] = ACTIONS(2949),
    [anon_sym_PERCENT] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [879] = {
    [sym_concatenation] = STATE(1349),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1349),
    [anon_sym_RBRACE] = ACTIONS(2955),
    [anon_sym_EQ] = ACTIONS(2957),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_COLON] = ACTIONS(2957),
    [anon_sym_COLON_QMARK] = ACTIONS(2957),
    [anon_sym_COLON_DASH] = ACTIONS(2957),
    [anon_sym_PERCENT] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [880] = {
    [sym_concatenation] = STATE(1351),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1351),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_EQ] = ACTIONS(2965),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(2967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(2965),
    [anon_sym_COLON_QMARK] = ACTIONS(2965),
    [anon_sym_COLON_DASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2965),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [881] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2969),
    [anon_sym_SEMI_SEMI] = ACTIONS(2971),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_LF] = ACTIONS(2971),
    [anon_sym_AMP] = ACTIONS(2973),
  },
  [882] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2969),
    [anon_sym_SEMI_SEMI] = ACTIONS(2971),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_LF] = ACTIONS(2971),
    [anon_sym_AMP] = ACTIONS(2973),
  },
  [883] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1354),
    [sym_c_style_for_statement] = STATE(1354),
    [sym_while_statement] = STATE(1354),
    [sym_if_statement] = STATE(1354),
    [sym_case_statement] = STATE(1354),
    [sym_function_definition] = STATE(1354),
    [sym_subshell] = STATE(1354),
    [sym_pipeline] = STATE(1354),
    [sym_list] = STATE(1354),
    [sym_negated_command] = STATE(1354),
    [sym_test_command] = STATE(1354),
    [sym_declaration_command] = STATE(1354),
    [sym_unset_command] = STATE(1354),
    [sym_command] = STATE(1354),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1355),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [884] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2975),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(2969),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_LF] = ACTIONS(2975),
    [anon_sym_AMP] = ACTIONS(2977),
  },
  [885] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(2975),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(2969),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_LF] = ACTIONS(2975),
    [anon_sym_AMP] = ACTIONS(2977),
  },
  [886] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1357),
    [sym_c_style_for_statement] = STATE(1357),
    [sym_while_statement] = STATE(1357),
    [sym_if_statement] = STATE(1357),
    [sym_case_statement] = STATE(1357),
    [sym_function_definition] = STATE(1357),
    [sym_subshell] = STATE(1357),
    [sym_pipeline] = STATE(1357),
    [sym_list] = STATE(1357),
    [sym_negated_command] = STATE(1357),
    [sym_test_command] = STATE(1357),
    [sym_declaration_command] = STATE(1357),
    [sym_unset_command] = STATE(1357),
    [sym_command] = STATE(1357),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(1358),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [887] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_SEMI_SEMI] = ACTIONS(2981),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2983),
  },
  [888] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_SEMI_SEMI] = ACTIONS(2981),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2983),
  },
  [889] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1361),
    [sym_c_style_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_case_statement] = STATE(1361),
    [sym_function_definition] = STATE(1361),
    [sym_subshell] = STATE(1361),
    [sym_pipeline] = STATE(1361),
    [sym_list] = STATE(1361),
    [sym_negated_command] = STATE(1361),
    [sym_test_command] = STATE(1361),
    [sym_declaration_command] = STATE(1361),
    [sym_unset_command] = STATE(1361),
    [sym_command] = STATE(1361),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1362),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [890] = {
    [sym__simple_heredoc_body] = ACTIONS(2985),
    [sym__heredoc_body_beginning] = ACTIONS(2985),
    [sym_file_descriptor] = ACTIONS(2985),
    [sym__concat] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [anon_sym_PIPE_AMP] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_EQ_TILDE] = ACTIONS(2987),
    [anon_sym_EQ_EQ] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_GT] = ACTIONS(2987),
    [anon_sym_AMP_GT_GT] = ACTIONS(2985),
    [anon_sym_LT_AMP] = ACTIONS(2985),
    [anon_sym_GT_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_LT_LT_DASH] = ACTIONS(2985),
    [anon_sym_LT_LT_LT] = ACTIONS(2985),
    [sym__special_characters] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2987),
  },
  [891] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(2991),
    [sym__special_characters] = ACTIONS(2994),
    [anon_sym_DQUOTE] = ACTIONS(2997),
    [anon_sym_DOLLAR] = ACTIONS(3000),
    [sym_raw_string] = ACTIONS(3003),
    [anon_sym_POUND] = ACTIONS(3006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_COLON_QMARK] = ACTIONS(2991),
    [anon_sym_COLON_DASH] = ACTIONS(2991),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_DASH] = ACTIONS(2991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3012),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [anon_sym_LT_LPAREN] = ACTIONS(3018),
    [anon_sym_GT_LPAREN] = ACTIONS(3018),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(3021),
  },
  [892] = {
    [sym_concatenation] = STATE(1364),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1364),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_EQ] = ACTIONS(3026),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3026),
    [anon_sym_COLON_QMARK] = ACTIONS(3026),
    [anon_sym_COLON_DASH] = ACTIONS(3026),
    [anon_sym_PERCENT] = ACTIONS(3026),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [893] = {
    [sym__simple_heredoc_body] = ACTIONS(3030),
    [sym__heredoc_body_beginning] = ACTIONS(3030),
    [sym_file_descriptor] = ACTIONS(3030),
    [sym__concat] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_PIPE_AMP] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_AMP_GT] = ACTIONS(3032),
    [anon_sym_AMP_GT_GT] = ACTIONS(3030),
    [anon_sym_LT_AMP] = ACTIONS(3030),
    [anon_sym_GT_AMP] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_LT_LT_DASH] = ACTIONS(3030),
    [anon_sym_LT_LT_LT] = ACTIONS(3030),
    [sym__special_characters] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
  },
  [894] = {
    [sym_concatenation] = STATE(1366),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1366),
    [anon_sym_RBRACE] = ACTIONS(3034),
    [anon_sym_EQ] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3036),
    [anon_sym_COLON_QMARK] = ACTIONS(3036),
    [anon_sym_COLON_DASH] = ACTIONS(3036),
    [anon_sym_PERCENT] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [895] = {
    [sym__simple_heredoc_body] = ACTIONS(3040),
    [sym__heredoc_body_beginning] = ACTIONS(3040),
    [sym_file_descriptor] = ACTIONS(3040),
    [sym__concat] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE_AMP] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_AMP_GT] = ACTIONS(3042),
    [anon_sym_AMP_GT_GT] = ACTIONS(3040),
    [anon_sym_LT_AMP] = ACTIONS(3040),
    [anon_sym_GT_AMP] = ACTIONS(3040),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_LT_LT_DASH] = ACTIONS(3040),
    [anon_sym_LT_LT_LT] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
  },
  [896] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [897] = {
    [sym_file_redirect] = STATE(1368),
    [sym_heredoc_redirect] = STATE(1368),
    [sym_heredoc_body] = STATE(575),
    [sym_herestring_redirect] = STATE(1368),
    [aux_sym_while_statement_repeat1] = STATE(1368),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [898] = {
    [anon_sym_RPAREN] = ACTIONS(3046),
    [sym_comment] = ACTIONS(53),
  },
  [899] = {
    [sym_file_redirect] = STATE(624),
    [sym_file_descriptor] = ACTIONS(3048),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_SEMI_SEMI] = ACTIONS(1193),
    [anon_sym_PIPE_AMP] = ACTIONS(1193),
    [anon_sym_AMP_AMP] = ACTIONS(1193),
    [anon_sym_PIPE_PIPE] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(3050),
    [anon_sym_GT] = ACTIONS(3050),
    [anon_sym_GT_GT] = ACTIONS(3052),
    [anon_sym_AMP_GT] = ACTIONS(3050),
    [anon_sym_AMP_GT_GT] = ACTIONS(3052),
    [anon_sym_LT_AMP] = ACTIONS(3052),
    [anon_sym_GT_AMP] = ACTIONS(3052),
    [anon_sym_BQUOTE] = ACTIONS(1193),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym_LF] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1191),
  },
  [900] = {
    [sym_file_redirect] = STATE(1375),
    [sym_heredoc_redirect] = STATE(1375),
    [sym_herestring_redirect] = STATE(1375),
    [aux_sym_while_statement_repeat1] = STATE(1375),
    [sym_file_descriptor] = ACTIONS(3054),
    [anon_sym_PIPE] = ACTIONS(1313),
    [anon_sym_SEMI_SEMI] = ACTIONS(1315),
    [anon_sym_PIPE_AMP] = ACTIONS(1315),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(3056),
    [anon_sym_GT] = ACTIONS(3056),
    [anon_sym_GT_GT] = ACTIONS(3058),
    [anon_sym_AMP_GT] = ACTIONS(3056),
    [anon_sym_AMP_GT_GT] = ACTIONS(3058),
    [anon_sym_LT_AMP] = ACTIONS(3058),
    [anon_sym_GT_AMP] = ACTIONS(3058),
    [anon_sym_LT_LT] = ACTIONS(1321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1323),
    [anon_sym_LT_LT_LT] = ACTIONS(3060),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1313),
    [anon_sym_LF] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1313),
  },
  [901] = {
    [sym_compound_statement] = STATE(1376),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [902] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(1890),
    [anon_sym_SEMI_SEMI] = ACTIONS(1888),
    [anon_sym_PIPE_AMP] = ACTIONS(1888),
    [anon_sym_AMP_AMP] = ACTIONS(1888),
    [anon_sym_PIPE_PIPE] = ACTIONS(1888),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(1888),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1890),
    [anon_sym_LF] = ACTIONS(1888),
    [anon_sym_AMP] = ACTIONS(1890),
  },
  [903] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(1892),
    [anon_sym_PIPE_PIPE] = ACTIONS(1892),
    [anon_sym_BQUOTE] = ACTIONS(1892),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_LF] = ACTIONS(1892),
    [anon_sym_AMP] = ACTIONS(1894),
  },
  [904] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(1892),
    [anon_sym_PIPE_PIPE] = ACTIONS(1892),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_LF] = ACTIONS(1892),
    [anon_sym_AMP] = ACTIONS(1894),
  },
  [905] = {
    [sym_concatenation] = STATE(928),
    [sym_string] = STATE(1378),
    [sym_simple_expansion] = STATE(1378),
    [sym_string_expansion] = STATE(1378),
    [sym_expansion] = STATE(1378),
    [sym_command_substitution] = STATE(1378),
    [sym_process_substitution] = STATE(1378),
    [sym__special_characters] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(3064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3064),
  },
  [906] = {
    [aux_sym_concatenation_repeat1] = STATE(1379),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [907] = {
    [aux_sym_concatenation_repeat1] = STATE(1379),
    [sym__simple_heredoc_body] = ACTIONS(679),
    [sym__heredoc_body_beginning] = ACTIONS(679),
    [sym_file_descriptor] = ACTIONS(679),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [908] = {
    [aux_sym_concatenation_repeat1] = STATE(1379),
    [sym__simple_heredoc_body] = ACTIONS(1936),
    [sym__heredoc_body_beginning] = ACTIONS(1936),
    [sym_file_descriptor] = ACTIONS(1936),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(1938),
    [anon_sym_SEMI_SEMI] = ACTIONS(1936),
    [anon_sym_PIPE_AMP] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1938),
    [anon_sym_GT] = ACTIONS(1938),
    [anon_sym_GT_GT] = ACTIONS(1936),
    [anon_sym_AMP_GT] = ACTIONS(1938),
    [anon_sym_AMP_GT_GT] = ACTIONS(1936),
    [anon_sym_LT_AMP] = ACTIONS(1936),
    [anon_sym_GT_AMP] = ACTIONS(1936),
    [anon_sym_LT_LT] = ACTIONS(1938),
    [anon_sym_LT_LT_DASH] = ACTIONS(1936),
    [anon_sym_LT_LT_LT] = ACTIONS(1936),
    [anon_sym_BQUOTE] = ACTIONS(1936),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_LF] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1938),
  },
  [909] = {
    [aux_sym_concatenation_repeat1] = STATE(1379),
    [sym__simple_heredoc_body] = ACTIONS(1940),
    [sym__heredoc_body_beginning] = ACTIONS(1940),
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [910] = {
    [sym_file_redirect] = STATE(910),
    [sym_heredoc_redirect] = STATE(910),
    [sym_herestring_redirect] = STATE(910),
    [aux_sym_while_statement_repeat1] = STATE(910),
    [sym__simple_heredoc_body] = ACTIONS(1948),
    [sym__heredoc_body_beginning] = ACTIONS(1948),
    [sym_file_descriptor] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_SEMI_SEMI] = ACTIONS(1948),
    [anon_sym_PIPE_AMP] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_PIPE_PIPE] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_GT_GT] = ACTIONS(3072),
    [anon_sym_AMP_GT] = ACTIONS(3069),
    [anon_sym_AMP_GT_GT] = ACTIONS(3072),
    [anon_sym_LT_AMP] = ACTIONS(3072),
    [anon_sym_GT_AMP] = ACTIONS(3072),
    [anon_sym_LT_LT] = ACTIONS(1961),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(1948),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_LF] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1953),
  },
  [911] = {
    [sym_file_redirect] = STATE(910),
    [sym_heredoc_redirect] = STATE(910),
    [sym_heredoc_body] = STATE(930),
    [sym_herestring_redirect] = STATE(910),
    [aux_sym_while_statement_repeat1] = STATE(910),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(1946),
    [anon_sym_SEMI_SEMI] = ACTIONS(1944),
    [anon_sym_PIPE_AMP] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(1944),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_LF] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1946),
  },
  [912] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(3044),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [913] = {
    [sym_file_redirect] = STATE(1380),
    [sym_heredoc_redirect] = STATE(1380),
    [sym_heredoc_body] = STATE(930),
    [sym_herestring_redirect] = STATE(1380),
    [sym_concatenation] = STATE(493),
    [sym_string] = STATE(174),
    [sym_simple_expansion] = STATE(174),
    [sym_string_expansion] = STATE(174),
    [sym_expansion] = STATE(174),
    [sym_command_substitution] = STATE(174),
    [sym_process_substitution] = STATE(174),
    [aux_sym_while_statement_repeat1] = STATE(1380),
    [aux_sym_command_repeat2] = STATE(493),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(1946),
    [anon_sym_SEMI_SEMI] = ACTIONS(1944),
    [anon_sym_PIPE_AMP] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_EQ_TILDE] = ACTIONS(307),
    [anon_sym_EQ_EQ] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(823),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(1944),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_LF] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1946),
  },
  [914] = {
    [sym__simple_heredoc_body] = ACTIONS(3078),
    [sym__heredoc_body_beginning] = ACTIONS(3078),
    [sym_file_descriptor] = ACTIONS(3078),
    [sym__concat] = ACTIONS(3078),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3078),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [anon_sym_EQ_TILDE] = ACTIONS(3080),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3078),
    [anon_sym_AMP_GT] = ACTIONS(3080),
    [anon_sym_AMP_GT_GT] = ACTIONS(3078),
    [anon_sym_LT_AMP] = ACTIONS(3078),
    [anon_sym_GT_AMP] = ACTIONS(3078),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_LT_LT_DASH] = ACTIONS(3078),
    [anon_sym_LT_LT_LT] = ACTIONS(3078),
    [sym__special_characters] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
  },
  [915] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3082),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [916] = {
    [sym_file_redirect] = STATE(1382),
    [sym_file_descriptor] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(2375),
    [anon_sym_SEMI_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE_AMP] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_GT] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_AMP_GT] = ACTIONS(1195),
    [anon_sym_AMP_GT_GT] = ACTIONS(1197),
    [anon_sym_LT_AMP] = ACTIONS(1197),
    [anon_sym_GT_AMP] = ACTIONS(1197),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2375),
  },
  [917] = {
    [sym__heredoc_body_middle] = ACTIONS(731),
    [sym__heredoc_body_end] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
  },
  [918] = {
    [sym__heredoc_body_middle] = ACTIONS(739),
    [sym__heredoc_body_end] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
  },
  [919] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(3084),
    [sym_comment] = ACTIONS(53),
  },
  [920] = {
    [sym_subscript] = STATE(1387),
    [sym_variable_name] = ACTIONS(3086),
    [anon_sym_DOLLAR] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3088),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AT] = ACTIONS(3088),
    [anon_sym_QMARK] = ACTIONS(3088),
    [anon_sym_0] = ACTIONS(3092),
    [anon_sym__] = ACTIONS(3092),
  },
  [921] = {
    [sym_concatenation] = STATE(1390),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1390),
    [anon_sym_RBRACE] = ACTIONS(3094),
    [anon_sym_EQ] = ACTIONS(3096),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3100),
    [anon_sym_COLON] = ACTIONS(3096),
    [anon_sym_COLON_QMARK] = ACTIONS(3096),
    [anon_sym_COLON_DASH] = ACTIONS(3096),
    [anon_sym_PERCENT] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [922] = {
    [sym_concatenation] = STATE(1393),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1393),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_EQ] = ACTIONS(3104),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3106),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3108),
    [anon_sym_COLON] = ACTIONS(3104),
    [anon_sym_COLON_QMARK] = ACTIONS(3104),
    [anon_sym_COLON_DASH] = ACTIONS(3104),
    [anon_sym_PERCENT] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [923] = {
    [sym_concatenation] = STATE(1396),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1396),
    [anon_sym_RBRACE] = ACTIONS(3110),
    [anon_sym_EQ] = ACTIONS(3112),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3116),
    [anon_sym_COLON] = ACTIONS(3112),
    [anon_sym_COLON_QMARK] = ACTIONS(3112),
    [anon_sym_COLON_DASH] = ACTIONS(3112),
    [anon_sym_PERCENT] = ACTIONS(3112),
    [anon_sym_DASH] = ACTIONS(3112),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [924] = {
    [anon_sym_esac] = ACTIONS(3118),
    [anon_sym_PIPE] = ACTIONS(3120),
    [anon_sym_RPAREN] = ACTIONS(3118),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [anon_sym_BQUOTE] = ACTIONS(3118),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3120),
  },
  [925] = {
    [sym_simple_expansion] = STATE(925),
    [sym_expansion] = STATE(925),
    [aux_sym_heredoc_body_repeat1] = STATE(925),
    [sym__heredoc_body_middle] = ACTIONS(3122),
    [sym__heredoc_body_end] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3130),
    [sym_comment] = ACTIONS(53),
  },
  [926] = {
    [aux_sym_concatenation_repeat1] = STATE(929),
    [sym__simple_heredoc_body] = ACTIONS(981),
    [sym__heredoc_body_beginning] = ACTIONS(981),
    [sym_file_descriptor] = ACTIONS(981),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(981),
    [anon_sym_LT_AMP] = ACTIONS(981),
    [anon_sym_GT_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(981),
    [anon_sym_LT_LT_LT] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [927] = {
    [aux_sym_concatenation_repeat1] = STATE(929),
    [sym__simple_heredoc_body] = ACTIONS(985),
    [sym__heredoc_body_beginning] = ACTIONS(985),
    [sym_file_descriptor] = ACTIONS(985),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_DASH] = ACTIONS(985),
    [anon_sym_LT_LT_LT] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [928] = {
    [sym__simple_heredoc_body] = ACTIONS(985),
    [sym__heredoc_body_beginning] = ACTIONS(985),
    [sym_file_descriptor] = ACTIONS(985),
    [anon_sym_esac] = ACTIONS(985),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(985),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_DASH] = ACTIONS(985),
    [anon_sym_LT_LT_LT] = ACTIONS(985),
    [anon_sym_BQUOTE] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [929] = {
    [aux_sym_concatenation_repeat1] = STATE(1397),
    [sym__simple_heredoc_body] = ACTIONS(695),
    [sym__heredoc_body_beginning] = ACTIONS(695),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [930] = {
    [anon_sym_esac] = ACTIONS(3133),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_RPAREN] = ACTIONS(3133),
    [anon_sym_SEMI_SEMI] = ACTIONS(3133),
    [anon_sym_PIPE_AMP] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3133),
    [anon_sym_PIPE_PIPE] = ACTIONS(3133),
    [anon_sym_BQUOTE] = ACTIONS(3133),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_LF] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
  },
  [931] = {
    [sym_file_redirect] = STATE(491),
    [sym_heredoc_redirect] = STATE(491),
    [sym_heredoc_body] = STATE(1398),
    [sym_herestring_redirect] = STATE(491),
    [aux_sym_while_statement_repeat1] = STATE(491),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_SEMI_SEMI] = ACTIONS(3133),
    [anon_sym_PIPE_AMP] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3133),
    [anon_sym_PIPE_PIPE] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(309),
    [anon_sym_GT_GT] = ACTIONS(311),
    [anon_sym_AMP_GT] = ACTIONS(309),
    [anon_sym_AMP_GT_GT] = ACTIONS(311),
    [anon_sym_LT_AMP] = ACTIONS(311),
    [anon_sym_GT_AMP] = ACTIONS(311),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_LF] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
  },
  [932] = {
    [sym__concat] = ACTIONS(3137),
    [anon_sym_EQ] = ACTIONS(3139),
    [anon_sym_PLUS_EQ] = ACTIONS(3139),
    [sym_comment] = ACTIONS(53),
  },
  [933] = {
    [anon_sym_EQ] = ACTIONS(3139),
    [anon_sym_PLUS_EQ] = ACTIONS(3139),
    [sym_comment] = ACTIONS(53),
  },
  [934] = {
    [aux_sym_concatenation_repeat1] = STATE(934),
    [sym__concat] = ACTIONS(2460),
    [anon_sym_RBRACK] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
  },
  [935] = {
    [sym__concat] = ACTIONS(3141),
    [anon_sym_EQ] = ACTIONS(3143),
    [anon_sym_PLUS_EQ] = ACTIONS(3143),
    [sym_comment] = ACTIONS(53),
  },
  [936] = {
    [anon_sym_EQ] = ACTIONS(3143),
    [anon_sym_PLUS_EQ] = ACTIONS(3143),
    [sym_comment] = ACTIONS(53),
  },
  [937] = {
    [sym_string] = STATE(1401),
    [sym_simple_expansion] = STATE(1401),
    [sym_string_expansion] = STATE(1401),
    [sym_expansion] = STATE(1401),
    [sym_command_substitution] = STATE(1401),
    [sym_process_substitution] = STATE(1401),
    [sym__special_characters] = ACTIONS(3145),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [sym_raw_string] = ACTIONS(3145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1019),
    [anon_sym_GT_LPAREN] = ACTIONS(1019),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3145),
  },
  [938] = {
    [aux_sym_concatenation_repeat1] = STATE(1402),
    [sym__concat] = ACTIONS(2018),
    [anon_sym_RPAREN] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(695),
  },
  [939] = {
    [sym__concat] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(699),
  },
  [940] = {
    [anon_sym_DQUOTE] = ACTIONS(3147),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [941] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(3147),
    [anon_sym_DOLLAR] = ACTIONS(3149),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [942] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(731),
  },
  [943] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(735),
  },
  [944] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_RPAREN] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(739),
  },
  [945] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(3151),
    [sym_comment] = ACTIONS(53),
  },
  [946] = {
    [sym_subscript] = STATE(1409),
    [sym_variable_name] = ACTIONS(3153),
    [anon_sym_DOLLAR] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3155),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3157),
    [anon_sym_STAR] = ACTIONS(3155),
    [anon_sym_AT] = ACTIONS(3155),
    [anon_sym_QMARK] = ACTIONS(3155),
    [anon_sym_0] = ACTIONS(3159),
    [anon_sym__] = ACTIONS(3159),
  },
  [947] = {
    [sym_concatenation] = STATE(1412),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1412),
    [anon_sym_RBRACE] = ACTIONS(3161),
    [anon_sym_EQ] = ACTIONS(3163),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_COLON] = ACTIONS(3163),
    [anon_sym_COLON_QMARK] = ACTIONS(3163),
    [anon_sym_COLON_DASH] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [948] = {
    [sym_concatenation] = STATE(1415),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1415),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3171),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3175),
    [anon_sym_COLON] = ACTIONS(3171),
    [anon_sym_COLON_QMARK] = ACTIONS(3171),
    [anon_sym_COLON_DASH] = ACTIONS(3171),
    [anon_sym_PERCENT] = ACTIONS(3171),
    [anon_sym_DASH] = ACTIONS(3171),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [949] = {
    [sym_concatenation] = STATE(1418),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1418),
    [anon_sym_RBRACE] = ACTIONS(3177),
    [anon_sym_EQ] = ACTIONS(3179),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3183),
    [anon_sym_COLON] = ACTIONS(3179),
    [anon_sym_COLON_QMARK] = ACTIONS(3179),
    [anon_sym_COLON_DASH] = ACTIONS(3179),
    [anon_sym_PERCENT] = ACTIONS(3179),
    [anon_sym_DASH] = ACTIONS(3179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [950] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3185),
    [anon_sym_SEMI_SEMI] = ACTIONS(3187),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_LF] = ACTIONS(3187),
    [anon_sym_AMP] = ACTIONS(3189),
  },
  [951] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3185),
    [anon_sym_SEMI_SEMI] = ACTIONS(3187),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_LF] = ACTIONS(3187),
    [anon_sym_AMP] = ACTIONS(3189),
  },
  [952] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1421),
    [sym_c_style_for_statement] = STATE(1421),
    [sym_while_statement] = STATE(1421),
    [sym_if_statement] = STATE(1421),
    [sym_case_statement] = STATE(1421),
    [sym_function_definition] = STATE(1421),
    [sym_subshell] = STATE(1421),
    [sym_pipeline] = STATE(1421),
    [sym_list] = STATE(1421),
    [sym_negated_command] = STATE(1421),
    [sym_test_command] = STATE(1421),
    [sym_declaration_command] = STATE(1421),
    [sym_unset_command] = STATE(1421),
    [sym_command] = STATE(1421),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1422),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [953] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(3191),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(3185),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3193),
    [anon_sym_LF] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
  },
  [954] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(3191),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(3185),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3193),
    [anon_sym_LF] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
  },
  [955] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1424),
    [sym_c_style_for_statement] = STATE(1424),
    [sym_while_statement] = STATE(1424),
    [sym_if_statement] = STATE(1424),
    [sym_case_statement] = STATE(1424),
    [sym_function_definition] = STATE(1424),
    [sym_subshell] = STATE(1424),
    [sym_pipeline] = STATE(1424),
    [sym_list] = STATE(1424),
    [sym_negated_command] = STATE(1424),
    [sym_test_command] = STATE(1424),
    [sym_declaration_command] = STATE(1424),
    [sym_unset_command] = STATE(1424),
    [sym_command] = STATE(1424),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(1425),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [956] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3195),
    [anon_sym_SEMI_SEMI] = ACTIONS(3197),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3199),
    [anon_sym_LF] = ACTIONS(3197),
    [anon_sym_AMP] = ACTIONS(3199),
  },
  [957] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3195),
    [anon_sym_SEMI_SEMI] = ACTIONS(3197),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3199),
    [anon_sym_LF] = ACTIONS(3197),
    [anon_sym_AMP] = ACTIONS(3199),
  },
  [958] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1428),
    [sym_c_style_for_statement] = STATE(1428),
    [sym_while_statement] = STATE(1428),
    [sym_if_statement] = STATE(1428),
    [sym_case_statement] = STATE(1428),
    [sym_function_definition] = STATE(1428),
    [sym_subshell] = STATE(1428),
    [sym_pipeline] = STATE(1428),
    [sym_list] = STATE(1428),
    [sym_negated_command] = STATE(1428),
    [sym_test_command] = STATE(1428),
    [sym_declaration_command] = STATE(1428),
    [sym_unset_command] = STATE(1428),
    [sym_command] = STATE(1428),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1429),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [959] = {
    [sym_file_descriptor] = ACTIONS(3201),
    [sym_variable_name] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_RPAREN] = ACTIONS(3201),
    [anon_sym_SEMI_SEMI] = ACTIONS(3201),
    [anon_sym_PIPE_AMP] = ACTIONS(3201),
    [anon_sym_AMP_AMP] = ACTIONS(3201),
    [anon_sym_PIPE_PIPE] = ACTIONS(3201),
    [anon_sym_LT] = ACTIONS(3203),
    [anon_sym_GT] = ACTIONS(3203),
    [anon_sym_GT_GT] = ACTIONS(3201),
    [anon_sym_AMP_GT] = ACTIONS(3203),
    [anon_sym_AMP_GT_GT] = ACTIONS(3201),
    [anon_sym_LT_AMP] = ACTIONS(3201),
    [anon_sym_GT_AMP] = ACTIONS(3201),
    [sym__special_characters] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3201),
    [anon_sym_DOLLAR] = ACTIONS(3203),
    [sym_raw_string] = ACTIONS(3201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3201),
    [anon_sym_BQUOTE] = ACTIONS(3201),
    [anon_sym_LT_LPAREN] = ACTIONS(3201),
    [anon_sym_GT_LPAREN] = ACTIONS(3201),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3203),
    [anon_sym_LF] = ACTIONS(3201),
    [anon_sym_AMP] = ACTIONS(3203),
  },
  [960] = {
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_string_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [aux_sym_for_statement_repeat1] = STATE(960),
    [anon_sym_RPAREN] = ACTIONS(3205),
    [sym__special_characters] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(3210),
    [anon_sym_DOLLAR] = ACTIONS(3213),
    [sym_raw_string] = ACTIONS(3216),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3222),
    [anon_sym_BQUOTE] = ACTIONS(3225),
    [anon_sym_LT_LPAREN] = ACTIONS(3228),
    [anon_sym_GT_LPAREN] = ACTIONS(3228),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3216),
  },
  [961] = {
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1664),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [962] = {
    [aux_sym_concatenation_repeat1] = STATE(962),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(3231),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [963] = {
    [sym_file_descriptor] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1671),
    [sym_variable_name] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1673),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1673),
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1673),
  },
  [964] = {
    [anon_sym_DQUOTE] = ACTIONS(3234),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [965] = {
    [sym_concatenation] = STATE(1434),
    [sym_string] = STATE(1433),
    [sym_simple_expansion] = STATE(1433),
    [sym_string_expansion] = STATE(1433),
    [sym_expansion] = STATE(1433),
    [sym_command_substitution] = STATE(1433),
    [sym_process_substitution] = STATE(1433),
    [anon_sym_RBRACE] = ACTIONS(3236),
    [sym__special_characters] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(3240),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3240),
  },
  [966] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(3242),
    [sym_comment] = ACTIONS(53),
  },
  [967] = {
    [sym_concatenation] = STATE(1438),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1438),
    [anon_sym_RBRACE] = ACTIONS(3244),
    [anon_sym_EQ] = ACTIONS(3246),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3250),
    [anon_sym_COLON] = ACTIONS(3246),
    [anon_sym_COLON_QMARK] = ACTIONS(3246),
    [anon_sym_COLON_DASH] = ACTIONS(3246),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [968] = {
    [sym_concatenation] = STATE(1441),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1441),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_EQ] = ACTIONS(3254),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3258),
    [anon_sym_COLON] = ACTIONS(3254),
    [anon_sym_COLON_QMARK] = ACTIONS(3254),
    [anon_sym_COLON_DASH] = ACTIONS(3254),
    [anon_sym_PERCENT] = ACTIONS(3254),
    [anon_sym_DASH] = ACTIONS(3254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [969] = {
    [sym_concatenation] = STATE(1443),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1443),
    [anon_sym_RBRACE] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(3260),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3260),
    [anon_sym_COLON_QMARK] = ACTIONS(3260),
    [anon_sym_COLON_DASH] = ACTIONS(3260),
    [anon_sym_PERCENT] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3260),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [970] = {
    [sym_file_descriptor] = ACTIONS(1788),
    [sym__concat] = ACTIONS(1788),
    [sym_variable_name] = ACTIONS(1788),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1788),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [anon_sym_PIPE_AMP] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [anon_sym_LT] = ACTIONS(1790),
    [anon_sym_GT] = ACTIONS(1790),
    [anon_sym_GT_GT] = ACTIONS(1788),
    [anon_sym_AMP_GT] = ACTIONS(1790),
    [anon_sym_AMP_GT_GT] = ACTIONS(1788),
    [anon_sym_LT_AMP] = ACTIONS(1788),
    [anon_sym_GT_AMP] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1790),
  },
  [971] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3266),
  },
  [972] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3268),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [973] = {
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [sym_variable_name] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [974] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3270),
  },
  [975] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [976] = {
    [sym_file_descriptor] = ACTIONS(1840),
    [sym__concat] = ACTIONS(1840),
    [sym_variable_name] = ACTIONS(1840),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [anon_sym_PIPE_AMP] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_GT] = ACTIONS(1842),
    [anon_sym_GT_GT] = ACTIONS(1840),
    [anon_sym_AMP_GT] = ACTIONS(1842),
    [anon_sym_AMP_GT_GT] = ACTIONS(1840),
    [anon_sym_LT_AMP] = ACTIONS(1840),
    [anon_sym_GT_AMP] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [977] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3274),
  },
  [978] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [979] = {
    [sym_file_descriptor] = ACTIONS(1846),
    [sym__concat] = ACTIONS(1846),
    [sym_variable_name] = ACTIONS(1846),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT] = ACTIONS(1848),
    [anon_sym_AMP_GT_GT] = ACTIONS(1846),
    [anon_sym_LT_AMP] = ACTIONS(1846),
    [anon_sym_GT_AMP] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1848),
  },
  [980] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [981] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3276),
    [anon_sym_SEMI_SEMI] = ACTIONS(3278),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_LF] = ACTIONS(3278),
    [anon_sym_AMP] = ACTIONS(3280),
  },
  [982] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3276),
    [anon_sym_SEMI_SEMI] = ACTIONS(3278),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_LF] = ACTIONS(3278),
    [anon_sym_AMP] = ACTIONS(3280),
  },
  [983] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(3276),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [984] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(3282),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(3276),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3284),
    [anon_sym_LF] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3284),
  },
  [985] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(3282),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(3276),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3284),
    [anon_sym_LF] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3284),
  },
  [986] = {
    [sym_file_descriptor] = ACTIONS(1878),
    [sym__concat] = ACTIONS(1878),
    [sym_variable_name] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_RPAREN] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1880),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT] = ACTIONS(1880),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1880),
  },
  [987] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3286),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [988] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3286),
    [anon_sym_SEMI_SEMI] = ACTIONS(3288),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3290),
    [anon_sym_LF] = ACTIONS(3288),
    [anon_sym_AMP] = ACTIONS(3290),
  },
  [989] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3286),
    [anon_sym_SEMI_SEMI] = ACTIONS(3288),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3290),
    [anon_sym_LF] = ACTIONS(3288),
    [anon_sym_AMP] = ACTIONS(3290),
  },
  [990] = {
    [sym_do_group] = STATE(1455),
    [sym_compound_statement] = STATE(1455),
    [anon_sym_do] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [sym_comment] = ACTIONS(53),
  },
  [991] = {
    [sym__expression] = STATE(1456),
    [sym_binary_expression] = STATE(1456),
    [sym_unary_expression] = STATE(1456),
    [sym_parenthesized_expression] = STATE(1456),
    [sym_concatenation] = STATE(1456),
    [sym_string] = STATE(278),
    [sym_simple_expansion] = STATE(278),
    [sym_string_expansion] = STATE(278),
    [sym_expansion] = STATE(278),
    [sym_command_substitution] = STATE(278),
    [sym_process_substitution] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(499),
    [sym__special_characters] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(505),
    [sym_test_operator] = ACTIONS(507),
  },
  [992] = {
    [sym__expression] = STATE(1457),
    [sym_binary_expression] = STATE(1457),
    [sym_unary_expression] = STATE(1457),
    [sym_parenthesized_expression] = STATE(1457),
    [sym_concatenation] = STATE(1457),
    [sym_string] = STATE(996),
    [sym_simple_expansion] = STATE(996),
    [sym_string_expansion] = STATE(996),
    [sym_expansion] = STATE(996),
    [sym_command_substitution] = STATE(996),
    [sym_process_substitution] = STATE(996),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_BANG] = ACTIONS(2112),
    [sym__special_characters] = ACTIONS(2114),
    [anon_sym_DQUOTE] = ACTIONS(2116),
    [anon_sym_DOLLAR] = ACTIONS(2118),
    [sym_raw_string] = ACTIONS(2120),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2124),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [anon_sym_LT_LPAREN] = ACTIONS(2128),
    [anon_sym_GT_LPAREN] = ACTIONS(2128),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2130),
    [sym_test_operator] = ACTIONS(2132),
  },
  [993] = {
    [aux_sym_concatenation_repeat1] = STATE(1459),
    [sym__concat] = ACTIONS(3294),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(511),
    [anon_sym_AMP_AMP] = ACTIONS(511),
    [anon_sym_PIPE_PIPE] = ACTIONS(511),
    [anon_sym_EQ_TILDE] = ACTIONS(511),
    [anon_sym_EQ_EQ] = ACTIONS(511),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(511),
  },
  [994] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(1462),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_DOLLAR] = ACTIONS(3298),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [995] = {
    [sym_string] = STATE(1464),
    [anon_sym_DQUOTE] = ACTIONS(2116),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [sym_raw_string] = ACTIONS(3302),
    [anon_sym_POUND] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_AT] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_0] = ACTIONS(3306),
    [anon_sym__] = ACTIONS(3306),
  },
  [996] = {
    [aux_sym_concatenation_repeat1] = STATE(1459),
    [sym__concat] = ACTIONS(3294),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_EQ_TILDE] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(527),
  },
  [997] = {
    [sym_subscript] = STATE(1470),
    [sym_variable_name] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3312),
    [anon_sym_POUND] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3312),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AT] = ACTIONS(3312),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_0] = ACTIONS(3316),
    [anon_sym__] = ACTIONS(3316),
  },
  [998] = {
    [sym__terminated_statement] = STATE(1473),
    [sym_for_statement] = STATE(1471),
    [sym_c_style_for_statement] = STATE(1471),
    [sym_while_statement] = STATE(1471),
    [sym_if_statement] = STATE(1471),
    [sym_case_statement] = STATE(1471),
    [sym_function_definition] = STATE(1471),
    [sym_subshell] = STATE(1471),
    [sym_pipeline] = STATE(1471),
    [sym_list] = STATE(1471),
    [sym_negated_command] = STATE(1471),
    [sym_test_command] = STATE(1471),
    [sym_declaration_command] = STATE(1471),
    [sym_unset_command] = STATE(1471),
    [sym_command] = STATE(1471),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1472),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(1473),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [999] = {
    [sym__terminated_statement] = STATE(1476),
    [sym_for_statement] = STATE(1474),
    [sym_c_style_for_statement] = STATE(1474),
    [sym_while_statement] = STATE(1474),
    [sym_if_statement] = STATE(1474),
    [sym_case_statement] = STATE(1474),
    [sym_function_definition] = STATE(1474),
    [sym_subshell] = STATE(1474),
    [sym_pipeline] = STATE(1474),
    [sym_list] = STATE(1474),
    [sym_negated_command] = STATE(1474),
    [sym_test_command] = STATE(1474),
    [sym_declaration_command] = STATE(1474),
    [sym_unset_command] = STATE(1474),
    [sym_command] = STATE(1474),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(1475),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1476),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [1000] = {
    [sym__terminated_statement] = STATE(1479),
    [sym_for_statement] = STATE(1477),
    [sym_c_style_for_statement] = STATE(1477),
    [sym_while_statement] = STATE(1477),
    [sym_if_statement] = STATE(1477),
    [sym_case_statement] = STATE(1477),
    [sym_function_definition] = STATE(1477),
    [sym_subshell] = STATE(1477),
    [sym_pipeline] = STATE(1477),
    [sym_list] = STATE(1477),
    [sym_negated_command] = STATE(1477),
    [sym_test_command] = STATE(1477),
    [sym_declaration_command] = STATE(1477),
    [sym_unset_command] = STATE(1477),
    [sym_command] = STATE(1477),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1478),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(1479),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1001] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_PIPE_PIPE] = ACTIONS(3320),
    [anon_sym_EQ_TILDE] = ACTIONS(3322),
    [anon_sym_EQ_EQ] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_GT] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3320),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3320),
  },
  [1002] = {
    [sym__expression] = STATE(1483),
    [sym_binary_expression] = STATE(1483),
    [sym_unary_expression] = STATE(1483),
    [sym_parenthesized_expression] = STATE(1483),
    [sym_concatenation] = STATE(1483),
    [sym_string] = STATE(996),
    [sym_simple_expansion] = STATE(996),
    [sym_string_expansion] = STATE(996),
    [sym_expansion] = STATE(996),
    [sym_command_substitution] = STATE(996),
    [sym_process_substitution] = STATE(996),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_BANG] = ACTIONS(2112),
    [sym__special_characters] = ACTIONS(2114),
    [anon_sym_DQUOTE] = ACTIONS(2116),
    [anon_sym_DOLLAR] = ACTIONS(2118),
    [sym_raw_string] = ACTIONS(2120),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2124),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [anon_sym_LT_LPAREN] = ACTIONS(2128),
    [anon_sym_GT_LPAREN] = ACTIONS(2128),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2130),
    [sym_test_operator] = ACTIONS(2132),
  },
  [1003] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [1004] = {
    [sym__concat] = ACTIONS(1664),
    [anon_sym_esac] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1664),
    [anon_sym_EQ_EQ] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_BANG_EQ] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1664),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [1005] = {
    [aux_sym_concatenation_repeat1] = STATE(1005),
    [sym__concat] = ACTIONS(3326),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1664),
    [anon_sym_EQ_EQ] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_BANG_EQ] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1664),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [1006] = {
    [sym__concat] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_EQ_TILDE] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1673),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_BANG_EQ] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1671),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1673),
  },
  [1007] = {
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [1008] = {
    [sym_concatenation] = STATE(1488),
    [sym_string] = STATE(1487),
    [sym_simple_expansion] = STATE(1487),
    [sym_string_expansion] = STATE(1487),
    [sym_expansion] = STATE(1487),
    [sym_command_substitution] = STATE(1487),
    [sym_process_substitution] = STATE(1487),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [sym__special_characters] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(3335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3335),
  },
  [1009] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(3337),
    [sym_comment] = ACTIONS(53),
  },
  [1010] = {
    [sym_concatenation] = STATE(1492),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1492),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [anon_sym_EQ] = ACTIONS(3341),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3345),
    [anon_sym_COLON] = ACTIONS(3341),
    [anon_sym_COLON_QMARK] = ACTIONS(3341),
    [anon_sym_COLON_DASH] = ACTIONS(3341),
    [anon_sym_PERCENT] = ACTIONS(3341),
    [anon_sym_DASH] = ACTIONS(3341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1011] = {
    [sym_concatenation] = STATE(1495),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1495),
    [anon_sym_RBRACE] = ACTIONS(3347),
    [anon_sym_EQ] = ACTIONS(3349),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3349),
    [anon_sym_COLON_QMARK] = ACTIONS(3349),
    [anon_sym_COLON_DASH] = ACTIONS(3349),
    [anon_sym_PERCENT] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1012] = {
    [sym_concatenation] = STATE(1497),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1497),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_EQ] = ACTIONS(3355),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3359),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_DASH] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1013] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_esac] = ACTIONS(1788),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [anon_sym_PIPE_AMP] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [anon_sym_EQ_TILDE] = ACTIONS(1788),
    [anon_sym_EQ_EQ] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(1788),
    [anon_sym_GT] = ACTIONS(1788),
    [anon_sym_BANG_EQ] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1788),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1790),
  },
  [1014] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3361),
  },
  [1015] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1016] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_esac] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1832),
    [anon_sym_EQ_EQ] = ACTIONS(1832),
    [anon_sym_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1832),
    [anon_sym_GT] = ACTIONS(1832),
    [anon_sym_BANG_EQ] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [1017] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3365),
  },
  [1018] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1019] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_esac] = ACTIONS(1840),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [anon_sym_PIPE_AMP] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_EQ_TILDE] = ACTIONS(1840),
    [anon_sym_EQ_EQ] = ACTIONS(1840),
    [anon_sym_EQ] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1840),
    [anon_sym_GT] = ACTIONS(1840),
    [anon_sym_BANG_EQ] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1840),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [1020] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3369),
  },
  [1021] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1022] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_esac] = ACTIONS(1846),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_EQ_TILDE] = ACTIONS(1846),
    [anon_sym_EQ_EQ] = ACTIONS(1846),
    [anon_sym_EQ] = ACTIONS(1848),
    [anon_sym_LT] = ACTIONS(1846),
    [anon_sym_GT] = ACTIONS(1846),
    [anon_sym_BANG_EQ] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1846),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1848),
  },
  [1023] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3371),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1024] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3371),
    [anon_sym_SEMI_SEMI] = ACTIONS(3373),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_LF] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3375),
  },
  [1025] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3371),
    [anon_sym_SEMI_SEMI] = ACTIONS(3373),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_LF] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3375),
  },
  [1026] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(3371),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1027] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(3377),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(3371),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_LF] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3379),
  },
  [1028] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(3377),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(3371),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_LF] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3379),
  },
  [1029] = {
    [sym__concat] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_EQ_TILDE] = ACTIONS(1878),
    [anon_sym_EQ_EQ] = ACTIONS(1878),
    [anon_sym_EQ] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_BANG_EQ] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1878),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1880),
  },
  [1030] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3381),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1031] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3381),
    [anon_sym_SEMI_SEMI] = ACTIONS(3383),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_LF] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3385),
  },
  [1032] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3381),
    [anon_sym_SEMI_SEMI] = ACTIONS(3383),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_LF] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3385),
  },
  [1033] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_EQ_TILDE] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_BANG_EQ] = ACTIONS(1079),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1079),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_LF] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3389),
  },
  [1034] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2521),
    [anon_sym_AMP_AMP] = ACTIONS(2521),
    [anon_sym_PIPE_PIPE] = ACTIONS(2521),
    [anon_sym_EQ_TILDE] = ACTIONS(2521),
    [anon_sym_EQ_EQ] = ACTIONS(2521),
    [anon_sym_EQ] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_BANG_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2523),
    [anon_sym_LF] = ACTIONS(2521),
    [anon_sym_AMP] = ACTIONS(2523),
  },
  [1035] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2521),
    [anon_sym_AMP_AMP] = ACTIONS(2521),
    [anon_sym_PIPE_PIPE] = ACTIONS(2521),
    [anon_sym_EQ_TILDE] = ACTIONS(2521),
    [anon_sym_EQ_EQ] = ACTIONS(2521),
    [anon_sym_EQ] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_BANG_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2523),
    [anon_sym_LF] = ACTIONS(2521),
    [anon_sym_AMP] = ACTIONS(2523),
  },
  [1036] = {
    [sym_string] = STATE(1509),
    [sym_simple_expansion] = STATE(1509),
    [sym_string_expansion] = STATE(1509),
    [sym_expansion] = STATE(1509),
    [sym_command_substitution] = STATE(1509),
    [sym_process_substitution] = STATE(1509),
    [sym__special_characters] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym_raw_string] = ACTIONS(3391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3391),
  },
  [1037] = {
    [aux_sym_concatenation_repeat1] = STATE(1510),
    [sym__concat] = ACTIONS(2214),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1038] = {
    [sym__concat] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [1039] = {
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [1040] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [anon_sym_DOLLAR] = ACTIONS(3395),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [1041] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
  },
  [1042] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [1043] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(739),
  },
  [1044] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(3397),
    [sym_comment] = ACTIONS(53),
  },
  [1045] = {
    [sym_subscript] = STATE(1517),
    [sym_variable_name] = ACTIONS(3399),
    [anon_sym_DOLLAR] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AT] = ACTIONS(3401),
    [anon_sym_QMARK] = ACTIONS(3401),
    [anon_sym_0] = ACTIONS(3405),
    [anon_sym__] = ACTIONS(3405),
  },
  [1046] = {
    [sym_concatenation] = STATE(1520),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1520),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_EQ] = ACTIONS(3409),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3413),
    [anon_sym_COLON] = ACTIONS(3409),
    [anon_sym_COLON_QMARK] = ACTIONS(3409),
    [anon_sym_COLON_DASH] = ACTIONS(3409),
    [anon_sym_PERCENT] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1047] = {
    [sym_concatenation] = STATE(1523),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1523),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(3417),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3419),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_DASH] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1048] = {
    [sym_concatenation] = STATE(1526),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1526),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_EQ] = ACTIONS(3425),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3425),
    [anon_sym_COLON_QMARK] = ACTIONS(3425),
    [anon_sym_COLON_DASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1049] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3431),
    [anon_sym_SEMI_SEMI] = ACTIONS(3433),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_LF] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3435),
  },
  [1050] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3431),
    [anon_sym_SEMI_SEMI] = ACTIONS(3433),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_LF] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3435),
  },
  [1051] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1529),
    [sym_c_style_for_statement] = STATE(1529),
    [sym_while_statement] = STATE(1529),
    [sym_if_statement] = STATE(1529),
    [sym_case_statement] = STATE(1529),
    [sym_function_definition] = STATE(1529),
    [sym_subshell] = STATE(1529),
    [sym_pipeline] = STATE(1529),
    [sym_list] = STATE(1529),
    [sym_negated_command] = STATE(1529),
    [sym_test_command] = STATE(1529),
    [sym_declaration_command] = STATE(1529),
    [sym_unset_command] = STATE(1529),
    [sym_command] = STATE(1529),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1530),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1052] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(3437),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(3431),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_LF] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3439),
  },
  [1053] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(3437),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(3431),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_LF] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3439),
  },
  [1054] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1532),
    [sym_c_style_for_statement] = STATE(1532),
    [sym_while_statement] = STATE(1532),
    [sym_if_statement] = STATE(1532),
    [sym_case_statement] = STATE(1532),
    [sym_function_definition] = STATE(1532),
    [sym_subshell] = STATE(1532),
    [sym_pipeline] = STATE(1532),
    [sym_list] = STATE(1532),
    [sym_negated_command] = STATE(1532),
    [sym_test_command] = STATE(1532),
    [sym_declaration_command] = STATE(1532),
    [sym_unset_command] = STATE(1532),
    [sym_command] = STATE(1532),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(1533),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [1055] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3441),
    [anon_sym_SEMI_SEMI] = ACTIONS(3443),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_LF] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3445),
  },
  [1056] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3441),
    [anon_sym_SEMI_SEMI] = ACTIONS(3443),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_LF] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3445),
  },
  [1057] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1536),
    [sym_c_style_for_statement] = STATE(1536),
    [sym_while_statement] = STATE(1536),
    [sym_if_statement] = STATE(1536),
    [sym_case_statement] = STATE(1536),
    [sym_function_definition] = STATE(1536),
    [sym_subshell] = STATE(1536),
    [sym_pipeline] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_negated_command] = STATE(1536),
    [sym_test_command] = STATE(1536),
    [sym_declaration_command] = STATE(1536),
    [sym_unset_command] = STATE(1536),
    [sym_command] = STATE(1536),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1537),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1058] = {
    [sym_do_group] = STATE(1538),
    [anon_sym_do] = ACTIONS(1103),
    [sym_comment] = ACTIONS(53),
  },
  [1059] = {
    [sym_concatenation] = STATE(1059),
    [sym_string] = STATE(565),
    [sym_simple_expansion] = STATE(565),
    [sym_string_expansion] = STATE(565),
    [sym_expansion] = STATE(565),
    [sym_command_substitution] = STATE(565),
    [sym_process_substitution] = STATE(565),
    [aux_sym_for_statement_repeat1] = STATE(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(3205),
    [sym__special_characters] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [anon_sym_DOLLAR] = ACTIONS(3453),
    [sym_raw_string] = ACTIONS(3456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3462),
    [anon_sym_BQUOTE] = ACTIONS(3465),
    [anon_sym_LT_LPAREN] = ACTIONS(3468),
    [anon_sym_GT_LPAREN] = ACTIONS(3468),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3474),
    [anon_sym_LF] = ACTIONS(3205),
    [anon_sym_AMP] = ACTIONS(3205),
  },
  [1060] = {
    [anon_sym_esac] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_SEMI_SEMI] = ACTIONS(2250),
    [anon_sym_PIPE_AMP] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2252),
    [anon_sym_LF] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2252),
  },
  [1061] = {
    [sym__terminated_statement] = STATE(1063),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1063),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1062] = {
    [sym__simple_heredoc_body] = ACTIONS(3478),
    [sym__heredoc_body_beginning] = ACTIONS(3478),
    [sym_file_descriptor] = ACTIONS(3478),
    [anon_sym_esac] = ACTIONS(3478),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_RPAREN] = ACTIONS(3478),
    [anon_sym_SEMI_SEMI] = ACTIONS(3478),
    [anon_sym_PIPE_AMP] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_PIPE_PIPE] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(3480),
    [anon_sym_GT_GT] = ACTIONS(3478),
    [anon_sym_AMP_GT] = ACTIONS(3480),
    [anon_sym_AMP_GT_GT] = ACTIONS(3478),
    [anon_sym_LT_AMP] = ACTIONS(3478),
    [anon_sym_GT_AMP] = ACTIONS(3478),
    [anon_sym_LT_LT] = ACTIONS(3480),
    [anon_sym_LT_LT_DASH] = ACTIONS(3478),
    [anon_sym_LT_LT_LT] = ACTIONS(3478),
    [anon_sym_BQUOTE] = ACTIONS(3478),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym_LF] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
  },
  [1063] = {
    [sym__terminated_statement] = STATE(1063),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1063),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(891),
    [sym_variable_name] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_done] = ACTIONS(3482),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(923),
    [anon_sym_declare] = ACTIONS(926),
    [anon_sym_typeset] = ACTIONS(926),
    [anon_sym_export] = ACTIONS(926),
    [anon_sym_readonly] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym_unset] = ACTIONS(929),
    [anon_sym_unsetenv] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [sym_raw_string] = ACTIONS(947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [anon_sym_LT_LPAREN] = ACTIONS(959),
    [anon_sym_GT_LPAREN] = ACTIONS(959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(962),
  },
  [1064] = {
    [anon_sym_esac] = ACTIONS(3484),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_RPAREN] = ACTIONS(3484),
    [anon_sym_SEMI_SEMI] = ACTIONS(3484),
    [anon_sym_PIPE_AMP] = ACTIONS(3484),
    [anon_sym_AMP_AMP] = ACTIONS(3484),
    [anon_sym_PIPE_PIPE] = ACTIONS(3484),
    [anon_sym_BQUOTE] = ACTIONS(3484),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3486),
    [anon_sym_LF] = ACTIONS(3484),
    [anon_sym_AMP] = ACTIONS(3486),
  },
  [1065] = {
    [anon_sym_then] = ACTIONS(3488),
    [sym_comment] = ACTIONS(53),
  },
  [1066] = {
    [sym__terminated_statement] = STATE(1541),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1541),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(3490),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1067] = {
    [anon_sym_esac] = ACTIONS(3492),
    [anon_sym_PIPE] = ACTIONS(3494),
    [anon_sym_RPAREN] = ACTIONS(3492),
    [anon_sym_SEMI_SEMI] = ACTIONS(3492),
    [anon_sym_PIPE_AMP] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE] = ACTIONS(3492),
    [anon_sym_BQUOTE] = ACTIONS(3492),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3494),
    [anon_sym_LF] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
  },
  [1068] = {
    [anon_sym_fi] = ACTIONS(3496),
    [sym_comment] = ACTIONS(53),
  },
  [1069] = {
    [sym__terminated_statement] = STATE(1069),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1069),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(891),
    [sym_variable_name] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_fi] = ACTIONS(3482),
    [anon_sym_elif] = ACTIONS(3482),
    [anon_sym_else] = ACTIONS(3482),
    [anon_sym_case] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(923),
    [anon_sym_declare] = ACTIONS(926),
    [anon_sym_typeset] = ACTIONS(926),
    [anon_sym_export] = ACTIONS(926),
    [anon_sym_readonly] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym_unset] = ACTIONS(929),
    [anon_sym_unsetenv] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [sym_raw_string] = ACTIONS(947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [anon_sym_LT_LPAREN] = ACTIONS(959),
    [anon_sym_GT_LPAREN] = ACTIONS(959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(962),
  },
  [1070] = {
    [sym_elif_clause] = STATE(580),
    [sym_else_clause] = STATE(1543),
    [aux_sym_if_statement_repeat1] = STATE(1071),
    [anon_sym_fi] = ACTIONS(3496),
    [anon_sym_elif] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2274),
    [sym_comment] = ACTIONS(53),
  },
  [1071] = {
    [sym_elif_clause] = STATE(580),
    [aux_sym_if_statement_repeat1] = STATE(1071),
    [anon_sym_fi] = ACTIONS(3498),
    [anon_sym_elif] = ACTIONS(3500),
    [anon_sym_else] = ACTIONS(3498),
    [sym_comment] = ACTIONS(53),
  },
  [1072] = {
    [anon_sym_esac] = ACTIONS(3503),
    [anon_sym_PIPE] = ACTIONS(3505),
    [anon_sym_RPAREN] = ACTIONS(3503),
    [anon_sym_SEMI_SEMI] = ACTIONS(3503),
    [anon_sym_PIPE_AMP] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_PIPE_PIPE] = ACTIONS(3503),
    [anon_sym_BQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3505),
    [anon_sym_LF] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
  },
  [1073] = {
    [aux_sym_case_item_repeat1] = STATE(1546),
    [aux_sym_concatenation_repeat1] = STATE(1547),
    [sym__concat] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(3509),
    [sym_comment] = ACTIONS(53),
  },
  [1074] = {
    [aux_sym_case_item_repeat1] = STATE(1549),
    [aux_sym_concatenation_repeat1] = STATE(1547),
    [sym__concat] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(3511),
    [sym_comment] = ACTIONS(53),
  },
  [1075] = {
    [anon_sym_esac] = ACTIONS(3513),
    [sym_comment] = ACTIONS(53),
  },
  [1076] = {
    [aux_sym_case_item_repeat1] = STATE(1549),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(3511),
    [sym_comment] = ACTIONS(53),
  },
  [1077] = {
    [sym_case_item] = STATE(1552),
    [sym_last_case_item] = STATE(1551),
    [sym_concatenation] = STATE(1076),
    [sym_string] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [sym_command_substitution] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [aux_sym_case_statement_repeat1] = STATE(1552),
    [sym__special_characters] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(2280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2280),
  },
  [1078] = {
    [sym_case_item] = STATE(1554),
    [sym_last_case_item] = STATE(1551),
    [sym_concatenation] = STATE(1076),
    [sym_string] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [sym_command_substitution] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [aux_sym_case_statement_repeat1] = STATE(1554),
    [anon_sym_esac] = ACTIONS(3515),
    [sym__special_characters] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(2280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2282),
  },
  [1079] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_in] = ACTIONS(2855),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
  },
  [1080] = {
    [anon_sym_esac] = ACTIONS(3517),
    [anon_sym_PIPE] = ACTIONS(3519),
    [anon_sym_RPAREN] = ACTIONS(3517),
    [anon_sym_SEMI_SEMI] = ACTIONS(3517),
    [anon_sym_PIPE_AMP] = ACTIONS(3517),
    [anon_sym_AMP_AMP] = ACTIONS(3517),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(3517),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_LF] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
  },
  [1081] = {
    [anon_sym_esac] = ACTIONS(3521),
    [sym_comment] = ACTIONS(53),
  },
  [1082] = {
    [sym_case_item] = STATE(1552),
    [sym_last_case_item] = STATE(1556),
    [sym_concatenation] = STATE(1076),
    [sym_string] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [sym_command_substitution] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [aux_sym_case_statement_repeat1] = STATE(1552),
    [sym__special_characters] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(2280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2280),
  },
  [1083] = {
    [sym_case_item] = STATE(1558),
    [sym_last_case_item] = STATE(1556),
    [sym_concatenation] = STATE(1076),
    [sym_string] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [sym_command_substitution] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [aux_sym_case_statement_repeat1] = STATE(1558),
    [anon_sym_esac] = ACTIONS(3523),
    [sym__special_characters] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(2280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2282),
  },
  [1084] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_in] = ACTIONS(2869),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2869),
  },
  [1085] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3525),
    [sym_comment] = ACTIONS(53),
  },
  [1086] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [sym_comment] = ACTIONS(53),
  },
  [1087] = {
    [anon_sym_RBRACE] = ACTIONS(3527),
    [sym_comment] = ACTIONS(53),
  },
  [1088] = {
    [sym_concatenation] = STATE(1563),
    [sym_string] = STATE(1562),
    [sym_simple_expansion] = STATE(1562),
    [sym_string_expansion] = STATE(1562),
    [sym_expansion] = STATE(1562),
    [sym_command_substitution] = STATE(1562),
    [sym_process_substitution] = STATE(1562),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [sym__special_characters] = ACTIONS(3529),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(3531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3531),
  },
  [1089] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_in] = ACTIONS(2905),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2905),
  },
  [1090] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3533),
  },
  [1091] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1092] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_in] = ACTIONS(2913),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
  },
  [1093] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3537),
  },
  [1094] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1095] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3541),
  },
  [1096] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1097] = {
    [sym_concatenation] = STATE(1570),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1570),
    [anon_sym_RBRACE] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3545),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3545),
    [anon_sym_COLON_QMARK] = ACTIONS(3545),
    [anon_sym_COLON_DASH] = ACTIONS(3545),
    [anon_sym_PERCENT] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3545),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1098] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
  },
  [1099] = {
    [sym_concatenation] = STATE(1572),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1572),
    [anon_sym_RBRACE] = ACTIONS(3549),
    [anon_sym_EQ] = ACTIONS(3551),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_DASH] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1100] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3030),
  },
  [1101] = {
    [sym_concatenation] = STATE(1574),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1574),
    [anon_sym_RBRACE] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3557),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3557),
    [anon_sym_COLON_QMARK] = ACTIONS(3557),
    [anon_sym_COLON_DASH] = ACTIONS(3557),
    [anon_sym_PERCENT] = ACTIONS(3557),
    [anon_sym_DASH] = ACTIONS(3557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1102] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_in] = ACTIONS(3040),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3040),
  },
  [1103] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3561),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1104] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(3561),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1105] = {
    [sym__concat] = ACTIONS(3078),
    [anon_sym_in] = ACTIONS(3078),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3078),
  },
  [1106] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3563),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1107] = {
    [sym_file_redirect] = STATE(1577),
    [sym_file_descriptor] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(3565),
    [anon_sym_SEMI_SEMI] = ACTIONS(3567),
    [anon_sym_PIPE_AMP] = ACTIONS(3567),
    [anon_sym_AMP_AMP] = ACTIONS(3567),
    [anon_sym_PIPE_PIPE] = ACTIONS(3567),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_GT] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_AMP_GT] = ACTIONS(1195),
    [anon_sym_AMP_GT_GT] = ACTIONS(1197),
    [anon_sym_LT_AMP] = ACTIONS(1197),
    [anon_sym_GT_AMP] = ACTIONS(1197),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3565),
    [anon_sym_LF] = ACTIONS(3567),
    [anon_sym_AMP] = ACTIONS(3565),
  },
  [1108] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1109] = {
    [sym_file_descriptor] = ACTIONS(3569),
    [anon_sym_esac] = ACTIONS(3569),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_RPAREN] = ACTIONS(3569),
    [anon_sym_SEMI_SEMI] = ACTIONS(3569),
    [anon_sym_PIPE_AMP] = ACTIONS(3569),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3569),
    [anon_sym_LT] = ACTIONS(3571),
    [anon_sym_GT] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3569),
    [anon_sym_AMP_GT] = ACTIONS(3571),
    [anon_sym_AMP_GT_GT] = ACTIONS(3569),
    [anon_sym_LT_AMP] = ACTIONS(3569),
    [anon_sym_GT_AMP] = ACTIONS(3569),
    [anon_sym_BQUOTE] = ACTIONS(3569),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym_LF] = ACTIONS(3569),
    [anon_sym_AMP] = ACTIONS(3571),
  },
  [1110] = {
    [sym__terminated_statement] = STATE(1110),
    [sym_for_statement] = STATE(619),
    [sym_c_style_for_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_case_statement] = STATE(619),
    [sym_function_definition] = STATE(619),
    [sym_subshell] = STATE(619),
    [sym_pipeline] = STATE(619),
    [sym_list] = STATE(619),
    [sym_negated_command] = STATE(619),
    [sym_test_command] = STATE(619),
    [sym_declaration_command] = STATE(619),
    [sym_unset_command] = STATE(619),
    [sym_command] = STATE(619),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(620),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1110),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(891),
    [sym_variable_name] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(914),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(923),
    [anon_sym_declare] = ACTIONS(926),
    [anon_sym_typeset] = ACTIONS(926),
    [anon_sym_export] = ACTIONS(926),
    [anon_sym_readonly] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym_unset] = ACTIONS(929),
    [anon_sym_unsetenv] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [sym_raw_string] = ACTIONS(947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [anon_sym_LT_LPAREN] = ACTIONS(959),
    [anon_sym_GT_LPAREN] = ACTIONS(959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(962),
  },
  [1111] = {
    [sym_concatenation] = STATE(1580),
    [sym_string] = STATE(1579),
    [sym_simple_expansion] = STATE(1579),
    [sym_string_expansion] = STATE(1579),
    [sym_expansion] = STATE(1579),
    [sym_command_substitution] = STATE(1579),
    [sym_process_substitution] = STATE(1579),
    [sym__special_characters] = ACTIONS(3573),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3575),
  },
  [1112] = {
    [aux_sym_concatenation_repeat1] = STATE(1581),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1113] = {
    [aux_sym_concatenation_repeat1] = STATE(1581),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [1114] = {
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [1115] = {
    [aux_sym_concatenation_repeat1] = STATE(1582),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [1116] = {
    [sym_file_redirect] = STATE(648),
    [sym_heredoc_redirect] = STATE(648),
    [sym_heredoc_body] = STATE(1064),
    [sym_herestring_redirect] = STATE(648),
    [aux_sym_while_statement_repeat1] = STATE(648),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2256),
    [anon_sym_SEMI_SEMI] = ACTIONS(2256),
    [anon_sym_PIPE_AMP] = ACTIONS(2256),
    [anon_sym_AMP_AMP] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(483),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_LF] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2258),
  },
  [1117] = {
    [sym_compound_statement] = STATE(1583),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [1118] = {
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3579),
    [anon_sym_AMP_GT] = ACTIONS(3577),
    [anon_sym_AMP_GT_GT] = ACTIONS(3579),
    [anon_sym_LT_AMP] = ACTIONS(3579),
    [anon_sym_GT_AMP] = ACTIONS(3579),
    [sym_comment] = ACTIONS(53),
  },
  [1119] = {
    [sym_concatenation] = STATE(1114),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [sym__special_characters] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(3583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3583),
  },
  [1120] = {
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_GT_GT] = ACTIONS(3587),
    [anon_sym_AMP_GT] = ACTIONS(3585),
    [anon_sym_AMP_GT_GT] = ACTIONS(3587),
    [anon_sym_LT_AMP] = ACTIONS(3587),
    [anon_sym_GT_AMP] = ACTIONS(3587),
    [sym_comment] = ACTIONS(53),
  },
  [1121] = {
    [sym_concatenation] = STATE(1170),
    [sym_string] = STATE(1589),
    [sym_simple_expansion] = STATE(1589),
    [sym_string_expansion] = STATE(1589),
    [sym_expansion] = STATE(1589),
    [sym_command_substitution] = STATE(1589),
    [sym_process_substitution] = STATE(1589),
    [sym__special_characters] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(3591),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3591),
  },
  [1122] = {
    [sym_concatenation] = STATE(1174),
    [sym_string] = STATE(1591),
    [sym_simple_expansion] = STATE(1591),
    [sym_string_expansion] = STATE(1591),
    [sym_expansion] = STATE(1591),
    [sym_command_substitution] = STATE(1591),
    [sym_process_substitution] = STATE(1591),
    [sym__special_characters] = ACTIONS(3593),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(3595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3595),
  },
  [1123] = {
    [sym_file_redirect] = STATE(1592),
    [sym_heredoc_redirect] = STATE(1592),
    [sym_herestring_redirect] = STATE(1592),
    [aux_sym_while_statement_repeat1] = STATE(1592),
    [sym_file_descriptor] = ACTIONS(2385),
    [anon_sym_PIPE] = ACTIONS(2551),
    [anon_sym_RPAREN] = ACTIONS(2553),
    [anon_sym_SEMI_SEMI] = ACTIONS(2553),
    [anon_sym_PIPE_AMP] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(2387),
    [anon_sym_GT] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2389),
    [anon_sym_AMP_GT] = ACTIONS(2387),
    [anon_sym_AMP_GT_GT] = ACTIONS(2389),
    [anon_sym_LT_AMP] = ACTIONS(2389),
    [anon_sym_GT_AMP] = ACTIONS(2389),
    [anon_sym_LT_LT] = ACTIONS(1321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1323),
    [anon_sym_LT_LT_LT] = ACTIONS(2391),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2551),
    [anon_sym_LF] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2551),
  },
  [1124] = {
    [aux_sym_concatenation_repeat1] = STATE(632),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1025),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_SEMI_SEMI] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1025),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1025),
    [sym_word] = ACTIONS(1025),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_LF] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1025),
  },
  [1125] = {
    [aux_sym_concatenation_repeat1] = STATE(632),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(999),
    [anon_sym_PIPE_AMP] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1001),
    [sym_word] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LF] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(1001),
  },
  [1126] = {
    [aux_sym_concatenation_repeat1] = STATE(1126),
    [sym__concat] = ACTIONS(2618),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1666),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [1127] = {
    [aux_sym_concatenation_repeat1] = STATE(1127),
    [sym__concat] = ACTIONS(2679),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1666),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [1128] = {
    [sym_file_redirect] = STATE(1382),
    [sym_file_descriptor] = ACTIONS(2379),
    [anon_sym_PIPE] = ACTIONS(2375),
    [anon_sym_RPAREN] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE_AMP] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_GT] = ACTIONS(2381),
    [anon_sym_GT_GT] = ACTIONS(2383),
    [anon_sym_AMP_GT] = ACTIONS(2381),
    [anon_sym_AMP_GT_GT] = ACTIONS(2383),
    [anon_sym_LT_AMP] = ACTIONS(2383),
    [anon_sym_GT_AMP] = ACTIONS(2383),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2375),
  },
  [1129] = {
    [aux_sym_concatenation_repeat1] = STATE(1131),
    [sym__simple_heredoc_body] = ACTIONS(981),
    [sym__heredoc_body_beginning] = ACTIONS(981),
    [sym_file_descriptor] = ACTIONS(981),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_RPAREN] = ACTIONS(981),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(981),
    [anon_sym_LT_AMP] = ACTIONS(981),
    [anon_sym_GT_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(981),
    [anon_sym_LT_LT_LT] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [1130] = {
    [aux_sym_concatenation_repeat1] = STATE(1131),
    [sym__simple_heredoc_body] = ACTIONS(985),
    [sym__heredoc_body_beginning] = ACTIONS(985),
    [sym_file_descriptor] = ACTIONS(985),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(985),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_DASH] = ACTIONS(985),
    [anon_sym_LT_LT_LT] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [1131] = {
    [aux_sym_concatenation_repeat1] = STATE(1593),
    [sym__simple_heredoc_body] = ACTIONS(695),
    [sym__heredoc_body_beginning] = ACTIONS(695),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [1132] = {
    [anon_sym_esac] = ACTIONS(3597),
    [anon_sym_PIPE] = ACTIONS(3599),
    [anon_sym_RPAREN] = ACTIONS(3597),
    [anon_sym_SEMI_SEMI] = ACTIONS(3597),
    [anon_sym_PIPE_AMP] = ACTIONS(3597),
    [anon_sym_AMP_AMP] = ACTIONS(3597),
    [anon_sym_PIPE_PIPE] = ACTIONS(3597),
    [anon_sym_BQUOTE] = ACTIONS(3597),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym_LF] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3599),
  },
  [1133] = {
    [sym_file_redirect] = STATE(648),
    [sym_heredoc_redirect] = STATE(648),
    [sym_heredoc_body] = STATE(1398),
    [sym_herestring_redirect] = STATE(648),
    [aux_sym_while_statement_repeat1] = STATE(648),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_RPAREN] = ACTIONS(3133),
    [anon_sym_SEMI_SEMI] = ACTIONS(3133),
    [anon_sym_PIPE_AMP] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3133),
    [anon_sym_PIPE_PIPE] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(483),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_LF] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
  },
  [1134] = {
    [sym_file_descriptor] = ACTIONS(2014),
    [sym_variable_name] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2016),
    [anon_sym_GT] = ACTIONS(2016),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT] = ACTIONS(2016),
    [anon_sym_AMP_GT_GT] = ACTIONS(2014),
    [anon_sym_LT_AMP] = ACTIONS(2014),
    [anon_sym_GT_AMP] = ACTIONS(2014),
    [sym__special_characters] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_DOLLAR] = ACTIONS(2016),
    [sym_raw_string] = ACTIONS(2014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2014),
    [anon_sym_BQUOTE] = ACTIONS(2014),
    [anon_sym_LT_LPAREN] = ACTIONS(2014),
    [anon_sym_GT_LPAREN] = ACTIONS(2014),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2014),
  },
  [1135] = {
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_string_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [aux_sym_for_statement_repeat1] = STATE(960),
    [anon_sym_RPAREN] = ACTIONS(3601),
    [sym__special_characters] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [sym_raw_string] = ACTIONS(1011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1019),
    [anon_sym_GT_LPAREN] = ACTIONS(1019),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1011),
  },
  [1136] = {
    [aux_sym_concatenation_repeat1] = STATE(1136),
    [sym__concat] = ACTIONS(2555),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1664),
    [anon_sym_EQ_EQ] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_BANG_EQ] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1664),
  },
  [1137] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_RBRACK] = ACTIONS(2855),
    [anon_sym_EQ_TILDE] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2855),
  },
  [1138] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [anon_sym_RBRACK] = ACTIONS(2869),
    [anon_sym_EQ_TILDE] = ACTIONS(2869),
    [anon_sym_EQ_EQ] = ACTIONS(2869),
    [anon_sym_EQ] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_GT] = ACTIONS(2869),
    [anon_sym_BANG_EQ] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2869),
  },
  [1139] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3603),
    [sym_comment] = ACTIONS(53),
  },
  [1140] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3605),
    [sym_comment] = ACTIONS(53),
  },
  [1141] = {
    [anon_sym_RBRACE] = ACTIONS(3605),
    [sym_comment] = ACTIONS(53),
  },
  [1142] = {
    [sym_concatenation] = STATE(1599),
    [sym_string] = STATE(1598),
    [sym_simple_expansion] = STATE(1598),
    [sym_string_expansion] = STATE(1598),
    [sym_expansion] = STATE(1598),
    [sym_command_substitution] = STATE(1598),
    [sym_process_substitution] = STATE(1598),
    [anon_sym_RBRACE] = ACTIONS(3605),
    [sym__special_characters] = ACTIONS(3607),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(3609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3609),
  },
  [1143] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_RBRACK] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2905),
    [anon_sym_EQ_EQ] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2905),
    [anon_sym_BANG_EQ] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2905),
  },
  [1144] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3611),
  },
  [1145] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3613),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1146] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_RBRACK] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2913),
  },
  [1147] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3615),
  },
  [1148] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1149] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3619),
  },
  [1150] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3605),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1151] = {
    [sym_concatenation] = STATE(1606),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1606),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_EQ] = ACTIONS(3623),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3623),
    [anon_sym_COLON_QMARK] = ACTIONS(3623),
    [anon_sym_COLON_DASH] = ACTIONS(3623),
    [anon_sym_PERCENT] = ACTIONS(3623),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1152] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_EQ_TILDE] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2985),
  },
  [1153] = {
    [sym_concatenation] = STATE(1608),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1608),
    [anon_sym_RBRACE] = ACTIONS(3627),
    [anon_sym_EQ] = ACTIONS(3629),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3629),
    [anon_sym_COLON_QMARK] = ACTIONS(3629),
    [anon_sym_COLON_DASH] = ACTIONS(3629),
    [anon_sym_PERCENT] = ACTIONS(3629),
    [anon_sym_DASH] = ACTIONS(3629),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1154] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_RBRACK] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3030),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_GT] = ACTIONS(3030),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3030),
  },
  [1155] = {
    [sym_concatenation] = STATE(1610),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1610),
    [anon_sym_RBRACE] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(3635),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3637),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3635),
    [anon_sym_COLON_QMARK] = ACTIONS(3635),
    [anon_sym_COLON_DASH] = ACTIONS(3635),
    [anon_sym_PERCENT] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1156] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_RBRACK] = ACTIONS(3040),
    [anon_sym_EQ_TILDE] = ACTIONS(3040),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3040),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3040),
  },
  [1157] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3639),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1158] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(3639),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1159] = {
    [sym__concat] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [anon_sym_RBRACK] = ACTIONS(3078),
    [anon_sym_EQ_TILDE] = ACTIONS(3078),
    [anon_sym_EQ_EQ] = ACTIONS(3078),
    [anon_sym_EQ] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3078),
    [anon_sym_GT] = ACTIONS(3078),
    [anon_sym_BANG_EQ] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3078),
  },
  [1160] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3641),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1161] = {
    [sym_concatenation] = STATE(1615),
    [sym_string] = STATE(1614),
    [sym_simple_expansion] = STATE(1614),
    [sym_string_expansion] = STATE(1614),
    [sym_expansion] = STATE(1614),
    [sym_command_substitution] = STATE(1614),
    [sym_process_substitution] = STATE(1614),
    [sym__special_characters] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(3645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3645),
  },
  [1162] = {
    [aux_sym_concatenation_repeat1] = STATE(1617),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1163] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(1620),
    [anon_sym_DQUOTE] = ACTIONS(3649),
    [anon_sym_DOLLAR] = ACTIONS(3651),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [1164] = {
    [sym_string] = STATE(1622),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(3653),
    [sym_raw_string] = ACTIONS(3655),
    [anon_sym_POUND] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3653),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3657),
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_AT] = ACTIONS(3653),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_0] = ACTIONS(3659),
    [anon_sym__] = ACTIONS(3659),
  },
  [1165] = {
    [aux_sym_concatenation_repeat1] = STATE(1617),
    [sym_file_descriptor] = ACTIONS(679),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [1166] = {
    [sym_subscript] = STATE(1628),
    [sym_variable_name] = ACTIONS(3661),
    [anon_sym_BANG] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(3665),
    [anon_sym_POUND] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3665),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3665),
    [anon_sym_AT] = ACTIONS(3665),
    [anon_sym_QMARK] = ACTIONS(3665),
    [anon_sym_0] = ACTIONS(3669),
    [anon_sym__] = ACTIONS(3669),
  },
  [1167] = {
    [sym__terminated_statement] = STATE(1631),
    [sym_for_statement] = STATE(1629),
    [sym_c_style_for_statement] = STATE(1629),
    [sym_while_statement] = STATE(1629),
    [sym_if_statement] = STATE(1629),
    [sym_case_statement] = STATE(1629),
    [sym_function_definition] = STATE(1629),
    [sym_subshell] = STATE(1629),
    [sym_pipeline] = STATE(1629),
    [sym_list] = STATE(1629),
    [sym_negated_command] = STATE(1629),
    [sym_test_command] = STATE(1629),
    [sym_declaration_command] = STATE(1629),
    [sym_unset_command] = STATE(1629),
    [sym_command] = STATE(1629),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1630),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(1631),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1168] = {
    [sym__terminated_statement] = STATE(1634),
    [sym_for_statement] = STATE(1632),
    [sym_c_style_for_statement] = STATE(1632),
    [sym_while_statement] = STATE(1632),
    [sym_if_statement] = STATE(1632),
    [sym_case_statement] = STATE(1632),
    [sym_function_definition] = STATE(1632),
    [sym_subshell] = STATE(1632),
    [sym_pipeline] = STATE(1632),
    [sym_list] = STATE(1632),
    [sym_negated_command] = STATE(1632),
    [sym_test_command] = STATE(1632),
    [sym_declaration_command] = STATE(1632),
    [sym_unset_command] = STATE(1632),
    [sym_command] = STATE(1632),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(1633),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1634),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [1169] = {
    [sym__terminated_statement] = STATE(1637),
    [sym_for_statement] = STATE(1635),
    [sym_c_style_for_statement] = STATE(1635),
    [sym_while_statement] = STATE(1635),
    [sym_if_statement] = STATE(1635),
    [sym_case_statement] = STATE(1635),
    [sym_function_definition] = STATE(1635),
    [sym_subshell] = STATE(1635),
    [sym_pipeline] = STATE(1635),
    [sym_list] = STATE(1635),
    [sym_negated_command] = STATE(1635),
    [sym_test_command] = STATE(1635),
    [sym_declaration_command] = STATE(1635),
    [sym_unset_command] = STATE(1635),
    [sym_command] = STATE(1635),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1636),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(1637),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1170] = {
    [sym_file_descriptor] = ACTIONS(679),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [1171] = {
    [sym_file_descriptor] = ACTIONS(1932),
    [anon_sym_esac] = ACTIONS(1932),
    [anon_sym_PIPE] = ACTIONS(1934),
    [anon_sym_RPAREN] = ACTIONS(1932),
    [anon_sym_SEMI_SEMI] = ACTIONS(1932),
    [anon_sym_PIPE_AMP] = ACTIONS(1932),
    [anon_sym_AMP_AMP] = ACTIONS(1932),
    [anon_sym_PIPE_PIPE] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1934),
    [anon_sym_GT] = ACTIONS(1934),
    [anon_sym_GT_GT] = ACTIONS(1932),
    [anon_sym_AMP_GT] = ACTIONS(1934),
    [anon_sym_AMP_GT_GT] = ACTIONS(1932),
    [anon_sym_LT_AMP] = ACTIONS(1932),
    [anon_sym_GT_AMP] = ACTIONS(1932),
    [anon_sym_LT_LT] = ACTIONS(1934),
    [anon_sym_LT_LT_DASH] = ACTIONS(1932),
    [anon_sym_LT_LT_LT] = ACTIONS(1932),
    [anon_sym_BQUOTE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym_LF] = ACTIONS(1932),
    [anon_sym_AMP] = ACTIONS(1934),
  },
  [1172] = {
    [aux_sym_concatenation_repeat1] = STATE(1617),
    [sym_file_descriptor] = ACTIONS(1936),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(1938),
    [anon_sym_SEMI_SEMI] = ACTIONS(1936),
    [anon_sym_PIPE_AMP] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1938),
    [anon_sym_GT] = ACTIONS(1938),
    [anon_sym_GT_GT] = ACTIONS(1936),
    [anon_sym_AMP_GT] = ACTIONS(1938),
    [anon_sym_AMP_GT_GT] = ACTIONS(1936),
    [anon_sym_LT_AMP] = ACTIONS(1936),
    [anon_sym_GT_AMP] = ACTIONS(1936),
    [anon_sym_LT_LT] = ACTIONS(1938),
    [anon_sym_LT_LT_DASH] = ACTIONS(1936),
    [anon_sym_LT_LT_LT] = ACTIONS(1936),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_LF] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1938),
  },
  [1173] = {
    [aux_sym_concatenation_repeat1] = STATE(1617),
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [1174] = {
    [sym_file_descriptor] = ACTIONS(1940),
    [anon_sym_esac] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [1175] = {
    [sym_file_redirect] = STATE(1175),
    [sym_heredoc_redirect] = STATE(1175),
    [sym_herestring_redirect] = STATE(1175),
    [aux_sym_while_statement_repeat1] = STATE(1175),
    [sym_file_descriptor] = ACTIONS(3671),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_SEMI_SEMI] = ACTIONS(1948),
    [anon_sym_PIPE_AMP] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_PIPE_PIPE] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_GT_GT] = ACTIONS(3677),
    [anon_sym_AMP_GT] = ACTIONS(3674),
    [anon_sym_AMP_GT_GT] = ACTIONS(3677),
    [anon_sym_LT_AMP] = ACTIONS(3677),
    [anon_sym_GT_AMP] = ACTIONS(3677),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_LT_LT_DASH] = ACTIONS(3683),
    [anon_sym_LT_LT_LT] = ACTIONS(3686),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_LF] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1953),
  },
  [1176] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2855),
    [anon_sym_EQ_TILDE] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2855),
  },
  [1177] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_RPAREN] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2869),
    [anon_sym_EQ_TILDE] = ACTIONS(2869),
    [anon_sym_EQ_EQ] = ACTIONS(2869),
    [anon_sym_EQ] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_GT] = ACTIONS(2869),
    [anon_sym_BANG_EQ] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2869),
  },
  [1178] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3689),
    [sym_comment] = ACTIONS(53),
  },
  [1179] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [sym_comment] = ACTIONS(53),
  },
  [1180] = {
    [anon_sym_RBRACE] = ACTIONS(3691),
    [sym_comment] = ACTIONS(53),
  },
  [1181] = {
    [sym_concatenation] = STATE(1642),
    [sym_string] = STATE(1641),
    [sym_simple_expansion] = STATE(1641),
    [sym_string_expansion] = STATE(1641),
    [sym_expansion] = STATE(1641),
    [sym_command_substitution] = STATE(1641),
    [sym_process_substitution] = STATE(1641),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [sym__special_characters] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(3695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3695),
  },
  [1182] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2905),
    [anon_sym_EQ_EQ] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2905),
    [anon_sym_BANG_EQ] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2905),
  },
  [1183] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3697),
  },
  [1184] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1185] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2913),
  },
  [1186] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3701),
  },
  [1187] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3703),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1188] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3705),
  },
  [1189] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1190] = {
    [sym_concatenation] = STATE(1649),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1649),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [anon_sym_EQ] = ACTIONS(3709),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COLON_QMARK] = ACTIONS(3709),
    [anon_sym_COLON_DASH] = ACTIONS(3709),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1191] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2985),
    [anon_sym_EQ_TILDE] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2985),
  },
  [1192] = {
    [sym_concatenation] = STATE(1651),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1651),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_EQ] = ACTIONS(3715),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3715),
    [anon_sym_COLON_QMARK] = ACTIONS(3715),
    [anon_sym_COLON_DASH] = ACTIONS(3715),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1193] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3030),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_GT] = ACTIONS(3030),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3030),
  },
  [1194] = {
    [sym_concatenation] = STATE(1653),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1653),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_EQ] = ACTIONS(3721),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3723),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COLON_QMARK] = ACTIONS(3721),
    [anon_sym_COLON_DASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1195] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3040),
    [anon_sym_EQ_TILDE] = ACTIONS(3040),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3040),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3040),
  },
  [1196] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3725),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1197] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(3725),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1198] = {
    [sym__concat] = ACTIONS(3078),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3078),
    [anon_sym_EQ_TILDE] = ACTIONS(3078),
    [anon_sym_EQ_EQ] = ACTIONS(3078),
    [anon_sym_EQ] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3078),
    [anon_sym_GT] = ACTIONS(3078),
    [anon_sym_BANG_EQ] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3078),
  },
  [1199] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3727),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1200] = {
    [sym_variable_name] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2016),
    [anon_sym_RPAREN] = ACTIONS(2014),
    [anon_sym_SEMI_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE_AMP] = ACTIONS(2014),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_PIPE_PIPE] = ACTIONS(2014),
    [sym__special_characters] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_DOLLAR] = ACTIONS(2016),
    [sym_raw_string] = ACTIONS(2014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2014),
    [anon_sym_BQUOTE] = ACTIONS(2014),
    [anon_sym_LT_LPAREN] = ACTIONS(2014),
    [anon_sym_GT_LPAREN] = ACTIONS(2014),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2016),
    [sym_word] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2016),
    [anon_sym_LF] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2016),
  },
  [1201] = {
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_string_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [aux_sym_for_statement_repeat1] = STATE(960),
    [anon_sym_RPAREN] = ACTIONS(3729),
    [sym__special_characters] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [sym_raw_string] = ACTIONS(1011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1019),
    [anon_sym_GT_LPAREN] = ACTIONS(1019),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1011),
  },
  [1202] = {
    [sym__concat] = ACTIONS(2855),
    [sym_variable_name] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [1203] = {
    [sym__concat] = ACTIONS(2869),
    [sym_variable_name] = ACTIONS(2869),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_RPAREN] = ACTIONS(2869),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [anon_sym_PIPE_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2871),
    [sym_word] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [1204] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [sym_comment] = ACTIONS(53),
  },
  [1205] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3733),
    [sym_comment] = ACTIONS(53),
  },
  [1206] = {
    [anon_sym_RBRACE] = ACTIONS(3733),
    [sym_comment] = ACTIONS(53),
  },
  [1207] = {
    [sym_concatenation] = STATE(1661),
    [sym_string] = STATE(1660),
    [sym_simple_expansion] = STATE(1660),
    [sym_string_expansion] = STATE(1660),
    [sym_expansion] = STATE(1660),
    [sym_command_substitution] = STATE(1660),
    [sym_process_substitution] = STATE(1660),
    [anon_sym_RBRACE] = ACTIONS(3733),
    [sym__special_characters] = ACTIONS(3735),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(3737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3737),
  },
  [1208] = {
    [sym__concat] = ACTIONS(2905),
    [sym_variable_name] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [anon_sym_PIPE_AMP] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2907),
    [sym_word] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [1209] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3739),
  },
  [1210] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1211] = {
    [sym__concat] = ACTIONS(2913),
    [sym_variable_name] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [anon_sym_PIPE_AMP] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [sym__special_characters] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2915),
    [sym_word] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [1212] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3743),
  },
  [1213] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3745),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1214] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3747),
  },
  [1215] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3733),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1216] = {
    [sym_concatenation] = STATE(1668),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1668),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_EQ] = ACTIONS(3751),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3751),
    [anon_sym_COLON_QMARK] = ACTIONS(3751),
    [anon_sym_COLON_DASH] = ACTIONS(3751),
    [anon_sym_PERCENT] = ACTIONS(3751),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1217] = {
    [sym__concat] = ACTIONS(2985),
    [sym_variable_name] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [anon_sym_PIPE_AMP] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [sym__special_characters] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2987),
    [sym_word] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2987),
  },
  [1218] = {
    [sym_concatenation] = STATE(1670),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1670),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [anon_sym_EQ] = ACTIONS(3757),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3757),
    [anon_sym_COLON_QMARK] = ACTIONS(3757),
    [anon_sym_COLON_DASH] = ACTIONS(3757),
    [anon_sym_PERCENT] = ACTIONS(3757),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1219] = {
    [sym__concat] = ACTIONS(3030),
    [sym_variable_name] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_PIPE_AMP] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [sym__special_characters] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3032),
    [sym_word] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
  },
  [1220] = {
    [sym_concatenation] = STATE(1672),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1672),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3763),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3763),
    [anon_sym_COLON_QMARK] = ACTIONS(3763),
    [anon_sym_COLON_DASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [anon_sym_DASH] = ACTIONS(3763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1221] = {
    [sym__concat] = ACTIONS(3040),
    [sym_variable_name] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE_AMP] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3042),
    [sym_word] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
  },
  [1222] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3767),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1223] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(3767),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1224] = {
    [sym__concat] = ACTIONS(3078),
    [sym_variable_name] = ACTIONS(3078),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3078),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [sym__special_characters] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3080),
    [sym_word] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
  },
  [1225] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3769),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1226] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [1227] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_RPAREN] = ACTIONS(2869),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [anon_sym_PIPE_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2871),
    [sym_word] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [1228] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3771),
    [sym_comment] = ACTIONS(53),
  },
  [1229] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [sym_comment] = ACTIONS(53),
  },
  [1230] = {
    [anon_sym_RBRACE] = ACTIONS(3773),
    [sym_comment] = ACTIONS(53),
  },
  [1231] = {
    [sym_concatenation] = STATE(1679),
    [sym_string] = STATE(1678),
    [sym_simple_expansion] = STATE(1678),
    [sym_string_expansion] = STATE(1678),
    [sym_expansion] = STATE(1678),
    [sym_command_substitution] = STATE(1678),
    [sym_process_substitution] = STATE(1678),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [sym__special_characters] = ACTIONS(3775),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(3777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3777),
  },
  [1232] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [anon_sym_PIPE_AMP] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2907),
    [sym_word] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [1233] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3779),
  },
  [1234] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1235] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [anon_sym_PIPE_AMP] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [sym__special_characters] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2915),
    [sym_word] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [1236] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3783),
  },
  [1237] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3785),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1238] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3787),
  },
  [1239] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1240] = {
    [sym_concatenation] = STATE(1686),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1686),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(3791),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3791),
    [anon_sym_COLON_QMARK] = ACTIONS(3791),
    [anon_sym_COLON_DASH] = ACTIONS(3791),
    [anon_sym_PERCENT] = ACTIONS(3791),
    [anon_sym_DASH] = ACTIONS(3791),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1241] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [anon_sym_PIPE_AMP] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [sym__special_characters] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2987),
    [sym_word] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2987),
  },
  [1242] = {
    [sym_concatenation] = STATE(1688),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1688),
    [anon_sym_RBRACE] = ACTIONS(3795),
    [anon_sym_EQ] = ACTIONS(3797),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3799),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3797),
    [anon_sym_COLON_QMARK] = ACTIONS(3797),
    [anon_sym_COLON_DASH] = ACTIONS(3797),
    [anon_sym_PERCENT] = ACTIONS(3797),
    [anon_sym_DASH] = ACTIONS(3797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1243] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_PIPE_AMP] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [sym__special_characters] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3032),
    [sym_word] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
  },
  [1244] = {
    [sym_concatenation] = STATE(1690),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1690),
    [anon_sym_RBRACE] = ACTIONS(3801),
    [anon_sym_EQ] = ACTIONS(3803),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3805),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3803),
    [anon_sym_COLON_QMARK] = ACTIONS(3803),
    [anon_sym_COLON_DASH] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1245] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE_AMP] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3042),
    [sym_word] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
  },
  [1246] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3807),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1247] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(3807),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1248] = {
    [sym__concat] = ACTIONS(3078),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3078),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [sym__special_characters] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3080),
    [sym_word] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
  },
  [1249] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3809),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1250] = {
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [sym_variable_name] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2855),
    [anon_sym_LT_AMP] = ACTIONS(2855),
    [anon_sym_GT_AMP] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2855),
  },
  [1251] = {
    [sym_file_descriptor] = ACTIONS(2869),
    [sym__concat] = ACTIONS(2869),
    [sym_variable_name] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_GT_GT] = ACTIONS(2869),
    [anon_sym_AMP_GT] = ACTIONS(2871),
    [anon_sym_AMP_GT_GT] = ACTIONS(2869),
    [anon_sym_LT_AMP] = ACTIONS(2869),
    [anon_sym_GT_AMP] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2869),
  },
  [1252] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [sym_comment] = ACTIONS(53),
  },
  [1253] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3813),
    [sym_comment] = ACTIONS(53),
  },
  [1254] = {
    [anon_sym_RBRACE] = ACTIONS(3813),
    [sym_comment] = ACTIONS(53),
  },
  [1255] = {
    [sym_concatenation] = STATE(1697),
    [sym_string] = STATE(1696),
    [sym_simple_expansion] = STATE(1696),
    [sym_string_expansion] = STATE(1696),
    [sym_expansion] = STATE(1696),
    [sym_command_substitution] = STATE(1696),
    [sym_process_substitution] = STATE(1696),
    [anon_sym_RBRACE] = ACTIONS(3813),
    [sym__special_characters] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(3817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3817),
  },
  [1256] = {
    [sym_file_descriptor] = ACTIONS(2905),
    [sym__concat] = ACTIONS(2905),
    [sym_variable_name] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2907),
    [anon_sym_GT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2905),
    [anon_sym_AMP_GT] = ACTIONS(2907),
    [anon_sym_AMP_GT_GT] = ACTIONS(2905),
    [anon_sym_LT_AMP] = ACTIONS(2905),
    [anon_sym_GT_AMP] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2905),
  },
  [1257] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3819),
  },
  [1258] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3821),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1259] = {
    [sym_file_descriptor] = ACTIONS(2913),
    [sym__concat] = ACTIONS(2913),
    [sym_variable_name] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_AMP_GT] = ACTIONS(2915),
    [anon_sym_AMP_GT_GT] = ACTIONS(2913),
    [anon_sym_LT_AMP] = ACTIONS(2913),
    [anon_sym_GT_AMP] = ACTIONS(2913),
    [sym__special_characters] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2913),
  },
  [1260] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3823),
  },
  [1261] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1262] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3827),
  },
  [1263] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1264] = {
    [sym_concatenation] = STATE(1704),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1704),
    [anon_sym_RBRACE] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3831),
    [anon_sym_COLON_QMARK] = ACTIONS(3831),
    [anon_sym_COLON_DASH] = ACTIONS(3831),
    [anon_sym_PERCENT] = ACTIONS(3831),
    [anon_sym_DASH] = ACTIONS(3831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1265] = {
    [sym_file_descriptor] = ACTIONS(2985),
    [sym__concat] = ACTIONS(2985),
    [sym_variable_name] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_GT] = ACTIONS(2987),
    [anon_sym_AMP_GT_GT] = ACTIONS(2985),
    [anon_sym_LT_AMP] = ACTIONS(2985),
    [anon_sym_GT_AMP] = ACTIONS(2985),
    [sym__special_characters] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2985),
  },
  [1266] = {
    [sym_concatenation] = STATE(1706),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1706),
    [anon_sym_RBRACE] = ACTIONS(3835),
    [anon_sym_EQ] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3837),
    [anon_sym_COLON_QMARK] = ACTIONS(3837),
    [anon_sym_COLON_DASH] = ACTIONS(3837),
    [anon_sym_PERCENT] = ACTIONS(3837),
    [anon_sym_DASH] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1267] = {
    [sym_file_descriptor] = ACTIONS(3030),
    [sym__concat] = ACTIONS(3030),
    [sym_variable_name] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_AMP_GT] = ACTIONS(3032),
    [anon_sym_AMP_GT_GT] = ACTIONS(3030),
    [anon_sym_LT_AMP] = ACTIONS(3030),
    [anon_sym_GT_AMP] = ACTIONS(3030),
    [sym__special_characters] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3030),
  },
  [1268] = {
    [sym_concatenation] = STATE(1708),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1708),
    [anon_sym_RBRACE] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3843),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3843),
    [anon_sym_COLON_QMARK] = ACTIONS(3843),
    [anon_sym_COLON_DASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1269] = {
    [sym_file_descriptor] = ACTIONS(3040),
    [sym__concat] = ACTIONS(3040),
    [sym_variable_name] = ACTIONS(3040),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_AMP_GT] = ACTIONS(3042),
    [anon_sym_AMP_GT_GT] = ACTIONS(3040),
    [anon_sym_LT_AMP] = ACTIONS(3040),
    [anon_sym_GT_AMP] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3040),
  },
  [1270] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1271] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(3847),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1272] = {
    [sym_file_descriptor] = ACTIONS(3078),
    [sym__concat] = ACTIONS(3078),
    [sym_variable_name] = ACTIONS(3078),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3078),
    [anon_sym_AMP_GT] = ACTIONS(3080),
    [anon_sym_AMP_GT_GT] = ACTIONS(3078),
    [anon_sym_LT_AMP] = ACTIONS(3078),
    [anon_sym_GT_AMP] = ACTIONS(3078),
    [sym__special_characters] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3078),
  },
  [1273] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1274] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2871),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym__string_content] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2871),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2871),
    [anon_sym_BQUOTE] = ACTIONS(2871),
    [sym_comment] = ACTIONS(243),
  },
  [1275] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3851),
    [sym_comment] = ACTIONS(53),
  },
  [1276] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3853),
    [sym_comment] = ACTIONS(53),
  },
  [1277] = {
    [anon_sym_RBRACE] = ACTIONS(3853),
    [sym_comment] = ACTIONS(53),
  },
  [1278] = {
    [sym_concatenation] = STATE(1715),
    [sym_string] = STATE(1714),
    [sym_simple_expansion] = STATE(1714),
    [sym_string_expansion] = STATE(1714),
    [sym_expansion] = STATE(1714),
    [sym_command_substitution] = STATE(1714),
    [sym_process_substitution] = STATE(1714),
    [anon_sym_RBRACE] = ACTIONS(3853),
    [sym__special_characters] = ACTIONS(3855),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(3857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3857),
  },
  [1279] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2907),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym__string_content] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2907),
    [anon_sym_BQUOTE] = ACTIONS(2907),
    [sym_comment] = ACTIONS(243),
  },
  [1280] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3859),
  },
  [1281] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3861),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1282] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2915),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym__string_content] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2915),
    [anon_sym_BQUOTE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(243),
  },
  [1283] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3863),
  },
  [1284] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1285] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(3867),
  },
  [1286] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(3853),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1287] = {
    [sym_concatenation] = STATE(1722),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1722),
    [anon_sym_RBRACE] = ACTIONS(3869),
    [anon_sym_EQ] = ACTIONS(3871),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3871),
    [anon_sym_COLON_QMARK] = ACTIONS(3871),
    [anon_sym_COLON_DASH] = ACTIONS(3871),
    [anon_sym_PERCENT] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3871),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1288] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym__string_content] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2987),
    [anon_sym_BQUOTE] = ACTIONS(2987),
    [sym_comment] = ACTIONS(243),
  },
  [1289] = {
    [sym_concatenation] = STATE(1724),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1724),
    [anon_sym_RBRACE] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3877),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3877),
    [anon_sym_COLON_QMARK] = ACTIONS(3877),
    [anon_sym_COLON_DASH] = ACTIONS(3877),
    [anon_sym_PERCENT] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3877),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1290] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym__string_content] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3032),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3032),
    [anon_sym_BQUOTE] = ACTIONS(3032),
    [sym_comment] = ACTIONS(243),
  },
  [1291] = {
    [sym_concatenation] = STATE(1726),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1726),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3883),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3883),
    [anon_sym_COLON_QMARK] = ACTIONS(3883),
    [anon_sym_COLON_DASH] = ACTIONS(3883),
    [anon_sym_PERCENT] = ACTIONS(3883),
    [anon_sym_DASH] = ACTIONS(3883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1292] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3042),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym__string_content] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3042),
    [anon_sym_BQUOTE] = ACTIONS(3042),
    [sym_comment] = ACTIONS(243),
  },
  [1293] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1294] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(3887),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1295] = {
    [sym_string] = STATE(662),
    [sym_simple_expansion] = STATE(662),
    [sym_string_expansion] = STATE(662),
    [sym_expansion] = STATE(662),
    [sym_command_substitution] = STATE(662),
    [sym_process_substitution] = STATE(662),
    [anon_sym_RBRACK] = ACTIONS(3889),
    [sym__special_characters] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1255),
  },
  [1296] = {
    [sym__concat] = ACTIONS(3891),
    [anon_sym_RBRACE] = ACTIONS(2006),
    [anon_sym_EQ] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [sym_raw_string] = ACTIONS(2006),
    [anon_sym_POUND] = ACTIONS(2006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2006),
    [anon_sym_SLASH] = ACTIONS(2006),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_DASH] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2006),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [anon_sym_LT_LPAREN] = ACTIONS(2006),
    [anon_sym_GT_LPAREN] = ACTIONS(2006),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(3893),
  },
  [1297] = {
    [sym_string] = STATE(662),
    [sym_simple_expansion] = STATE(662),
    [sym_string_expansion] = STATE(662),
    [sym_expansion] = STATE(662),
    [sym_command_substitution] = STATE(662),
    [sym_process_substitution] = STATE(662),
    [anon_sym_RBRACK] = ACTIONS(3895),
    [sym__special_characters] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1255),
  },
  [1298] = {
    [sym__concat] = ACTIONS(3897),
    [anon_sym_RBRACE] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(3899),
    [sym__special_characters] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [sym_raw_string] = ACTIONS(2012),
    [anon_sym_POUND] = ACTIONS(2012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_DASH] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2012),
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2012),
    [anon_sym_GT_LPAREN] = ACTIONS(2012),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(3899),
  },
  [1299] = {
    [anon_sym_RBRACK] = ACTIONS(3895),
    [sym_comment] = ACTIONS(53),
  },
  [1300] = {
    [sym_string] = STATE(1732),
    [sym_simple_expansion] = STATE(1732),
    [sym_string_expansion] = STATE(1732),
    [sym_expansion] = STATE(1732),
    [sym_command_substitution] = STATE(1732),
    [sym_process_substitution] = STATE(1732),
    [sym__special_characters] = ACTIONS(3901),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(3901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3901),
  },
  [1301] = {
    [sym__simple_heredoc_body] = ACTIONS(3903),
    [sym__heredoc_body_beginning] = ACTIONS(3903),
    [sym_file_descriptor] = ACTIONS(3903),
    [sym__concat] = ACTIONS(3903),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_RPAREN] = ACTIONS(3903),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_EQ_TILDE] = ACTIONS(3905),
    [anon_sym_EQ_EQ] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_GT_GT] = ACTIONS(3903),
    [anon_sym_AMP_GT] = ACTIONS(3905),
    [anon_sym_AMP_GT_GT] = ACTIONS(3903),
    [anon_sym_LT_AMP] = ACTIONS(3903),
    [anon_sym_GT_AMP] = ACTIONS(3903),
    [anon_sym_LT_LT] = ACTIONS(3905),
    [anon_sym_LT_LT_DASH] = ACTIONS(3903),
    [anon_sym_LT_LT_LT] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [1302] = {
    [aux_sym_concatenation_repeat1] = STATE(1733),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
  },
  [1303] = {
    [sym__concat] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
  },
  [1304] = {
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [1305] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_DOLLAR] = ACTIONS(3909),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [1306] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
  },
  [1307] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
  },
  [1308] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_RBRACE] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
  },
  [1309] = {
    [sym__simple_heredoc_body] = ACTIONS(3911),
    [sym__heredoc_body_beginning] = ACTIONS(3911),
    [sym_file_descriptor] = ACTIONS(3911),
    [sym__concat] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_EQ_TILDE] = ACTIONS(3913),
    [anon_sym_EQ_EQ] = ACTIONS(3913),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_GT] = ACTIONS(3913),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3913),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3913),
    [anon_sym_LT_LT_DASH] = ACTIONS(3911),
    [anon_sym_LT_LT_LT] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3913),
  },
  [1310] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
  },
  [1311] = {
    [sym_subscript] = STATE(1740),
    [sym_variable_name] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [anon_sym_DASH] = ACTIONS(3919),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3921),
    [anon_sym_STAR] = ACTIONS(3919),
    [anon_sym_AT] = ACTIONS(3919),
    [anon_sym_QMARK] = ACTIONS(3919),
    [anon_sym_0] = ACTIONS(3923),
    [anon_sym__] = ACTIONS(3923),
  },
  [1312] = {
    [sym_concatenation] = STATE(1743),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1743),
    [anon_sym_RBRACE] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_DASH] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1313] = {
    [sym_concatenation] = STATE(1746),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1746),
    [anon_sym_RBRACE] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3937),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_DASH] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1314] = {
    [sym_concatenation] = STATE(1749),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1749),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3943),
    [anon_sym_COLON_QMARK] = ACTIONS(3943),
    [anon_sym_COLON_DASH] = ACTIONS(3943),
    [anon_sym_PERCENT] = ACTIONS(3943),
    [anon_sym_DASH] = ACTIONS(3943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1315] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3949),
    [anon_sym_SEMI_SEMI] = ACTIONS(3951),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3953),
    [anon_sym_LF] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3953),
  },
  [1316] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3949),
    [anon_sym_SEMI_SEMI] = ACTIONS(3951),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3953),
    [anon_sym_LF] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3953),
  },
  [1317] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1752),
    [sym_c_style_for_statement] = STATE(1752),
    [sym_while_statement] = STATE(1752),
    [sym_if_statement] = STATE(1752),
    [sym_case_statement] = STATE(1752),
    [sym_function_definition] = STATE(1752),
    [sym_subshell] = STATE(1752),
    [sym_pipeline] = STATE(1752),
    [sym_list] = STATE(1752),
    [sym_negated_command] = STATE(1752),
    [sym_test_command] = STATE(1752),
    [sym_declaration_command] = STATE(1752),
    [sym_unset_command] = STATE(1752),
    [sym_command] = STATE(1752),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1753),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1318] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(3955),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(3949),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3957),
    [anon_sym_LF] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3957),
  },
  [1319] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(3955),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(3949),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3957),
    [anon_sym_LF] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3957),
  },
  [1320] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1755),
    [sym_c_style_for_statement] = STATE(1755),
    [sym_while_statement] = STATE(1755),
    [sym_if_statement] = STATE(1755),
    [sym_case_statement] = STATE(1755),
    [sym_function_definition] = STATE(1755),
    [sym_subshell] = STATE(1755),
    [sym_pipeline] = STATE(1755),
    [sym_list] = STATE(1755),
    [sym_negated_command] = STATE(1755),
    [sym_test_command] = STATE(1755),
    [sym_declaration_command] = STATE(1755),
    [sym_unset_command] = STATE(1755),
    [sym_command] = STATE(1755),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(1756),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [1321] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3959),
    [anon_sym_SEMI_SEMI] = ACTIONS(3961),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3963),
    [anon_sym_LF] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
  },
  [1322] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(3959),
    [anon_sym_SEMI_SEMI] = ACTIONS(3961),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(3963),
    [anon_sym_LF] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
  },
  [1323] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1759),
    [sym_c_style_for_statement] = STATE(1759),
    [sym_while_statement] = STATE(1759),
    [sym_if_statement] = STATE(1759),
    [sym_case_statement] = STATE(1759),
    [sym_function_definition] = STATE(1759),
    [sym_subshell] = STATE(1759),
    [sym_pipeline] = STATE(1759),
    [sym_list] = STATE(1759),
    [sym_negated_command] = STATE(1759),
    [sym_test_command] = STATE(1759),
    [sym_declaration_command] = STATE(1759),
    [sym_unset_command] = STATE(1759),
    [sym_command] = STATE(1759),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1760),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1324] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3965),
    [sym_comment] = ACTIONS(53),
  },
  [1325] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [sym_comment] = ACTIONS(53),
  },
  [1326] = {
    [anon_sym_RBRACE] = ACTIONS(3967),
    [sym_comment] = ACTIONS(53),
  },
  [1327] = {
    [sym_concatenation] = STATE(1764),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1764),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3971),
    [anon_sym_COLON_QMARK] = ACTIONS(3971),
    [anon_sym_COLON_DASH] = ACTIONS(3971),
    [anon_sym_PERCENT] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1328] = {
    [sym__simple_heredoc_body] = ACTIONS(3975),
    [sym__heredoc_body_beginning] = ACTIONS(3975),
    [sym_file_descriptor] = ACTIONS(3975),
    [sym__concat] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3975),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [anon_sym_PIPE_AMP] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_EQ_TILDE] = ACTIONS(3977),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_LT] = ACTIONS(3977),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_GT_GT] = ACTIONS(3975),
    [anon_sym_AMP_GT] = ACTIONS(3977),
    [anon_sym_AMP_GT_GT] = ACTIONS(3975),
    [anon_sym_LT_AMP] = ACTIONS(3975),
    [anon_sym_GT_AMP] = ACTIONS(3975),
    [anon_sym_LT_LT] = ACTIONS(3977),
    [anon_sym_LT_LT_DASH] = ACTIONS(3975),
    [anon_sym_LT_LT_LT] = ACTIONS(3975),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3977),
  },
  [1329] = {
    [sym_concatenation] = STATE(1766),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1766),
    [anon_sym_RBRACE] = ACTIONS(3979),
    [anon_sym_EQ] = ACTIONS(3981),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3981),
    [anon_sym_COLON_QMARK] = ACTIONS(3981),
    [anon_sym_COLON_DASH] = ACTIONS(3981),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1330] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3987),
    [anon_sym_EQ_EQ] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3987),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [1331] = {
    [sym_concatenation] = STATE(1768),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1768),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_EQ] = ACTIONS(3991),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(3993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_COLON_QMARK] = ACTIONS(3991),
    [anon_sym_COLON_DASH] = ACTIONS(3991),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1332] = {
    [sym__concat] = ACTIONS(1664),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1666),
    [sym__special_characters] = ACTIONS(1666),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_POUND] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_COLON] = ACTIONS(1666),
    [anon_sym_COLON_QMARK] = ACTIONS(1666),
    [anon_sym_COLON_DASH] = ACTIONS(1666),
    [anon_sym_PERCENT] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(1666),
  },
  [1333] = {
    [aux_sym_concatenation_repeat1] = STATE(1333),
    [sym__concat] = ACTIONS(3995),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1666),
    [sym__special_characters] = ACTIONS(1666),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_POUND] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_COLON] = ACTIONS(1666),
    [anon_sym_COLON_QMARK] = ACTIONS(1666),
    [anon_sym_COLON_DASH] = ACTIONS(1666),
    [anon_sym_PERCENT] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(1666),
  },
  [1334] = {
    [sym__concat] = ACTIONS(1671),
    [anon_sym_RBRACE] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1673),
    [sym__special_characters] = ACTIONS(1673),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_POUND] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_COLON] = ACTIONS(1673),
    [anon_sym_COLON_QMARK] = ACTIONS(1673),
    [anon_sym_COLON_DASH] = ACTIONS(1673),
    [anon_sym_PERCENT] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(1673),
  },
  [1335] = {
    [anon_sym_DQUOTE] = ACTIONS(3998),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [1336] = {
    [sym_concatenation] = STATE(1773),
    [sym_string] = STATE(1772),
    [sym_simple_expansion] = STATE(1772),
    [sym_string_expansion] = STATE(1772),
    [sym_expansion] = STATE(1772),
    [sym_command_substitution] = STATE(1772),
    [sym_process_substitution] = STATE(1772),
    [anon_sym_RBRACE] = ACTIONS(4000),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(4004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4004),
  },
  [1337] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(4006),
    [sym_comment] = ACTIONS(53),
  },
  [1338] = {
    [sym_concatenation] = STATE(1777),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1777),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_EQ] = ACTIONS(4010),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4014),
    [anon_sym_COLON] = ACTIONS(4010),
    [anon_sym_COLON_QMARK] = ACTIONS(4010),
    [anon_sym_COLON_DASH] = ACTIONS(4010),
    [anon_sym_PERCENT] = ACTIONS(4010),
    [anon_sym_DASH] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1339] = {
    [sym_concatenation] = STATE(1780),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1780),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [anon_sym_EQ] = ACTIONS(4018),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_DASH] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1340] = {
    [sym_concatenation] = STATE(1782),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1782),
    [anon_sym_RBRACE] = ACTIONS(4000),
    [anon_sym_EQ] = ACTIONS(4024),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COLON_QMARK] = ACTIONS(4024),
    [anon_sym_COLON_DASH] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_DASH] = ACTIONS(4024),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1341] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_RBRACE] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(1790),
    [sym__special_characters] = ACTIONS(1790),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_POUND] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_COLON] = ACTIONS(1790),
    [anon_sym_COLON_QMARK] = ACTIONS(1790),
    [anon_sym_COLON_DASH] = ACTIONS(1790),
    [anon_sym_PERCENT] = ACTIONS(1790),
    [anon_sym_DASH] = ACTIONS(1790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(1790),
  },
  [1342] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4030),
  },
  [1343] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1344] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_RBRACE] = ACTIONS(1832),
    [anon_sym_EQ] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_POUND] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_COLON] = ACTIONS(1834),
    [anon_sym_COLON_QMARK] = ACTIONS(1834),
    [anon_sym_COLON_DASH] = ACTIONS(1834),
    [anon_sym_PERCENT] = ACTIONS(1834),
    [anon_sym_DASH] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(1834),
  },
  [1345] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4034),
  },
  [1346] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1347] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_RBRACE] = ACTIONS(1840),
    [anon_sym_EQ] = ACTIONS(1842),
    [sym__special_characters] = ACTIONS(1842),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_POUND] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_COLON] = ACTIONS(1842),
    [anon_sym_COLON_QMARK] = ACTIONS(1842),
    [anon_sym_COLON_DASH] = ACTIONS(1842),
    [anon_sym_PERCENT] = ACTIONS(1842),
    [anon_sym_DASH] = ACTIONS(1842),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(1842),
  },
  [1348] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4038),
  },
  [1349] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4000),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1350] = {
    [sym__simple_heredoc_body] = ACTIONS(4040),
    [sym__heredoc_body_beginning] = ACTIONS(4040),
    [sym_file_descriptor] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [anon_sym_PIPE_AMP] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_EQ_TILDE] = ACTIONS(4042),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_GT_GT] = ACTIONS(4040),
    [anon_sym_AMP_GT] = ACTIONS(4042),
    [anon_sym_AMP_GT_GT] = ACTIONS(4040),
    [anon_sym_LT_AMP] = ACTIONS(4040),
    [anon_sym_GT_AMP] = ACTIONS(4040),
    [anon_sym_LT_LT] = ACTIONS(4042),
    [anon_sym_LT_LT_DASH] = ACTIONS(4040),
    [anon_sym_LT_LT_LT] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [1351] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1352] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [anon_sym_EQ] = ACTIONS(1848),
    [sym__special_characters] = ACTIONS(1848),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_POUND] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_COLON] = ACTIONS(1848),
    [anon_sym_COLON_QMARK] = ACTIONS(1848),
    [anon_sym_COLON_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(1848),
  },
  [1353] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4046),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1354] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4048),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_LF] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4050),
  },
  [1355] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4048),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_LF] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4050),
  },
  [1356] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1357] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4054),
    [anon_sym_LF] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
  },
  [1358] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4054),
    [anon_sym_LF] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
  },
  [1359] = {
    [sym__concat] = ACTIONS(1878),
    [anon_sym_RBRACE] = ACTIONS(1878),
    [anon_sym_EQ] = ACTIONS(1880),
    [sym__special_characters] = ACTIONS(1880),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_POUND] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_COLON] = ACTIONS(1880),
    [anon_sym_COLON_QMARK] = ACTIONS(1880),
    [anon_sym_COLON_DASH] = ACTIONS(1880),
    [anon_sym_PERCENT] = ACTIONS(1880),
    [anon_sym_DASH] = ACTIONS(1880),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(1880),
  },
  [1360] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1361] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_SEMI_SEMI] = ACTIONS(4058),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4060),
    [anon_sym_LF] = ACTIONS(4058),
    [anon_sym_AMP] = ACTIONS(4060),
  },
  [1362] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_SEMI_SEMI] = ACTIONS(4058),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4060),
    [anon_sym_LF] = ACTIONS(4058),
    [anon_sym_AMP] = ACTIONS(4060),
  },
  [1363] = {
    [sym__simple_heredoc_body] = ACTIONS(4062),
    [sym__heredoc_body_beginning] = ACTIONS(4062),
    [sym_file_descriptor] = ACTIONS(4062),
    [sym__concat] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_EQ_TILDE] = ACTIONS(4064),
    [anon_sym_EQ_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_GT_GT] = ACTIONS(4062),
    [anon_sym_AMP_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT_GT] = ACTIONS(4062),
    [anon_sym_LT_AMP] = ACTIONS(4062),
    [anon_sym_GT_AMP] = ACTIONS(4062),
    [anon_sym_LT_LT] = ACTIONS(4064),
    [anon_sym_LT_LT_DASH] = ACTIONS(4062),
    [anon_sym_LT_LT_LT] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [1364] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4066),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1365] = {
    [sym__simple_heredoc_body] = ACTIONS(4068),
    [sym__heredoc_body_beginning] = ACTIONS(4068),
    [sym_file_descriptor] = ACTIONS(4068),
    [sym__concat] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [anon_sym_PIPE_AMP] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4068),
    [anon_sym_AMP_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT_GT] = ACTIONS(4068),
    [anon_sym_LT_AMP] = ACTIONS(4068),
    [anon_sym_GT_AMP] = ACTIONS(4068),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_LT_LT_DASH] = ACTIONS(4068),
    [anon_sym_LT_LT_LT] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [1366] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1367] = {
    [sym__simple_heredoc_body] = ACTIONS(4074),
    [sym__heredoc_body_beginning] = ACTIONS(4074),
    [sym_file_descriptor] = ACTIONS(4074),
    [sym__concat] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_EQ_TILDE] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_AMP_GT] = ACTIONS(4076),
    [anon_sym_AMP_GT_GT] = ACTIONS(4074),
    [anon_sym_LT_AMP] = ACTIONS(4074),
    [anon_sym_GT_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_LT_LT_DASH] = ACTIONS(4074),
    [anon_sym_LT_LT_LT] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [1368] = {
    [sym_file_redirect] = STATE(910),
    [sym_heredoc_redirect] = STATE(910),
    [sym_heredoc_body] = STATE(1064),
    [sym_herestring_redirect] = STATE(910),
    [aux_sym_while_statement_repeat1] = STATE(910),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_SEMI_SEMI] = ACTIONS(2256),
    [anon_sym_PIPE_AMP] = ACTIONS(2256),
    [anon_sym_AMP_AMP] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(2256),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_LF] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2258),
  },
  [1369] = {
    [sym_compound_statement] = STATE(1796),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [1370] = {
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4078),
    [anon_sym_GT_GT] = ACTIONS(4080),
    [anon_sym_AMP_GT] = ACTIONS(4078),
    [anon_sym_AMP_GT_GT] = ACTIONS(4080),
    [anon_sym_LT_AMP] = ACTIONS(4080),
    [anon_sym_GT_AMP] = ACTIONS(4080),
    [sym_comment] = ACTIONS(53),
  },
  [1371] = {
    [sym_concatenation] = STATE(1114),
    [sym_string] = STATE(1799),
    [sym_simple_expansion] = STATE(1799),
    [sym_string_expansion] = STATE(1799),
    [sym_expansion] = STATE(1799),
    [sym_command_substitution] = STATE(1799),
    [sym_process_substitution] = STATE(1799),
    [sym__special_characters] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(4084),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4084),
  },
  [1372] = {
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_GT] = ACTIONS(4088),
    [anon_sym_AMP_GT] = ACTIONS(4086),
    [anon_sym_AMP_GT_GT] = ACTIONS(4088),
    [anon_sym_LT_AMP] = ACTIONS(4088),
    [anon_sym_GT_AMP] = ACTIONS(4088),
    [sym_comment] = ACTIONS(53),
  },
  [1373] = {
    [sym_concatenation] = STATE(1170),
    [sym_string] = STATE(1802),
    [sym_simple_expansion] = STATE(1802),
    [sym_string_expansion] = STATE(1802),
    [sym_expansion] = STATE(1802),
    [sym_command_substitution] = STATE(1802),
    [sym_process_substitution] = STATE(1802),
    [sym__special_characters] = ACTIONS(4090),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(4092),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4092),
  },
  [1374] = {
    [sym_concatenation] = STATE(1174),
    [sym_string] = STATE(1804),
    [sym_simple_expansion] = STATE(1804),
    [sym_string_expansion] = STATE(1804),
    [sym_expansion] = STATE(1804),
    [sym_command_substitution] = STATE(1804),
    [sym_process_substitution] = STATE(1804),
    [sym__special_characters] = ACTIONS(4094),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(4096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4096),
  },
  [1375] = {
    [sym_file_redirect] = STATE(1805),
    [sym_heredoc_redirect] = STATE(1805),
    [sym_herestring_redirect] = STATE(1805),
    [aux_sym_while_statement_repeat1] = STATE(1805),
    [sym_file_descriptor] = ACTIONS(3054),
    [anon_sym_PIPE] = ACTIONS(2551),
    [anon_sym_SEMI_SEMI] = ACTIONS(2553),
    [anon_sym_PIPE_AMP] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(3056),
    [anon_sym_GT] = ACTIONS(3056),
    [anon_sym_GT_GT] = ACTIONS(3058),
    [anon_sym_AMP_GT] = ACTIONS(3056),
    [anon_sym_AMP_GT_GT] = ACTIONS(3058),
    [anon_sym_LT_AMP] = ACTIONS(3058),
    [anon_sym_GT_AMP] = ACTIONS(3058),
    [anon_sym_LT_LT] = ACTIONS(1321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1323),
    [anon_sym_LT_LT_LT] = ACTIONS(3060),
    [anon_sym_BQUOTE] = ACTIONS(2553),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2551),
    [anon_sym_LF] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2551),
  },
  [1376] = {
    [sym_file_redirect] = STATE(1382),
    [sym_file_descriptor] = ACTIONS(3048),
    [anon_sym_PIPE] = ACTIONS(2375),
    [anon_sym_SEMI_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE_AMP] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(3050),
    [anon_sym_GT] = ACTIONS(3050),
    [anon_sym_GT_GT] = ACTIONS(3052),
    [anon_sym_AMP_GT] = ACTIONS(3050),
    [anon_sym_AMP_GT_GT] = ACTIONS(3052),
    [anon_sym_LT_AMP] = ACTIONS(3052),
    [anon_sym_GT_AMP] = ACTIONS(3052),
    [anon_sym_BQUOTE] = ACTIONS(2373),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2375),
  },
  [1377] = {
    [aux_sym_concatenation_repeat1] = STATE(1379),
    [sym__simple_heredoc_body] = ACTIONS(981),
    [sym__heredoc_body_beginning] = ACTIONS(981),
    [sym_file_descriptor] = ACTIONS(981),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(981),
    [anon_sym_LT_AMP] = ACTIONS(981),
    [anon_sym_GT_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(981),
    [anon_sym_LT_LT_LT] = ACTIONS(981),
    [anon_sym_BQUOTE] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [1378] = {
    [aux_sym_concatenation_repeat1] = STATE(1379),
    [sym__simple_heredoc_body] = ACTIONS(985),
    [sym__heredoc_body_beginning] = ACTIONS(985),
    [sym_file_descriptor] = ACTIONS(985),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_DASH] = ACTIONS(985),
    [anon_sym_LT_LT_LT] = ACTIONS(985),
    [anon_sym_BQUOTE] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [1379] = {
    [aux_sym_concatenation_repeat1] = STATE(1806),
    [sym__simple_heredoc_body] = ACTIONS(695),
    [sym__heredoc_body_beginning] = ACTIONS(695),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(227),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [1380] = {
    [sym_file_redirect] = STATE(910),
    [sym_heredoc_redirect] = STATE(910),
    [sym_heredoc_body] = STATE(1398),
    [sym_herestring_redirect] = STATE(910),
    [aux_sym_while_statement_repeat1] = STATE(910),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_SEMI_SEMI] = ACTIONS(3133),
    [anon_sym_PIPE_AMP] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3133),
    [anon_sym_PIPE_PIPE] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(3133),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_LF] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
  },
  [1381] = {
    [sym__simple_heredoc_body] = ACTIONS(4098),
    [sym__heredoc_body_beginning] = ACTIONS(4098),
    [sym_file_descriptor] = ACTIONS(4098),
    [sym__concat] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_RPAREN] = ACTIONS(4098),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [anon_sym_PIPE_AMP] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_EQ_TILDE] = ACTIONS(4100),
    [anon_sym_EQ_EQ] = ACTIONS(4100),
    [anon_sym_LT] = ACTIONS(4100),
    [anon_sym_GT] = ACTIONS(4100),
    [anon_sym_GT_GT] = ACTIONS(4098),
    [anon_sym_AMP_GT] = ACTIONS(4100),
    [anon_sym_AMP_GT_GT] = ACTIONS(4098),
    [anon_sym_LT_AMP] = ACTIONS(4098),
    [anon_sym_GT_AMP] = ACTIONS(4098),
    [anon_sym_LT_LT] = ACTIONS(4100),
    [anon_sym_LT_LT_DASH] = ACTIONS(4098),
    [anon_sym_LT_LT_LT] = ACTIONS(4098),
    [sym__special_characters] = ACTIONS(4098),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
  },
  [1382] = {
    [anon_sym_esac] = ACTIONS(3567),
    [anon_sym_PIPE] = ACTIONS(3565),
    [anon_sym_RPAREN] = ACTIONS(3567),
    [anon_sym_SEMI_SEMI] = ACTIONS(3567),
    [anon_sym_PIPE_AMP] = ACTIONS(3567),
    [anon_sym_AMP_AMP] = ACTIONS(3567),
    [anon_sym_PIPE_PIPE] = ACTIONS(3567),
    [anon_sym_BQUOTE] = ACTIONS(3567),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3565),
    [anon_sym_LF] = ACTIONS(3567),
    [anon_sym_AMP] = ACTIONS(3565),
  },
  [1383] = {
    [sym_concatenation] = STATE(1810),
    [sym_string] = STATE(1809),
    [sym_simple_expansion] = STATE(1809),
    [sym_string_expansion] = STATE(1809),
    [sym_expansion] = STATE(1809),
    [sym_command_substitution] = STATE(1809),
    [sym_process_substitution] = STATE(1809),
    [anon_sym_RBRACE] = ACTIONS(4102),
    [sym__special_characters] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(4106),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4106),
  },
  [1384] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(4108),
    [sym_comment] = ACTIONS(53),
  },
  [1385] = {
    [sym_concatenation] = STATE(1814),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1814),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_EQ] = ACTIONS(4112),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_DASH] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1386] = {
    [sym_concatenation] = STATE(1817),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1817),
    [anon_sym_RBRACE] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4120),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4122),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4120),
    [anon_sym_COLON_QMARK] = ACTIONS(4120),
    [anon_sym_COLON_DASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1387] = {
    [sym_concatenation] = STATE(1819),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1819),
    [anon_sym_RBRACE] = ACTIONS(4102),
    [anon_sym_EQ] = ACTIONS(4126),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4128),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_DASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1388] = {
    [sym__heredoc_body_middle] = ACTIONS(1788),
    [sym__heredoc_body_end] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
  },
  [1389] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4132),
  },
  [1390] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4134),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1391] = {
    [sym__heredoc_body_middle] = ACTIONS(1832),
    [sym__heredoc_body_end] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
  },
  [1392] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4136),
  },
  [1393] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1394] = {
    [sym__heredoc_body_middle] = ACTIONS(1840),
    [sym__heredoc_body_end] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
  },
  [1395] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4140),
  },
  [1396] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4102),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1397] = {
    [aux_sym_concatenation_repeat1] = STATE(1397),
    [sym__simple_heredoc_body] = ACTIONS(1664),
    [sym__heredoc_body_beginning] = ACTIONS(1664),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1668),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [1398] = {
    [anon_sym_esac] = ACTIONS(4142),
    [anon_sym_PIPE] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4142),
    [anon_sym_SEMI_SEMI] = ACTIONS(4142),
    [anon_sym_PIPE_AMP] = ACTIONS(4142),
    [anon_sym_AMP_AMP] = ACTIONS(4142),
    [anon_sym_PIPE_PIPE] = ACTIONS(4142),
    [anon_sym_BQUOTE] = ACTIONS(4142),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_LF] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4144),
  },
  [1399] = {
    [anon_sym_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [sym_comment] = ACTIONS(53),
  },
  [1400] = {
    [anon_sym_EQ] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [sym_comment] = ACTIONS(53),
  },
  [1401] = {
    [sym__concat] = ACTIONS(1664),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1664),
  },
  [1402] = {
    [aux_sym_concatenation_repeat1] = STATE(1402),
    [sym__concat] = ACTIONS(4150),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1664),
  },
  [1403] = {
    [sym__concat] = ACTIONS(1671),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1671),
  },
  [1404] = {
    [anon_sym_DQUOTE] = ACTIONS(4153),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [1405] = {
    [sym_concatenation] = STATE(1829),
    [sym_string] = STATE(1828),
    [sym_simple_expansion] = STATE(1828),
    [sym_string_expansion] = STATE(1828),
    [sym_expansion] = STATE(1828),
    [sym_command_substitution] = STATE(1828),
    [sym_process_substitution] = STATE(1828),
    [anon_sym_RBRACE] = ACTIONS(4155),
    [sym__special_characters] = ACTIONS(4157),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4159),
  },
  [1406] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(4161),
    [sym_comment] = ACTIONS(53),
  },
  [1407] = {
    [sym_concatenation] = STATE(1833),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1833),
    [anon_sym_RBRACE] = ACTIONS(4163),
    [anon_sym_EQ] = ACTIONS(4165),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_COLON] = ACTIONS(4165),
    [anon_sym_COLON_QMARK] = ACTIONS(4165),
    [anon_sym_COLON_DASH] = ACTIONS(4165),
    [anon_sym_PERCENT] = ACTIONS(4165),
    [anon_sym_DASH] = ACTIONS(4165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1408] = {
    [sym_concatenation] = STATE(1836),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1836),
    [anon_sym_RBRACE] = ACTIONS(4171),
    [anon_sym_EQ] = ACTIONS(4173),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4177),
    [anon_sym_COLON] = ACTIONS(4173),
    [anon_sym_COLON_QMARK] = ACTIONS(4173),
    [anon_sym_COLON_DASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1409] = {
    [sym_concatenation] = STATE(1838),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1838),
    [anon_sym_RBRACE] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4179),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4183),
    [anon_sym_COLON] = ACTIONS(4179),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_COLON_DASH] = ACTIONS(4179),
    [anon_sym_PERCENT] = ACTIONS(4179),
    [anon_sym_DASH] = ACTIONS(4179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1410] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_RPAREN] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1788),
  },
  [1411] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4185),
  },
  [1412] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4187),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1413] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1832),
  },
  [1414] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4189),
  },
  [1415] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4191),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1416] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1840),
  },
  [1417] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4193),
  },
  [1418] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1419] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1846),
  },
  [1420] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1421] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4195),
    [anon_sym_SEMI_SEMI] = ACTIONS(4197),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4199),
    [anon_sym_LF] = ACTIONS(4197),
    [anon_sym_AMP] = ACTIONS(4199),
  },
  [1422] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4195),
    [anon_sym_SEMI_SEMI] = ACTIONS(4197),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4199),
    [anon_sym_LF] = ACTIONS(4197),
    [anon_sym_AMP] = ACTIONS(4199),
  },
  [1423] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(4195),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1424] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4201),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(4195),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4203),
    [anon_sym_LF] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4203),
  },
  [1425] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4201),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(4195),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4203),
    [anon_sym_LF] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4203),
  },
  [1426] = {
    [sym__concat] = ACTIONS(1878),
    [anon_sym_RPAREN] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1878),
  },
  [1427] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1428] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_SEMI_SEMI] = ACTIONS(4207),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4209),
    [anon_sym_LF] = ACTIONS(4207),
    [anon_sym_AMP] = ACTIONS(4209),
  },
  [1429] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_SEMI_SEMI] = ACTIONS(4207),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4209),
    [anon_sym_LF] = ACTIONS(4207),
    [anon_sym_AMP] = ACTIONS(4209),
  },
  [1430] = {
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [sym_variable_name] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2855),
    [anon_sym_LT_AMP] = ACTIONS(2855),
    [anon_sym_GT_AMP] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [1431] = {
    [sym_file_descriptor] = ACTIONS(2869),
    [sym__concat] = ACTIONS(2869),
    [sym_variable_name] = ACTIONS(2869),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_RPAREN] = ACTIONS(2869),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [anon_sym_PIPE_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_GT_GT] = ACTIONS(2869),
    [anon_sym_AMP_GT] = ACTIONS(2871),
    [anon_sym_AMP_GT_GT] = ACTIONS(2869),
    [anon_sym_LT_AMP] = ACTIONS(2869),
    [anon_sym_GT_AMP] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [1432] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [sym_comment] = ACTIONS(53),
  },
  [1433] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [sym_comment] = ACTIONS(53),
  },
  [1434] = {
    [anon_sym_RBRACE] = ACTIONS(4213),
    [sym_comment] = ACTIONS(53),
  },
  [1435] = {
    [sym_concatenation] = STATE(1853),
    [sym_string] = STATE(1852),
    [sym_simple_expansion] = STATE(1852),
    [sym_string_expansion] = STATE(1852),
    [sym_expansion] = STATE(1852),
    [sym_command_substitution] = STATE(1852),
    [sym_process_substitution] = STATE(1852),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [sym__special_characters] = ACTIONS(4215),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(4217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4217),
  },
  [1436] = {
    [sym_file_descriptor] = ACTIONS(2905),
    [sym__concat] = ACTIONS(2905),
    [sym_variable_name] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [anon_sym_PIPE_AMP] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2907),
    [anon_sym_GT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2905),
    [anon_sym_AMP_GT] = ACTIONS(2907),
    [anon_sym_AMP_GT_GT] = ACTIONS(2905),
    [anon_sym_LT_AMP] = ACTIONS(2905),
    [anon_sym_GT_AMP] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [1437] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4219),
  },
  [1438] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4221),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1439] = {
    [sym_file_descriptor] = ACTIONS(2913),
    [sym__concat] = ACTIONS(2913),
    [sym_variable_name] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [anon_sym_PIPE_AMP] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_AMP_GT] = ACTIONS(2915),
    [anon_sym_AMP_GT_GT] = ACTIONS(2913),
    [anon_sym_LT_AMP] = ACTIONS(2913),
    [anon_sym_GT_AMP] = ACTIONS(2913),
    [sym__special_characters] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [1440] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4223),
  },
  [1441] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4225),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1442] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4227),
  },
  [1443] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1444] = {
    [sym_concatenation] = STATE(1860),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1860),
    [anon_sym_RBRACE] = ACTIONS(4229),
    [anon_sym_EQ] = ACTIONS(4231),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4231),
    [anon_sym_COLON_QMARK] = ACTIONS(4231),
    [anon_sym_COLON_DASH] = ACTIONS(4231),
    [anon_sym_PERCENT] = ACTIONS(4231),
    [anon_sym_DASH] = ACTIONS(4231),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1445] = {
    [sym_file_descriptor] = ACTIONS(2985),
    [sym__concat] = ACTIONS(2985),
    [sym_variable_name] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [anon_sym_PIPE_AMP] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_GT] = ACTIONS(2987),
    [anon_sym_AMP_GT_GT] = ACTIONS(2985),
    [anon_sym_LT_AMP] = ACTIONS(2985),
    [anon_sym_GT_AMP] = ACTIONS(2985),
    [sym__special_characters] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2987),
  },
  [1446] = {
    [sym_concatenation] = STATE(1862),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1862),
    [anon_sym_RBRACE] = ACTIONS(4235),
    [anon_sym_EQ] = ACTIONS(4237),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4237),
    [anon_sym_COLON_QMARK] = ACTIONS(4237),
    [anon_sym_COLON_DASH] = ACTIONS(4237),
    [anon_sym_PERCENT] = ACTIONS(4237),
    [anon_sym_DASH] = ACTIONS(4237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1447] = {
    [sym_file_descriptor] = ACTIONS(3030),
    [sym__concat] = ACTIONS(3030),
    [sym_variable_name] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_PIPE_AMP] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_AMP_GT] = ACTIONS(3032),
    [anon_sym_AMP_GT_GT] = ACTIONS(3030),
    [anon_sym_LT_AMP] = ACTIONS(3030),
    [anon_sym_GT_AMP] = ACTIONS(3030),
    [sym__special_characters] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
  },
  [1448] = {
    [sym_concatenation] = STATE(1864),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1864),
    [anon_sym_RBRACE] = ACTIONS(4241),
    [anon_sym_EQ] = ACTIONS(4243),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4245),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4243),
    [anon_sym_COLON_QMARK] = ACTIONS(4243),
    [anon_sym_COLON_DASH] = ACTIONS(4243),
    [anon_sym_PERCENT] = ACTIONS(4243),
    [anon_sym_DASH] = ACTIONS(4243),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1449] = {
    [sym_file_descriptor] = ACTIONS(3040),
    [sym__concat] = ACTIONS(3040),
    [sym_variable_name] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE_AMP] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_AMP_GT] = ACTIONS(3042),
    [anon_sym_AMP_GT_GT] = ACTIONS(3040),
    [anon_sym_LT_AMP] = ACTIONS(3040),
    [anon_sym_GT_AMP] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
  },
  [1450] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1451] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(4247),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1452] = {
    [sym_file_descriptor] = ACTIONS(3078),
    [sym__concat] = ACTIONS(3078),
    [sym_variable_name] = ACTIONS(3078),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3078),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3078),
    [anon_sym_AMP_GT] = ACTIONS(3080),
    [anon_sym_AMP_GT_GT] = ACTIONS(3078),
    [anon_sym_LT_AMP] = ACTIONS(3078),
    [anon_sym_GT_AMP] = ACTIONS(3078),
    [sym__special_characters] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
  },
  [1453] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4249),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1454] = {
    [sym__terminated_statement] = STATE(1868),
    [sym_for_statement] = STATE(619),
    [sym_c_style_for_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_case_statement] = STATE(619),
    [sym_function_definition] = STATE(619),
    [sym_subshell] = STATE(619),
    [sym_pipeline] = STATE(619),
    [sym_list] = STATE(619),
    [sym_negated_command] = STATE(619),
    [sym_test_command] = STATE(619),
    [sym_declaration_command] = STATE(619),
    [sym_unset_command] = STATE(619),
    [sym_command] = STATE(619),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(620),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1868),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(4251),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1455] = {
    [anon_sym_esac] = ACTIONS(4253),
    [anon_sym_PIPE] = ACTIONS(4255),
    [anon_sym_RPAREN] = ACTIONS(4253),
    [anon_sym_SEMI_SEMI] = ACTIONS(4253),
    [anon_sym_PIPE_AMP] = ACTIONS(4253),
    [anon_sym_AMP_AMP] = ACTIONS(4253),
    [anon_sym_PIPE_PIPE] = ACTIONS(4253),
    [anon_sym_BQUOTE] = ACTIONS(4253),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4255),
    [anon_sym_LF] = ACTIONS(4253),
    [anon_sym_AMP] = ACTIONS(4255),
  },
  [1456] = {
    [anon_sym_RPAREN] = ACTIONS(4257),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_EQ_TILDE] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1249),
    [anon_sym_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1247),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1247),
  },
  [1457] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_PIPE_PIPE] = ACTIONS(3320),
    [anon_sym_EQ_TILDE] = ACTIONS(3322),
    [anon_sym_EQ_EQ] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_GT] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3320),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3320),
  },
  [1458] = {
    [sym_string] = STATE(1870),
    [sym_simple_expansion] = STATE(1870),
    [sym_string_expansion] = STATE(1870),
    [sym_expansion] = STATE(1870),
    [sym_command_substitution] = STATE(1870),
    [sym_process_substitution] = STATE(1870),
    [sym__special_characters] = ACTIONS(4259),
    [anon_sym_DQUOTE] = ACTIONS(2116),
    [anon_sym_DOLLAR] = ACTIONS(2118),
    [sym_raw_string] = ACTIONS(4259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2124),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [anon_sym_LT_LPAREN] = ACTIONS(2128),
    [anon_sym_GT_LPAREN] = ACTIONS(2128),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4259),
  },
  [1459] = {
    [aux_sym_concatenation_repeat1] = STATE(1871),
    [sym__concat] = ACTIONS(3294),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_EQ] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_BANG_EQ] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(695),
  },
  [1460] = {
    [sym__concat] = ACTIONS(699),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_EQ_TILDE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_EQ] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(699),
  },
  [1461] = {
    [anon_sym_DQUOTE] = ACTIONS(4261),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [1462] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(4261),
    [anon_sym_DOLLAR] = ACTIONS(4263),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [1463] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(731),
  },
  [1464] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(735),
  },
  [1465] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_EQ_TILDE] = ACTIONS(739),
    [anon_sym_EQ_EQ] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(739),
    [anon_sym_BANG_EQ] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(739),
  },
  [1466] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(4265),
    [sym_comment] = ACTIONS(53),
  },
  [1467] = {
    [sym_subscript] = STATE(1878),
    [sym_variable_name] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [anon_sym_DASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4271),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_AT] = ACTIONS(4269),
    [anon_sym_QMARK] = ACTIONS(4269),
    [anon_sym_0] = ACTIONS(4273),
    [anon_sym__] = ACTIONS(4273),
  },
  [1468] = {
    [sym_concatenation] = STATE(1881),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1881),
    [anon_sym_RBRACE] = ACTIONS(4275),
    [anon_sym_EQ] = ACTIONS(4277),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4279),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4281),
    [anon_sym_COLON] = ACTIONS(4277),
    [anon_sym_COLON_QMARK] = ACTIONS(4277),
    [anon_sym_COLON_DASH] = ACTIONS(4277),
    [anon_sym_PERCENT] = ACTIONS(4277),
    [anon_sym_DASH] = ACTIONS(4277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1469] = {
    [sym_concatenation] = STATE(1884),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1884),
    [anon_sym_RBRACE] = ACTIONS(4283),
    [anon_sym_EQ] = ACTIONS(4285),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_COLON] = ACTIONS(4285),
    [anon_sym_COLON_QMARK] = ACTIONS(4285),
    [anon_sym_COLON_DASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1470] = {
    [sym_concatenation] = STATE(1887),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1887),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_EQ] = ACTIONS(4293),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4297),
    [anon_sym_COLON] = ACTIONS(4293),
    [anon_sym_COLON_QMARK] = ACTIONS(4293),
    [anon_sym_COLON_DASH] = ACTIONS(4293),
    [anon_sym_PERCENT] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1471] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4299),
    [anon_sym_SEMI_SEMI] = ACTIONS(4301),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4303),
    [anon_sym_LF] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4303),
  },
  [1472] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4299),
    [anon_sym_SEMI_SEMI] = ACTIONS(4301),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4303),
    [anon_sym_LF] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4303),
  },
  [1473] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1890),
    [sym_c_style_for_statement] = STATE(1890),
    [sym_while_statement] = STATE(1890),
    [sym_if_statement] = STATE(1890),
    [sym_case_statement] = STATE(1890),
    [sym_function_definition] = STATE(1890),
    [sym_subshell] = STATE(1890),
    [sym_pipeline] = STATE(1890),
    [sym_list] = STATE(1890),
    [sym_negated_command] = STATE(1890),
    [sym_test_command] = STATE(1890),
    [sym_declaration_command] = STATE(1890),
    [sym_unset_command] = STATE(1890),
    [sym_command] = STATE(1890),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1891),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1474] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4305),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(4299),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4307),
    [anon_sym_LF] = ACTIONS(4305),
    [anon_sym_AMP] = ACTIONS(4307),
  },
  [1475] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4305),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(4299),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4307),
    [anon_sym_LF] = ACTIONS(4305),
    [anon_sym_AMP] = ACTIONS(4307),
  },
  [1476] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1893),
    [sym_c_style_for_statement] = STATE(1893),
    [sym_while_statement] = STATE(1893),
    [sym_if_statement] = STATE(1893),
    [sym_case_statement] = STATE(1893),
    [sym_function_definition] = STATE(1893),
    [sym_subshell] = STATE(1893),
    [sym_pipeline] = STATE(1893),
    [sym_list] = STATE(1893),
    [sym_negated_command] = STATE(1893),
    [sym_test_command] = STATE(1893),
    [sym_declaration_command] = STATE(1893),
    [sym_unset_command] = STATE(1893),
    [sym_command] = STATE(1893),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(1894),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [1477] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4309),
    [anon_sym_SEMI_SEMI] = ACTIONS(4311),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4313),
    [anon_sym_LF] = ACTIONS(4311),
    [anon_sym_AMP] = ACTIONS(4313),
  },
  [1478] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4309),
    [anon_sym_SEMI_SEMI] = ACTIONS(4311),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4313),
    [anon_sym_LF] = ACTIONS(4311),
    [anon_sym_AMP] = ACTIONS(4313),
  },
  [1479] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(1897),
    [sym_c_style_for_statement] = STATE(1897),
    [sym_while_statement] = STATE(1897),
    [sym_if_statement] = STATE(1897),
    [sym_case_statement] = STATE(1897),
    [sym_function_definition] = STATE(1897),
    [sym_subshell] = STATE(1897),
    [sym_pipeline] = STATE(1897),
    [sym_list] = STATE(1897),
    [sym_negated_command] = STATE(1897),
    [sym_test_command] = STATE(1897),
    [sym_declaration_command] = STATE(1897),
    [sym_unset_command] = STATE(1897),
    [sym_command] = STATE(1897),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(1898),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1480] = {
    [sym_do_group] = STATE(1899),
    [sym_compound_statement] = STATE(1899),
    [anon_sym_do] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [sym_comment] = ACTIONS(53),
  },
  [1481] = {
    [sym__expression] = STATE(1900),
    [sym_binary_expression] = STATE(1900),
    [sym_unary_expression] = STATE(1900),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_concatenation] = STATE(1900),
    [sym_string] = STATE(996),
    [sym_simple_expansion] = STATE(996),
    [sym_string_expansion] = STATE(996),
    [sym_expansion] = STATE(996),
    [sym_command_substitution] = STATE(996),
    [sym_process_substitution] = STATE(996),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_BANG] = ACTIONS(2112),
    [sym__special_characters] = ACTIONS(2114),
    [anon_sym_DQUOTE] = ACTIONS(2116),
    [anon_sym_DOLLAR] = ACTIONS(2118),
    [sym_raw_string] = ACTIONS(2120),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2124),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [anon_sym_LT_LPAREN] = ACTIONS(2128),
    [anon_sym_GT_LPAREN] = ACTIONS(2128),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2130),
    [sym_test_operator] = ACTIONS(2132),
  },
  [1482] = {
    [sym__expression] = STATE(1900),
    [sym_binary_expression] = STATE(1900),
    [sym_unary_expression] = STATE(1900),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_concatenation] = STATE(1900),
    [sym_string] = STATE(996),
    [sym_simple_expansion] = STATE(996),
    [sym_string_expansion] = STATE(996),
    [sym_expansion] = STATE(996),
    [sym_command_substitution] = STATE(996),
    [sym_process_substitution] = STATE(996),
    [anon_sym_LPAREN] = ACTIONS(4315),
    [anon_sym_BANG] = ACTIONS(2112),
    [sym__special_characters] = ACTIONS(4317),
    [anon_sym_DQUOTE] = ACTIONS(4319),
    [anon_sym_DOLLAR] = ACTIONS(2118),
    [sym_raw_string] = ACTIONS(2130),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4323),
    [anon_sym_BQUOTE] = ACTIONS(4325),
    [anon_sym_LT_LPAREN] = ACTIONS(4327),
    [anon_sym_GT_LPAREN] = ACTIONS(4327),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(2130),
    [sym_test_operator] = ACTIONS(2112),
    [sym_regex] = ACTIONS(4329),
  },
  [1483] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_PIPE_PIPE] = ACTIONS(3320),
    [anon_sym_EQ_TILDE] = ACTIONS(3322),
    [anon_sym_EQ_EQ] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_GT] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3320),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3320),
  },
  [1484] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_EQ_TILDE] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [1485] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_esac] = ACTIONS(2869),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [anon_sym_PIPE_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [anon_sym_EQ_TILDE] = ACTIONS(2869),
    [anon_sym_EQ_EQ] = ACTIONS(2869),
    [anon_sym_EQ] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_GT] = ACTIONS(2869),
    [anon_sym_BANG_EQ] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [1486] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4333),
    [sym_comment] = ACTIONS(53),
  },
  [1487] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4335),
    [sym_comment] = ACTIONS(53),
  },
  [1488] = {
    [anon_sym_RBRACE] = ACTIONS(4335),
    [sym_comment] = ACTIONS(53),
  },
  [1489] = {
    [sym_concatenation] = STATE(1907),
    [sym_string] = STATE(1906),
    [sym_simple_expansion] = STATE(1906),
    [sym_string_expansion] = STATE(1906),
    [sym_expansion] = STATE(1906),
    [sym_command_substitution] = STATE(1906),
    [sym_process_substitution] = STATE(1906),
    [anon_sym_RBRACE] = ACTIONS(4335),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4339),
  },
  [1490] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_esac] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [anon_sym_PIPE_AMP] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2905),
    [anon_sym_EQ_EQ] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2905),
    [anon_sym_BANG_EQ] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [1491] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4341),
  },
  [1492] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4343),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1493] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_esac] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [anon_sym_PIPE_AMP] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [1494] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4345),
  },
  [1495] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4347),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1496] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4349),
  },
  [1497] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4335),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1498] = {
    [sym_concatenation] = STATE(1914),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1914),
    [anon_sym_RBRACE] = ACTIONS(4351),
    [anon_sym_EQ] = ACTIONS(4353),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4353),
    [anon_sym_COLON_QMARK] = ACTIONS(4353),
    [anon_sym_COLON_DASH] = ACTIONS(4353),
    [anon_sym_PERCENT] = ACTIONS(4353),
    [anon_sym_DASH] = ACTIONS(4353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1499] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_esac] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [anon_sym_PIPE_AMP] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_EQ_TILDE] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2987),
  },
  [1500] = {
    [sym_concatenation] = STATE(1916),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1916),
    [anon_sym_RBRACE] = ACTIONS(4357),
    [anon_sym_EQ] = ACTIONS(4359),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4359),
    [anon_sym_COLON_QMARK] = ACTIONS(4359),
    [anon_sym_COLON_DASH] = ACTIONS(4359),
    [anon_sym_PERCENT] = ACTIONS(4359),
    [anon_sym_DASH] = ACTIONS(4359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1501] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_esac] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_PIPE_AMP] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3030),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_GT] = ACTIONS(3030),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
  },
  [1502] = {
    [sym_concatenation] = STATE(1918),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1918),
    [anon_sym_RBRACE] = ACTIONS(4363),
    [anon_sym_EQ] = ACTIONS(4365),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4365),
    [anon_sym_COLON_QMARK] = ACTIONS(4365),
    [anon_sym_COLON_DASH] = ACTIONS(4365),
    [anon_sym_PERCENT] = ACTIONS(4365),
    [anon_sym_DASH] = ACTIONS(4365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1503] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_esac] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE_AMP] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_EQ_TILDE] = ACTIONS(3040),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3040),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
  },
  [1504] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4369),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1505] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(4369),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1506] = {
    [sym__concat] = ACTIONS(3078),
    [anon_sym_esac] = ACTIONS(3078),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [anon_sym_EQ_TILDE] = ACTIONS(3078),
    [anon_sym_EQ_EQ] = ACTIONS(3078),
    [anon_sym_EQ] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3078),
    [anon_sym_GT] = ACTIONS(3078),
    [anon_sym_BANG_EQ] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
  },
  [1507] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4371),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1508] = {
    [sym__expression] = STATE(1921),
    [sym_binary_expression] = STATE(1921),
    [sym_unary_expression] = STATE(1921),
    [sym_parenthesized_expression] = STATE(1921),
    [sym_concatenation] = STATE(1921),
    [sym_string] = STATE(996),
    [sym_simple_expansion] = STATE(996),
    [sym_string_expansion] = STATE(996),
    [sym_expansion] = STATE(996),
    [sym_command_substitution] = STATE(996),
    [sym_process_substitution] = STATE(996),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4331),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_BANG] = ACTIONS(2112),
    [sym__special_characters] = ACTIONS(2114),
    [anon_sym_DQUOTE] = ACTIONS(2116),
    [anon_sym_DOLLAR] = ACTIONS(2118),
    [sym_raw_string] = ACTIONS(2120),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2124),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [anon_sym_LT_LPAREN] = ACTIONS(2128),
    [anon_sym_GT_LPAREN] = ACTIONS(2128),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2130),
    [sym_test_operator] = ACTIONS(2132),
  },
  [1509] = {
    [sym__concat] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1664),
  },
  [1510] = {
    [aux_sym_concatenation_repeat1] = STATE(1510),
    [sym__concat] = ACTIONS(4373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1664),
  },
  [1511] = {
    [sym__concat] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
  },
  [1512] = {
    [anon_sym_DQUOTE] = ACTIONS(4376),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [1513] = {
    [sym_concatenation] = STATE(1926),
    [sym_string] = STATE(1925),
    [sym_simple_expansion] = STATE(1925),
    [sym_string_expansion] = STATE(1925),
    [sym_expansion] = STATE(1925),
    [sym_command_substitution] = STATE(1925),
    [sym_process_substitution] = STATE(1925),
    [anon_sym_RBRACE] = ACTIONS(4378),
    [sym__special_characters] = ACTIONS(4380),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(4382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4382),
  },
  [1514] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(4384),
    [sym_comment] = ACTIONS(53),
  },
  [1515] = {
    [sym_concatenation] = STATE(1930),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1930),
    [anon_sym_RBRACE] = ACTIONS(4386),
    [anon_sym_EQ] = ACTIONS(4388),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_COLON] = ACTIONS(4388),
    [anon_sym_COLON_QMARK] = ACTIONS(4388),
    [anon_sym_COLON_DASH] = ACTIONS(4388),
    [anon_sym_PERCENT] = ACTIONS(4388),
    [anon_sym_DASH] = ACTIONS(4388),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1516] = {
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1933),
    [anon_sym_RBRACE] = ACTIONS(4394),
    [anon_sym_EQ] = ACTIONS(4396),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4400),
    [anon_sym_COLON] = ACTIONS(4396),
    [anon_sym_COLON_QMARK] = ACTIONS(4396),
    [anon_sym_COLON_DASH] = ACTIONS(4396),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_DASH] = ACTIONS(4396),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1517] = {
    [sym_concatenation] = STATE(1935),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1935),
    [anon_sym_RBRACE] = ACTIONS(4378),
    [anon_sym_EQ] = ACTIONS(4402),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4404),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_COLON] = ACTIONS(4402),
    [anon_sym_COLON_QMARK] = ACTIONS(4402),
    [anon_sym_COLON_DASH] = ACTIONS(4402),
    [anon_sym_PERCENT] = ACTIONS(4402),
    [anon_sym_DASH] = ACTIONS(4402),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1518] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1788),
  },
  [1519] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4408),
  },
  [1520] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1521] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1832),
  },
  [1522] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4412),
  },
  [1523] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4414),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1524] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1840),
  },
  [1525] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4416),
  },
  [1526] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4378),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1527] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1846),
  },
  [1528] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4418),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1529] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4418),
    [anon_sym_SEMI_SEMI] = ACTIONS(4420),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4422),
    [anon_sym_LF] = ACTIONS(4420),
    [anon_sym_AMP] = ACTIONS(4422),
  },
  [1530] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4418),
    [anon_sym_SEMI_SEMI] = ACTIONS(4420),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4422),
    [anon_sym_LF] = ACTIONS(4420),
    [anon_sym_AMP] = ACTIONS(4422),
  },
  [1531] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(4418),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1532] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4424),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(4418),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_LF] = ACTIONS(4424),
    [anon_sym_AMP] = ACTIONS(4426),
  },
  [1533] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4424),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(4418),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_LF] = ACTIONS(4424),
    [anon_sym_AMP] = ACTIONS(4426),
  },
  [1534] = {
    [sym__concat] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [1535] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1536] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_SEMI_SEMI] = ACTIONS(4430),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4432),
    [anon_sym_LF] = ACTIONS(4430),
    [anon_sym_AMP] = ACTIONS(4432),
  },
  [1537] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_SEMI_SEMI] = ACTIONS(4430),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4432),
    [anon_sym_LF] = ACTIONS(4430),
    [anon_sym_AMP] = ACTIONS(4432),
  },
  [1538] = {
    [anon_sym_esac] = ACTIONS(4434),
    [anon_sym_PIPE] = ACTIONS(4436),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_SEMI_SEMI] = ACTIONS(4434),
    [anon_sym_PIPE_AMP] = ACTIONS(4434),
    [anon_sym_AMP_AMP] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE] = ACTIONS(4434),
    [anon_sym_BQUOTE] = ACTIONS(4434),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4436),
    [anon_sym_LF] = ACTIONS(4434),
    [anon_sym_AMP] = ACTIONS(4436),
  },
  [1539] = {
    [anon_sym_esac] = ACTIONS(3478),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_RPAREN] = ACTIONS(3478),
    [anon_sym_SEMI_SEMI] = ACTIONS(3478),
    [anon_sym_PIPE_AMP] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_PIPE_PIPE] = ACTIONS(3478),
    [anon_sym_BQUOTE] = ACTIONS(3478),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym_LF] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
  },
  [1540] = {
    [sym__terminated_statement] = STATE(1946),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1946),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(4438),
    [anon_sym_elif] = ACTIONS(4438),
    [anon_sym_else] = ACTIONS(4438),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1541] = {
    [sym__terminated_statement] = STATE(1541),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1541),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(891),
    [sym_variable_name] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_fi] = ACTIONS(3482),
    [anon_sym_case] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(923),
    [anon_sym_declare] = ACTIONS(926),
    [anon_sym_typeset] = ACTIONS(926),
    [anon_sym_export] = ACTIONS(926),
    [anon_sym_readonly] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym_unset] = ACTIONS(929),
    [anon_sym_unsetenv] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [sym_raw_string] = ACTIONS(947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [anon_sym_LT_LPAREN] = ACTIONS(959),
    [anon_sym_GT_LPAREN] = ACTIONS(959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(962),
  },
  [1542] = {
    [anon_sym_esac] = ACTIONS(4440),
    [anon_sym_PIPE] = ACTIONS(4442),
    [anon_sym_RPAREN] = ACTIONS(4440),
    [anon_sym_SEMI_SEMI] = ACTIONS(4440),
    [anon_sym_PIPE_AMP] = ACTIONS(4440),
    [anon_sym_AMP_AMP] = ACTIONS(4440),
    [anon_sym_PIPE_PIPE] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4440),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4442),
    [anon_sym_LF] = ACTIONS(4440),
    [anon_sym_AMP] = ACTIONS(4442),
  },
  [1543] = {
    [anon_sym_fi] = ACTIONS(4444),
    [sym_comment] = ACTIONS(53),
  },
  [1544] = {
    [sym_concatenation] = STATE(1950),
    [sym_string] = STATE(1949),
    [sym_simple_expansion] = STATE(1949),
    [sym_string_expansion] = STATE(1949),
    [sym_expansion] = STATE(1949),
    [sym_command_substitution] = STATE(1949),
    [sym_process_substitution] = STATE(1949),
    [sym__special_characters] = ACTIONS(4446),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(4448),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4448),
  },
  [1545] = {
    [sym__terminated_statement] = STATE(1974),
    [sym_for_statement] = STATE(1969),
    [sym_c_style_for_statement] = STATE(1969),
    [sym_while_statement] = STATE(1969),
    [sym_if_statement] = STATE(1969),
    [sym_case_statement] = STATE(1969),
    [sym_function_definition] = STATE(1969),
    [sym_subshell] = STATE(1969),
    [sym_pipeline] = STATE(1969),
    [sym_list] = STATE(1969),
    [sym_negated_command] = STATE(1969),
    [sym_test_command] = STATE(1969),
    [sym_declaration_command] = STATE(1969),
    [sym_unset_command] = STATE(1969),
    [sym_command] = STATE(1969),
    [sym_command_name] = STATE(1970),
    [sym_variable_assignment] = STATE(1971),
    [sym_subscript] = STATE(1972),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_program_repeat1] = STATE(1974),
    [aux_sym_command_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4450),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4452),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4454),
    [anon_sym_SEMI_SEMI] = ACTIONS(4456),
    [anon_sym_function] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4464),
    [anon_sym_declare] = ACTIONS(4466),
    [anon_sym_typeset] = ACTIONS(4466),
    [anon_sym_export] = ACTIONS(4466),
    [anon_sym_readonly] = ACTIONS(4466),
    [anon_sym_local] = ACTIONS(4466),
    [anon_sym_unset] = ACTIONS(4468),
    [anon_sym_unsetenv] = ACTIONS(4468),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4470),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4486),
  },
  [1546] = {
    [aux_sym_case_item_repeat1] = STATE(1977),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(4488),
    [sym_comment] = ACTIONS(53),
  },
  [1547] = {
    [aux_sym_concatenation_repeat1] = STATE(1978),
    [sym__concat] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
  },
  [1548] = {
    [sym__terminated_statement] = STATE(1982),
    [sym_for_statement] = STATE(1980),
    [sym_c_style_for_statement] = STATE(1980),
    [sym_while_statement] = STATE(1980),
    [sym_if_statement] = STATE(1980),
    [sym_case_statement] = STATE(1980),
    [sym_function_definition] = STATE(1980),
    [sym_subshell] = STATE(1980),
    [sym_pipeline] = STATE(1980),
    [sym_list] = STATE(1980),
    [sym_negated_command] = STATE(1980),
    [sym_test_command] = STATE(1980),
    [sym_declaration_command] = STATE(1980),
    [sym_unset_command] = STATE(1980),
    [sym_command] = STATE(1980),
    [sym_command_name] = STATE(1970),
    [sym_variable_assignment] = STATE(1981),
    [sym_subscript] = STATE(1972),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_program_repeat1] = STATE(1982),
    [aux_sym_command_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4450),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4452),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4490),
    [anon_sym_SEMI_SEMI] = ACTIONS(4492),
    [anon_sym_function] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4464),
    [anon_sym_declare] = ACTIONS(4466),
    [anon_sym_typeset] = ACTIONS(4466),
    [anon_sym_export] = ACTIONS(4466),
    [anon_sym_readonly] = ACTIONS(4466),
    [anon_sym_local] = ACTIONS(4466),
    [anon_sym_unset] = ACTIONS(4468),
    [anon_sym_unsetenv] = ACTIONS(4468),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4470),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4486),
  },
  [1549] = {
    [aux_sym_case_item_repeat1] = STATE(1977),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(4494),
    [sym_comment] = ACTIONS(53),
  },
  [1550] = {
    [anon_sym_esac] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4498),
    [anon_sym_RPAREN] = ACTIONS(4496),
    [anon_sym_SEMI_SEMI] = ACTIONS(4496),
    [anon_sym_PIPE_AMP] = ACTIONS(4496),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4498),
    [anon_sym_LF] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4498),
  },
  [1551] = {
    [anon_sym_esac] = ACTIONS(4500),
    [sym_comment] = ACTIONS(53),
  },
  [1552] = {
    [sym_case_item] = STATE(1552),
    [sym_concatenation] = STATE(1987),
    [sym_string] = STATE(1986),
    [sym_simple_expansion] = STATE(1986),
    [sym_string_expansion] = STATE(1986),
    [sym_expansion] = STATE(1986),
    [sym_command_substitution] = STATE(1986),
    [sym_process_substitution] = STATE(1986),
    [aux_sym_case_statement_repeat1] = STATE(1552),
    [sym__special_characters] = ACTIONS(4502),
    [anon_sym_DQUOTE] = ACTIONS(4505),
    [anon_sym_DOLLAR] = ACTIONS(4508),
    [sym_raw_string] = ACTIONS(4511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4517),
    [anon_sym_BQUOTE] = ACTIONS(4520),
    [anon_sym_LT_LPAREN] = ACTIONS(4523),
    [anon_sym_GT_LPAREN] = ACTIONS(4523),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4511),
  },
  [1553] = {
    [anon_sym_esac] = ACTIONS(4526),
    [anon_sym_PIPE] = ACTIONS(4528),
    [anon_sym_RPAREN] = ACTIONS(4526),
    [anon_sym_SEMI_SEMI] = ACTIONS(4526),
    [anon_sym_PIPE_AMP] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_BQUOTE] = ACTIONS(4526),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4528),
    [anon_sym_LF] = ACTIONS(4526),
    [anon_sym_AMP] = ACTIONS(4528),
  },
  [1554] = {
    [sym_case_item] = STATE(1552),
    [sym_last_case_item] = STATE(1988),
    [sym_concatenation] = STATE(1076),
    [sym_string] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [sym_command_substitution] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [aux_sym_case_statement_repeat1] = STATE(1552),
    [sym__special_characters] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(2280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2280),
  },
  [1555] = {
    [anon_sym_esac] = ACTIONS(4530),
    [anon_sym_PIPE] = ACTIONS(4532),
    [anon_sym_RPAREN] = ACTIONS(4530),
    [anon_sym_SEMI_SEMI] = ACTIONS(4530),
    [anon_sym_PIPE_AMP] = ACTIONS(4530),
    [anon_sym_AMP_AMP] = ACTIONS(4530),
    [anon_sym_PIPE_PIPE] = ACTIONS(4530),
    [anon_sym_BQUOTE] = ACTIONS(4530),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4532),
    [anon_sym_LF] = ACTIONS(4530),
    [anon_sym_AMP] = ACTIONS(4532),
  },
  [1556] = {
    [anon_sym_esac] = ACTIONS(4534),
    [sym_comment] = ACTIONS(53),
  },
  [1557] = {
    [anon_sym_esac] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4538),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [anon_sym_SEMI_SEMI] = ACTIONS(4536),
    [anon_sym_PIPE_AMP] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_BQUOTE] = ACTIONS(4536),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4538),
    [anon_sym_LF] = ACTIONS(4536),
    [anon_sym_AMP] = ACTIONS(4538),
  },
  [1558] = {
    [sym_case_item] = STATE(1552),
    [sym_last_case_item] = STATE(1990),
    [sym_concatenation] = STATE(1076),
    [sym_string] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [sym_command_substitution] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [aux_sym_case_statement_repeat1] = STATE(1552),
    [sym__special_characters] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(2280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2280),
  },
  [1559] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_in] = ACTIONS(3903),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3903),
  },
  [1560] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_in] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [1561] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4540),
    [sym_comment] = ACTIONS(53),
  },
  [1562] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4542),
    [sym_comment] = ACTIONS(53),
  },
  [1563] = {
    [anon_sym_RBRACE] = ACTIONS(4542),
    [sym_comment] = ACTIONS(53),
  },
  [1564] = {
    [sym_concatenation] = STATE(1994),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1994),
    [anon_sym_RBRACE] = ACTIONS(4544),
    [anon_sym_EQ] = ACTIONS(4546),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4546),
    [anon_sym_COLON_QMARK] = ACTIONS(4546),
    [anon_sym_COLON_DASH] = ACTIONS(4546),
    [anon_sym_PERCENT] = ACTIONS(4546),
    [anon_sym_DASH] = ACTIONS(4546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1565] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_in] = ACTIONS(3975),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3975),
  },
  [1566] = {
    [sym_concatenation] = STATE(1996),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1996),
    [anon_sym_RBRACE] = ACTIONS(4550),
    [anon_sym_EQ] = ACTIONS(4552),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4552),
    [anon_sym_COLON_QMARK] = ACTIONS(4552),
    [anon_sym_COLON_DASH] = ACTIONS(4552),
    [anon_sym_PERCENT] = ACTIONS(4552),
    [anon_sym_DASH] = ACTIONS(4552),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1567] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_in] = ACTIONS(3985),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3985),
  },
  [1568] = {
    [sym_concatenation] = STATE(1998),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(1998),
    [anon_sym_RBRACE] = ACTIONS(4556),
    [anon_sym_EQ] = ACTIONS(4558),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4558),
    [anon_sym_COLON_QMARK] = ACTIONS(4558),
    [anon_sym_COLON_DASH] = ACTIONS(4558),
    [anon_sym_PERCENT] = ACTIONS(4558),
    [anon_sym_DASH] = ACTIONS(4558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1569] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_in] = ACTIONS(4040),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4040),
  },
  [1570] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4562),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1571] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_in] = ACTIONS(4062),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4062),
  },
  [1572] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4564),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1573] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_in] = ACTIONS(4068),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4068),
  },
  [1574] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1575] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
  },
  [1576] = {
    [sym__concat] = ACTIONS(4098),
    [anon_sym_in] = ACTIONS(4098),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4098),
  },
  [1577] = {
    [anon_sym_esac] = ACTIONS(4568),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [1578] = {
    [aux_sym_concatenation_repeat1] = STATE(1581),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [1579] = {
    [aux_sym_concatenation_repeat1] = STATE(1581),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [1580] = {
    [anon_sym_esac] = ACTIONS(985),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(985),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_BQUOTE] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [1581] = {
    [aux_sym_concatenation_repeat1] = STATE(2002),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [1582] = {
    [aux_sym_concatenation_repeat1] = STATE(1582),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(3231),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [1583] = {
    [sym_file_redirect] = STATE(1577),
    [sym_file_descriptor] = ACTIONS(2379),
    [anon_sym_PIPE] = ACTIONS(3565),
    [anon_sym_RPAREN] = ACTIONS(3567),
    [anon_sym_SEMI_SEMI] = ACTIONS(3567),
    [anon_sym_PIPE_AMP] = ACTIONS(3567),
    [anon_sym_AMP_AMP] = ACTIONS(3567),
    [anon_sym_PIPE_PIPE] = ACTIONS(3567),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_GT] = ACTIONS(2381),
    [anon_sym_GT_GT] = ACTIONS(2383),
    [anon_sym_AMP_GT] = ACTIONS(2381),
    [anon_sym_AMP_GT_GT] = ACTIONS(2383),
    [anon_sym_LT_AMP] = ACTIONS(2383),
    [anon_sym_GT_AMP] = ACTIONS(2383),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3565),
    [anon_sym_LF] = ACTIONS(3567),
    [anon_sym_AMP] = ACTIONS(3565),
  },
  [1584] = {
    [sym_concatenation] = STATE(1580),
    [sym_string] = STATE(2004),
    [sym_simple_expansion] = STATE(2004),
    [sym_string_expansion] = STATE(2004),
    [sym_expansion] = STATE(2004),
    [sym_command_substitution] = STATE(2004),
    [sym_process_substitution] = STATE(2004),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(4574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4574),
  },
  [1585] = {
    [aux_sym_concatenation_repeat1] = STATE(2005),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1586] = {
    [aux_sym_concatenation_repeat1] = STATE(2005),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [1587] = {
    [sym_concatenation] = STATE(1615),
    [sym_string] = STATE(2007),
    [sym_simple_expansion] = STATE(2007),
    [sym_string_expansion] = STATE(2007),
    [sym_expansion] = STATE(2007),
    [sym_command_substitution] = STATE(2007),
    [sym_process_substitution] = STATE(2007),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(4578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4578),
  },
  [1588] = {
    [aux_sym_concatenation_repeat1] = STATE(2008),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1589] = {
    [aux_sym_concatenation_repeat1] = STATE(2008),
    [sym_file_descriptor] = ACTIONS(679),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [1590] = {
    [aux_sym_concatenation_repeat1] = STATE(2008),
    [sym_file_descriptor] = ACTIONS(1936),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(1938),
    [anon_sym_RPAREN] = ACTIONS(1936),
    [anon_sym_SEMI_SEMI] = ACTIONS(1936),
    [anon_sym_PIPE_AMP] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1938),
    [anon_sym_GT] = ACTIONS(1938),
    [anon_sym_GT_GT] = ACTIONS(1936),
    [anon_sym_AMP_GT] = ACTIONS(1938),
    [anon_sym_AMP_GT_GT] = ACTIONS(1936),
    [anon_sym_LT_AMP] = ACTIONS(1936),
    [anon_sym_GT_AMP] = ACTIONS(1936),
    [anon_sym_LT_LT] = ACTIONS(1938),
    [anon_sym_LT_LT_DASH] = ACTIONS(1936),
    [anon_sym_LT_LT_LT] = ACTIONS(1936),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_LF] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1938),
  },
  [1591] = {
    [aux_sym_concatenation_repeat1] = STATE(2008),
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [1592] = {
    [sym_file_redirect] = STATE(1592),
    [sym_heredoc_redirect] = STATE(1592),
    [sym_herestring_redirect] = STATE(1592),
    [aux_sym_while_statement_repeat1] = STATE(1592),
    [sym_file_descriptor] = ACTIONS(4580),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [anon_sym_SEMI_SEMI] = ACTIONS(1948),
    [anon_sym_PIPE_AMP] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_PIPE_PIPE] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_GT] = ACTIONS(4583),
    [anon_sym_GT_GT] = ACTIONS(4586),
    [anon_sym_AMP_GT] = ACTIONS(4583),
    [anon_sym_AMP_GT_GT] = ACTIONS(4586),
    [anon_sym_LT_AMP] = ACTIONS(4586),
    [anon_sym_GT_AMP] = ACTIONS(4586),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_LT_LT_DASH] = ACTIONS(3683),
    [anon_sym_LT_LT_LT] = ACTIONS(4589),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_LF] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1953),
  },
  [1593] = {
    [aux_sym_concatenation_repeat1] = STATE(1593),
    [sym__simple_heredoc_body] = ACTIONS(1664),
    [sym__heredoc_body_beginning] = ACTIONS(1664),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1668),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [1594] = {
    [sym_file_descriptor] = ACTIONS(3201),
    [sym_variable_name] = ACTIONS(3201),
    [anon_sym_LT] = ACTIONS(3203),
    [anon_sym_GT] = ACTIONS(3203),
    [anon_sym_GT_GT] = ACTIONS(3201),
    [anon_sym_AMP_GT] = ACTIONS(3203),
    [anon_sym_AMP_GT_GT] = ACTIONS(3201),
    [anon_sym_LT_AMP] = ACTIONS(3201),
    [anon_sym_GT_AMP] = ACTIONS(3201),
    [sym__special_characters] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3201),
    [anon_sym_DOLLAR] = ACTIONS(3203),
    [sym_raw_string] = ACTIONS(3201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3201),
    [anon_sym_BQUOTE] = ACTIONS(3201),
    [anon_sym_LT_LPAREN] = ACTIONS(3201),
    [anon_sym_GT_LPAREN] = ACTIONS(3201),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3201),
  },
  [1595] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_RBRACK] = ACTIONS(3903),
    [anon_sym_EQ_TILDE] = ACTIONS(3903),
    [anon_sym_EQ_EQ] = ACTIONS(3903),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3903),
    [anon_sym_GT] = ACTIONS(3903),
    [anon_sym_BANG_EQ] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3903),
  },
  [1596] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_RBRACK] = ACTIONS(3911),
    [anon_sym_EQ_TILDE] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_EQ] = ACTIONS(3913),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3911),
  },
  [1597] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4592),
    [sym_comment] = ACTIONS(53),
  },
  [1598] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4594),
    [sym_comment] = ACTIONS(53),
  },
  [1599] = {
    [anon_sym_RBRACE] = ACTIONS(4594),
    [sym_comment] = ACTIONS(53),
  },
  [1600] = {
    [sym_concatenation] = STATE(2012),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2012),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(4598),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4598),
    [anon_sym_COLON_QMARK] = ACTIONS(4598),
    [anon_sym_COLON_DASH] = ACTIONS(4598),
    [anon_sym_PERCENT] = ACTIONS(4598),
    [anon_sym_DASH] = ACTIONS(4598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1601] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_RBRACK] = ACTIONS(3975),
    [anon_sym_EQ_TILDE] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_EQ] = ACTIONS(3977),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3975),
  },
  [1602] = {
    [sym_concatenation] = STATE(2014),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2014),
    [anon_sym_RBRACE] = ACTIONS(4602),
    [anon_sym_EQ] = ACTIONS(4604),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4606),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COLON_QMARK] = ACTIONS(4604),
    [anon_sym_COLON_DASH] = ACTIONS(4604),
    [anon_sym_PERCENT] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1603] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_RBRACK] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3985),
    [anon_sym_GT] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3985),
  },
  [1604] = {
    [sym_concatenation] = STATE(2016),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2016),
    [anon_sym_RBRACE] = ACTIONS(4608),
    [anon_sym_EQ] = ACTIONS(4610),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4610),
    [anon_sym_COLON_QMARK] = ACTIONS(4610),
    [anon_sym_COLON_DASH] = ACTIONS(4610),
    [anon_sym_PERCENT] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4610),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1605] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_RBRACK] = ACTIONS(4040),
    [anon_sym_EQ_TILDE] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_EQ] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4040),
  },
  [1606] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4614),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1607] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_EQ_TILDE] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_GT] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4062),
  },
  [1608] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4616),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1609] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4068),
    [anon_sym_GT] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4068),
  },
  [1610] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4618),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1611] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_RBRACK] = ACTIONS(4074),
    [anon_sym_EQ_TILDE] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4074),
  },
  [1612] = {
    [sym__concat] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_RBRACK] = ACTIONS(4098),
    [anon_sym_EQ_TILDE] = ACTIONS(4098),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_EQ] = ACTIONS(4100),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_GT] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4098),
  },
  [1613] = {
    [aux_sym_concatenation_repeat1] = STATE(1617),
    [sym_file_descriptor] = ACTIONS(981),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(981),
    [anon_sym_LT_AMP] = ACTIONS(981),
    [anon_sym_GT_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(981),
    [anon_sym_LT_LT_LT] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [1614] = {
    [aux_sym_concatenation_repeat1] = STATE(1617),
    [sym_file_descriptor] = ACTIONS(985),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_DASH] = ACTIONS(985),
    [anon_sym_LT_LT_LT] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [1615] = {
    [sym_file_descriptor] = ACTIONS(985),
    [anon_sym_esac] = ACTIONS(985),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(985),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_DASH] = ACTIONS(985),
    [anon_sym_LT_LT_LT] = ACTIONS(985),
    [anon_sym_BQUOTE] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [1616] = {
    [sym_string] = STATE(2020),
    [sym_simple_expansion] = STATE(2020),
    [sym_string_expansion] = STATE(2020),
    [sym_expansion] = STATE(2020),
    [sym_command_substitution] = STATE(2020),
    [sym_process_substitution] = STATE(2020),
    [sym__special_characters] = ACTIONS(4620),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(4620),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4620),
  },
  [1617] = {
    [aux_sym_concatenation_repeat1] = STATE(2021),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [1618] = {
    [sym_file_descriptor] = ACTIONS(699),
    [sym__concat] = ACTIONS(699),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(701),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_LT_LT_DASH] = ACTIONS(699),
    [anon_sym_LT_LT_LT] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
  },
  [1619] = {
    [anon_sym_DQUOTE] = ACTIONS(4622),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [1620] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(4622),
    [anon_sym_DOLLAR] = ACTIONS(4624),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [1621] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [1622] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(735),
    [anon_sym_LT_LT_LT] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [1623] = {
    [sym_file_descriptor] = ACTIONS(739),
    [sym__concat] = ACTIONS(739),
    [anon_sym_esac] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_LT_LT_DASH] = ACTIONS(739),
    [anon_sym_LT_LT_LT] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [1624] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(4626),
    [sym_comment] = ACTIONS(53),
  },
  [1625] = {
    [sym_subscript] = STATE(2028),
    [sym_variable_name] = ACTIONS(4628),
    [anon_sym_DOLLAR] = ACTIONS(4630),
    [anon_sym_DASH] = ACTIONS(4630),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4632),
    [anon_sym_STAR] = ACTIONS(4630),
    [anon_sym_AT] = ACTIONS(4630),
    [anon_sym_QMARK] = ACTIONS(4630),
    [anon_sym_0] = ACTIONS(4634),
    [anon_sym__] = ACTIONS(4634),
  },
  [1626] = {
    [sym_concatenation] = STATE(2031),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2031),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_EQ] = ACTIONS(4638),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4642),
    [anon_sym_COLON] = ACTIONS(4638),
    [anon_sym_COLON_QMARK] = ACTIONS(4638),
    [anon_sym_COLON_DASH] = ACTIONS(4638),
    [anon_sym_PERCENT] = ACTIONS(4638),
    [anon_sym_DASH] = ACTIONS(4638),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1627] = {
    [sym_concatenation] = STATE(2034),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2034),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [anon_sym_EQ] = ACTIONS(4646),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4650),
    [anon_sym_COLON] = ACTIONS(4646),
    [anon_sym_COLON_QMARK] = ACTIONS(4646),
    [anon_sym_COLON_DASH] = ACTIONS(4646),
    [anon_sym_PERCENT] = ACTIONS(4646),
    [anon_sym_DASH] = ACTIONS(4646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1628] = {
    [sym_concatenation] = STATE(2037),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2037),
    [anon_sym_RBRACE] = ACTIONS(4652),
    [anon_sym_EQ] = ACTIONS(4654),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4658),
    [anon_sym_COLON] = ACTIONS(4654),
    [anon_sym_COLON_QMARK] = ACTIONS(4654),
    [anon_sym_COLON_DASH] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(4654),
    [anon_sym_DASH] = ACTIONS(4654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1629] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4660),
    [anon_sym_SEMI_SEMI] = ACTIONS(4662),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4664),
    [anon_sym_LF] = ACTIONS(4662),
    [anon_sym_AMP] = ACTIONS(4664),
  },
  [1630] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4660),
    [anon_sym_SEMI_SEMI] = ACTIONS(4662),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4664),
    [anon_sym_LF] = ACTIONS(4662),
    [anon_sym_AMP] = ACTIONS(4664),
  },
  [1631] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2040),
    [sym_c_style_for_statement] = STATE(2040),
    [sym_while_statement] = STATE(2040),
    [sym_if_statement] = STATE(2040),
    [sym_case_statement] = STATE(2040),
    [sym_function_definition] = STATE(2040),
    [sym_subshell] = STATE(2040),
    [sym_pipeline] = STATE(2040),
    [sym_list] = STATE(2040),
    [sym_negated_command] = STATE(2040),
    [sym_test_command] = STATE(2040),
    [sym_declaration_command] = STATE(2040),
    [sym_unset_command] = STATE(2040),
    [sym_command] = STATE(2040),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2041),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1632] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4666),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(4660),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4668),
    [anon_sym_LF] = ACTIONS(4666),
    [anon_sym_AMP] = ACTIONS(4668),
  },
  [1633] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4666),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(4660),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4668),
    [anon_sym_LF] = ACTIONS(4666),
    [anon_sym_AMP] = ACTIONS(4668),
  },
  [1634] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2043),
    [sym_c_style_for_statement] = STATE(2043),
    [sym_while_statement] = STATE(2043),
    [sym_if_statement] = STATE(2043),
    [sym_case_statement] = STATE(2043),
    [sym_function_definition] = STATE(2043),
    [sym_subshell] = STATE(2043),
    [sym_pipeline] = STATE(2043),
    [sym_list] = STATE(2043),
    [sym_negated_command] = STATE(2043),
    [sym_test_command] = STATE(2043),
    [sym_declaration_command] = STATE(2043),
    [sym_unset_command] = STATE(2043),
    [sym_command] = STATE(2043),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(2044),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [1635] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4670),
    [anon_sym_SEMI_SEMI] = ACTIONS(4672),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4674),
    [anon_sym_LF] = ACTIONS(4672),
    [anon_sym_AMP] = ACTIONS(4674),
  },
  [1636] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4670),
    [anon_sym_SEMI_SEMI] = ACTIONS(4672),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4674),
    [anon_sym_LF] = ACTIONS(4672),
    [anon_sym_AMP] = ACTIONS(4674),
  },
  [1637] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2047),
    [sym_c_style_for_statement] = STATE(2047),
    [sym_while_statement] = STATE(2047),
    [sym_if_statement] = STATE(2047),
    [sym_case_statement] = STATE(2047),
    [sym_function_definition] = STATE(2047),
    [sym_subshell] = STATE(2047),
    [sym_pipeline] = STATE(2047),
    [sym_list] = STATE(2047),
    [sym_negated_command] = STATE(2047),
    [sym_test_command] = STATE(2047),
    [sym_declaration_command] = STATE(2047),
    [sym_unset_command] = STATE(2047),
    [sym_command] = STATE(2047),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2048),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1638] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_RPAREN] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3903),
    [anon_sym_EQ_TILDE] = ACTIONS(3903),
    [anon_sym_EQ_EQ] = ACTIONS(3903),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3903),
    [anon_sym_GT] = ACTIONS(3903),
    [anon_sym_BANG_EQ] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3903),
  },
  [1639] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3911),
    [anon_sym_EQ_TILDE] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_EQ] = ACTIONS(3913),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3911),
  },
  [1640] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4676),
    [sym_comment] = ACTIONS(53),
  },
  [1641] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4678),
    [sym_comment] = ACTIONS(53),
  },
  [1642] = {
    [anon_sym_RBRACE] = ACTIONS(4678),
    [sym_comment] = ACTIONS(53),
  },
  [1643] = {
    [sym_concatenation] = STATE(2052),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2052),
    [anon_sym_RBRACE] = ACTIONS(4680),
    [anon_sym_EQ] = ACTIONS(4682),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4682),
    [anon_sym_COLON_QMARK] = ACTIONS(4682),
    [anon_sym_COLON_DASH] = ACTIONS(4682),
    [anon_sym_PERCENT] = ACTIONS(4682),
    [anon_sym_DASH] = ACTIONS(4682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1644] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3975),
    [anon_sym_EQ_TILDE] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_EQ] = ACTIONS(3977),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3975),
  },
  [1645] = {
    [sym_concatenation] = STATE(2054),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2054),
    [anon_sym_RBRACE] = ACTIONS(4686),
    [anon_sym_EQ] = ACTIONS(4688),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4688),
    [anon_sym_COLON_QMARK] = ACTIONS(4688),
    [anon_sym_COLON_DASH] = ACTIONS(4688),
    [anon_sym_PERCENT] = ACTIONS(4688),
    [anon_sym_DASH] = ACTIONS(4688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1646] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3985),
    [anon_sym_GT] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3985),
  },
  [1647] = {
    [sym_concatenation] = STATE(2056),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2056),
    [anon_sym_RBRACE] = ACTIONS(4692),
    [anon_sym_EQ] = ACTIONS(4694),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4694),
    [anon_sym_COLON_QMARK] = ACTIONS(4694),
    [anon_sym_COLON_DASH] = ACTIONS(4694),
    [anon_sym_PERCENT] = ACTIONS(4694),
    [anon_sym_DASH] = ACTIONS(4694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1648] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4040),
    [anon_sym_EQ_TILDE] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_EQ] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4040),
  },
  [1649] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4698),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1650] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4062),
    [anon_sym_EQ_TILDE] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_GT] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4062),
  },
  [1651] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1652] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4068),
    [anon_sym_GT] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4068),
  },
  [1653] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4702),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1654] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4074),
    [anon_sym_EQ_TILDE] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4074),
  },
  [1655] = {
    [sym__concat] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_RPAREN] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4098),
    [anon_sym_EQ_TILDE] = ACTIONS(4098),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_EQ] = ACTIONS(4100),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_GT] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4098),
  },
  [1656] = {
    [sym_variable_name] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_RPAREN] = ACTIONS(3201),
    [anon_sym_SEMI_SEMI] = ACTIONS(3201),
    [anon_sym_PIPE_AMP] = ACTIONS(3201),
    [anon_sym_AMP_AMP] = ACTIONS(3201),
    [anon_sym_PIPE_PIPE] = ACTIONS(3201),
    [sym__special_characters] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3201),
    [anon_sym_DOLLAR] = ACTIONS(3203),
    [sym_raw_string] = ACTIONS(3201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3201),
    [anon_sym_BQUOTE] = ACTIONS(3201),
    [anon_sym_LT_LPAREN] = ACTIONS(3201),
    [anon_sym_GT_LPAREN] = ACTIONS(3201),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3203),
    [sym_word] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3203),
    [anon_sym_LF] = ACTIONS(3201),
    [anon_sym_AMP] = ACTIONS(3203),
  },
  [1657] = {
    [sym__concat] = ACTIONS(3903),
    [sym_variable_name] = ACTIONS(3903),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_RPAREN] = ACTIONS(3903),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3905),
    [sym_word] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [1658] = {
    [sym__concat] = ACTIONS(3911),
    [sym_variable_name] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3913),
    [sym_word] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3913),
  },
  [1659] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4704),
    [sym_comment] = ACTIONS(53),
  },
  [1660] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4706),
    [sym_comment] = ACTIONS(53),
  },
  [1661] = {
    [anon_sym_RBRACE] = ACTIONS(4706),
    [sym_comment] = ACTIONS(53),
  },
  [1662] = {
    [sym_concatenation] = STATE(2063),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2063),
    [anon_sym_RBRACE] = ACTIONS(4708),
    [anon_sym_EQ] = ACTIONS(4710),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4710),
    [anon_sym_COLON_QMARK] = ACTIONS(4710),
    [anon_sym_COLON_DASH] = ACTIONS(4710),
    [anon_sym_PERCENT] = ACTIONS(4710),
    [anon_sym_DASH] = ACTIONS(4710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1663] = {
    [sym__concat] = ACTIONS(3975),
    [sym_variable_name] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3975),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [anon_sym_PIPE_AMP] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3977),
    [sym_word] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3977),
  },
  [1664] = {
    [sym_concatenation] = STATE(2065),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2065),
    [anon_sym_RBRACE] = ACTIONS(4714),
    [anon_sym_EQ] = ACTIONS(4716),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4718),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4716),
    [anon_sym_COLON_QMARK] = ACTIONS(4716),
    [anon_sym_COLON_DASH] = ACTIONS(4716),
    [anon_sym_PERCENT] = ACTIONS(4716),
    [anon_sym_DASH] = ACTIONS(4716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1665] = {
    [sym__concat] = ACTIONS(3985),
    [sym_variable_name] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3987),
    [sym_word] = ACTIONS(3987),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [1666] = {
    [sym_concatenation] = STATE(2067),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2067),
    [anon_sym_RBRACE] = ACTIONS(4720),
    [anon_sym_EQ] = ACTIONS(4722),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4722),
    [anon_sym_COLON_QMARK] = ACTIONS(4722),
    [anon_sym_COLON_DASH] = ACTIONS(4722),
    [anon_sym_PERCENT] = ACTIONS(4722),
    [anon_sym_DASH] = ACTIONS(4722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1667] = {
    [sym__concat] = ACTIONS(4040),
    [sym_variable_name] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [anon_sym_PIPE_AMP] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4042),
    [sym_word] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [1668] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4726),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1669] = {
    [sym__concat] = ACTIONS(4062),
    [sym_variable_name] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4064),
    [sym_word] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [1670] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4728),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1671] = {
    [sym__concat] = ACTIONS(4068),
    [sym_variable_name] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [anon_sym_PIPE_AMP] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4070),
    [sym_word] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [1672] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4730),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1673] = {
    [sym__concat] = ACTIONS(4074),
    [sym_variable_name] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4076),
    [sym_word] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [1674] = {
    [sym__concat] = ACTIONS(4098),
    [sym_variable_name] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_RPAREN] = ACTIONS(4098),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [anon_sym_PIPE_AMP] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [sym__special_characters] = ACTIONS(4098),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4100),
    [sym_word] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
  },
  [1675] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_RPAREN] = ACTIONS(3903),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3905),
    [sym_word] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [1676] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3913),
    [sym_word] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3913),
  },
  [1677] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4732),
    [sym_comment] = ACTIONS(53),
  },
  [1678] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4734),
    [sym_comment] = ACTIONS(53),
  },
  [1679] = {
    [anon_sym_RBRACE] = ACTIONS(4734),
    [sym_comment] = ACTIONS(53),
  },
  [1680] = {
    [sym_concatenation] = STATE(2074),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2074),
    [anon_sym_RBRACE] = ACTIONS(4736),
    [anon_sym_EQ] = ACTIONS(4738),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4740),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4738),
    [anon_sym_COLON_QMARK] = ACTIONS(4738),
    [anon_sym_COLON_DASH] = ACTIONS(4738),
    [anon_sym_PERCENT] = ACTIONS(4738),
    [anon_sym_DASH] = ACTIONS(4738),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1681] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3975),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [anon_sym_PIPE_AMP] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3977),
    [sym_word] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3977),
  },
  [1682] = {
    [sym_concatenation] = STATE(2076),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2076),
    [anon_sym_RBRACE] = ACTIONS(4742),
    [anon_sym_EQ] = ACTIONS(4744),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4744),
    [anon_sym_COLON_QMARK] = ACTIONS(4744),
    [anon_sym_COLON_DASH] = ACTIONS(4744),
    [anon_sym_PERCENT] = ACTIONS(4744),
    [anon_sym_DASH] = ACTIONS(4744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1683] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3987),
    [sym_word] = ACTIONS(3987),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [1684] = {
    [sym_concatenation] = STATE(2078),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2078),
    [anon_sym_RBRACE] = ACTIONS(4748),
    [anon_sym_EQ] = ACTIONS(4750),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4750),
    [anon_sym_COLON_QMARK] = ACTIONS(4750),
    [anon_sym_COLON_DASH] = ACTIONS(4750),
    [anon_sym_PERCENT] = ACTIONS(4750),
    [anon_sym_DASH] = ACTIONS(4750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1685] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [anon_sym_PIPE_AMP] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4042),
    [sym_word] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [1686] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1687] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4064),
    [sym_word] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [1688] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1689] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [anon_sym_PIPE_AMP] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4070),
    [sym_word] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [1690] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4758),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1691] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4076),
    [sym_word] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [1692] = {
    [sym__concat] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_RPAREN] = ACTIONS(4098),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [anon_sym_PIPE_AMP] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [sym__special_characters] = ACTIONS(4098),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4100),
    [sym_word] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
  },
  [1693] = {
    [sym_file_descriptor] = ACTIONS(3903),
    [sym__concat] = ACTIONS(3903),
    [sym_variable_name] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_GT_GT] = ACTIONS(3903),
    [anon_sym_AMP_GT] = ACTIONS(3905),
    [anon_sym_AMP_GT_GT] = ACTIONS(3903),
    [anon_sym_LT_AMP] = ACTIONS(3903),
    [anon_sym_GT_AMP] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3903),
  },
  [1694] = {
    [sym_file_descriptor] = ACTIONS(3911),
    [sym__concat] = ACTIONS(3911),
    [sym_variable_name] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_GT] = ACTIONS(3913),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3913),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3911),
  },
  [1695] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4760),
    [sym_comment] = ACTIONS(53),
  },
  [1696] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4762),
    [sym_comment] = ACTIONS(53),
  },
  [1697] = {
    [anon_sym_RBRACE] = ACTIONS(4762),
    [sym_comment] = ACTIONS(53),
  },
  [1698] = {
    [sym_concatenation] = STATE(2085),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2085),
    [anon_sym_RBRACE] = ACTIONS(4764),
    [anon_sym_EQ] = ACTIONS(4766),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4768),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4766),
    [anon_sym_COLON_QMARK] = ACTIONS(4766),
    [anon_sym_COLON_DASH] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4766),
    [anon_sym_DASH] = ACTIONS(4766),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1699] = {
    [sym_file_descriptor] = ACTIONS(3975),
    [sym__concat] = ACTIONS(3975),
    [sym_variable_name] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3977),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_GT_GT] = ACTIONS(3975),
    [anon_sym_AMP_GT] = ACTIONS(3977),
    [anon_sym_AMP_GT_GT] = ACTIONS(3975),
    [anon_sym_LT_AMP] = ACTIONS(3975),
    [anon_sym_GT_AMP] = ACTIONS(3975),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3975),
  },
  [1700] = {
    [sym_concatenation] = STATE(2087),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2087),
    [anon_sym_RBRACE] = ACTIONS(4770),
    [anon_sym_EQ] = ACTIONS(4772),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4774),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4772),
    [anon_sym_COLON_QMARK] = ACTIONS(4772),
    [anon_sym_COLON_DASH] = ACTIONS(4772),
    [anon_sym_PERCENT] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1701] = {
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [sym_variable_name] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3985),
  },
  [1702] = {
    [sym_concatenation] = STATE(2089),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2089),
    [anon_sym_RBRACE] = ACTIONS(4776),
    [anon_sym_EQ] = ACTIONS(4778),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4778),
    [anon_sym_COLON_QMARK] = ACTIONS(4778),
    [anon_sym_COLON_DASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [anon_sym_DASH] = ACTIONS(4778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1703] = {
    [sym_file_descriptor] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [sym_variable_name] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_GT_GT] = ACTIONS(4040),
    [anon_sym_AMP_GT] = ACTIONS(4042),
    [anon_sym_AMP_GT_GT] = ACTIONS(4040),
    [anon_sym_LT_AMP] = ACTIONS(4040),
    [anon_sym_GT_AMP] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4040),
  },
  [1704] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4782),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1705] = {
    [sym_file_descriptor] = ACTIONS(4062),
    [sym__concat] = ACTIONS(4062),
    [sym_variable_name] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_GT_GT] = ACTIONS(4062),
    [anon_sym_AMP_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT_GT] = ACTIONS(4062),
    [anon_sym_LT_AMP] = ACTIONS(4062),
    [anon_sym_GT_AMP] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4062),
  },
  [1706] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4784),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1707] = {
    [sym_file_descriptor] = ACTIONS(4068),
    [sym__concat] = ACTIONS(4068),
    [sym_variable_name] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4068),
    [anon_sym_AMP_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT_GT] = ACTIONS(4068),
    [anon_sym_LT_AMP] = ACTIONS(4068),
    [anon_sym_GT_AMP] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4068),
  },
  [1708] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4786),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1709] = {
    [sym_file_descriptor] = ACTIONS(4074),
    [sym__concat] = ACTIONS(4074),
    [sym_variable_name] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_AMP_GT] = ACTIONS(4076),
    [anon_sym_AMP_GT_GT] = ACTIONS(4074),
    [anon_sym_LT_AMP] = ACTIONS(4074),
    [anon_sym_GT_AMP] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4074),
  },
  [1710] = {
    [sym_file_descriptor] = ACTIONS(4098),
    [sym__concat] = ACTIONS(4098),
    [sym_variable_name] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4100),
    [anon_sym_GT] = ACTIONS(4100),
    [anon_sym_GT_GT] = ACTIONS(4098),
    [anon_sym_AMP_GT] = ACTIONS(4100),
    [anon_sym_AMP_GT_GT] = ACTIONS(4098),
    [anon_sym_LT_AMP] = ACTIONS(4098),
    [anon_sym_GT_AMP] = ACTIONS(4098),
    [sym__special_characters] = ACTIONS(4098),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4098),
  },
  [1711] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym__string_content] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3905),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_comment] = ACTIONS(243),
  },
  [1712] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3913),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym__string_content] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3913),
    [anon_sym_BQUOTE] = ACTIONS(3913),
    [sym_comment] = ACTIONS(243),
  },
  [1713] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4788),
    [sym_comment] = ACTIONS(53),
  },
  [1714] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4790),
    [sym_comment] = ACTIONS(53),
  },
  [1715] = {
    [anon_sym_RBRACE] = ACTIONS(4790),
    [sym_comment] = ACTIONS(53),
  },
  [1716] = {
    [sym_concatenation] = STATE(2096),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2096),
    [anon_sym_RBRACE] = ACTIONS(4792),
    [anon_sym_EQ] = ACTIONS(4794),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4794),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_COLON_DASH] = ACTIONS(4794),
    [anon_sym_PERCENT] = ACTIONS(4794),
    [anon_sym_DASH] = ACTIONS(4794),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1717] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym__string_content] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3977),
    [anon_sym_BQUOTE] = ACTIONS(3977),
    [sym_comment] = ACTIONS(243),
  },
  [1718] = {
    [sym_concatenation] = STATE(2098),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2098),
    [anon_sym_RBRACE] = ACTIONS(4798),
    [anon_sym_EQ] = ACTIONS(4800),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4802),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4800),
    [anon_sym_COLON_QMARK] = ACTIONS(4800),
    [anon_sym_COLON_DASH] = ACTIONS(4800),
    [anon_sym_PERCENT] = ACTIONS(4800),
    [anon_sym_DASH] = ACTIONS(4800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1719] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3987),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym__string_content] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3987),
    [anon_sym_BQUOTE] = ACTIONS(3987),
    [sym_comment] = ACTIONS(243),
  },
  [1720] = {
    [sym_concatenation] = STATE(2100),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2100),
    [anon_sym_RBRACE] = ACTIONS(4804),
    [anon_sym_EQ] = ACTIONS(4806),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4806),
    [anon_sym_COLON_QMARK] = ACTIONS(4806),
    [anon_sym_COLON_DASH] = ACTIONS(4806),
    [anon_sym_PERCENT] = ACTIONS(4806),
    [anon_sym_DASH] = ACTIONS(4806),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1721] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym__string_content] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4042),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [sym_comment] = ACTIONS(243),
  },
  [1722] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4810),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1723] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym__string_content] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [sym_comment] = ACTIONS(243),
  },
  [1724] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1725] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym__string_content] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [sym_comment] = ACTIONS(243),
  },
  [1726] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4814),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1727] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym__string_content] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4076),
    [anon_sym_BQUOTE] = ACTIONS(4076),
    [sym_comment] = ACTIONS(243),
  },
  [1728] = {
    [sym__concat] = ACTIONS(4816),
    [anon_sym_RBRACE] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(4818),
    [sym__special_characters] = ACTIONS(4818),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_DOLLAR] = ACTIONS(4818),
    [sym_raw_string] = ACTIONS(3139),
    [anon_sym_POUND] = ACTIONS(3139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3139),
    [anon_sym_SLASH] = ACTIONS(3139),
    [anon_sym_COLON] = ACTIONS(4818),
    [anon_sym_COLON_QMARK] = ACTIONS(4818),
    [anon_sym_COLON_DASH] = ACTIONS(4818),
    [anon_sym_PERCENT] = ACTIONS(4818),
    [anon_sym_DASH] = ACTIONS(4818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3139),
    [anon_sym_BQUOTE] = ACTIONS(3139),
    [anon_sym_LT_LPAREN] = ACTIONS(3139),
    [anon_sym_GT_LPAREN] = ACTIONS(3139),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4818),
  },
  [1729] = {
    [anon_sym_RBRACE] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(4818),
    [sym__special_characters] = ACTIONS(4818),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_DOLLAR] = ACTIONS(4818),
    [sym_raw_string] = ACTIONS(3139),
    [anon_sym_POUND] = ACTIONS(3139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3139),
    [anon_sym_SLASH] = ACTIONS(3139),
    [anon_sym_COLON] = ACTIONS(4818),
    [anon_sym_COLON_QMARK] = ACTIONS(4818),
    [anon_sym_COLON_DASH] = ACTIONS(4818),
    [anon_sym_PERCENT] = ACTIONS(4818),
    [anon_sym_DASH] = ACTIONS(4818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3139),
    [anon_sym_BQUOTE] = ACTIONS(3139),
    [anon_sym_LT_LPAREN] = ACTIONS(3139),
    [anon_sym_GT_LPAREN] = ACTIONS(3139),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4818),
  },
  [1730] = {
    [sym__concat] = ACTIONS(4820),
    [anon_sym_RBRACE] = ACTIONS(3143),
    [anon_sym_EQ] = ACTIONS(4822),
    [sym__special_characters] = ACTIONS(4822),
    [anon_sym_DQUOTE] = ACTIONS(3143),
    [anon_sym_DOLLAR] = ACTIONS(4822),
    [sym_raw_string] = ACTIONS(3143),
    [anon_sym_POUND] = ACTIONS(3143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3143),
    [anon_sym_SLASH] = ACTIONS(3143),
    [anon_sym_COLON] = ACTIONS(4822),
    [anon_sym_COLON_QMARK] = ACTIONS(4822),
    [anon_sym_COLON_DASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4822),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3143),
    [anon_sym_BQUOTE] = ACTIONS(3143),
    [anon_sym_LT_LPAREN] = ACTIONS(3143),
    [anon_sym_GT_LPAREN] = ACTIONS(3143),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4822),
  },
  [1731] = {
    [anon_sym_RBRACE] = ACTIONS(3143),
    [anon_sym_EQ] = ACTIONS(4822),
    [sym__special_characters] = ACTIONS(4822),
    [anon_sym_DQUOTE] = ACTIONS(3143),
    [anon_sym_DOLLAR] = ACTIONS(4822),
    [sym_raw_string] = ACTIONS(3143),
    [anon_sym_POUND] = ACTIONS(3143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3143),
    [anon_sym_SLASH] = ACTIONS(3143),
    [anon_sym_COLON] = ACTIONS(4822),
    [anon_sym_COLON_QMARK] = ACTIONS(4822),
    [anon_sym_COLON_DASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4822),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3143),
    [anon_sym_BQUOTE] = ACTIONS(3143),
    [anon_sym_LT_LPAREN] = ACTIONS(3143),
    [anon_sym_GT_LPAREN] = ACTIONS(3143),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4822),
  },
  [1732] = {
    [sym__concat] = ACTIONS(1664),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
  },
  [1733] = {
    [aux_sym_concatenation_repeat1] = STATE(1733),
    [sym__concat] = ACTIONS(4824),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
  },
  [1734] = {
    [sym__concat] = ACTIONS(1671),
    [anon_sym_RBRACE] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
  },
  [1735] = {
    [anon_sym_DQUOTE] = ACTIONS(4827),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [1736] = {
    [sym_concatenation] = STATE(2110),
    [sym_string] = STATE(2109),
    [sym_simple_expansion] = STATE(2109),
    [sym_string_expansion] = STATE(2109),
    [sym_expansion] = STATE(2109),
    [sym_command_substitution] = STATE(2109),
    [sym_process_substitution] = STATE(2109),
    [anon_sym_RBRACE] = ACTIONS(4829),
    [sym__special_characters] = ACTIONS(4831),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(4833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4833),
  },
  [1737] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(4835),
    [sym_comment] = ACTIONS(53),
  },
  [1738] = {
    [sym_concatenation] = STATE(2114),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2114),
    [anon_sym_RBRACE] = ACTIONS(4837),
    [anon_sym_EQ] = ACTIONS(4839),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4843),
    [anon_sym_COLON] = ACTIONS(4839),
    [anon_sym_COLON_QMARK] = ACTIONS(4839),
    [anon_sym_COLON_DASH] = ACTIONS(4839),
    [anon_sym_PERCENT] = ACTIONS(4839),
    [anon_sym_DASH] = ACTIONS(4839),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1739] = {
    [sym_concatenation] = STATE(2117),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2117),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym_EQ] = ACTIONS(4847),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4849),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4851),
    [anon_sym_COLON] = ACTIONS(4847),
    [anon_sym_COLON_QMARK] = ACTIONS(4847),
    [anon_sym_COLON_DASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1740] = {
    [sym_concatenation] = STATE(2119),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2119),
    [anon_sym_RBRACE] = ACTIONS(4829),
    [anon_sym_EQ] = ACTIONS(4853),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(4857),
    [anon_sym_COLON] = ACTIONS(4853),
    [anon_sym_COLON_QMARK] = ACTIONS(4853),
    [anon_sym_COLON_DASH] = ACTIONS(4853),
    [anon_sym_PERCENT] = ACTIONS(4853),
    [anon_sym_DASH] = ACTIONS(4853),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1741] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_RBRACE] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
  },
  [1742] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4859),
  },
  [1743] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1744] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_RBRACE] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
  },
  [1745] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4863),
  },
  [1746] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4865),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1747] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_RBRACE] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
  },
  [1748] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4867),
  },
  [1749] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4829),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1750] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
  },
  [1751] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4869),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1752] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4869),
    [anon_sym_SEMI_SEMI] = ACTIONS(4871),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4873),
    [anon_sym_LF] = ACTIONS(4871),
    [anon_sym_AMP] = ACTIONS(4873),
  },
  [1753] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4869),
    [anon_sym_SEMI_SEMI] = ACTIONS(4871),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4873),
    [anon_sym_LF] = ACTIONS(4871),
    [anon_sym_AMP] = ACTIONS(4873),
  },
  [1754] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(4869),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1755] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4875),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(4869),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_LF] = ACTIONS(4875),
    [anon_sym_AMP] = ACTIONS(4877),
  },
  [1756] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(4875),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(4869),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_LF] = ACTIONS(4875),
    [anon_sym_AMP] = ACTIONS(4877),
  },
  [1757] = {
    [sym__concat] = ACTIONS(1878),
    [anon_sym_RBRACE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
  },
  [1758] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4879),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1759] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4879),
    [anon_sym_SEMI_SEMI] = ACTIONS(4881),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4883),
    [anon_sym_LF] = ACTIONS(4881),
    [anon_sym_AMP] = ACTIONS(4883),
  },
  [1760] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(4879),
    [anon_sym_SEMI_SEMI] = ACTIONS(4881),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(4883),
    [anon_sym_LF] = ACTIONS(4881),
    [anon_sym_AMP] = ACTIONS(4883),
  },
  [1761] = {
    [sym__simple_heredoc_body] = ACTIONS(4885),
    [sym__heredoc_body_beginning] = ACTIONS(4885),
    [sym_file_descriptor] = ACTIONS(4885),
    [sym__concat] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [anon_sym_PIPE_AMP] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_EQ_TILDE] = ACTIONS(4887),
    [anon_sym_EQ_EQ] = ACTIONS(4887),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_GT_GT] = ACTIONS(4885),
    [anon_sym_AMP_GT] = ACTIONS(4887),
    [anon_sym_AMP_GT_GT] = ACTIONS(4885),
    [anon_sym_LT_AMP] = ACTIONS(4885),
    [anon_sym_GT_AMP] = ACTIONS(4885),
    [anon_sym_LT_LT] = ACTIONS(4887),
    [anon_sym_LT_LT_DASH] = ACTIONS(4885),
    [anon_sym_LT_LT_LT] = ACTIONS(4885),
    [sym__special_characters] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4887),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4887),
  },
  [1762] = {
    [sym__simple_heredoc_body] = ACTIONS(4889),
    [sym__heredoc_body_beginning] = ACTIONS(4889),
    [sym_file_descriptor] = ACTIONS(4889),
    [sym__concat] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [anon_sym_PIPE_AMP] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_EQ_TILDE] = ACTIONS(4891),
    [anon_sym_EQ_EQ] = ACTIONS(4891),
    [anon_sym_LT] = ACTIONS(4891),
    [anon_sym_GT] = ACTIONS(4891),
    [anon_sym_GT_GT] = ACTIONS(4889),
    [anon_sym_AMP_GT] = ACTIONS(4891),
    [anon_sym_AMP_GT_GT] = ACTIONS(4889),
    [anon_sym_LT_AMP] = ACTIONS(4889),
    [anon_sym_GT_AMP] = ACTIONS(4889),
    [anon_sym_LT_LT] = ACTIONS(4891),
    [anon_sym_LT_LT_DASH] = ACTIONS(4889),
    [anon_sym_LT_LT_LT] = ACTIONS(4889),
    [sym__special_characters] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4891),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4891),
  },
  [1763] = {
    [sym__simple_heredoc_body] = ACTIONS(4893),
    [sym__heredoc_body_beginning] = ACTIONS(4893),
    [sym_file_descriptor] = ACTIONS(4893),
    [sym__concat] = ACTIONS(4893),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [anon_sym_EQ_TILDE] = ACTIONS(4895),
    [anon_sym_EQ_EQ] = ACTIONS(4895),
    [anon_sym_LT] = ACTIONS(4895),
    [anon_sym_GT] = ACTIONS(4895),
    [anon_sym_GT_GT] = ACTIONS(4893),
    [anon_sym_AMP_GT] = ACTIONS(4895),
    [anon_sym_AMP_GT_GT] = ACTIONS(4893),
    [anon_sym_LT_AMP] = ACTIONS(4893),
    [anon_sym_GT_AMP] = ACTIONS(4893),
    [anon_sym_LT_LT] = ACTIONS(4895),
    [anon_sym_LT_LT_DASH] = ACTIONS(4893),
    [anon_sym_LT_LT_LT] = ACTIONS(4893),
    [sym__special_characters] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4895),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [1764] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4897),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1765] = {
    [sym__simple_heredoc_body] = ACTIONS(4899),
    [sym__heredoc_body_beginning] = ACTIONS(4899),
    [sym_file_descriptor] = ACTIONS(4899),
    [sym__concat] = ACTIONS(4899),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_RPAREN] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [anon_sym_PIPE_AMP] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [anon_sym_EQ_TILDE] = ACTIONS(4901),
    [anon_sym_EQ_EQ] = ACTIONS(4901),
    [anon_sym_LT] = ACTIONS(4901),
    [anon_sym_GT] = ACTIONS(4901),
    [anon_sym_GT_GT] = ACTIONS(4899),
    [anon_sym_AMP_GT] = ACTIONS(4901),
    [anon_sym_AMP_GT_GT] = ACTIONS(4899),
    [anon_sym_LT_AMP] = ACTIONS(4899),
    [anon_sym_GT_AMP] = ACTIONS(4899),
    [anon_sym_LT_LT] = ACTIONS(4901),
    [anon_sym_LT_LT_DASH] = ACTIONS(4899),
    [anon_sym_LT_LT_LT] = ACTIONS(4899),
    [sym__special_characters] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4901),
  },
  [1766] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4903),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1767] = {
    [sym__simple_heredoc_body] = ACTIONS(4905),
    [sym__heredoc_body_beginning] = ACTIONS(4905),
    [sym_file_descriptor] = ACTIONS(4905),
    [sym__concat] = ACTIONS(4905),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [anon_sym_PIPE_AMP] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_EQ_TILDE] = ACTIONS(4907),
    [anon_sym_EQ_EQ] = ACTIONS(4907),
    [anon_sym_LT] = ACTIONS(4907),
    [anon_sym_GT] = ACTIONS(4907),
    [anon_sym_GT_GT] = ACTIONS(4905),
    [anon_sym_AMP_GT] = ACTIONS(4907),
    [anon_sym_AMP_GT_GT] = ACTIONS(4905),
    [anon_sym_LT_AMP] = ACTIONS(4905),
    [anon_sym_GT_AMP] = ACTIONS(4905),
    [anon_sym_LT_LT] = ACTIONS(4907),
    [anon_sym_LT_LT_DASH] = ACTIONS(4905),
    [anon_sym_LT_LT_LT] = ACTIONS(4905),
    [sym__special_characters] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4907),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4907),
  },
  [1768] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4909),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1769] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [sym__special_characters] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_POUND] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_COLON] = ACTIONS(2857),
    [anon_sym_COLON_QMARK] = ACTIONS(2857),
    [anon_sym_COLON_DASH] = ACTIONS(2857),
    [anon_sym_PERCENT] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(2857),
  },
  [1770] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [anon_sym_EQ] = ACTIONS(2871),
    [sym__special_characters] = ACTIONS(2871),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_POUND] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2871),
    [anon_sym_COLON_QMARK] = ACTIONS(2871),
    [anon_sym_COLON_DASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [anon_sym_DASH] = ACTIONS(2871),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(2871),
  },
  [1771] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4911),
    [sym_comment] = ACTIONS(53),
  },
  [1772] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4913),
    [sym_comment] = ACTIONS(53),
  },
  [1773] = {
    [anon_sym_RBRACE] = ACTIONS(4913),
    [sym_comment] = ACTIONS(53),
  },
  [1774] = {
    [sym_concatenation] = STATE(2137),
    [sym_string] = STATE(2136),
    [sym_simple_expansion] = STATE(2136),
    [sym_string_expansion] = STATE(2136),
    [sym_expansion] = STATE(2136),
    [sym_command_substitution] = STATE(2136),
    [sym_process_substitution] = STATE(2136),
    [anon_sym_RBRACE] = ACTIONS(4913),
    [sym__special_characters] = ACTIONS(4915),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(4917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4917),
  },
  [1775] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2907),
    [sym__special_characters] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_POUND] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_COLON] = ACTIONS(2907),
    [anon_sym_COLON_QMARK] = ACTIONS(2907),
    [anon_sym_COLON_DASH] = ACTIONS(2907),
    [anon_sym_PERCENT] = ACTIONS(2907),
    [anon_sym_DASH] = ACTIONS(2907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(2907),
  },
  [1776] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4919),
  },
  [1777] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4921),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1778] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2915),
    [sym__special_characters] = ACTIONS(2915),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_POUND] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_COLON] = ACTIONS(2915),
    [anon_sym_COLON_QMARK] = ACTIONS(2915),
    [anon_sym_COLON_DASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(2915),
  },
  [1779] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4923),
  },
  [1780] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4925),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1781] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4927),
  },
  [1782] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4913),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1783] = {
    [sym_concatenation] = STATE(2144),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2144),
    [anon_sym_RBRACE] = ACTIONS(4929),
    [anon_sym_EQ] = ACTIONS(4931),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4931),
    [anon_sym_COLON_QMARK] = ACTIONS(4931),
    [anon_sym_COLON_DASH] = ACTIONS(4931),
    [anon_sym_PERCENT] = ACTIONS(4931),
    [anon_sym_DASH] = ACTIONS(4931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1784] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2987),
    [sym__special_characters] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_POUND] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_COLON_QMARK] = ACTIONS(2987),
    [anon_sym_COLON_DASH] = ACTIONS(2987),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(2987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(2987),
  },
  [1785] = {
    [sym_concatenation] = STATE(2146),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2146),
    [anon_sym_RBRACE] = ACTIONS(4935),
    [anon_sym_EQ] = ACTIONS(4937),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4937),
    [anon_sym_COLON_QMARK] = ACTIONS(4937),
    [anon_sym_COLON_DASH] = ACTIONS(4937),
    [anon_sym_PERCENT] = ACTIONS(4937),
    [anon_sym_DASH] = ACTIONS(4937),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1786] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_EQ] = ACTIONS(3032),
    [sym__special_characters] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_POUND] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_DASH] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(3032),
  },
  [1787] = {
    [sym_concatenation] = STATE(2148),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2148),
    [anon_sym_RBRACE] = ACTIONS(4941),
    [anon_sym_EQ] = ACTIONS(4943),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(4945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(4943),
    [anon_sym_COLON_QMARK] = ACTIONS(4943),
    [anon_sym_COLON_DASH] = ACTIONS(4943),
    [anon_sym_PERCENT] = ACTIONS(4943),
    [anon_sym_DASH] = ACTIONS(4943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1788] = {
    [sym__simple_heredoc_body] = ACTIONS(4947),
    [sym__heredoc_body_beginning] = ACTIONS(4947),
    [sym_file_descriptor] = ACTIONS(4947),
    [sym__concat] = ACTIONS(4947),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_EQ_TILDE] = ACTIONS(4949),
    [anon_sym_EQ_EQ] = ACTIONS(4949),
    [anon_sym_LT] = ACTIONS(4949),
    [anon_sym_GT] = ACTIONS(4949),
    [anon_sym_GT_GT] = ACTIONS(4947),
    [anon_sym_AMP_GT] = ACTIONS(4949),
    [anon_sym_AMP_GT_GT] = ACTIONS(4947),
    [anon_sym_LT_AMP] = ACTIONS(4947),
    [anon_sym_GT_AMP] = ACTIONS(4947),
    [anon_sym_LT_LT] = ACTIONS(4949),
    [anon_sym_LT_LT_DASH] = ACTIONS(4947),
    [anon_sym_LT_LT_LT] = ACTIONS(4947),
    [sym__special_characters] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4949),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4949),
  },
  [1789] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_EQ] = ACTIONS(3042),
    [sym__special_characters] = ACTIONS(3042),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_POUND] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_COLON_QMARK] = ACTIONS(3042),
    [anon_sym_COLON_DASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(3042),
  },
  [1790] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4951),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1791] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(4951),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1792] = {
    [sym__concat] = ACTIONS(3078),
    [anon_sym_RBRACE] = ACTIONS(3078),
    [anon_sym_EQ] = ACTIONS(3080),
    [sym__special_characters] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_POUND] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_COLON] = ACTIONS(3080),
    [anon_sym_COLON_QMARK] = ACTIONS(3080),
    [anon_sym_COLON_DASH] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(3080),
  },
  [1793] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(4953),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1794] = {
    [sym__simple_heredoc_body] = ACTIONS(4955),
    [sym__heredoc_body_beginning] = ACTIONS(4955),
    [sym_file_descriptor] = ACTIONS(4955),
    [sym__concat] = ACTIONS(4955),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [anon_sym_PIPE_AMP] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [anon_sym_EQ_TILDE] = ACTIONS(4957),
    [anon_sym_EQ_EQ] = ACTIONS(4957),
    [anon_sym_LT] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4957),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym_AMP_GT] = ACTIONS(4957),
    [anon_sym_AMP_GT_GT] = ACTIONS(4955),
    [anon_sym_LT_AMP] = ACTIONS(4955),
    [anon_sym_GT_AMP] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4957),
    [anon_sym_LT_LT_DASH] = ACTIONS(4955),
    [anon_sym_LT_LT_LT] = ACTIONS(4955),
    [sym__special_characters] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4957),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4957),
  },
  [1795] = {
    [sym__simple_heredoc_body] = ACTIONS(4959),
    [sym__heredoc_body_beginning] = ACTIONS(4959),
    [sym_file_descriptor] = ACTIONS(4959),
    [sym__concat] = ACTIONS(4959),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4959),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [anon_sym_PIPE_AMP] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [anon_sym_EQ_TILDE] = ACTIONS(4961),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_LT] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym_AMP_GT] = ACTIONS(4961),
    [anon_sym_AMP_GT_GT] = ACTIONS(4959),
    [anon_sym_LT_AMP] = ACTIONS(4959),
    [anon_sym_GT_AMP] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4961),
    [anon_sym_LT_LT_DASH] = ACTIONS(4959),
    [anon_sym_LT_LT_LT] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4961),
  },
  [1796] = {
    [sym_file_redirect] = STATE(1577),
    [sym_file_descriptor] = ACTIONS(3048),
    [anon_sym_PIPE] = ACTIONS(3565),
    [anon_sym_SEMI_SEMI] = ACTIONS(3567),
    [anon_sym_PIPE_AMP] = ACTIONS(3567),
    [anon_sym_AMP_AMP] = ACTIONS(3567),
    [anon_sym_PIPE_PIPE] = ACTIONS(3567),
    [anon_sym_LT] = ACTIONS(3050),
    [anon_sym_GT] = ACTIONS(3050),
    [anon_sym_GT_GT] = ACTIONS(3052),
    [anon_sym_AMP_GT] = ACTIONS(3050),
    [anon_sym_AMP_GT_GT] = ACTIONS(3052),
    [anon_sym_LT_AMP] = ACTIONS(3052),
    [anon_sym_GT_AMP] = ACTIONS(3052),
    [anon_sym_BQUOTE] = ACTIONS(3567),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3565),
    [anon_sym_LF] = ACTIONS(3567),
    [anon_sym_AMP] = ACTIONS(3565),
  },
  [1797] = {
    [sym_concatenation] = STATE(1580),
    [sym_string] = STATE(2152),
    [sym_simple_expansion] = STATE(2152),
    [sym_string_expansion] = STATE(2152),
    [sym_expansion] = STATE(2152),
    [sym_command_substitution] = STATE(2152),
    [sym_process_substitution] = STATE(2152),
    [sym__special_characters] = ACTIONS(4963),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [sym_raw_string] = ACTIONS(4965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(203),
    [anon_sym_GT_LPAREN] = ACTIONS(203),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4965),
  },
  [1798] = {
    [aux_sym_concatenation_repeat1] = STATE(2153),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1799] = {
    [aux_sym_concatenation_repeat1] = STATE(2153),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [1800] = {
    [sym_concatenation] = STATE(1615),
    [sym_string] = STATE(2155),
    [sym_simple_expansion] = STATE(2155),
    [sym_string_expansion] = STATE(2155),
    [sym_expansion] = STATE(2155),
    [sym_command_substitution] = STATE(2155),
    [sym_process_substitution] = STATE(2155),
    [sym__special_characters] = ACTIONS(4967),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(4969),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4969),
  },
  [1801] = {
    [aux_sym_concatenation_repeat1] = STATE(2156),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1802] = {
    [aux_sym_concatenation_repeat1] = STATE(2156),
    [sym_file_descriptor] = ACTIONS(679),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [1803] = {
    [aux_sym_concatenation_repeat1] = STATE(2156),
    [sym_file_descriptor] = ACTIONS(1936),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(1938),
    [anon_sym_SEMI_SEMI] = ACTIONS(1936),
    [anon_sym_PIPE_AMP] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1938),
    [anon_sym_GT] = ACTIONS(1938),
    [anon_sym_GT_GT] = ACTIONS(1936),
    [anon_sym_AMP_GT] = ACTIONS(1938),
    [anon_sym_AMP_GT_GT] = ACTIONS(1936),
    [anon_sym_LT_AMP] = ACTIONS(1936),
    [anon_sym_GT_AMP] = ACTIONS(1936),
    [anon_sym_LT_LT] = ACTIONS(1938),
    [anon_sym_LT_LT_DASH] = ACTIONS(1936),
    [anon_sym_LT_LT_LT] = ACTIONS(1936),
    [anon_sym_BQUOTE] = ACTIONS(1936),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_LF] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1938),
  },
  [1804] = {
    [aux_sym_concatenation_repeat1] = STATE(2156),
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [1805] = {
    [sym_file_redirect] = STATE(1805),
    [sym_heredoc_redirect] = STATE(1805),
    [sym_herestring_redirect] = STATE(1805),
    [aux_sym_while_statement_repeat1] = STATE(1805),
    [sym_file_descriptor] = ACTIONS(4971),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_SEMI_SEMI] = ACTIONS(1948),
    [anon_sym_PIPE_AMP] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_PIPE_PIPE] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(4974),
    [anon_sym_GT] = ACTIONS(4974),
    [anon_sym_GT_GT] = ACTIONS(4977),
    [anon_sym_AMP_GT] = ACTIONS(4974),
    [anon_sym_AMP_GT_GT] = ACTIONS(4977),
    [anon_sym_LT_AMP] = ACTIONS(4977),
    [anon_sym_GT_AMP] = ACTIONS(4977),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_LT_LT_DASH] = ACTIONS(3683),
    [anon_sym_LT_LT_LT] = ACTIONS(4980),
    [anon_sym_BQUOTE] = ACTIONS(1948),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_LF] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1953),
  },
  [1806] = {
    [aux_sym_concatenation_repeat1] = STATE(1806),
    [sym__simple_heredoc_body] = ACTIONS(1664),
    [sym__heredoc_body_beginning] = ACTIONS(1664),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1668),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [1807] = {
    [sym__heredoc_body_middle] = ACTIONS(2869),
    [sym__heredoc_body_end] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
  },
  [1808] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4983),
    [sym_comment] = ACTIONS(53),
  },
  [1809] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(4985),
    [sym_comment] = ACTIONS(53),
  },
  [1810] = {
    [anon_sym_RBRACE] = ACTIONS(4985),
    [sym_comment] = ACTIONS(53),
  },
  [1811] = {
    [sym_concatenation] = STATE(2161),
    [sym_string] = STATE(2160),
    [sym_simple_expansion] = STATE(2160),
    [sym_string_expansion] = STATE(2160),
    [sym_expansion] = STATE(2160),
    [sym_command_substitution] = STATE(2160),
    [sym_process_substitution] = STATE(2160),
    [anon_sym_RBRACE] = ACTIONS(4985),
    [sym__special_characters] = ACTIONS(4987),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(4989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4989),
  },
  [1812] = {
    [sym__heredoc_body_middle] = ACTIONS(2905),
    [sym__heredoc_body_end] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
  },
  [1813] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4991),
  },
  [1814] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1815] = {
    [sym__heredoc_body_middle] = ACTIONS(2913),
    [sym__heredoc_body_end] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
  },
  [1816] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4995),
  },
  [1817] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4997),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1818] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(4999),
  },
  [1819] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(4985),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1820] = {
    [sym_concatenation] = STATE(2168),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2168),
    [anon_sym_RBRACE] = ACTIONS(5001),
    [anon_sym_EQ] = ACTIONS(5003),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5005),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5003),
    [anon_sym_COLON_QMARK] = ACTIONS(5003),
    [anon_sym_COLON_DASH] = ACTIONS(5003),
    [anon_sym_PERCENT] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(5003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1821] = {
    [sym__heredoc_body_middle] = ACTIONS(2985),
    [sym__heredoc_body_end] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
  },
  [1822] = {
    [sym_concatenation] = STATE(2170),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2170),
    [anon_sym_RBRACE] = ACTIONS(5007),
    [anon_sym_EQ] = ACTIONS(5009),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5009),
    [anon_sym_COLON_QMARK] = ACTIONS(5009),
    [anon_sym_COLON_DASH] = ACTIONS(5009),
    [anon_sym_PERCENT] = ACTIONS(5009),
    [anon_sym_DASH] = ACTIONS(5009),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1823] = {
    [sym__heredoc_body_middle] = ACTIONS(3030),
    [sym__heredoc_body_end] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
  },
  [1824] = {
    [sym_concatenation] = STATE(2172),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2172),
    [anon_sym_RBRACE] = ACTIONS(5013),
    [anon_sym_EQ] = ACTIONS(5015),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_DASH] = ACTIONS(5015),
    [anon_sym_PERCENT] = ACTIONS(5015),
    [anon_sym_DASH] = ACTIONS(5015),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1825] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2855),
  },
  [1826] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_RPAREN] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2869),
  },
  [1827] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [sym_comment] = ACTIONS(53),
  },
  [1828] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5021),
    [sym_comment] = ACTIONS(53),
  },
  [1829] = {
    [anon_sym_RBRACE] = ACTIONS(5021),
    [sym_comment] = ACTIONS(53),
  },
  [1830] = {
    [sym_concatenation] = STATE(2177),
    [sym_string] = STATE(2176),
    [sym_simple_expansion] = STATE(2176),
    [sym_string_expansion] = STATE(2176),
    [sym_expansion] = STATE(2176),
    [sym_command_substitution] = STATE(2176),
    [sym_process_substitution] = STATE(2176),
    [anon_sym_RBRACE] = ACTIONS(5021),
    [sym__special_characters] = ACTIONS(5023),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(5025),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5025),
  },
  [1831] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2905),
  },
  [1832] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5027),
  },
  [1833] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5029),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1834] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [sym__special_characters] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2913),
  },
  [1835] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5031),
  },
  [1836] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5033),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1837] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5035),
  },
  [1838] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5021),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1839] = {
    [sym_concatenation] = STATE(2184),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2184),
    [anon_sym_RBRACE] = ACTIONS(5037),
    [anon_sym_EQ] = ACTIONS(5039),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5041),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5039),
    [anon_sym_COLON_QMARK] = ACTIONS(5039),
    [anon_sym_COLON_DASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH] = ACTIONS(5039),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1840] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [sym__special_characters] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2985),
  },
  [1841] = {
    [sym_concatenation] = STATE(2186),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2186),
    [anon_sym_RBRACE] = ACTIONS(5043),
    [anon_sym_EQ] = ACTIONS(5045),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5045),
    [anon_sym_COLON_QMARK] = ACTIONS(5045),
    [anon_sym_COLON_DASH] = ACTIONS(5045),
    [anon_sym_PERCENT] = ACTIONS(5045),
    [anon_sym_DASH] = ACTIONS(5045),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1842] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [sym__special_characters] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3030),
  },
  [1843] = {
    [sym_concatenation] = STATE(2188),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2188),
    [anon_sym_RBRACE] = ACTIONS(5049),
    [anon_sym_EQ] = ACTIONS(5051),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5051),
    [anon_sym_COLON_QMARK] = ACTIONS(5051),
    [anon_sym_COLON_DASH] = ACTIONS(5051),
    [anon_sym_PERCENT] = ACTIONS(5051),
    [anon_sym_DASH] = ACTIONS(5051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1844] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3040),
  },
  [1845] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5055),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1846] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(5055),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1847] = {
    [sym__concat] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3078),
    [sym__special_characters] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3078),
  },
  [1848] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5057),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1849] = {
    [sym_file_descriptor] = ACTIONS(3903),
    [sym__concat] = ACTIONS(3903),
    [sym_variable_name] = ACTIONS(3903),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_RPAREN] = ACTIONS(3903),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_GT_GT] = ACTIONS(3903),
    [anon_sym_AMP_GT] = ACTIONS(3905),
    [anon_sym_AMP_GT_GT] = ACTIONS(3903),
    [anon_sym_LT_AMP] = ACTIONS(3903),
    [anon_sym_GT_AMP] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [1850] = {
    [sym_file_descriptor] = ACTIONS(3911),
    [sym__concat] = ACTIONS(3911),
    [sym_variable_name] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_GT] = ACTIONS(3913),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3913),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3913),
  },
  [1851] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5059),
    [sym_comment] = ACTIONS(53),
  },
  [1852] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5061),
    [sym_comment] = ACTIONS(53),
  },
  [1853] = {
    [anon_sym_RBRACE] = ACTIONS(5061),
    [sym_comment] = ACTIONS(53),
  },
  [1854] = {
    [sym_concatenation] = STATE(2194),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2194),
    [anon_sym_RBRACE] = ACTIONS(5063),
    [anon_sym_EQ] = ACTIONS(5065),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5065),
    [anon_sym_COLON_QMARK] = ACTIONS(5065),
    [anon_sym_COLON_DASH] = ACTIONS(5065),
    [anon_sym_PERCENT] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1855] = {
    [sym_file_descriptor] = ACTIONS(3975),
    [sym__concat] = ACTIONS(3975),
    [sym_variable_name] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3975),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [anon_sym_PIPE_AMP] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3977),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_GT_GT] = ACTIONS(3975),
    [anon_sym_AMP_GT] = ACTIONS(3977),
    [anon_sym_AMP_GT_GT] = ACTIONS(3975),
    [anon_sym_LT_AMP] = ACTIONS(3975),
    [anon_sym_GT_AMP] = ACTIONS(3975),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3977),
  },
  [1856] = {
    [sym_concatenation] = STATE(2196),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2196),
    [anon_sym_RBRACE] = ACTIONS(5069),
    [anon_sym_EQ] = ACTIONS(5071),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5071),
    [anon_sym_COLON_QMARK] = ACTIONS(5071),
    [anon_sym_COLON_DASH] = ACTIONS(5071),
    [anon_sym_PERCENT] = ACTIONS(5071),
    [anon_sym_DASH] = ACTIONS(5071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1857] = {
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [sym_variable_name] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3987),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [1858] = {
    [sym_concatenation] = STATE(2198),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2198),
    [anon_sym_RBRACE] = ACTIONS(5075),
    [anon_sym_EQ] = ACTIONS(5077),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5077),
    [anon_sym_COLON_QMARK] = ACTIONS(5077),
    [anon_sym_COLON_DASH] = ACTIONS(5077),
    [anon_sym_PERCENT] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1859] = {
    [sym_file_descriptor] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [sym_variable_name] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [anon_sym_PIPE_AMP] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_GT_GT] = ACTIONS(4040),
    [anon_sym_AMP_GT] = ACTIONS(4042),
    [anon_sym_AMP_GT_GT] = ACTIONS(4040),
    [anon_sym_LT_AMP] = ACTIONS(4040),
    [anon_sym_GT_AMP] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [1860] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5081),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1861] = {
    [sym_file_descriptor] = ACTIONS(4062),
    [sym__concat] = ACTIONS(4062),
    [sym_variable_name] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_GT_GT] = ACTIONS(4062),
    [anon_sym_AMP_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT_GT] = ACTIONS(4062),
    [anon_sym_LT_AMP] = ACTIONS(4062),
    [anon_sym_GT_AMP] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [1862] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5083),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1863] = {
    [sym_file_descriptor] = ACTIONS(4068),
    [sym__concat] = ACTIONS(4068),
    [sym_variable_name] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [anon_sym_PIPE_AMP] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4068),
    [anon_sym_AMP_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT_GT] = ACTIONS(4068),
    [anon_sym_LT_AMP] = ACTIONS(4068),
    [anon_sym_GT_AMP] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [1864] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5085),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1865] = {
    [sym_file_descriptor] = ACTIONS(4074),
    [sym__concat] = ACTIONS(4074),
    [sym_variable_name] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_AMP_GT] = ACTIONS(4076),
    [anon_sym_AMP_GT_GT] = ACTIONS(4074),
    [anon_sym_LT_AMP] = ACTIONS(4074),
    [anon_sym_GT_AMP] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [1866] = {
    [sym_file_descriptor] = ACTIONS(4098),
    [sym__concat] = ACTIONS(4098),
    [sym_variable_name] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_RPAREN] = ACTIONS(4098),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [anon_sym_PIPE_AMP] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4100),
    [anon_sym_GT] = ACTIONS(4100),
    [anon_sym_GT_GT] = ACTIONS(4098),
    [anon_sym_AMP_GT] = ACTIONS(4100),
    [anon_sym_AMP_GT_GT] = ACTIONS(4098),
    [anon_sym_LT_AMP] = ACTIONS(4098),
    [anon_sym_GT_AMP] = ACTIONS(4098),
    [sym__special_characters] = ACTIONS(4098),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
  },
  [1867] = {
    [anon_sym_esac] = ACTIONS(2355),
    [anon_sym_PIPE] = ACTIONS(2357),
    [anon_sym_RPAREN] = ACTIONS(2355),
    [anon_sym_SEMI_SEMI] = ACTIONS(2355),
    [anon_sym_PIPE_AMP] = ACTIONS(2355),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_PIPE_PIPE] = ACTIONS(2355),
    [anon_sym_BQUOTE] = ACTIONS(2355),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2357),
    [anon_sym_LF] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
  },
  [1868] = {
    [sym__terminated_statement] = STATE(1110),
    [sym_for_statement] = STATE(619),
    [sym_c_style_for_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_case_statement] = STATE(619),
    [sym_function_definition] = STATE(619),
    [sym_subshell] = STATE(619),
    [sym_pipeline] = STATE(619),
    [sym_list] = STATE(619),
    [sym_negated_command] = STATE(619),
    [sym_test_command] = STATE(619),
    [sym_declaration_command] = STATE(619),
    [sym_unset_command] = STATE(619),
    [sym_command] = STATE(619),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(620),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1110),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1869] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2454),
  },
  [1870] = {
    [sym__concat] = ACTIONS(1664),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1664),
    [anon_sym_EQ_EQ] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_BANG_EQ] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1664),
  },
  [1871] = {
    [aux_sym_concatenation_repeat1] = STATE(1871),
    [sym__concat] = ACTIONS(5089),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1664),
    [anon_sym_EQ_EQ] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_BANG_EQ] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1664),
  },
  [1872] = {
    [sym__concat] = ACTIONS(1671),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_EQ_TILDE] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1673),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_BANG_EQ] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1671),
  },
  [1873] = {
    [anon_sym_DQUOTE] = ACTIONS(5092),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [1874] = {
    [sym_concatenation] = STATE(2207),
    [sym_string] = STATE(2206),
    [sym_simple_expansion] = STATE(2206),
    [sym_string_expansion] = STATE(2206),
    [sym_expansion] = STATE(2206),
    [sym_command_substitution] = STATE(2206),
    [sym_process_substitution] = STATE(2206),
    [anon_sym_RBRACE] = ACTIONS(5094),
    [sym__special_characters] = ACTIONS(5096),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(5098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5098),
  },
  [1875] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(5100),
    [sym_comment] = ACTIONS(53),
  },
  [1876] = {
    [sym_concatenation] = STATE(2211),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2211),
    [anon_sym_RBRACE] = ACTIONS(5102),
    [anon_sym_EQ] = ACTIONS(5104),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5106),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(5108),
    [anon_sym_COLON] = ACTIONS(5104),
    [anon_sym_COLON_QMARK] = ACTIONS(5104),
    [anon_sym_COLON_DASH] = ACTIONS(5104),
    [anon_sym_PERCENT] = ACTIONS(5104),
    [anon_sym_DASH] = ACTIONS(5104),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1877] = {
    [sym_concatenation] = STATE(2214),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2214),
    [anon_sym_RBRACE] = ACTIONS(5110),
    [anon_sym_EQ] = ACTIONS(5112),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(5116),
    [anon_sym_COLON] = ACTIONS(5112),
    [anon_sym_COLON_QMARK] = ACTIONS(5112),
    [anon_sym_COLON_DASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [anon_sym_DASH] = ACTIONS(5112),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1878] = {
    [sym_concatenation] = STATE(2216),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2216),
    [anon_sym_RBRACE] = ACTIONS(5094),
    [anon_sym_EQ] = ACTIONS(5118),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5120),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(5122),
    [anon_sym_COLON] = ACTIONS(5118),
    [anon_sym_COLON_QMARK] = ACTIONS(5118),
    [anon_sym_COLON_DASH] = ACTIONS(5118),
    [anon_sym_PERCENT] = ACTIONS(5118),
    [anon_sym_DASH] = ACTIONS(5118),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1879] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [anon_sym_EQ_TILDE] = ACTIONS(1788),
    [anon_sym_EQ_EQ] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(1788),
    [anon_sym_GT] = ACTIONS(1788),
    [anon_sym_BANG_EQ] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1788),
  },
  [1880] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5124),
  },
  [1881] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5126),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1882] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1832),
    [anon_sym_EQ_EQ] = ACTIONS(1832),
    [anon_sym_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1832),
    [anon_sym_GT] = ACTIONS(1832),
    [anon_sym_BANG_EQ] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1832),
  },
  [1883] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5128),
  },
  [1884] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5130),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1885] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_EQ_TILDE] = ACTIONS(1840),
    [anon_sym_EQ_EQ] = ACTIONS(1840),
    [anon_sym_EQ] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1840),
    [anon_sym_GT] = ACTIONS(1840),
    [anon_sym_BANG_EQ] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1840),
  },
  [1886] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5132),
  },
  [1887] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5094),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1888] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_EQ_TILDE] = ACTIONS(1846),
    [anon_sym_EQ_EQ] = ACTIONS(1846),
    [anon_sym_EQ] = ACTIONS(1848),
    [anon_sym_LT] = ACTIONS(1846),
    [anon_sym_GT] = ACTIONS(1846),
    [anon_sym_BANG_EQ] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1846),
  },
  [1889] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5134),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1890] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5134),
    [anon_sym_SEMI_SEMI] = ACTIONS(5136),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5138),
    [anon_sym_LF] = ACTIONS(5136),
    [anon_sym_AMP] = ACTIONS(5138),
  },
  [1891] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5134),
    [anon_sym_SEMI_SEMI] = ACTIONS(5136),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5138),
    [anon_sym_LF] = ACTIONS(5136),
    [anon_sym_AMP] = ACTIONS(5138),
  },
  [1892] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(5134),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1893] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(5140),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(5134),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5142),
    [anon_sym_LF] = ACTIONS(5140),
    [anon_sym_AMP] = ACTIONS(5142),
  },
  [1894] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(5140),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(5134),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5142),
    [anon_sym_LF] = ACTIONS(5140),
    [anon_sym_AMP] = ACTIONS(5142),
  },
  [1895] = {
    [sym__concat] = ACTIONS(1878),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_EQ_TILDE] = ACTIONS(1878),
    [anon_sym_EQ_EQ] = ACTIONS(1878),
    [anon_sym_EQ] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_BANG_EQ] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1878),
  },
  [1896] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5144),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1897] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5144),
    [anon_sym_SEMI_SEMI] = ACTIONS(5146),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5148),
    [anon_sym_LF] = ACTIONS(5146),
    [anon_sym_AMP] = ACTIONS(5148),
  },
  [1898] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5144),
    [anon_sym_SEMI_SEMI] = ACTIONS(5146),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5148),
    [anon_sym_LF] = ACTIONS(5146),
    [anon_sym_AMP] = ACTIONS(5148),
  },
  [1899] = {
    [anon_sym_esac] = ACTIONS(5150),
    [anon_sym_PIPE] = ACTIONS(5152),
    [anon_sym_RPAREN] = ACTIONS(5150),
    [anon_sym_SEMI_SEMI] = ACTIONS(5150),
    [anon_sym_PIPE_AMP] = ACTIONS(5150),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_BQUOTE] = ACTIONS(5150),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5152),
    [anon_sym_LF] = ACTIONS(5150),
    [anon_sym_AMP] = ACTIONS(5152),
  },
  [1900] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2521),
    [anon_sym_AMP_AMP] = ACTIONS(2521),
    [anon_sym_PIPE_PIPE] = ACTIONS(2521),
    [anon_sym_EQ_TILDE] = ACTIONS(2521),
    [anon_sym_EQ_EQ] = ACTIONS(2521),
    [anon_sym_EQ] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_BANG_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2521),
  },
  [1901] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2521),
    [anon_sym_AMP_AMP] = ACTIONS(2521),
    [anon_sym_PIPE_PIPE] = ACTIONS(2521),
    [anon_sym_EQ_TILDE] = ACTIONS(2521),
    [anon_sym_EQ_EQ] = ACTIONS(2521),
    [anon_sym_EQ] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_BANG_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2521),
  },
  [1902] = {
    [sym_do_group] = STATE(2227),
    [sym_compound_statement] = STATE(2227),
    [anon_sym_do] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [sym_comment] = ACTIONS(53),
  },
  [1903] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_esac] = ACTIONS(3903),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_EQ_TILDE] = ACTIONS(3903),
    [anon_sym_EQ_EQ] = ACTIONS(3903),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3903),
    [anon_sym_GT] = ACTIONS(3903),
    [anon_sym_BANG_EQ] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3903),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [1904] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_esac] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_EQ_TILDE] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_EQ] = ACTIONS(3913),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3911),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3913),
  },
  [1905] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5154),
    [sym_comment] = ACTIONS(53),
  },
  [1906] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5156),
    [sym_comment] = ACTIONS(53),
  },
  [1907] = {
    [anon_sym_RBRACE] = ACTIONS(5156),
    [sym_comment] = ACTIONS(53),
  },
  [1908] = {
    [sym_concatenation] = STATE(2231),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2231),
    [anon_sym_RBRACE] = ACTIONS(5158),
    [anon_sym_EQ] = ACTIONS(5160),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5160),
    [anon_sym_COLON_QMARK] = ACTIONS(5160),
    [anon_sym_COLON_DASH] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5160),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1909] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_esac] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [anon_sym_PIPE_AMP] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_EQ_TILDE] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_EQ] = ACTIONS(3977),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3975),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3977),
  },
  [1910] = {
    [sym_concatenation] = STATE(2233),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2233),
    [anon_sym_RBRACE] = ACTIONS(5164),
    [anon_sym_EQ] = ACTIONS(5166),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5166),
    [anon_sym_COLON_QMARK] = ACTIONS(5166),
    [anon_sym_COLON_DASH] = ACTIONS(5166),
    [anon_sym_PERCENT] = ACTIONS(5166),
    [anon_sym_DASH] = ACTIONS(5166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1911] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_esac] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3985),
    [anon_sym_GT] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [1912] = {
    [sym_concatenation] = STATE(2235),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2235),
    [anon_sym_RBRACE] = ACTIONS(5170),
    [anon_sym_EQ] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5174),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5172),
    [anon_sym_COLON_QMARK] = ACTIONS(5172),
    [anon_sym_COLON_DASH] = ACTIONS(5172),
    [anon_sym_PERCENT] = ACTIONS(5172),
    [anon_sym_DASH] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1913] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_esac] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [anon_sym_PIPE_AMP] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_EQ_TILDE] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_EQ] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [1914] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5176),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1915] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_esac] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_EQ_TILDE] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_GT] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [1916] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5178),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1917] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_esac] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [anon_sym_PIPE_AMP] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4068),
    [anon_sym_GT] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4068),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [1918] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5180),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1919] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_esac] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_EQ_TILDE] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4074),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [1920] = {
    [sym__concat] = ACTIONS(4098),
    [anon_sym_esac] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [anon_sym_PIPE_AMP] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_EQ_TILDE] = ACTIONS(4098),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_EQ] = ACTIONS(4100),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_GT] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4098),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
  },
  [1921] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5182),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_PIPE_PIPE] = ACTIONS(3320),
    [anon_sym_EQ_TILDE] = ACTIONS(3322),
    [anon_sym_EQ_EQ] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_GT] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3320),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3320),
  },
  [1922] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
  },
  [1923] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2869),
  },
  [1924] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5184),
    [sym_comment] = ACTIONS(53),
  },
  [1925] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5186),
    [sym_comment] = ACTIONS(53),
  },
  [1926] = {
    [anon_sym_RBRACE] = ACTIONS(5186),
    [sym_comment] = ACTIONS(53),
  },
  [1927] = {
    [sym_concatenation] = STATE(2244),
    [sym_string] = STATE(2243),
    [sym_simple_expansion] = STATE(2243),
    [sym_string_expansion] = STATE(2243),
    [sym_expansion] = STATE(2243),
    [sym_command_substitution] = STATE(2243),
    [sym_process_substitution] = STATE(2243),
    [anon_sym_RBRACE] = ACTIONS(5186),
    [sym__special_characters] = ACTIONS(5188),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(5190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5190),
  },
  [1928] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2905),
  },
  [1929] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5192),
  },
  [1930] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1931] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [sym__special_characters] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
  },
  [1932] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5196),
  },
  [1933] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5198),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1934] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5200),
  },
  [1935] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5186),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1936] = {
    [sym_concatenation] = STATE(2251),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2251),
    [anon_sym_RBRACE] = ACTIONS(5202),
    [anon_sym_EQ] = ACTIONS(5204),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5204),
    [anon_sym_COLON_QMARK] = ACTIONS(5204),
    [anon_sym_COLON_DASH] = ACTIONS(5204),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(5204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1937] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [sym__special_characters] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
  },
  [1938] = {
    [sym_concatenation] = STATE(2253),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2253),
    [anon_sym_RBRACE] = ACTIONS(5208),
    [anon_sym_EQ] = ACTIONS(5210),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5212),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5210),
    [anon_sym_COLON_QMARK] = ACTIONS(5210),
    [anon_sym_COLON_DASH] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_DASH] = ACTIONS(5210),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1939] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [sym__special_characters] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3030),
  },
  [1940] = {
    [sym_concatenation] = STATE(2255),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2255),
    [anon_sym_RBRACE] = ACTIONS(5214),
    [anon_sym_EQ] = ACTIONS(5216),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5218),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5216),
    [anon_sym_COLON_QMARK] = ACTIONS(5216),
    [anon_sym_COLON_DASH] = ACTIONS(5216),
    [anon_sym_PERCENT] = ACTIONS(5216),
    [anon_sym_DASH] = ACTIONS(5216),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1941] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3040),
  },
  [1942] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5220),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1943] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(5220),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1944] = {
    [sym__concat] = ACTIONS(3078),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [sym__special_characters] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3078),
  },
  [1945] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5222),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [1946] = {
    [sym__terminated_statement] = STATE(1069),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1069),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(5224),
    [anon_sym_elif] = ACTIONS(5224),
    [anon_sym_else] = ACTIONS(5224),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1947] = {
    [anon_sym_esac] = ACTIONS(5226),
    [anon_sym_PIPE] = ACTIONS(5228),
    [anon_sym_RPAREN] = ACTIONS(5226),
    [anon_sym_SEMI_SEMI] = ACTIONS(5226),
    [anon_sym_PIPE_AMP] = ACTIONS(5226),
    [anon_sym_AMP_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5226),
    [anon_sym_BQUOTE] = ACTIONS(5226),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5228),
    [anon_sym_LF] = ACTIONS(5226),
    [anon_sym_AMP] = ACTIONS(5228),
  },
  [1948] = {
    [aux_sym_concatenation_repeat1] = STATE(1547),
    [sym__concat] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_RPAREN] = ACTIONS(5230),
    [sym_comment] = ACTIONS(53),
  },
  [1949] = {
    [aux_sym_concatenation_repeat1] = STATE(1547),
    [sym__concat] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(5232),
    [anon_sym_RPAREN] = ACTIONS(5232),
    [sym_comment] = ACTIONS(53),
  },
  [1950] = {
    [anon_sym_PIPE] = ACTIONS(5232),
    [anon_sym_RPAREN] = ACTIONS(5232),
    [sym_comment] = ACTIONS(53),
  },
  [1951] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(5234),
    [anon_sym_PLUS_EQ] = ACTIONS(5234),
    [sym_comment] = ACTIONS(53),
  },
  [1952] = {
    [sym__terminated_statement] = STATE(2259),
    [sym_for_statement] = STATE(40),
    [sym_c_style_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_subshell] = STATE(40),
    [sym_pipeline] = STATE(40),
    [sym_list] = STATE(40),
    [sym_negated_command] = STATE(40),
    [sym_test_command] = STATE(40),
    [sym_declaration_command] = STATE(40),
    [sym_unset_command] = STATE(40),
    [sym_command] = STATE(40),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(41),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1953] = {
    [anon_sym_esac] = ACTIONS(5236),
    [sym__special_characters] = ACTIONS(5238),
    [anon_sym_DQUOTE] = ACTIONS(5238),
    [anon_sym_DOLLAR] = ACTIONS(5240),
    [sym_raw_string] = ACTIONS(5238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5238),
    [anon_sym_BQUOTE] = ACTIONS(5238),
    [anon_sym_LT_LPAREN] = ACTIONS(5238),
    [anon_sym_GT_LPAREN] = ACTIONS(5238),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5240),
  },
  [1954] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5242),
  },
  [1955] = {
    [sym_subshell] = STATE(71),
    [sym_test_command] = STATE(71),
    [sym_command] = STATE(71),
    [sym_command_name] = STATE(1970),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(72),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_command_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4464),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4470),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4476),
  },
  [1956] = {
    [sym__expression] = STATE(2261),
    [sym_binary_expression] = STATE(2261),
    [sym_unary_expression] = STATE(2261),
    [sym_parenthesized_expression] = STATE(2261),
    [sym_concatenation] = STATE(2261),
    [sym_string] = STATE(78),
    [sym_simple_expansion] = STATE(78),
    [sym_string_expansion] = STATE(78),
    [sym_expansion] = STATE(78),
    [sym_command_substitution] = STATE(78),
    [sym_process_substitution] = STATE(78),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [sym__special_characters] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR] = ACTIONS(119),
    [sym_raw_string] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(131),
    [sym_test_operator] = ACTIONS(133),
  },
  [1957] = {
    [sym__expression] = STATE(2262),
    [sym_binary_expression] = STATE(2262),
    [sym_unary_expression] = STATE(2262),
    [sym_parenthesized_expression] = STATE(2262),
    [sym_concatenation] = STATE(2262),
    [sym_string] = STATE(89),
    [sym_simple_expansion] = STATE(89),
    [sym_string_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [sym_process_substitution] = STATE(89),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [sym__special_characters] = ACTIONS(139),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym_raw_string] = ACTIONS(145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_LT_LPAREN] = ACTIONS(153),
    [anon_sym_GT_LPAREN] = ACTIONS(153),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(155),
    [sym_test_operator] = ACTIONS(157),
  },
  [1958] = {
    [sym_variable_assignment] = STATE(2274),
    [sym_subscript] = STATE(2273),
    [sym_concatenation] = STATE(2274),
    [sym_string] = STATE(2267),
    [sym_simple_expansion] = STATE(2267),
    [sym_string_expansion] = STATE(2267),
    [sym_expansion] = STATE(2267),
    [sym_command_substitution] = STATE(2267),
    [sym_process_substitution] = STATE(2267),
    [aux_sym_declaration_command_repeat1] = STATE(2274),
    [sym_variable_name] = ACTIONS(5244),
    [anon_sym_esac] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_SEMI_SEMI] = ACTIONS(163),
    [anon_sym_PIPE_AMP] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [sym__special_characters] = ACTIONS(5246),
    [anon_sym_DQUOTE] = ACTIONS(5248),
    [anon_sym_DOLLAR] = ACTIONS(5250),
    [sym_raw_string] = ACTIONS(5252),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5256),
    [anon_sym_BQUOTE] = ACTIONS(5258),
    [anon_sym_LT_LPAREN] = ACTIONS(5260),
    [anon_sym_GT_LPAREN] = ACTIONS(5260),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5262),
    [sym_word] = ACTIONS(5264),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_LF] = ACTIONS(163),
    [anon_sym_AMP] = ACTIONS(161),
  },
  [1959] = {
    [sym_concatenation] = STATE(2284),
    [sym_string] = STATE(2278),
    [sym_simple_expansion] = STATE(2278),
    [sym_string_expansion] = STATE(2278),
    [sym_expansion] = STATE(2278),
    [sym_command_substitution] = STATE(2278),
    [sym_process_substitution] = STATE(2278),
    [aux_sym_unset_command_repeat1] = STATE(2284),
    [anon_sym_esac] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym__special_characters] = ACTIONS(5266),
    [anon_sym_DQUOTE] = ACTIONS(5268),
    [anon_sym_DOLLAR] = ACTIONS(5270),
    [sym_raw_string] = ACTIONS(5272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5274),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5276),
    [anon_sym_BQUOTE] = ACTIONS(5278),
    [anon_sym_LT_LPAREN] = ACTIONS(5280),
    [anon_sym_GT_LPAREN] = ACTIONS(5280),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5282),
    [sym_word] = ACTIONS(5284),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_LF] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [1960] = {
    [aux_sym_concatenation_repeat1] = STATE(2286),
    [sym__simple_heredoc_body] = ACTIONS(225),
    [sym__heredoc_body_beginning] = ACTIONS(225),
    [sym_file_descriptor] = ACTIONS(225),
    [sym__concat] = ACTIONS(5286),
    [anon_sym_esac] = ACTIONS(229),
    [anon_sym_PIPE] = ACTIONS(229),
    [anon_sym_SEMI_SEMI] = ACTIONS(225),
    [anon_sym_PIPE_AMP] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_EQ_TILDE] = ACTIONS(229),
    [anon_sym_EQ_EQ] = ACTIONS(229),
    [anon_sym_LT] = ACTIONS(229),
    [anon_sym_GT] = ACTIONS(229),
    [anon_sym_GT_GT] = ACTIONS(225),
    [anon_sym_AMP_GT] = ACTIONS(229),
    [anon_sym_AMP_GT_GT] = ACTIONS(225),
    [anon_sym_LT_AMP] = ACTIONS(225),
    [anon_sym_GT_AMP] = ACTIONS(225),
    [anon_sym_LT_LT] = ACTIONS(229),
    [anon_sym_LT_LT_DASH] = ACTIONS(225),
    [anon_sym_LT_LT_LT] = ACTIONS(225),
    [sym__special_characters] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(229),
    [anon_sym_LF] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(229),
  },
  [1961] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(2289),
    [anon_sym_DQUOTE] = ACTIONS(5288),
    [anon_sym_DOLLAR] = ACTIONS(5290),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [1962] = {
    [sym_string] = STATE(2291),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(5292),
    [sym_raw_string] = ACTIONS(5294),
    [anon_sym_POUND] = ACTIONS(5292),
    [anon_sym_DASH] = ACTIONS(5292),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_AT] = ACTIONS(5292),
    [anon_sym_QMARK] = ACTIONS(5292),
    [anon_sym_0] = ACTIONS(5298),
    [anon_sym__] = ACTIONS(5298),
  },
  [1963] = {
    [aux_sym_concatenation_repeat1] = STATE(2286),
    [sym__simple_heredoc_body] = ACTIONS(253),
    [sym__heredoc_body_beginning] = ACTIONS(253),
    [sym_file_descriptor] = ACTIONS(253),
    [sym__concat] = ACTIONS(5286),
    [anon_sym_esac] = ACTIONS(255),
    [anon_sym_PIPE] = ACTIONS(255),
    [anon_sym_SEMI_SEMI] = ACTIONS(253),
    [anon_sym_PIPE_AMP] = ACTIONS(253),
    [anon_sym_AMP_AMP] = ACTIONS(253),
    [anon_sym_PIPE_PIPE] = ACTIONS(253),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(255),
    [anon_sym_GT] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(253),
    [anon_sym_AMP_GT] = ACTIONS(255),
    [anon_sym_AMP_GT_GT] = ACTIONS(253),
    [anon_sym_LT_AMP] = ACTIONS(253),
    [anon_sym_GT_AMP] = ACTIONS(253),
    [anon_sym_LT_LT] = ACTIONS(255),
    [anon_sym_LT_LT_DASH] = ACTIONS(253),
    [anon_sym_LT_LT_LT] = ACTIONS(253),
    [sym__special_characters] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(255),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(253),
    [anon_sym_LT_LPAREN] = ACTIONS(253),
    [anon_sym_GT_LPAREN] = ACTIONS(253),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LF] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(255),
  },
  [1964] = {
    [sym_subscript] = STATE(2297),
    [sym_variable_name] = ACTIONS(5300),
    [anon_sym_BANG] = ACTIONS(5302),
    [anon_sym_DOLLAR] = ACTIONS(5304),
    [anon_sym_POUND] = ACTIONS(5302),
    [anon_sym_DASH] = ACTIONS(5304),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5306),
    [anon_sym_STAR] = ACTIONS(5304),
    [anon_sym_AT] = ACTIONS(5304),
    [anon_sym_QMARK] = ACTIONS(5304),
    [anon_sym_0] = ACTIONS(5308),
    [anon_sym__] = ACTIONS(5308),
  },
  [1965] = {
    [sym__terminated_statement] = STATE(2300),
    [sym_for_statement] = STATE(2298),
    [sym_c_style_for_statement] = STATE(2298),
    [sym_while_statement] = STATE(2298),
    [sym_if_statement] = STATE(2298),
    [sym_case_statement] = STATE(2298),
    [sym_function_definition] = STATE(2298),
    [sym_subshell] = STATE(2298),
    [sym_pipeline] = STATE(2298),
    [sym_list] = STATE(2298),
    [sym_negated_command] = STATE(2298),
    [sym_test_command] = STATE(2298),
    [sym_declaration_command] = STATE(2298),
    [sym_unset_command] = STATE(2298),
    [sym_command] = STATE(2298),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2299),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(2300),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1966] = {
    [sym__terminated_statement] = STATE(2303),
    [sym_for_statement] = STATE(2301),
    [sym_c_style_for_statement] = STATE(2301),
    [sym_while_statement] = STATE(2301),
    [sym_if_statement] = STATE(2301),
    [sym_case_statement] = STATE(2301),
    [sym_function_definition] = STATE(2301),
    [sym_subshell] = STATE(2301),
    [sym_pipeline] = STATE(2301),
    [sym_list] = STATE(2301),
    [sym_negated_command] = STATE(2301),
    [sym_test_command] = STATE(2301),
    [sym_declaration_command] = STATE(2301),
    [sym_unset_command] = STATE(2301),
    [sym_command] = STATE(2301),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(2302),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2303),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [1967] = {
    [sym__terminated_statement] = STATE(2306),
    [sym_for_statement] = STATE(2304),
    [sym_c_style_for_statement] = STATE(2304),
    [sym_while_statement] = STATE(2304),
    [sym_if_statement] = STATE(2304),
    [sym_case_statement] = STATE(2304),
    [sym_function_definition] = STATE(2304),
    [sym_subshell] = STATE(2304),
    [sym_pipeline] = STATE(2304),
    [sym_list] = STATE(2304),
    [sym_negated_command] = STATE(2304),
    [sym_test_command] = STATE(2304),
    [sym_declaration_command] = STATE(2304),
    [sym_unset_command] = STATE(2304),
    [sym_command] = STATE(2304),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2305),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(2306),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [1968] = {
    [aux_sym_concatenation_repeat1] = STATE(2286),
    [sym__simple_heredoc_body] = ACTIONS(253),
    [sym__heredoc_body_beginning] = ACTIONS(253),
    [sym_file_descriptor] = ACTIONS(253),
    [sym__concat] = ACTIONS(5286),
    [anon_sym_esac] = ACTIONS(255),
    [anon_sym_PIPE] = ACTIONS(255),
    [anon_sym_SEMI_SEMI] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [anon_sym_PIPE_AMP] = ACTIONS(253),
    [anon_sym_AMP_AMP] = ACTIONS(253),
    [anon_sym_PIPE_PIPE] = ACTIONS(253),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(255),
    [anon_sym_GT] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(253),
    [anon_sym_AMP_GT] = ACTIONS(255),
    [anon_sym_AMP_GT_GT] = ACTIONS(253),
    [anon_sym_LT_AMP] = ACTIONS(253),
    [anon_sym_GT_AMP] = ACTIONS(253),
    [anon_sym_LT_LT] = ACTIONS(255),
    [anon_sym_LT_LT_DASH] = ACTIONS(253),
    [anon_sym_LT_LT_LT] = ACTIONS(253),
    [sym__special_characters] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(255),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(253),
    [anon_sym_LT_LPAREN] = ACTIONS(253),
    [anon_sym_GT_LPAREN] = ACTIONS(253),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LF] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(255),
  },
  [1969] = {
    [anon_sym_esac] = ACTIONS(5312),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5316),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [1970] = {
    [sym_file_redirect] = STATE(2318),
    [sym_heredoc_redirect] = STATE(2318),
    [sym_heredoc_body] = STATE(175),
    [sym_herestring_redirect] = STATE(2318),
    [sym_concatenation] = STATE(2319),
    [sym_string] = STATE(2317),
    [sym_simple_expansion] = STATE(2317),
    [sym_string_expansion] = STATE(2317),
    [sym_expansion] = STATE(2317),
    [sym_command_substitution] = STATE(2317),
    [sym_process_substitution] = STATE(2317),
    [aux_sym_while_statement_repeat1] = STATE(2318),
    [aux_sym_command_repeat2] = STATE(2319),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(5326),
    [anon_sym_esac] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_SEMI_SEMI] = ACTIONS(305),
    [anon_sym_PIPE_AMP] = ACTIONS(305),
    [anon_sym_AMP_AMP] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(305),
    [anon_sym_EQ_TILDE] = ACTIONS(5328),
    [anon_sym_EQ_EQ] = ACTIONS(5328),
    [anon_sym_LT] = ACTIONS(5330),
    [anon_sym_GT] = ACTIONS(5330),
    [anon_sym_GT_GT] = ACTIONS(5332),
    [anon_sym_AMP_GT] = ACTIONS(5330),
    [anon_sym_AMP_GT_GT] = ACTIONS(5332),
    [anon_sym_LT_AMP] = ACTIONS(5332),
    [anon_sym_GT_AMP] = ACTIONS(5332),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(5334),
    [sym__special_characters] = ACTIONS(5336),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(5338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5340),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_LF] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(303),
  },
  [1971] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_esac] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5316),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [1972] = {
    [anon_sym_EQ] = ACTIONS(5234),
    [anon_sym_PLUS_EQ] = ACTIONS(5234),
    [sym_comment] = ACTIONS(53),
  },
  [1973] = {
    [sym__simple_heredoc_body] = ACTIONS(253),
    [sym__heredoc_body_beginning] = ACTIONS(253),
    [sym_file_descriptor] = ACTIONS(253),
    [anon_sym_esac] = ACTIONS(255),
    [anon_sym_PIPE] = ACTIONS(255),
    [anon_sym_SEMI_SEMI] = ACTIONS(253),
    [anon_sym_PIPE_AMP] = ACTIONS(253),
    [anon_sym_AMP_AMP] = ACTIONS(253),
    [anon_sym_PIPE_PIPE] = ACTIONS(253),
    [anon_sym_EQ_TILDE] = ACTIONS(255),
    [anon_sym_EQ_EQ] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(255),
    [anon_sym_GT] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(253),
    [anon_sym_AMP_GT] = ACTIONS(255),
    [anon_sym_AMP_GT_GT] = ACTIONS(253),
    [anon_sym_LT_AMP] = ACTIONS(253),
    [anon_sym_GT_AMP] = ACTIONS(253),
    [anon_sym_LT_LT] = ACTIONS(255),
    [anon_sym_LT_LT_DASH] = ACTIONS(253),
    [anon_sym_LT_LT_LT] = ACTIONS(253),
    [sym__special_characters] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(255),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(253),
    [anon_sym_LT_LPAREN] = ACTIONS(253),
    [anon_sym_GT_LPAREN] = ACTIONS(253),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LF] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(255),
  },
  [1974] = {
    [sym__terminated_statement] = STATE(2323),
    [sym_for_statement] = STATE(2321),
    [sym_c_style_for_statement] = STATE(2321),
    [sym_while_statement] = STATE(2321),
    [sym_if_statement] = STATE(2321),
    [sym_case_statement] = STATE(2321),
    [sym_function_definition] = STATE(2321),
    [sym_subshell] = STATE(2321),
    [sym_pipeline] = STATE(2321),
    [sym_list] = STATE(2321),
    [sym_negated_command] = STATE(2321),
    [sym_test_command] = STATE(2321),
    [sym_declaration_command] = STATE(2321),
    [sym_unset_command] = STATE(2321),
    [sym_command] = STATE(2321),
    [sym_command_name] = STATE(1970),
    [sym_variable_assignment] = STATE(2322),
    [sym_subscript] = STATE(1972),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_program_repeat1] = STATE(2323),
    [aux_sym_command_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4450),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4452),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5236),
    [anon_sym_SEMI_SEMI] = ACTIONS(5342),
    [anon_sym_function] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4464),
    [anon_sym_declare] = ACTIONS(4466),
    [anon_sym_typeset] = ACTIONS(4466),
    [anon_sym_export] = ACTIONS(4466),
    [anon_sym_readonly] = ACTIONS(4466),
    [anon_sym_local] = ACTIONS(4466),
    [anon_sym_unset] = ACTIONS(4468),
    [anon_sym_unsetenv] = ACTIONS(4468),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4470),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4486),
  },
  [1975] = {
    [sym_command_name] = STATE(2324),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(72),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_command_repeat1] = STATE(180),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(5344),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4476),
  },
  [1976] = {
    [sym__terminated_statement] = STATE(2325),
    [sym_for_statement] = STATE(2321),
    [sym_c_style_for_statement] = STATE(2321),
    [sym_while_statement] = STATE(2321),
    [sym_if_statement] = STATE(2321),
    [sym_case_statement] = STATE(2321),
    [sym_function_definition] = STATE(2321),
    [sym_subshell] = STATE(2321),
    [sym_pipeline] = STATE(2321),
    [sym_list] = STATE(2321),
    [sym_negated_command] = STATE(2321),
    [sym_test_command] = STATE(2321),
    [sym_declaration_command] = STATE(2321),
    [sym_unset_command] = STATE(2321),
    [sym_command] = STATE(2321),
    [sym_command_name] = STATE(1970),
    [sym_variable_assignment] = STATE(2322),
    [sym_subscript] = STATE(1972),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_program_repeat1] = STATE(2325),
    [aux_sym_command_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4450),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4452),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5236),
    [anon_sym_SEMI_SEMI] = ACTIONS(5342),
    [anon_sym_function] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4464),
    [anon_sym_declare] = ACTIONS(4466),
    [anon_sym_typeset] = ACTIONS(4466),
    [anon_sym_export] = ACTIONS(4466),
    [anon_sym_readonly] = ACTIONS(4466),
    [anon_sym_local] = ACTIONS(4466),
    [anon_sym_unset] = ACTIONS(4468),
    [anon_sym_unsetenv] = ACTIONS(4468),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4470),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4486),
  },
  [1977] = {
    [aux_sym_case_item_repeat1] = STATE(1977),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_RPAREN] = ACTIONS(5232),
    [sym_comment] = ACTIONS(53),
  },
  [1978] = {
    [aux_sym_concatenation_repeat1] = STATE(1978),
    [sym__concat] = ACTIONS(2555),
    [anon_sym_PIPE] = ACTIONS(1664),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
  },
  [1979] = {
    [anon_sym_esac] = ACTIONS(5349),
    [sym__special_characters] = ACTIONS(5351),
    [anon_sym_DQUOTE] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5353),
    [sym_raw_string] = ACTIONS(5351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5351),
    [anon_sym_BQUOTE] = ACTIONS(5351),
    [anon_sym_LT_LPAREN] = ACTIONS(5351),
    [anon_sym_GT_LPAREN] = ACTIONS(5351),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5353),
  },
  [1980] = {
    [anon_sym_esac] = ACTIONS(5355),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5357),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [1981] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_esac] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5357),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [1982] = {
    [sym__terminated_statement] = STATE(2323),
    [sym_for_statement] = STATE(2328),
    [sym_c_style_for_statement] = STATE(2328),
    [sym_while_statement] = STATE(2328),
    [sym_if_statement] = STATE(2328),
    [sym_case_statement] = STATE(2328),
    [sym_function_definition] = STATE(2328),
    [sym_subshell] = STATE(2328),
    [sym_pipeline] = STATE(2328),
    [sym_list] = STATE(2328),
    [sym_negated_command] = STATE(2328),
    [sym_test_command] = STATE(2328),
    [sym_declaration_command] = STATE(2328),
    [sym_unset_command] = STATE(2328),
    [sym_command] = STATE(2328),
    [sym_command_name] = STATE(1970),
    [sym_variable_assignment] = STATE(2329),
    [sym_subscript] = STATE(1972),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_program_repeat1] = STATE(2323),
    [aux_sym_command_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4450),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4452),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5349),
    [anon_sym_SEMI_SEMI] = ACTIONS(5359),
    [anon_sym_function] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4464),
    [anon_sym_declare] = ACTIONS(4466),
    [anon_sym_typeset] = ACTIONS(4466),
    [anon_sym_export] = ACTIONS(4466),
    [anon_sym_readonly] = ACTIONS(4466),
    [anon_sym_local] = ACTIONS(4466),
    [anon_sym_unset] = ACTIONS(4468),
    [anon_sym_unsetenv] = ACTIONS(4468),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4470),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4486),
  },
  [1983] = {
    [sym__terminated_statement] = STATE(2330),
    [sym_for_statement] = STATE(2328),
    [sym_c_style_for_statement] = STATE(2328),
    [sym_while_statement] = STATE(2328),
    [sym_if_statement] = STATE(2328),
    [sym_case_statement] = STATE(2328),
    [sym_function_definition] = STATE(2328),
    [sym_subshell] = STATE(2328),
    [sym_pipeline] = STATE(2328),
    [sym_list] = STATE(2328),
    [sym_negated_command] = STATE(2328),
    [sym_test_command] = STATE(2328),
    [sym_declaration_command] = STATE(2328),
    [sym_unset_command] = STATE(2328),
    [sym_command] = STATE(2328),
    [sym_command_name] = STATE(1970),
    [sym_variable_assignment] = STATE(2329),
    [sym_subscript] = STATE(1972),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_program_repeat1] = STATE(2330),
    [aux_sym_command_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4450),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4452),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5349),
    [anon_sym_SEMI_SEMI] = ACTIONS(5359),
    [anon_sym_function] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4464),
    [anon_sym_declare] = ACTIONS(4466),
    [anon_sym_typeset] = ACTIONS(4466),
    [anon_sym_export] = ACTIONS(4466),
    [anon_sym_readonly] = ACTIONS(4466),
    [anon_sym_local] = ACTIONS(4466),
    [anon_sym_unset] = ACTIONS(4468),
    [anon_sym_unsetenv] = ACTIONS(4468),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4470),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4486),
  },
  [1984] = {
    [anon_sym_esac] = ACTIONS(5361),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5361),
    [anon_sym_SEMI_SEMI] = ACTIONS(5361),
    [anon_sym_PIPE_AMP] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_BQUOTE] = ACTIONS(5361),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5363),
    [anon_sym_LF] = ACTIONS(5361),
    [anon_sym_AMP] = ACTIONS(5363),
  },
  [1985] = {
    [aux_sym_case_item_repeat1] = STATE(2332),
    [aux_sym_concatenation_repeat1] = STATE(1547),
    [sym__concat] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [sym_comment] = ACTIONS(53),
  },
  [1986] = {
    [aux_sym_case_item_repeat1] = STATE(2334),
    [aux_sym_concatenation_repeat1] = STATE(1547),
    [sym__concat] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(5367),
    [sym_comment] = ACTIONS(53),
  },
  [1987] = {
    [aux_sym_case_item_repeat1] = STATE(2334),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(5367),
    [sym_comment] = ACTIONS(53),
  },
  [1988] = {
    [anon_sym_esac] = ACTIONS(5369),
    [sym_comment] = ACTIONS(53),
  },
  [1989] = {
    [anon_sym_esac] = ACTIONS(5371),
    [anon_sym_PIPE] = ACTIONS(5373),
    [anon_sym_RPAREN] = ACTIONS(5371),
    [anon_sym_SEMI_SEMI] = ACTIONS(5371),
    [anon_sym_PIPE_AMP] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5371),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_BQUOTE] = ACTIONS(5371),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5373),
    [anon_sym_LF] = ACTIONS(5371),
    [anon_sym_AMP] = ACTIONS(5373),
  },
  [1990] = {
    [anon_sym_esac] = ACTIONS(5375),
    [sym_comment] = ACTIONS(53),
  },
  [1991] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_in] = ACTIONS(4885),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4885),
  },
  [1992] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_in] = ACTIONS(4889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4889),
  },
  [1993] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_in] = ACTIONS(4893),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4893),
  },
  [1994] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5377),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1995] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_in] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4899),
  },
  [1996] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5379),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1997] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_in] = ACTIONS(4905),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4905),
  },
  [1998] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5381),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [1999] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_in] = ACTIONS(4947),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4947),
  },
  [2000] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_in] = ACTIONS(4955),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
  },
  [2001] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_in] = ACTIONS(4959),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4959),
  },
  [2002] = {
    [aux_sym_concatenation_repeat1] = STATE(2002),
    [sym__concat] = ACTIONS(2679),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2003] = {
    [aux_sym_concatenation_repeat1] = STATE(2005),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_RPAREN] = ACTIONS(981),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [2004] = {
    [aux_sym_concatenation_repeat1] = STATE(2005),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(985),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [2005] = {
    [aux_sym_concatenation_repeat1] = STATE(2340),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [2006] = {
    [aux_sym_concatenation_repeat1] = STATE(2008),
    [sym_file_descriptor] = ACTIONS(981),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_RPAREN] = ACTIONS(981),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(981),
    [anon_sym_LT_AMP] = ACTIONS(981),
    [anon_sym_GT_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(981),
    [anon_sym_LT_LT_LT] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [2007] = {
    [aux_sym_concatenation_repeat1] = STATE(2008),
    [sym_file_descriptor] = ACTIONS(985),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(985),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_DASH] = ACTIONS(985),
    [anon_sym_LT_LT_LT] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [2008] = {
    [aux_sym_concatenation_repeat1] = STATE(2341),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [2009] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_RBRACK] = ACTIONS(4885),
    [anon_sym_EQ_TILDE] = ACTIONS(4885),
    [anon_sym_EQ_EQ] = ACTIONS(4885),
    [anon_sym_EQ] = ACTIONS(4887),
    [anon_sym_LT] = ACTIONS(4885),
    [anon_sym_GT] = ACTIONS(4885),
    [anon_sym_BANG_EQ] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4885),
  },
  [2010] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_RBRACK] = ACTIONS(4889),
    [anon_sym_EQ_TILDE] = ACTIONS(4889),
    [anon_sym_EQ_EQ] = ACTIONS(4889),
    [anon_sym_EQ] = ACTIONS(4891),
    [anon_sym_LT] = ACTIONS(4889),
    [anon_sym_GT] = ACTIONS(4889),
    [anon_sym_BANG_EQ] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4889),
  },
  [2011] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [anon_sym_RBRACK] = ACTIONS(4893),
    [anon_sym_EQ_TILDE] = ACTIONS(4893),
    [anon_sym_EQ_EQ] = ACTIONS(4893),
    [anon_sym_EQ] = ACTIONS(4895),
    [anon_sym_LT] = ACTIONS(4893),
    [anon_sym_GT] = ACTIONS(4893),
    [anon_sym_BANG_EQ] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4893),
  },
  [2012] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5383),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2013] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [anon_sym_RBRACK] = ACTIONS(4899),
    [anon_sym_EQ_TILDE] = ACTIONS(4899),
    [anon_sym_EQ_EQ] = ACTIONS(4899),
    [anon_sym_EQ] = ACTIONS(4901),
    [anon_sym_LT] = ACTIONS(4899),
    [anon_sym_GT] = ACTIONS(4899),
    [anon_sym_BANG_EQ] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4899),
  },
  [2014] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2015] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_RBRACK] = ACTIONS(4905),
    [anon_sym_EQ_TILDE] = ACTIONS(4905),
    [anon_sym_EQ_EQ] = ACTIONS(4905),
    [anon_sym_EQ] = ACTIONS(4907),
    [anon_sym_LT] = ACTIONS(4905),
    [anon_sym_GT] = ACTIONS(4905),
    [anon_sym_BANG_EQ] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4905),
  },
  [2016] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5387),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2017] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_RBRACK] = ACTIONS(4947),
    [anon_sym_EQ_TILDE] = ACTIONS(4947),
    [anon_sym_EQ_EQ] = ACTIONS(4947),
    [anon_sym_EQ] = ACTIONS(4949),
    [anon_sym_LT] = ACTIONS(4947),
    [anon_sym_GT] = ACTIONS(4947),
    [anon_sym_BANG_EQ] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4947),
  },
  [2018] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [anon_sym_RBRACK] = ACTIONS(4955),
    [anon_sym_EQ_TILDE] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4955),
    [anon_sym_EQ] = ACTIONS(4957),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_BANG_EQ] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4955),
  },
  [2019] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [anon_sym_RBRACK] = ACTIONS(4959),
    [anon_sym_EQ_TILDE] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4959),
    [anon_sym_EQ] = ACTIONS(4961),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_BANG_EQ] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4959),
  },
  [2020] = {
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1664),
    [anon_sym_esac] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2021] = {
    [aux_sym_concatenation_repeat1] = STATE(2021),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(5389),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2022] = {
    [sym_file_descriptor] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1673),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1673),
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1673),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1673),
  },
  [2023] = {
    [anon_sym_DQUOTE] = ACTIONS(5392),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [2024] = {
    [sym_concatenation] = STATE(2349),
    [sym_string] = STATE(2348),
    [sym_simple_expansion] = STATE(2348),
    [sym_string_expansion] = STATE(2348),
    [sym_expansion] = STATE(2348),
    [sym_command_substitution] = STATE(2348),
    [sym_process_substitution] = STATE(2348),
    [anon_sym_RBRACE] = ACTIONS(5394),
    [sym__special_characters] = ACTIONS(5396),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(5398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5398),
  },
  [2025] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(5400),
    [sym_comment] = ACTIONS(53),
  },
  [2026] = {
    [sym_concatenation] = STATE(2353),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2353),
    [anon_sym_RBRACE] = ACTIONS(5402),
    [anon_sym_EQ] = ACTIONS(5404),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(5408),
    [anon_sym_COLON] = ACTIONS(5404),
    [anon_sym_COLON_QMARK] = ACTIONS(5404),
    [anon_sym_COLON_DASH] = ACTIONS(5404),
    [anon_sym_PERCENT] = ACTIONS(5404),
    [anon_sym_DASH] = ACTIONS(5404),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2027] = {
    [sym_concatenation] = STATE(2356),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2356),
    [anon_sym_RBRACE] = ACTIONS(5410),
    [anon_sym_EQ] = ACTIONS(5412),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(5416),
    [anon_sym_COLON] = ACTIONS(5412),
    [anon_sym_COLON_QMARK] = ACTIONS(5412),
    [anon_sym_COLON_DASH] = ACTIONS(5412),
    [anon_sym_PERCENT] = ACTIONS(5412),
    [anon_sym_DASH] = ACTIONS(5412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2028] = {
    [sym_concatenation] = STATE(2358),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2358),
    [anon_sym_RBRACE] = ACTIONS(5394),
    [anon_sym_EQ] = ACTIONS(5418),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5420),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(5422),
    [anon_sym_COLON] = ACTIONS(5418),
    [anon_sym_COLON_QMARK] = ACTIONS(5418),
    [anon_sym_COLON_DASH] = ACTIONS(5418),
    [anon_sym_PERCENT] = ACTIONS(5418),
    [anon_sym_DASH] = ACTIONS(5418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2029] = {
    [sym_file_descriptor] = ACTIONS(1788),
    [sym__concat] = ACTIONS(1788),
    [anon_sym_esac] = ACTIONS(1788),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1788),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [anon_sym_PIPE_AMP] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [anon_sym_LT] = ACTIONS(1790),
    [anon_sym_GT] = ACTIONS(1790),
    [anon_sym_GT_GT] = ACTIONS(1788),
    [anon_sym_AMP_GT] = ACTIONS(1790),
    [anon_sym_AMP_GT_GT] = ACTIONS(1788),
    [anon_sym_LT_AMP] = ACTIONS(1788),
    [anon_sym_GT_AMP] = ACTIONS(1788),
    [anon_sym_LT_LT] = ACTIONS(1790),
    [anon_sym_LT_LT_DASH] = ACTIONS(1788),
    [anon_sym_LT_LT_LT] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1790),
  },
  [2030] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5424),
  },
  [2031] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5426),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2032] = {
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [anon_sym_esac] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [anon_sym_LT_LT] = ACTIONS(1834),
    [anon_sym_LT_LT_DASH] = ACTIONS(1832),
    [anon_sym_LT_LT_LT] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [2033] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5428),
  },
  [2034] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5430),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2035] = {
    [sym_file_descriptor] = ACTIONS(1840),
    [sym__concat] = ACTIONS(1840),
    [anon_sym_esac] = ACTIONS(1840),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [anon_sym_PIPE_AMP] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_GT] = ACTIONS(1842),
    [anon_sym_GT_GT] = ACTIONS(1840),
    [anon_sym_AMP_GT] = ACTIONS(1842),
    [anon_sym_AMP_GT_GT] = ACTIONS(1840),
    [anon_sym_LT_AMP] = ACTIONS(1840),
    [anon_sym_GT_AMP] = ACTIONS(1840),
    [anon_sym_LT_LT] = ACTIONS(1842),
    [anon_sym_LT_LT_DASH] = ACTIONS(1840),
    [anon_sym_LT_LT_LT] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [2036] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5432),
  },
  [2037] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5394),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2038] = {
    [sym_file_descriptor] = ACTIONS(1846),
    [sym__concat] = ACTIONS(1846),
    [anon_sym_esac] = ACTIONS(1846),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT] = ACTIONS(1848),
    [anon_sym_AMP_GT_GT] = ACTIONS(1846),
    [anon_sym_LT_AMP] = ACTIONS(1846),
    [anon_sym_GT_AMP] = ACTIONS(1846),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_LT_LT_DASH] = ACTIONS(1846),
    [anon_sym_LT_LT_LT] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1848),
  },
  [2039] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5434),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2040] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5434),
    [anon_sym_SEMI_SEMI] = ACTIONS(5436),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5438),
    [anon_sym_LF] = ACTIONS(5436),
    [anon_sym_AMP] = ACTIONS(5438),
  },
  [2041] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5434),
    [anon_sym_SEMI_SEMI] = ACTIONS(5436),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5438),
    [anon_sym_LF] = ACTIONS(5436),
    [anon_sym_AMP] = ACTIONS(5438),
  },
  [2042] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(5434),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2043] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(5440),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(5434),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5442),
    [anon_sym_LF] = ACTIONS(5440),
    [anon_sym_AMP] = ACTIONS(5442),
  },
  [2044] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(5440),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(5434),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5442),
    [anon_sym_LF] = ACTIONS(5440),
    [anon_sym_AMP] = ACTIONS(5442),
  },
  [2045] = {
    [sym_file_descriptor] = ACTIONS(1878),
    [sym__concat] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_RPAREN] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1880),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT] = ACTIONS(1880),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [anon_sym_LT_LT] = ACTIONS(1880),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1880),
  },
  [2046] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2047] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_SEMI_SEMI] = ACTIONS(5446),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_LF] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5448),
  },
  [2048] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_SEMI_SEMI] = ACTIONS(5446),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_LF] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5448),
  },
  [2049] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4885),
    [anon_sym_EQ_TILDE] = ACTIONS(4885),
    [anon_sym_EQ_EQ] = ACTIONS(4885),
    [anon_sym_EQ] = ACTIONS(4887),
    [anon_sym_LT] = ACTIONS(4885),
    [anon_sym_GT] = ACTIONS(4885),
    [anon_sym_BANG_EQ] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4885),
  },
  [2050] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4889),
    [anon_sym_EQ_TILDE] = ACTIONS(4889),
    [anon_sym_EQ_EQ] = ACTIONS(4889),
    [anon_sym_EQ] = ACTIONS(4891),
    [anon_sym_LT] = ACTIONS(4889),
    [anon_sym_GT] = ACTIONS(4889),
    [anon_sym_BANG_EQ] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4889),
  },
  [2051] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4893),
    [anon_sym_EQ_TILDE] = ACTIONS(4893),
    [anon_sym_EQ_EQ] = ACTIONS(4893),
    [anon_sym_EQ] = ACTIONS(4895),
    [anon_sym_LT] = ACTIONS(4893),
    [anon_sym_GT] = ACTIONS(4893),
    [anon_sym_BANG_EQ] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4893),
  },
  [2052] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5450),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2053] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_RPAREN] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4899),
    [anon_sym_EQ_TILDE] = ACTIONS(4899),
    [anon_sym_EQ_EQ] = ACTIONS(4899),
    [anon_sym_EQ] = ACTIONS(4901),
    [anon_sym_LT] = ACTIONS(4899),
    [anon_sym_GT] = ACTIONS(4899),
    [anon_sym_BANG_EQ] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4899),
  },
  [2054] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2055] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4905),
    [anon_sym_EQ_TILDE] = ACTIONS(4905),
    [anon_sym_EQ_EQ] = ACTIONS(4905),
    [anon_sym_EQ] = ACTIONS(4907),
    [anon_sym_LT] = ACTIONS(4905),
    [anon_sym_GT] = ACTIONS(4905),
    [anon_sym_BANG_EQ] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4905),
  },
  [2056] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2057] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4947),
    [anon_sym_EQ_TILDE] = ACTIONS(4947),
    [anon_sym_EQ_EQ] = ACTIONS(4947),
    [anon_sym_EQ] = ACTIONS(4949),
    [anon_sym_LT] = ACTIONS(4947),
    [anon_sym_GT] = ACTIONS(4947),
    [anon_sym_BANG_EQ] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4947),
  },
  [2058] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4955),
    [anon_sym_EQ_TILDE] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4955),
    [anon_sym_EQ] = ACTIONS(4957),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_BANG_EQ] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4955),
  },
  [2059] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4959),
    [anon_sym_EQ_TILDE] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4959),
    [anon_sym_EQ] = ACTIONS(4961),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_BANG_EQ] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4959),
  },
  [2060] = {
    [sym__concat] = ACTIONS(4885),
    [sym_variable_name] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [anon_sym_PIPE_AMP] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [sym__special_characters] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4887),
    [sym_word] = ACTIONS(4887),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4887),
  },
  [2061] = {
    [sym__concat] = ACTIONS(4889),
    [sym_variable_name] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [anon_sym_PIPE_AMP] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [sym__special_characters] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4891),
    [sym_word] = ACTIONS(4891),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4891),
  },
  [2062] = {
    [sym__concat] = ACTIONS(4893),
    [sym_variable_name] = ACTIONS(4893),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [sym__special_characters] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4895),
    [sym_word] = ACTIONS(4895),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2063] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5456),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2064] = {
    [sym__concat] = ACTIONS(4899),
    [sym_variable_name] = ACTIONS(4899),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_RPAREN] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [anon_sym_PIPE_AMP] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [sym__special_characters] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4901),
    [sym_word] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4901),
  },
  [2065] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5458),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2066] = {
    [sym__concat] = ACTIONS(4905),
    [sym_variable_name] = ACTIONS(4905),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [anon_sym_PIPE_AMP] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [sym__special_characters] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4907),
    [sym_word] = ACTIONS(4907),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4907),
  },
  [2067] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2068] = {
    [sym__concat] = ACTIONS(4947),
    [sym_variable_name] = ACTIONS(4947),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [sym__special_characters] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4949),
    [sym_word] = ACTIONS(4949),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4949),
  },
  [2069] = {
    [sym__concat] = ACTIONS(4955),
    [sym_variable_name] = ACTIONS(4955),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [anon_sym_PIPE_AMP] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [sym__special_characters] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4957),
    [sym_word] = ACTIONS(4957),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4957),
  },
  [2070] = {
    [sym__concat] = ACTIONS(4959),
    [sym_variable_name] = ACTIONS(4959),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4959),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [anon_sym_PIPE_AMP] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4961),
    [sym_word] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4961),
  },
  [2071] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [anon_sym_PIPE_AMP] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [sym__special_characters] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4887),
    [sym_word] = ACTIONS(4887),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4887),
  },
  [2072] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [anon_sym_PIPE_AMP] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [sym__special_characters] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4891),
    [sym_word] = ACTIONS(4891),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4891),
  },
  [2073] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [sym__special_characters] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4895),
    [sym_word] = ACTIONS(4895),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2074] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5462),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2075] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_RPAREN] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [anon_sym_PIPE_AMP] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [sym__special_characters] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4901),
    [sym_word] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4901),
  },
  [2076] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2077] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [anon_sym_PIPE_AMP] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [sym__special_characters] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4907),
    [sym_word] = ACTIONS(4907),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4907),
  },
  [2078] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5466),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2079] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [sym__special_characters] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4949),
    [sym_word] = ACTIONS(4949),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4949),
  },
  [2080] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [anon_sym_PIPE_AMP] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [sym__special_characters] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4957),
    [sym_word] = ACTIONS(4957),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4957),
  },
  [2081] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4959),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [anon_sym_PIPE_AMP] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4961),
    [sym_word] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4961),
  },
  [2082] = {
    [sym_file_descriptor] = ACTIONS(4885),
    [sym__concat] = ACTIONS(4885),
    [sym_variable_name] = ACTIONS(4885),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_GT_GT] = ACTIONS(4885),
    [anon_sym_AMP_GT] = ACTIONS(4887),
    [anon_sym_AMP_GT_GT] = ACTIONS(4885),
    [anon_sym_LT_AMP] = ACTIONS(4885),
    [anon_sym_GT_AMP] = ACTIONS(4885),
    [sym__special_characters] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4885),
  },
  [2083] = {
    [sym_file_descriptor] = ACTIONS(4889),
    [sym__concat] = ACTIONS(4889),
    [sym_variable_name] = ACTIONS(4889),
    [anon_sym_LT] = ACTIONS(4891),
    [anon_sym_GT] = ACTIONS(4891),
    [anon_sym_GT_GT] = ACTIONS(4889),
    [anon_sym_AMP_GT] = ACTIONS(4891),
    [anon_sym_AMP_GT_GT] = ACTIONS(4889),
    [anon_sym_LT_AMP] = ACTIONS(4889),
    [anon_sym_GT_AMP] = ACTIONS(4889),
    [sym__special_characters] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4889),
  },
  [2084] = {
    [sym_file_descriptor] = ACTIONS(4893),
    [sym__concat] = ACTIONS(4893),
    [sym_variable_name] = ACTIONS(4893),
    [anon_sym_LT] = ACTIONS(4895),
    [anon_sym_GT] = ACTIONS(4895),
    [anon_sym_GT_GT] = ACTIONS(4893),
    [anon_sym_AMP_GT] = ACTIONS(4895),
    [anon_sym_AMP_GT_GT] = ACTIONS(4893),
    [anon_sym_LT_AMP] = ACTIONS(4893),
    [anon_sym_GT_AMP] = ACTIONS(4893),
    [sym__special_characters] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4893),
  },
  [2085] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2086] = {
    [sym_file_descriptor] = ACTIONS(4899),
    [sym__concat] = ACTIONS(4899),
    [sym_variable_name] = ACTIONS(4899),
    [anon_sym_LT] = ACTIONS(4901),
    [anon_sym_GT] = ACTIONS(4901),
    [anon_sym_GT_GT] = ACTIONS(4899),
    [anon_sym_AMP_GT] = ACTIONS(4901),
    [anon_sym_AMP_GT_GT] = ACTIONS(4899),
    [anon_sym_LT_AMP] = ACTIONS(4899),
    [anon_sym_GT_AMP] = ACTIONS(4899),
    [sym__special_characters] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4899),
  },
  [2087] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2088] = {
    [sym_file_descriptor] = ACTIONS(4905),
    [sym__concat] = ACTIONS(4905),
    [sym_variable_name] = ACTIONS(4905),
    [anon_sym_LT] = ACTIONS(4907),
    [anon_sym_GT] = ACTIONS(4907),
    [anon_sym_GT_GT] = ACTIONS(4905),
    [anon_sym_AMP_GT] = ACTIONS(4907),
    [anon_sym_AMP_GT_GT] = ACTIONS(4905),
    [anon_sym_LT_AMP] = ACTIONS(4905),
    [anon_sym_GT_AMP] = ACTIONS(4905),
    [sym__special_characters] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4905),
  },
  [2089] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2090] = {
    [sym_file_descriptor] = ACTIONS(4947),
    [sym__concat] = ACTIONS(4947),
    [sym_variable_name] = ACTIONS(4947),
    [anon_sym_LT] = ACTIONS(4949),
    [anon_sym_GT] = ACTIONS(4949),
    [anon_sym_GT_GT] = ACTIONS(4947),
    [anon_sym_AMP_GT] = ACTIONS(4949),
    [anon_sym_AMP_GT_GT] = ACTIONS(4947),
    [anon_sym_LT_AMP] = ACTIONS(4947),
    [anon_sym_GT_AMP] = ACTIONS(4947),
    [sym__special_characters] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4947),
  },
  [2091] = {
    [sym_file_descriptor] = ACTIONS(4955),
    [sym__concat] = ACTIONS(4955),
    [sym_variable_name] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4957),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym_AMP_GT] = ACTIONS(4957),
    [anon_sym_AMP_GT_GT] = ACTIONS(4955),
    [anon_sym_LT_AMP] = ACTIONS(4955),
    [anon_sym_GT_AMP] = ACTIONS(4955),
    [sym__special_characters] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4955),
  },
  [2092] = {
    [sym_file_descriptor] = ACTIONS(4959),
    [sym__concat] = ACTIONS(4959),
    [sym_variable_name] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym_AMP_GT] = ACTIONS(4961),
    [anon_sym_AMP_GT_GT] = ACTIONS(4959),
    [anon_sym_LT_AMP] = ACTIONS(4959),
    [anon_sym_GT_AMP] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4959),
  },
  [2093] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4887),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym__string_content] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4887),
    [anon_sym_BQUOTE] = ACTIONS(4887),
    [sym_comment] = ACTIONS(243),
  },
  [2094] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4891),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym__string_content] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4891),
    [anon_sym_BQUOTE] = ACTIONS(4891),
    [sym_comment] = ACTIONS(243),
  },
  [2095] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4895),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym__string_content] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4895),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4895),
    [anon_sym_BQUOTE] = ACTIONS(4895),
    [sym_comment] = ACTIONS(243),
  },
  [2096] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5474),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2097] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4901),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym__string_content] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4901),
    [anon_sym_BQUOTE] = ACTIONS(4901),
    [sym_comment] = ACTIONS(243),
  },
  [2098] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2099] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4907),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym__string_content] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4907),
    [anon_sym_BQUOTE] = ACTIONS(4907),
    [sym_comment] = ACTIONS(243),
  },
  [2100] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5478),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2101] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4949),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym__string_content] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4949),
    [anon_sym_BQUOTE] = ACTIONS(4949),
    [sym_comment] = ACTIONS(243),
  },
  [2102] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4957),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym__string_content] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4957),
    [anon_sym_BQUOTE] = ACTIONS(4957),
    [sym_comment] = ACTIONS(243),
  },
  [2103] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4961),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym__string_content] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4961),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4961),
    [anon_sym_BQUOTE] = ACTIONS(4961),
    [sym_comment] = ACTIONS(243),
  },
  [2104] = {
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(5480),
    [sym__special_characters] = ACTIONS(5480),
    [anon_sym_DQUOTE] = ACTIONS(4146),
    [anon_sym_DOLLAR] = ACTIONS(5480),
    [sym_raw_string] = ACTIONS(4146),
    [anon_sym_POUND] = ACTIONS(4146),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4146),
    [anon_sym_COLON] = ACTIONS(5480),
    [anon_sym_COLON_QMARK] = ACTIONS(5480),
    [anon_sym_COLON_DASH] = ACTIONS(5480),
    [anon_sym_PERCENT] = ACTIONS(5480),
    [anon_sym_DASH] = ACTIONS(5480),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4146),
    [anon_sym_BQUOTE] = ACTIONS(4146),
    [anon_sym_LT_LPAREN] = ACTIONS(4146),
    [anon_sym_GT_LPAREN] = ACTIONS(4146),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(5480),
  },
  [2105] = {
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(5482),
    [sym__special_characters] = ACTIONS(5482),
    [anon_sym_DQUOTE] = ACTIONS(4148),
    [anon_sym_DOLLAR] = ACTIONS(5482),
    [sym_raw_string] = ACTIONS(4148),
    [anon_sym_POUND] = ACTIONS(4148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4148),
    [anon_sym_COLON] = ACTIONS(5482),
    [anon_sym_COLON_QMARK] = ACTIONS(5482),
    [anon_sym_COLON_DASH] = ACTIONS(5482),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_DASH] = ACTIONS(5482),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4148),
    [anon_sym_BQUOTE] = ACTIONS(4148),
    [anon_sym_LT_LPAREN] = ACTIONS(4148),
    [anon_sym_GT_LPAREN] = ACTIONS(4148),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(5482),
  },
  [2106] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
  },
  [2107] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
  },
  [2108] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [sym_comment] = ACTIONS(53),
  },
  [2109] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [sym_comment] = ACTIONS(53),
  },
  [2110] = {
    [anon_sym_RBRACE] = ACTIONS(5486),
    [sym_comment] = ACTIONS(53),
  },
  [2111] = {
    [sym_concatenation] = STATE(2388),
    [sym_string] = STATE(2387),
    [sym_simple_expansion] = STATE(2387),
    [sym_string_expansion] = STATE(2387),
    [sym_expansion] = STATE(2387),
    [sym_command_substitution] = STATE(2387),
    [sym_process_substitution] = STATE(2387),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [sym__special_characters] = ACTIONS(5488),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(5490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5490),
  },
  [2112] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
  },
  [2113] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5492),
  },
  [2114] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2115] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
  },
  [2116] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5496),
  },
  [2117] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2118] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5500),
  },
  [2119] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2120] = {
    [sym_concatenation] = STATE(2395),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2395),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_EQ] = ACTIONS(5504),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5504),
    [anon_sym_COLON_QMARK] = ACTIONS(5504),
    [anon_sym_COLON_DASH] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2121] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
  },
  [2122] = {
    [sym_concatenation] = STATE(2397),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2397),
    [anon_sym_RBRACE] = ACTIONS(5508),
    [anon_sym_EQ] = ACTIONS(5510),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5510),
    [anon_sym_COLON_QMARK] = ACTIONS(5510),
    [anon_sym_COLON_DASH] = ACTIONS(5510),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_DASH] = ACTIONS(5510),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2123] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
  },
  [2124] = {
    [sym_concatenation] = STATE(2399),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2399),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [anon_sym_EQ] = ACTIONS(5516),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5516),
    [anon_sym_COLON_QMARK] = ACTIONS(5516),
    [anon_sym_COLON_DASH] = ACTIONS(5516),
    [anon_sym_PERCENT] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5516),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2125] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
  },
  [2126] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5520),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2127] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(5520),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2128] = {
    [sym__concat] = ACTIONS(3078),
    [anon_sym_RBRACE] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
  },
  [2129] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5522),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2130] = {
    [sym__simple_heredoc_body] = ACTIONS(5524),
    [sym__heredoc_body_beginning] = ACTIONS(5524),
    [sym_file_descriptor] = ACTIONS(5524),
    [sym__concat] = ACTIONS(5524),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5524),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [anon_sym_PIPE_AMP] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_EQ_TILDE] = ACTIONS(5526),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5526),
    [anon_sym_GT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_AMP_GT] = ACTIONS(5526),
    [anon_sym_AMP_GT_GT] = ACTIONS(5524),
    [anon_sym_LT_AMP] = ACTIONS(5524),
    [anon_sym_GT_AMP] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_LT_LT_DASH] = ACTIONS(5524),
    [anon_sym_LT_LT_LT] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5526),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5526),
  },
  [2131] = {
    [sym__simple_heredoc_body] = ACTIONS(5528),
    [sym__heredoc_body_beginning] = ACTIONS(5528),
    [sym_file_descriptor] = ACTIONS(5528),
    [sym__concat] = ACTIONS(5528),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_RPAREN] = ACTIONS(5528),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [anon_sym_PIPE_AMP] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_EQ_TILDE] = ACTIONS(5530),
    [anon_sym_EQ_EQ] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5530),
    [anon_sym_GT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_AMP_GT] = ACTIONS(5530),
    [anon_sym_AMP_GT_GT] = ACTIONS(5528),
    [anon_sym_LT_AMP] = ACTIONS(5528),
    [anon_sym_GT_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5530),
    [anon_sym_LT_LT_DASH] = ACTIONS(5528),
    [anon_sym_LT_LT_LT] = ACTIONS(5528),
    [sym__special_characters] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5530),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5530),
  },
  [2132] = {
    [sym__simple_heredoc_body] = ACTIONS(5532),
    [sym__heredoc_body_beginning] = ACTIONS(5532),
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_EQ_TILDE] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5532),
    [anon_sym_LT_AMP] = ACTIONS(5532),
    [anon_sym_GT_AMP] = ACTIONS(5532),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_LT_LT_DASH] = ACTIONS(5532),
    [anon_sym_LT_LT_LT] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2133] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3903),
    [anon_sym_EQ] = ACTIONS(3905),
    [sym__special_characters] = ACTIONS(3905),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_POUND] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_COLON] = ACTIONS(3905),
    [anon_sym_COLON_QMARK] = ACTIONS(3905),
    [anon_sym_COLON_DASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(3905),
  },
  [2134] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_RBRACE] = ACTIONS(3911),
    [anon_sym_EQ] = ACTIONS(3913),
    [sym__special_characters] = ACTIONS(3913),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_POUND] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_COLON] = ACTIONS(3913),
    [anon_sym_COLON_QMARK] = ACTIONS(3913),
    [anon_sym_COLON_DASH] = ACTIONS(3913),
    [anon_sym_PERCENT] = ACTIONS(3913),
    [anon_sym_DASH] = ACTIONS(3913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(3913),
  },
  [2135] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5536),
    [sym_comment] = ACTIONS(53),
  },
  [2136] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5538),
    [sym_comment] = ACTIONS(53),
  },
  [2137] = {
    [anon_sym_RBRACE] = ACTIONS(5538),
    [sym_comment] = ACTIONS(53),
  },
  [2138] = {
    [sym_concatenation] = STATE(2405),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2405),
    [anon_sym_RBRACE] = ACTIONS(5540),
    [anon_sym_EQ] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5542),
    [anon_sym_COLON_QMARK] = ACTIONS(5542),
    [anon_sym_COLON_DASH] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_DASH] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2139] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_EQ] = ACTIONS(3977),
    [sym__special_characters] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_POUND] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_DASH] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(3977),
  },
  [2140] = {
    [sym_concatenation] = STATE(2407),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2407),
    [anon_sym_RBRACE] = ACTIONS(5546),
    [anon_sym_EQ] = ACTIONS(5548),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5548),
    [anon_sym_COLON_QMARK] = ACTIONS(5548),
    [anon_sym_COLON_DASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [anon_sym_DASH] = ACTIONS(5548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2141] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_EQ] = ACTIONS(3987),
    [sym__special_characters] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_POUND] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_COLON] = ACTIONS(3987),
    [anon_sym_COLON_QMARK] = ACTIONS(3987),
    [anon_sym_COLON_DASH] = ACTIONS(3987),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(3987),
  },
  [2142] = {
    [sym_concatenation] = STATE(2409),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2409),
    [anon_sym_RBRACE] = ACTIONS(5552),
    [anon_sym_EQ] = ACTIONS(5554),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5556),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5554),
    [anon_sym_COLON_QMARK] = ACTIONS(5554),
    [anon_sym_COLON_DASH] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(5554),
    [anon_sym_DASH] = ACTIONS(5554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2143] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [anon_sym_EQ] = ACTIONS(4042),
    [sym__special_characters] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_POUND] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_COLON] = ACTIONS(4042),
    [anon_sym_COLON_QMARK] = ACTIONS(4042),
    [anon_sym_COLON_DASH] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4042),
  },
  [2144] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5558),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2145] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_POUND] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_DASH] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4064),
  },
  [2146] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5560),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2147] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_EQ] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_POUND] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4070),
    [anon_sym_COLON_QMARK] = ACTIONS(4070),
    [anon_sym_COLON_DASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4070),
  },
  [2148] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5562),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2149] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4076),
    [sym__special_characters] = ACTIONS(4076),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_POUND] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COLON_QMARK] = ACTIONS(4076),
    [anon_sym_COLON_DASH] = ACTIONS(4076),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_DASH] = ACTIONS(4076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4076),
  },
  [2150] = {
    [sym__concat] = ACTIONS(4098),
    [anon_sym_RBRACE] = ACTIONS(4098),
    [anon_sym_EQ] = ACTIONS(4100),
    [sym__special_characters] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_POUND] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_DASH] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4100),
  },
  [2151] = {
    [aux_sym_concatenation_repeat1] = STATE(2153),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_BQUOTE] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [2152] = {
    [aux_sym_concatenation_repeat1] = STATE(2153),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_BQUOTE] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [2153] = {
    [aux_sym_concatenation_repeat1] = STATE(2413),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [2154] = {
    [aux_sym_concatenation_repeat1] = STATE(2156),
    [sym_file_descriptor] = ACTIONS(981),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(981),
    [anon_sym_LT_AMP] = ACTIONS(981),
    [anon_sym_GT_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(981),
    [anon_sym_LT_LT_LT] = ACTIONS(981),
    [anon_sym_BQUOTE] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [2155] = {
    [aux_sym_concatenation_repeat1] = STATE(2156),
    [sym_file_descriptor] = ACTIONS(985),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_DASH] = ACTIONS(985),
    [anon_sym_LT_LT_LT] = ACTIONS(985),
    [anon_sym_BQUOTE] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [2156] = {
    [aux_sym_concatenation_repeat1] = STATE(2414),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [2157] = {
    [sym__heredoc_body_middle] = ACTIONS(3903),
    [sym__heredoc_body_end] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
  },
  [2158] = {
    [sym__heredoc_body_middle] = ACTIONS(3911),
    [sym__heredoc_body_end] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
  },
  [2159] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [sym_comment] = ACTIONS(53),
  },
  [2160] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [sym_comment] = ACTIONS(53),
  },
  [2161] = {
    [anon_sym_RBRACE] = ACTIONS(5566),
    [sym_comment] = ACTIONS(53),
  },
  [2162] = {
    [sym_concatenation] = STATE(2418),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2418),
    [anon_sym_RBRACE] = ACTIONS(5568),
    [anon_sym_EQ] = ACTIONS(5570),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5570),
    [anon_sym_COLON_QMARK] = ACTIONS(5570),
    [anon_sym_COLON_DASH] = ACTIONS(5570),
    [anon_sym_PERCENT] = ACTIONS(5570),
    [anon_sym_DASH] = ACTIONS(5570),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2163] = {
    [sym__heredoc_body_middle] = ACTIONS(3975),
    [sym__heredoc_body_end] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
  },
  [2164] = {
    [sym_concatenation] = STATE(2420),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2420),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_EQ] = ACTIONS(5576),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5576),
    [anon_sym_COLON_QMARK] = ACTIONS(5576),
    [anon_sym_COLON_DASH] = ACTIONS(5576),
    [anon_sym_PERCENT] = ACTIONS(5576),
    [anon_sym_DASH] = ACTIONS(5576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2165] = {
    [sym__heredoc_body_middle] = ACTIONS(3985),
    [sym__heredoc_body_end] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
  },
  [2166] = {
    [sym_concatenation] = STATE(2422),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2422),
    [anon_sym_RBRACE] = ACTIONS(5580),
    [anon_sym_EQ] = ACTIONS(5582),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_COLON_QMARK] = ACTIONS(5582),
    [anon_sym_COLON_DASH] = ACTIONS(5582),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_DASH] = ACTIONS(5582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2167] = {
    [sym__heredoc_body_middle] = ACTIONS(4040),
    [sym__heredoc_body_end] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
  },
  [2168] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2169] = {
    [sym__heredoc_body_middle] = ACTIONS(4062),
    [sym__heredoc_body_end] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
  },
  [2170] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5588),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2171] = {
    [sym__heredoc_body_middle] = ACTIONS(4068),
    [sym__heredoc_body_end] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
  },
  [2172] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2173] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_RPAREN] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3903),
  },
  [2174] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3911),
  },
  [2175] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [sym_comment] = ACTIONS(53),
  },
  [2176] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [sym_comment] = ACTIONS(53),
  },
  [2177] = {
    [anon_sym_RBRACE] = ACTIONS(5594),
    [sym_comment] = ACTIONS(53),
  },
  [2178] = {
    [sym_concatenation] = STATE(2429),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2429),
    [anon_sym_RBRACE] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5598),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5598),
    [anon_sym_COLON_QMARK] = ACTIONS(5598),
    [anon_sym_COLON_DASH] = ACTIONS(5598),
    [anon_sym_PERCENT] = ACTIONS(5598),
    [anon_sym_DASH] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2179] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_RPAREN] = ACTIONS(3975),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3975),
  },
  [2180] = {
    [sym_concatenation] = STATE(2431),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2431),
    [anon_sym_RBRACE] = ACTIONS(5602),
    [anon_sym_EQ] = ACTIONS(5604),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5606),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5604),
    [anon_sym_COLON_QMARK] = ACTIONS(5604),
    [anon_sym_COLON_DASH] = ACTIONS(5604),
    [anon_sym_PERCENT] = ACTIONS(5604),
    [anon_sym_DASH] = ACTIONS(5604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2181] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3985),
  },
  [2182] = {
    [sym_concatenation] = STATE(2433),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2433),
    [anon_sym_RBRACE] = ACTIONS(5608),
    [anon_sym_EQ] = ACTIONS(5610),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5610),
    [anon_sym_COLON_QMARK] = ACTIONS(5610),
    [anon_sym_COLON_DASH] = ACTIONS(5610),
    [anon_sym_PERCENT] = ACTIONS(5610),
    [anon_sym_DASH] = ACTIONS(5610),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2183] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4040),
  },
  [2184] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5614),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2185] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4062),
  },
  [2186] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5616),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2187] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4068),
  },
  [2188] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5618),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2189] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4074),
  },
  [2190] = {
    [sym__concat] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(4098),
    [sym__special_characters] = ACTIONS(4098),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4098),
  },
  [2191] = {
    [sym_file_descriptor] = ACTIONS(4885),
    [sym__concat] = ACTIONS(4885),
    [sym_variable_name] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [anon_sym_PIPE_AMP] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_GT_GT] = ACTIONS(4885),
    [anon_sym_AMP_GT] = ACTIONS(4887),
    [anon_sym_AMP_GT_GT] = ACTIONS(4885),
    [anon_sym_LT_AMP] = ACTIONS(4885),
    [anon_sym_GT_AMP] = ACTIONS(4885),
    [sym__special_characters] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4887),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4887),
  },
  [2192] = {
    [sym_file_descriptor] = ACTIONS(4889),
    [sym__concat] = ACTIONS(4889),
    [sym_variable_name] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [anon_sym_PIPE_AMP] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_LT] = ACTIONS(4891),
    [anon_sym_GT] = ACTIONS(4891),
    [anon_sym_GT_GT] = ACTIONS(4889),
    [anon_sym_AMP_GT] = ACTIONS(4891),
    [anon_sym_AMP_GT_GT] = ACTIONS(4889),
    [anon_sym_LT_AMP] = ACTIONS(4889),
    [anon_sym_GT_AMP] = ACTIONS(4889),
    [sym__special_characters] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4891),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4891),
  },
  [2193] = {
    [sym_file_descriptor] = ACTIONS(4893),
    [sym__concat] = ACTIONS(4893),
    [sym_variable_name] = ACTIONS(4893),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [anon_sym_LT] = ACTIONS(4895),
    [anon_sym_GT] = ACTIONS(4895),
    [anon_sym_GT_GT] = ACTIONS(4893),
    [anon_sym_AMP_GT] = ACTIONS(4895),
    [anon_sym_AMP_GT_GT] = ACTIONS(4893),
    [anon_sym_LT_AMP] = ACTIONS(4893),
    [anon_sym_GT_AMP] = ACTIONS(4893),
    [sym__special_characters] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4895),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2194] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2195] = {
    [sym_file_descriptor] = ACTIONS(4899),
    [sym__concat] = ACTIONS(4899),
    [sym_variable_name] = ACTIONS(4899),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_RPAREN] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [anon_sym_PIPE_AMP] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [anon_sym_LT] = ACTIONS(4901),
    [anon_sym_GT] = ACTIONS(4901),
    [anon_sym_GT_GT] = ACTIONS(4899),
    [anon_sym_AMP_GT] = ACTIONS(4901),
    [anon_sym_AMP_GT_GT] = ACTIONS(4899),
    [anon_sym_LT_AMP] = ACTIONS(4899),
    [anon_sym_GT_AMP] = ACTIONS(4899),
    [sym__special_characters] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4901),
  },
  [2196] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5622),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2197] = {
    [sym_file_descriptor] = ACTIONS(4905),
    [sym__concat] = ACTIONS(4905),
    [sym_variable_name] = ACTIONS(4905),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [anon_sym_PIPE_AMP] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_LT] = ACTIONS(4907),
    [anon_sym_GT] = ACTIONS(4907),
    [anon_sym_GT_GT] = ACTIONS(4905),
    [anon_sym_AMP_GT] = ACTIONS(4907),
    [anon_sym_AMP_GT_GT] = ACTIONS(4905),
    [anon_sym_LT_AMP] = ACTIONS(4905),
    [anon_sym_GT_AMP] = ACTIONS(4905),
    [sym__special_characters] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4907),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4907),
  },
  [2198] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2199] = {
    [sym_file_descriptor] = ACTIONS(4947),
    [sym__concat] = ACTIONS(4947),
    [sym_variable_name] = ACTIONS(4947),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_LT] = ACTIONS(4949),
    [anon_sym_GT] = ACTIONS(4949),
    [anon_sym_GT_GT] = ACTIONS(4947),
    [anon_sym_AMP_GT] = ACTIONS(4949),
    [anon_sym_AMP_GT_GT] = ACTIONS(4947),
    [anon_sym_LT_AMP] = ACTIONS(4947),
    [anon_sym_GT_AMP] = ACTIONS(4947),
    [sym__special_characters] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4949),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4949),
  },
  [2200] = {
    [sym_file_descriptor] = ACTIONS(4955),
    [sym__concat] = ACTIONS(4955),
    [sym_variable_name] = ACTIONS(4955),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [anon_sym_PIPE_AMP] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4957),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym_AMP_GT] = ACTIONS(4957),
    [anon_sym_AMP_GT_GT] = ACTIONS(4955),
    [anon_sym_LT_AMP] = ACTIONS(4955),
    [anon_sym_GT_AMP] = ACTIONS(4955),
    [sym__special_characters] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4957),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4957),
  },
  [2201] = {
    [sym_file_descriptor] = ACTIONS(4959),
    [sym__concat] = ACTIONS(4959),
    [sym_variable_name] = ACTIONS(4959),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4959),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [anon_sym_PIPE_AMP] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym_AMP_GT] = ACTIONS(4961),
    [anon_sym_AMP_GT_GT] = ACTIONS(4959),
    [anon_sym_LT_AMP] = ACTIONS(4959),
    [anon_sym_GT_AMP] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4961),
  },
  [2202] = {
    [anon_sym_esac] = ACTIONS(3569),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_RPAREN] = ACTIONS(3569),
    [anon_sym_SEMI_SEMI] = ACTIONS(3569),
    [anon_sym_PIPE_AMP] = ACTIONS(3569),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3569),
    [anon_sym_BQUOTE] = ACTIONS(3569),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym_LF] = ACTIONS(3569),
    [anon_sym_AMP] = ACTIONS(3571),
  },
  [2203] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_EQ_TILDE] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2855),
  },
  [2204] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [anon_sym_EQ_TILDE] = ACTIONS(2869),
    [anon_sym_EQ_EQ] = ACTIONS(2869),
    [anon_sym_EQ] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_GT] = ACTIONS(2869),
    [anon_sym_BANG_EQ] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2869),
  },
  [2205] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5626),
    [sym_comment] = ACTIONS(53),
  },
  [2206] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [sym_comment] = ACTIONS(53),
  },
  [2207] = {
    [anon_sym_RBRACE] = ACTIONS(5628),
    [sym_comment] = ACTIONS(53),
  },
  [2208] = {
    [sym_concatenation] = STATE(2444),
    [sym_string] = STATE(2443),
    [sym_simple_expansion] = STATE(2443),
    [sym_string_expansion] = STATE(2443),
    [sym_expansion] = STATE(2443),
    [sym_command_substitution] = STATE(2443),
    [sym_process_substitution] = STATE(2443),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [sym__special_characters] = ACTIONS(5630),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(5632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5632),
  },
  [2209] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2905),
    [anon_sym_EQ_EQ] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2905),
    [anon_sym_BANG_EQ] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2905),
  },
  [2210] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5634),
  },
  [2211] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5636),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2212] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2913),
  },
  [2213] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5638),
  },
  [2214] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2215] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5642),
  },
  [2216] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2217] = {
    [sym_concatenation] = STATE(2451),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2451),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_EQ] = ACTIONS(5646),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5646),
    [anon_sym_COLON_QMARK] = ACTIONS(5646),
    [anon_sym_COLON_DASH] = ACTIONS(5646),
    [anon_sym_PERCENT] = ACTIONS(5646),
    [anon_sym_DASH] = ACTIONS(5646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2218] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_EQ_TILDE] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2985),
  },
  [2219] = {
    [sym_concatenation] = STATE(2453),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2453),
    [anon_sym_RBRACE] = ACTIONS(5650),
    [anon_sym_EQ] = ACTIONS(5652),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5652),
    [anon_sym_COLON_QMARK] = ACTIONS(5652),
    [anon_sym_COLON_DASH] = ACTIONS(5652),
    [anon_sym_PERCENT] = ACTIONS(5652),
    [anon_sym_DASH] = ACTIONS(5652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2220] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3030),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_GT] = ACTIONS(3030),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3030),
  },
  [2221] = {
    [sym_concatenation] = STATE(2455),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2455),
    [anon_sym_RBRACE] = ACTIONS(5656),
    [anon_sym_EQ] = ACTIONS(5658),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5658),
    [anon_sym_COLON_QMARK] = ACTIONS(5658),
    [anon_sym_COLON_DASH] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5658),
    [anon_sym_DASH] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2222] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_EQ_TILDE] = ACTIONS(3040),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3040),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3040),
  },
  [2223] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5662),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2224] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(5662),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2225] = {
    [sym__concat] = ACTIONS(3078),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [anon_sym_EQ_TILDE] = ACTIONS(3078),
    [anon_sym_EQ_EQ] = ACTIONS(3078),
    [anon_sym_EQ] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3078),
    [anon_sym_GT] = ACTIONS(3078),
    [anon_sym_BANG_EQ] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3078),
  },
  [2226] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5664),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2227] = {
    [anon_sym_esac] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_SEMI_SEMI] = ACTIONS(5666),
    [anon_sym_PIPE_AMP] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE] = ACTIONS(5666),
    [anon_sym_BQUOTE] = ACTIONS(5666),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5668),
    [anon_sym_LF] = ACTIONS(5666),
    [anon_sym_AMP] = ACTIONS(5668),
  },
  [2228] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_esac] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [anon_sym_PIPE_AMP] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_EQ_TILDE] = ACTIONS(4885),
    [anon_sym_EQ_EQ] = ACTIONS(4885),
    [anon_sym_EQ] = ACTIONS(4887),
    [anon_sym_LT] = ACTIONS(4885),
    [anon_sym_GT] = ACTIONS(4885),
    [anon_sym_BANG_EQ] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4885),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4887),
  },
  [2229] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_esac] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [anon_sym_PIPE_AMP] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_EQ_TILDE] = ACTIONS(4889),
    [anon_sym_EQ_EQ] = ACTIONS(4889),
    [anon_sym_EQ] = ACTIONS(4891),
    [anon_sym_LT] = ACTIONS(4889),
    [anon_sym_GT] = ACTIONS(4889),
    [anon_sym_BANG_EQ] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4889),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4891),
  },
  [2230] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_esac] = ACTIONS(4893),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [anon_sym_EQ_TILDE] = ACTIONS(4893),
    [anon_sym_EQ_EQ] = ACTIONS(4893),
    [anon_sym_EQ] = ACTIONS(4895),
    [anon_sym_LT] = ACTIONS(4893),
    [anon_sym_GT] = ACTIONS(4893),
    [anon_sym_BANG_EQ] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4893),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2231] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2232] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_esac] = ACTIONS(4899),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [anon_sym_PIPE_AMP] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [anon_sym_EQ_TILDE] = ACTIONS(4899),
    [anon_sym_EQ_EQ] = ACTIONS(4899),
    [anon_sym_EQ] = ACTIONS(4901),
    [anon_sym_LT] = ACTIONS(4899),
    [anon_sym_GT] = ACTIONS(4899),
    [anon_sym_BANG_EQ] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4899),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4901),
  },
  [2233] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5672),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2234] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_esac] = ACTIONS(4905),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [anon_sym_PIPE_AMP] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_EQ_TILDE] = ACTIONS(4905),
    [anon_sym_EQ_EQ] = ACTIONS(4905),
    [anon_sym_EQ] = ACTIONS(4907),
    [anon_sym_LT] = ACTIONS(4905),
    [anon_sym_GT] = ACTIONS(4905),
    [anon_sym_BANG_EQ] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4905),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4907),
  },
  [2235] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2236] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_esac] = ACTIONS(4947),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_EQ_TILDE] = ACTIONS(4947),
    [anon_sym_EQ_EQ] = ACTIONS(4947),
    [anon_sym_EQ] = ACTIONS(4949),
    [anon_sym_LT] = ACTIONS(4947),
    [anon_sym_GT] = ACTIONS(4947),
    [anon_sym_BANG_EQ] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4947),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4949),
  },
  [2237] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_esac] = ACTIONS(4955),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [anon_sym_PIPE_AMP] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [anon_sym_EQ_TILDE] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4955),
    [anon_sym_EQ] = ACTIONS(4957),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_BANG_EQ] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4955),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4957),
  },
  [2238] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_esac] = ACTIONS(4959),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [anon_sym_PIPE_AMP] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [anon_sym_EQ_TILDE] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4959),
    [anon_sym_EQ] = ACTIONS(4961),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_BANG_EQ] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4959),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4961),
  },
  [2239] = {
    [sym_do_group] = STATE(2461),
    [sym_compound_statement] = STATE(2461),
    [anon_sym_do] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [sym_comment] = ACTIONS(53),
  },
  [2240] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3903),
  },
  [2241] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [2242] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5676),
    [sym_comment] = ACTIONS(53),
  },
  [2243] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5678),
    [sym_comment] = ACTIONS(53),
  },
  [2244] = {
    [anon_sym_RBRACE] = ACTIONS(5678),
    [sym_comment] = ACTIONS(53),
  },
  [2245] = {
    [sym_concatenation] = STATE(2465),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2465),
    [anon_sym_RBRACE] = ACTIONS(5680),
    [anon_sym_EQ] = ACTIONS(5682),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5682),
    [anon_sym_COLON_QMARK] = ACTIONS(5682),
    [anon_sym_COLON_DASH] = ACTIONS(5682),
    [anon_sym_PERCENT] = ACTIONS(5682),
    [anon_sym_DASH] = ACTIONS(5682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2246] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3975),
  },
  [2247] = {
    [sym_concatenation] = STATE(2467),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2467),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5688),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5688),
    [anon_sym_COLON_QMARK] = ACTIONS(5688),
    [anon_sym_COLON_DASH] = ACTIONS(5688),
    [anon_sym_PERCENT] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2248] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3987),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3985),
  },
  [2249] = {
    [sym_concatenation] = STATE(2469),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2469),
    [anon_sym_RBRACE] = ACTIONS(5692),
    [anon_sym_EQ] = ACTIONS(5694),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5694),
    [anon_sym_COLON_QMARK] = ACTIONS(5694),
    [anon_sym_COLON_DASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5694),
    [anon_sym_DASH] = ACTIONS(5694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2250] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4040),
  },
  [2251] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2252] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4062),
  },
  [2253] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5700),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2254] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4068),
  },
  [2255] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2256] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
  },
  [2257] = {
    [sym__concat] = ACTIONS(4098),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [sym__special_characters] = ACTIONS(4098),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4098),
  },
  [2258] = {
    [sym_concatenation] = STATE(2473),
    [sym_string] = STATE(2478),
    [sym_array] = STATE(2473),
    [sym_simple_expansion] = STATE(2478),
    [sym_string_expansion] = STATE(2478),
    [sym_expansion] = STATE(2478),
    [sym_command_substitution] = STATE(2478),
    [sym_process_substitution] = STATE(2478),
    [sym__empty_value] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(5706),
    [sym__special_characters] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5710),
    [anon_sym_DOLLAR] = ACTIONS(5712),
    [sym_raw_string] = ACTIONS(5714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5718),
    [anon_sym_BQUOTE] = ACTIONS(5720),
    [anon_sym_LT_LPAREN] = ACTIONS(5722),
    [anon_sym_GT_LPAREN] = ACTIONS(5722),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5714),
  },
  [2259] = {
    [sym_do_group] = STATE(2483),
    [anon_sym_do] = ACTIONS(395),
    [sym_comment] = ACTIONS(53),
  },
  [2260] = {
    [sym_compound_statement] = STATE(2485),
    [anon_sym_LPAREN] = ACTIONS(5724),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [2261] = {
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(5726),
    [anon_sym_EQ_TILDE] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_EQ] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(541),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(541),
  },
  [2262] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5726),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [2263] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(5728),
    [anon_sym_PLUS_EQ] = ACTIONS(5728),
    [sym_comment] = ACTIONS(53),
  },
  [2264] = {
    [aux_sym_concatenation_repeat1] = STATE(2489),
    [sym__concat] = ACTIONS(5730),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_esac] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym__special_characters] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(585),
  },
  [2265] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(2492),
    [anon_sym_DQUOTE] = ACTIONS(5732),
    [anon_sym_DOLLAR] = ACTIONS(5734),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [2266] = {
    [sym_string] = STATE(2494),
    [anon_sym_DQUOTE] = ACTIONS(5248),
    [anon_sym_DOLLAR] = ACTIONS(5736),
    [sym_raw_string] = ACTIONS(5738),
    [anon_sym_POUND] = ACTIONS(5736),
    [anon_sym_DASH] = ACTIONS(5736),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5740),
    [anon_sym_STAR] = ACTIONS(5736),
    [anon_sym_AT] = ACTIONS(5736),
    [anon_sym_QMARK] = ACTIONS(5736),
    [anon_sym_0] = ACTIONS(5742),
    [anon_sym__] = ACTIONS(5742),
  },
  [2267] = {
    [aux_sym_concatenation_repeat1] = STATE(2489),
    [sym__concat] = ACTIONS(5730),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_esac] = ACTIONS(601),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(599),
    [anon_sym_PIPE_AMP] = ACTIONS(599),
    [anon_sym_AMP_AMP] = ACTIONS(599),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [sym__special_characters] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(599),
    [anon_sym_BQUOTE] = ACTIONS(599),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [2268] = {
    [sym_subscript] = STATE(2500),
    [sym_variable_name] = ACTIONS(5744),
    [anon_sym_BANG] = ACTIONS(5746),
    [anon_sym_DOLLAR] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5748),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5750),
    [anon_sym_STAR] = ACTIONS(5748),
    [anon_sym_AT] = ACTIONS(5748),
    [anon_sym_QMARK] = ACTIONS(5748),
    [anon_sym_0] = ACTIONS(5752),
    [anon_sym__] = ACTIONS(5752),
  },
  [2269] = {
    [sym__terminated_statement] = STATE(2503),
    [sym_for_statement] = STATE(2501),
    [sym_c_style_for_statement] = STATE(2501),
    [sym_while_statement] = STATE(2501),
    [sym_if_statement] = STATE(2501),
    [sym_case_statement] = STATE(2501),
    [sym_function_definition] = STATE(2501),
    [sym_subshell] = STATE(2501),
    [sym_pipeline] = STATE(2501),
    [sym_list] = STATE(2501),
    [sym_negated_command] = STATE(2501),
    [sym_test_command] = STATE(2501),
    [sym_declaration_command] = STATE(2501),
    [sym_unset_command] = STATE(2501),
    [sym_command] = STATE(2501),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2502),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(2503),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2270] = {
    [sym__terminated_statement] = STATE(2506),
    [sym_for_statement] = STATE(2504),
    [sym_c_style_for_statement] = STATE(2504),
    [sym_while_statement] = STATE(2504),
    [sym_if_statement] = STATE(2504),
    [sym_case_statement] = STATE(2504),
    [sym_function_definition] = STATE(2504),
    [sym_subshell] = STATE(2504),
    [sym_pipeline] = STATE(2504),
    [sym_list] = STATE(2504),
    [sym_negated_command] = STATE(2504),
    [sym_test_command] = STATE(2504),
    [sym_declaration_command] = STATE(2504),
    [sym_unset_command] = STATE(2504),
    [sym_command] = STATE(2504),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(2505),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2506),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [2271] = {
    [sym__terminated_statement] = STATE(2509),
    [sym_for_statement] = STATE(2507),
    [sym_c_style_for_statement] = STATE(2507),
    [sym_while_statement] = STATE(2507),
    [sym_if_statement] = STATE(2507),
    [sym_case_statement] = STATE(2507),
    [sym_function_definition] = STATE(2507),
    [sym_subshell] = STATE(2507),
    [sym_pipeline] = STATE(2507),
    [sym_list] = STATE(2507),
    [sym_negated_command] = STATE(2507),
    [sym_test_command] = STATE(2507),
    [sym_declaration_command] = STATE(2507),
    [sym_unset_command] = STATE(2507),
    [sym_command] = STATE(2507),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2508),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(2509),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2272] = {
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_esac] = ACTIONS(615),
    [anon_sym_PIPE] = ACTIONS(615),
    [anon_sym_SEMI_SEMI] = ACTIONS(613),
    [anon_sym_PIPE_AMP] = ACTIONS(613),
    [anon_sym_AMP_AMP] = ACTIONS(613),
    [anon_sym_PIPE_PIPE] = ACTIONS(613),
    [sym__special_characters] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [sym_raw_string] = ACTIONS(613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(613),
    [anon_sym_LT_LPAREN] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(613),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(615),
    [sym_word] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(615),
    [anon_sym_LF] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(615),
  },
  [2273] = {
    [anon_sym_EQ] = ACTIONS(5728),
    [anon_sym_PLUS_EQ] = ACTIONS(5728),
    [sym_comment] = ACTIONS(53),
  },
  [2274] = {
    [sym_variable_assignment] = STATE(2510),
    [sym_subscript] = STATE(2273),
    [sym_concatenation] = STATE(2510),
    [sym_string] = STATE(2267),
    [sym_simple_expansion] = STATE(2267),
    [sym_string_expansion] = STATE(2267),
    [sym_expansion] = STATE(2267),
    [sym_command_substitution] = STATE(2267),
    [sym_process_substitution] = STATE(2267),
    [aux_sym_declaration_command_repeat1] = STATE(2510),
    [sym_variable_name] = ACTIONS(5244),
    [anon_sym_esac] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(619),
    [anon_sym_PIPE_AMP] = ACTIONS(619),
    [anon_sym_AMP_AMP] = ACTIONS(619),
    [anon_sym_PIPE_PIPE] = ACTIONS(619),
    [sym__special_characters] = ACTIONS(5246),
    [anon_sym_DQUOTE] = ACTIONS(5248),
    [anon_sym_DOLLAR] = ACTIONS(5250),
    [sym_raw_string] = ACTIONS(5252),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5256),
    [anon_sym_BQUOTE] = ACTIONS(5258),
    [anon_sym_LT_LPAREN] = ACTIONS(5260),
    [anon_sym_GT_LPAREN] = ACTIONS(5260),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5262),
    [sym_word] = ACTIONS(5264),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [2275] = {
    [aux_sym_concatenation_repeat1] = STATE(2512),
    [sym__concat] = ACTIONS(5754),
    [anon_sym_esac] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(625),
    [anon_sym_PIPE_AMP] = ACTIONS(625),
    [anon_sym_AMP_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(625),
    [sym__special_characters] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(625),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LT_LPAREN] = ACTIONS(625),
    [anon_sym_GT_LPAREN] = ACTIONS(625),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(623),
  },
  [2276] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(2515),
    [anon_sym_DQUOTE] = ACTIONS(5756),
    [anon_sym_DOLLAR] = ACTIONS(5758),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [2277] = {
    [sym_string] = STATE(2517),
    [anon_sym_DQUOTE] = ACTIONS(5268),
    [anon_sym_DOLLAR] = ACTIONS(5760),
    [sym_raw_string] = ACTIONS(5762),
    [anon_sym_POUND] = ACTIONS(5760),
    [anon_sym_DASH] = ACTIONS(5760),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5764),
    [anon_sym_STAR] = ACTIONS(5760),
    [anon_sym_AT] = ACTIONS(5760),
    [anon_sym_QMARK] = ACTIONS(5760),
    [anon_sym_0] = ACTIONS(5766),
    [anon_sym__] = ACTIONS(5766),
  },
  [2278] = {
    [aux_sym_concatenation_repeat1] = STATE(2512),
    [sym__concat] = ACTIONS(5754),
    [anon_sym_esac] = ACTIONS(639),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_SEMI_SEMI] = ACTIONS(641),
    [anon_sym_PIPE_AMP] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [sym__special_characters] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(641),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [anon_sym_LT_LPAREN] = ACTIONS(641),
    [anon_sym_GT_LPAREN] = ACTIONS(641),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_LF] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(639),
  },
  [2279] = {
    [sym_subscript] = STATE(2523),
    [sym_variable_name] = ACTIONS(5768),
    [anon_sym_BANG] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5772),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5774),
    [anon_sym_STAR] = ACTIONS(5772),
    [anon_sym_AT] = ACTIONS(5772),
    [anon_sym_QMARK] = ACTIONS(5772),
    [anon_sym_0] = ACTIONS(5776),
    [anon_sym__] = ACTIONS(5776),
  },
  [2280] = {
    [sym__terminated_statement] = STATE(2526),
    [sym_for_statement] = STATE(2524),
    [sym_c_style_for_statement] = STATE(2524),
    [sym_while_statement] = STATE(2524),
    [sym_if_statement] = STATE(2524),
    [sym_case_statement] = STATE(2524),
    [sym_function_definition] = STATE(2524),
    [sym_subshell] = STATE(2524),
    [sym_pipeline] = STATE(2524),
    [sym_list] = STATE(2524),
    [sym_negated_command] = STATE(2524),
    [sym_test_command] = STATE(2524),
    [sym_declaration_command] = STATE(2524),
    [sym_unset_command] = STATE(2524),
    [sym_command] = STATE(2524),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2525),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(2526),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2281] = {
    [sym__terminated_statement] = STATE(2529),
    [sym_for_statement] = STATE(2527),
    [sym_c_style_for_statement] = STATE(2527),
    [sym_while_statement] = STATE(2527),
    [sym_if_statement] = STATE(2527),
    [sym_case_statement] = STATE(2527),
    [sym_function_definition] = STATE(2527),
    [sym_subshell] = STATE(2527),
    [sym_pipeline] = STATE(2527),
    [sym_list] = STATE(2527),
    [sym_negated_command] = STATE(2527),
    [sym_test_command] = STATE(2527),
    [sym_declaration_command] = STATE(2527),
    [sym_unset_command] = STATE(2527),
    [sym_command] = STATE(2527),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(2528),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2529),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [2282] = {
    [sym__terminated_statement] = STATE(2532),
    [sym_for_statement] = STATE(2530),
    [sym_c_style_for_statement] = STATE(2530),
    [sym_while_statement] = STATE(2530),
    [sym_if_statement] = STATE(2530),
    [sym_case_statement] = STATE(2530),
    [sym_function_definition] = STATE(2530),
    [sym_subshell] = STATE(2530),
    [sym_pipeline] = STATE(2530),
    [sym_list] = STATE(2530),
    [sym_negated_command] = STATE(2530),
    [sym_test_command] = STATE(2530),
    [sym_declaration_command] = STATE(2530),
    [sym_unset_command] = STATE(2530),
    [sym_command] = STATE(2530),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2531),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(2532),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2283] = {
    [anon_sym_esac] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_SEMI_SEMI] = ACTIONS(655),
    [anon_sym_PIPE_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(655),
    [sym__special_characters] = ACTIONS(655),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [sym_raw_string] = ACTIONS(655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(655),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_LT_LPAREN] = ACTIONS(655),
    [anon_sym_GT_LPAREN] = ACTIONS(655),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(653),
    [sym_word] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LF] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(653),
  },
  [2284] = {
    [sym_concatenation] = STATE(2533),
    [sym_string] = STATE(2278),
    [sym_simple_expansion] = STATE(2278),
    [sym_string_expansion] = STATE(2278),
    [sym_expansion] = STATE(2278),
    [sym_command_substitution] = STATE(2278),
    [sym_process_substitution] = STATE(2278),
    [aux_sym_unset_command_repeat1] = STATE(2533),
    [anon_sym_esac] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(659),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [sym__special_characters] = ACTIONS(5266),
    [anon_sym_DQUOTE] = ACTIONS(5268),
    [anon_sym_DOLLAR] = ACTIONS(5270),
    [sym_raw_string] = ACTIONS(5272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5274),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5276),
    [anon_sym_BQUOTE] = ACTIONS(5278),
    [anon_sym_LT_LPAREN] = ACTIONS(5280),
    [anon_sym_GT_LPAREN] = ACTIONS(5280),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5282),
    [sym_word] = ACTIONS(5284),
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(657),
  },
  [2285] = {
    [sym_string] = STATE(2534),
    [sym_simple_expansion] = STATE(2534),
    [sym_string_expansion] = STATE(2534),
    [sym_expansion] = STATE(2534),
    [sym_command_substitution] = STATE(2534),
    [sym_process_substitution] = STATE(2534),
    [sym__special_characters] = ACTIONS(5778),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(5778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5778),
  },
  [2286] = {
    [aux_sym_concatenation_repeat1] = STATE(2535),
    [sym__simple_heredoc_body] = ACTIONS(695),
    [sym__heredoc_body_beginning] = ACTIONS(695),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(5286),
    [anon_sym_esac] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [2287] = {
    [sym__simple_heredoc_body] = ACTIONS(699),
    [sym__heredoc_body_beginning] = ACTIONS(699),
    [sym_file_descriptor] = ACTIONS(699),
    [sym__concat] = ACTIONS(699),
    [anon_sym_esac] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_EQ_TILDE] = ACTIONS(701),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(701),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_LT_LT_DASH] = ACTIONS(699),
    [anon_sym_LT_LT_LT] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
  },
  [2288] = {
    [anon_sym_DQUOTE] = ACTIONS(5780),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [2289] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(5780),
    [anon_sym_DOLLAR] = ACTIONS(5782),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [2290] = {
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2291] = {
    [sym__simple_heredoc_body] = ACTIONS(735),
    [sym__heredoc_body_beginning] = ACTIONS(735),
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(735),
    [anon_sym_LT_LT_LT] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2292] = {
    [sym__simple_heredoc_body] = ACTIONS(739),
    [sym__heredoc_body_beginning] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(739),
    [sym__concat] = ACTIONS(739),
    [anon_sym_esac] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_EQ_TILDE] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_LT_LT_DASH] = ACTIONS(739),
    [anon_sym_LT_LT_LT] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [2293] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(5784),
    [sym_comment] = ACTIONS(53),
  },
  [2294] = {
    [sym_subscript] = STATE(2542),
    [sym_variable_name] = ACTIONS(5786),
    [anon_sym_DOLLAR] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5790),
    [anon_sym_STAR] = ACTIONS(5788),
    [anon_sym_AT] = ACTIONS(5788),
    [anon_sym_QMARK] = ACTIONS(5788),
    [anon_sym_0] = ACTIONS(5792),
    [anon_sym__] = ACTIONS(5792),
  },
  [2295] = {
    [sym_concatenation] = STATE(2545),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2545),
    [anon_sym_RBRACE] = ACTIONS(5794),
    [anon_sym_EQ] = ACTIONS(5796),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(5800),
    [anon_sym_COLON] = ACTIONS(5796),
    [anon_sym_COLON_QMARK] = ACTIONS(5796),
    [anon_sym_COLON_DASH] = ACTIONS(5796),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2296] = {
    [sym_concatenation] = STATE(2548),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2548),
    [anon_sym_RBRACE] = ACTIONS(5802),
    [anon_sym_EQ] = ACTIONS(5804),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5804),
    [anon_sym_COLON_QMARK] = ACTIONS(5804),
    [anon_sym_COLON_DASH] = ACTIONS(5804),
    [anon_sym_PERCENT] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2297] = {
    [sym_concatenation] = STATE(2551),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2551),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5812),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5814),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(5816),
    [anon_sym_COLON] = ACTIONS(5812),
    [anon_sym_COLON_QMARK] = ACTIONS(5812),
    [anon_sym_COLON_DASH] = ACTIONS(5812),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2298] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5818),
    [anon_sym_SEMI_SEMI] = ACTIONS(5820),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_LF] = ACTIONS(5820),
    [anon_sym_AMP] = ACTIONS(5822),
  },
  [2299] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5818),
    [anon_sym_SEMI_SEMI] = ACTIONS(5820),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_LF] = ACTIONS(5820),
    [anon_sym_AMP] = ACTIONS(5822),
  },
  [2300] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2554),
    [sym_c_style_for_statement] = STATE(2554),
    [sym_while_statement] = STATE(2554),
    [sym_if_statement] = STATE(2554),
    [sym_case_statement] = STATE(2554),
    [sym_function_definition] = STATE(2554),
    [sym_subshell] = STATE(2554),
    [sym_pipeline] = STATE(2554),
    [sym_list] = STATE(2554),
    [sym_negated_command] = STATE(2554),
    [sym_test_command] = STATE(2554),
    [sym_declaration_command] = STATE(2554),
    [sym_unset_command] = STATE(2554),
    [sym_command] = STATE(2554),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2555),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2301] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(5824),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(5818),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5826),
    [anon_sym_LF] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5826),
  },
  [2302] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(5824),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(5818),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5826),
    [anon_sym_LF] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5826),
  },
  [2303] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2557),
    [sym_c_style_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_if_statement] = STATE(2557),
    [sym_case_statement] = STATE(2557),
    [sym_function_definition] = STATE(2557),
    [sym_subshell] = STATE(2557),
    [sym_pipeline] = STATE(2557),
    [sym_list] = STATE(2557),
    [sym_negated_command] = STATE(2557),
    [sym_test_command] = STATE(2557),
    [sym_declaration_command] = STATE(2557),
    [sym_unset_command] = STATE(2557),
    [sym_command] = STATE(2557),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(2558),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [2304] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5828),
    [anon_sym_SEMI_SEMI] = ACTIONS(5830),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5832),
    [anon_sym_LF] = ACTIONS(5830),
    [anon_sym_AMP] = ACTIONS(5832),
  },
  [2305] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(5828),
    [anon_sym_SEMI_SEMI] = ACTIONS(5830),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5832),
    [anon_sym_LF] = ACTIONS(5830),
    [anon_sym_AMP] = ACTIONS(5832),
  },
  [2306] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2561),
    [sym_c_style_for_statement] = STATE(2561),
    [sym_while_statement] = STATE(2561),
    [sym_if_statement] = STATE(2561),
    [sym_case_statement] = STATE(2561),
    [sym_function_definition] = STATE(2561),
    [sym_subshell] = STATE(2561),
    [sym_pipeline] = STATE(2561),
    [sym_list] = STATE(2561),
    [sym_negated_command] = STATE(2561),
    [sym_test_command] = STATE(2561),
    [sym_declaration_command] = STATE(2561),
    [sym_unset_command] = STATE(2561),
    [sym_command] = STATE(2561),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2562),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2307] = {
    [anon_sym_RPAREN] = ACTIONS(5834),
    [sym_comment] = ACTIONS(53),
  },
  [2308] = {
    [sym_for_statement] = STATE(471),
    [sym_c_style_for_statement] = STATE(471),
    [sym_while_statement] = STATE(471),
    [sym_if_statement] = STATE(471),
    [sym_case_statement] = STATE(471),
    [sym_function_definition] = STATE(471),
    [sym_subshell] = STATE(471),
    [sym_pipeline] = STATE(471),
    [sym_list] = STATE(471),
    [sym_negated_command] = STATE(471),
    [sym_test_command] = STATE(471),
    [sym_declaration_command] = STATE(471),
    [sym_unset_command] = STATE(471),
    [sym_command] = STATE(471),
    [sym_command_name] = STATE(1970),
    [sym_variable_assignment] = STATE(2564),
    [sym_subscript] = STATE(1972),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_command_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4450),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4452),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4464),
    [anon_sym_declare] = ACTIONS(4466),
    [anon_sym_typeset] = ACTIONS(4466),
    [anon_sym_export] = ACTIONS(4466),
    [anon_sym_readonly] = ACTIONS(4466),
    [anon_sym_local] = ACTIONS(4466),
    [anon_sym_unset] = ACTIONS(4468),
    [anon_sym_unsetenv] = ACTIONS(4468),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4470),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4486),
  },
  [2309] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_esac] = ACTIONS(5836),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(5838),
    [anon_sym_DQUOTE] = ACTIONS(5840),
    [anon_sym_DOLLAR] = ACTIONS(5838),
    [sym_raw_string] = ACTIONS(5840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5840),
    [anon_sym_BQUOTE] = ACTIONS(5840),
    [anon_sym_LT_LPAREN] = ACTIONS(5840),
    [anon_sym_GT_LPAREN] = ACTIONS(5840),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5838),
  },
  [2310] = {
    [sym_for_statement] = STATE(2565),
    [sym_c_style_for_statement] = STATE(2565),
    [sym_while_statement] = STATE(2565),
    [sym_if_statement] = STATE(2565),
    [sym_case_statement] = STATE(2565),
    [sym_function_definition] = STATE(2565),
    [sym_subshell] = STATE(2565),
    [sym_pipeline] = STATE(2565),
    [sym_list] = STATE(2565),
    [sym_negated_command] = STATE(2565),
    [sym_test_command] = STATE(2565),
    [sym_declaration_command] = STATE(2565),
    [sym_unset_command] = STATE(2565),
    [sym_command] = STATE(2565),
    [sym_command_name] = STATE(1970),
    [sym_variable_assignment] = STATE(2566),
    [sym_subscript] = STATE(1972),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_command_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4450),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4452),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4464),
    [anon_sym_declare] = ACTIONS(4466),
    [anon_sym_typeset] = ACTIONS(4466),
    [anon_sym_export] = ACTIONS(4466),
    [anon_sym_readonly] = ACTIONS(4466),
    [anon_sym_local] = ACTIONS(4466),
    [anon_sym_unset] = ACTIONS(4468),
    [anon_sym_unsetenv] = ACTIONS(4468),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4470),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4486),
  },
  [2311] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_esac] = ACTIONS(835),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2312] = {
    [anon_sym_LT] = ACTIONS(5842),
    [anon_sym_GT] = ACTIONS(5842),
    [anon_sym_GT_GT] = ACTIONS(5844),
    [anon_sym_AMP_GT] = ACTIONS(5842),
    [anon_sym_AMP_GT_GT] = ACTIONS(5844),
    [anon_sym_LT_AMP] = ACTIONS(5844),
    [anon_sym_GT_AMP] = ACTIONS(5844),
    [sym_comment] = ACTIONS(53),
  },
  [2313] = {
    [sym_concatenation] = STATE(2570),
    [sym_string] = STATE(2569),
    [sym_simple_expansion] = STATE(2569),
    [sym_string_expansion] = STATE(2569),
    [sym_expansion] = STATE(2569),
    [sym_command_substitution] = STATE(2569),
    [sym_process_substitution] = STATE(2569),
    [sym__special_characters] = ACTIONS(5846),
    [anon_sym_DQUOTE] = ACTIONS(5848),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(5850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5854),
    [anon_sym_BQUOTE] = ACTIONS(5856),
    [anon_sym_LT_LPAREN] = ACTIONS(5858),
    [anon_sym_GT_LPAREN] = ACTIONS(5858),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(5850),
    [sym_regex] = ACTIONS(5860),
  },
  [2314] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(2574),
    [sym_simple_expansion] = STATE(2574),
    [sym_string_expansion] = STATE(2574),
    [sym_expansion] = STATE(2574),
    [sym_command_substitution] = STATE(2574),
    [sym_process_substitution] = STATE(2574),
    [sym__special_characters] = ACTIONS(5862),
    [anon_sym_DQUOTE] = ACTIONS(5864),
    [anon_sym_DOLLAR] = ACTIONS(5866),
    [sym_raw_string] = ACTIONS(5868),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5870),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5872),
    [anon_sym_BQUOTE] = ACTIONS(5874),
    [anon_sym_LT_LPAREN] = ACTIONS(5876),
    [anon_sym_GT_LPAREN] = ACTIONS(5876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5868),
  },
  [2315] = {
    [sym_concatenation] = STATE(489),
    [sym_string] = STATE(2580),
    [sym_simple_expansion] = STATE(2580),
    [sym_string_expansion] = STATE(2580),
    [sym_expansion] = STATE(2580),
    [sym_command_substitution] = STATE(2580),
    [sym_process_substitution] = STATE(2580),
    [sym__special_characters] = ACTIONS(5878),
    [anon_sym_DQUOTE] = ACTIONS(5864),
    [anon_sym_DOLLAR] = ACTIONS(5866),
    [sym_raw_string] = ACTIONS(5880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5870),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5872),
    [anon_sym_BQUOTE] = ACTIONS(5874),
    [anon_sym_LT_LPAREN] = ACTIONS(5876),
    [anon_sym_GT_LPAREN] = ACTIONS(5876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5880),
  },
  [2316] = {
    [aux_sym_concatenation_repeat1] = STATE(2286),
    [sym__simple_heredoc_body] = ACTIONS(879),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(879),
    [sym__concat] = ACTIONS(5286),
    [anon_sym_esac] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(881),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(881),
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [sym__special_characters] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(881),
    [sym_raw_string] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_LF] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(881),
  },
  [2317] = {
    [aux_sym_concatenation_repeat1] = STATE(2286),
    [sym__simple_heredoc_body] = ACTIONS(883),
    [sym__heredoc_body_beginning] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(883),
    [sym__concat] = ACTIONS(5286),
    [anon_sym_esac] = ACTIONS(885),
    [anon_sym_PIPE] = ACTIONS(885),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_EQ_TILDE] = ACTIONS(885),
    [anon_sym_EQ_EQ] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(885),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [sym__special_characters] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(885),
    [anon_sym_LF] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(885),
  },
  [2318] = {
    [sym_file_redirect] = STATE(2581),
    [sym_heredoc_redirect] = STATE(2581),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(2581),
    [aux_sym_while_statement_repeat1] = STATE(2581),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(5326),
    [anon_sym_esac] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(5330),
    [anon_sym_GT] = ACTIONS(5330),
    [anon_sym_GT_GT] = ACTIONS(5332),
    [anon_sym_AMP_GT] = ACTIONS(5330),
    [anon_sym_AMP_GT_GT] = ACTIONS(5332),
    [anon_sym_LT_AMP] = ACTIONS(5332),
    [anon_sym_GT_AMP] = ACTIONS(5332),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(5334),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [2319] = {
    [sym_file_redirect] = STATE(2582),
    [sym_heredoc_redirect] = STATE(2582),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(2582),
    [sym_concatenation] = STATE(2583),
    [sym_string] = STATE(2317),
    [sym_simple_expansion] = STATE(2317),
    [sym_string_expansion] = STATE(2317),
    [sym_expansion] = STATE(2317),
    [sym_command_substitution] = STATE(2317),
    [sym_process_substitution] = STATE(2317),
    [aux_sym_while_statement_repeat1] = STATE(2582),
    [aux_sym_command_repeat2] = STATE(2583),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(5326),
    [anon_sym_esac] = ACTIONS(889),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(5328),
    [anon_sym_EQ_EQ] = ACTIONS(5328),
    [anon_sym_LT] = ACTIONS(5330),
    [anon_sym_GT] = ACTIONS(5330),
    [anon_sym_GT_GT] = ACTIONS(5332),
    [anon_sym_AMP_GT] = ACTIONS(5330),
    [anon_sym_AMP_GT_GT] = ACTIONS(5332),
    [anon_sym_LT_AMP] = ACTIONS(5332),
    [anon_sym_GT_AMP] = ACTIONS(5332),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(5334),
    [sym__special_characters] = ACTIONS(5336),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(5338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5340),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [2320] = {
    [anon_sym_esac] = ACTIONS(5836),
    [sym__special_characters] = ACTIONS(5840),
    [anon_sym_DQUOTE] = ACTIONS(5840),
    [anon_sym_DOLLAR] = ACTIONS(5838),
    [sym_raw_string] = ACTIONS(5840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5840),
    [anon_sym_BQUOTE] = ACTIONS(5840),
    [anon_sym_LT_LPAREN] = ACTIONS(5840),
    [anon_sym_GT_LPAREN] = ACTIONS(5840),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5838),
  },
  [2321] = {
    [anon_sym_esac] = ACTIONS(5882),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5884),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [2322] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_esac] = ACTIONS(5836),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5884),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [2323] = {
    [sym__terminated_statement] = STATE(2323),
    [sym_for_statement] = STATE(2585),
    [sym_c_style_for_statement] = STATE(2585),
    [sym_while_statement] = STATE(2585),
    [sym_if_statement] = STATE(2585),
    [sym_case_statement] = STATE(2585),
    [sym_function_definition] = STATE(2585),
    [sym_subshell] = STATE(2585),
    [sym_pipeline] = STATE(2585),
    [sym_list] = STATE(2585),
    [sym_negated_command] = STATE(2585),
    [sym_test_command] = STATE(2585),
    [sym_declaration_command] = STATE(2585),
    [sym_unset_command] = STATE(2585),
    [sym_command] = STATE(2585),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2586),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2323),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(891),
    [sym_variable_name] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(908),
    [anon_sym_esac] = ACTIONS(3482),
    [anon_sym_SEMI_SEMI] = ACTIONS(897),
    [anon_sym_function] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(923),
    [anon_sym_declare] = ACTIONS(926),
    [anon_sym_typeset] = ACTIONS(926),
    [anon_sym_export] = ACTIONS(926),
    [anon_sym_readonly] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym_unset] = ACTIONS(929),
    [anon_sym_unsetenv] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [sym_raw_string] = ACTIONS(947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [anon_sym_LT_LPAREN] = ACTIONS(959),
    [anon_sym_GT_LPAREN] = ACTIONS(959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(962),
  },
  [2324] = {
    [sym_file_redirect] = STATE(2582),
    [sym_heredoc_redirect] = STATE(2582),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(2582),
    [sym_concatenation] = STATE(2587),
    [sym_string] = STATE(2317),
    [sym_simple_expansion] = STATE(2317),
    [sym_string_expansion] = STATE(2317),
    [sym_expansion] = STATE(2317),
    [sym_command_substitution] = STATE(2317),
    [sym_process_substitution] = STATE(2317),
    [aux_sym_while_statement_repeat1] = STATE(2582),
    [aux_sym_command_repeat2] = STATE(2587),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(5326),
    [anon_sym_esac] = ACTIONS(889),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(5328),
    [anon_sym_EQ_EQ] = ACTIONS(5328),
    [anon_sym_LT] = ACTIONS(5330),
    [anon_sym_GT] = ACTIONS(5330),
    [anon_sym_GT_GT] = ACTIONS(5332),
    [anon_sym_AMP_GT] = ACTIONS(5330),
    [anon_sym_AMP_GT_GT] = ACTIONS(5332),
    [anon_sym_LT_AMP] = ACTIONS(5332),
    [anon_sym_GT_AMP] = ACTIONS(5332),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(5334),
    [sym__special_characters] = ACTIONS(5336),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(5338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5340),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
  },
  [2325] = {
    [sym__terminated_statement] = STATE(2323),
    [sym_for_statement] = STATE(2589),
    [sym_c_style_for_statement] = STATE(2589),
    [sym_while_statement] = STATE(2589),
    [sym_if_statement] = STATE(2589),
    [sym_case_statement] = STATE(2589),
    [sym_function_definition] = STATE(2589),
    [sym_subshell] = STATE(2589),
    [sym_pipeline] = STATE(2589),
    [sym_list] = STATE(2589),
    [sym_negated_command] = STATE(2589),
    [sym_test_command] = STATE(2589),
    [sym_declaration_command] = STATE(2589),
    [sym_unset_command] = STATE(2589),
    [sym_command] = STATE(2589),
    [sym_command_name] = STATE(1970),
    [sym_variable_assignment] = STATE(2590),
    [sym_subscript] = STATE(1972),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_program_repeat1] = STATE(2323),
    [aux_sym_command_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4450),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4452),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5836),
    [anon_sym_SEMI_SEMI] = ACTIONS(5886),
    [anon_sym_function] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4464),
    [anon_sym_declare] = ACTIONS(4466),
    [anon_sym_typeset] = ACTIONS(4466),
    [anon_sym_export] = ACTIONS(4466),
    [anon_sym_readonly] = ACTIONS(4466),
    [anon_sym_local] = ACTIONS(4466),
    [anon_sym_unset] = ACTIONS(4468),
    [anon_sym_unsetenv] = ACTIONS(4468),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4470),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4486),
  },
  [2326] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_esac] = ACTIONS(5888),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(5890),
    [anon_sym_DQUOTE] = ACTIONS(5892),
    [anon_sym_DOLLAR] = ACTIONS(5890),
    [sym_raw_string] = ACTIONS(5892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5892),
    [anon_sym_BQUOTE] = ACTIONS(5892),
    [anon_sym_LT_LPAREN] = ACTIONS(5892),
    [anon_sym_GT_LPAREN] = ACTIONS(5892),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5890),
  },
  [2327] = {
    [anon_sym_esac] = ACTIONS(5888),
    [sym__special_characters] = ACTIONS(5892),
    [anon_sym_DQUOTE] = ACTIONS(5892),
    [anon_sym_DOLLAR] = ACTIONS(5890),
    [sym_raw_string] = ACTIONS(5892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5892),
    [anon_sym_BQUOTE] = ACTIONS(5892),
    [anon_sym_LT_LPAREN] = ACTIONS(5892),
    [anon_sym_GT_LPAREN] = ACTIONS(5892),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5890),
  },
  [2328] = {
    [anon_sym_esac] = ACTIONS(5894),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5896),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [2329] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_esac] = ACTIONS(5888),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5896),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [2330] = {
    [sym__terminated_statement] = STATE(2323),
    [sym_for_statement] = STATE(2593),
    [sym_c_style_for_statement] = STATE(2593),
    [sym_while_statement] = STATE(2593),
    [sym_if_statement] = STATE(2593),
    [sym_case_statement] = STATE(2593),
    [sym_function_definition] = STATE(2593),
    [sym_subshell] = STATE(2593),
    [sym_pipeline] = STATE(2593),
    [sym_list] = STATE(2593),
    [sym_negated_command] = STATE(2593),
    [sym_test_command] = STATE(2593),
    [sym_declaration_command] = STATE(2593),
    [sym_unset_command] = STATE(2593),
    [sym_command] = STATE(2593),
    [sym_command_name] = STATE(1970),
    [sym_variable_assignment] = STATE(2594),
    [sym_subscript] = STATE(1972),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1963),
    [sym_simple_expansion] = STATE(1963),
    [sym_string_expansion] = STATE(1963),
    [sym_expansion] = STATE(1963),
    [sym_command_substitution] = STATE(1963),
    [sym_process_substitution] = STATE(1963),
    [aux_sym_program_repeat1] = STATE(2323),
    [aux_sym_command_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4450),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4452),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5888),
    [anon_sym_SEMI_SEMI] = ACTIONS(5898),
    [anon_sym_function] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4464),
    [anon_sym_declare] = ACTIONS(4466),
    [anon_sym_typeset] = ACTIONS(4466),
    [anon_sym_export] = ACTIONS(4466),
    [anon_sym_readonly] = ACTIONS(4466),
    [anon_sym_local] = ACTIONS(4466),
    [anon_sym_unset] = ACTIONS(4468),
    [anon_sym_unsetenv] = ACTIONS(4468),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4470),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4486),
  },
  [2331] = {
    [sym__terminated_statement] = STATE(2598),
    [sym_for_statement] = STATE(2596),
    [sym_c_style_for_statement] = STATE(2596),
    [sym_while_statement] = STATE(2596),
    [sym_if_statement] = STATE(2596),
    [sym_case_statement] = STATE(2596),
    [sym_function_definition] = STATE(2596),
    [sym_subshell] = STATE(2596),
    [sym_pipeline] = STATE(2596),
    [sym_list] = STATE(2596),
    [sym_negated_command] = STATE(2596),
    [sym_test_command] = STATE(2596),
    [sym_declaration_command] = STATE(2596),
    [sym_unset_command] = STATE(2596),
    [sym_command] = STATE(2596),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2597),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2598),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5900),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2332] = {
    [aux_sym_case_item_repeat1] = STATE(1977),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(5902),
    [sym_comment] = ACTIONS(53),
  },
  [2333] = {
    [sym__terminated_statement] = STATE(2603),
    [sym_for_statement] = STATE(2601),
    [sym_c_style_for_statement] = STATE(2601),
    [sym_while_statement] = STATE(2601),
    [sym_if_statement] = STATE(2601),
    [sym_case_statement] = STATE(2601),
    [sym_function_definition] = STATE(2601),
    [sym_subshell] = STATE(2601),
    [sym_pipeline] = STATE(2601),
    [sym_list] = STATE(2601),
    [sym_negated_command] = STATE(2601),
    [sym_test_command] = STATE(2601),
    [sym_declaration_command] = STATE(2601),
    [sym_unset_command] = STATE(2601),
    [sym_command] = STATE(2601),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2602),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2603),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5904),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2334] = {
    [aux_sym_case_item_repeat1] = STATE(1977),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(5906),
    [sym_comment] = ACTIONS(53),
  },
  [2335] = {
    [anon_sym_esac] = ACTIONS(5908),
    [anon_sym_PIPE] = ACTIONS(5910),
    [anon_sym_RPAREN] = ACTIONS(5908),
    [anon_sym_SEMI_SEMI] = ACTIONS(5908),
    [anon_sym_PIPE_AMP] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_BQUOTE] = ACTIONS(5908),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5910),
    [anon_sym_LF] = ACTIONS(5908),
    [anon_sym_AMP] = ACTIONS(5910),
  },
  [2336] = {
    [anon_sym_esac] = ACTIONS(5912),
    [anon_sym_PIPE] = ACTIONS(5914),
    [anon_sym_RPAREN] = ACTIONS(5912),
    [anon_sym_SEMI_SEMI] = ACTIONS(5912),
    [anon_sym_PIPE_AMP] = ACTIONS(5912),
    [anon_sym_AMP_AMP] = ACTIONS(5912),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_BQUOTE] = ACTIONS(5912),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5914),
    [anon_sym_LF] = ACTIONS(5912),
    [anon_sym_AMP] = ACTIONS(5914),
  },
  [2337] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_in] = ACTIONS(5524),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5524),
  },
  [2338] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
  },
  [2339] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_in] = ACTIONS(5532),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5532),
  },
  [2340] = {
    [aux_sym_concatenation_repeat1] = STATE(2340),
    [sym__concat] = ACTIONS(2679),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2341] = {
    [aux_sym_concatenation_repeat1] = STATE(2341),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(5389),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2342] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_RBRACK] = ACTIONS(5524),
    [anon_sym_EQ_TILDE] = ACTIONS(5524),
    [anon_sym_EQ_EQ] = ACTIONS(5524),
    [anon_sym_EQ] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_BANG_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5524),
  },
  [2343] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_RBRACK] = ACTIONS(5528),
    [anon_sym_EQ_TILDE] = ACTIONS(5528),
    [anon_sym_EQ_EQ] = ACTIONS(5528),
    [anon_sym_EQ] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_BANG_EQ] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5528),
  },
  [2344] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_RBRACK] = ACTIONS(5532),
    [anon_sym_EQ_TILDE] = ACTIONS(5532),
    [anon_sym_EQ_EQ] = ACTIONS(5532),
    [anon_sym_EQ] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5532),
    [anon_sym_GT] = ACTIONS(5532),
    [anon_sym_BANG_EQ] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5532),
  },
  [2345] = {
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2855),
    [anon_sym_LT_AMP] = ACTIONS(2855),
    [anon_sym_GT_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_LT_LT_DASH] = ACTIONS(2855),
    [anon_sym_LT_LT_LT] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [2346] = {
    [sym_file_descriptor] = ACTIONS(2869),
    [sym__concat] = ACTIONS(2869),
    [anon_sym_esac] = ACTIONS(2869),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_RPAREN] = ACTIONS(2869),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [anon_sym_PIPE_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_GT_GT] = ACTIONS(2869),
    [anon_sym_AMP_GT] = ACTIONS(2871),
    [anon_sym_AMP_GT_GT] = ACTIONS(2869),
    [anon_sym_LT_AMP] = ACTIONS(2869),
    [anon_sym_GT_AMP] = ACTIONS(2869),
    [anon_sym_LT_LT] = ACTIONS(2871),
    [anon_sym_LT_LT_DASH] = ACTIONS(2869),
    [anon_sym_LT_LT_LT] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [2347] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5916),
    [sym_comment] = ACTIONS(53),
  },
  [2348] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5918),
    [sym_comment] = ACTIONS(53),
  },
  [2349] = {
    [anon_sym_RBRACE] = ACTIONS(5918),
    [sym_comment] = ACTIONS(53),
  },
  [2350] = {
    [sym_concatenation] = STATE(2609),
    [sym_string] = STATE(2608),
    [sym_simple_expansion] = STATE(2608),
    [sym_string_expansion] = STATE(2608),
    [sym_expansion] = STATE(2608),
    [sym_command_substitution] = STATE(2608),
    [sym_process_substitution] = STATE(2608),
    [anon_sym_RBRACE] = ACTIONS(5918),
    [sym__special_characters] = ACTIONS(5920),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(5922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5922),
  },
  [2351] = {
    [sym_file_descriptor] = ACTIONS(2905),
    [sym__concat] = ACTIONS(2905),
    [anon_sym_esac] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [anon_sym_PIPE_AMP] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2907),
    [anon_sym_GT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2905),
    [anon_sym_AMP_GT] = ACTIONS(2907),
    [anon_sym_AMP_GT_GT] = ACTIONS(2905),
    [anon_sym_LT_AMP] = ACTIONS(2905),
    [anon_sym_GT_AMP] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_LT_LT_DASH] = ACTIONS(2905),
    [anon_sym_LT_LT_LT] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [2352] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5924),
  },
  [2353] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5926),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2354] = {
    [sym_file_descriptor] = ACTIONS(2913),
    [sym__concat] = ACTIONS(2913),
    [anon_sym_esac] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [anon_sym_PIPE_AMP] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_AMP_GT] = ACTIONS(2915),
    [anon_sym_AMP_GT_GT] = ACTIONS(2913),
    [anon_sym_LT_AMP] = ACTIONS(2913),
    [anon_sym_GT_AMP] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_LT_LT_DASH] = ACTIONS(2913),
    [anon_sym_LT_LT_LT] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [2355] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5928),
  },
  [2356] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5930),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2357] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(5932),
  },
  [2358] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2359] = {
    [sym_concatenation] = STATE(2616),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2616),
    [anon_sym_RBRACE] = ACTIONS(5934),
    [anon_sym_EQ] = ACTIONS(5936),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5938),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5936),
    [anon_sym_COLON_QMARK] = ACTIONS(5936),
    [anon_sym_COLON_DASH] = ACTIONS(5936),
    [anon_sym_PERCENT] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2360] = {
    [sym_file_descriptor] = ACTIONS(2985),
    [sym__concat] = ACTIONS(2985),
    [anon_sym_esac] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [anon_sym_PIPE_AMP] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_GT] = ACTIONS(2987),
    [anon_sym_AMP_GT_GT] = ACTIONS(2985),
    [anon_sym_LT_AMP] = ACTIONS(2985),
    [anon_sym_GT_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_LT_LT_DASH] = ACTIONS(2985),
    [anon_sym_LT_LT_LT] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2987),
  },
  [2361] = {
    [sym_concatenation] = STATE(2618),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2618),
    [anon_sym_RBRACE] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5942),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5942),
    [anon_sym_COLON_QMARK] = ACTIONS(5942),
    [anon_sym_COLON_DASH] = ACTIONS(5942),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_DASH] = ACTIONS(5942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2362] = {
    [sym_file_descriptor] = ACTIONS(3030),
    [sym__concat] = ACTIONS(3030),
    [anon_sym_esac] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_PIPE_AMP] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_AMP_GT] = ACTIONS(3032),
    [anon_sym_AMP_GT_GT] = ACTIONS(3030),
    [anon_sym_LT_AMP] = ACTIONS(3030),
    [anon_sym_GT_AMP] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_LT_LT_DASH] = ACTIONS(3030),
    [anon_sym_LT_LT_LT] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
  },
  [2363] = {
    [sym_concatenation] = STATE(2620),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2620),
    [anon_sym_RBRACE] = ACTIONS(5946),
    [anon_sym_EQ] = ACTIONS(5948),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5948),
    [anon_sym_COLON_QMARK] = ACTIONS(5948),
    [anon_sym_COLON_DASH] = ACTIONS(5948),
    [anon_sym_PERCENT] = ACTIONS(5948),
    [anon_sym_DASH] = ACTIONS(5948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2364] = {
    [sym_file_descriptor] = ACTIONS(3040),
    [sym__concat] = ACTIONS(3040),
    [anon_sym_esac] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE_AMP] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_AMP_GT] = ACTIONS(3042),
    [anon_sym_AMP_GT_GT] = ACTIONS(3040),
    [anon_sym_LT_AMP] = ACTIONS(3040),
    [anon_sym_GT_AMP] = ACTIONS(3040),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_LT_LT_DASH] = ACTIONS(3040),
    [anon_sym_LT_LT_LT] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
  },
  [2365] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5952),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2366] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(5952),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2367] = {
    [sym_file_descriptor] = ACTIONS(3078),
    [sym__concat] = ACTIONS(3078),
    [anon_sym_esac] = ACTIONS(3078),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3078),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3078),
    [anon_sym_AMP_GT] = ACTIONS(3080),
    [anon_sym_AMP_GT_GT] = ACTIONS(3078),
    [anon_sym_LT_AMP] = ACTIONS(3078),
    [anon_sym_GT_AMP] = ACTIONS(3078),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_LT_LT_DASH] = ACTIONS(3078),
    [anon_sym_LT_LT_LT] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
  },
  [2368] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(5954),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2369] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5524),
    [anon_sym_EQ_TILDE] = ACTIONS(5524),
    [anon_sym_EQ_EQ] = ACTIONS(5524),
    [anon_sym_EQ] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_BANG_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5524),
  },
  [2370] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_RPAREN] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5528),
    [anon_sym_EQ_TILDE] = ACTIONS(5528),
    [anon_sym_EQ_EQ] = ACTIONS(5528),
    [anon_sym_EQ] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_BANG_EQ] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5528),
  },
  [2371] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5532),
    [anon_sym_EQ_TILDE] = ACTIONS(5532),
    [anon_sym_EQ_EQ] = ACTIONS(5532),
    [anon_sym_EQ] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5532),
    [anon_sym_GT] = ACTIONS(5532),
    [anon_sym_BANG_EQ] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5532),
  },
  [2372] = {
    [sym__concat] = ACTIONS(5524),
    [sym_variable_name] = ACTIONS(5524),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5524),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [anon_sym_PIPE_AMP] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5526),
    [sym_word] = ACTIONS(5526),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5526),
  },
  [2373] = {
    [sym__concat] = ACTIONS(5528),
    [sym_variable_name] = ACTIONS(5528),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_RPAREN] = ACTIONS(5528),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [anon_sym_PIPE_AMP] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [sym__special_characters] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5530),
    [sym_word] = ACTIONS(5530),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5530),
  },
  [2374] = {
    [sym__concat] = ACTIONS(5532),
    [sym_variable_name] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5534),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2375] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5524),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [anon_sym_PIPE_AMP] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5526),
    [sym_word] = ACTIONS(5526),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5526),
  },
  [2376] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_RPAREN] = ACTIONS(5528),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [anon_sym_PIPE_AMP] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [sym__special_characters] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5530),
    [sym_word] = ACTIONS(5530),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5530),
  },
  [2377] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5534),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2378] = {
    [sym_file_descriptor] = ACTIONS(5524),
    [sym__concat] = ACTIONS(5524),
    [sym_variable_name] = ACTIONS(5524),
    [anon_sym_LT] = ACTIONS(5526),
    [anon_sym_GT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_AMP_GT] = ACTIONS(5526),
    [anon_sym_AMP_GT_GT] = ACTIONS(5524),
    [anon_sym_LT_AMP] = ACTIONS(5524),
    [anon_sym_GT_AMP] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5524),
  },
  [2379] = {
    [sym_file_descriptor] = ACTIONS(5528),
    [sym__concat] = ACTIONS(5528),
    [sym_variable_name] = ACTIONS(5528),
    [anon_sym_LT] = ACTIONS(5530),
    [anon_sym_GT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_AMP_GT] = ACTIONS(5530),
    [anon_sym_AMP_GT_GT] = ACTIONS(5528),
    [anon_sym_LT_AMP] = ACTIONS(5528),
    [anon_sym_GT_AMP] = ACTIONS(5528),
    [sym__special_characters] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5528),
  },
  [2380] = {
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [sym_variable_name] = ACTIONS(5532),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5532),
    [anon_sym_LT_AMP] = ACTIONS(5532),
    [anon_sym_GT_AMP] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5532),
  },
  [2381] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5526),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym__string_content] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5526),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5526),
    [anon_sym_BQUOTE] = ACTIONS(5526),
    [sym_comment] = ACTIONS(243),
  },
  [2382] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5530),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym__string_content] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5530),
    [anon_sym_BQUOTE] = ACTIONS(5530),
    [sym_comment] = ACTIONS(243),
  },
  [2383] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym__string_content] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5534),
    [anon_sym_BQUOTE] = ACTIONS(5534),
    [sym_comment] = ACTIONS(243),
  },
  [2384] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
  },
  [2385] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_RBRACE] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
  },
  [2386] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5956),
    [sym_comment] = ACTIONS(53),
  },
  [2387] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(5958),
    [sym_comment] = ACTIONS(53),
  },
  [2388] = {
    [anon_sym_RBRACE] = ACTIONS(5958),
    [sym_comment] = ACTIONS(53),
  },
  [2389] = {
    [sym_concatenation] = STATE(2626),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2626),
    [anon_sym_RBRACE] = ACTIONS(5960),
    [anon_sym_EQ] = ACTIONS(5962),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5962),
    [anon_sym_COLON_QMARK] = ACTIONS(5962),
    [anon_sym_COLON_DASH] = ACTIONS(5962),
    [anon_sym_PERCENT] = ACTIONS(5962),
    [anon_sym_DASH] = ACTIONS(5962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2390] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
  },
  [2391] = {
    [sym_concatenation] = STATE(2628),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2628),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_EQ] = ACTIONS(5968),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5970),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5968),
    [anon_sym_COLON_QMARK] = ACTIONS(5968),
    [anon_sym_COLON_DASH] = ACTIONS(5968),
    [anon_sym_PERCENT] = ACTIONS(5968),
    [anon_sym_DASH] = ACTIONS(5968),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2392] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
  },
  [2393] = {
    [sym_concatenation] = STATE(2630),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2630),
    [anon_sym_RBRACE] = ACTIONS(5972),
    [anon_sym_EQ] = ACTIONS(5974),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(5976),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(5974),
    [anon_sym_COLON_QMARK] = ACTIONS(5974),
    [anon_sym_COLON_DASH] = ACTIONS(5974),
    [anon_sym_PERCENT] = ACTIONS(5974),
    [anon_sym_DASH] = ACTIONS(5974),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2394] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
  },
  [2395] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2396] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
  },
  [2397] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5980),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2398] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
  },
  [2399] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5982),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2400] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
  },
  [2401] = {
    [sym__concat] = ACTIONS(4098),
    [anon_sym_RBRACE] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
  },
  [2402] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [anon_sym_EQ] = ACTIONS(4887),
    [sym__special_characters] = ACTIONS(4887),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_POUND] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_COLON] = ACTIONS(4887),
    [anon_sym_COLON_QMARK] = ACTIONS(4887),
    [anon_sym_COLON_DASH] = ACTIONS(4887),
    [anon_sym_PERCENT] = ACTIONS(4887),
    [anon_sym_DASH] = ACTIONS(4887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4887),
  },
  [2403] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_RBRACE] = ACTIONS(4889),
    [anon_sym_EQ] = ACTIONS(4891),
    [sym__special_characters] = ACTIONS(4891),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_POUND] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_COLON] = ACTIONS(4891),
    [anon_sym_COLON_QMARK] = ACTIONS(4891),
    [anon_sym_COLON_DASH] = ACTIONS(4891),
    [anon_sym_PERCENT] = ACTIONS(4891),
    [anon_sym_DASH] = ACTIONS(4891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4891),
  },
  [2404] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_RBRACE] = ACTIONS(4893),
    [anon_sym_EQ] = ACTIONS(4895),
    [sym__special_characters] = ACTIONS(4895),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_POUND] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_COLON] = ACTIONS(4895),
    [anon_sym_COLON_QMARK] = ACTIONS(4895),
    [anon_sym_COLON_DASH] = ACTIONS(4895),
    [anon_sym_PERCENT] = ACTIONS(4895),
    [anon_sym_DASH] = ACTIONS(4895),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4895),
  },
  [2405] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5984),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2406] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_RBRACE] = ACTIONS(4899),
    [anon_sym_EQ] = ACTIONS(4901),
    [sym__special_characters] = ACTIONS(4901),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_POUND] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_COLON] = ACTIONS(4901),
    [anon_sym_COLON_QMARK] = ACTIONS(4901),
    [anon_sym_COLON_DASH] = ACTIONS(4901),
    [anon_sym_PERCENT] = ACTIONS(4901),
    [anon_sym_DASH] = ACTIONS(4901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4901),
  },
  [2407] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5986),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2408] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_RBRACE] = ACTIONS(4905),
    [anon_sym_EQ] = ACTIONS(4907),
    [sym__special_characters] = ACTIONS(4907),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_POUND] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_COLON] = ACTIONS(4907),
    [anon_sym_COLON_QMARK] = ACTIONS(4907),
    [anon_sym_COLON_DASH] = ACTIONS(4907),
    [anon_sym_PERCENT] = ACTIONS(4907),
    [anon_sym_DASH] = ACTIONS(4907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4907),
  },
  [2409] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5988),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2410] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_RBRACE] = ACTIONS(4947),
    [anon_sym_EQ] = ACTIONS(4949),
    [sym__special_characters] = ACTIONS(4949),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_POUND] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_COLON] = ACTIONS(4949),
    [anon_sym_COLON_QMARK] = ACTIONS(4949),
    [anon_sym_COLON_DASH] = ACTIONS(4949),
    [anon_sym_PERCENT] = ACTIONS(4949),
    [anon_sym_DASH] = ACTIONS(4949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4949),
  },
  [2411] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_RBRACE] = ACTIONS(4955),
    [anon_sym_EQ] = ACTIONS(4957),
    [sym__special_characters] = ACTIONS(4957),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_POUND] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_COLON] = ACTIONS(4957),
    [anon_sym_COLON_QMARK] = ACTIONS(4957),
    [anon_sym_COLON_DASH] = ACTIONS(4957),
    [anon_sym_PERCENT] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4957),
  },
  [2412] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_RBRACE] = ACTIONS(4959),
    [anon_sym_EQ] = ACTIONS(4961),
    [sym__special_characters] = ACTIONS(4961),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_POUND] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_COLON] = ACTIONS(4961),
    [anon_sym_COLON_QMARK] = ACTIONS(4961),
    [anon_sym_COLON_DASH] = ACTIONS(4961),
    [anon_sym_PERCENT] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(4961),
  },
  [2413] = {
    [aux_sym_concatenation_repeat1] = STATE(2413),
    [sym__concat] = ACTIONS(2679),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2414] = {
    [aux_sym_concatenation_repeat1] = STATE(2414),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(5389),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2415] = {
    [sym__heredoc_body_middle] = ACTIONS(4885),
    [sym__heredoc_body_end] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
  },
  [2416] = {
    [sym__heredoc_body_middle] = ACTIONS(4889),
    [sym__heredoc_body_end] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
  },
  [2417] = {
    [sym__heredoc_body_middle] = ACTIONS(4893),
    [sym__heredoc_body_end] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
  },
  [2418] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5990),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2419] = {
    [sym__heredoc_body_middle] = ACTIONS(4899),
    [sym__heredoc_body_end] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
  },
  [2420] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2421] = {
    [sym__heredoc_body_middle] = ACTIONS(4905),
    [sym__heredoc_body_end] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
  },
  [2422] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5994),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2423] = {
    [sym__heredoc_body_middle] = ACTIONS(4947),
    [sym__heredoc_body_end] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
  },
  [2424] = {
    [sym__heredoc_body_middle] = ACTIONS(4955),
    [sym__heredoc_body_end] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
  },
  [2425] = {
    [sym__heredoc_body_middle] = ACTIONS(4959),
    [sym__heredoc_body_end] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
  },
  [2426] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [sym__special_characters] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4885),
  },
  [2427] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [sym__special_characters] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4889),
  },
  [2428] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [sym__special_characters] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4893),
  },
  [2429] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5996),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2430] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_RPAREN] = ACTIONS(4899),
    [sym__special_characters] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4899),
  },
  [2431] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(5998),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2432] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [sym__special_characters] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4905),
  },
  [2433] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6000),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2434] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [sym__special_characters] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4947),
  },
  [2435] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [sym__special_characters] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4955),
  },
  [2436] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_RPAREN] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4959),
  },
  [2437] = {
    [sym_file_descriptor] = ACTIONS(5524),
    [sym__concat] = ACTIONS(5524),
    [sym_variable_name] = ACTIONS(5524),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5524),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [anon_sym_PIPE_AMP] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_LT] = ACTIONS(5526),
    [anon_sym_GT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_AMP_GT] = ACTIONS(5526),
    [anon_sym_AMP_GT_GT] = ACTIONS(5524),
    [anon_sym_LT_AMP] = ACTIONS(5524),
    [anon_sym_GT_AMP] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5526),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5526),
  },
  [2438] = {
    [sym_file_descriptor] = ACTIONS(5528),
    [sym__concat] = ACTIONS(5528),
    [sym_variable_name] = ACTIONS(5528),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_RPAREN] = ACTIONS(5528),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [anon_sym_PIPE_AMP] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_LT] = ACTIONS(5530),
    [anon_sym_GT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_AMP_GT] = ACTIONS(5530),
    [anon_sym_AMP_GT_GT] = ACTIONS(5528),
    [anon_sym_LT_AMP] = ACTIONS(5528),
    [anon_sym_GT_AMP] = ACTIONS(5528),
    [sym__special_characters] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5530),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5530),
  },
  [2439] = {
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [sym_variable_name] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5532),
    [anon_sym_LT_AMP] = ACTIONS(5532),
    [anon_sym_GT_AMP] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2440] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_EQ_TILDE] = ACTIONS(3903),
    [anon_sym_EQ_EQ] = ACTIONS(3903),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3903),
    [anon_sym_GT] = ACTIONS(3903),
    [anon_sym_BANG_EQ] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3903),
  },
  [2441] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_EQ_TILDE] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_EQ] = ACTIONS(3913),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3911),
  },
  [2442] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6002),
    [sym_comment] = ACTIONS(53),
  },
  [2443] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6004),
    [sym_comment] = ACTIONS(53),
  },
  [2444] = {
    [anon_sym_RBRACE] = ACTIONS(6004),
    [sym_comment] = ACTIONS(53),
  },
  [2445] = {
    [sym_concatenation] = STATE(2646),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2646),
    [anon_sym_RBRACE] = ACTIONS(6006),
    [anon_sym_EQ] = ACTIONS(6008),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6008),
    [anon_sym_COLON_QMARK] = ACTIONS(6008),
    [anon_sym_COLON_DASH] = ACTIONS(6008),
    [anon_sym_PERCENT] = ACTIONS(6008),
    [anon_sym_DASH] = ACTIONS(6008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2446] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_EQ_TILDE] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_EQ] = ACTIONS(3977),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3975),
  },
  [2447] = {
    [sym_concatenation] = STATE(2648),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2648),
    [anon_sym_RBRACE] = ACTIONS(6012),
    [anon_sym_EQ] = ACTIONS(6014),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6014),
    [anon_sym_COLON_QMARK] = ACTIONS(6014),
    [anon_sym_COLON_DASH] = ACTIONS(6014),
    [anon_sym_PERCENT] = ACTIONS(6014),
    [anon_sym_DASH] = ACTIONS(6014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2448] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3985),
    [anon_sym_GT] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3985),
  },
  [2449] = {
    [sym_concatenation] = STATE(2650),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2650),
    [anon_sym_RBRACE] = ACTIONS(6018),
    [anon_sym_EQ] = ACTIONS(6020),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6022),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6020),
    [anon_sym_COLON_QMARK] = ACTIONS(6020),
    [anon_sym_COLON_DASH] = ACTIONS(6020),
    [anon_sym_PERCENT] = ACTIONS(6020),
    [anon_sym_DASH] = ACTIONS(6020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2450] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_EQ_TILDE] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_EQ] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4040),
  },
  [2451] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6024),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2452] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_EQ_TILDE] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_GT] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4062),
  },
  [2453] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6026),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2454] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4068),
    [anon_sym_GT] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4068),
  },
  [2455] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6028),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2456] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_EQ_TILDE] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4074),
  },
  [2457] = {
    [sym__concat] = ACTIONS(4098),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_EQ_TILDE] = ACTIONS(4098),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_EQ] = ACTIONS(4100),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_GT] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4098),
  },
  [2458] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_esac] = ACTIONS(5524),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [anon_sym_PIPE_AMP] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_EQ_TILDE] = ACTIONS(5524),
    [anon_sym_EQ_EQ] = ACTIONS(5524),
    [anon_sym_EQ] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_BANG_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5524),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5526),
  },
  [2459] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_esac] = ACTIONS(5528),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [anon_sym_PIPE_AMP] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_EQ_TILDE] = ACTIONS(5528),
    [anon_sym_EQ_EQ] = ACTIONS(5528),
    [anon_sym_EQ] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_BANG_EQ] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5528),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5530),
  },
  [2460] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_EQ_TILDE] = ACTIONS(5532),
    [anon_sym_EQ_EQ] = ACTIONS(5532),
    [anon_sym_EQ] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5532),
    [anon_sym_GT] = ACTIONS(5532),
    [anon_sym_BANG_EQ] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5532),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2461] = {
    [anon_sym_esac] = ACTIONS(6030),
    [anon_sym_PIPE] = ACTIONS(6032),
    [anon_sym_RPAREN] = ACTIONS(6030),
    [anon_sym_SEMI_SEMI] = ACTIONS(6030),
    [anon_sym_PIPE_AMP] = ACTIONS(6030),
    [anon_sym_AMP_AMP] = ACTIONS(6030),
    [anon_sym_PIPE_PIPE] = ACTIONS(6030),
    [anon_sym_BQUOTE] = ACTIONS(6030),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6032),
    [anon_sym_LF] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(6032),
  },
  [2462] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [sym__special_characters] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4887),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4885),
  },
  [2463] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [sym__special_characters] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4891),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4889),
  },
  [2464] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [sym__special_characters] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4895),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4893),
  },
  [2465] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6034),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2466] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [sym__special_characters] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4899),
  },
  [2467] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6036),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2468] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [sym__special_characters] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4907),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4905),
  },
  [2469] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6038),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2470] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [sym__special_characters] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4949),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4947),
  },
  [2471] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [sym__special_characters] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4957),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
  },
  [2472] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4959),
  },
  [2473] = {
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_esac] = ACTIONS(1001),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_SEMI_SEMI] = ACTIONS(999),
    [anon_sym_PIPE_AMP] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1001),
    [anon_sym_GT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_AMP_GT] = ACTIONS(1001),
    [anon_sym_AMP_GT_GT] = ACTIONS(999),
    [anon_sym_LT_AMP] = ACTIONS(999),
    [anon_sym_GT_AMP] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LF] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(1001),
  },
  [2474] = {
    [sym_concatenation] = STATE(2658),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_string_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [aux_sym_for_statement_repeat1] = STATE(2658),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [sym__special_characters] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [sym_raw_string] = ACTIONS(1011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1019),
    [anon_sym_GT_LPAREN] = ACTIONS(1019),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1011),
  },
  [2475] = {
    [aux_sym_concatenation_repeat1] = STATE(2660),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(6042),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_esac] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1025),
    [anon_sym_SEMI_SEMI] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(1025),
    [anon_sym_GT] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1025),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1025),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1025),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_LF] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1025),
  },
  [2476] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(2663),
    [anon_sym_DQUOTE] = ACTIONS(6044),
    [anon_sym_DOLLAR] = ACTIONS(6046),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [2477] = {
    [sym_string] = STATE(2665),
    [anon_sym_DQUOTE] = ACTIONS(5710),
    [anon_sym_DOLLAR] = ACTIONS(6048),
    [sym_raw_string] = ACTIONS(6050),
    [anon_sym_POUND] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6052),
    [anon_sym_STAR] = ACTIONS(6048),
    [anon_sym_AT] = ACTIONS(6048),
    [anon_sym_QMARK] = ACTIONS(6048),
    [anon_sym_0] = ACTIONS(6054),
    [anon_sym__] = ACTIONS(6054),
  },
  [2478] = {
    [aux_sym_concatenation_repeat1] = STATE(2660),
    [sym_file_descriptor] = ACTIONS(999),
    [sym__concat] = ACTIONS(6042),
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_esac] = ACTIONS(1001),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_SEMI_SEMI] = ACTIONS(999),
    [anon_sym_PIPE_AMP] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1001),
    [anon_sym_GT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_AMP_GT] = ACTIONS(1001),
    [anon_sym_AMP_GT_GT] = ACTIONS(999),
    [anon_sym_LT_AMP] = ACTIONS(999),
    [anon_sym_GT_AMP] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LF] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(1001),
  },
  [2479] = {
    [sym_subscript] = STATE(2671),
    [sym_variable_name] = ACTIONS(6056),
    [anon_sym_BANG] = ACTIONS(6058),
    [anon_sym_DOLLAR] = ACTIONS(6060),
    [anon_sym_POUND] = ACTIONS(6058),
    [anon_sym_DASH] = ACTIONS(6060),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6062),
    [anon_sym_STAR] = ACTIONS(6060),
    [anon_sym_AT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_0] = ACTIONS(6064),
    [anon_sym__] = ACTIONS(6064),
  },
  [2480] = {
    [sym__terminated_statement] = STATE(2674),
    [sym_for_statement] = STATE(2672),
    [sym_c_style_for_statement] = STATE(2672),
    [sym_while_statement] = STATE(2672),
    [sym_if_statement] = STATE(2672),
    [sym_case_statement] = STATE(2672),
    [sym_function_definition] = STATE(2672),
    [sym_subshell] = STATE(2672),
    [sym_pipeline] = STATE(2672),
    [sym_list] = STATE(2672),
    [sym_negated_command] = STATE(2672),
    [sym_test_command] = STATE(2672),
    [sym_declaration_command] = STATE(2672),
    [sym_unset_command] = STATE(2672),
    [sym_command] = STATE(2672),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2673),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(2674),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2481] = {
    [sym__terminated_statement] = STATE(2677),
    [sym_for_statement] = STATE(2675),
    [sym_c_style_for_statement] = STATE(2675),
    [sym_while_statement] = STATE(2675),
    [sym_if_statement] = STATE(2675),
    [sym_case_statement] = STATE(2675),
    [sym_function_definition] = STATE(2675),
    [sym_subshell] = STATE(2675),
    [sym_pipeline] = STATE(2675),
    [sym_list] = STATE(2675),
    [sym_negated_command] = STATE(2675),
    [sym_test_command] = STATE(2675),
    [sym_declaration_command] = STATE(2675),
    [sym_unset_command] = STATE(2675),
    [sym_command] = STATE(2675),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(2676),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2677),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [2482] = {
    [sym__terminated_statement] = STATE(2680),
    [sym_for_statement] = STATE(2678),
    [sym_c_style_for_statement] = STATE(2678),
    [sym_while_statement] = STATE(2678),
    [sym_if_statement] = STATE(2678),
    [sym_case_statement] = STATE(2678),
    [sym_function_definition] = STATE(2678),
    [sym_subshell] = STATE(2678),
    [sym_pipeline] = STATE(2678),
    [sym_list] = STATE(2678),
    [sym_negated_command] = STATE(2678),
    [sym_test_command] = STATE(2678),
    [sym_declaration_command] = STATE(2678),
    [sym_unset_command] = STATE(2678),
    [sym_command] = STATE(2678),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2679),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(2680),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2483] = {
    [sym_file_redirect] = STATE(2681),
    [sym_heredoc_redirect] = STATE(2681),
    [sym_heredoc_body] = STATE(575),
    [sym_herestring_redirect] = STATE(2681),
    [aux_sym_while_statement_repeat1] = STATE(2681),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(5326),
    [anon_sym_esac] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(5330),
    [anon_sym_GT] = ACTIONS(5330),
    [anon_sym_GT_GT] = ACTIONS(5332),
    [anon_sym_AMP_GT] = ACTIONS(5330),
    [anon_sym_AMP_GT_GT] = ACTIONS(5332),
    [anon_sym_LT_AMP] = ACTIONS(5332),
    [anon_sym_GT_AMP] = ACTIONS(5332),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(5334),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [2484] = {
    [anon_sym_RPAREN] = ACTIONS(6066),
    [sym_comment] = ACTIONS(53),
  },
  [2485] = {
    [sym_file_redirect] = STATE(624),
    [sym_file_descriptor] = ACTIONS(6068),
    [anon_sym_esac] = ACTIONS(1193),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_SEMI_SEMI] = ACTIONS(1193),
    [anon_sym_PIPE_AMP] = ACTIONS(1193),
    [anon_sym_AMP_AMP] = ACTIONS(1193),
    [anon_sym_PIPE_PIPE] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(6070),
    [anon_sym_GT] = ACTIONS(6070),
    [anon_sym_GT_GT] = ACTIONS(6072),
    [anon_sym_AMP_GT] = ACTIONS(6070),
    [anon_sym_AMP_GT_GT] = ACTIONS(6072),
    [anon_sym_LT_AMP] = ACTIONS(6072),
    [anon_sym_GT_AMP] = ACTIONS(6072),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym_LF] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1191),
  },
  [2486] = {
    [sym_file_redirect] = STATE(2688),
    [sym_heredoc_redirect] = STATE(2688),
    [sym_herestring_redirect] = STATE(2688),
    [aux_sym_while_statement_repeat1] = STATE(2688),
    [sym_file_descriptor] = ACTIONS(6074),
    [anon_sym_esac] = ACTIONS(1315),
    [anon_sym_PIPE] = ACTIONS(1313),
    [anon_sym_SEMI_SEMI] = ACTIONS(1315),
    [anon_sym_PIPE_AMP] = ACTIONS(1315),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(6076),
    [anon_sym_GT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_AMP_GT] = ACTIONS(6076),
    [anon_sym_AMP_GT_GT] = ACTIONS(6078),
    [anon_sym_LT_AMP] = ACTIONS(6078),
    [anon_sym_GT_AMP] = ACTIONS(6078),
    [anon_sym_LT_LT] = ACTIONS(1321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1323),
    [anon_sym_LT_LT_LT] = ACTIONS(6080),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1313),
    [anon_sym_LF] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1313),
  },
  [2487] = {
    [sym_concatenation] = STATE(2689),
    [sym_string] = STATE(2692),
    [sym_array] = STATE(2689),
    [sym_simple_expansion] = STATE(2692),
    [sym_string_expansion] = STATE(2692),
    [sym_expansion] = STATE(2692),
    [sym_command_substitution] = STATE(2692),
    [sym_process_substitution] = STATE(2692),
    [sym__empty_value] = ACTIONS(6082),
    [anon_sym_LPAREN] = ACTIONS(6084),
    [sym__special_characters] = ACTIONS(6086),
    [anon_sym_DQUOTE] = ACTIONS(5248),
    [anon_sym_DOLLAR] = ACTIONS(5250),
    [sym_raw_string] = ACTIONS(6088),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5256),
    [anon_sym_BQUOTE] = ACTIONS(5258),
    [anon_sym_LT_LPAREN] = ACTIONS(5260),
    [anon_sym_GT_LPAREN] = ACTIONS(5260),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6088),
  },
  [2488] = {
    [sym_string] = STATE(2693),
    [sym_simple_expansion] = STATE(2693),
    [sym_string_expansion] = STATE(2693),
    [sym_expansion] = STATE(2693),
    [sym_command_substitution] = STATE(2693),
    [sym_process_substitution] = STATE(2693),
    [sym__special_characters] = ACTIONS(6090),
    [anon_sym_DQUOTE] = ACTIONS(5248),
    [anon_sym_DOLLAR] = ACTIONS(5250),
    [sym_raw_string] = ACTIONS(6090),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5256),
    [anon_sym_BQUOTE] = ACTIONS(5258),
    [anon_sym_LT_LPAREN] = ACTIONS(5260),
    [anon_sym_GT_LPAREN] = ACTIONS(5260),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6090),
  },
  [2489] = {
    [aux_sym_concatenation_repeat1] = STATE(2694),
    [sym__concat] = ACTIONS(5730),
    [sym_variable_name] = ACTIONS(695),
    [anon_sym_esac] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [2490] = {
    [sym__concat] = ACTIONS(699),
    [sym_variable_name] = ACTIONS(699),
    [anon_sym_esac] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(701),
    [sym_word] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
  },
  [2491] = {
    [anon_sym_DQUOTE] = ACTIONS(6092),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [2492] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(6092),
    [anon_sym_DOLLAR] = ACTIONS(6094),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [2493] = {
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2494] = {
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2495] = {
    [sym__concat] = ACTIONS(739),
    [sym_variable_name] = ACTIONS(739),
    [anon_sym_esac] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(741),
    [sym_word] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [2496] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(6096),
    [sym_comment] = ACTIONS(53),
  },
  [2497] = {
    [sym_subscript] = STATE(2701),
    [sym_variable_name] = ACTIONS(6098),
    [anon_sym_DOLLAR] = ACTIONS(6100),
    [anon_sym_DASH] = ACTIONS(6100),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6102),
    [anon_sym_STAR] = ACTIONS(6100),
    [anon_sym_AT] = ACTIONS(6100),
    [anon_sym_QMARK] = ACTIONS(6100),
    [anon_sym_0] = ACTIONS(6104),
    [anon_sym__] = ACTIONS(6104),
  },
  [2498] = {
    [sym_concatenation] = STATE(2704),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2704),
    [anon_sym_RBRACE] = ACTIONS(6106),
    [anon_sym_EQ] = ACTIONS(6108),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_COLON] = ACTIONS(6108),
    [anon_sym_COLON_QMARK] = ACTIONS(6108),
    [anon_sym_COLON_DASH] = ACTIONS(6108),
    [anon_sym_PERCENT] = ACTIONS(6108),
    [anon_sym_DASH] = ACTIONS(6108),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2499] = {
    [sym_concatenation] = STATE(2707),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2707),
    [anon_sym_RBRACE] = ACTIONS(6114),
    [anon_sym_EQ] = ACTIONS(6116),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6120),
    [anon_sym_COLON] = ACTIONS(6116),
    [anon_sym_COLON_QMARK] = ACTIONS(6116),
    [anon_sym_COLON_DASH] = ACTIONS(6116),
    [anon_sym_PERCENT] = ACTIONS(6116),
    [anon_sym_DASH] = ACTIONS(6116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2500] = {
    [sym_concatenation] = STATE(2710),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2710),
    [anon_sym_RBRACE] = ACTIONS(6122),
    [anon_sym_EQ] = ACTIONS(6124),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6126),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6128),
    [anon_sym_COLON] = ACTIONS(6124),
    [anon_sym_COLON_QMARK] = ACTIONS(6124),
    [anon_sym_COLON_DASH] = ACTIONS(6124),
    [anon_sym_PERCENT] = ACTIONS(6124),
    [anon_sym_DASH] = ACTIONS(6124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2501] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6130),
    [anon_sym_SEMI_SEMI] = ACTIONS(6132),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6134),
    [anon_sym_LF] = ACTIONS(6132),
    [anon_sym_AMP] = ACTIONS(6134),
  },
  [2502] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6130),
    [anon_sym_SEMI_SEMI] = ACTIONS(6132),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6134),
    [anon_sym_LF] = ACTIONS(6132),
    [anon_sym_AMP] = ACTIONS(6134),
  },
  [2503] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2713),
    [sym_c_style_for_statement] = STATE(2713),
    [sym_while_statement] = STATE(2713),
    [sym_if_statement] = STATE(2713),
    [sym_case_statement] = STATE(2713),
    [sym_function_definition] = STATE(2713),
    [sym_subshell] = STATE(2713),
    [sym_pipeline] = STATE(2713),
    [sym_list] = STATE(2713),
    [sym_negated_command] = STATE(2713),
    [sym_test_command] = STATE(2713),
    [sym_declaration_command] = STATE(2713),
    [sym_unset_command] = STATE(2713),
    [sym_command] = STATE(2713),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2714),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2504] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6136),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(6130),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6138),
    [anon_sym_LF] = ACTIONS(6136),
    [anon_sym_AMP] = ACTIONS(6138),
  },
  [2505] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6136),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(6130),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6138),
    [anon_sym_LF] = ACTIONS(6136),
    [anon_sym_AMP] = ACTIONS(6138),
  },
  [2506] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2716),
    [sym_c_style_for_statement] = STATE(2716),
    [sym_while_statement] = STATE(2716),
    [sym_if_statement] = STATE(2716),
    [sym_case_statement] = STATE(2716),
    [sym_function_definition] = STATE(2716),
    [sym_subshell] = STATE(2716),
    [sym_pipeline] = STATE(2716),
    [sym_list] = STATE(2716),
    [sym_negated_command] = STATE(2716),
    [sym_test_command] = STATE(2716),
    [sym_declaration_command] = STATE(2716),
    [sym_unset_command] = STATE(2716),
    [sym_command] = STATE(2716),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(2717),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [2507] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6140),
    [anon_sym_SEMI_SEMI] = ACTIONS(6142),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6144),
    [anon_sym_LF] = ACTIONS(6142),
    [anon_sym_AMP] = ACTIONS(6144),
  },
  [2508] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6140),
    [anon_sym_SEMI_SEMI] = ACTIONS(6142),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6144),
    [anon_sym_LF] = ACTIONS(6142),
    [anon_sym_AMP] = ACTIONS(6144),
  },
  [2509] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2720),
    [sym_c_style_for_statement] = STATE(2720),
    [sym_while_statement] = STATE(2720),
    [sym_if_statement] = STATE(2720),
    [sym_case_statement] = STATE(2720),
    [sym_function_definition] = STATE(2720),
    [sym_subshell] = STATE(2720),
    [sym_pipeline] = STATE(2720),
    [sym_list] = STATE(2720),
    [sym_negated_command] = STATE(2720),
    [sym_test_command] = STATE(2720),
    [sym_declaration_command] = STATE(2720),
    [sym_unset_command] = STATE(2720),
    [sym_command] = STATE(2720),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2721),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2510] = {
    [sym_variable_assignment] = STATE(2510),
    [sym_subscript] = STATE(2273),
    [sym_concatenation] = STATE(2510),
    [sym_string] = STATE(2267),
    [sym_simple_expansion] = STATE(2267),
    [sym_string_expansion] = STATE(2267),
    [sym_expansion] = STATE(2267),
    [sym_command_substitution] = STATE(2267),
    [sym_process_substitution] = STATE(2267),
    [aux_sym_declaration_command_repeat1] = STATE(2510),
    [sym_variable_name] = ACTIONS(6146),
    [anon_sym_esac] = ACTIONS(1484),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_SEMI_SEMI] = ACTIONS(1486),
    [anon_sym_PIPE_AMP] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [sym__special_characters] = ACTIONS(6149),
    [anon_sym_DQUOTE] = ACTIONS(6152),
    [anon_sym_DOLLAR] = ACTIONS(6155),
    [sym_raw_string] = ACTIONS(6158),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6164),
    [anon_sym_BQUOTE] = ACTIONS(6167),
    [anon_sym_LT_LPAREN] = ACTIONS(6170),
    [anon_sym_GT_LPAREN] = ACTIONS(6170),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6173),
    [sym_word] = ACTIONS(6176),
    [anon_sym_SEMI] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1484),
  },
  [2511] = {
    [sym_string] = STATE(2722),
    [sym_simple_expansion] = STATE(2722),
    [sym_string_expansion] = STATE(2722),
    [sym_expansion] = STATE(2722),
    [sym_command_substitution] = STATE(2722),
    [sym_process_substitution] = STATE(2722),
    [sym__special_characters] = ACTIONS(6179),
    [anon_sym_DQUOTE] = ACTIONS(5268),
    [anon_sym_DOLLAR] = ACTIONS(5270),
    [sym_raw_string] = ACTIONS(6179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5274),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5276),
    [anon_sym_BQUOTE] = ACTIONS(5278),
    [anon_sym_LT_LPAREN] = ACTIONS(5280),
    [anon_sym_GT_LPAREN] = ACTIONS(5280),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6179),
  },
  [2512] = {
    [aux_sym_concatenation_repeat1] = STATE(2723),
    [sym__concat] = ACTIONS(5754),
    [anon_sym_esac] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [2513] = {
    [sym__concat] = ACTIONS(699),
    [anon_sym_esac] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(701),
    [sym_word] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
  },
  [2514] = {
    [anon_sym_DQUOTE] = ACTIONS(6181),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [2515] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(6181),
    [anon_sym_DOLLAR] = ACTIONS(6183),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [2516] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2517] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2518] = {
    [sym__concat] = ACTIONS(739),
    [anon_sym_esac] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(741),
    [sym_word] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [2519] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(6185),
    [sym_comment] = ACTIONS(53),
  },
  [2520] = {
    [sym_subscript] = STATE(2730),
    [sym_variable_name] = ACTIONS(6187),
    [anon_sym_DOLLAR] = ACTIONS(6189),
    [anon_sym_DASH] = ACTIONS(6189),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6191),
    [anon_sym_STAR] = ACTIONS(6189),
    [anon_sym_AT] = ACTIONS(6189),
    [anon_sym_QMARK] = ACTIONS(6189),
    [anon_sym_0] = ACTIONS(6193),
    [anon_sym__] = ACTIONS(6193),
  },
  [2521] = {
    [sym_concatenation] = STATE(2733),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2733),
    [anon_sym_RBRACE] = ACTIONS(6195),
    [anon_sym_EQ] = ACTIONS(6197),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6201),
    [anon_sym_COLON] = ACTIONS(6197),
    [anon_sym_COLON_QMARK] = ACTIONS(6197),
    [anon_sym_COLON_DASH] = ACTIONS(6197),
    [anon_sym_PERCENT] = ACTIONS(6197),
    [anon_sym_DASH] = ACTIONS(6197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2522] = {
    [sym_concatenation] = STATE(2736),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2736),
    [anon_sym_RBRACE] = ACTIONS(6203),
    [anon_sym_EQ] = ACTIONS(6205),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_COLON] = ACTIONS(6205),
    [anon_sym_COLON_QMARK] = ACTIONS(6205),
    [anon_sym_COLON_DASH] = ACTIONS(6205),
    [anon_sym_PERCENT] = ACTIONS(6205),
    [anon_sym_DASH] = ACTIONS(6205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2523] = {
    [sym_concatenation] = STATE(2739),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2739),
    [anon_sym_RBRACE] = ACTIONS(6211),
    [anon_sym_EQ] = ACTIONS(6213),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_COLON] = ACTIONS(6213),
    [anon_sym_COLON_QMARK] = ACTIONS(6213),
    [anon_sym_COLON_DASH] = ACTIONS(6213),
    [anon_sym_PERCENT] = ACTIONS(6213),
    [anon_sym_DASH] = ACTIONS(6213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2524] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6219),
    [anon_sym_SEMI_SEMI] = ACTIONS(6221),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6223),
    [anon_sym_LF] = ACTIONS(6221),
    [anon_sym_AMP] = ACTIONS(6223),
  },
  [2525] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6219),
    [anon_sym_SEMI_SEMI] = ACTIONS(6221),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6223),
    [anon_sym_LF] = ACTIONS(6221),
    [anon_sym_AMP] = ACTIONS(6223),
  },
  [2526] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2742),
    [sym_c_style_for_statement] = STATE(2742),
    [sym_while_statement] = STATE(2742),
    [sym_if_statement] = STATE(2742),
    [sym_case_statement] = STATE(2742),
    [sym_function_definition] = STATE(2742),
    [sym_subshell] = STATE(2742),
    [sym_pipeline] = STATE(2742),
    [sym_list] = STATE(2742),
    [sym_negated_command] = STATE(2742),
    [sym_test_command] = STATE(2742),
    [sym_declaration_command] = STATE(2742),
    [sym_unset_command] = STATE(2742),
    [sym_command] = STATE(2742),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2743),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2527] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6225),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(6219),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6227),
    [anon_sym_LF] = ACTIONS(6225),
    [anon_sym_AMP] = ACTIONS(6227),
  },
  [2528] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6225),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(6219),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6227),
    [anon_sym_LF] = ACTIONS(6225),
    [anon_sym_AMP] = ACTIONS(6227),
  },
  [2529] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2745),
    [sym_c_style_for_statement] = STATE(2745),
    [sym_while_statement] = STATE(2745),
    [sym_if_statement] = STATE(2745),
    [sym_case_statement] = STATE(2745),
    [sym_function_definition] = STATE(2745),
    [sym_subshell] = STATE(2745),
    [sym_pipeline] = STATE(2745),
    [sym_list] = STATE(2745),
    [sym_negated_command] = STATE(2745),
    [sym_test_command] = STATE(2745),
    [sym_declaration_command] = STATE(2745),
    [sym_unset_command] = STATE(2745),
    [sym_command] = STATE(2745),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(2746),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [2530] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6229),
    [anon_sym_SEMI_SEMI] = ACTIONS(6231),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6233),
    [anon_sym_LF] = ACTIONS(6231),
    [anon_sym_AMP] = ACTIONS(6233),
  },
  [2531] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6229),
    [anon_sym_SEMI_SEMI] = ACTIONS(6231),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6233),
    [anon_sym_LF] = ACTIONS(6231),
    [anon_sym_AMP] = ACTIONS(6233),
  },
  [2532] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2749),
    [sym_c_style_for_statement] = STATE(2749),
    [sym_while_statement] = STATE(2749),
    [sym_if_statement] = STATE(2749),
    [sym_case_statement] = STATE(2749),
    [sym_function_definition] = STATE(2749),
    [sym_subshell] = STATE(2749),
    [sym_pipeline] = STATE(2749),
    [sym_list] = STATE(2749),
    [sym_negated_command] = STATE(2749),
    [sym_test_command] = STATE(2749),
    [sym_declaration_command] = STATE(2749),
    [sym_unset_command] = STATE(2749),
    [sym_command] = STATE(2749),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2750),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2533] = {
    [sym_concatenation] = STATE(2533),
    [sym_string] = STATE(2278),
    [sym_simple_expansion] = STATE(2278),
    [sym_string_expansion] = STATE(2278),
    [sym_expansion] = STATE(2278),
    [sym_command_substitution] = STATE(2278),
    [sym_process_substitution] = STATE(2278),
    [aux_sym_unset_command_repeat1] = STATE(2533),
    [anon_sym_esac] = ACTIONS(1574),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_SEMI_SEMI] = ACTIONS(1576),
    [anon_sym_PIPE_AMP] = ACTIONS(1576),
    [anon_sym_AMP_AMP] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1576),
    [sym__special_characters] = ACTIONS(6235),
    [anon_sym_DQUOTE] = ACTIONS(6238),
    [anon_sym_DOLLAR] = ACTIONS(6241),
    [sym_raw_string] = ACTIONS(6244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6250),
    [anon_sym_BQUOTE] = ACTIONS(6253),
    [anon_sym_LT_LPAREN] = ACTIONS(6256),
    [anon_sym_GT_LPAREN] = ACTIONS(6256),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6259),
    [sym_word] = ACTIONS(6262),
    [anon_sym_SEMI] = ACTIONS(1574),
    [anon_sym_LF] = ACTIONS(1576),
    [anon_sym_AMP] = ACTIONS(1574),
  },
  [2534] = {
    [sym__simple_heredoc_body] = ACTIONS(1664),
    [sym__heredoc_body_beginning] = ACTIONS(1664),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1664),
    [anon_sym_esac] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1666),
    [anon_sym_EQ_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2535] = {
    [aux_sym_concatenation_repeat1] = STATE(2535),
    [sym__simple_heredoc_body] = ACTIONS(1664),
    [sym__heredoc_body_beginning] = ACTIONS(1664),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(6265),
    [anon_sym_esac] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_EQ_TILDE] = ACTIONS(1666),
    [anon_sym_EQ_EQ] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2536] = {
    [sym__simple_heredoc_body] = ACTIONS(1671),
    [sym__heredoc_body_beginning] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1673),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_EQ_TILDE] = ACTIONS(1673),
    [anon_sym_EQ_EQ] = ACTIONS(1673),
    [anon_sym_LT] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1673),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1673),
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1673),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1673),
  },
  [2537] = {
    [anon_sym_DQUOTE] = ACTIONS(6268),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [2538] = {
    [sym_concatenation] = STATE(2755),
    [sym_string] = STATE(2754),
    [sym_simple_expansion] = STATE(2754),
    [sym_string_expansion] = STATE(2754),
    [sym_expansion] = STATE(2754),
    [sym_command_substitution] = STATE(2754),
    [sym_process_substitution] = STATE(2754),
    [anon_sym_RBRACE] = ACTIONS(6270),
    [sym__special_characters] = ACTIONS(6272),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(6274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6274),
  },
  [2539] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(6276),
    [sym_comment] = ACTIONS(53),
  },
  [2540] = {
    [sym_concatenation] = STATE(2759),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2759),
    [anon_sym_RBRACE] = ACTIONS(6278),
    [anon_sym_EQ] = ACTIONS(6280),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6284),
    [anon_sym_COLON] = ACTIONS(6280),
    [anon_sym_COLON_QMARK] = ACTIONS(6280),
    [anon_sym_COLON_DASH] = ACTIONS(6280),
    [anon_sym_PERCENT] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2541] = {
    [sym_concatenation] = STATE(2762),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2762),
    [anon_sym_RBRACE] = ACTIONS(6286),
    [anon_sym_EQ] = ACTIONS(6288),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6292),
    [anon_sym_COLON] = ACTIONS(6288),
    [anon_sym_COLON_QMARK] = ACTIONS(6288),
    [anon_sym_COLON_DASH] = ACTIONS(6288),
    [anon_sym_PERCENT] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2542] = {
    [sym_concatenation] = STATE(2764),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2764),
    [anon_sym_RBRACE] = ACTIONS(6270),
    [anon_sym_EQ] = ACTIONS(6294),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6296),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6294),
    [anon_sym_COLON_QMARK] = ACTIONS(6294),
    [anon_sym_COLON_DASH] = ACTIONS(6294),
    [anon_sym_PERCENT] = ACTIONS(6294),
    [anon_sym_DASH] = ACTIONS(6294),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2543] = {
    [sym__simple_heredoc_body] = ACTIONS(1788),
    [sym__heredoc_body_beginning] = ACTIONS(1788),
    [sym_file_descriptor] = ACTIONS(1788),
    [sym__concat] = ACTIONS(1788),
    [anon_sym_esac] = ACTIONS(1790),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [anon_sym_PIPE_AMP] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [anon_sym_EQ_TILDE] = ACTIONS(1790),
    [anon_sym_EQ_EQ] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(1790),
    [anon_sym_GT] = ACTIONS(1790),
    [anon_sym_GT_GT] = ACTIONS(1788),
    [anon_sym_AMP_GT] = ACTIONS(1790),
    [anon_sym_AMP_GT_GT] = ACTIONS(1788),
    [anon_sym_LT_AMP] = ACTIONS(1788),
    [anon_sym_GT_AMP] = ACTIONS(1788),
    [anon_sym_LT_LT] = ACTIONS(1790),
    [anon_sym_LT_LT_DASH] = ACTIONS(1788),
    [anon_sym_LT_LT_LT] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1790),
  },
  [2544] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6300),
  },
  [2545] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6302),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2546] = {
    [sym__simple_heredoc_body] = ACTIONS(1832),
    [sym__heredoc_body_beginning] = ACTIONS(1832),
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [anon_sym_esac] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1834),
    [anon_sym_EQ_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [anon_sym_LT_LT] = ACTIONS(1834),
    [anon_sym_LT_LT_DASH] = ACTIONS(1832),
    [anon_sym_LT_LT_LT] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [2547] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6304),
  },
  [2548] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6306),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2549] = {
    [sym__simple_heredoc_body] = ACTIONS(1840),
    [sym__heredoc_body_beginning] = ACTIONS(1840),
    [sym_file_descriptor] = ACTIONS(1840),
    [sym__concat] = ACTIONS(1840),
    [anon_sym_esac] = ACTIONS(1842),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [anon_sym_PIPE_AMP] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_EQ_TILDE] = ACTIONS(1842),
    [anon_sym_EQ_EQ] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_GT] = ACTIONS(1842),
    [anon_sym_GT_GT] = ACTIONS(1840),
    [anon_sym_AMP_GT] = ACTIONS(1842),
    [anon_sym_AMP_GT_GT] = ACTIONS(1840),
    [anon_sym_LT_AMP] = ACTIONS(1840),
    [anon_sym_GT_AMP] = ACTIONS(1840),
    [anon_sym_LT_LT] = ACTIONS(1842),
    [anon_sym_LT_LT_DASH] = ACTIONS(1840),
    [anon_sym_LT_LT_LT] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [2550] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6308),
  },
  [2551] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6270),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2552] = {
    [sym__simple_heredoc_body] = ACTIONS(1846),
    [sym__heredoc_body_beginning] = ACTIONS(1846),
    [sym_file_descriptor] = ACTIONS(1846),
    [sym__concat] = ACTIONS(1846),
    [anon_sym_esac] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_EQ_TILDE] = ACTIONS(1848),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT] = ACTIONS(1848),
    [anon_sym_AMP_GT_GT] = ACTIONS(1846),
    [anon_sym_LT_AMP] = ACTIONS(1846),
    [anon_sym_GT_AMP] = ACTIONS(1846),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_LT_LT_DASH] = ACTIONS(1846),
    [anon_sym_LT_LT_LT] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1848),
  },
  [2553] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6310),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2554] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6310),
    [anon_sym_SEMI_SEMI] = ACTIONS(6312),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6314),
    [anon_sym_LF] = ACTIONS(6312),
    [anon_sym_AMP] = ACTIONS(6314),
  },
  [2555] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6310),
    [anon_sym_SEMI_SEMI] = ACTIONS(6312),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6314),
    [anon_sym_LF] = ACTIONS(6312),
    [anon_sym_AMP] = ACTIONS(6314),
  },
  [2556] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(6310),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2557] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6316),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(6310),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6318),
    [anon_sym_LF] = ACTIONS(6316),
    [anon_sym_AMP] = ACTIONS(6318),
  },
  [2558] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6316),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(6310),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6318),
    [anon_sym_LF] = ACTIONS(6316),
    [anon_sym_AMP] = ACTIONS(6318),
  },
  [2559] = {
    [sym__simple_heredoc_body] = ACTIONS(1878),
    [sym__heredoc_body_beginning] = ACTIONS(1878),
    [sym_file_descriptor] = ACTIONS(1878),
    [sym__concat] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1880),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_EQ_TILDE] = ACTIONS(1880),
    [anon_sym_EQ_EQ] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1880),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT] = ACTIONS(1880),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [anon_sym_LT_LT] = ACTIONS(1880),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1880),
  },
  [2560] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2561] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_SEMI_SEMI] = ACTIONS(6322),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6324),
    [anon_sym_LF] = ACTIONS(6322),
    [anon_sym_AMP] = ACTIONS(6324),
  },
  [2562] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_SEMI_SEMI] = ACTIONS(6322),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6324),
    [anon_sym_LF] = ACTIONS(6322),
    [anon_sym_AMP] = ACTIONS(6324),
  },
  [2563] = {
    [sym_compound_statement] = STATE(2775),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [2564] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_esac] = ACTIONS(1890),
    [anon_sym_PIPE] = ACTIONS(1890),
    [anon_sym_SEMI_SEMI] = ACTIONS(1888),
    [anon_sym_PIPE_AMP] = ACTIONS(1888),
    [anon_sym_AMP_AMP] = ACTIONS(1888),
    [anon_sym_PIPE_PIPE] = ACTIONS(1888),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1890),
    [anon_sym_LF] = ACTIONS(1888),
    [anon_sym_AMP] = ACTIONS(1890),
  },
  [2565] = {
    [anon_sym_esac] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(1892),
    [anon_sym_PIPE_PIPE] = ACTIONS(1892),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_LF] = ACTIONS(1892),
    [anon_sym_AMP] = ACTIONS(1894),
  },
  [2566] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_esac] = ACTIONS(1894),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(1892),
    [anon_sym_PIPE_PIPE] = ACTIONS(1892),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_LF] = ACTIONS(1892),
    [anon_sym_AMP] = ACTIONS(1894),
  },
  [2567] = {
    [sym_concatenation] = STATE(928),
    [sym_string] = STATE(2777),
    [sym_simple_expansion] = STATE(2777),
    [sym_string_expansion] = STATE(2777),
    [sym_expansion] = STATE(2777),
    [sym_command_substitution] = STATE(2777),
    [sym_process_substitution] = STATE(2777),
    [sym__special_characters] = ACTIONS(6326),
    [anon_sym_DQUOTE] = ACTIONS(5864),
    [anon_sym_DOLLAR] = ACTIONS(5866),
    [sym_raw_string] = ACTIONS(6328),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5870),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5872),
    [anon_sym_BQUOTE] = ACTIONS(5874),
    [anon_sym_LT_LPAREN] = ACTIONS(5876),
    [anon_sym_GT_LPAREN] = ACTIONS(5876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6328),
  },
  [2568] = {
    [aux_sym_concatenation_repeat1] = STATE(2286),
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(5286),
    [anon_sym_esac] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_EQ_TILDE] = ACTIONS(1926),
    [anon_sym_EQ_EQ] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [2569] = {
    [aux_sym_concatenation_repeat1] = STATE(2286),
    [sym__simple_heredoc_body] = ACTIONS(1928),
    [sym__heredoc_body_beginning] = ACTIONS(1928),
    [sym_file_descriptor] = ACTIONS(1928),
    [sym__concat] = ACTIONS(5286),
    [anon_sym_esac] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(1930),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_EQ_TILDE] = ACTIONS(1930),
    [anon_sym_EQ_EQ] = ACTIONS(1930),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_GT] = ACTIONS(1930),
    [anon_sym_GT_GT] = ACTIONS(1928),
    [anon_sym_AMP_GT] = ACTIONS(1930),
    [anon_sym_AMP_GT_GT] = ACTIONS(1928),
    [anon_sym_LT_AMP] = ACTIONS(1928),
    [anon_sym_GT_AMP] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(1930),
    [anon_sym_LT_LT_DASH] = ACTIONS(1928),
    [anon_sym_LT_LT_LT] = ACTIONS(1928),
    [sym__special_characters] = ACTIONS(1928),
    [anon_sym_DQUOTE] = ACTIONS(1928),
    [anon_sym_DOLLAR] = ACTIONS(1930),
    [sym_raw_string] = ACTIONS(1928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1928),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [anon_sym_LT_LPAREN] = ACTIONS(1928),
    [anon_sym_GT_LPAREN] = ACTIONS(1928),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1930),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [2570] = {
    [sym__simple_heredoc_body] = ACTIONS(1928),
    [sym__heredoc_body_beginning] = ACTIONS(1928),
    [sym_file_descriptor] = ACTIONS(1928),
    [anon_sym_esac] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(1930),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_EQ_TILDE] = ACTIONS(1930),
    [anon_sym_EQ_EQ] = ACTIONS(1930),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_GT] = ACTIONS(1930),
    [anon_sym_GT_GT] = ACTIONS(1928),
    [anon_sym_AMP_GT] = ACTIONS(1930),
    [anon_sym_AMP_GT_GT] = ACTIONS(1928),
    [anon_sym_LT_AMP] = ACTIONS(1928),
    [anon_sym_GT_AMP] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(1930),
    [anon_sym_LT_LT_DASH] = ACTIONS(1928),
    [anon_sym_LT_LT_LT] = ACTIONS(1928),
    [sym__special_characters] = ACTIONS(1928),
    [anon_sym_DQUOTE] = ACTIONS(1928),
    [anon_sym_DOLLAR] = ACTIONS(1930),
    [sym_raw_string] = ACTIONS(1928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1928),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [anon_sym_LT_LPAREN] = ACTIONS(1928),
    [anon_sym_GT_LPAREN] = ACTIONS(1928),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1930),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [2571] = {
    [aux_sym_concatenation_repeat1] = STATE(2779),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(6330),
    [anon_sym_esac] = ACTIONS(661),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [2572] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(2782),
    [anon_sym_DQUOTE] = ACTIONS(6332),
    [anon_sym_DOLLAR] = ACTIONS(6334),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [2573] = {
    [sym_string] = STATE(2784),
    [anon_sym_DQUOTE] = ACTIONS(5864),
    [anon_sym_DOLLAR] = ACTIONS(6336),
    [sym_raw_string] = ACTIONS(6338),
    [anon_sym_POUND] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6340),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_AT] = ACTIONS(6336),
    [anon_sym_QMARK] = ACTIONS(6336),
    [anon_sym_0] = ACTIONS(6342),
    [anon_sym__] = ACTIONS(6342),
  },
  [2574] = {
    [aux_sym_concatenation_repeat1] = STATE(2779),
    [sym__simple_heredoc_body] = ACTIONS(679),
    [sym__heredoc_body_beginning] = ACTIONS(679),
    [sym_file_descriptor] = ACTIONS(679),
    [sym__concat] = ACTIONS(6330),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [2575] = {
    [sym_subscript] = STATE(2790),
    [sym_variable_name] = ACTIONS(6344),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_DOLLAR] = ACTIONS(6348),
    [anon_sym_POUND] = ACTIONS(6346),
    [anon_sym_DASH] = ACTIONS(6348),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6350),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_AT] = ACTIONS(6348),
    [anon_sym_QMARK] = ACTIONS(6348),
    [anon_sym_0] = ACTIONS(6352),
    [anon_sym__] = ACTIONS(6352),
  },
  [2576] = {
    [sym__terminated_statement] = STATE(2793),
    [sym_for_statement] = STATE(2791),
    [sym_c_style_for_statement] = STATE(2791),
    [sym_while_statement] = STATE(2791),
    [sym_if_statement] = STATE(2791),
    [sym_case_statement] = STATE(2791),
    [sym_function_definition] = STATE(2791),
    [sym_subshell] = STATE(2791),
    [sym_pipeline] = STATE(2791),
    [sym_list] = STATE(2791),
    [sym_negated_command] = STATE(2791),
    [sym_test_command] = STATE(2791),
    [sym_declaration_command] = STATE(2791),
    [sym_unset_command] = STATE(2791),
    [sym_command] = STATE(2791),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2792),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(2793),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2577] = {
    [sym__terminated_statement] = STATE(2796),
    [sym_for_statement] = STATE(2794),
    [sym_c_style_for_statement] = STATE(2794),
    [sym_while_statement] = STATE(2794),
    [sym_if_statement] = STATE(2794),
    [sym_case_statement] = STATE(2794),
    [sym_function_definition] = STATE(2794),
    [sym_subshell] = STATE(2794),
    [sym_pipeline] = STATE(2794),
    [sym_list] = STATE(2794),
    [sym_negated_command] = STATE(2794),
    [sym_test_command] = STATE(2794),
    [sym_declaration_command] = STATE(2794),
    [sym_unset_command] = STATE(2794),
    [sym_command] = STATE(2794),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(2795),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2796),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [2578] = {
    [sym__terminated_statement] = STATE(2799),
    [sym_for_statement] = STATE(2797),
    [sym_c_style_for_statement] = STATE(2797),
    [sym_while_statement] = STATE(2797),
    [sym_if_statement] = STATE(2797),
    [sym_case_statement] = STATE(2797),
    [sym_function_definition] = STATE(2797),
    [sym_subshell] = STATE(2797),
    [sym_pipeline] = STATE(2797),
    [sym_list] = STATE(2797),
    [sym_negated_command] = STATE(2797),
    [sym_test_command] = STATE(2797),
    [sym_declaration_command] = STATE(2797),
    [sym_unset_command] = STATE(2797),
    [sym_command] = STATE(2797),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2798),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(2799),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2579] = {
    [aux_sym_concatenation_repeat1] = STATE(2779),
    [sym__simple_heredoc_body] = ACTIONS(1936),
    [sym__heredoc_body_beginning] = ACTIONS(1936),
    [sym_file_descriptor] = ACTIONS(1936),
    [sym__concat] = ACTIONS(6330),
    [anon_sym_esac] = ACTIONS(1936),
    [anon_sym_PIPE] = ACTIONS(1938),
    [anon_sym_SEMI_SEMI] = ACTIONS(1936),
    [anon_sym_PIPE_AMP] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1938),
    [anon_sym_GT] = ACTIONS(1938),
    [anon_sym_GT_GT] = ACTIONS(1936),
    [anon_sym_AMP_GT] = ACTIONS(1938),
    [anon_sym_AMP_GT_GT] = ACTIONS(1936),
    [anon_sym_LT_AMP] = ACTIONS(1936),
    [anon_sym_GT_AMP] = ACTIONS(1936),
    [anon_sym_LT_LT] = ACTIONS(1938),
    [anon_sym_LT_LT_DASH] = ACTIONS(1936),
    [anon_sym_LT_LT_LT] = ACTIONS(1936),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_LF] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1938),
  },
  [2580] = {
    [aux_sym_concatenation_repeat1] = STATE(2779),
    [sym__simple_heredoc_body] = ACTIONS(1940),
    [sym__heredoc_body_beginning] = ACTIONS(1940),
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(6330),
    [anon_sym_esac] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [2581] = {
    [sym_file_redirect] = STATE(2581),
    [sym_heredoc_redirect] = STATE(2581),
    [sym_herestring_redirect] = STATE(2581),
    [aux_sym_while_statement_repeat1] = STATE(2581),
    [sym__simple_heredoc_body] = ACTIONS(1948),
    [sym__heredoc_body_beginning] = ACTIONS(1948),
    [sym_file_descriptor] = ACTIONS(6354),
    [anon_sym_esac] = ACTIONS(1948),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_SEMI_SEMI] = ACTIONS(1948),
    [anon_sym_PIPE_AMP] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_PIPE_PIPE] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(6357),
    [anon_sym_GT] = ACTIONS(6357),
    [anon_sym_GT_GT] = ACTIONS(6360),
    [anon_sym_AMP_GT] = ACTIONS(6357),
    [anon_sym_AMP_GT_GT] = ACTIONS(6360),
    [anon_sym_LT_AMP] = ACTIONS(6360),
    [anon_sym_GT_AMP] = ACTIONS(6360),
    [anon_sym_LT_LT] = ACTIONS(1961),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(6363),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_LF] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1953),
  },
  [2582] = {
    [sym_file_redirect] = STATE(2581),
    [sym_heredoc_redirect] = STATE(2581),
    [sym_heredoc_body] = STATE(930),
    [sym_herestring_redirect] = STATE(2581),
    [aux_sym_while_statement_repeat1] = STATE(2581),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(5326),
    [anon_sym_esac] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1946),
    [anon_sym_SEMI_SEMI] = ACTIONS(1944),
    [anon_sym_PIPE_AMP] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_LT] = ACTIONS(5330),
    [anon_sym_GT] = ACTIONS(5330),
    [anon_sym_GT_GT] = ACTIONS(5332),
    [anon_sym_AMP_GT] = ACTIONS(5330),
    [anon_sym_AMP_GT_GT] = ACTIONS(5332),
    [anon_sym_LT_AMP] = ACTIONS(5332),
    [anon_sym_GT_AMP] = ACTIONS(5332),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(5334),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_LF] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1946),
  },
  [2583] = {
    [sym_concatenation] = STATE(2583),
    [sym_string] = STATE(2317),
    [sym_simple_expansion] = STATE(2317),
    [sym_string_expansion] = STATE(2317),
    [sym_expansion] = STATE(2317),
    [sym_command_substitution] = STATE(2317),
    [sym_process_substitution] = STATE(2317),
    [aux_sym_command_repeat2] = STATE(2583),
    [sym__simple_heredoc_body] = ACTIONS(1928),
    [sym__heredoc_body_beginning] = ACTIONS(1928),
    [sym_file_descriptor] = ACTIONS(1928),
    [anon_sym_esac] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(1930),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_EQ_TILDE] = ACTIONS(6366),
    [anon_sym_EQ_EQ] = ACTIONS(6366),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_GT] = ACTIONS(1930),
    [anon_sym_GT_GT] = ACTIONS(1928),
    [anon_sym_AMP_GT] = ACTIONS(1930),
    [anon_sym_AMP_GT_GT] = ACTIONS(1928),
    [anon_sym_LT_AMP] = ACTIONS(1928),
    [anon_sym_GT_AMP] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(1930),
    [anon_sym_LT_LT_DASH] = ACTIONS(1928),
    [anon_sym_LT_LT_LT] = ACTIONS(1928),
    [sym__special_characters] = ACTIONS(6369),
    [anon_sym_DQUOTE] = ACTIONS(6372),
    [anon_sym_DOLLAR] = ACTIONS(6375),
    [sym_raw_string] = ACTIONS(6378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6381),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6384),
    [anon_sym_BQUOTE] = ACTIONS(6387),
    [anon_sym_LT_LPAREN] = ACTIONS(6390),
    [anon_sym_GT_LPAREN] = ACTIONS(6390),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6393),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [2584] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_esac] = ACTIONS(6396),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(6398),
    [anon_sym_DQUOTE] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [sym_raw_string] = ACTIONS(6400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6400),
    [anon_sym_BQUOTE] = ACTIONS(6400),
    [anon_sym_LT_LPAREN] = ACTIONS(6400),
    [anon_sym_GT_LPAREN] = ACTIONS(6400),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6398),
  },
  [2585] = {
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(5324),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [2586] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(5324),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [2587] = {
    [sym_file_redirect] = STATE(2800),
    [sym_heredoc_redirect] = STATE(2800),
    [sym_heredoc_body] = STATE(930),
    [sym_herestring_redirect] = STATE(2800),
    [sym_concatenation] = STATE(2583),
    [sym_string] = STATE(2317),
    [sym_simple_expansion] = STATE(2317),
    [sym_string_expansion] = STATE(2317),
    [sym_expansion] = STATE(2317),
    [sym_command_substitution] = STATE(2317),
    [sym_process_substitution] = STATE(2317),
    [aux_sym_while_statement_repeat1] = STATE(2800),
    [aux_sym_command_repeat2] = STATE(2583),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(5326),
    [anon_sym_esac] = ACTIONS(1946),
    [anon_sym_PIPE] = ACTIONS(1946),
    [anon_sym_SEMI_SEMI] = ACTIONS(1944),
    [anon_sym_PIPE_AMP] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_EQ_TILDE] = ACTIONS(5328),
    [anon_sym_EQ_EQ] = ACTIONS(5328),
    [anon_sym_LT] = ACTIONS(5330),
    [anon_sym_GT] = ACTIONS(5330),
    [anon_sym_GT_GT] = ACTIONS(5332),
    [anon_sym_AMP_GT] = ACTIONS(5330),
    [anon_sym_AMP_GT_GT] = ACTIONS(5332),
    [anon_sym_LT_AMP] = ACTIONS(5332),
    [anon_sym_GT_AMP] = ACTIONS(5332),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(5334),
    [sym__special_characters] = ACTIONS(5336),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_raw_string] = ACTIONS(5338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4480),
    [anon_sym_BQUOTE] = ACTIONS(4482),
    [anon_sym_LT_LPAREN] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5340),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_LF] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1946),
  },
  [2588] = {
    [anon_sym_esac] = ACTIONS(6396),
    [sym__special_characters] = ACTIONS(6400),
    [anon_sym_DQUOTE] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [sym_raw_string] = ACTIONS(6400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6400),
    [anon_sym_BQUOTE] = ACTIONS(6400),
    [anon_sym_LT_LPAREN] = ACTIONS(6400),
    [anon_sym_GT_LPAREN] = ACTIONS(6400),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6398),
  },
  [2589] = {
    [anon_sym_esac] = ACTIONS(6402),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6404),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [2590] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_esac] = ACTIONS(6396),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6404),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [2591] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_esac] = ACTIONS(6406),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(6408),
    [anon_sym_DQUOTE] = ACTIONS(6410),
    [anon_sym_DOLLAR] = ACTIONS(6408),
    [sym_raw_string] = ACTIONS(6410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6410),
    [anon_sym_BQUOTE] = ACTIONS(6410),
    [anon_sym_LT_LPAREN] = ACTIONS(6410),
    [anon_sym_GT_LPAREN] = ACTIONS(6410),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6408),
  },
  [2592] = {
    [anon_sym_esac] = ACTIONS(6406),
    [sym__special_characters] = ACTIONS(6410),
    [anon_sym_DQUOTE] = ACTIONS(6410),
    [anon_sym_DOLLAR] = ACTIONS(6408),
    [sym_raw_string] = ACTIONS(6410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6410),
    [anon_sym_BQUOTE] = ACTIONS(6410),
    [anon_sym_LT_LPAREN] = ACTIONS(6410),
    [anon_sym_GT_LPAREN] = ACTIONS(6410),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6408),
  },
  [2593] = {
    [anon_sym_esac] = ACTIONS(6412),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6414),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [2594] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_esac] = ACTIONS(6406),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6414),
    [anon_sym_PIPE_AMP] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5320),
    [anon_sym_PIPE_PIPE] = ACTIONS(5320),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym_LF] = ACTIONS(5324),
    [anon_sym_AMP] = ACTIONS(5322),
  },
  [2595] = {
    [sym__special_characters] = ACTIONS(5238),
    [anon_sym_DQUOTE] = ACTIONS(5238),
    [anon_sym_DOLLAR] = ACTIONS(5240),
    [sym_raw_string] = ACTIONS(5238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5238),
    [anon_sym_BQUOTE] = ACTIONS(5238),
    [anon_sym_LT_LPAREN] = ACTIONS(5238),
    [anon_sym_GT_LPAREN] = ACTIONS(5238),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5238),
  },
  [2596] = {
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(6416),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2597] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(6416),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2598] = {
    [sym__terminated_statement] = STATE(2807),
    [sym_for_statement] = STATE(2805),
    [sym_c_style_for_statement] = STATE(2805),
    [sym_while_statement] = STATE(2805),
    [sym_if_statement] = STATE(2805),
    [sym_case_statement] = STATE(2805),
    [sym_function_definition] = STATE(2805),
    [sym_subshell] = STATE(2805),
    [sym_pipeline] = STATE(2805),
    [sym_list] = STATE(2805),
    [sym_negated_command] = STATE(2805),
    [sym_test_command] = STATE(2805),
    [sym_declaration_command] = STATE(2805),
    [sym_unset_command] = STATE(2805),
    [sym_command] = STATE(2805),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2806),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2807),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6418),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2599] = {
    [sym__terminated_statement] = STATE(2808),
    [sym_for_statement] = STATE(2805),
    [sym_c_style_for_statement] = STATE(2805),
    [sym_while_statement] = STATE(2805),
    [sym_if_statement] = STATE(2805),
    [sym_case_statement] = STATE(2805),
    [sym_function_definition] = STATE(2805),
    [sym_subshell] = STATE(2805),
    [sym_pipeline] = STATE(2805),
    [sym_list] = STATE(2805),
    [sym_negated_command] = STATE(2805),
    [sym_test_command] = STATE(2805),
    [sym_declaration_command] = STATE(2805),
    [sym_unset_command] = STATE(2805),
    [sym_command] = STATE(2805),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2806),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2808),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6418),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2600] = {
    [sym__special_characters] = ACTIONS(5351),
    [anon_sym_DQUOTE] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5353),
    [sym_raw_string] = ACTIONS(5351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5351),
    [anon_sym_BQUOTE] = ACTIONS(5351),
    [anon_sym_LT_LPAREN] = ACTIONS(5351),
    [anon_sym_GT_LPAREN] = ACTIONS(5351),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5351),
  },
  [2601] = {
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(6420),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2602] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(6420),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2603] = {
    [sym__terminated_statement] = STATE(2807),
    [sym_for_statement] = STATE(2811),
    [sym_c_style_for_statement] = STATE(2811),
    [sym_while_statement] = STATE(2811),
    [sym_if_statement] = STATE(2811),
    [sym_case_statement] = STATE(2811),
    [sym_function_definition] = STATE(2811),
    [sym_subshell] = STATE(2811),
    [sym_pipeline] = STATE(2811),
    [sym_list] = STATE(2811),
    [sym_negated_command] = STATE(2811),
    [sym_test_command] = STATE(2811),
    [sym_declaration_command] = STATE(2811),
    [sym_unset_command] = STATE(2811),
    [sym_command] = STATE(2811),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2812),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2807),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6422),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2604] = {
    [sym__terminated_statement] = STATE(2813),
    [sym_for_statement] = STATE(2811),
    [sym_c_style_for_statement] = STATE(2811),
    [sym_while_statement] = STATE(2811),
    [sym_if_statement] = STATE(2811),
    [sym_case_statement] = STATE(2811),
    [sym_function_definition] = STATE(2811),
    [sym_subshell] = STATE(2811),
    [sym_pipeline] = STATE(2811),
    [sym_list] = STATE(2811),
    [sym_negated_command] = STATE(2811),
    [sym_test_command] = STATE(2811),
    [sym_declaration_command] = STATE(2811),
    [sym_unset_command] = STATE(2811),
    [sym_command] = STATE(2811),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2812),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2813),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6422),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2605] = {
    [sym_file_descriptor] = ACTIONS(3903),
    [sym__concat] = ACTIONS(3903),
    [anon_sym_esac] = ACTIONS(3903),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_RPAREN] = ACTIONS(3903),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_GT_GT] = ACTIONS(3903),
    [anon_sym_AMP_GT] = ACTIONS(3905),
    [anon_sym_AMP_GT_GT] = ACTIONS(3903),
    [anon_sym_LT_AMP] = ACTIONS(3903),
    [anon_sym_GT_AMP] = ACTIONS(3903),
    [anon_sym_LT_LT] = ACTIONS(3905),
    [anon_sym_LT_LT_DASH] = ACTIONS(3903),
    [anon_sym_LT_LT_LT] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [2606] = {
    [sym_file_descriptor] = ACTIONS(3911),
    [sym__concat] = ACTIONS(3911),
    [anon_sym_esac] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_GT] = ACTIONS(3913),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3913),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3913),
    [anon_sym_LT_LT_DASH] = ACTIONS(3911),
    [anon_sym_LT_LT_LT] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3913),
  },
  [2607] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6424),
    [sym_comment] = ACTIONS(53),
  },
  [2608] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6426),
    [sym_comment] = ACTIONS(53),
  },
  [2609] = {
    [anon_sym_RBRACE] = ACTIONS(6426),
    [sym_comment] = ACTIONS(53),
  },
  [2610] = {
    [sym_concatenation] = STATE(2817),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2817),
    [anon_sym_RBRACE] = ACTIONS(6428),
    [anon_sym_EQ] = ACTIONS(6430),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6432),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_COLON_QMARK] = ACTIONS(6430),
    [anon_sym_COLON_DASH] = ACTIONS(6430),
    [anon_sym_PERCENT] = ACTIONS(6430),
    [anon_sym_DASH] = ACTIONS(6430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2611] = {
    [sym_file_descriptor] = ACTIONS(3975),
    [sym__concat] = ACTIONS(3975),
    [anon_sym_esac] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3975),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [anon_sym_PIPE_AMP] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3977),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_GT_GT] = ACTIONS(3975),
    [anon_sym_AMP_GT] = ACTIONS(3977),
    [anon_sym_AMP_GT_GT] = ACTIONS(3975),
    [anon_sym_LT_AMP] = ACTIONS(3975),
    [anon_sym_GT_AMP] = ACTIONS(3975),
    [anon_sym_LT_LT] = ACTIONS(3977),
    [anon_sym_LT_LT_DASH] = ACTIONS(3975),
    [anon_sym_LT_LT_LT] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3977),
  },
  [2612] = {
    [sym_concatenation] = STATE(2819),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2819),
    [anon_sym_RBRACE] = ACTIONS(6434),
    [anon_sym_EQ] = ACTIONS(6436),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6436),
    [anon_sym_COLON_QMARK] = ACTIONS(6436),
    [anon_sym_COLON_DASH] = ACTIONS(6436),
    [anon_sym_PERCENT] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2613] = {
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [anon_sym_esac] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [2614] = {
    [sym_concatenation] = STATE(2821),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2821),
    [anon_sym_RBRACE] = ACTIONS(6440),
    [anon_sym_EQ] = ACTIONS(6442),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_COLON_QMARK] = ACTIONS(6442),
    [anon_sym_COLON_DASH] = ACTIONS(6442),
    [anon_sym_PERCENT] = ACTIONS(6442),
    [anon_sym_DASH] = ACTIONS(6442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2615] = {
    [sym_file_descriptor] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_esac] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [anon_sym_PIPE_AMP] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_GT_GT] = ACTIONS(4040),
    [anon_sym_AMP_GT] = ACTIONS(4042),
    [anon_sym_AMP_GT_GT] = ACTIONS(4040),
    [anon_sym_LT_AMP] = ACTIONS(4040),
    [anon_sym_GT_AMP] = ACTIONS(4040),
    [anon_sym_LT_LT] = ACTIONS(4042),
    [anon_sym_LT_LT_DASH] = ACTIONS(4040),
    [anon_sym_LT_LT_LT] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [2616] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6446),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2617] = {
    [sym_file_descriptor] = ACTIONS(4062),
    [sym__concat] = ACTIONS(4062),
    [anon_sym_esac] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_GT_GT] = ACTIONS(4062),
    [anon_sym_AMP_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT_GT] = ACTIONS(4062),
    [anon_sym_LT_AMP] = ACTIONS(4062),
    [anon_sym_GT_AMP] = ACTIONS(4062),
    [anon_sym_LT_LT] = ACTIONS(4064),
    [anon_sym_LT_LT_DASH] = ACTIONS(4062),
    [anon_sym_LT_LT_LT] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [2618] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6448),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2619] = {
    [sym_file_descriptor] = ACTIONS(4068),
    [sym__concat] = ACTIONS(4068),
    [anon_sym_esac] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [anon_sym_PIPE_AMP] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4068),
    [anon_sym_AMP_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT_GT] = ACTIONS(4068),
    [anon_sym_LT_AMP] = ACTIONS(4068),
    [anon_sym_GT_AMP] = ACTIONS(4068),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_LT_LT_DASH] = ACTIONS(4068),
    [anon_sym_LT_LT_LT] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [2620] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6450),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2621] = {
    [sym_file_descriptor] = ACTIONS(4074),
    [sym__concat] = ACTIONS(4074),
    [anon_sym_esac] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_AMP_GT] = ACTIONS(4076),
    [anon_sym_AMP_GT_GT] = ACTIONS(4074),
    [anon_sym_LT_AMP] = ACTIONS(4074),
    [anon_sym_GT_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_LT_LT_DASH] = ACTIONS(4074),
    [anon_sym_LT_LT_LT] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [2622] = {
    [sym_file_descriptor] = ACTIONS(4098),
    [sym__concat] = ACTIONS(4098),
    [anon_sym_esac] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_RPAREN] = ACTIONS(4098),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [anon_sym_PIPE_AMP] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4100),
    [anon_sym_GT] = ACTIONS(4100),
    [anon_sym_GT_GT] = ACTIONS(4098),
    [anon_sym_AMP_GT] = ACTIONS(4100),
    [anon_sym_AMP_GT_GT] = ACTIONS(4098),
    [anon_sym_LT_AMP] = ACTIONS(4098),
    [anon_sym_GT_AMP] = ACTIONS(4098),
    [anon_sym_LT_LT] = ACTIONS(4100),
    [anon_sym_LT_LT_DASH] = ACTIONS(4098),
    [anon_sym_LT_LT_LT] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
  },
  [2623] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
  },
  [2624] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_RBRACE] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
  },
  [2625] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_RBRACE] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
  },
  [2626] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6452),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2627] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_RBRACE] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
  },
  [2628] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6454),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2629] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_RBRACE] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
  },
  [2630] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2631] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_RBRACE] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
  },
  [2632] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_RBRACE] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
  },
  [2633] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_RBRACE] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
  },
  [2634] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_RBRACE] = ACTIONS(5524),
    [anon_sym_EQ] = ACTIONS(5526),
    [sym__special_characters] = ACTIONS(5526),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_POUND] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_COLON] = ACTIONS(5526),
    [anon_sym_COLON_QMARK] = ACTIONS(5526),
    [anon_sym_COLON_DASH] = ACTIONS(5526),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_DASH] = ACTIONS(5526),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(5526),
  },
  [2635] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_RBRACE] = ACTIONS(5528),
    [anon_sym_EQ] = ACTIONS(5530),
    [sym__special_characters] = ACTIONS(5530),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_POUND] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_COLON] = ACTIONS(5530),
    [anon_sym_COLON_QMARK] = ACTIONS(5530),
    [anon_sym_COLON_DASH] = ACTIONS(5530),
    [anon_sym_PERCENT] = ACTIONS(5530),
    [anon_sym_DASH] = ACTIONS(5530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(5530),
  },
  [2636] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_RBRACE] = ACTIONS(5532),
    [anon_sym_EQ] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_POUND] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_COLON] = ACTIONS(5534),
    [anon_sym_COLON_QMARK] = ACTIONS(5534),
    [anon_sym_COLON_DASH] = ACTIONS(5534),
    [anon_sym_PERCENT] = ACTIONS(5534),
    [anon_sym_DASH] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(5534),
  },
  [2637] = {
    [sym__heredoc_body_middle] = ACTIONS(5524),
    [sym__heredoc_body_end] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
  },
  [2638] = {
    [sym__heredoc_body_middle] = ACTIONS(5528),
    [sym__heredoc_body_end] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
  },
  [2639] = {
    [sym__heredoc_body_middle] = ACTIONS(5532),
    [sym__heredoc_body_end] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
  },
  [2640] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_RPAREN] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5524),
  },
  [2641] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_RPAREN] = ACTIONS(5528),
    [sym__special_characters] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5528),
  },
  [2642] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5532),
  },
  [2643] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_EQ_TILDE] = ACTIONS(4885),
    [anon_sym_EQ_EQ] = ACTIONS(4885),
    [anon_sym_EQ] = ACTIONS(4887),
    [anon_sym_LT] = ACTIONS(4885),
    [anon_sym_GT] = ACTIONS(4885),
    [anon_sym_BANG_EQ] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4885),
  },
  [2644] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_EQ_TILDE] = ACTIONS(4889),
    [anon_sym_EQ_EQ] = ACTIONS(4889),
    [anon_sym_EQ] = ACTIONS(4891),
    [anon_sym_LT] = ACTIONS(4889),
    [anon_sym_GT] = ACTIONS(4889),
    [anon_sym_BANG_EQ] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4889),
  },
  [2645] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [anon_sym_EQ_TILDE] = ACTIONS(4893),
    [anon_sym_EQ_EQ] = ACTIONS(4893),
    [anon_sym_EQ] = ACTIONS(4895),
    [anon_sym_LT] = ACTIONS(4893),
    [anon_sym_GT] = ACTIONS(4893),
    [anon_sym_BANG_EQ] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4893),
  },
  [2646] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6458),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2647] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [anon_sym_EQ_TILDE] = ACTIONS(4899),
    [anon_sym_EQ_EQ] = ACTIONS(4899),
    [anon_sym_EQ] = ACTIONS(4901),
    [anon_sym_LT] = ACTIONS(4899),
    [anon_sym_GT] = ACTIONS(4899),
    [anon_sym_BANG_EQ] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4899),
  },
  [2648] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6460),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2649] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_EQ_TILDE] = ACTIONS(4905),
    [anon_sym_EQ_EQ] = ACTIONS(4905),
    [anon_sym_EQ] = ACTIONS(4907),
    [anon_sym_LT] = ACTIONS(4905),
    [anon_sym_GT] = ACTIONS(4905),
    [anon_sym_BANG_EQ] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4905),
  },
  [2650] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6462),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2651] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_EQ_TILDE] = ACTIONS(4947),
    [anon_sym_EQ_EQ] = ACTIONS(4947),
    [anon_sym_EQ] = ACTIONS(4949),
    [anon_sym_LT] = ACTIONS(4947),
    [anon_sym_GT] = ACTIONS(4947),
    [anon_sym_BANG_EQ] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4947),
  },
  [2652] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [anon_sym_EQ_TILDE] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4955),
    [anon_sym_EQ] = ACTIONS(4957),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_BANG_EQ] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4955),
  },
  [2653] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [anon_sym_EQ_TILDE] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4959),
    [anon_sym_EQ] = ACTIONS(4961),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_BANG_EQ] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4959),
  },
  [2654] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5526),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5524),
  },
  [2655] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [sym__special_characters] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5530),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
  },
  [2656] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5532),
  },
  [2657] = {
    [sym_file_descriptor] = ACTIONS(2014),
    [sym_variable_name] = ACTIONS(2014),
    [anon_sym_esac] = ACTIONS(2016),
    [anon_sym_PIPE] = ACTIONS(2016),
    [anon_sym_SEMI_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE_AMP] = ACTIONS(2014),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_PIPE_PIPE] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2016),
    [anon_sym_GT] = ACTIONS(2016),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT] = ACTIONS(2016),
    [anon_sym_AMP_GT_GT] = ACTIONS(2014),
    [anon_sym_LT_AMP] = ACTIONS(2014),
    [anon_sym_GT_AMP] = ACTIONS(2014),
    [sym__special_characters] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_DOLLAR] = ACTIONS(2016),
    [sym_raw_string] = ACTIONS(2014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2014),
    [anon_sym_BQUOTE] = ACTIONS(2014),
    [anon_sym_LT_LPAREN] = ACTIONS(2014),
    [anon_sym_GT_LPAREN] = ACTIONS(2014),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2016),
    [anon_sym_LF] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2016),
  },
  [2658] = {
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_string_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [aux_sym_for_statement_repeat1] = STATE(960),
    [anon_sym_RPAREN] = ACTIONS(6464),
    [sym__special_characters] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [sym_raw_string] = ACTIONS(1011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1019),
    [anon_sym_GT_LPAREN] = ACTIONS(1019),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1011),
  },
  [2659] = {
    [sym_string] = STATE(2832),
    [sym_simple_expansion] = STATE(2832),
    [sym_string_expansion] = STATE(2832),
    [sym_expansion] = STATE(2832),
    [sym_command_substitution] = STATE(2832),
    [sym_process_substitution] = STATE(2832),
    [sym__special_characters] = ACTIONS(6466),
    [anon_sym_DQUOTE] = ACTIONS(5710),
    [anon_sym_DOLLAR] = ACTIONS(5712),
    [sym_raw_string] = ACTIONS(6466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5718),
    [anon_sym_BQUOTE] = ACTIONS(5720),
    [anon_sym_LT_LPAREN] = ACTIONS(5722),
    [anon_sym_GT_LPAREN] = ACTIONS(5722),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6466),
  },
  [2660] = {
    [aux_sym_concatenation_repeat1] = STATE(2833),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(6042),
    [sym_variable_name] = ACTIONS(695),
    [anon_sym_esac] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [2661] = {
    [sym_file_descriptor] = ACTIONS(699),
    [sym__concat] = ACTIONS(699),
    [sym_variable_name] = ACTIONS(699),
    [anon_sym_esac] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(701),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
  },
  [2662] = {
    [anon_sym_DQUOTE] = ACTIONS(6468),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [2663] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(6468),
    [anon_sym_DOLLAR] = ACTIONS(6470),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [2664] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2665] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2666] = {
    [sym_file_descriptor] = ACTIONS(739),
    [sym__concat] = ACTIONS(739),
    [sym_variable_name] = ACTIONS(739),
    [anon_sym_esac] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [2667] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(6472),
    [sym_comment] = ACTIONS(53),
  },
  [2668] = {
    [sym_subscript] = STATE(2840),
    [sym_variable_name] = ACTIONS(6474),
    [anon_sym_DOLLAR] = ACTIONS(6476),
    [anon_sym_DASH] = ACTIONS(6476),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6478),
    [anon_sym_STAR] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6476),
    [anon_sym_QMARK] = ACTIONS(6476),
    [anon_sym_0] = ACTIONS(6480),
    [anon_sym__] = ACTIONS(6480),
  },
  [2669] = {
    [sym_concatenation] = STATE(2843),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2843),
    [anon_sym_RBRACE] = ACTIONS(6482),
    [anon_sym_EQ] = ACTIONS(6484),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6486),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6488),
    [anon_sym_COLON] = ACTIONS(6484),
    [anon_sym_COLON_QMARK] = ACTIONS(6484),
    [anon_sym_COLON_DASH] = ACTIONS(6484),
    [anon_sym_PERCENT] = ACTIONS(6484),
    [anon_sym_DASH] = ACTIONS(6484),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2670] = {
    [sym_concatenation] = STATE(2846),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2846),
    [anon_sym_RBRACE] = ACTIONS(6490),
    [anon_sym_EQ] = ACTIONS(6492),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6494),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6496),
    [anon_sym_COLON] = ACTIONS(6492),
    [anon_sym_COLON_QMARK] = ACTIONS(6492),
    [anon_sym_COLON_DASH] = ACTIONS(6492),
    [anon_sym_PERCENT] = ACTIONS(6492),
    [anon_sym_DASH] = ACTIONS(6492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2671] = {
    [sym_concatenation] = STATE(2849),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2849),
    [anon_sym_RBRACE] = ACTIONS(6498),
    [anon_sym_EQ] = ACTIONS(6500),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6504),
    [anon_sym_COLON] = ACTIONS(6500),
    [anon_sym_COLON_QMARK] = ACTIONS(6500),
    [anon_sym_COLON_DASH] = ACTIONS(6500),
    [anon_sym_PERCENT] = ACTIONS(6500),
    [anon_sym_DASH] = ACTIONS(6500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2672] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6506),
    [anon_sym_SEMI_SEMI] = ACTIONS(6508),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6510),
    [anon_sym_LF] = ACTIONS(6508),
    [anon_sym_AMP] = ACTIONS(6510),
  },
  [2673] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6506),
    [anon_sym_SEMI_SEMI] = ACTIONS(6508),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6510),
    [anon_sym_LF] = ACTIONS(6508),
    [anon_sym_AMP] = ACTIONS(6510),
  },
  [2674] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2852),
    [sym_c_style_for_statement] = STATE(2852),
    [sym_while_statement] = STATE(2852),
    [sym_if_statement] = STATE(2852),
    [sym_case_statement] = STATE(2852),
    [sym_function_definition] = STATE(2852),
    [sym_subshell] = STATE(2852),
    [sym_pipeline] = STATE(2852),
    [sym_list] = STATE(2852),
    [sym_negated_command] = STATE(2852),
    [sym_test_command] = STATE(2852),
    [sym_declaration_command] = STATE(2852),
    [sym_unset_command] = STATE(2852),
    [sym_command] = STATE(2852),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2853),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2675] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6512),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(6506),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6514),
    [anon_sym_LF] = ACTIONS(6512),
    [anon_sym_AMP] = ACTIONS(6514),
  },
  [2676] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6512),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(6506),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6514),
    [anon_sym_LF] = ACTIONS(6512),
    [anon_sym_AMP] = ACTIONS(6514),
  },
  [2677] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2855),
    [sym_c_style_for_statement] = STATE(2855),
    [sym_while_statement] = STATE(2855),
    [sym_if_statement] = STATE(2855),
    [sym_case_statement] = STATE(2855),
    [sym_function_definition] = STATE(2855),
    [sym_subshell] = STATE(2855),
    [sym_pipeline] = STATE(2855),
    [sym_list] = STATE(2855),
    [sym_negated_command] = STATE(2855),
    [sym_test_command] = STATE(2855),
    [sym_declaration_command] = STATE(2855),
    [sym_unset_command] = STATE(2855),
    [sym_command] = STATE(2855),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(2856),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [2678] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6516),
    [anon_sym_SEMI_SEMI] = ACTIONS(6518),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6520),
    [anon_sym_LF] = ACTIONS(6518),
    [anon_sym_AMP] = ACTIONS(6520),
  },
  [2679] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6516),
    [anon_sym_SEMI_SEMI] = ACTIONS(6518),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6520),
    [anon_sym_LF] = ACTIONS(6518),
    [anon_sym_AMP] = ACTIONS(6520),
  },
  [2680] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2859),
    [sym_c_style_for_statement] = STATE(2859),
    [sym_while_statement] = STATE(2859),
    [sym_if_statement] = STATE(2859),
    [sym_case_statement] = STATE(2859),
    [sym_function_definition] = STATE(2859),
    [sym_subshell] = STATE(2859),
    [sym_pipeline] = STATE(2859),
    [sym_list] = STATE(2859),
    [sym_negated_command] = STATE(2859),
    [sym_test_command] = STATE(2859),
    [sym_declaration_command] = STATE(2859),
    [sym_unset_command] = STATE(2859),
    [sym_command] = STATE(2859),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2860),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2681] = {
    [sym_file_redirect] = STATE(2581),
    [sym_heredoc_redirect] = STATE(2581),
    [sym_heredoc_body] = STATE(1064),
    [sym_herestring_redirect] = STATE(2581),
    [aux_sym_while_statement_repeat1] = STATE(2581),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(5326),
    [anon_sym_esac] = ACTIONS(2256),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_SEMI_SEMI] = ACTIONS(2256),
    [anon_sym_PIPE_AMP] = ACTIONS(2256),
    [anon_sym_AMP_AMP] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(5330),
    [anon_sym_GT] = ACTIONS(5330),
    [anon_sym_GT_GT] = ACTIONS(5332),
    [anon_sym_AMP_GT] = ACTIONS(5330),
    [anon_sym_AMP_GT_GT] = ACTIONS(5332),
    [anon_sym_LT_AMP] = ACTIONS(5332),
    [anon_sym_GT_AMP] = ACTIONS(5332),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(5334),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_LF] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2258),
  },
  [2682] = {
    [sym_compound_statement] = STATE(2861),
    [anon_sym_LBRACE] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [2683] = {
    [anon_sym_LT] = ACTIONS(6522),
    [anon_sym_GT] = ACTIONS(6522),
    [anon_sym_GT_GT] = ACTIONS(6524),
    [anon_sym_AMP_GT] = ACTIONS(6522),
    [anon_sym_AMP_GT_GT] = ACTIONS(6524),
    [anon_sym_LT_AMP] = ACTIONS(6524),
    [anon_sym_GT_AMP] = ACTIONS(6524),
    [sym_comment] = ACTIONS(53),
  },
  [2684] = {
    [sym_concatenation] = STATE(1114),
    [sym_string] = STATE(2864),
    [sym_simple_expansion] = STATE(2864),
    [sym_string_expansion] = STATE(2864),
    [sym_expansion] = STATE(2864),
    [sym_command_substitution] = STATE(2864),
    [sym_process_substitution] = STATE(2864),
    [sym__special_characters] = ACTIONS(6526),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(6528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6528),
  },
  [2685] = {
    [anon_sym_LT] = ACTIONS(6530),
    [anon_sym_GT] = ACTIONS(6530),
    [anon_sym_GT_GT] = ACTIONS(6532),
    [anon_sym_AMP_GT] = ACTIONS(6530),
    [anon_sym_AMP_GT_GT] = ACTIONS(6532),
    [anon_sym_LT_AMP] = ACTIONS(6532),
    [anon_sym_GT_AMP] = ACTIONS(6532),
    [sym_comment] = ACTIONS(53),
  },
  [2686] = {
    [sym_concatenation] = STATE(1170),
    [sym_string] = STATE(2867),
    [sym_simple_expansion] = STATE(2867),
    [sym_string_expansion] = STATE(2867),
    [sym_expansion] = STATE(2867),
    [sym_command_substitution] = STATE(2867),
    [sym_process_substitution] = STATE(2867),
    [sym__special_characters] = ACTIONS(6534),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(6536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6536),
  },
  [2687] = {
    [sym_concatenation] = STATE(1174),
    [sym_string] = STATE(2869),
    [sym_simple_expansion] = STATE(2869),
    [sym_string_expansion] = STATE(2869),
    [sym_expansion] = STATE(2869),
    [sym_command_substitution] = STATE(2869),
    [sym_process_substitution] = STATE(2869),
    [sym__special_characters] = ACTIONS(6538),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(6540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6540),
  },
  [2688] = {
    [sym_file_redirect] = STATE(2870),
    [sym_heredoc_redirect] = STATE(2870),
    [sym_herestring_redirect] = STATE(2870),
    [aux_sym_while_statement_repeat1] = STATE(2870),
    [sym_file_descriptor] = ACTIONS(6074),
    [anon_sym_esac] = ACTIONS(2553),
    [anon_sym_PIPE] = ACTIONS(2551),
    [anon_sym_SEMI_SEMI] = ACTIONS(2553),
    [anon_sym_PIPE_AMP] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(6076),
    [anon_sym_GT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_AMP_GT] = ACTIONS(6076),
    [anon_sym_AMP_GT_GT] = ACTIONS(6078),
    [anon_sym_LT_AMP] = ACTIONS(6078),
    [anon_sym_GT_AMP] = ACTIONS(6078),
    [anon_sym_LT_LT] = ACTIONS(1321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1323),
    [anon_sym_LT_LT_LT] = ACTIONS(6080),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2551),
    [anon_sym_LF] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2551),
  },
  [2689] = {
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_esac] = ACTIONS(1001),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_SEMI_SEMI] = ACTIONS(999),
    [anon_sym_PIPE_AMP] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1001),
    [sym_word] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LF] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(1001),
  },
  [2690] = {
    [sym_concatenation] = STATE(2872),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_string_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [aux_sym_for_statement_repeat1] = STATE(2872),
    [anon_sym_RPAREN] = ACTIONS(6542),
    [sym__special_characters] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [sym_raw_string] = ACTIONS(1011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1019),
    [anon_sym_GT_LPAREN] = ACTIONS(1019),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1011),
  },
  [2691] = {
    [aux_sym_concatenation_repeat1] = STATE(2489),
    [sym__concat] = ACTIONS(5730),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_esac] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1025),
    [anon_sym_SEMI_SEMI] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1025),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1025),
    [sym_word] = ACTIONS(1025),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_LF] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1025),
  },
  [2692] = {
    [aux_sym_concatenation_repeat1] = STATE(2489),
    [sym__concat] = ACTIONS(5730),
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_esac] = ACTIONS(1001),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_SEMI_SEMI] = ACTIONS(999),
    [anon_sym_PIPE_AMP] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [sym__special_characters] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [sym_raw_string] = ACTIONS(999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(999),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [anon_sym_LT_LPAREN] = ACTIONS(999),
    [anon_sym_GT_LPAREN] = ACTIONS(999),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1001),
    [sym_word] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LF] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(1001),
  },
  [2693] = {
    [sym__concat] = ACTIONS(1664),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_esac] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1666),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2694] = {
    [aux_sym_concatenation_repeat1] = STATE(2694),
    [sym__concat] = ACTIONS(6544),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_esac] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1666),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2695] = {
    [sym__concat] = ACTIONS(1671),
    [sym_variable_name] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1673),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1673),
    [sym_word] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1673),
  },
  [2696] = {
    [anon_sym_DQUOTE] = ACTIONS(6547),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [2697] = {
    [sym_concatenation] = STATE(2877),
    [sym_string] = STATE(2876),
    [sym_simple_expansion] = STATE(2876),
    [sym_string_expansion] = STATE(2876),
    [sym_expansion] = STATE(2876),
    [sym_command_substitution] = STATE(2876),
    [sym_process_substitution] = STATE(2876),
    [anon_sym_RBRACE] = ACTIONS(6549),
    [sym__special_characters] = ACTIONS(6551),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(6553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6553),
  },
  [2698] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(6555),
    [sym_comment] = ACTIONS(53),
  },
  [2699] = {
    [sym_concatenation] = STATE(2881),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2881),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_EQ] = ACTIONS(6559),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6563),
    [anon_sym_COLON] = ACTIONS(6559),
    [anon_sym_COLON_QMARK] = ACTIONS(6559),
    [anon_sym_COLON_DASH] = ACTIONS(6559),
    [anon_sym_PERCENT] = ACTIONS(6559),
    [anon_sym_DASH] = ACTIONS(6559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2700] = {
    [sym_concatenation] = STATE(2884),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2884),
    [anon_sym_RBRACE] = ACTIONS(6565),
    [anon_sym_EQ] = ACTIONS(6567),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6571),
    [anon_sym_COLON] = ACTIONS(6567),
    [anon_sym_COLON_QMARK] = ACTIONS(6567),
    [anon_sym_COLON_DASH] = ACTIONS(6567),
    [anon_sym_PERCENT] = ACTIONS(6567),
    [anon_sym_DASH] = ACTIONS(6567),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2701] = {
    [sym_concatenation] = STATE(2886),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2886),
    [anon_sym_RBRACE] = ACTIONS(6549),
    [anon_sym_EQ] = ACTIONS(6573),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6577),
    [anon_sym_COLON] = ACTIONS(6573),
    [anon_sym_COLON_QMARK] = ACTIONS(6573),
    [anon_sym_COLON_DASH] = ACTIONS(6573),
    [anon_sym_PERCENT] = ACTIONS(6573),
    [anon_sym_DASH] = ACTIONS(6573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2702] = {
    [sym__concat] = ACTIONS(1788),
    [sym_variable_name] = ACTIONS(1788),
    [anon_sym_esac] = ACTIONS(1790),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [anon_sym_PIPE_AMP] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1790),
    [sym_word] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1790),
  },
  [2703] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6579),
  },
  [2704] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6581),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2705] = {
    [sym__concat] = ACTIONS(1832),
    [sym_variable_name] = ACTIONS(1832),
    [anon_sym_esac] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1834),
    [sym_word] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [2706] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6583),
  },
  [2707] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6585),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2708] = {
    [sym__concat] = ACTIONS(1840),
    [sym_variable_name] = ACTIONS(1840),
    [anon_sym_esac] = ACTIONS(1842),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [anon_sym_PIPE_AMP] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1842),
    [sym_word] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [2709] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6587),
  },
  [2710] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6549),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2711] = {
    [sym__concat] = ACTIONS(1846),
    [sym_variable_name] = ACTIONS(1846),
    [anon_sym_esac] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1848),
    [sym_word] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1848),
  },
  [2712] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6589),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2713] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6589),
    [anon_sym_SEMI_SEMI] = ACTIONS(6591),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6593),
    [anon_sym_LF] = ACTIONS(6591),
    [anon_sym_AMP] = ACTIONS(6593),
  },
  [2714] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6589),
    [anon_sym_SEMI_SEMI] = ACTIONS(6591),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6593),
    [anon_sym_LF] = ACTIONS(6591),
    [anon_sym_AMP] = ACTIONS(6593),
  },
  [2715] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(6589),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2716] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6595),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(6589),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6597),
    [anon_sym_LF] = ACTIONS(6595),
    [anon_sym_AMP] = ACTIONS(6597),
  },
  [2717] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6595),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(6589),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6597),
    [anon_sym_LF] = ACTIONS(6595),
    [anon_sym_AMP] = ACTIONS(6597),
  },
  [2718] = {
    [sym__concat] = ACTIONS(1878),
    [sym_variable_name] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1880),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1880),
    [sym_word] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1880),
  },
  [2719] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6599),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2720] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6599),
    [anon_sym_SEMI_SEMI] = ACTIONS(6601),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6603),
    [anon_sym_LF] = ACTIONS(6601),
    [anon_sym_AMP] = ACTIONS(6603),
  },
  [2721] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6599),
    [anon_sym_SEMI_SEMI] = ACTIONS(6601),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6603),
    [anon_sym_LF] = ACTIONS(6601),
    [anon_sym_AMP] = ACTIONS(6603),
  },
  [2722] = {
    [sym__concat] = ACTIONS(1664),
    [anon_sym_esac] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1666),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2723] = {
    [aux_sym_concatenation_repeat1] = STATE(2723),
    [sym__concat] = ACTIONS(6605),
    [anon_sym_esac] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1666),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2724] = {
    [sym__concat] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1673),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1673),
    [sym_word] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1673),
  },
  [2725] = {
    [anon_sym_DQUOTE] = ACTIONS(6608),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [2726] = {
    [sym_concatenation] = STATE(2901),
    [sym_string] = STATE(2900),
    [sym_simple_expansion] = STATE(2900),
    [sym_string_expansion] = STATE(2900),
    [sym_expansion] = STATE(2900),
    [sym_command_substitution] = STATE(2900),
    [sym_process_substitution] = STATE(2900),
    [anon_sym_RBRACE] = ACTIONS(6610),
    [sym__special_characters] = ACTIONS(6612),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(6614),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6614),
  },
  [2727] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(6616),
    [sym_comment] = ACTIONS(53),
  },
  [2728] = {
    [sym_concatenation] = STATE(2905),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2905),
    [anon_sym_RBRACE] = ACTIONS(6618),
    [anon_sym_EQ] = ACTIONS(6620),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6622),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6624),
    [anon_sym_COLON] = ACTIONS(6620),
    [anon_sym_COLON_QMARK] = ACTIONS(6620),
    [anon_sym_COLON_DASH] = ACTIONS(6620),
    [anon_sym_PERCENT] = ACTIONS(6620),
    [anon_sym_DASH] = ACTIONS(6620),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2729] = {
    [sym_concatenation] = STATE(2908),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2908),
    [anon_sym_RBRACE] = ACTIONS(6626),
    [anon_sym_EQ] = ACTIONS(6628),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6630),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_COLON] = ACTIONS(6628),
    [anon_sym_COLON_QMARK] = ACTIONS(6628),
    [anon_sym_COLON_DASH] = ACTIONS(6628),
    [anon_sym_PERCENT] = ACTIONS(6628),
    [anon_sym_DASH] = ACTIONS(6628),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2730] = {
    [sym_concatenation] = STATE(2910),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2910),
    [anon_sym_RBRACE] = ACTIONS(6610),
    [anon_sym_EQ] = ACTIONS(6634),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6638),
    [anon_sym_COLON] = ACTIONS(6634),
    [anon_sym_COLON_QMARK] = ACTIONS(6634),
    [anon_sym_COLON_DASH] = ACTIONS(6634),
    [anon_sym_PERCENT] = ACTIONS(6634),
    [anon_sym_DASH] = ACTIONS(6634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2731] = {
    [sym__concat] = ACTIONS(1788),
    [anon_sym_esac] = ACTIONS(1790),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [anon_sym_PIPE_AMP] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1790),
    [sym_word] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1790),
  },
  [2732] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6640),
  },
  [2733] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6642),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2734] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_esac] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1834),
    [sym_word] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [2735] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6644),
  },
  [2736] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6646),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2737] = {
    [sym__concat] = ACTIONS(1840),
    [anon_sym_esac] = ACTIONS(1842),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [anon_sym_PIPE_AMP] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1842),
    [sym_word] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [2738] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6648),
  },
  [2739] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6610),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2740] = {
    [sym__concat] = ACTIONS(1846),
    [anon_sym_esac] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1848),
    [sym_word] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1848),
  },
  [2741] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6650),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2742] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6650),
    [anon_sym_SEMI_SEMI] = ACTIONS(6652),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6654),
    [anon_sym_LF] = ACTIONS(6652),
    [anon_sym_AMP] = ACTIONS(6654),
  },
  [2743] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6650),
    [anon_sym_SEMI_SEMI] = ACTIONS(6652),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6654),
    [anon_sym_LF] = ACTIONS(6652),
    [anon_sym_AMP] = ACTIONS(6654),
  },
  [2744] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(6650),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2745] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6656),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(6650),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6658),
    [anon_sym_LF] = ACTIONS(6656),
    [anon_sym_AMP] = ACTIONS(6658),
  },
  [2746] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6656),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(6650),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6658),
    [anon_sym_LF] = ACTIONS(6656),
    [anon_sym_AMP] = ACTIONS(6658),
  },
  [2747] = {
    [sym__concat] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1880),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1880),
    [sym_word] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1880),
  },
  [2748] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6660),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2749] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6660),
    [anon_sym_SEMI_SEMI] = ACTIONS(6662),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6664),
    [anon_sym_LF] = ACTIONS(6662),
    [anon_sym_AMP] = ACTIONS(6664),
  },
  [2750] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6660),
    [anon_sym_SEMI_SEMI] = ACTIONS(6662),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6664),
    [anon_sym_LF] = ACTIONS(6662),
    [anon_sym_AMP] = ACTIONS(6664),
  },
  [2751] = {
    [sym__simple_heredoc_body] = ACTIONS(2855),
    [sym__heredoc_body_beginning] = ACTIONS(2855),
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_EQ_EQ] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2855),
    [anon_sym_LT_AMP] = ACTIONS(2855),
    [anon_sym_GT_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_LT_LT_DASH] = ACTIONS(2855),
    [anon_sym_LT_LT_LT] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [2752] = {
    [sym__simple_heredoc_body] = ACTIONS(2869),
    [sym__heredoc_body_beginning] = ACTIONS(2869),
    [sym_file_descriptor] = ACTIONS(2869),
    [sym__concat] = ACTIONS(2869),
    [anon_sym_esac] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [anon_sym_PIPE_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [anon_sym_EQ_TILDE] = ACTIONS(2871),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_GT_GT] = ACTIONS(2869),
    [anon_sym_AMP_GT] = ACTIONS(2871),
    [anon_sym_AMP_GT_GT] = ACTIONS(2869),
    [anon_sym_LT_AMP] = ACTIONS(2869),
    [anon_sym_GT_AMP] = ACTIONS(2869),
    [anon_sym_LT_LT] = ACTIONS(2871),
    [anon_sym_LT_LT_DASH] = ACTIONS(2869),
    [anon_sym_LT_LT_LT] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [2753] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6666),
    [sym_comment] = ACTIONS(53),
  },
  [2754] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6668),
    [sym_comment] = ACTIONS(53),
  },
  [2755] = {
    [anon_sym_RBRACE] = ACTIONS(6668),
    [sym_comment] = ACTIONS(53),
  },
  [2756] = {
    [sym_concatenation] = STATE(2925),
    [sym_string] = STATE(2924),
    [sym_simple_expansion] = STATE(2924),
    [sym_string_expansion] = STATE(2924),
    [sym_expansion] = STATE(2924),
    [sym_command_substitution] = STATE(2924),
    [sym_process_substitution] = STATE(2924),
    [anon_sym_RBRACE] = ACTIONS(6668),
    [sym__special_characters] = ACTIONS(6670),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(6672),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6672),
  },
  [2757] = {
    [sym__simple_heredoc_body] = ACTIONS(2905),
    [sym__heredoc_body_beginning] = ACTIONS(2905),
    [sym_file_descriptor] = ACTIONS(2905),
    [sym__concat] = ACTIONS(2905),
    [anon_sym_esac] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [anon_sym_PIPE_AMP] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_EQ_EQ] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2907),
    [anon_sym_GT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2905),
    [anon_sym_AMP_GT] = ACTIONS(2907),
    [anon_sym_AMP_GT_GT] = ACTIONS(2905),
    [anon_sym_LT_AMP] = ACTIONS(2905),
    [anon_sym_GT_AMP] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_LT_LT_DASH] = ACTIONS(2905),
    [anon_sym_LT_LT_LT] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [2758] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6674),
  },
  [2759] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6676),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2760] = {
    [sym__simple_heredoc_body] = ACTIONS(2913),
    [sym__heredoc_body_beginning] = ACTIONS(2913),
    [sym_file_descriptor] = ACTIONS(2913),
    [sym__concat] = ACTIONS(2913),
    [anon_sym_esac] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [anon_sym_PIPE_AMP] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_EQ_TILDE] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_AMP_GT] = ACTIONS(2915),
    [anon_sym_AMP_GT_GT] = ACTIONS(2913),
    [anon_sym_LT_AMP] = ACTIONS(2913),
    [anon_sym_GT_AMP] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_LT_LT_DASH] = ACTIONS(2913),
    [anon_sym_LT_LT_LT] = ACTIONS(2913),
    [sym__special_characters] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [2761] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6678),
  },
  [2762] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2763] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6682),
  },
  [2764] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6668),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2765] = {
    [sym_concatenation] = STATE(2932),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2932),
    [anon_sym_RBRACE] = ACTIONS(6684),
    [anon_sym_EQ] = ACTIONS(6686),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6686),
    [anon_sym_COLON_QMARK] = ACTIONS(6686),
    [anon_sym_COLON_DASH] = ACTIONS(6686),
    [anon_sym_PERCENT] = ACTIONS(6686),
    [anon_sym_DASH] = ACTIONS(6686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2766] = {
    [sym__simple_heredoc_body] = ACTIONS(2985),
    [sym__heredoc_body_beginning] = ACTIONS(2985),
    [sym_file_descriptor] = ACTIONS(2985),
    [sym__concat] = ACTIONS(2985),
    [anon_sym_esac] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [anon_sym_PIPE_AMP] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_EQ_TILDE] = ACTIONS(2987),
    [anon_sym_EQ_EQ] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_GT] = ACTIONS(2987),
    [anon_sym_AMP_GT_GT] = ACTIONS(2985),
    [anon_sym_LT_AMP] = ACTIONS(2985),
    [anon_sym_GT_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_LT_LT_DASH] = ACTIONS(2985),
    [anon_sym_LT_LT_LT] = ACTIONS(2985),
    [sym__special_characters] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2987),
  },
  [2767] = {
    [sym_concatenation] = STATE(2934),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2934),
    [anon_sym_RBRACE] = ACTIONS(6690),
    [anon_sym_EQ] = ACTIONS(6692),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6692),
    [anon_sym_COLON_QMARK] = ACTIONS(6692),
    [anon_sym_COLON_DASH] = ACTIONS(6692),
    [anon_sym_PERCENT] = ACTIONS(6692),
    [anon_sym_DASH] = ACTIONS(6692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2768] = {
    [sym__simple_heredoc_body] = ACTIONS(3030),
    [sym__heredoc_body_beginning] = ACTIONS(3030),
    [sym_file_descriptor] = ACTIONS(3030),
    [sym__concat] = ACTIONS(3030),
    [anon_sym_esac] = ACTIONS(3032),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_PIPE_AMP] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_AMP_GT] = ACTIONS(3032),
    [anon_sym_AMP_GT_GT] = ACTIONS(3030),
    [anon_sym_LT_AMP] = ACTIONS(3030),
    [anon_sym_GT_AMP] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_LT_LT_DASH] = ACTIONS(3030),
    [anon_sym_LT_LT_LT] = ACTIONS(3030),
    [sym__special_characters] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
  },
  [2769] = {
    [sym_concatenation] = STATE(2936),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2936),
    [anon_sym_RBRACE] = ACTIONS(6696),
    [anon_sym_EQ] = ACTIONS(6698),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6700),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6698),
    [anon_sym_COLON_QMARK] = ACTIONS(6698),
    [anon_sym_COLON_DASH] = ACTIONS(6698),
    [anon_sym_PERCENT] = ACTIONS(6698),
    [anon_sym_DASH] = ACTIONS(6698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2770] = {
    [sym__simple_heredoc_body] = ACTIONS(3040),
    [sym__heredoc_body_beginning] = ACTIONS(3040),
    [sym_file_descriptor] = ACTIONS(3040),
    [sym__concat] = ACTIONS(3040),
    [anon_sym_esac] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE_AMP] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_AMP_GT] = ACTIONS(3042),
    [anon_sym_AMP_GT_GT] = ACTIONS(3040),
    [anon_sym_LT_AMP] = ACTIONS(3040),
    [anon_sym_GT_AMP] = ACTIONS(3040),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_LT_LT_DASH] = ACTIONS(3040),
    [anon_sym_LT_LT_LT] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
  },
  [2771] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6702),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2772] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(6702),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2773] = {
    [sym__simple_heredoc_body] = ACTIONS(3078),
    [sym__heredoc_body_beginning] = ACTIONS(3078),
    [sym_file_descriptor] = ACTIONS(3078),
    [sym__concat] = ACTIONS(3078),
    [anon_sym_esac] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [anon_sym_EQ_TILDE] = ACTIONS(3080),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3078),
    [anon_sym_AMP_GT] = ACTIONS(3080),
    [anon_sym_AMP_GT_GT] = ACTIONS(3078),
    [anon_sym_LT_AMP] = ACTIONS(3078),
    [anon_sym_GT_AMP] = ACTIONS(3078),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_LT_LT_DASH] = ACTIONS(3078),
    [anon_sym_LT_LT_LT] = ACTIONS(3078),
    [sym__special_characters] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
  },
  [2774] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6704),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2775] = {
    [sym_file_redirect] = STATE(1382),
    [sym_file_descriptor] = ACTIONS(6068),
    [anon_sym_esac] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2375),
    [anon_sym_SEMI_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE_AMP] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(6070),
    [anon_sym_GT] = ACTIONS(6070),
    [anon_sym_GT_GT] = ACTIONS(6072),
    [anon_sym_AMP_GT] = ACTIONS(6070),
    [anon_sym_AMP_GT_GT] = ACTIONS(6072),
    [anon_sym_LT_AMP] = ACTIONS(6072),
    [anon_sym_GT_AMP] = ACTIONS(6072),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2375),
  },
  [2776] = {
    [aux_sym_concatenation_repeat1] = STATE(2779),
    [sym__simple_heredoc_body] = ACTIONS(981),
    [sym__heredoc_body_beginning] = ACTIONS(981),
    [sym_file_descriptor] = ACTIONS(981),
    [sym__concat] = ACTIONS(6330),
    [anon_sym_esac] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(981),
    [anon_sym_LT_AMP] = ACTIONS(981),
    [anon_sym_GT_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(981),
    [anon_sym_LT_LT_LT] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [2777] = {
    [aux_sym_concatenation_repeat1] = STATE(2779),
    [sym__simple_heredoc_body] = ACTIONS(985),
    [sym__heredoc_body_beginning] = ACTIONS(985),
    [sym_file_descriptor] = ACTIONS(985),
    [sym__concat] = ACTIONS(6330),
    [anon_sym_esac] = ACTIONS(985),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_DASH] = ACTIONS(985),
    [anon_sym_LT_LT_LT] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [2778] = {
    [sym_string] = STATE(2939),
    [sym_simple_expansion] = STATE(2939),
    [sym_string_expansion] = STATE(2939),
    [sym_expansion] = STATE(2939),
    [sym_command_substitution] = STATE(2939),
    [sym_process_substitution] = STATE(2939),
    [sym__special_characters] = ACTIONS(6706),
    [anon_sym_DQUOTE] = ACTIONS(5864),
    [anon_sym_DOLLAR] = ACTIONS(5866),
    [sym_raw_string] = ACTIONS(6706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5870),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5872),
    [anon_sym_BQUOTE] = ACTIONS(5874),
    [anon_sym_LT_LPAREN] = ACTIONS(5876),
    [anon_sym_GT_LPAREN] = ACTIONS(5876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6706),
  },
  [2779] = {
    [aux_sym_concatenation_repeat1] = STATE(2940),
    [sym__simple_heredoc_body] = ACTIONS(695),
    [sym__heredoc_body_beginning] = ACTIONS(695),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(6330),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [2780] = {
    [sym__simple_heredoc_body] = ACTIONS(699),
    [sym__heredoc_body_beginning] = ACTIONS(699),
    [sym_file_descriptor] = ACTIONS(699),
    [sym__concat] = ACTIONS(699),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(701),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_LT_LT_DASH] = ACTIONS(699),
    [anon_sym_LT_LT_LT] = ACTIONS(699),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
  },
  [2781] = {
    [anon_sym_DQUOTE] = ACTIONS(6708),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [2782] = {
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(6708),
    [anon_sym_DOLLAR] = ACTIONS(6710),
    [sym__string_content] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [sym_comment] = ACTIONS(243),
  },
  [2783] = {
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2784] = {
    [sym__simple_heredoc_body] = ACTIONS(735),
    [sym__heredoc_body_beginning] = ACTIONS(735),
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(735),
    [anon_sym_LT_LT_LT] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2785] = {
    [sym__simple_heredoc_body] = ACTIONS(739),
    [sym__heredoc_body_beginning] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(739),
    [sym__concat] = ACTIONS(739),
    [anon_sym_esac] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_LT_LT_DASH] = ACTIONS(739),
    [anon_sym_LT_LT_LT] = ACTIONS(739),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [2786] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(6712),
    [sym_comment] = ACTIONS(53),
  },
  [2787] = {
    [sym_subscript] = STATE(2947),
    [sym_variable_name] = ACTIONS(6714),
    [anon_sym_DOLLAR] = ACTIONS(6716),
    [anon_sym_DASH] = ACTIONS(6716),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6718),
    [anon_sym_STAR] = ACTIONS(6716),
    [anon_sym_AT] = ACTIONS(6716),
    [anon_sym_QMARK] = ACTIONS(6716),
    [anon_sym_0] = ACTIONS(6720),
    [anon_sym__] = ACTIONS(6720),
  },
  [2788] = {
    [sym_concatenation] = STATE(2950),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2950),
    [anon_sym_RBRACE] = ACTIONS(6722),
    [anon_sym_EQ] = ACTIONS(6724),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6728),
    [anon_sym_COLON] = ACTIONS(6724),
    [anon_sym_COLON_QMARK] = ACTIONS(6724),
    [anon_sym_COLON_DASH] = ACTIONS(6724),
    [anon_sym_PERCENT] = ACTIONS(6724),
    [anon_sym_DASH] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2789] = {
    [sym_concatenation] = STATE(2953),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2953),
    [anon_sym_RBRACE] = ACTIONS(6730),
    [anon_sym_EQ] = ACTIONS(6732),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6736),
    [anon_sym_COLON] = ACTIONS(6732),
    [anon_sym_COLON_QMARK] = ACTIONS(6732),
    [anon_sym_COLON_DASH] = ACTIONS(6732),
    [anon_sym_PERCENT] = ACTIONS(6732),
    [anon_sym_DASH] = ACTIONS(6732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2790] = {
    [sym_concatenation] = STATE(2956),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2956),
    [anon_sym_RBRACE] = ACTIONS(6738),
    [anon_sym_EQ] = ACTIONS(6740),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6742),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6744),
    [anon_sym_COLON] = ACTIONS(6740),
    [anon_sym_COLON_QMARK] = ACTIONS(6740),
    [anon_sym_COLON_DASH] = ACTIONS(6740),
    [anon_sym_PERCENT] = ACTIONS(6740),
    [anon_sym_DASH] = ACTIONS(6740),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2791] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6746),
    [anon_sym_SEMI_SEMI] = ACTIONS(6748),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6750),
    [anon_sym_LF] = ACTIONS(6748),
    [anon_sym_AMP] = ACTIONS(6750),
  },
  [2792] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6746),
    [anon_sym_SEMI_SEMI] = ACTIONS(6748),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6750),
    [anon_sym_LF] = ACTIONS(6748),
    [anon_sym_AMP] = ACTIONS(6750),
  },
  [2793] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2959),
    [sym_c_style_for_statement] = STATE(2959),
    [sym_while_statement] = STATE(2959),
    [sym_if_statement] = STATE(2959),
    [sym_case_statement] = STATE(2959),
    [sym_function_definition] = STATE(2959),
    [sym_subshell] = STATE(2959),
    [sym_pipeline] = STATE(2959),
    [sym_list] = STATE(2959),
    [sym_negated_command] = STATE(2959),
    [sym_test_command] = STATE(2959),
    [sym_declaration_command] = STATE(2959),
    [sym_unset_command] = STATE(2959),
    [sym_command] = STATE(2959),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2960),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2794] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6752),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(6746),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6754),
    [anon_sym_LF] = ACTIONS(6752),
    [anon_sym_AMP] = ACTIONS(6754),
  },
  [2795] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6752),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(6746),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6754),
    [anon_sym_LF] = ACTIONS(6752),
    [anon_sym_AMP] = ACTIONS(6754),
  },
  [2796] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2962),
    [sym_c_style_for_statement] = STATE(2962),
    [sym_while_statement] = STATE(2962),
    [sym_if_statement] = STATE(2962),
    [sym_case_statement] = STATE(2962),
    [sym_function_definition] = STATE(2962),
    [sym_subshell] = STATE(2962),
    [sym_pipeline] = STATE(2962),
    [sym_list] = STATE(2962),
    [sym_negated_command] = STATE(2962),
    [sym_test_command] = STATE(2962),
    [sym_declaration_command] = STATE(2962),
    [sym_unset_command] = STATE(2962),
    [sym_command] = STATE(2962),
    [sym_command_name] = STATE(155),
    [sym_variable_assignment] = STATE(2963),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(281),
  },
  [2797] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6756),
    [anon_sym_SEMI_SEMI] = ACTIONS(6758),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6760),
    [anon_sym_LF] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(6760),
  },
  [2798] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6756),
    [anon_sym_SEMI_SEMI] = ACTIONS(6758),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6760),
    [anon_sym_LF] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(6760),
  },
  [2799] = {
    [sym__terminated_statement] = STATE(273),
    [sym_for_statement] = STATE(2966),
    [sym_c_style_for_statement] = STATE(2966),
    [sym_while_statement] = STATE(2966),
    [sym_if_statement] = STATE(2966),
    [sym_case_statement] = STATE(2966),
    [sym_function_definition] = STATE(2966),
    [sym_subshell] = STATE(2966),
    [sym_pipeline] = STATE(2966),
    [sym_list] = STATE(2966),
    [sym_negated_command] = STATE(2966),
    [sym_test_command] = STATE(2966),
    [sym_declaration_command] = STATE(2966),
    [sym_unset_command] = STATE(2966),
    [sym_command] = STATE(2966),
    [sym_command_name] = STATE(65),
    [sym_variable_assignment] = STATE(2967),
    [sym_subscript] = STATE(67),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_string_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_program_repeat1] = STATE(273),
    [aux_sym_command_repeat1] = STATE(69),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_typeset] = ACTIONS(99),
    [anon_sym_export] = ACTIONS(99),
    [anon_sym_readonly] = ACTIONS(99),
    [anon_sym_local] = ACTIONS(99),
    [anon_sym_unset] = ACTIONS(101),
    [anon_sym_unsetenv] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [2800] = {
    [sym_file_redirect] = STATE(2581),
    [sym_heredoc_redirect] = STATE(2581),
    [sym_heredoc_body] = STATE(1398),
    [sym_herestring_redirect] = STATE(2581),
    [aux_sym_while_statement_repeat1] = STATE(2581),
    [sym__simple_heredoc_body] = ACTIONS(297),
    [sym__heredoc_body_beginning] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(5326),
    [anon_sym_esac] = ACTIONS(3133),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_SEMI_SEMI] = ACTIONS(3133),
    [anon_sym_PIPE_AMP] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3133),
    [anon_sym_PIPE_PIPE] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(5330),
    [anon_sym_GT] = ACTIONS(5330),
    [anon_sym_GT_GT] = ACTIONS(5332),
    [anon_sym_AMP_GT] = ACTIONS(5330),
    [anon_sym_AMP_GT_GT] = ACTIONS(5332),
    [anon_sym_LT_AMP] = ACTIONS(5332),
    [anon_sym_GT_AMP] = ACTIONS(5332),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(5334),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_LF] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
  },
  [2801] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_esac] = ACTIONS(6762),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(6764),
    [anon_sym_DQUOTE] = ACTIONS(6766),
    [anon_sym_DOLLAR] = ACTIONS(6764),
    [sym_raw_string] = ACTIONS(6766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6766),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6766),
    [anon_sym_BQUOTE] = ACTIONS(6766),
    [anon_sym_LT_LPAREN] = ACTIONS(6766),
    [anon_sym_GT_LPAREN] = ACTIONS(6766),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6764),
  },
  [2802] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_esac] = ACTIONS(6768),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(6770),
    [anon_sym_DQUOTE] = ACTIONS(6772),
    [anon_sym_DOLLAR] = ACTIONS(6770),
    [sym_raw_string] = ACTIONS(6772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6772),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6772),
    [anon_sym_BQUOTE] = ACTIONS(6772),
    [anon_sym_LT_LPAREN] = ACTIONS(6772),
    [anon_sym_GT_LPAREN] = ACTIONS(6772),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6770),
  },
  [2803] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(5838),
    [anon_sym_DQUOTE] = ACTIONS(5840),
    [anon_sym_DOLLAR] = ACTIONS(5838),
    [sym_raw_string] = ACTIONS(5840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5840),
    [anon_sym_BQUOTE] = ACTIONS(5840),
    [anon_sym_LT_LPAREN] = ACTIONS(5840),
    [anon_sym_GT_LPAREN] = ACTIONS(5840),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5838),
  },
  [2804] = {
    [sym__special_characters] = ACTIONS(5840),
    [anon_sym_DQUOTE] = ACTIONS(5840),
    [anon_sym_DOLLAR] = ACTIONS(5838),
    [sym_raw_string] = ACTIONS(5840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5840),
    [anon_sym_BQUOTE] = ACTIONS(5840),
    [anon_sym_LT_LPAREN] = ACTIONS(5840),
    [anon_sym_GT_LPAREN] = ACTIONS(5840),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5840),
  },
  [2805] = {
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(6774),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2806] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(6774),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2807] = {
    [sym__terminated_statement] = STATE(2807),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2807),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(891),
    [sym_variable_name] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(908),
    [anon_sym_SEMI_SEMI] = ACTIONS(897),
    [anon_sym_function] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(923),
    [anon_sym_declare] = ACTIONS(926),
    [anon_sym_typeset] = ACTIONS(926),
    [anon_sym_export] = ACTIONS(926),
    [anon_sym_readonly] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym_unset] = ACTIONS(929),
    [anon_sym_unsetenv] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [sym_raw_string] = ACTIONS(947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [anon_sym_LT_LPAREN] = ACTIONS(959),
    [anon_sym_GT_LPAREN] = ACTIONS(959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(962),
  },
  [2808] = {
    [sym__terminated_statement] = STATE(2807),
    [sym_for_statement] = STATE(2970),
    [sym_c_style_for_statement] = STATE(2970),
    [sym_while_statement] = STATE(2970),
    [sym_if_statement] = STATE(2970),
    [sym_case_statement] = STATE(2970),
    [sym_function_definition] = STATE(2970),
    [sym_subshell] = STATE(2970),
    [sym_pipeline] = STATE(2970),
    [sym_list] = STATE(2970),
    [sym_negated_command] = STATE(2970),
    [sym_test_command] = STATE(2970),
    [sym_declaration_command] = STATE(2970),
    [sym_unset_command] = STATE(2970),
    [sym_command] = STATE(2970),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2971),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2807),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6776),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2809] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(5890),
    [anon_sym_DQUOTE] = ACTIONS(5892),
    [anon_sym_DOLLAR] = ACTIONS(5890),
    [sym_raw_string] = ACTIONS(5892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5892),
    [anon_sym_BQUOTE] = ACTIONS(5892),
    [anon_sym_LT_LPAREN] = ACTIONS(5892),
    [anon_sym_GT_LPAREN] = ACTIONS(5892),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5890),
  },
  [2810] = {
    [sym__special_characters] = ACTIONS(5892),
    [anon_sym_DQUOTE] = ACTIONS(5892),
    [anon_sym_DOLLAR] = ACTIONS(5890),
    [sym_raw_string] = ACTIONS(5892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5892),
    [anon_sym_BQUOTE] = ACTIONS(5892),
    [anon_sym_LT_LPAREN] = ACTIONS(5892),
    [anon_sym_GT_LPAREN] = ACTIONS(5892),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5892),
  },
  [2811] = {
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(6778),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2812] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(6778),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2813] = {
    [sym__terminated_statement] = STATE(2807),
    [sym_for_statement] = STATE(2974),
    [sym_c_style_for_statement] = STATE(2974),
    [sym_while_statement] = STATE(2974),
    [sym_if_statement] = STATE(2974),
    [sym_case_statement] = STATE(2974),
    [sym_function_definition] = STATE(2974),
    [sym_subshell] = STATE(2974),
    [sym_pipeline] = STATE(2974),
    [sym_list] = STATE(2974),
    [sym_negated_command] = STATE(2974),
    [sym_test_command] = STATE(2974),
    [sym_declaration_command] = STATE(2974),
    [sym_unset_command] = STATE(2974),
    [sym_command] = STATE(2974),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2975),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2807),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6780),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2814] = {
    [sym_file_descriptor] = ACTIONS(4885),
    [sym__concat] = ACTIONS(4885),
    [anon_sym_esac] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [anon_sym_PIPE_AMP] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_GT_GT] = ACTIONS(4885),
    [anon_sym_AMP_GT] = ACTIONS(4887),
    [anon_sym_AMP_GT_GT] = ACTIONS(4885),
    [anon_sym_LT_AMP] = ACTIONS(4885),
    [anon_sym_GT_AMP] = ACTIONS(4885),
    [anon_sym_LT_LT] = ACTIONS(4887),
    [anon_sym_LT_LT_DASH] = ACTIONS(4885),
    [anon_sym_LT_LT_LT] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4887),
  },
  [2815] = {
    [sym_file_descriptor] = ACTIONS(4889),
    [sym__concat] = ACTIONS(4889),
    [anon_sym_esac] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [anon_sym_PIPE_AMP] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_LT] = ACTIONS(4891),
    [anon_sym_GT] = ACTIONS(4891),
    [anon_sym_GT_GT] = ACTIONS(4889),
    [anon_sym_AMP_GT] = ACTIONS(4891),
    [anon_sym_AMP_GT_GT] = ACTIONS(4889),
    [anon_sym_LT_AMP] = ACTIONS(4889),
    [anon_sym_GT_AMP] = ACTIONS(4889),
    [anon_sym_LT_LT] = ACTIONS(4891),
    [anon_sym_LT_LT_DASH] = ACTIONS(4889),
    [anon_sym_LT_LT_LT] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4891),
  },
  [2816] = {
    [sym_file_descriptor] = ACTIONS(4893),
    [sym__concat] = ACTIONS(4893),
    [anon_sym_esac] = ACTIONS(4893),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [anon_sym_LT] = ACTIONS(4895),
    [anon_sym_GT] = ACTIONS(4895),
    [anon_sym_GT_GT] = ACTIONS(4893),
    [anon_sym_AMP_GT] = ACTIONS(4895),
    [anon_sym_AMP_GT_GT] = ACTIONS(4893),
    [anon_sym_LT_AMP] = ACTIONS(4893),
    [anon_sym_GT_AMP] = ACTIONS(4893),
    [anon_sym_LT_LT] = ACTIONS(4895),
    [anon_sym_LT_LT_DASH] = ACTIONS(4893),
    [anon_sym_LT_LT_LT] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2817] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6782),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2818] = {
    [sym_file_descriptor] = ACTIONS(4899),
    [sym__concat] = ACTIONS(4899),
    [anon_sym_esac] = ACTIONS(4899),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_RPAREN] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [anon_sym_PIPE_AMP] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [anon_sym_LT] = ACTIONS(4901),
    [anon_sym_GT] = ACTIONS(4901),
    [anon_sym_GT_GT] = ACTIONS(4899),
    [anon_sym_AMP_GT] = ACTIONS(4901),
    [anon_sym_AMP_GT_GT] = ACTIONS(4899),
    [anon_sym_LT_AMP] = ACTIONS(4899),
    [anon_sym_GT_AMP] = ACTIONS(4899),
    [anon_sym_LT_LT] = ACTIONS(4901),
    [anon_sym_LT_LT_DASH] = ACTIONS(4899),
    [anon_sym_LT_LT_LT] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4901),
  },
  [2819] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6784),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2820] = {
    [sym_file_descriptor] = ACTIONS(4905),
    [sym__concat] = ACTIONS(4905),
    [anon_sym_esac] = ACTIONS(4905),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [anon_sym_PIPE_AMP] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_LT] = ACTIONS(4907),
    [anon_sym_GT] = ACTIONS(4907),
    [anon_sym_GT_GT] = ACTIONS(4905),
    [anon_sym_AMP_GT] = ACTIONS(4907),
    [anon_sym_AMP_GT_GT] = ACTIONS(4905),
    [anon_sym_LT_AMP] = ACTIONS(4905),
    [anon_sym_GT_AMP] = ACTIONS(4905),
    [anon_sym_LT_LT] = ACTIONS(4907),
    [anon_sym_LT_LT_DASH] = ACTIONS(4905),
    [anon_sym_LT_LT_LT] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4907),
  },
  [2821] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6786),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2822] = {
    [sym_file_descriptor] = ACTIONS(4947),
    [sym__concat] = ACTIONS(4947),
    [anon_sym_esac] = ACTIONS(4947),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_LT] = ACTIONS(4949),
    [anon_sym_GT] = ACTIONS(4949),
    [anon_sym_GT_GT] = ACTIONS(4947),
    [anon_sym_AMP_GT] = ACTIONS(4949),
    [anon_sym_AMP_GT_GT] = ACTIONS(4947),
    [anon_sym_LT_AMP] = ACTIONS(4947),
    [anon_sym_GT_AMP] = ACTIONS(4947),
    [anon_sym_LT_LT] = ACTIONS(4949),
    [anon_sym_LT_LT_DASH] = ACTIONS(4947),
    [anon_sym_LT_LT_LT] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4949),
  },
  [2823] = {
    [sym_file_descriptor] = ACTIONS(4955),
    [sym__concat] = ACTIONS(4955),
    [anon_sym_esac] = ACTIONS(4955),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [anon_sym_PIPE_AMP] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4957),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym_AMP_GT] = ACTIONS(4957),
    [anon_sym_AMP_GT_GT] = ACTIONS(4955),
    [anon_sym_LT_AMP] = ACTIONS(4955),
    [anon_sym_GT_AMP] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4957),
    [anon_sym_LT_LT_DASH] = ACTIONS(4955),
    [anon_sym_LT_LT_LT] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4957),
  },
  [2824] = {
    [sym_file_descriptor] = ACTIONS(4959),
    [sym__concat] = ACTIONS(4959),
    [anon_sym_esac] = ACTIONS(4959),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4959),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [anon_sym_PIPE_AMP] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym_AMP_GT] = ACTIONS(4961),
    [anon_sym_AMP_GT_GT] = ACTIONS(4959),
    [anon_sym_LT_AMP] = ACTIONS(4959),
    [anon_sym_GT_AMP] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4961),
    [anon_sym_LT_LT_DASH] = ACTIONS(4959),
    [anon_sym_LT_LT_LT] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4961),
  },
  [2825] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_RBRACE] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
  },
  [2826] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_RBRACE] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
  },
  [2827] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_RBRACE] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
  },
  [2828] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_EQ_TILDE] = ACTIONS(5524),
    [anon_sym_EQ_EQ] = ACTIONS(5524),
    [anon_sym_EQ] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_BANG_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5524),
  },
  [2829] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_EQ_TILDE] = ACTIONS(5528),
    [anon_sym_EQ_EQ] = ACTIONS(5528),
    [anon_sym_EQ] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_BANG_EQ] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5528),
  },
  [2830] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_EQ_TILDE] = ACTIONS(5532),
    [anon_sym_EQ_EQ] = ACTIONS(5532),
    [anon_sym_EQ] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5532),
    [anon_sym_GT] = ACTIONS(5532),
    [anon_sym_BANG_EQ] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5532),
  },
  [2831] = {
    [sym_file_descriptor] = ACTIONS(3201),
    [sym_variable_name] = ACTIONS(3201),
    [anon_sym_esac] = ACTIONS(3203),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_SEMI_SEMI] = ACTIONS(3201),
    [anon_sym_PIPE_AMP] = ACTIONS(3201),
    [anon_sym_AMP_AMP] = ACTIONS(3201),
    [anon_sym_PIPE_PIPE] = ACTIONS(3201),
    [anon_sym_LT] = ACTIONS(3203),
    [anon_sym_GT] = ACTIONS(3203),
    [anon_sym_GT_GT] = ACTIONS(3201),
    [anon_sym_AMP_GT] = ACTIONS(3203),
    [anon_sym_AMP_GT_GT] = ACTIONS(3201),
    [anon_sym_LT_AMP] = ACTIONS(3201),
    [anon_sym_GT_AMP] = ACTIONS(3201),
    [sym__special_characters] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3201),
    [anon_sym_DOLLAR] = ACTIONS(3203),
    [sym_raw_string] = ACTIONS(3201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3201),
    [anon_sym_BQUOTE] = ACTIONS(3201),
    [anon_sym_LT_LPAREN] = ACTIONS(3201),
    [anon_sym_GT_LPAREN] = ACTIONS(3201),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3203),
    [anon_sym_LF] = ACTIONS(3201),
    [anon_sym_AMP] = ACTIONS(3203),
  },
  [2832] = {
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1664),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_esac] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2833] = {
    [aux_sym_concatenation_repeat1] = STATE(2833),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(6788),
    [sym_variable_name] = ACTIONS(1664),
    [anon_sym_esac] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [sym__special_characters] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1664),
    [anon_sym_GT_LPAREN] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2834] = {
    [sym_file_descriptor] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1671),
    [sym_variable_name] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1673),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1673),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1673),
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1673),
  },
  [2835] = {
    [anon_sym_DQUOTE] = ACTIONS(6791),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [2836] = {
    [sym_concatenation] = STATE(2983),
    [sym_string] = STATE(2982),
    [sym_simple_expansion] = STATE(2982),
    [sym_string_expansion] = STATE(2982),
    [sym_expansion] = STATE(2982),
    [sym_command_substitution] = STATE(2982),
    [sym_process_substitution] = STATE(2982),
    [anon_sym_RBRACE] = ACTIONS(6793),
    [sym__special_characters] = ACTIONS(6795),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(6797),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6797),
  },
  [2837] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(6799),
    [sym_comment] = ACTIONS(53),
  },
  [2838] = {
    [sym_concatenation] = STATE(2987),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2987),
    [anon_sym_RBRACE] = ACTIONS(6801),
    [anon_sym_EQ] = ACTIONS(6803),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6805),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6807),
    [anon_sym_COLON] = ACTIONS(6803),
    [anon_sym_COLON_QMARK] = ACTIONS(6803),
    [anon_sym_COLON_DASH] = ACTIONS(6803),
    [anon_sym_PERCENT] = ACTIONS(6803),
    [anon_sym_DASH] = ACTIONS(6803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2839] = {
    [sym_concatenation] = STATE(2990),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2990),
    [anon_sym_RBRACE] = ACTIONS(6809),
    [anon_sym_EQ] = ACTIONS(6811),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6813),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6815),
    [anon_sym_COLON] = ACTIONS(6811),
    [anon_sym_COLON_QMARK] = ACTIONS(6811),
    [anon_sym_COLON_DASH] = ACTIONS(6811),
    [anon_sym_PERCENT] = ACTIONS(6811),
    [anon_sym_DASH] = ACTIONS(6811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2840] = {
    [sym_concatenation] = STATE(2992),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(2992),
    [anon_sym_RBRACE] = ACTIONS(6793),
    [anon_sym_EQ] = ACTIONS(6817),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6819),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6821),
    [anon_sym_COLON] = ACTIONS(6817),
    [anon_sym_COLON_QMARK] = ACTIONS(6817),
    [anon_sym_COLON_DASH] = ACTIONS(6817),
    [anon_sym_PERCENT] = ACTIONS(6817),
    [anon_sym_DASH] = ACTIONS(6817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2841] = {
    [sym_file_descriptor] = ACTIONS(1788),
    [sym__concat] = ACTIONS(1788),
    [sym_variable_name] = ACTIONS(1788),
    [anon_sym_esac] = ACTIONS(1790),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [anon_sym_PIPE_AMP] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [anon_sym_LT] = ACTIONS(1790),
    [anon_sym_GT] = ACTIONS(1790),
    [anon_sym_GT_GT] = ACTIONS(1788),
    [anon_sym_AMP_GT] = ACTIONS(1790),
    [anon_sym_AMP_GT_GT] = ACTIONS(1788),
    [anon_sym_LT_AMP] = ACTIONS(1788),
    [anon_sym_GT_AMP] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_DOLLAR] = ACTIONS(1790),
    [sym_raw_string] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [anon_sym_LT_LPAREN] = ACTIONS(1788),
    [anon_sym_GT_LPAREN] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1790),
  },
  [2842] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6823),
  },
  [2843] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6825),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2844] = {
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [sym_variable_name] = ACTIONS(1832),
    [anon_sym_esac] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [2845] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6827),
  },
  [2846] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6829),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2847] = {
    [sym_file_descriptor] = ACTIONS(1840),
    [sym__concat] = ACTIONS(1840),
    [sym_variable_name] = ACTIONS(1840),
    [anon_sym_esac] = ACTIONS(1842),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [anon_sym_PIPE_AMP] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_GT] = ACTIONS(1842),
    [anon_sym_GT_GT] = ACTIONS(1840),
    [anon_sym_AMP_GT] = ACTIONS(1842),
    [anon_sym_AMP_GT_GT] = ACTIONS(1840),
    [anon_sym_LT_AMP] = ACTIONS(1840),
    [anon_sym_GT_AMP] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [2848] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6831),
  },
  [2849] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6793),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2850] = {
    [sym_file_descriptor] = ACTIONS(1846),
    [sym__concat] = ACTIONS(1846),
    [sym_variable_name] = ACTIONS(1846),
    [anon_sym_esac] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT] = ACTIONS(1848),
    [anon_sym_AMP_GT_GT] = ACTIONS(1846),
    [anon_sym_LT_AMP] = ACTIONS(1846),
    [anon_sym_GT_AMP] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1846),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [anon_sym_LT_LPAREN] = ACTIONS(1846),
    [anon_sym_GT_LPAREN] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1848),
  },
  [2851] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2852] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6833),
    [anon_sym_SEMI_SEMI] = ACTIONS(6835),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6837),
    [anon_sym_LF] = ACTIONS(6835),
    [anon_sym_AMP] = ACTIONS(6837),
  },
  [2853] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6833),
    [anon_sym_SEMI_SEMI] = ACTIONS(6835),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6837),
    [anon_sym_LF] = ACTIONS(6835),
    [anon_sym_AMP] = ACTIONS(6837),
  },
  [2854] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(6833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2855] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6839),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(6833),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6841),
    [anon_sym_LF] = ACTIONS(6839),
    [anon_sym_AMP] = ACTIONS(6841),
  },
  [2856] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(6839),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(6833),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6841),
    [anon_sym_LF] = ACTIONS(6839),
    [anon_sym_AMP] = ACTIONS(6841),
  },
  [2857] = {
    [sym_file_descriptor] = ACTIONS(1878),
    [sym__concat] = ACTIONS(1878),
    [sym_variable_name] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1880),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1880),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT] = ACTIONS(1880),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_LT_LPAREN] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1880),
  },
  [2858] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6843),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2859] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6843),
    [anon_sym_SEMI_SEMI] = ACTIONS(6845),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(6847),
    [anon_sym_LF] = ACTIONS(6845),
    [anon_sym_AMP] = ACTIONS(6847),
  },
  [2860] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(6843),
    [anon_sym_SEMI_SEMI] = ACTIONS(6845),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(6847),
    [anon_sym_LF] = ACTIONS(6845),
    [anon_sym_AMP] = ACTIONS(6847),
  },
  [2861] = {
    [sym_file_redirect] = STATE(1577),
    [sym_file_descriptor] = ACTIONS(6068),
    [anon_sym_esac] = ACTIONS(3567),
    [anon_sym_PIPE] = ACTIONS(3565),
    [anon_sym_SEMI_SEMI] = ACTIONS(3567),
    [anon_sym_PIPE_AMP] = ACTIONS(3567),
    [anon_sym_AMP_AMP] = ACTIONS(3567),
    [anon_sym_PIPE_PIPE] = ACTIONS(3567),
    [anon_sym_LT] = ACTIONS(6070),
    [anon_sym_GT] = ACTIONS(6070),
    [anon_sym_GT_GT] = ACTIONS(6072),
    [anon_sym_AMP_GT] = ACTIONS(6070),
    [anon_sym_AMP_GT_GT] = ACTIONS(6072),
    [anon_sym_LT_AMP] = ACTIONS(6072),
    [anon_sym_GT_AMP] = ACTIONS(6072),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3565),
    [anon_sym_LF] = ACTIONS(3567),
    [anon_sym_AMP] = ACTIONS(3565),
  },
  [2862] = {
    [sym_concatenation] = STATE(1580),
    [sym_string] = STATE(3004),
    [sym_simple_expansion] = STATE(3004),
    [sym_string_expansion] = STATE(3004),
    [sym_expansion] = STATE(3004),
    [sym_command_substitution] = STATE(3004),
    [sym_process_substitution] = STATE(3004),
    [sym__special_characters] = ACTIONS(6849),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(6851),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6851),
  },
  [2863] = {
    [aux_sym_concatenation_repeat1] = STATE(3005),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(661),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [2864] = {
    [aux_sym_concatenation_repeat1] = STATE(3005),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [2865] = {
    [sym_concatenation] = STATE(1615),
    [sym_string] = STATE(3007),
    [sym_simple_expansion] = STATE(3007),
    [sym_string_expansion] = STATE(3007),
    [sym_expansion] = STATE(3007),
    [sym_command_substitution] = STATE(3007),
    [sym_process_substitution] = STATE(3007),
    [sym__special_characters] = ACTIONS(6853),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [sym_raw_string] = ACTIONS(6855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2539),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6855),
  },
  [2866] = {
    [aux_sym_concatenation_repeat1] = STATE(3008),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_esac] = ACTIONS(661),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [2867] = {
    [aux_sym_concatenation_repeat1] = STATE(3008),
    [sym_file_descriptor] = ACTIONS(679),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [2868] = {
    [aux_sym_concatenation_repeat1] = STATE(3008),
    [sym_file_descriptor] = ACTIONS(1936),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_esac] = ACTIONS(1936),
    [anon_sym_PIPE] = ACTIONS(1938),
    [anon_sym_SEMI_SEMI] = ACTIONS(1936),
    [anon_sym_PIPE_AMP] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1938),
    [anon_sym_GT] = ACTIONS(1938),
    [anon_sym_GT_GT] = ACTIONS(1936),
    [anon_sym_AMP_GT] = ACTIONS(1938),
    [anon_sym_AMP_GT_GT] = ACTIONS(1936),
    [anon_sym_LT_AMP] = ACTIONS(1936),
    [anon_sym_GT_AMP] = ACTIONS(1936),
    [anon_sym_LT_LT] = ACTIONS(1938),
    [anon_sym_LT_LT_DASH] = ACTIONS(1936),
    [anon_sym_LT_LT_LT] = ACTIONS(1936),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_LF] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1938),
  },
  [2869] = {
    [aux_sym_concatenation_repeat1] = STATE(3008),
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_esac] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [2870] = {
    [sym_file_redirect] = STATE(2870),
    [sym_heredoc_redirect] = STATE(2870),
    [sym_herestring_redirect] = STATE(2870),
    [aux_sym_while_statement_repeat1] = STATE(2870),
    [sym_file_descriptor] = ACTIONS(6857),
    [anon_sym_esac] = ACTIONS(1948),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_SEMI_SEMI] = ACTIONS(1948),
    [anon_sym_PIPE_AMP] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_PIPE_PIPE] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(6860),
    [anon_sym_GT] = ACTIONS(6860),
    [anon_sym_GT_GT] = ACTIONS(6863),
    [anon_sym_AMP_GT] = ACTIONS(6860),
    [anon_sym_AMP_GT_GT] = ACTIONS(6863),
    [anon_sym_LT_AMP] = ACTIONS(6863),
    [anon_sym_GT_AMP] = ACTIONS(6863),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_LT_LT_DASH] = ACTIONS(3683),
    [anon_sym_LT_LT_LT] = ACTIONS(6866),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_LF] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1953),
  },
  [2871] = {
    [sym_variable_name] = ACTIONS(2014),
    [anon_sym_esac] = ACTIONS(2016),
    [anon_sym_PIPE] = ACTIONS(2016),
    [anon_sym_SEMI_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE_AMP] = ACTIONS(2014),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_PIPE_PIPE] = ACTIONS(2014),
    [sym__special_characters] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_DOLLAR] = ACTIONS(2016),
    [sym_raw_string] = ACTIONS(2014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2014),
    [anon_sym_BQUOTE] = ACTIONS(2014),
    [anon_sym_LT_LPAREN] = ACTIONS(2014),
    [anon_sym_GT_LPAREN] = ACTIONS(2014),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2016),
    [sym_word] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2016),
    [anon_sym_LF] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2016),
  },
  [2872] = {
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_string_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [aux_sym_for_statement_repeat1] = STATE(960),
    [anon_sym_RPAREN] = ACTIONS(6869),
    [sym__special_characters] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [sym_raw_string] = ACTIONS(1011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1019),
    [anon_sym_GT_LPAREN] = ACTIONS(1019),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1011),
  },
  [2873] = {
    [sym__concat] = ACTIONS(2855),
    [sym_variable_name] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [2874] = {
    [sym__concat] = ACTIONS(2869),
    [sym_variable_name] = ACTIONS(2869),
    [anon_sym_esac] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [anon_sym_PIPE_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2871),
    [sym_word] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [2875] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6871),
    [sym_comment] = ACTIONS(53),
  },
  [2876] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6873),
    [sym_comment] = ACTIONS(53),
  },
  [2877] = {
    [anon_sym_RBRACE] = ACTIONS(6873),
    [sym_comment] = ACTIONS(53),
  },
  [2878] = {
    [sym_concatenation] = STATE(3014),
    [sym_string] = STATE(3013),
    [sym_simple_expansion] = STATE(3013),
    [sym_string_expansion] = STATE(3013),
    [sym_expansion] = STATE(3013),
    [sym_command_substitution] = STATE(3013),
    [sym_process_substitution] = STATE(3013),
    [anon_sym_RBRACE] = ACTIONS(6873),
    [sym__special_characters] = ACTIONS(6875),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(6877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6877),
  },
  [2879] = {
    [sym__concat] = ACTIONS(2905),
    [sym_variable_name] = ACTIONS(2905),
    [anon_sym_esac] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [anon_sym_PIPE_AMP] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2907),
    [sym_word] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [2880] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6879),
  },
  [2881] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6881),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2882] = {
    [sym__concat] = ACTIONS(2913),
    [sym_variable_name] = ACTIONS(2913),
    [anon_sym_esac] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [anon_sym_PIPE_AMP] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [sym__special_characters] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2915),
    [sym_word] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [2883] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6883),
  },
  [2884] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6885),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2885] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6887),
  },
  [2886] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6873),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2887] = {
    [sym_concatenation] = STATE(3021),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3021),
    [anon_sym_RBRACE] = ACTIONS(6889),
    [anon_sym_EQ] = ACTIONS(6891),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6891),
    [anon_sym_COLON_QMARK] = ACTIONS(6891),
    [anon_sym_COLON_DASH] = ACTIONS(6891),
    [anon_sym_PERCENT] = ACTIONS(6891),
    [anon_sym_DASH] = ACTIONS(6891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2888] = {
    [sym__concat] = ACTIONS(2985),
    [sym_variable_name] = ACTIONS(2985),
    [anon_sym_esac] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [anon_sym_PIPE_AMP] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [sym__special_characters] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2987),
    [sym_word] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2987),
  },
  [2889] = {
    [sym_concatenation] = STATE(3023),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3023),
    [anon_sym_RBRACE] = ACTIONS(6895),
    [anon_sym_EQ] = ACTIONS(6897),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6897),
    [anon_sym_COLON_QMARK] = ACTIONS(6897),
    [anon_sym_COLON_DASH] = ACTIONS(6897),
    [anon_sym_PERCENT] = ACTIONS(6897),
    [anon_sym_DASH] = ACTIONS(6897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2890] = {
    [sym__concat] = ACTIONS(3030),
    [sym_variable_name] = ACTIONS(3030),
    [anon_sym_esac] = ACTIONS(3032),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_PIPE_AMP] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [sym__special_characters] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3032),
    [sym_word] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
  },
  [2891] = {
    [sym_concatenation] = STATE(3025),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3025),
    [anon_sym_RBRACE] = ACTIONS(6901),
    [anon_sym_EQ] = ACTIONS(6903),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6903),
    [anon_sym_COLON_QMARK] = ACTIONS(6903),
    [anon_sym_COLON_DASH] = ACTIONS(6903),
    [anon_sym_PERCENT] = ACTIONS(6903),
    [anon_sym_DASH] = ACTIONS(6903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2892] = {
    [sym__concat] = ACTIONS(3040),
    [sym_variable_name] = ACTIONS(3040),
    [anon_sym_esac] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE_AMP] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3042),
    [sym_word] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
  },
  [2893] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6907),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2894] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(6907),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2895] = {
    [sym__concat] = ACTIONS(3078),
    [sym_variable_name] = ACTIONS(3078),
    [anon_sym_esac] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [sym__special_characters] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3080),
    [sym_word] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
  },
  [2896] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2897] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [2898] = {
    [sym__concat] = ACTIONS(2869),
    [anon_sym_esac] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [anon_sym_PIPE_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2871),
    [sym_word] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [2899] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6911),
    [sym_comment] = ACTIONS(53),
  },
  [2900] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6913),
    [sym_comment] = ACTIONS(53),
  },
  [2901] = {
    [anon_sym_RBRACE] = ACTIONS(6913),
    [sym_comment] = ACTIONS(53),
  },
  [2902] = {
    [sym_concatenation] = STATE(3032),
    [sym_string] = STATE(3031),
    [sym_simple_expansion] = STATE(3031),
    [sym_string_expansion] = STATE(3031),
    [sym_expansion] = STATE(3031),
    [sym_command_substitution] = STATE(3031),
    [sym_process_substitution] = STATE(3031),
    [anon_sym_RBRACE] = ACTIONS(6913),
    [sym__special_characters] = ACTIONS(6915),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(6917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6917),
  },
  [2903] = {
    [sym__concat] = ACTIONS(2905),
    [anon_sym_esac] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [anon_sym_PIPE_AMP] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2907),
    [sym_word] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [2904] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6919),
  },
  [2905] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6921),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2906] = {
    [sym__concat] = ACTIONS(2913),
    [anon_sym_esac] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [anon_sym_PIPE_AMP] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [sym__special_characters] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2915),
    [sym_word] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [2907] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6923),
  },
  [2908] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6925),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2909] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(6927),
  },
  [2910] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6913),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2911] = {
    [sym_concatenation] = STATE(3039),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3039),
    [anon_sym_RBRACE] = ACTIONS(6929),
    [anon_sym_EQ] = ACTIONS(6931),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6931),
    [anon_sym_COLON_QMARK] = ACTIONS(6931),
    [anon_sym_COLON_DASH] = ACTIONS(6931),
    [anon_sym_PERCENT] = ACTIONS(6931),
    [anon_sym_DASH] = ACTIONS(6931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2912] = {
    [sym__concat] = ACTIONS(2985),
    [anon_sym_esac] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [anon_sym_PIPE_AMP] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [sym__special_characters] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2987),
    [sym_word] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2987),
  },
  [2913] = {
    [sym_concatenation] = STATE(3041),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3041),
    [anon_sym_RBRACE] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(6937),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6937),
    [anon_sym_COLON_QMARK] = ACTIONS(6937),
    [anon_sym_COLON_DASH] = ACTIONS(6937),
    [anon_sym_PERCENT] = ACTIONS(6937),
    [anon_sym_DASH] = ACTIONS(6937),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2914] = {
    [sym__concat] = ACTIONS(3030),
    [anon_sym_esac] = ACTIONS(3032),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_PIPE_AMP] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [sym__special_characters] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3032),
    [sym_word] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
  },
  [2915] = {
    [sym_concatenation] = STATE(3043),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3043),
    [anon_sym_RBRACE] = ACTIONS(6941),
    [anon_sym_EQ] = ACTIONS(6943),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6943),
    [anon_sym_COLON_QMARK] = ACTIONS(6943),
    [anon_sym_COLON_DASH] = ACTIONS(6943),
    [anon_sym_PERCENT] = ACTIONS(6943),
    [anon_sym_DASH] = ACTIONS(6943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2916] = {
    [sym__concat] = ACTIONS(3040),
    [anon_sym_esac] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE_AMP] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3042),
    [sym_word] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
  },
  [2917] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6947),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2918] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(6947),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2919] = {
    [sym__concat] = ACTIONS(3078),
    [anon_sym_esac] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [sym__special_characters] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3080),
    [sym_word] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
  },
  [2920] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(6949),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2921] = {
    [sym__simple_heredoc_body] = ACTIONS(3903),
    [sym__heredoc_body_beginning] = ACTIONS(3903),
    [sym_file_descriptor] = ACTIONS(3903),
    [sym__concat] = ACTIONS(3903),
    [anon_sym_esac] = ACTIONS(3905),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_EQ_TILDE] = ACTIONS(3905),
    [anon_sym_EQ_EQ] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_GT_GT] = ACTIONS(3903),
    [anon_sym_AMP_GT] = ACTIONS(3905),
    [anon_sym_AMP_GT_GT] = ACTIONS(3903),
    [anon_sym_LT_AMP] = ACTIONS(3903),
    [anon_sym_GT_AMP] = ACTIONS(3903),
    [anon_sym_LT_LT] = ACTIONS(3905),
    [anon_sym_LT_LT_DASH] = ACTIONS(3903),
    [anon_sym_LT_LT_LT] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [2922] = {
    [sym__simple_heredoc_body] = ACTIONS(3911),
    [sym__heredoc_body_beginning] = ACTIONS(3911),
    [sym_file_descriptor] = ACTIONS(3911),
    [sym__concat] = ACTIONS(3911),
    [anon_sym_esac] = ACTIONS(3913),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_EQ_TILDE] = ACTIONS(3913),
    [anon_sym_EQ_EQ] = ACTIONS(3913),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_GT] = ACTIONS(3913),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3913),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3913),
    [anon_sym_LT_LT_DASH] = ACTIONS(3911),
    [anon_sym_LT_LT_LT] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3913),
  },
  [2923] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6951),
    [sym_comment] = ACTIONS(53),
  },
  [2924] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(6953),
    [sym_comment] = ACTIONS(53),
  },
  [2925] = {
    [anon_sym_RBRACE] = ACTIONS(6953),
    [sym_comment] = ACTIONS(53),
  },
  [2926] = {
    [sym_concatenation] = STATE(3049),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3049),
    [anon_sym_RBRACE] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(6957),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6957),
    [anon_sym_COLON_QMARK] = ACTIONS(6957),
    [anon_sym_COLON_DASH] = ACTIONS(6957),
    [anon_sym_PERCENT] = ACTIONS(6957),
    [anon_sym_DASH] = ACTIONS(6957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2927] = {
    [sym__simple_heredoc_body] = ACTIONS(3975),
    [sym__heredoc_body_beginning] = ACTIONS(3975),
    [sym_file_descriptor] = ACTIONS(3975),
    [sym__concat] = ACTIONS(3975),
    [anon_sym_esac] = ACTIONS(3977),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [anon_sym_PIPE_AMP] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_EQ_TILDE] = ACTIONS(3977),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_LT] = ACTIONS(3977),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_GT_GT] = ACTIONS(3975),
    [anon_sym_AMP_GT] = ACTIONS(3977),
    [anon_sym_AMP_GT_GT] = ACTIONS(3975),
    [anon_sym_LT_AMP] = ACTIONS(3975),
    [anon_sym_GT_AMP] = ACTIONS(3975),
    [anon_sym_LT_LT] = ACTIONS(3977),
    [anon_sym_LT_LT_DASH] = ACTIONS(3975),
    [anon_sym_LT_LT_LT] = ACTIONS(3975),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3977),
  },
  [2928] = {
    [sym_concatenation] = STATE(3051),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3051),
    [anon_sym_RBRACE] = ACTIONS(6961),
    [anon_sym_EQ] = ACTIONS(6963),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6963),
    [anon_sym_COLON_QMARK] = ACTIONS(6963),
    [anon_sym_COLON_DASH] = ACTIONS(6963),
    [anon_sym_PERCENT] = ACTIONS(6963),
    [anon_sym_DASH] = ACTIONS(6963),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2929] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [anon_sym_esac] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3987),
    [anon_sym_EQ_EQ] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3987),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [2930] = {
    [sym_concatenation] = STATE(3053),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3053),
    [anon_sym_RBRACE] = ACTIONS(6967),
    [anon_sym_EQ] = ACTIONS(6969),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6971),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(6969),
    [anon_sym_COLON_QMARK] = ACTIONS(6969),
    [anon_sym_COLON_DASH] = ACTIONS(6969),
    [anon_sym_PERCENT] = ACTIONS(6969),
    [anon_sym_DASH] = ACTIONS(6969),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2931] = {
    [sym__simple_heredoc_body] = ACTIONS(4040),
    [sym__heredoc_body_beginning] = ACTIONS(4040),
    [sym_file_descriptor] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_esac] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [anon_sym_PIPE_AMP] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_EQ_TILDE] = ACTIONS(4042),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_GT_GT] = ACTIONS(4040),
    [anon_sym_AMP_GT] = ACTIONS(4042),
    [anon_sym_AMP_GT_GT] = ACTIONS(4040),
    [anon_sym_LT_AMP] = ACTIONS(4040),
    [anon_sym_GT_AMP] = ACTIONS(4040),
    [anon_sym_LT_LT] = ACTIONS(4042),
    [anon_sym_LT_LT_DASH] = ACTIONS(4040),
    [anon_sym_LT_LT_LT] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [2932] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6973),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2933] = {
    [sym__simple_heredoc_body] = ACTIONS(4062),
    [sym__heredoc_body_beginning] = ACTIONS(4062),
    [sym_file_descriptor] = ACTIONS(4062),
    [sym__concat] = ACTIONS(4062),
    [anon_sym_esac] = ACTIONS(4064),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_EQ_TILDE] = ACTIONS(4064),
    [anon_sym_EQ_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_GT_GT] = ACTIONS(4062),
    [anon_sym_AMP_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT_GT] = ACTIONS(4062),
    [anon_sym_LT_AMP] = ACTIONS(4062),
    [anon_sym_GT_AMP] = ACTIONS(4062),
    [anon_sym_LT_LT] = ACTIONS(4064),
    [anon_sym_LT_LT_DASH] = ACTIONS(4062),
    [anon_sym_LT_LT_LT] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [2934] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6975),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2935] = {
    [sym__simple_heredoc_body] = ACTIONS(4068),
    [sym__heredoc_body_beginning] = ACTIONS(4068),
    [sym_file_descriptor] = ACTIONS(4068),
    [sym__concat] = ACTIONS(4068),
    [anon_sym_esac] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [anon_sym_PIPE_AMP] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4068),
    [anon_sym_AMP_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT_GT] = ACTIONS(4068),
    [anon_sym_LT_AMP] = ACTIONS(4068),
    [anon_sym_GT_AMP] = ACTIONS(4068),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_LT_LT_DASH] = ACTIONS(4068),
    [anon_sym_LT_LT_LT] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [2936] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6977),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2937] = {
    [sym__simple_heredoc_body] = ACTIONS(4074),
    [sym__heredoc_body_beginning] = ACTIONS(4074),
    [sym_file_descriptor] = ACTIONS(4074),
    [sym__concat] = ACTIONS(4074),
    [anon_sym_esac] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_EQ_TILDE] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_AMP_GT] = ACTIONS(4076),
    [anon_sym_AMP_GT_GT] = ACTIONS(4074),
    [anon_sym_LT_AMP] = ACTIONS(4074),
    [anon_sym_GT_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_LT_LT_DASH] = ACTIONS(4074),
    [anon_sym_LT_LT_LT] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [2938] = {
    [sym__simple_heredoc_body] = ACTIONS(4098),
    [sym__heredoc_body_beginning] = ACTIONS(4098),
    [sym_file_descriptor] = ACTIONS(4098),
    [sym__concat] = ACTIONS(4098),
    [anon_sym_esac] = ACTIONS(4100),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [anon_sym_PIPE_AMP] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_EQ_TILDE] = ACTIONS(4100),
    [anon_sym_EQ_EQ] = ACTIONS(4100),
    [anon_sym_LT] = ACTIONS(4100),
    [anon_sym_GT] = ACTIONS(4100),
    [anon_sym_GT_GT] = ACTIONS(4098),
    [anon_sym_AMP_GT] = ACTIONS(4100),
    [anon_sym_AMP_GT_GT] = ACTIONS(4098),
    [anon_sym_LT_AMP] = ACTIONS(4098),
    [anon_sym_GT_AMP] = ACTIONS(4098),
    [anon_sym_LT_LT] = ACTIONS(4100),
    [anon_sym_LT_LT_DASH] = ACTIONS(4098),
    [anon_sym_LT_LT_LT] = ACTIONS(4098),
    [sym__special_characters] = ACTIONS(4098),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
  },
  [2939] = {
    [sym__simple_heredoc_body] = ACTIONS(1664),
    [sym__heredoc_body_beginning] = ACTIONS(1664),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(1664),
    [anon_sym_esac] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2940] = {
    [aux_sym_concatenation_repeat1] = STATE(2940),
    [sym__simple_heredoc_body] = ACTIONS(1664),
    [sym__heredoc_body_beginning] = ACTIONS(1664),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(6979),
    [anon_sym_esac] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [2941] = {
    [sym__simple_heredoc_body] = ACTIONS(1671),
    [sym__heredoc_body_beginning] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1673),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1673),
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1673),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1673),
  },
  [2942] = {
    [anon_sym_DQUOTE] = ACTIONS(6982),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [sym__string_content] = ACTIONS(707),
    [anon_sym_POUND] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(243),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
  },
  [2943] = {
    [sym_concatenation] = STATE(3061),
    [sym_string] = STATE(3060),
    [sym_simple_expansion] = STATE(3060),
    [sym_string_expansion] = STATE(3060),
    [sym_expansion] = STATE(3060),
    [sym_command_substitution] = STATE(3060),
    [sym_process_substitution] = STATE(3060),
    [anon_sym_RBRACE] = ACTIONS(6984),
    [sym__special_characters] = ACTIONS(6986),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(6988),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6988),
  },
  [2944] = {
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(6990),
    [sym_comment] = ACTIONS(53),
  },
  [2945] = {
    [sym_concatenation] = STATE(3065),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3065),
    [anon_sym_RBRACE] = ACTIONS(6992),
    [anon_sym_EQ] = ACTIONS(6994),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(6996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(6998),
    [anon_sym_COLON] = ACTIONS(6994),
    [anon_sym_COLON_QMARK] = ACTIONS(6994),
    [anon_sym_COLON_DASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [anon_sym_DASH] = ACTIONS(6994),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2946] = {
    [sym_concatenation] = STATE(3068),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3068),
    [anon_sym_RBRACE] = ACTIONS(7000),
    [anon_sym_EQ] = ACTIONS(7002),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(7006),
    [anon_sym_COLON] = ACTIONS(7002),
    [anon_sym_COLON_QMARK] = ACTIONS(7002),
    [anon_sym_COLON_DASH] = ACTIONS(7002),
    [anon_sym_PERCENT] = ACTIONS(7002),
    [anon_sym_DASH] = ACTIONS(7002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2947] = {
    [sym_concatenation] = STATE(3070),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3070),
    [anon_sym_RBRACE] = ACTIONS(6984),
    [anon_sym_EQ] = ACTIONS(7008),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(7012),
    [anon_sym_COLON] = ACTIONS(7008),
    [anon_sym_COLON_QMARK] = ACTIONS(7008),
    [anon_sym_COLON_DASH] = ACTIONS(7008),
    [anon_sym_PERCENT] = ACTIONS(7008),
    [anon_sym_DASH] = ACTIONS(7008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2948] = {
    [sym__simple_heredoc_body] = ACTIONS(1788),
    [sym__heredoc_body_beginning] = ACTIONS(1788),
    [sym_file_descriptor] = ACTIONS(1788),
    [sym__concat] = ACTIONS(1788),
    [anon_sym_esac] = ACTIONS(1788),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_SEMI_SEMI] = ACTIONS(1788),
    [anon_sym_PIPE_AMP] = ACTIONS(1788),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1788),
    [anon_sym_LT] = ACTIONS(1790),
    [anon_sym_GT] = ACTIONS(1790),
    [anon_sym_GT_GT] = ACTIONS(1788),
    [anon_sym_AMP_GT] = ACTIONS(1790),
    [anon_sym_AMP_GT_GT] = ACTIONS(1788),
    [anon_sym_LT_AMP] = ACTIONS(1788),
    [anon_sym_GT_AMP] = ACTIONS(1788),
    [anon_sym_LT_LT] = ACTIONS(1790),
    [anon_sym_LT_LT_DASH] = ACTIONS(1788),
    [anon_sym_LT_LT_LT] = ACTIONS(1788),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_LF] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1790),
  },
  [2949] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(7014),
  },
  [2950] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7016),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2951] = {
    [sym__simple_heredoc_body] = ACTIONS(1832),
    [sym__heredoc_body_beginning] = ACTIONS(1832),
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [anon_sym_esac] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [anon_sym_LT_LT] = ACTIONS(1834),
    [anon_sym_LT_LT_DASH] = ACTIONS(1832),
    [anon_sym_LT_LT_LT] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [2952] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(7018),
  },
  [2953] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7020),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2954] = {
    [sym__simple_heredoc_body] = ACTIONS(1840),
    [sym__heredoc_body_beginning] = ACTIONS(1840),
    [sym_file_descriptor] = ACTIONS(1840),
    [sym__concat] = ACTIONS(1840),
    [anon_sym_esac] = ACTIONS(1840),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [anon_sym_PIPE_AMP] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_GT] = ACTIONS(1842),
    [anon_sym_GT_GT] = ACTIONS(1840),
    [anon_sym_AMP_GT] = ACTIONS(1842),
    [anon_sym_AMP_GT_GT] = ACTIONS(1840),
    [anon_sym_LT_AMP] = ACTIONS(1840),
    [anon_sym_GT_AMP] = ACTIONS(1840),
    [anon_sym_LT_LT] = ACTIONS(1842),
    [anon_sym_LT_LT_DASH] = ACTIONS(1840),
    [anon_sym_LT_LT_LT] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [2955] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(7022),
  },
  [2956] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(6984),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2957] = {
    [sym__simple_heredoc_body] = ACTIONS(1846),
    [sym__heredoc_body_beginning] = ACTIONS(1846),
    [sym_file_descriptor] = ACTIONS(1846),
    [sym__concat] = ACTIONS(1846),
    [anon_sym_esac] = ACTIONS(1846),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT] = ACTIONS(1848),
    [anon_sym_AMP_GT_GT] = ACTIONS(1846),
    [anon_sym_LT_AMP] = ACTIONS(1846),
    [anon_sym_GT_AMP] = ACTIONS(1846),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_LT_LT_DASH] = ACTIONS(1846),
    [anon_sym_LT_LT_LT] = ACTIONS(1846),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1848),
  },
  [2958] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(7024),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2959] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(7024),
    [anon_sym_SEMI_SEMI] = ACTIONS(7026),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(7028),
    [anon_sym_LF] = ACTIONS(7026),
    [anon_sym_AMP] = ACTIONS(7028),
  },
  [2960] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(7024),
    [anon_sym_SEMI_SEMI] = ACTIONS(7026),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(7028),
    [anon_sym_LF] = ACTIONS(7026),
    [anon_sym_AMP] = ACTIONS(7028),
  },
  [2961] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(7024),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2962] = {
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(7030),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(7024),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(7032),
    [anon_sym_LF] = ACTIONS(7030),
    [anon_sym_AMP] = ACTIONS(7032),
  },
  [2963] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(7030),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(7024),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(7032),
    [anon_sym_LF] = ACTIONS(7030),
    [anon_sym_AMP] = ACTIONS(7032),
  },
  [2964] = {
    [sym__simple_heredoc_body] = ACTIONS(1878),
    [sym__heredoc_body_beginning] = ACTIONS(1878),
    [sym_file_descriptor] = ACTIONS(1878),
    [sym__concat] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1878),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1880),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT] = ACTIONS(1880),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [anon_sym_LT_LT] = ACTIONS(1880),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_LF] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1880),
  },
  [2965] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(7034),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [2966] = {
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(7034),
    [anon_sym_SEMI_SEMI] = ACTIONS(7036),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(7038),
    [anon_sym_LF] = ACTIONS(7036),
    [anon_sym_AMP] = ACTIONS(7038),
  },
  [2967] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(7034),
    [anon_sym_SEMI_SEMI] = ACTIONS(7036),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(7038),
    [anon_sym_LF] = ACTIONS(7036),
    [anon_sym_AMP] = ACTIONS(7038),
  },
  [2968] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(6398),
    [anon_sym_DQUOTE] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [sym_raw_string] = ACTIONS(6400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6400),
    [anon_sym_BQUOTE] = ACTIONS(6400),
    [anon_sym_LT_LPAREN] = ACTIONS(6400),
    [anon_sym_GT_LPAREN] = ACTIONS(6400),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6398),
  },
  [2969] = {
    [sym__special_characters] = ACTIONS(6400),
    [anon_sym_DQUOTE] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [sym_raw_string] = ACTIONS(6400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6400),
    [anon_sym_BQUOTE] = ACTIONS(6400),
    [anon_sym_LT_LPAREN] = ACTIONS(6400),
    [anon_sym_GT_LPAREN] = ACTIONS(6400),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6400),
  },
  [2970] = {
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2971] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2972] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(6408),
    [anon_sym_DQUOTE] = ACTIONS(6410),
    [anon_sym_DOLLAR] = ACTIONS(6408),
    [sym_raw_string] = ACTIONS(6410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6410),
    [anon_sym_BQUOTE] = ACTIONS(6410),
    [anon_sym_LT_LPAREN] = ACTIONS(6410),
    [anon_sym_GT_LPAREN] = ACTIONS(6410),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6408),
  },
  [2973] = {
    [sym__special_characters] = ACTIONS(6410),
    [anon_sym_DQUOTE] = ACTIONS(6410),
    [anon_sym_DOLLAR] = ACTIONS(6408),
    [sym_raw_string] = ACTIONS(6410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6410),
    [anon_sym_BQUOTE] = ACTIONS(6410),
    [anon_sym_LT_LPAREN] = ACTIONS(6410),
    [anon_sym_GT_LPAREN] = ACTIONS(6410),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6410),
  },
  [2974] = {
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2975] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE_AMP] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(327),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(327),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [2976] = {
    [sym_file_descriptor] = ACTIONS(5524),
    [sym__concat] = ACTIONS(5524),
    [anon_sym_esac] = ACTIONS(5524),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5524),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [anon_sym_PIPE_AMP] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_LT] = ACTIONS(5526),
    [anon_sym_GT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_AMP_GT] = ACTIONS(5526),
    [anon_sym_AMP_GT_GT] = ACTIONS(5524),
    [anon_sym_LT_AMP] = ACTIONS(5524),
    [anon_sym_GT_AMP] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_LT_LT_DASH] = ACTIONS(5524),
    [anon_sym_LT_LT_LT] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5526),
  },
  [2977] = {
    [sym_file_descriptor] = ACTIONS(5528),
    [sym__concat] = ACTIONS(5528),
    [anon_sym_esac] = ACTIONS(5528),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_RPAREN] = ACTIONS(5528),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [anon_sym_PIPE_AMP] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_LT] = ACTIONS(5530),
    [anon_sym_GT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_AMP_GT] = ACTIONS(5530),
    [anon_sym_AMP_GT_GT] = ACTIONS(5528),
    [anon_sym_LT_AMP] = ACTIONS(5528),
    [anon_sym_GT_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5530),
    [anon_sym_LT_LT_DASH] = ACTIONS(5528),
    [anon_sym_LT_LT_LT] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5530),
  },
  [2978] = {
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5532),
    [anon_sym_LT_AMP] = ACTIONS(5532),
    [anon_sym_GT_AMP] = ACTIONS(5532),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_LT_LT_DASH] = ACTIONS(5532),
    [anon_sym_LT_LT_LT] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2979] = {
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [sym_variable_name] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2855),
    [anon_sym_LT_AMP] = ACTIONS(2855),
    [anon_sym_GT_AMP] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [2980] = {
    [sym_file_descriptor] = ACTIONS(2869),
    [sym__concat] = ACTIONS(2869),
    [sym_variable_name] = ACTIONS(2869),
    [anon_sym_esac] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [anon_sym_PIPE_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_GT_GT] = ACTIONS(2869),
    [anon_sym_AMP_GT] = ACTIONS(2871),
    [anon_sym_AMP_GT_GT] = ACTIONS(2869),
    [anon_sym_LT_AMP] = ACTIONS(2869),
    [anon_sym_GT_AMP] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [sym_raw_string] = ACTIONS(2869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [anon_sym_LT_LPAREN] = ACTIONS(2869),
    [anon_sym_GT_LPAREN] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [2981] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7044),
    [sym_comment] = ACTIONS(53),
  },
  [2982] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7046),
    [sym_comment] = ACTIONS(53),
  },
  [2983] = {
    [anon_sym_RBRACE] = ACTIONS(7046),
    [sym_comment] = ACTIONS(53),
  },
  [2984] = {
    [sym_concatenation] = STATE(3087),
    [sym_string] = STATE(3086),
    [sym_simple_expansion] = STATE(3086),
    [sym_string_expansion] = STATE(3086),
    [sym_expansion] = STATE(3086),
    [sym_command_substitution] = STATE(3086),
    [sym_process_substitution] = STATE(3086),
    [anon_sym_RBRACE] = ACTIONS(7046),
    [sym__special_characters] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(7050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(7050),
  },
  [2985] = {
    [sym_file_descriptor] = ACTIONS(2905),
    [sym__concat] = ACTIONS(2905),
    [sym_variable_name] = ACTIONS(2905),
    [anon_sym_esac] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [anon_sym_PIPE_AMP] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2907),
    [anon_sym_GT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2905),
    [anon_sym_AMP_GT] = ACTIONS(2907),
    [anon_sym_AMP_GT_GT] = ACTIONS(2905),
    [anon_sym_LT_AMP] = ACTIONS(2905),
    [anon_sym_GT_AMP] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_DOLLAR] = ACTIONS(2907),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2905),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2905),
    [anon_sym_GT_LPAREN] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [2986] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(7052),
  },
  [2987] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7054),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2988] = {
    [sym_file_descriptor] = ACTIONS(2913),
    [sym__concat] = ACTIONS(2913),
    [sym_variable_name] = ACTIONS(2913),
    [anon_sym_esac] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [anon_sym_PIPE_AMP] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_AMP_GT] = ACTIONS(2915),
    [anon_sym_AMP_GT_GT] = ACTIONS(2913),
    [anon_sym_LT_AMP] = ACTIONS(2913),
    [anon_sym_GT_AMP] = ACTIONS(2913),
    [sym__special_characters] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2913),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [anon_sym_LT_LPAREN] = ACTIONS(2913),
    [anon_sym_GT_LPAREN] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [2989] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(7056),
  },
  [2990] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7058),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2991] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(7060),
  },
  [2992] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7046),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2993] = {
    [sym_concatenation] = STATE(3094),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3094),
    [anon_sym_RBRACE] = ACTIONS(7062),
    [anon_sym_EQ] = ACTIONS(7064),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7066),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7064),
    [anon_sym_COLON_QMARK] = ACTIONS(7064),
    [anon_sym_COLON_DASH] = ACTIONS(7064),
    [anon_sym_PERCENT] = ACTIONS(7064),
    [anon_sym_DASH] = ACTIONS(7064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2994] = {
    [sym_file_descriptor] = ACTIONS(2985),
    [sym__concat] = ACTIONS(2985),
    [sym_variable_name] = ACTIONS(2985),
    [anon_sym_esac] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [anon_sym_PIPE_AMP] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_GT] = ACTIONS(2987),
    [anon_sym_AMP_GT_GT] = ACTIONS(2985),
    [anon_sym_LT_AMP] = ACTIONS(2985),
    [anon_sym_GT_AMP] = ACTIONS(2985),
    [sym__special_characters] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2985),
    [anon_sym_GT_LPAREN] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2987),
  },
  [2995] = {
    [sym_concatenation] = STATE(3096),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3096),
    [anon_sym_RBRACE] = ACTIONS(7068),
    [anon_sym_EQ] = ACTIONS(7070),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7072),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7070),
    [anon_sym_COLON_QMARK] = ACTIONS(7070),
    [anon_sym_COLON_DASH] = ACTIONS(7070),
    [anon_sym_PERCENT] = ACTIONS(7070),
    [anon_sym_DASH] = ACTIONS(7070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2996] = {
    [sym_file_descriptor] = ACTIONS(3030),
    [sym__concat] = ACTIONS(3030),
    [sym_variable_name] = ACTIONS(3030),
    [anon_sym_esac] = ACTIONS(3032),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_PIPE_AMP] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_AMP_GT] = ACTIONS(3032),
    [anon_sym_AMP_GT_GT] = ACTIONS(3030),
    [anon_sym_LT_AMP] = ACTIONS(3030),
    [anon_sym_GT_AMP] = ACTIONS(3030),
    [sym__special_characters] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [sym_raw_string] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3030),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [anon_sym_LT_LPAREN] = ACTIONS(3030),
    [anon_sym_GT_LPAREN] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
  },
  [2997] = {
    [sym_concatenation] = STATE(3098),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3098),
    [anon_sym_RBRACE] = ACTIONS(7074),
    [anon_sym_EQ] = ACTIONS(7076),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7076),
    [anon_sym_COLON_QMARK] = ACTIONS(7076),
    [anon_sym_COLON_DASH] = ACTIONS(7076),
    [anon_sym_PERCENT] = ACTIONS(7076),
    [anon_sym_DASH] = ACTIONS(7076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [2998] = {
    [sym_file_descriptor] = ACTIONS(3040),
    [sym__concat] = ACTIONS(3040),
    [sym_variable_name] = ACTIONS(3040),
    [anon_sym_esac] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE_AMP] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_AMP_GT] = ACTIONS(3042),
    [anon_sym_AMP_GT_GT] = ACTIONS(3040),
    [anon_sym_LT_AMP] = ACTIONS(3040),
    [anon_sym_GT_AMP] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(3042),
    [sym_raw_string] = ACTIONS(3040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3040),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [anon_sym_LT_LPAREN] = ACTIONS(3040),
    [anon_sym_GT_LPAREN] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
  },
  [2999] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(7080),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [3000] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(7080),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [3001] = {
    [sym_file_descriptor] = ACTIONS(3078),
    [sym__concat] = ACTIONS(3078),
    [sym_variable_name] = ACTIONS(3078),
    [anon_sym_esac] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3078),
    [anon_sym_AMP_GT] = ACTIONS(3080),
    [anon_sym_AMP_GT_GT] = ACTIONS(3078),
    [anon_sym_LT_AMP] = ACTIONS(3078),
    [anon_sym_GT_AMP] = ACTIONS(3078),
    [sym__special_characters] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3078),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [anon_sym_LT_LPAREN] = ACTIONS(3078),
    [anon_sym_GT_LPAREN] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
  },
  [3002] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(7082),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [3003] = {
    [aux_sym_concatenation_repeat1] = STATE(3005),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [3004] = {
    [aux_sym_concatenation_repeat1] = STATE(3005),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(985),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [3005] = {
    [aux_sym_concatenation_repeat1] = STATE(3101),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [3006] = {
    [aux_sym_concatenation_repeat1] = STATE(3008),
    [sym_file_descriptor] = ACTIONS(981),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_esac] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(981),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(981),
    [anon_sym_LT_AMP] = ACTIONS(981),
    [anon_sym_GT_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(981),
    [anon_sym_LT_LT_LT] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [3007] = {
    [aux_sym_concatenation_repeat1] = STATE(3008),
    [sym_file_descriptor] = ACTIONS(985),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_esac] = ACTIONS(985),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_SEMI_SEMI] = ACTIONS(985),
    [anon_sym_PIPE_AMP] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_AMP_GT] = ACTIONS(987),
    [anon_sym_AMP_GT_GT] = ACTIONS(985),
    [anon_sym_LT_AMP] = ACTIONS(985),
    [anon_sym_GT_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_DASH] = ACTIONS(985),
    [anon_sym_LT_LT_LT] = ACTIONS(985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [3008] = {
    [aux_sym_concatenation_repeat1] = STATE(3102),
    [sym_file_descriptor] = ACTIONS(695),
    [sym__concat] = ACTIONS(3647),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [3009] = {
    [sym_variable_name] = ACTIONS(3201),
    [anon_sym_esac] = ACTIONS(3203),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_SEMI_SEMI] = ACTIONS(3201),
    [anon_sym_PIPE_AMP] = ACTIONS(3201),
    [anon_sym_AMP_AMP] = ACTIONS(3201),
    [anon_sym_PIPE_PIPE] = ACTIONS(3201),
    [sym__special_characters] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3201),
    [anon_sym_DOLLAR] = ACTIONS(3203),
    [sym_raw_string] = ACTIONS(3201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3201),
    [anon_sym_BQUOTE] = ACTIONS(3201),
    [anon_sym_LT_LPAREN] = ACTIONS(3201),
    [anon_sym_GT_LPAREN] = ACTIONS(3201),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3203),
    [sym_word] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3203),
    [anon_sym_LF] = ACTIONS(3201),
    [anon_sym_AMP] = ACTIONS(3203),
  },
  [3010] = {
    [sym__concat] = ACTIONS(3903),
    [sym_variable_name] = ACTIONS(3903),
    [anon_sym_esac] = ACTIONS(3905),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3905),
    [sym_word] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [3011] = {
    [sym__concat] = ACTIONS(3911),
    [sym_variable_name] = ACTIONS(3911),
    [anon_sym_esac] = ACTIONS(3913),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3913),
    [sym_word] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3913),
  },
  [3012] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7084),
    [sym_comment] = ACTIONS(53),
  },
  [3013] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7086),
    [sym_comment] = ACTIONS(53),
  },
  [3014] = {
    [anon_sym_RBRACE] = ACTIONS(7086),
    [sym_comment] = ACTIONS(53),
  },
  [3015] = {
    [sym_concatenation] = STATE(3106),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3106),
    [anon_sym_RBRACE] = ACTIONS(7088),
    [anon_sym_EQ] = ACTIONS(7090),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7092),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7090),
    [anon_sym_COLON_QMARK] = ACTIONS(7090),
    [anon_sym_COLON_DASH] = ACTIONS(7090),
    [anon_sym_PERCENT] = ACTIONS(7090),
    [anon_sym_DASH] = ACTIONS(7090),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3016] = {
    [sym__concat] = ACTIONS(3975),
    [sym_variable_name] = ACTIONS(3975),
    [anon_sym_esac] = ACTIONS(3977),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [anon_sym_PIPE_AMP] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3977),
    [sym_word] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3977),
  },
  [3017] = {
    [sym_concatenation] = STATE(3108),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3108),
    [anon_sym_RBRACE] = ACTIONS(7094),
    [anon_sym_EQ] = ACTIONS(7096),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7096),
    [anon_sym_COLON_QMARK] = ACTIONS(7096),
    [anon_sym_COLON_DASH] = ACTIONS(7096),
    [anon_sym_PERCENT] = ACTIONS(7096),
    [anon_sym_DASH] = ACTIONS(7096),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3018] = {
    [sym__concat] = ACTIONS(3985),
    [sym_variable_name] = ACTIONS(3985),
    [anon_sym_esac] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3987),
    [sym_word] = ACTIONS(3987),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [3019] = {
    [sym_concatenation] = STATE(3110),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3110),
    [anon_sym_RBRACE] = ACTIONS(7100),
    [anon_sym_EQ] = ACTIONS(7102),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7102),
    [anon_sym_COLON_QMARK] = ACTIONS(7102),
    [anon_sym_COLON_DASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [anon_sym_DASH] = ACTIONS(7102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3020] = {
    [sym__concat] = ACTIONS(4040),
    [sym_variable_name] = ACTIONS(4040),
    [anon_sym_esac] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [anon_sym_PIPE_AMP] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4042),
    [sym_word] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [3021] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3022] = {
    [sym__concat] = ACTIONS(4062),
    [sym_variable_name] = ACTIONS(4062),
    [anon_sym_esac] = ACTIONS(4064),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4064),
    [sym_word] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [3023] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7108),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3024] = {
    [sym__concat] = ACTIONS(4068),
    [sym_variable_name] = ACTIONS(4068),
    [anon_sym_esac] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [anon_sym_PIPE_AMP] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4070),
    [sym_word] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [3025] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7110),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3026] = {
    [sym__concat] = ACTIONS(4074),
    [sym_variable_name] = ACTIONS(4074),
    [anon_sym_esac] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4076),
    [sym_word] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [3027] = {
    [sym__concat] = ACTIONS(4098),
    [sym_variable_name] = ACTIONS(4098),
    [anon_sym_esac] = ACTIONS(4100),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [anon_sym_PIPE_AMP] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [sym__special_characters] = ACTIONS(4098),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4100),
    [sym_word] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
  },
  [3028] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_esac] = ACTIONS(3905),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3905),
    [sym_word] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [3029] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_esac] = ACTIONS(3913),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3913),
    [sym_word] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3913),
  },
  [3030] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7112),
    [sym_comment] = ACTIONS(53),
  },
  [3031] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7114),
    [sym_comment] = ACTIONS(53),
  },
  [3032] = {
    [anon_sym_RBRACE] = ACTIONS(7114),
    [sym_comment] = ACTIONS(53),
  },
  [3033] = {
    [sym_concatenation] = STATE(3117),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3117),
    [anon_sym_RBRACE] = ACTIONS(7116),
    [anon_sym_EQ] = ACTIONS(7118),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7120),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7118),
    [anon_sym_COLON_QMARK] = ACTIONS(7118),
    [anon_sym_COLON_DASH] = ACTIONS(7118),
    [anon_sym_PERCENT] = ACTIONS(7118),
    [anon_sym_DASH] = ACTIONS(7118),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3034] = {
    [sym__concat] = ACTIONS(3975),
    [anon_sym_esac] = ACTIONS(3977),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [anon_sym_PIPE_AMP] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3977),
    [sym_word] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3977),
  },
  [3035] = {
    [sym_concatenation] = STATE(3119),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3119),
    [anon_sym_RBRACE] = ACTIONS(7122),
    [anon_sym_EQ] = ACTIONS(7124),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7126),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7124),
    [anon_sym_COLON_QMARK] = ACTIONS(7124),
    [anon_sym_COLON_DASH] = ACTIONS(7124),
    [anon_sym_PERCENT] = ACTIONS(7124),
    [anon_sym_DASH] = ACTIONS(7124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3036] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_esac] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3987),
    [sym_word] = ACTIONS(3987),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [3037] = {
    [sym_concatenation] = STATE(3121),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3121),
    [anon_sym_RBRACE] = ACTIONS(7128),
    [anon_sym_EQ] = ACTIONS(7130),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7130),
    [anon_sym_COLON_QMARK] = ACTIONS(7130),
    [anon_sym_COLON_DASH] = ACTIONS(7130),
    [anon_sym_PERCENT] = ACTIONS(7130),
    [anon_sym_DASH] = ACTIONS(7130),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3038] = {
    [sym__concat] = ACTIONS(4040),
    [anon_sym_esac] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [anon_sym_PIPE_AMP] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4042),
    [sym_word] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [3039] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7134),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3040] = {
    [sym__concat] = ACTIONS(4062),
    [anon_sym_esac] = ACTIONS(4064),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4064),
    [sym_word] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [3041] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7136),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3042] = {
    [sym__concat] = ACTIONS(4068),
    [anon_sym_esac] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [anon_sym_PIPE_AMP] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4070),
    [sym_word] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [3043] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7138),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3044] = {
    [sym__concat] = ACTIONS(4074),
    [anon_sym_esac] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4076),
    [sym_word] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [3045] = {
    [sym__concat] = ACTIONS(4098),
    [anon_sym_esac] = ACTIONS(4100),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [anon_sym_PIPE_AMP] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [sym__special_characters] = ACTIONS(4098),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4100),
    [sym_word] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
  },
  [3046] = {
    [sym__simple_heredoc_body] = ACTIONS(4885),
    [sym__heredoc_body_beginning] = ACTIONS(4885),
    [sym_file_descriptor] = ACTIONS(4885),
    [sym__concat] = ACTIONS(4885),
    [anon_sym_esac] = ACTIONS(4887),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [anon_sym_PIPE_AMP] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_EQ_TILDE] = ACTIONS(4887),
    [anon_sym_EQ_EQ] = ACTIONS(4887),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_GT_GT] = ACTIONS(4885),
    [anon_sym_AMP_GT] = ACTIONS(4887),
    [anon_sym_AMP_GT_GT] = ACTIONS(4885),
    [anon_sym_LT_AMP] = ACTIONS(4885),
    [anon_sym_GT_AMP] = ACTIONS(4885),
    [anon_sym_LT_LT] = ACTIONS(4887),
    [anon_sym_LT_LT_DASH] = ACTIONS(4885),
    [anon_sym_LT_LT_LT] = ACTIONS(4885),
    [sym__special_characters] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4887),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4887),
  },
  [3047] = {
    [sym__simple_heredoc_body] = ACTIONS(4889),
    [sym__heredoc_body_beginning] = ACTIONS(4889),
    [sym_file_descriptor] = ACTIONS(4889),
    [sym__concat] = ACTIONS(4889),
    [anon_sym_esac] = ACTIONS(4891),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [anon_sym_PIPE_AMP] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_EQ_TILDE] = ACTIONS(4891),
    [anon_sym_EQ_EQ] = ACTIONS(4891),
    [anon_sym_LT] = ACTIONS(4891),
    [anon_sym_GT] = ACTIONS(4891),
    [anon_sym_GT_GT] = ACTIONS(4889),
    [anon_sym_AMP_GT] = ACTIONS(4891),
    [anon_sym_AMP_GT_GT] = ACTIONS(4889),
    [anon_sym_LT_AMP] = ACTIONS(4889),
    [anon_sym_GT_AMP] = ACTIONS(4889),
    [anon_sym_LT_LT] = ACTIONS(4891),
    [anon_sym_LT_LT_DASH] = ACTIONS(4889),
    [anon_sym_LT_LT_LT] = ACTIONS(4889),
    [sym__special_characters] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4891),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4891),
  },
  [3048] = {
    [sym__simple_heredoc_body] = ACTIONS(4893),
    [sym__heredoc_body_beginning] = ACTIONS(4893),
    [sym_file_descriptor] = ACTIONS(4893),
    [sym__concat] = ACTIONS(4893),
    [anon_sym_esac] = ACTIONS(4895),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [anon_sym_EQ_TILDE] = ACTIONS(4895),
    [anon_sym_EQ_EQ] = ACTIONS(4895),
    [anon_sym_LT] = ACTIONS(4895),
    [anon_sym_GT] = ACTIONS(4895),
    [anon_sym_GT_GT] = ACTIONS(4893),
    [anon_sym_AMP_GT] = ACTIONS(4895),
    [anon_sym_AMP_GT_GT] = ACTIONS(4893),
    [anon_sym_LT_AMP] = ACTIONS(4893),
    [anon_sym_GT_AMP] = ACTIONS(4893),
    [anon_sym_LT_LT] = ACTIONS(4895),
    [anon_sym_LT_LT_DASH] = ACTIONS(4893),
    [anon_sym_LT_LT_LT] = ACTIONS(4893),
    [sym__special_characters] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4895),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [3049] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7140),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3050] = {
    [sym__simple_heredoc_body] = ACTIONS(4899),
    [sym__heredoc_body_beginning] = ACTIONS(4899),
    [sym_file_descriptor] = ACTIONS(4899),
    [sym__concat] = ACTIONS(4899),
    [anon_sym_esac] = ACTIONS(4901),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [anon_sym_PIPE_AMP] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [anon_sym_EQ_TILDE] = ACTIONS(4901),
    [anon_sym_EQ_EQ] = ACTIONS(4901),
    [anon_sym_LT] = ACTIONS(4901),
    [anon_sym_GT] = ACTIONS(4901),
    [anon_sym_GT_GT] = ACTIONS(4899),
    [anon_sym_AMP_GT] = ACTIONS(4901),
    [anon_sym_AMP_GT_GT] = ACTIONS(4899),
    [anon_sym_LT_AMP] = ACTIONS(4899),
    [anon_sym_GT_AMP] = ACTIONS(4899),
    [anon_sym_LT_LT] = ACTIONS(4901),
    [anon_sym_LT_LT_DASH] = ACTIONS(4899),
    [anon_sym_LT_LT_LT] = ACTIONS(4899),
    [sym__special_characters] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4901),
  },
  [3051] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7142),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3052] = {
    [sym__simple_heredoc_body] = ACTIONS(4905),
    [sym__heredoc_body_beginning] = ACTIONS(4905),
    [sym_file_descriptor] = ACTIONS(4905),
    [sym__concat] = ACTIONS(4905),
    [anon_sym_esac] = ACTIONS(4907),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [anon_sym_PIPE_AMP] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_EQ_TILDE] = ACTIONS(4907),
    [anon_sym_EQ_EQ] = ACTIONS(4907),
    [anon_sym_LT] = ACTIONS(4907),
    [anon_sym_GT] = ACTIONS(4907),
    [anon_sym_GT_GT] = ACTIONS(4905),
    [anon_sym_AMP_GT] = ACTIONS(4907),
    [anon_sym_AMP_GT_GT] = ACTIONS(4905),
    [anon_sym_LT_AMP] = ACTIONS(4905),
    [anon_sym_GT_AMP] = ACTIONS(4905),
    [anon_sym_LT_LT] = ACTIONS(4907),
    [anon_sym_LT_LT_DASH] = ACTIONS(4905),
    [anon_sym_LT_LT_LT] = ACTIONS(4905),
    [sym__special_characters] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4907),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4907),
  },
  [3053] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7144),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3054] = {
    [sym__simple_heredoc_body] = ACTIONS(4947),
    [sym__heredoc_body_beginning] = ACTIONS(4947),
    [sym_file_descriptor] = ACTIONS(4947),
    [sym__concat] = ACTIONS(4947),
    [anon_sym_esac] = ACTIONS(4949),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_EQ_TILDE] = ACTIONS(4949),
    [anon_sym_EQ_EQ] = ACTIONS(4949),
    [anon_sym_LT] = ACTIONS(4949),
    [anon_sym_GT] = ACTIONS(4949),
    [anon_sym_GT_GT] = ACTIONS(4947),
    [anon_sym_AMP_GT] = ACTIONS(4949),
    [anon_sym_AMP_GT_GT] = ACTIONS(4947),
    [anon_sym_LT_AMP] = ACTIONS(4947),
    [anon_sym_GT_AMP] = ACTIONS(4947),
    [anon_sym_LT_LT] = ACTIONS(4949),
    [anon_sym_LT_LT_DASH] = ACTIONS(4947),
    [anon_sym_LT_LT_LT] = ACTIONS(4947),
    [sym__special_characters] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4949),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4949),
  },
  [3055] = {
    [sym__simple_heredoc_body] = ACTIONS(4955),
    [sym__heredoc_body_beginning] = ACTIONS(4955),
    [sym_file_descriptor] = ACTIONS(4955),
    [sym__concat] = ACTIONS(4955),
    [anon_sym_esac] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [anon_sym_PIPE_AMP] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [anon_sym_EQ_TILDE] = ACTIONS(4957),
    [anon_sym_EQ_EQ] = ACTIONS(4957),
    [anon_sym_LT] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4957),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym_AMP_GT] = ACTIONS(4957),
    [anon_sym_AMP_GT_GT] = ACTIONS(4955),
    [anon_sym_LT_AMP] = ACTIONS(4955),
    [anon_sym_GT_AMP] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4957),
    [anon_sym_LT_LT_DASH] = ACTIONS(4955),
    [anon_sym_LT_LT_LT] = ACTIONS(4955),
    [sym__special_characters] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4957),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4957),
  },
  [3056] = {
    [sym__simple_heredoc_body] = ACTIONS(4959),
    [sym__heredoc_body_beginning] = ACTIONS(4959),
    [sym_file_descriptor] = ACTIONS(4959),
    [sym__concat] = ACTIONS(4959),
    [anon_sym_esac] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [anon_sym_PIPE_AMP] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [anon_sym_EQ_TILDE] = ACTIONS(4961),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_LT] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym_AMP_GT] = ACTIONS(4961),
    [anon_sym_AMP_GT_GT] = ACTIONS(4959),
    [anon_sym_LT_AMP] = ACTIONS(4959),
    [anon_sym_GT_AMP] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4961),
    [anon_sym_LT_LT_DASH] = ACTIONS(4959),
    [anon_sym_LT_LT_LT] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4961),
  },
  [3057] = {
    [sym__simple_heredoc_body] = ACTIONS(2855),
    [sym__heredoc_body_beginning] = ACTIONS(2855),
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2855),
    [anon_sym_LT_AMP] = ACTIONS(2855),
    [anon_sym_GT_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_LT_LT_DASH] = ACTIONS(2855),
    [anon_sym_LT_LT_LT] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [3058] = {
    [sym__simple_heredoc_body] = ACTIONS(2869),
    [sym__heredoc_body_beginning] = ACTIONS(2869),
    [sym_file_descriptor] = ACTIONS(2869),
    [sym__concat] = ACTIONS(2869),
    [anon_sym_esac] = ACTIONS(2869),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_SEMI_SEMI] = ACTIONS(2869),
    [anon_sym_PIPE_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_PIPE_PIPE] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_GT_GT] = ACTIONS(2869),
    [anon_sym_AMP_GT] = ACTIONS(2871),
    [anon_sym_AMP_GT_GT] = ACTIONS(2869),
    [anon_sym_LT_AMP] = ACTIONS(2869),
    [anon_sym_GT_AMP] = ACTIONS(2869),
    [anon_sym_LT_LT] = ACTIONS(2871),
    [anon_sym_LT_LT_DASH] = ACTIONS(2869),
    [anon_sym_LT_LT_LT] = ACTIONS(2869),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [3059] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7146),
    [sym_comment] = ACTIONS(53),
  },
  [3060] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7148),
    [sym_comment] = ACTIONS(53),
  },
  [3061] = {
    [anon_sym_RBRACE] = ACTIONS(7148),
    [sym_comment] = ACTIONS(53),
  },
  [3062] = {
    [sym_concatenation] = STATE(3132),
    [sym_string] = STATE(3131),
    [sym_simple_expansion] = STATE(3131),
    [sym_string_expansion] = STATE(3131),
    [sym_expansion] = STATE(3131),
    [sym_command_substitution] = STATE(3131),
    [sym_process_substitution] = STATE(3131),
    [anon_sym_RBRACE] = ACTIONS(7148),
    [sym__special_characters] = ACTIONS(7150),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(7152),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1760),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(7152),
  },
  [3063] = {
    [sym__simple_heredoc_body] = ACTIONS(2905),
    [sym__heredoc_body_beginning] = ACTIONS(2905),
    [sym_file_descriptor] = ACTIONS(2905),
    [sym__concat] = ACTIONS(2905),
    [anon_sym_esac] = ACTIONS(2905),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_SEMI_SEMI] = ACTIONS(2905),
    [anon_sym_PIPE_AMP] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2907),
    [anon_sym_GT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2905),
    [anon_sym_AMP_GT] = ACTIONS(2907),
    [anon_sym_AMP_GT_GT] = ACTIONS(2905),
    [anon_sym_LT_AMP] = ACTIONS(2905),
    [anon_sym_GT_AMP] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_LT_LT_DASH] = ACTIONS(2905),
    [anon_sym_LT_LT_LT] = ACTIONS(2905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [3064] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(7154),
  },
  [3065] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7156),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3066] = {
    [sym__simple_heredoc_body] = ACTIONS(2913),
    [sym__heredoc_body_beginning] = ACTIONS(2913),
    [sym_file_descriptor] = ACTIONS(2913),
    [sym__concat] = ACTIONS(2913),
    [anon_sym_esac] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [anon_sym_PIPE_AMP] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_AMP_GT] = ACTIONS(2915),
    [anon_sym_AMP_GT_GT] = ACTIONS(2913),
    [anon_sym_LT_AMP] = ACTIONS(2913),
    [anon_sym_GT_AMP] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_LT_LT_DASH] = ACTIONS(2913),
    [anon_sym_LT_LT_LT] = ACTIONS(2913),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [3067] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(7158),
  },
  [3068] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7160),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3069] = {
    [sym_comment] = ACTIONS(243),
    [sym_regex_without_right_brace] = ACTIONS(7162),
  },
  [3070] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7148),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3071] = {
    [sym_concatenation] = STATE(3139),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3139),
    [anon_sym_RBRACE] = ACTIONS(7164),
    [anon_sym_EQ] = ACTIONS(7166),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7166),
    [anon_sym_COLON_QMARK] = ACTIONS(7166),
    [anon_sym_COLON_DASH] = ACTIONS(7166),
    [anon_sym_PERCENT] = ACTIONS(7166),
    [anon_sym_DASH] = ACTIONS(7166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3072] = {
    [sym__simple_heredoc_body] = ACTIONS(2985),
    [sym__heredoc_body_beginning] = ACTIONS(2985),
    [sym_file_descriptor] = ACTIONS(2985),
    [sym__concat] = ACTIONS(2985),
    [anon_sym_esac] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2987),
    [anon_sym_SEMI_SEMI] = ACTIONS(2985),
    [anon_sym_PIPE_AMP] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_GT] = ACTIONS(2987),
    [anon_sym_AMP_GT_GT] = ACTIONS(2985),
    [anon_sym_LT_AMP] = ACTIONS(2985),
    [anon_sym_GT_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_LT_LT_DASH] = ACTIONS(2985),
    [anon_sym_LT_LT_LT] = ACTIONS(2985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2987),
  },
  [3073] = {
    [sym_concatenation] = STATE(3141),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3141),
    [anon_sym_RBRACE] = ACTIONS(7170),
    [anon_sym_EQ] = ACTIONS(7172),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7174),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7172),
    [anon_sym_COLON_QMARK] = ACTIONS(7172),
    [anon_sym_COLON_DASH] = ACTIONS(7172),
    [anon_sym_PERCENT] = ACTIONS(7172),
    [anon_sym_DASH] = ACTIONS(7172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3074] = {
    [sym__simple_heredoc_body] = ACTIONS(3030),
    [sym__heredoc_body_beginning] = ACTIONS(3030),
    [sym_file_descriptor] = ACTIONS(3030),
    [sym__concat] = ACTIONS(3030),
    [anon_sym_esac] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_PIPE_AMP] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_AMP_GT] = ACTIONS(3032),
    [anon_sym_AMP_GT_GT] = ACTIONS(3030),
    [anon_sym_LT_AMP] = ACTIONS(3030),
    [anon_sym_GT_AMP] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_LT_LT_DASH] = ACTIONS(3030),
    [anon_sym_LT_LT_LT] = ACTIONS(3030),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LF] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
  },
  [3075] = {
    [sym_concatenation] = STATE(3143),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3143),
    [anon_sym_RBRACE] = ACTIONS(7176),
    [anon_sym_EQ] = ACTIONS(7178),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7178),
    [anon_sym_COLON_QMARK] = ACTIONS(7178),
    [anon_sym_COLON_DASH] = ACTIONS(7178),
    [anon_sym_PERCENT] = ACTIONS(7178),
    [anon_sym_DASH] = ACTIONS(7178),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3076] = {
    [sym__simple_heredoc_body] = ACTIONS(3040),
    [sym__heredoc_body_beginning] = ACTIONS(3040),
    [sym_file_descriptor] = ACTIONS(3040),
    [sym__concat] = ACTIONS(3040),
    [anon_sym_esac] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_SEMI_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE_AMP] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_AMP_GT] = ACTIONS(3042),
    [anon_sym_AMP_GT_GT] = ACTIONS(3040),
    [anon_sym_LT_AMP] = ACTIONS(3040),
    [anon_sym_GT_AMP] = ACTIONS(3040),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_LT_LT_DASH] = ACTIONS(3040),
    [anon_sym_LT_LT_LT] = ACTIONS(3040),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LF] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
  },
  [3077] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(7182),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [3078] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(7182),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [3079] = {
    [sym__simple_heredoc_body] = ACTIONS(3078),
    [sym__heredoc_body_beginning] = ACTIONS(3078),
    [sym_file_descriptor] = ACTIONS(3078),
    [sym__concat] = ACTIONS(3078),
    [anon_sym_esac] = ACTIONS(3078),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_SEMI_SEMI] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3078),
    [anon_sym_AMP_GT] = ACTIONS(3080),
    [anon_sym_AMP_GT_GT] = ACTIONS(3078),
    [anon_sym_LT_AMP] = ACTIONS(3078),
    [anon_sym_GT_AMP] = ACTIONS(3078),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_LT_LT_DASH] = ACTIONS(3078),
    [anon_sym_LT_LT_LT] = ACTIONS(3078),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
  },
  [3080] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(7184),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(833),
    [anon_sym_LT_LPAREN] = ACTIONS(833),
    [anon_sym_GT_LPAREN] = ACTIONS(833),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(835),
  },
  [3081] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(6764),
    [anon_sym_DQUOTE] = ACTIONS(6766),
    [anon_sym_DOLLAR] = ACTIONS(6764),
    [sym_raw_string] = ACTIONS(6766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6766),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6766),
    [anon_sym_BQUOTE] = ACTIONS(6766),
    [anon_sym_LT_LPAREN] = ACTIONS(6766),
    [anon_sym_GT_LPAREN] = ACTIONS(6766),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6764),
  },
  [3082] = {
    [sym_file_descriptor] = ACTIONS(833),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_typeset] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_local] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_unsetenv] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_AMP_GT] = ACTIONS(835),
    [anon_sym_AMP_GT_GT] = ACTIONS(833),
    [anon_sym_LT_AMP] = ACTIONS(833),
    [anon_sym_GT_AMP] = ACTIONS(833),
    [sym__special_characters] = ACTIONS(6770),
    [anon_sym_DQUOTE] = ACTIONS(6772),
    [anon_sym_DOLLAR] = ACTIONS(6770),
    [sym_raw_string] = ACTIONS(6772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6772),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6772),
    [anon_sym_BQUOTE] = ACTIONS(6772),
    [anon_sym_LT_LPAREN] = ACTIONS(6772),
    [anon_sym_GT_LPAREN] = ACTIONS(6772),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6770),
  },
  [3083] = {
    [sym_file_descriptor] = ACTIONS(3903),
    [sym__concat] = ACTIONS(3903),
    [sym_variable_name] = ACTIONS(3903),
    [anon_sym_esac] = ACTIONS(3905),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_GT_GT] = ACTIONS(3903),
    [anon_sym_AMP_GT] = ACTIONS(3905),
    [anon_sym_AMP_GT_GT] = ACTIONS(3903),
    [anon_sym_LT_AMP] = ACTIONS(3903),
    [anon_sym_GT_AMP] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3903),
    [anon_sym_LT_LPAREN] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [3084] = {
    [sym_file_descriptor] = ACTIONS(3911),
    [sym__concat] = ACTIONS(3911),
    [sym_variable_name] = ACTIONS(3911),
    [anon_sym_esac] = ACTIONS(3913),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_GT] = ACTIONS(3913),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3913),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3913),
  },
  [3085] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7186),
    [sym_comment] = ACTIONS(53),
  },
  [3086] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7188),
    [sym_comment] = ACTIONS(53),
  },
  [3087] = {
    [anon_sym_RBRACE] = ACTIONS(7188),
    [sym_comment] = ACTIONS(53),
  },
  [3088] = {
    [sym_concatenation] = STATE(3149),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3149),
    [anon_sym_RBRACE] = ACTIONS(7190),
    [anon_sym_EQ] = ACTIONS(7192),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7192),
    [anon_sym_COLON_QMARK] = ACTIONS(7192),
    [anon_sym_COLON_DASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3089] = {
    [sym_file_descriptor] = ACTIONS(3975),
    [sym__concat] = ACTIONS(3975),
    [sym_variable_name] = ACTIONS(3975),
    [anon_sym_esac] = ACTIONS(3977),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [anon_sym_PIPE_AMP] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3977),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_GT_GT] = ACTIONS(3975),
    [anon_sym_AMP_GT] = ACTIONS(3977),
    [anon_sym_AMP_GT_GT] = ACTIONS(3975),
    [anon_sym_LT_AMP] = ACTIONS(3975),
    [anon_sym_GT_AMP] = ACTIONS(3975),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3977),
  },
  [3090] = {
    [sym_concatenation] = STATE(3151),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3151),
    [anon_sym_RBRACE] = ACTIONS(7196),
    [anon_sym_EQ] = ACTIONS(7198),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7198),
    [anon_sym_COLON_QMARK] = ACTIONS(7198),
    [anon_sym_COLON_DASH] = ACTIONS(7198),
    [anon_sym_PERCENT] = ACTIONS(7198),
    [anon_sym_DASH] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3091] = {
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [sym_variable_name] = ACTIONS(3985),
    [anon_sym_esac] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3987),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [3092] = {
    [sym_concatenation] = STATE(3153),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3153),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [anon_sym_EQ] = ACTIONS(7204),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7204),
    [anon_sym_COLON_QMARK] = ACTIONS(7204),
    [anon_sym_COLON_DASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3093] = {
    [sym_file_descriptor] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [sym_variable_name] = ACTIONS(4040),
    [anon_sym_esac] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [anon_sym_PIPE_AMP] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_GT_GT] = ACTIONS(4040),
    [anon_sym_AMP_GT] = ACTIONS(4042),
    [anon_sym_AMP_GT_GT] = ACTIONS(4040),
    [anon_sym_LT_AMP] = ACTIONS(4040),
    [anon_sym_GT_AMP] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4042),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [3094] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7208),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3095] = {
    [sym_file_descriptor] = ACTIONS(4062),
    [sym__concat] = ACTIONS(4062),
    [sym_variable_name] = ACTIONS(4062),
    [anon_sym_esac] = ACTIONS(4064),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_GT_GT] = ACTIONS(4062),
    [anon_sym_AMP_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT_GT] = ACTIONS(4062),
    [anon_sym_LT_AMP] = ACTIONS(4062),
    [anon_sym_GT_AMP] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [sym_raw_string] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4062),
    [anon_sym_LT_LPAREN] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [3096] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7210),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3097] = {
    [sym_file_descriptor] = ACTIONS(4068),
    [sym__concat] = ACTIONS(4068),
    [sym_variable_name] = ACTIONS(4068),
    [anon_sym_esac] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [anon_sym_PIPE_AMP] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4068),
    [anon_sym_AMP_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT_GT] = ACTIONS(4068),
    [anon_sym_LT_AMP] = ACTIONS(4068),
    [anon_sym_GT_AMP] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [sym_raw_string] = ACTIONS(4068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4068),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [3098] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7212),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3099] = {
    [sym_file_descriptor] = ACTIONS(4074),
    [sym__concat] = ACTIONS(4074),
    [sym_variable_name] = ACTIONS(4074),
    [anon_sym_esac] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_AMP_GT] = ACTIONS(4076),
    [anon_sym_AMP_GT_GT] = ACTIONS(4074),
    [anon_sym_LT_AMP] = ACTIONS(4074),
    [anon_sym_GT_AMP] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(4076),
    [sym_raw_string] = ACTIONS(4074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_LT_LPAREN] = ACTIONS(4074),
    [anon_sym_GT_LPAREN] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [3100] = {
    [sym_file_descriptor] = ACTIONS(4098),
    [sym__concat] = ACTIONS(4098),
    [sym_variable_name] = ACTIONS(4098),
    [anon_sym_esac] = ACTIONS(4100),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [anon_sym_PIPE_AMP] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4100),
    [anon_sym_GT] = ACTIONS(4100),
    [anon_sym_GT_GT] = ACTIONS(4098),
    [anon_sym_AMP_GT] = ACTIONS(4100),
    [anon_sym_AMP_GT_GT] = ACTIONS(4098),
    [anon_sym_LT_AMP] = ACTIONS(4098),
    [anon_sym_GT_AMP] = ACTIONS(4098),
    [sym__special_characters] = ACTIONS(4098),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4098),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(4098),
    [anon_sym_GT_LPAREN] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
  },
  [3101] = {
    [aux_sym_concatenation_repeat1] = STATE(3101),
    [sym__concat] = ACTIONS(3326),
    [anon_sym_esac] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [3102] = {
    [aux_sym_concatenation_repeat1] = STATE(3102),
    [sym_file_descriptor] = ACTIONS(1664),
    [sym__concat] = ACTIONS(5389),
    [anon_sym_esac] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_SEMI_SEMI] = ACTIONS(1664),
    [anon_sym_PIPE_AMP] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1666),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_AMP_GT] = ACTIONS(1666),
    [anon_sym_AMP_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_AMP] = ACTIONS(1664),
    [anon_sym_GT_AMP] = ACTIONS(1664),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT_LT_DASH] = ACTIONS(1664),
    [anon_sym_LT_LT_LT] = ACTIONS(1664),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_LF] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1666),
  },
  [3103] = {
    [sym__concat] = ACTIONS(4885),
    [sym_variable_name] = ACTIONS(4885),
    [anon_sym_esac] = ACTIONS(4887),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [anon_sym_PIPE_AMP] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [sym__special_characters] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4887),
    [sym_word] = ACTIONS(4887),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4887),
  },
  [3104] = {
    [sym__concat] = ACTIONS(4889),
    [sym_variable_name] = ACTIONS(4889),
    [anon_sym_esac] = ACTIONS(4891),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [anon_sym_PIPE_AMP] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [sym__special_characters] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4891),
    [sym_word] = ACTIONS(4891),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4891),
  },
  [3105] = {
    [sym__concat] = ACTIONS(4893),
    [sym_variable_name] = ACTIONS(4893),
    [anon_sym_esac] = ACTIONS(4895),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [sym__special_characters] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4895),
    [sym_word] = ACTIONS(4895),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [3106] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7214),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3107] = {
    [sym__concat] = ACTIONS(4899),
    [sym_variable_name] = ACTIONS(4899),
    [anon_sym_esac] = ACTIONS(4901),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [anon_sym_PIPE_AMP] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [sym__special_characters] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4901),
    [sym_word] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4901),
  },
  [3108] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7216),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3109] = {
    [sym__concat] = ACTIONS(4905),
    [sym_variable_name] = ACTIONS(4905),
    [anon_sym_esac] = ACTIONS(4907),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [anon_sym_PIPE_AMP] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [sym__special_characters] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4907),
    [sym_word] = ACTIONS(4907),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4907),
  },
  [3110] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7218),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3111] = {
    [sym__concat] = ACTIONS(4947),
    [sym_variable_name] = ACTIONS(4947),
    [anon_sym_esac] = ACTIONS(4949),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [sym__special_characters] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4949),
    [sym_word] = ACTIONS(4949),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4949),
  },
  [3112] = {
    [sym__concat] = ACTIONS(4955),
    [sym_variable_name] = ACTIONS(4955),
    [anon_sym_esac] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [anon_sym_PIPE_AMP] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [sym__special_characters] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4957),
    [sym_word] = ACTIONS(4957),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4957),
  },
  [3113] = {
    [sym__concat] = ACTIONS(4959),
    [sym_variable_name] = ACTIONS(4959),
    [anon_sym_esac] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [anon_sym_PIPE_AMP] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4961),
    [sym_word] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4961),
  },
  [3114] = {
    [sym__concat] = ACTIONS(4885),
    [anon_sym_esac] = ACTIONS(4887),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [anon_sym_PIPE_AMP] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [sym__special_characters] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4887),
    [sym_word] = ACTIONS(4887),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4887),
  },
  [3115] = {
    [sym__concat] = ACTIONS(4889),
    [anon_sym_esac] = ACTIONS(4891),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [anon_sym_PIPE_AMP] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [sym__special_characters] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4891),
    [sym_word] = ACTIONS(4891),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4891),
  },
  [3116] = {
    [sym__concat] = ACTIONS(4893),
    [anon_sym_esac] = ACTIONS(4895),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [sym__special_characters] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4895),
    [sym_word] = ACTIONS(4895),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [3117] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7220),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3118] = {
    [sym__concat] = ACTIONS(4899),
    [anon_sym_esac] = ACTIONS(4901),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [anon_sym_PIPE_AMP] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [sym__special_characters] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4901),
    [sym_word] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4901),
  },
  [3119] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7222),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3120] = {
    [sym__concat] = ACTIONS(4905),
    [anon_sym_esac] = ACTIONS(4907),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [anon_sym_PIPE_AMP] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [sym__special_characters] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4907),
    [sym_word] = ACTIONS(4907),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4907),
  },
  [3121] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3122] = {
    [sym__concat] = ACTIONS(4947),
    [anon_sym_esac] = ACTIONS(4949),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [sym__special_characters] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4949),
    [sym_word] = ACTIONS(4949),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4949),
  },
  [3123] = {
    [sym__concat] = ACTIONS(4955),
    [anon_sym_esac] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [anon_sym_PIPE_AMP] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [sym__special_characters] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4957),
    [sym_word] = ACTIONS(4957),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4957),
  },
  [3124] = {
    [sym__concat] = ACTIONS(4959),
    [anon_sym_esac] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [anon_sym_PIPE_AMP] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4961),
    [sym_word] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4961),
  },
  [3125] = {
    [sym__simple_heredoc_body] = ACTIONS(5524),
    [sym__heredoc_body_beginning] = ACTIONS(5524),
    [sym_file_descriptor] = ACTIONS(5524),
    [sym__concat] = ACTIONS(5524),
    [anon_sym_esac] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [anon_sym_PIPE_AMP] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_EQ_TILDE] = ACTIONS(5526),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5526),
    [anon_sym_GT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_AMP_GT] = ACTIONS(5526),
    [anon_sym_AMP_GT_GT] = ACTIONS(5524),
    [anon_sym_LT_AMP] = ACTIONS(5524),
    [anon_sym_GT_AMP] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_LT_LT_DASH] = ACTIONS(5524),
    [anon_sym_LT_LT_LT] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5526),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5526),
  },
  [3126] = {
    [sym__simple_heredoc_body] = ACTIONS(5528),
    [sym__heredoc_body_beginning] = ACTIONS(5528),
    [sym_file_descriptor] = ACTIONS(5528),
    [sym__concat] = ACTIONS(5528),
    [anon_sym_esac] = ACTIONS(5530),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [anon_sym_PIPE_AMP] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_EQ_TILDE] = ACTIONS(5530),
    [anon_sym_EQ_EQ] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5530),
    [anon_sym_GT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_AMP_GT] = ACTIONS(5530),
    [anon_sym_AMP_GT_GT] = ACTIONS(5528),
    [anon_sym_LT_AMP] = ACTIONS(5528),
    [anon_sym_GT_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5530),
    [anon_sym_LT_LT_DASH] = ACTIONS(5528),
    [anon_sym_LT_LT_LT] = ACTIONS(5528),
    [sym__special_characters] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5530),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5530),
  },
  [3127] = {
    [sym__simple_heredoc_body] = ACTIONS(5532),
    [sym__heredoc_body_beginning] = ACTIONS(5532),
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_EQ_TILDE] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5532),
    [anon_sym_LT_AMP] = ACTIONS(5532),
    [anon_sym_GT_AMP] = ACTIONS(5532),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_LT_LT_DASH] = ACTIONS(5532),
    [anon_sym_LT_LT_LT] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [3128] = {
    [sym__simple_heredoc_body] = ACTIONS(3903),
    [sym__heredoc_body_beginning] = ACTIONS(3903),
    [sym_file_descriptor] = ACTIONS(3903),
    [sym__concat] = ACTIONS(3903),
    [anon_sym_esac] = ACTIONS(3903),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_GT_GT] = ACTIONS(3903),
    [anon_sym_AMP_GT] = ACTIONS(3905),
    [anon_sym_AMP_GT_GT] = ACTIONS(3903),
    [anon_sym_LT_AMP] = ACTIONS(3903),
    [anon_sym_GT_AMP] = ACTIONS(3903),
    [anon_sym_LT_LT] = ACTIONS(3905),
    [anon_sym_LT_LT_DASH] = ACTIONS(3903),
    [anon_sym_LT_LT_LT] = ACTIONS(3903),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [3129] = {
    [sym__simple_heredoc_body] = ACTIONS(3911),
    [sym__heredoc_body_beginning] = ACTIONS(3911),
    [sym_file_descriptor] = ACTIONS(3911),
    [sym__concat] = ACTIONS(3911),
    [anon_sym_esac] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_GT] = ACTIONS(3913),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3913),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3913),
    [anon_sym_LT_LT_DASH] = ACTIONS(3911),
    [anon_sym_LT_LT_LT] = ACTIONS(3911),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_LF] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3913),
  },
  [3130] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7226),
    [sym_comment] = ACTIONS(53),
  },
  [3131] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(7228),
    [sym_comment] = ACTIONS(53),
  },
  [3132] = {
    [anon_sym_RBRACE] = ACTIONS(7228),
    [sym_comment] = ACTIONS(53),
  },
  [3133] = {
    [sym_concatenation] = STATE(3166),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3166),
    [anon_sym_RBRACE] = ACTIONS(7230),
    [anon_sym_EQ] = ACTIONS(7232),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7234),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7232),
    [anon_sym_COLON_QMARK] = ACTIONS(7232),
    [anon_sym_COLON_DASH] = ACTIONS(7232),
    [anon_sym_PERCENT] = ACTIONS(7232),
    [anon_sym_DASH] = ACTIONS(7232),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3134] = {
    [sym__simple_heredoc_body] = ACTIONS(3975),
    [sym__heredoc_body_beginning] = ACTIONS(3975),
    [sym_file_descriptor] = ACTIONS(3975),
    [sym__concat] = ACTIONS(3975),
    [anon_sym_esac] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_SEMI_SEMI] = ACTIONS(3975),
    [anon_sym_PIPE_AMP] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3977),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_GT_GT] = ACTIONS(3975),
    [anon_sym_AMP_GT] = ACTIONS(3977),
    [anon_sym_AMP_GT_GT] = ACTIONS(3975),
    [anon_sym_LT_AMP] = ACTIONS(3975),
    [anon_sym_GT_AMP] = ACTIONS(3975),
    [anon_sym_LT_LT] = ACTIONS(3977),
    [anon_sym_LT_LT_DASH] = ACTIONS(3975),
    [anon_sym_LT_LT_LT] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LF] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3977),
  },
  [3135] = {
    [sym_concatenation] = STATE(3168),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3168),
    [anon_sym_RBRACE] = ACTIONS(7236),
    [anon_sym_EQ] = ACTIONS(7238),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7240),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7238),
    [anon_sym_COLON_QMARK] = ACTIONS(7238),
    [anon_sym_COLON_DASH] = ACTIONS(7238),
    [anon_sym_PERCENT] = ACTIONS(7238),
    [anon_sym_DASH] = ACTIONS(7238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3136] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [anon_sym_esac] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [3137] = {
    [sym_concatenation] = STATE(3170),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(3170),
    [anon_sym_RBRACE] = ACTIONS(7242),
    [anon_sym_EQ] = ACTIONS(7244),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(7246),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(7244),
    [anon_sym_COLON_QMARK] = ACTIONS(7244),
    [anon_sym_COLON_DASH] = ACTIONS(7244),
    [anon_sym_PERCENT] = ACTIONS(7244),
    [anon_sym_DASH] = ACTIONS(7244),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3138] = {
    [sym__simple_heredoc_body] = ACTIONS(4040),
    [sym__heredoc_body_beginning] = ACTIONS(4040),
    [sym_file_descriptor] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_esac] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [anon_sym_PIPE_AMP] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_GT_GT] = ACTIONS(4040),
    [anon_sym_AMP_GT] = ACTIONS(4042),
    [anon_sym_AMP_GT_GT] = ACTIONS(4040),
    [anon_sym_LT_AMP] = ACTIONS(4040),
    [anon_sym_GT_AMP] = ACTIONS(4040),
    [anon_sym_LT_LT] = ACTIONS(4042),
    [anon_sym_LT_LT_DASH] = ACTIONS(4040),
    [anon_sym_LT_LT_LT] = ACTIONS(4040),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [3139] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7248),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3140] = {
    [sym__simple_heredoc_body] = ACTIONS(4062),
    [sym__heredoc_body_beginning] = ACTIONS(4062),
    [sym_file_descriptor] = ACTIONS(4062),
    [sym__concat] = ACTIONS(4062),
    [anon_sym_esac] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_GT_GT] = ACTIONS(4062),
    [anon_sym_AMP_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT_GT] = ACTIONS(4062),
    [anon_sym_LT_AMP] = ACTIONS(4062),
    [anon_sym_GT_AMP] = ACTIONS(4062),
    [anon_sym_LT_LT] = ACTIONS(4064),
    [anon_sym_LT_LT_DASH] = ACTIONS(4062),
    [anon_sym_LT_LT_LT] = ACTIONS(4062),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [3141] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7250),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3142] = {
    [sym__simple_heredoc_body] = ACTIONS(4068),
    [sym__heredoc_body_beginning] = ACTIONS(4068),
    [sym_file_descriptor] = ACTIONS(4068),
    [sym__concat] = ACTIONS(4068),
    [anon_sym_esac] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI_SEMI] = ACTIONS(4068),
    [anon_sym_PIPE_AMP] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4068),
    [anon_sym_AMP_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT_GT] = ACTIONS(4068),
    [anon_sym_LT_AMP] = ACTIONS(4068),
    [anon_sym_GT_AMP] = ACTIONS(4068),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_LT_LT_DASH] = ACTIONS(4068),
    [anon_sym_LT_LT_LT] = ACTIONS(4068),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [3143] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7252),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3144] = {
    [sym__simple_heredoc_body] = ACTIONS(4074),
    [sym__heredoc_body_beginning] = ACTIONS(4074),
    [sym_file_descriptor] = ACTIONS(4074),
    [sym__concat] = ACTIONS(4074),
    [anon_sym_esac] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4076),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_AMP_GT] = ACTIONS(4076),
    [anon_sym_AMP_GT_GT] = ACTIONS(4074),
    [anon_sym_LT_AMP] = ACTIONS(4074),
    [anon_sym_GT_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_LT_LT_DASH] = ACTIONS(4074),
    [anon_sym_LT_LT_LT] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [3145] = {
    [sym__simple_heredoc_body] = ACTIONS(4098),
    [sym__heredoc_body_beginning] = ACTIONS(4098),
    [sym_file_descriptor] = ACTIONS(4098),
    [sym__concat] = ACTIONS(4098),
    [anon_sym_esac] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(4100),
    [anon_sym_SEMI_SEMI] = ACTIONS(4098),
    [anon_sym_PIPE_AMP] = ACTIONS(4098),
    [anon_sym_AMP_AMP] = ACTIONS(4098),
    [anon_sym_PIPE_PIPE] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4100),
    [anon_sym_GT] = ACTIONS(4100),
    [anon_sym_GT_GT] = ACTIONS(4098),
    [anon_sym_AMP_GT] = ACTIONS(4100),
    [anon_sym_AMP_GT_GT] = ACTIONS(4098),
    [anon_sym_LT_AMP] = ACTIONS(4098),
    [anon_sym_GT_AMP] = ACTIONS(4098),
    [anon_sym_LT_LT] = ACTIONS(4100),
    [anon_sym_LT_LT_DASH] = ACTIONS(4098),
    [anon_sym_LT_LT_LT] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_LF] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
  },
  [3146] = {
    [sym_file_descriptor] = ACTIONS(4885),
    [sym__concat] = ACTIONS(4885),
    [sym_variable_name] = ACTIONS(4885),
    [anon_sym_esac] = ACTIONS(4887),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [anon_sym_PIPE_AMP] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_GT_GT] = ACTIONS(4885),
    [anon_sym_AMP_GT] = ACTIONS(4887),
    [anon_sym_AMP_GT_GT] = ACTIONS(4885),
    [anon_sym_LT_AMP] = ACTIONS(4885),
    [anon_sym_GT_AMP] = ACTIONS(4885),
    [sym__special_characters] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4885),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_LT_LPAREN] = ACTIONS(4885),
    [anon_sym_GT_LPAREN] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4887),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4887),
  },
  [3147] = {
    [sym_file_descriptor] = ACTIONS(4889),
    [sym__concat] = ACTIONS(4889),
    [sym_variable_name] = ACTIONS(4889),
    [anon_sym_esac] = ACTIONS(4891),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [anon_sym_PIPE_AMP] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_LT] = ACTIONS(4891),
    [anon_sym_GT] = ACTIONS(4891),
    [anon_sym_GT_GT] = ACTIONS(4889),
    [anon_sym_AMP_GT] = ACTIONS(4891),
    [anon_sym_AMP_GT_GT] = ACTIONS(4889),
    [anon_sym_LT_AMP] = ACTIONS(4889),
    [anon_sym_GT_AMP] = ACTIONS(4889),
    [sym__special_characters] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_BQUOTE] = ACTIONS(4889),
    [anon_sym_LT_LPAREN] = ACTIONS(4889),
    [anon_sym_GT_LPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4891),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4891),
  },
  [3148] = {
    [sym_file_descriptor] = ACTIONS(4893),
    [sym__concat] = ACTIONS(4893),
    [sym_variable_name] = ACTIONS(4893),
    [anon_sym_esac] = ACTIONS(4895),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [anon_sym_LT] = ACTIONS(4895),
    [anon_sym_GT] = ACTIONS(4895),
    [anon_sym_GT_GT] = ACTIONS(4893),
    [anon_sym_AMP_GT] = ACTIONS(4895),
    [anon_sym_AMP_GT_GT] = ACTIONS(4893),
    [anon_sym_LT_AMP] = ACTIONS(4893),
    [anon_sym_GT_AMP] = ACTIONS(4893),
    [sym__special_characters] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4895),
    [sym_raw_string] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_LT_LPAREN] = ACTIONS(4893),
    [anon_sym_GT_LPAREN] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4895),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [3149] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7254),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3150] = {
    [sym_file_descriptor] = ACTIONS(4899),
    [sym__concat] = ACTIONS(4899),
    [sym_variable_name] = ACTIONS(4899),
    [anon_sym_esac] = ACTIONS(4901),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [anon_sym_PIPE_AMP] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [anon_sym_LT] = ACTIONS(4901),
    [anon_sym_GT] = ACTIONS(4901),
    [anon_sym_GT_GT] = ACTIONS(4899),
    [anon_sym_AMP_GT] = ACTIONS(4901),
    [anon_sym_AMP_GT_GT] = ACTIONS(4899),
    [anon_sym_LT_AMP] = ACTIONS(4899),
    [anon_sym_GT_AMP] = ACTIONS(4899),
    [sym__special_characters] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [sym_raw_string] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4899),
    [anon_sym_LT_LPAREN] = ACTIONS(4899),
    [anon_sym_GT_LPAREN] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4901),
  },
  [3151] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7256),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3152] = {
    [sym_file_descriptor] = ACTIONS(4905),
    [sym__concat] = ACTIONS(4905),
    [sym_variable_name] = ACTIONS(4905),
    [anon_sym_esac] = ACTIONS(4907),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [anon_sym_PIPE_AMP] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_LT] = ACTIONS(4907),
    [anon_sym_GT] = ACTIONS(4907),
    [anon_sym_GT_GT] = ACTIONS(4905),
    [anon_sym_AMP_GT] = ACTIONS(4907),
    [anon_sym_AMP_GT_GT] = ACTIONS(4905),
    [anon_sym_LT_AMP] = ACTIONS(4905),
    [anon_sym_GT_AMP] = ACTIONS(4905),
    [sym__special_characters] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4905),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_LT_LPAREN] = ACTIONS(4905),
    [anon_sym_GT_LPAREN] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4907),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4907),
  },
  [3153] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7258),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3154] = {
    [sym_file_descriptor] = ACTIONS(4947),
    [sym__concat] = ACTIONS(4947),
    [sym_variable_name] = ACTIONS(4947),
    [anon_sym_esac] = ACTIONS(4949),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_LT] = ACTIONS(4949),
    [anon_sym_GT] = ACTIONS(4949),
    [anon_sym_GT_GT] = ACTIONS(4947),
    [anon_sym_AMP_GT] = ACTIONS(4949),
    [anon_sym_AMP_GT_GT] = ACTIONS(4947),
    [anon_sym_LT_AMP] = ACTIONS(4947),
    [anon_sym_GT_AMP] = ACTIONS(4947),
    [sym__special_characters] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4949),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4947),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(4947),
    [anon_sym_GT_LPAREN] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4949),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4949),
  },
  [3155] = {
    [sym_file_descriptor] = ACTIONS(4955),
    [sym__concat] = ACTIONS(4955),
    [sym_variable_name] = ACTIONS(4955),
    [anon_sym_esac] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [anon_sym_PIPE_AMP] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4957),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym_AMP_GT] = ACTIONS(4957),
    [anon_sym_AMP_GT_GT] = ACTIONS(4955),
    [anon_sym_LT_AMP] = ACTIONS(4955),
    [anon_sym_GT_AMP] = ACTIONS(4955),
    [sym__special_characters] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4955),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_LT_LPAREN] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4957),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4957),
  },
  [3156] = {
    [sym_file_descriptor] = ACTIONS(4959),
    [sym__concat] = ACTIONS(4959),
    [sym_variable_name] = ACTIONS(4959),
    [anon_sym_esac] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [anon_sym_PIPE_AMP] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym_AMP_GT] = ACTIONS(4961),
    [anon_sym_AMP_GT_GT] = ACTIONS(4959),
    [anon_sym_LT_AMP] = ACTIONS(4959),
    [anon_sym_GT_AMP] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4961),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(4959),
    [anon_sym_GT_LPAREN] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4961),
  },
  [3157] = {
    [sym__concat] = ACTIONS(5524),
    [sym_variable_name] = ACTIONS(5524),
    [anon_sym_esac] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [anon_sym_PIPE_AMP] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5526),
    [sym_word] = ACTIONS(5526),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5526),
  },
  [3158] = {
    [sym__concat] = ACTIONS(5528),
    [sym_variable_name] = ACTIONS(5528),
    [anon_sym_esac] = ACTIONS(5530),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [anon_sym_PIPE_AMP] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [sym__special_characters] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5530),
    [sym_word] = ACTIONS(5530),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5530),
  },
  [3159] = {
    [sym__concat] = ACTIONS(5532),
    [sym_variable_name] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5534),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [3160] = {
    [sym__concat] = ACTIONS(5524),
    [anon_sym_esac] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [anon_sym_PIPE_AMP] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5526),
    [sym_word] = ACTIONS(5526),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5526),
  },
  [3161] = {
    [sym__concat] = ACTIONS(5528),
    [anon_sym_esac] = ACTIONS(5530),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [anon_sym_PIPE_AMP] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [sym__special_characters] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5530),
    [sym_word] = ACTIONS(5530),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5530),
  },
  [3162] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5534),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [3163] = {
    [sym__simple_heredoc_body] = ACTIONS(4885),
    [sym__heredoc_body_beginning] = ACTIONS(4885),
    [sym_file_descriptor] = ACTIONS(4885),
    [sym__concat] = ACTIONS(4885),
    [anon_sym_esac] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_SEMI_SEMI] = ACTIONS(4885),
    [anon_sym_PIPE_AMP] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_GT_GT] = ACTIONS(4885),
    [anon_sym_AMP_GT] = ACTIONS(4887),
    [anon_sym_AMP_GT_GT] = ACTIONS(4885),
    [anon_sym_LT_AMP] = ACTIONS(4885),
    [anon_sym_GT_AMP] = ACTIONS(4885),
    [anon_sym_LT_LT] = ACTIONS(4887),
    [anon_sym_LT_LT_DASH] = ACTIONS(4885),
    [anon_sym_LT_LT_LT] = ACTIONS(4885),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4887),
  },
  [3164] = {
    [sym__simple_heredoc_body] = ACTIONS(4889),
    [sym__heredoc_body_beginning] = ACTIONS(4889),
    [sym_file_descriptor] = ACTIONS(4889),
    [sym__concat] = ACTIONS(4889),
    [anon_sym_esac] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_SEMI_SEMI] = ACTIONS(4889),
    [anon_sym_PIPE_AMP] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_LT] = ACTIONS(4891),
    [anon_sym_GT] = ACTIONS(4891),
    [anon_sym_GT_GT] = ACTIONS(4889),
    [anon_sym_AMP_GT] = ACTIONS(4891),
    [anon_sym_AMP_GT_GT] = ACTIONS(4889),
    [anon_sym_LT_AMP] = ACTIONS(4889),
    [anon_sym_GT_AMP] = ACTIONS(4889),
    [anon_sym_LT_LT] = ACTIONS(4891),
    [anon_sym_LT_LT_DASH] = ACTIONS(4889),
    [anon_sym_LT_LT_LT] = ACTIONS(4889),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4891),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4891),
  },
  [3165] = {
    [sym__simple_heredoc_body] = ACTIONS(4893),
    [sym__heredoc_body_beginning] = ACTIONS(4893),
    [sym_file_descriptor] = ACTIONS(4893),
    [sym__concat] = ACTIONS(4893),
    [anon_sym_esac] = ACTIONS(4893),
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_SEMI_SEMI] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [anon_sym_LT] = ACTIONS(4895),
    [anon_sym_GT] = ACTIONS(4895),
    [anon_sym_GT_GT] = ACTIONS(4893),
    [anon_sym_AMP_GT] = ACTIONS(4895),
    [anon_sym_AMP_GT_GT] = ACTIONS(4893),
    [anon_sym_LT_AMP] = ACTIONS(4893),
    [anon_sym_GT_AMP] = ACTIONS(4893),
    [anon_sym_LT_LT] = ACTIONS(4895),
    [anon_sym_LT_LT_DASH] = ACTIONS(4893),
    [anon_sym_LT_LT_LT] = ACTIONS(4893),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [3166] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7260),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3167] = {
    [sym__simple_heredoc_body] = ACTIONS(4899),
    [sym__heredoc_body_beginning] = ACTIONS(4899),
    [sym_file_descriptor] = ACTIONS(4899),
    [sym__concat] = ACTIONS(4899),
    [anon_sym_esac] = ACTIONS(4899),
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_SEMI_SEMI] = ACTIONS(4899),
    [anon_sym_PIPE_AMP] = ACTIONS(4899),
    [anon_sym_AMP_AMP] = ACTIONS(4899),
    [anon_sym_PIPE_PIPE] = ACTIONS(4899),
    [anon_sym_LT] = ACTIONS(4901),
    [anon_sym_GT] = ACTIONS(4901),
    [anon_sym_GT_GT] = ACTIONS(4899),
    [anon_sym_AMP_GT] = ACTIONS(4901),
    [anon_sym_AMP_GT_GT] = ACTIONS(4899),
    [anon_sym_LT_AMP] = ACTIONS(4899),
    [anon_sym_GT_AMP] = ACTIONS(4899),
    [anon_sym_LT_LT] = ACTIONS(4901),
    [anon_sym_LT_LT_DASH] = ACTIONS(4899),
    [anon_sym_LT_LT_LT] = ACTIONS(4899),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_LF] = ACTIONS(4899),
    [anon_sym_AMP] = ACTIONS(4901),
  },
  [3168] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7262),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3169] = {
    [sym__simple_heredoc_body] = ACTIONS(4905),
    [sym__heredoc_body_beginning] = ACTIONS(4905),
    [sym_file_descriptor] = ACTIONS(4905),
    [sym__concat] = ACTIONS(4905),
    [anon_sym_esac] = ACTIONS(4905),
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_SEMI_SEMI] = ACTIONS(4905),
    [anon_sym_PIPE_AMP] = ACTIONS(4905),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_LT] = ACTIONS(4907),
    [anon_sym_GT] = ACTIONS(4907),
    [anon_sym_GT_GT] = ACTIONS(4905),
    [anon_sym_AMP_GT] = ACTIONS(4907),
    [anon_sym_AMP_GT_GT] = ACTIONS(4905),
    [anon_sym_LT_AMP] = ACTIONS(4905),
    [anon_sym_GT_AMP] = ACTIONS(4905),
    [anon_sym_LT_LT] = ACTIONS(4907),
    [anon_sym_LT_LT_DASH] = ACTIONS(4905),
    [anon_sym_LT_LT_LT] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4907),
    [anon_sym_LF] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4907),
  },
  [3170] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(431),
    [sym_simple_expansion] = STATE(431),
    [sym_string_expansion] = STATE(431),
    [sym_expansion] = STATE(431),
    [sym_command_substitution] = STATE(431),
    [sym_process_substitution] = STATE(431),
    [aux_sym_expansion_repeat1] = STATE(891),
    [anon_sym_RBRACE] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(773),
    [anon_sym_BQUOTE] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(777),
    [anon_sym_GT_LPAREN] = ACTIONS(777),
    [sym_comment] = ACTIONS(243),
    [sym_word] = ACTIONS(779),
  },
  [3171] = {
    [sym__simple_heredoc_body] = ACTIONS(4947),
    [sym__heredoc_body_beginning] = ACTIONS(4947),
    [sym_file_descriptor] = ACTIONS(4947),
    [sym__concat] = ACTIONS(4947),
    [anon_sym_esac] = ACTIONS(4947),
    [anon_sym_PIPE] = ACTIONS(4949),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_LT] = ACTIONS(4949),
    [anon_sym_GT] = ACTIONS(4949),
    [anon_sym_GT_GT] = ACTIONS(4947),
    [anon_sym_AMP_GT] = ACTIONS(4949),
    [anon_sym_AMP_GT_GT] = ACTIONS(4947),
    [anon_sym_LT_AMP] = ACTIONS(4947),
    [anon_sym_GT_AMP] = ACTIONS(4947),
    [anon_sym_LT_LT] = ACTIONS(4949),
    [anon_sym_LT_LT_DASH] = ACTIONS(4947),
    [anon_sym_LT_LT_LT] = ACTIONS(4947),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LF] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4949),
  },
  [3172] = {
    [sym__simple_heredoc_body] = ACTIONS(4955),
    [sym__heredoc_body_beginning] = ACTIONS(4955),
    [sym_file_descriptor] = ACTIONS(4955),
    [sym__concat] = ACTIONS(4955),
    [anon_sym_esac] = ACTIONS(4955),
    [anon_sym_PIPE] = ACTIONS(4957),
    [anon_sym_SEMI_SEMI] = ACTIONS(4955),
    [anon_sym_PIPE_AMP] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4957),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym_AMP_GT] = ACTIONS(4957),
    [anon_sym_AMP_GT_GT] = ACTIONS(4955),
    [anon_sym_LT_AMP] = ACTIONS(4955),
    [anon_sym_GT_AMP] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4957),
    [anon_sym_LT_LT_DASH] = ACTIONS(4955),
    [anon_sym_LT_LT_LT] = ACTIONS(4955),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LF] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4957),
  },
  [3173] = {
    [sym__simple_heredoc_body] = ACTIONS(4959),
    [sym__heredoc_body_beginning] = ACTIONS(4959),
    [sym_file_descriptor] = ACTIONS(4959),
    [sym__concat] = ACTIONS(4959),
    [anon_sym_esac] = ACTIONS(4959),
    [anon_sym_PIPE] = ACTIONS(4961),
    [anon_sym_SEMI_SEMI] = ACTIONS(4959),
    [anon_sym_PIPE_AMP] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym_AMP_GT] = ACTIONS(4961),
    [anon_sym_AMP_GT_GT] = ACTIONS(4959),
    [anon_sym_LT_AMP] = ACTIONS(4959),
    [anon_sym_GT_AMP] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4961),
    [anon_sym_LT_LT_DASH] = ACTIONS(4959),
    [anon_sym_LT_LT_LT] = ACTIONS(4959),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym_LF] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4961),
  },
  [3174] = {
    [sym_file_descriptor] = ACTIONS(5524),
    [sym__concat] = ACTIONS(5524),
    [sym_variable_name] = ACTIONS(5524),
    [anon_sym_esac] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [anon_sym_PIPE_AMP] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_LT] = ACTIONS(5526),
    [anon_sym_GT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_AMP_GT] = ACTIONS(5526),
    [anon_sym_AMP_GT_GT] = ACTIONS(5524),
    [anon_sym_LT_AMP] = ACTIONS(5524),
    [anon_sym_GT_AMP] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(5524),
    [anon_sym_DQUOTE] = ACTIONS(5524),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5524),
    [anon_sym_BQUOTE] = ACTIONS(5524),
    [anon_sym_LT_LPAREN] = ACTIONS(5524),
    [anon_sym_GT_LPAREN] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5526),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5526),
  },
  [3175] = {
    [sym_file_descriptor] = ACTIONS(5528),
    [sym__concat] = ACTIONS(5528),
    [sym_variable_name] = ACTIONS(5528),
    [anon_sym_esac] = ACTIONS(5530),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [anon_sym_PIPE_AMP] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_LT] = ACTIONS(5530),
    [anon_sym_GT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_AMP_GT] = ACTIONS(5530),
    [anon_sym_AMP_GT_GT] = ACTIONS(5528),
    [anon_sym_LT_AMP] = ACTIONS(5528),
    [anon_sym_GT_AMP] = ACTIONS(5528),
    [sym__special_characters] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_DOLLAR] = ACTIONS(5530),
    [sym_raw_string] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5528),
    [anon_sym_BQUOTE] = ACTIONS(5528),
    [anon_sym_LT_LPAREN] = ACTIONS(5528),
    [anon_sym_GT_LPAREN] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5530),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5530),
  },
  [3176] = {
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [sym_variable_name] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5532),
    [anon_sym_LT_AMP] = ACTIONS(5532),
    [anon_sym_GT_AMP] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [3177] = {
    [sym__simple_heredoc_body] = ACTIONS(5524),
    [sym__heredoc_body_beginning] = ACTIONS(5524),
    [sym_file_descriptor] = ACTIONS(5524),
    [sym__concat] = ACTIONS(5524),
    [anon_sym_esac] = ACTIONS(5524),
    [anon_sym_PIPE] = ACTIONS(5526),
    [anon_sym_SEMI_SEMI] = ACTIONS(5524),
    [anon_sym_PIPE_AMP] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_LT] = ACTIONS(5526),
    [anon_sym_GT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_AMP_GT] = ACTIONS(5526),
    [anon_sym_AMP_GT_GT] = ACTIONS(5524),
    [anon_sym_LT_AMP] = ACTIONS(5524),
    [anon_sym_GT_AMP] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_LT_LT_DASH] = ACTIONS(5524),
    [anon_sym_LT_LT_LT] = ACTIONS(5524),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5526),
  },
  [3178] = {
    [sym__simple_heredoc_body] = ACTIONS(5528),
    [sym__heredoc_body_beginning] = ACTIONS(5528),
    [sym_file_descriptor] = ACTIONS(5528),
    [sym__concat] = ACTIONS(5528),
    [anon_sym_esac] = ACTIONS(5528),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_SEMI_SEMI] = ACTIONS(5528),
    [anon_sym_PIPE_AMP] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_LT] = ACTIONS(5530),
    [anon_sym_GT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_AMP_GT] = ACTIONS(5530),
    [anon_sym_AMP_GT_GT] = ACTIONS(5528),
    [anon_sym_LT_AMP] = ACTIONS(5528),
    [anon_sym_GT_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5530),
    [anon_sym_LT_LT_DASH] = ACTIONS(5528),
    [anon_sym_LT_LT_LT] = ACTIONS(5528),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LF] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5530),
  },
  [3179] = {
    [sym__simple_heredoc_body] = ACTIONS(5532),
    [sym__heredoc_body_beginning] = ACTIONS(5532),
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5532),
    [anon_sym_LT_AMP] = ACTIONS(5532),
    [anon_sym_GT_AMP] = ACTIONS(5532),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_LT_LT_DASH] = ACTIONS(5532),
    [anon_sym_LT_LT_LT] = ACTIONS(5532),
    [sym_comment] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [11] = {.count = 1, .reusable = false}, SHIFT(4),
  [13] = {.count = 1, .reusable = false}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = true}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = false}, SHIFT(11),
  [27] = {.count = 1, .reusable = true}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = false}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = true}, SHIFT(15),
  [37] = {.count = 1, .reusable = false}, SHIFT(16),
  [39] = {.count = 1, .reusable = true}, SHIFT(17),
  [41] = {.count = 1, .reusable = false}, SHIFT(18),
  [43] = {.count = 1, .reusable = true}, SHIFT(19),
  [45] = {.count = 1, .reusable = true}, SHIFT(20),
  [47] = {.count = 1, .reusable = true}, SHIFT(21),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT(23),
  [53] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [55] = {.count = 1, .reusable = false}, SHIFT(24),
  [57] = {.count = 1, .reusable = false}, SHIFT(34),
  [59] = {.count = 1, .reusable = true}, SHIFT(34),
  [61] = {.count = 1, .reusable = true}, SHIFT(35),
  [63] = {.count = 1, .reusable = true}, SHIFT(36),
  [65] = {.count = 1, .reusable = true}, SHIFT(37),
  [67] = {.count = 1, .reusable = true}, SHIFT(38),
  [69] = {.count = 1, .reusable = true}, SHIFT(43),
  [71] = {.count = 1, .reusable = true}, SHIFT(44),
  [73] = {.count = 1, .reusable = false}, SHIFT(45),
  [75] = {.count = 1, .reusable = true}, SHIFT(46),
  [77] = {.count = 1, .reusable = true}, SHIFT(47),
  [79] = {.count = 1, .reusable = true}, SHIFT(48),
  [81] = {.count = 1, .reusable = true}, SHIFT(49),
  [83] = {.count = 1, .reusable = true}, SHIFT(50),
  [85] = {.count = 1, .reusable = true}, SHIFT(52),
  [87] = {.count = 1, .reusable = true}, SHIFT(53),
  [89] = {.count = 1, .reusable = false}, SHIFT(54),
  [91] = {.count = 1, .reusable = false}, SHIFT(55),
  [93] = {.count = 1, .reusable = false}, SHIFT(56),
  [95] = {.count = 1, .reusable = false}, SHIFT(57),
  [97] = {.count = 1, .reusable = true}, SHIFT(58),
  [99] = {.count = 1, .reusable = false}, SHIFT(59),
  [101] = {.count = 1, .reusable = false}, SHIFT(60),
  [103] = {.count = 1, .reusable = false}, SHIFT(61),
  [105] = {.count = 1, .reusable = true}, SHIFT(62),
  [107] = {.count = 1, .reusable = false}, SHIFT(63),
  [109] = {.count = 1, .reusable = true}, SHIFT(70),
  [111] = {.count = 1, .reusable = true}, SHIFT(73),
  [113] = {.count = 1, .reusable = false}, SHIFT(74),
  [115] = {.count = 1, .reusable = true}, SHIFT(75),
  [117] = {.count = 1, .reusable = true}, SHIFT(76),
  [119] = {.count = 1, .reusable = false}, SHIFT(77),
  [121] = {.count = 1, .reusable = true}, SHIFT(78),
  [123] = {.count = 1, .reusable = true}, SHIFT(79),
  [125] = {.count = 1, .reusable = true}, SHIFT(80),
  [127] = {.count = 1, .reusable = true}, SHIFT(81),
  [129] = {.count = 1, .reusable = true}, SHIFT(82),
  [131] = {.count = 1, .reusable = false}, SHIFT(78),
  [133] = {.count = 1, .reusable = true}, SHIFT(74),
  [135] = {.count = 1, .reusable = true}, SHIFT(84),
  [137] = {.count = 1, .reusable = false}, SHIFT(85),
  [139] = {.count = 1, .reusable = true}, SHIFT(86),
  [141] = {.count = 1, .reusable = true}, SHIFT(87),
  [143] = {.count = 1, .reusable = false}, SHIFT(88),
  [145] = {.count = 1, .reusable = true}, SHIFT(89),
  [147] = {.count = 1, .reusable = true}, SHIFT(90),
  [149] = {.count = 1, .reusable = true}, SHIFT(91),
  [151] = {.count = 1, .reusable = true}, SHIFT(92),
  [153] = {.count = 1, .reusable = true}, SHIFT(93),
  [155] = {.count = 1, .reusable = false}, SHIFT(89),
  [157] = {.count = 1, .reusable = true}, SHIFT(85),
  [159] = {.count = 1, .reusable = true}, SHIFT(95),
  [161] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [163] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [165] = {.count = 1, .reusable = true}, SHIFT(96),
  [167] = {.count = 1, .reusable = true}, SHIFT(97),
  [169] = {.count = 1, .reusable = false}, SHIFT(98),
  [171] = {.count = 1, .reusable = true}, SHIFT(99),
  [173] = {.count = 1, .reusable = true}, SHIFT(100),
  [175] = {.count = 1, .reusable = true}, SHIFT(101),
  [177] = {.count = 1, .reusable = true}, SHIFT(102),
  [179] = {.count = 1, .reusable = true}, SHIFT(103),
  [181] = {.count = 1, .reusable = false}, SHIFT(104),
  [183] = {.count = 1, .reusable = false}, SHIFT(99),
  [185] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [187] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [189] = {.count = 1, .reusable = true}, SHIFT(107),
  [191] = {.count = 1, .reusable = true}, SHIFT(108),
  [193] = {.count = 1, .reusable = false}, SHIFT(109),
  [195] = {.count = 1, .reusable = true}, SHIFT(110),
  [197] = {.count = 1, .reusable = true}, SHIFT(111),
  [199] = {.count = 1, .reusable = true}, SHIFT(112),
  [201] = {.count = 1, .reusable = true}, SHIFT(113),
  [203] = {.count = 1, .reusable = true}, SHIFT(114),
  [205] = {.count = 1, .reusable = false}, SHIFT(115),
  [207] = {.count = 1, .reusable = false}, SHIFT(110),
  [209] = {.count = 1, .reusable = true}, SHIFT(117),
  [211] = {.count = 1, .reusable = true}, SHIFT(118),
  [213] = {.count = 1, .reusable = false}, SHIFT(119),
  [215] = {.count = 1, .reusable = true}, SHIFT(120),
  [217] = {.count = 1, .reusable = true}, SHIFT(121),
  [219] = {.count = 1, .reusable = true}, SHIFT(122),
  [221] = {.count = 1, .reusable = true}, SHIFT(123),
  [223] = {.count = 1, .reusable = true}, SHIFT(124),
  [225] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [227] = {.count = 1, .reusable = true}, SHIFT(126),
  [229] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [231] = {.count = 1, .reusable = false}, SHIFT(128),
  [233] = {.count = 1, .reusable = false}, SHIFT(129),
  [235] = {.count = 1, .reusable = true}, SHIFT(130),
  [237] = {.count = 1, .reusable = false}, SHIFT(131),
  [239] = {.count = 1, .reusable = false}, SHIFT(132),
  [241] = {.count = 1, .reusable = false}, SHIFT(133),
  [243] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [245] = {.count = 1, .reusable = true}, SHIFT(135),
  [247] = {.count = 1, .reusable = true}, SHIFT(136),
  [249] = {.count = 1, .reusable = false}, SHIFT(137),
  [251] = {.count = 1, .reusable = false}, SHIFT(135),
  [253] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [255] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [257] = {.count = 1, .reusable = true}, SHIFT(138),
  [259] = {.count = 1, .reusable = true}, SHIFT(139),
  [261] = {.count = 1, .reusable = true}, SHIFT(140),
  [263] = {.count = 1, .reusable = false}, SHIFT(141),
  [265] = {.count = 1, .reusable = false}, SHIFT(140),
  [267] = {.count = 1, .reusable = false}, SHIFT(146),
  [269] = {.count = 1, .reusable = false}, SHIFT(147),
  [271] = {.count = 1, .reusable = false}, SHIFT(148),
  [273] = {.count = 1, .reusable = false}, SHIFT(149),
  [275] = {.count = 1, .reusable = true}, SHIFT(150),
  [277] = {.count = 1, .reusable = false}, SHIFT(151),
  [279] = {.count = 1, .reusable = false}, SHIFT(152),
  [281] = {.count = 1, .reusable = false}, SHIFT(153),
  [283] = {.count = 1, .reusable = true}, SHIFT(162),
  [285] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [287] = {.count = 1, .reusable = false}, SHIFT(163),
  [289] = {.count = 1, .reusable = true}, SHIFT(164),
  [291] = {.count = 1, .reusable = true}, SHIFT(163),
  [293] = {.count = 1, .reusable = true}, SHIFT(165),
  [295] = {.count = 1, .reusable = false}, SHIFT(164),
  [297] = {.count = 1, .reusable = true}, SHIFT(166),
  [299] = {.count = 1, .reusable = true}, SHIFT(167),
  [301] = {.count = 1, .reusable = true}, SHIFT(168),
  [303] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [305] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [307] = {.count = 1, .reusable = false}, SHIFT(169),
  [309] = {.count = 1, .reusable = false}, SHIFT(170),
  [311] = {.count = 1, .reusable = true}, SHIFT(170),
  [313] = {.count = 1, .reusable = false}, SHIFT(171),
  [315] = {.count = 1, .reusable = true}, SHIFT(171),
  [317] = {.count = 1, .reusable = true}, SHIFT(172),
  [319] = {.count = 1, .reusable = true}, SHIFT(173),
  [321] = {.count = 1, .reusable = true}, SHIFT(174),
  [323] = {.count = 1, .reusable = false}, SHIFT(174),
  [325] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [327] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [329] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [331] = {.count = 1, .reusable = true}, SHIFT(16),
  [333] = {.count = 1, .reusable = true}, SHIFT(181),
  [335] = {.count = 1, .reusable = true}, SHIFT(182),
  [337] = {.count = 1, .reusable = true}, SHIFT(184),
  [339] = {.count = 1, .reusable = true}, SHIFT(185),
  [341] = {.count = 1, .reusable = true}, SHIFT(187),
  [343] = {.count = 1, .reusable = true}, SHIFT(188),
  [345] = {.count = 1, .reusable = true}, SHIFT(189),
  [347] = {.count = 1, .reusable = true}, SHIFT(190),
  [349] = {.count = 1, .reusable = false}, SHIFT(191),
  [351] = {.count = 1, .reusable = true}, SHIFT(192),
  [353] = {.count = 1, .reusable = true}, SHIFT(193),
  [355] = {.count = 1, .reusable = true}, SHIFT(194),
  [357] = {.count = 1, .reusable = true}, SHIFT(195),
  [359] = {.count = 1, .reusable = true}, SHIFT(196),
  [361] = {.count = 1, .reusable = true}, SHIFT(197),
  [363] = {.count = 1, .reusable = true}, SHIFT(198),
  [365] = {.count = 1, .reusable = false}, SHIFT(199),
  [367] = {.count = 1, .reusable = true}, SHIFT(200),
  [369] = {.count = 1, .reusable = true}, SHIFT(201),
  [371] = {.count = 1, .reusable = false}, SHIFT(202),
  [373] = {.count = 1, .reusable = true}, SHIFT(203),
  [375] = {.count = 1, .reusable = true}, SHIFT(204),
  [377] = {.count = 1, .reusable = true}, SHIFT(205),
  [379] = {.count = 1, .reusable = true}, SHIFT(206),
  [381] = {.count = 1, .reusable = true}, SHIFT(207),
  [383] = {.count = 1, .reusable = false}, SHIFT(203),
  [385] = {.count = 1, .reusable = true}, SHIFT(199),
  [387] = {.count = 1, .reusable = false}, SHIFT(197),
  [389] = {.count = 1, .reusable = true}, SHIFT(209),
  [391] = {.count = 1, .reusable = true}, SHIFT(210),
  [393] = {.count = 1, .reusable = false}, SHIFT(210),
  [395] = {.count = 1, .reusable = true}, SHIFT(211),
  [397] = {.count = 1, .reusable = true}, SHIFT(213),
  [399] = {.count = 1, .reusable = false}, SHIFT(213),
  [401] = {.count = 1, .reusable = true}, SHIFT(214),
  [403] = {.count = 1, .reusable = true}, SHIFT(215),
  [405] = {.count = 1, .reusable = true}, SHIFT(216),
  [407] = {.count = 1, .reusable = true}, SHIFT(217),
  [409] = {.count = 1, .reusable = false}, SHIFT(217),
  [411] = {.count = 1, .reusable = false}, SHIFT(219),
  [413] = {.count = 1, .reusable = false}, SHIFT(220),
  [415] = {.count = 1, .reusable = true}, SHIFT(222),
  [417] = {.count = 1, .reusable = true}, SHIFT(223),
  [419] = {.count = 1, .reusable = false}, SHIFT(224),
  [421] = {.count = 1, .reusable = false}, SHIFT(222),
  [423] = {.count = 1, .reusable = true}, SHIFT(225),
  [425] = {.count = 1, .reusable = true}, SHIFT(226),
  [427] = {.count = 1, .reusable = false}, SHIFT(226),
  [429] = {.count = 1, .reusable = true}, SHIFT(227),
  [431] = {.count = 1, .reusable = true}, SHIFT(228),
  [433] = {.count = 1, .reusable = true}, SHIFT(229),
  [435] = {.count = 1, .reusable = false}, SHIFT(230),
  [437] = {.count = 1, .reusable = false}, SHIFT(229),
  [439] = {.count = 1, .reusable = true}, SHIFT(241),
  [441] = {.count = 1, .reusable = true}, SHIFT(242),
  [443] = {.count = 1, .reusable = true}, SHIFT(244),
  [445] = {.count = 1, .reusable = true}, SHIFT(246),
  [447] = {.count = 1, .reusable = true}, SHIFT(249),
  [449] = {.count = 1, .reusable = true}, SHIFT(250),
  [451] = {.count = 1, .reusable = true}, SHIFT(251),
  [453] = {.count = 1, .reusable = false}, SHIFT(251),
  [455] = {.count = 1, .reusable = true}, SHIFT(254),
  [457] = {.count = 1, .reusable = true}, SHIFT(255),
  [459] = {.count = 1, .reusable = false}, SHIFT(255),
  [461] = {.count = 1, .reusable = true}, SHIFT(258),
  [463] = {.count = 1, .reusable = false}, SHIFT(259),
  [465] = {.count = 1, .reusable = true}, SHIFT(260),
  [467] = {.count = 1, .reusable = true}, SHIFT(261),
  [469] = {.count = 1, .reusable = true}, SHIFT(259),
  [471] = {.count = 1, .reusable = true}, SHIFT(262),
  [473] = {.count = 1, .reusable = false}, SHIFT(261),
  [475] = {.count = 1, .reusable = true}, SHIFT(263),
  [477] = {.count = 1, .reusable = false}, SHIFT(264),
  [479] = {.count = 1, .reusable = false}, SHIFT(265),
  [481] = {.count = 1, .reusable = true}, SHIFT(265),
  [483] = {.count = 1, .reusable = true}, SHIFT(266),
  [485] = {.count = 1, .reusable = true}, SHIFT(267),
  [487] = {.count = 1, .reusable = true}, SHIFT(268),
  [489] = {.count = 1, .reusable = false}, SHIFT(268),
  [491] = {.count = 1, .reusable = true}, SHIFT(61),
  [493] = {.count = 1, .reusable = true}, SHIFT(275),
  [495] = {.count = 1, .reusable = true}, REDUCE(sym_negated_command, 2),
  [497] = {.count = 1, .reusable = false}, REDUCE(sym_negated_command, 2),
  [499] = {.count = 1, .reusable = false}, SHIFT(276),
  [501] = {.count = 1, .reusable = true}, SHIFT(277),
  [503] = {.count = 1, .reusable = true}, SHIFT(278),
  [505] = {.count = 1, .reusable = false}, SHIFT(278),
  [507] = {.count = 1, .reusable = true}, SHIFT(276),
  [509] = {.count = 1, .reusable = true}, SHIFT(281),
  [511] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [513] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [515] = {.count = 1, .reusable = false}, SHIFT(283),
  [517] = {.count = 1, .reusable = false}, SHIFT(284),
  [519] = {.count = 1, .reusable = true}, SHIFT(286),
  [521] = {.count = 1, .reusable = true}, SHIFT(287),
  [523] = {.count = 1, .reusable = false}, SHIFT(288),
  [525] = {.count = 1, .reusable = false}, SHIFT(286),
  [527] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [529] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [531] = {.count = 1, .reusable = true}, SHIFT(289),
  [533] = {.count = 1, .reusable = true}, SHIFT(290),
  [535] = {.count = 1, .reusable = true}, SHIFT(291),
  [537] = {.count = 1, .reusable = false}, SHIFT(292),
  [539] = {.count = 1, .reusable = false}, SHIFT(291),
  [541] = {.count = 1, .reusable = true}, SHIFT(303),
  [543] = {.count = 1, .reusable = true}, SHIFT(304),
  [545] = {.count = 1, .reusable = true}, SHIFT(305),
  [547] = {.count = 1, .reusable = false}, SHIFT(303),
  [549] = {.count = 1, .reusable = true}, SHIFT(308),
  [551] = {.count = 1, .reusable = false}, SHIFT(310),
  [553] = {.count = 1, .reusable = false}, SHIFT(311),
  [555] = {.count = 1, .reusable = true}, SHIFT(313),
  [557] = {.count = 1, .reusable = true}, SHIFT(314),
  [559] = {.count = 1, .reusable = false}, SHIFT(315),
  [561] = {.count = 1, .reusable = false}, SHIFT(313),
  [563] = {.count = 1, .reusable = true}, SHIFT(316),
  [565] = {.count = 1, .reusable = true}, SHIFT(317),
  [567] = {.count = 1, .reusable = true}, SHIFT(318),
  [569] = {.count = 1, .reusable = false}, SHIFT(319),
  [571] = {.count = 1, .reusable = false}, SHIFT(318),
  [573] = {.count = 1, .reusable = true}, SHIFT(330),
  [575] = {.count = 1, .reusable = true}, SHIFT(331),
  [577] = {.count = 1, .reusable = false}, SHIFT(330),
  [579] = {.count = 1, .reusable = true}, SHIFT(332),
  [581] = {.count = 1, .reusable = true}, SHIFT(333),
  [583] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [585] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [587] = {.count = 1, .reusable = false}, SHIFT(335),
  [589] = {.count = 1, .reusable = false}, SHIFT(336),
  [591] = {.count = 1, .reusable = true}, SHIFT(338),
  [593] = {.count = 1, .reusable = true}, SHIFT(339),
  [595] = {.count = 1, .reusable = false}, SHIFT(340),
  [597] = {.count = 1, .reusable = false}, SHIFT(338),
  [599] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [601] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [603] = {.count = 1, .reusable = true}, SHIFT(341),
  [605] = {.count = 1, .reusable = true}, SHIFT(342),
  [607] = {.count = 1, .reusable = true}, SHIFT(343),
  [609] = {.count = 1, .reusable = false}, SHIFT(344),
  [611] = {.count = 1, .reusable = false}, SHIFT(343),
  [613] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [615] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [617] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [619] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [621] = {.count = 1, .reusable = true}, SHIFT(356),
  [623] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [625] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [627] = {.count = 1, .reusable = false}, SHIFT(358),
  [629] = {.count = 1, .reusable = false}, SHIFT(359),
  [631] = {.count = 1, .reusable = true}, SHIFT(361),
  [633] = {.count = 1, .reusable = true}, SHIFT(362),
  [635] = {.count = 1, .reusable = false}, SHIFT(363),
  [637] = {.count = 1, .reusable = false}, SHIFT(361),
  [639] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [641] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [643] = {.count = 1, .reusable = true}, SHIFT(364),
  [645] = {.count = 1, .reusable = true}, SHIFT(365),
  [647] = {.count = 1, .reusable = true}, SHIFT(366),
  [649] = {.count = 1, .reusable = false}, SHIFT(367),
  [651] = {.count = 1, .reusable = false}, SHIFT(366),
  [653] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 2),
  [655] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 2),
  [657] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [659] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [661] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [663] = {.count = 1, .reusable = true}, SHIFT(379),
  [665] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [667] = {.count = 1, .reusable = false}, SHIFT(381),
  [669] = {.count = 1, .reusable = false}, SHIFT(382),
  [671] = {.count = 1, .reusable = true}, SHIFT(384),
  [673] = {.count = 1, .reusable = true}, SHIFT(385),
  [675] = {.count = 1, .reusable = false}, SHIFT(386),
  [677] = {.count = 1, .reusable = false}, SHIFT(384),
  [679] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [681] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [683] = {.count = 1, .reusable = true}, SHIFT(387),
  [685] = {.count = 1, .reusable = true}, SHIFT(388),
  [687] = {.count = 1, .reusable = true}, SHIFT(389),
  [689] = {.count = 1, .reusable = false}, SHIFT(390),
  [691] = {.count = 1, .reusable = false}, SHIFT(389),
  [693] = {.count = 1, .reusable = true}, SHIFT(401),
  [695] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [697] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [699] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [701] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [703] = {.count = 1, .reusable = false}, SHIFT(403),
  [705] = {.count = 1, .reusable = false}, SHIFT(404),
  [707] = {.count = 1, .reusable = false}, SHIFT(405),
  [709] = {.count = 1, .reusable = true}, SHIFT(404),
  [711] = {.count = 1, .reusable = false}, SHIFT(406),
  [713] = {.count = 1, .reusable = true}, SHIFT(407),
  [715] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [717] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [719] = {.count = 1, .reusable = true}, SHIFT(408),
  [721] = {.count = 1, .reusable = true}, SHIFT(409),
  [723] = {.count = 1, .reusable = true}, SHIFT(410),
  [725] = {.count = 1, .reusable = false}, SHIFT(411),
  [727] = {.count = 1, .reusable = false}, SHIFT(410),
  [729] = {.count = 1, .reusable = false}, SHIFT(419),
  [731] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [733] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [735] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [737] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [739] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [741] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [743] = {.count = 1, .reusable = true}, SHIFT(421),
  [745] = {.count = 1, .reusable = true}, SHIFT(422),
  [747] = {.count = 1, .reusable = true}, SHIFT(423),
  [749] = {.count = 1, .reusable = true}, SHIFT(424),
  [751] = {.count = 1, .reusable = false}, SHIFT(425),
  [753] = {.count = 1, .reusable = false}, SHIFT(424),
  [755] = {.count = 1, .reusable = true}, SHIFT(427),
  [757] = {.count = 1, .reusable = false}, SHIFT(437),
  [759] = {.count = 1, .reusable = false}, SHIFT(428),
  [761] = {.count = 1, .reusable = true}, SHIFT(429),
  [763] = {.count = 1, .reusable = false}, SHIFT(430),
  [765] = {.count = 1, .reusable = true}, SHIFT(431),
  [767] = {.count = 1, .reusable = true}, SHIFT(437),
  [769] = {.count = 1, .reusable = true}, SHIFT(432),
  [771] = {.count = 1, .reusable = true}, SHIFT(433),
  [773] = {.count = 1, .reusable = true}, SHIFT(434),
  [775] = {.count = 1, .reusable = true}, SHIFT(435),
  [777] = {.count = 1, .reusable = true}, SHIFT(436),
  [779] = {.count = 1, .reusable = false}, SHIFT(431),
  [781] = {.count = 1, .reusable = true}, SHIFT(438),
  [783] = {.count = 1, .reusable = false}, SHIFT(440),
  [785] = {.count = 1, .reusable = true}, SHIFT(440),
  [787] = {.count = 1, .reusable = true}, SHIFT(439),
  [789] = {.count = 1, .reusable = true}, SHIFT(441),
  [791] = {.count = 1, .reusable = false}, SHIFT(443),
  [793] = {.count = 1, .reusable = true}, SHIFT(443),
  [795] = {.count = 1, .reusable = true}, SHIFT(442),
  [797] = {.count = 1, .reusable = true}, SHIFT(444),
  [799] = {.count = 1, .reusable = true}, SHIFT(445),
  [801] = {.count = 1, .reusable = false}, SHIFT(445),
  [803] = {.count = 1, .reusable = true}, SHIFT(449),
  [805] = {.count = 1, .reusable = true}, SHIFT(454),
  [807] = {.count = 1, .reusable = false}, SHIFT(455),
  [809] = {.count = 1, .reusable = true}, SHIFT(456),
  [811] = {.count = 1, .reusable = true}, SHIFT(455),
  [813] = {.count = 1, .reusable = true}, SHIFT(457),
  [815] = {.count = 1, .reusable = false}, SHIFT(456),
  [817] = {.count = 1, .reusable = true}, SHIFT(458),
  [819] = {.count = 1, .reusable = false}, SHIFT(459),
  [821] = {.count = 1, .reusable = true}, SHIFT(459),
  [823] = {.count = 1, .reusable = true}, SHIFT(460),
  [825] = {.count = 1, .reusable = true}, SHIFT(466),
  [827] = {.count = 1, .reusable = true}, SHIFT(467),
  [829] = {.count = 1, .reusable = false}, SHIFT(467),
  [831] = {.count = 1, .reusable = true}, SHIFT(470),
  [833] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [835] = {.count = 1, .reusable = false}, REDUCE(sym__terminated_statement, 2),
  [837] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [839] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [841] = {.count = 1, .reusable = true}, SHIFT(478),
  [843] = {.count = 1, .reusable = true}, SHIFT(475),
  [845] = {.count = 1, .reusable = false}, SHIFT(476),
  [847] = {.count = 1, .reusable = true}, SHIFT(477),
  [849] = {.count = 1, .reusable = false}, SHIFT(479),
  [851] = {.count = 1, .reusable = true}, SHIFT(479),
  [853] = {.count = 1, .reusable = false}, SHIFT(480),
  [855] = {.count = 1, .reusable = false}, SHIFT(17),
  [857] = {.count = 1, .reusable = false}, SHIFT(481),
  [859] = {.count = 1, .reusable = false}, SHIFT(20),
  [861] = {.count = 1, .reusable = false}, SHIFT(21),
  [863] = {.count = 1, .reusable = false}, SHIFT(22),
  [865] = {.count = 1, .reusable = false}, SHIFT(23),
  [867] = {.count = 1, .reusable = false}, SHIFT(482),
  [869] = {.count = 1, .reusable = true}, SHIFT(483),
  [871] = {.count = 1, .reusable = true}, SHIFT(484),
  [873] = {.count = 1, .reusable = true}, SHIFT(486),
  [875] = {.count = 1, .reusable = true}, SHIFT(487),
  [877] = {.count = 1, .reusable = true}, SHIFT(488),
  [879] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [881] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [883] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [885] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [887] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [889] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [891] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [894] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [897] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [899] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [902] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [905] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [908] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [911] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [914] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [917] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [920] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [923] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [926] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [929] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [932] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [935] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [938] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [941] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [944] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [947] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [950] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [953] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [956] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(22),
  [959] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(23),
  [962] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(24),
  [965] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [968] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(70),
  [971] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(15),
  [974] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(15),
  [977] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [979] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [981] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [983] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [985] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [987] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [989] = {.count = 1, .reusable = true}, SHIFT(495),
  [991] = {.count = 1, .reusable = true}, SHIFT(496),
  [993] = {.count = 1, .reusable = true}, SHIFT(498),
  [995] = {.count = 1, .reusable = true}, SHIFT(499),
  [997] = {.count = 1, .reusable = true}, SHIFT(500),
  [999] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3),
  [1001] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3),
  [1003] = {.count = 1, .reusable = true}, SHIFT(501),
  [1005] = {.count = 1, .reusable = true}, SHIFT(502),
  [1007] = {.count = 1, .reusable = true}, SHIFT(503),
  [1009] = {.count = 1, .reusable = false}, SHIFT(504),
  [1011] = {.count = 1, .reusable = true}, SHIFT(505),
  [1013] = {.count = 1, .reusable = true}, SHIFT(506),
  [1015] = {.count = 1, .reusable = true}, SHIFT(507),
  [1017] = {.count = 1, .reusable = true}, SHIFT(508),
  [1019] = {.count = 1, .reusable = true}, SHIFT(509),
  [1021] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 6),
  [1023] = {.count = 1, .reusable = true}, SHIFT(511),
  [1025] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 6),
  [1027] = {.count = 1, .reusable = false}, SHIFT(513),
  [1029] = {.count = 1, .reusable = false}, SHIFT(514),
  [1031] = {.count = 1, .reusable = true}, SHIFT(516),
  [1033] = {.count = 1, .reusable = true}, SHIFT(517),
  [1035] = {.count = 1, .reusable = false}, SHIFT(518),
  [1037] = {.count = 1, .reusable = false}, SHIFT(516),
  [1039] = {.count = 1, .reusable = true}, SHIFT(519),
  [1041] = {.count = 1, .reusable = true}, SHIFT(520),
  [1043] = {.count = 1, .reusable = true}, SHIFT(521),
  [1045] = {.count = 1, .reusable = false}, SHIFT(522),
  [1047] = {.count = 1, .reusable = false}, SHIFT(521),
  [1049] = {.count = 1, .reusable = true}, SHIFT(533),
  [1051] = {.count = 1, .reusable = false}, SHIFT(533),
  [1053] = {.count = 1, .reusable = true}, SHIFT(537),
  [1055] = {.count = 1, .reusable = false}, SHIFT(539),
  [1057] = {.count = 1, .reusable = false}, SHIFT(540),
  [1059] = {.count = 1, .reusable = true}, SHIFT(542),
  [1061] = {.count = 1, .reusable = true}, SHIFT(543),
  [1063] = {.count = 1, .reusable = false}, SHIFT(544),
  [1065] = {.count = 1, .reusable = false}, SHIFT(542),
  [1067] = {.count = 1, .reusable = true}, SHIFT(545),
  [1069] = {.count = 1, .reusable = true}, SHIFT(546),
  [1071] = {.count = 1, .reusable = true}, SHIFT(547),
  [1073] = {.count = 1, .reusable = false}, SHIFT(548),
  [1075] = {.count = 1, .reusable = false}, SHIFT(547),
  [1077] = {.count = 1, .reusable = true}, SHIFT(559),
  [1079] = {.count = 1, .reusable = true}, SHIFT(560),
  [1081] = {.count = 1, .reusable = true}, SHIFT(561),
  [1083] = {.count = 1, .reusable = false}, SHIFT(560),
  [1085] = {.count = 1, .reusable = false}, SHIFT(559),
  [1087] = {.count = 1, .reusable = true}, SHIFT(562),
  [1089] = {.count = 1, .reusable = true}, SHIFT(563),
  [1091] = {.count = 1, .reusable = false}, SHIFT(564),
  [1093] = {.count = 1, .reusable = true}, SHIFT(565),
  [1095] = {.count = 1, .reusable = true}, SHIFT(566),
  [1097] = {.count = 1, .reusable = true}, SHIFT(567),
  [1099] = {.count = 1, .reusable = true}, SHIFT(568),
  [1101] = {.count = 1, .reusable = true}, SHIFT(569),
  [1103] = {.count = 1, .reusable = true}, SHIFT(571),
  [1105] = {.count = 1, .reusable = false}, SHIFT(573),
  [1107] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1109] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1111] = {.count = 1, .reusable = false}, SHIFT(577),
  [1113] = {.count = 1, .reusable = false}, SHIFT(578),
  [1115] = {.count = 1, .reusable = false}, SHIFT(579),
  [1117] = {.count = 1, .reusable = true}, SHIFT(584),
  [1119] = {.count = 1, .reusable = true}, SHIFT(585),
  [1121] = {.count = 1, .reusable = false}, SHIFT(585),
  [1123] = {.count = 1, .reusable = true}, SHIFT(586),
  [1125] = {.count = 1, .reusable = false}, SHIFT(588),
  [1127] = {.count = 1, .reusable = false}, SHIFT(589),
  [1129] = {.count = 1, .reusable = true}, SHIFT(590),
  [1131] = {.count = 1, .reusable = false}, SHIFT(590),
  [1133] = {.count = 1, .reusable = true}, SHIFT(591),
  [1135] = {.count = 1, .reusable = true}, SHIFT(592),
  [1137] = {.count = 1, .reusable = true}, SHIFT(593),
  [1139] = {.count = 1, .reusable = true}, SHIFT(594),
  [1141] = {.count = 1, .reusable = false}, SHIFT(595),
  [1143] = {.count = 1, .reusable = false}, SHIFT(594),
  [1145] = {.count = 1, .reusable = true}, SHIFT(597),
  [1147] = {.count = 1, .reusable = false}, SHIFT(599),
  [1149] = {.count = 1, .reusable = true}, SHIFT(599),
  [1151] = {.count = 1, .reusable = true}, SHIFT(598),
  [1153] = {.count = 1, .reusable = true}, SHIFT(600),
  [1155] = {.count = 1, .reusable = false}, SHIFT(602),
  [1157] = {.count = 1, .reusable = true}, SHIFT(602),
  [1159] = {.count = 1, .reusable = true}, SHIFT(601),
  [1161] = {.count = 1, .reusable = true}, SHIFT(603),
  [1163] = {.count = 1, .reusable = false}, SHIFT(605),
  [1165] = {.count = 1, .reusable = true}, SHIFT(605),
  [1167] = {.count = 1, .reusable = true}, SHIFT(604),
  [1169] = {.count = 1, .reusable = true}, SHIFT(606),
  [1171] = {.count = 1, .reusable = true}, SHIFT(607),
  [1173] = {.count = 1, .reusable = false}, SHIFT(607),
  [1175] = {.count = 1, .reusable = true}, SHIFT(610),
  [1177] = {.count = 1, .reusable = false}, SHIFT(610),
  [1179] = {.count = 1, .reusable = true}, SHIFT(613),
  [1181] = {.count = 1, .reusable = true}, SHIFT(614),
  [1183] = {.count = 1, .reusable = false}, SHIFT(614),
  [1185] = {.count = 1, .reusable = true}, SHIFT(617),
  [1187] = {.count = 1, .reusable = true}, SHIFT(618),
  [1189] = {.count = 1, .reusable = true}, SHIFT(622),
  [1191] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1193] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1195] = {.count = 1, .reusable = false}, SHIFT(623),
  [1197] = {.count = 1, .reusable = true}, SHIFT(623),
  [1199] = {.count = 1, .reusable = true}, SHIFT(625),
  [1201] = {.count = 1, .reusable = true}, SHIFT(626),
  [1203] = {.count = 1, .reusable = true}, SHIFT(628),
  [1205] = {.count = 1, .reusable = true}, SHIFT(630),
  [1207] = {.count = 1, .reusable = true}, SHIFT(631),
  [1209] = {.count = 1, .reusable = true}, SHIFT(637),
  [1211] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [1213] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [1215] = {.count = 1, .reusable = true}, SHIFT(638),
  [1217] = {.count = 1, .reusable = false}, SHIFT(641),
  [1219] = {.count = 1, .reusable = true}, SHIFT(641),
  [1221] = {.count = 1, .reusable = false}, SHIFT(642),
  [1223] = {.count = 1, .reusable = false}, SHIFT(643),
  [1225] = {.count = 1, .reusable = true}, SHIFT(644),
  [1227] = {.count = 1, .reusable = true}, SHIFT(645),
  [1229] = {.count = 1, .reusable = true}, SHIFT(646),
  [1231] = {.count = 1, .reusable = true}, SHIFT(647),
  [1233] = {.count = 1, .reusable = true}, SHIFT(651),
  [1235] = {.count = 1, .reusable = false}, SHIFT(651),
  [1237] = {.count = 1, .reusable = true}, SHIFT(653),
  [1239] = {.count = 1, .reusable = true}, SHIFT(654),
  [1241] = {.count = 1, .reusable = true}, SHIFT(655),
  [1243] = {.count = 1, .reusable = true}, SHIFT(656),
  [1245] = {.count = 1, .reusable = true}, SHIFT(659),
  [1247] = {.count = 1, .reusable = true}, SHIFT(660),
  [1249] = {.count = 1, .reusable = true}, SHIFT(661),
  [1251] = {.count = 1, .reusable = false}, SHIFT(660),
  [1253] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1255] = {.count = 1, .reusable = true}, SHIFT(662),
  [1257] = {.count = 1, .reusable = false}, SHIFT(664),
  [1259] = {.count = 1, .reusable = false}, SHIFT(665),
  [1261] = {.count = 1, .reusable = true}, SHIFT(666),
  [1263] = {.count = 1, .reusable = true}, SHIFT(667),
  [1265] = {.count = 1, .reusable = true}, SHIFT(668),
  [1267] = {.count = 1, .reusable = false}, SHIFT(669),
  [1269] = {.count = 1, .reusable = false}, SHIFT(668),
  [1271] = {.count = 1, .reusable = true}, SHIFT(671),
  [1273] = {.count = 1, .reusable = false}, SHIFT(673),
  [1275] = {.count = 1, .reusable = true}, SHIFT(673),
  [1277] = {.count = 1, .reusable = true}, SHIFT(672),
  [1279] = {.count = 1, .reusable = true}, SHIFT(674),
  [1281] = {.count = 1, .reusable = false}, SHIFT(676),
  [1283] = {.count = 1, .reusable = true}, SHIFT(676),
  [1285] = {.count = 1, .reusable = true}, SHIFT(675),
  [1287] = {.count = 1, .reusable = true}, SHIFT(677),
  [1289] = {.count = 1, .reusable = false}, SHIFT(679),
  [1291] = {.count = 1, .reusable = true}, SHIFT(679),
  [1293] = {.count = 1, .reusable = true}, SHIFT(678),
  [1295] = {.count = 1, .reusable = true}, SHIFT(680),
  [1297] = {.count = 1, .reusable = true}, SHIFT(681),
  [1299] = {.count = 1, .reusable = false}, SHIFT(681),
  [1301] = {.count = 1, .reusable = true}, SHIFT(684),
  [1303] = {.count = 1, .reusable = false}, SHIFT(684),
  [1305] = {.count = 1, .reusable = true}, SHIFT(687),
  [1307] = {.count = 1, .reusable = true}, SHIFT(688),
  [1309] = {.count = 1, .reusable = false}, SHIFT(688),
  [1311] = {.count = 1, .reusable = true}, SHIFT(692),
  [1313] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 3),
  [1315] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 3),
  [1317] = {.count = 1, .reusable = false}, SHIFT(693),
  [1319] = {.count = 1, .reusable = true}, SHIFT(693),
  [1321] = {.count = 1, .reusable = false}, SHIFT(694),
  [1323] = {.count = 1, .reusable = true}, SHIFT(694),
  [1325] = {.count = 1, .reusable = true}, SHIFT(695),
  [1327] = {.count = 1, .reusable = false}, SHIFT(73),
  [1329] = {.count = 1, .reusable = false}, SHIFT(75),
  [1331] = {.count = 1, .reusable = false}, SHIFT(76),
  [1333] = {.count = 1, .reusable = false}, SHIFT(79),
  [1335] = {.count = 1, .reusable = false}, SHIFT(80),
  [1337] = {.count = 1, .reusable = false}, SHIFT(81),
  [1339] = {.count = 1, .reusable = false}, SHIFT(82),
  [1341] = {.count = 1, .reusable = false}, SHIFT(697),
  [1343] = {.count = 1, .reusable = true}, SHIFT(698),
  [1345] = {.count = 1, .reusable = true}, SHIFT(699),
  [1347] = {.count = 1, .reusable = false}, SHIFT(701),
  [1349] = {.count = 1, .reusable = false}, SHIFT(702),
  [1351] = {.count = 1, .reusable = true}, SHIFT(703),
  [1353] = {.count = 1, .reusable = true}, SHIFT(704),
  [1355] = {.count = 1, .reusable = true}, SHIFT(705),
  [1357] = {.count = 1, .reusable = false}, SHIFT(706),
  [1359] = {.count = 1, .reusable = false}, SHIFT(705),
  [1361] = {.count = 1, .reusable = true}, SHIFT(708),
  [1363] = {.count = 1, .reusable = false}, SHIFT(710),
  [1365] = {.count = 1, .reusable = true}, SHIFT(710),
  [1367] = {.count = 1, .reusable = true}, SHIFT(709),
  [1369] = {.count = 1, .reusable = true}, SHIFT(711),
  [1371] = {.count = 1, .reusable = false}, SHIFT(713),
  [1373] = {.count = 1, .reusable = true}, SHIFT(713),
  [1375] = {.count = 1, .reusable = true}, SHIFT(712),
  [1377] = {.count = 1, .reusable = true}, SHIFT(714),
  [1379] = {.count = 1, .reusable = false}, SHIFT(716),
  [1381] = {.count = 1, .reusable = true}, SHIFT(716),
  [1383] = {.count = 1, .reusable = true}, SHIFT(715),
  [1385] = {.count = 1, .reusable = true}, SHIFT(717),
  [1387] = {.count = 1, .reusable = true}, SHIFT(718),
  [1389] = {.count = 1, .reusable = false}, SHIFT(718),
  [1391] = {.count = 1, .reusable = true}, SHIFT(721),
  [1393] = {.count = 1, .reusable = false}, SHIFT(721),
  [1395] = {.count = 1, .reusable = true}, SHIFT(724),
  [1397] = {.count = 1, .reusable = true}, SHIFT(725),
  [1399] = {.count = 1, .reusable = false}, SHIFT(725),
  [1401] = {.count = 1, .reusable = false}, SHIFT(84),
  [1403] = {.count = 1, .reusable = false}, SHIFT(86),
  [1405] = {.count = 1, .reusable = false}, SHIFT(87),
  [1407] = {.count = 1, .reusable = false}, SHIFT(90),
  [1409] = {.count = 1, .reusable = false}, SHIFT(91),
  [1411] = {.count = 1, .reusable = false}, SHIFT(92),
  [1413] = {.count = 1, .reusable = false}, SHIFT(93),
  [1415] = {.count = 1, .reusable = false}, SHIFT(729),
  [1417] = {.count = 1, .reusable = true}, SHIFT(730),
  [1419] = {.count = 1, .reusable = true}, SHIFT(731),
  [1421] = {.count = 1, .reusable = true}, SHIFT(732),
  [1423] = {.count = 1, .reusable = true}, SHIFT(733),
  [1425] = {.count = 1, .reusable = true}, SHIFT(734),
  [1427] = {.count = 1, .reusable = false}, SHIFT(736),
  [1429] = {.count = 1, .reusable = false}, SHIFT(737),
  [1431] = {.count = 1, .reusable = true}, SHIFT(738),
  [1433] = {.count = 1, .reusable = true}, SHIFT(739),
  [1435] = {.count = 1, .reusable = true}, SHIFT(740),
  [1437] = {.count = 1, .reusable = false}, SHIFT(741),
  [1439] = {.count = 1, .reusable = false}, SHIFT(740),
  [1441] = {.count = 1, .reusable = true}, SHIFT(743),
  [1443] = {.count = 1, .reusable = false}, SHIFT(745),
  [1445] = {.count = 1, .reusable = true}, SHIFT(745),
  [1447] = {.count = 1, .reusable = true}, SHIFT(744),
  [1449] = {.count = 1, .reusable = true}, SHIFT(746),
  [1451] = {.count = 1, .reusable = false}, SHIFT(748),
  [1453] = {.count = 1, .reusable = true}, SHIFT(748),
  [1455] = {.count = 1, .reusable = true}, SHIFT(747),
  [1457] = {.count = 1, .reusable = true}, SHIFT(749),
  [1459] = {.count = 1, .reusable = false}, SHIFT(751),
  [1461] = {.count = 1, .reusable = true}, SHIFT(751),
  [1463] = {.count = 1, .reusable = true}, SHIFT(750),
  [1465] = {.count = 1, .reusable = true}, SHIFT(752),
  [1467] = {.count = 1, .reusable = true}, SHIFT(753),
  [1469] = {.count = 1, .reusable = false}, SHIFT(753),
  [1471] = {.count = 1, .reusable = true}, SHIFT(756),
  [1473] = {.count = 1, .reusable = false}, SHIFT(756),
  [1475] = {.count = 1, .reusable = true}, SHIFT(759),
  [1477] = {.count = 1, .reusable = true}, SHIFT(760),
  [1479] = {.count = 1, .reusable = false}, SHIFT(760),
  [1481] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(95),
  [1484] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1486] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1488] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(96),
  [1491] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(97),
  [1494] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(98),
  [1497] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(99),
  [1500] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(100),
  [1503] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(101),
  [1506] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(102),
  [1509] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(103),
  [1512] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(104),
  [1515] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(99),
  [1518] = {.count = 1, .reusable = true}, SHIFT(763),
  [1520] = {.count = 1, .reusable = false}, SHIFT(765),
  [1522] = {.count = 1, .reusable = false}, SHIFT(766),
  [1524] = {.count = 1, .reusable = true}, SHIFT(767),
  [1526] = {.count = 1, .reusable = true}, SHIFT(768),
  [1528] = {.count = 1, .reusable = true}, SHIFT(769),
  [1530] = {.count = 1, .reusable = false}, SHIFT(770),
  [1532] = {.count = 1, .reusable = false}, SHIFT(769),
  [1534] = {.count = 1, .reusable = true}, SHIFT(772),
  [1536] = {.count = 1, .reusable = false}, SHIFT(774),
  [1538] = {.count = 1, .reusable = true}, SHIFT(774),
  [1540] = {.count = 1, .reusable = true}, SHIFT(773),
  [1542] = {.count = 1, .reusable = true}, SHIFT(775),
  [1544] = {.count = 1, .reusable = false}, SHIFT(777),
  [1546] = {.count = 1, .reusable = true}, SHIFT(777),
  [1548] = {.count = 1, .reusable = true}, SHIFT(776),
  [1550] = {.count = 1, .reusable = true}, SHIFT(778),
  [1552] = {.count = 1, .reusable = false}, SHIFT(780),
  [1554] = {.count = 1, .reusable = true}, SHIFT(780),
  [1556] = {.count = 1, .reusable = true}, SHIFT(779),
  [1558] = {.count = 1, .reusable = true}, SHIFT(781),
  [1560] = {.count = 1, .reusable = true}, SHIFT(782),
  [1562] = {.count = 1, .reusable = false}, SHIFT(782),
  [1564] = {.count = 1, .reusable = true}, SHIFT(785),
  [1566] = {.count = 1, .reusable = false}, SHIFT(785),
  [1568] = {.count = 1, .reusable = true}, SHIFT(788),
  [1570] = {.count = 1, .reusable = true}, SHIFT(789),
  [1572] = {.count = 1, .reusable = false}, SHIFT(789),
  [1574] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1576] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1578] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(107),
  [1581] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(108),
  [1584] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(109),
  [1587] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(110),
  [1590] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(111),
  [1593] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(112),
  [1596] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(113),
  [1599] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(114),
  [1602] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(115),
  [1605] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(110),
  [1608] = {.count = 1, .reusable = true}, SHIFT(792),
  [1610] = {.count = 1, .reusable = false}, SHIFT(794),
  [1612] = {.count = 1, .reusable = false}, SHIFT(795),
  [1614] = {.count = 1, .reusable = true}, SHIFT(796),
  [1616] = {.count = 1, .reusable = true}, SHIFT(797),
  [1618] = {.count = 1, .reusable = true}, SHIFT(798),
  [1620] = {.count = 1, .reusable = false}, SHIFT(799),
  [1622] = {.count = 1, .reusable = false}, SHIFT(798),
  [1624] = {.count = 1, .reusable = true}, SHIFT(801),
  [1626] = {.count = 1, .reusable = false}, SHIFT(803),
  [1628] = {.count = 1, .reusable = true}, SHIFT(803),
  [1630] = {.count = 1, .reusable = true}, SHIFT(802),
  [1632] = {.count = 1, .reusable = true}, SHIFT(804),
  [1634] = {.count = 1, .reusable = false}, SHIFT(806),
  [1636] = {.count = 1, .reusable = true}, SHIFT(806),
  [1638] = {.count = 1, .reusable = true}, SHIFT(805),
  [1640] = {.count = 1, .reusable = true}, SHIFT(807),
  [1642] = {.count = 1, .reusable = false}, SHIFT(809),
  [1644] = {.count = 1, .reusable = true}, SHIFT(809),
  [1646] = {.count = 1, .reusable = true}, SHIFT(808),
  [1648] = {.count = 1, .reusable = true}, SHIFT(810),
  [1650] = {.count = 1, .reusable = true}, SHIFT(811),
  [1652] = {.count = 1, .reusable = false}, SHIFT(811),
  [1654] = {.count = 1, .reusable = true}, SHIFT(814),
  [1656] = {.count = 1, .reusable = false}, SHIFT(814),
  [1658] = {.count = 1, .reusable = true}, SHIFT(817),
  [1660] = {.count = 1, .reusable = true}, SHIFT(818),
  [1662] = {.count = 1, .reusable = false}, SHIFT(818),
  [1664] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1666] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1668] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(126),
  [1671] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1673] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1675] = {.count = 1, .reusable = true}, SHIFT(821),
  [1677] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1679] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1681] = {.count = 1, .reusable = true}, SHIFT(822),
  [1683] = {.count = 1, .reusable = true}, SHIFT(823),
  [1685] = {.count = 1, .reusable = true}, SHIFT(824),
  [1687] = {.count = 1, .reusable = false}, SHIFT(825),
  [1689] = {.count = 1, .reusable = false}, SHIFT(824),
  [1691] = {.count = 1, .reusable = true}, SHIFT(827),
  [1693] = {.count = 1, .reusable = false}, SHIFT(829),
  [1695] = {.count = 1, .reusable = true}, SHIFT(829),
  [1697] = {.count = 1, .reusable = true}, SHIFT(828),
  [1699] = {.count = 1, .reusable = true}, SHIFT(830),
  [1701] = {.count = 1, .reusable = false}, SHIFT(832),
  [1703] = {.count = 1, .reusable = true}, SHIFT(832),
  [1705] = {.count = 1, .reusable = true}, SHIFT(831),
  [1707] = {.count = 1, .reusable = true}, SHIFT(833),
  [1709] = {.count = 1, .reusable = false}, SHIFT(835),
  [1711] = {.count = 1, .reusable = true}, SHIFT(835),
  [1713] = {.count = 1, .reusable = true}, SHIFT(834),
  [1715] = {.count = 1, .reusable = true}, SHIFT(836),
  [1717] = {.count = 1, .reusable = true}, SHIFT(837),
  [1719] = {.count = 1, .reusable = false}, SHIFT(837),
  [1721] = {.count = 1, .reusable = true}, SHIFT(840),
  [1723] = {.count = 1, .reusable = false}, SHIFT(840),
  [1725] = {.count = 1, .reusable = false}, SHIFT(843),
  [1727] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(844),
  [1730] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(130),
  [1733] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(131),
  [1736] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(132),
  [1739] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(133),
  [1742] = {.count = 1, .reusable = true}, SHIFT(845),
  [1744] = {.count = 1, .reusable = true}, SHIFT(846),
  [1746] = {.count = 1, .reusable = true}, SHIFT(848),
  [1748] = {.count = 1, .reusable = false}, SHIFT(849),
  [1750] = {.count = 1, .reusable = true}, SHIFT(850),
  [1752] = {.count = 1, .reusable = false}, SHIFT(851),
  [1754] = {.count = 1, .reusable = true}, SHIFT(852),
  [1756] = {.count = 1, .reusable = true}, SHIFT(853),
  [1758] = {.count = 1, .reusable = true}, SHIFT(854),
  [1760] = {.count = 1, .reusable = true}, SHIFT(855),
  [1762] = {.count = 1, .reusable = true}, SHIFT(856),
  [1764] = {.count = 1, .reusable = true}, SHIFT(858),
  [1766] = {.count = 1, .reusable = true}, SHIFT(859),
  [1768] = {.count = 1, .reusable = false}, SHIFT(861),
  [1770] = {.count = 1, .reusable = true}, SHIFT(861),
  [1772] = {.count = 1, .reusable = true}, SHIFT(860),
  [1774] = {.count = 1, .reusable = true}, SHIFT(862),
  [1776] = {.count = 1, .reusable = false}, SHIFT(864),
  [1778] = {.count = 1, .reusable = true}, SHIFT(864),
  [1780] = {.count = 1, .reusable = true}, SHIFT(863),
  [1782] = {.count = 1, .reusable = false}, SHIFT(866),
  [1784] = {.count = 1, .reusable = true}, SHIFT(866),
  [1786] = {.count = 1, .reusable = true}, SHIFT(865),
  [1788] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1790] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1792] = {.count = 1, .reusable = true}, SHIFT(867),
  [1794] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1796] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1798] = {.count = 1, .reusable = false}, SHIFT(869),
  [1800] = {.count = 1, .reusable = false}, SHIFT(870),
  [1802] = {.count = 1, .reusable = true}, SHIFT(872),
  [1804] = {.count = 1, .reusable = true}, SHIFT(873),
  [1806] = {.count = 1, .reusable = false}, SHIFT(874),
  [1808] = {.count = 1, .reusable = false}, SHIFT(872),
  [1810] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1812] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1814] = {.count = 1, .reusable = true}, SHIFT(875),
  [1816] = {.count = 1, .reusable = true}, SHIFT(876),
  [1818] = {.count = 1, .reusable = true}, SHIFT(877),
  [1820] = {.count = 1, .reusable = false}, SHIFT(878),
  [1822] = {.count = 1, .reusable = false}, SHIFT(877),
  [1824] = {.count = 1, .reusable = true}, SHIFT(880),
  [1826] = {.count = 1, .reusable = true}, SHIFT(890),
  [1828] = {.count = 1, .reusable = false}, SHIFT(891),
  [1830] = {.count = 1, .reusable = true}, SHIFT(891),
  [1832] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1834] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1836] = {.count = 1, .reusable = true}, SHIFT(892),
  [1838] = {.count = 1, .reusable = true}, SHIFT(893),
  [1840] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [1842] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [1844] = {.count = 1, .reusable = true}, SHIFT(894),
  [1846] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [1848] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [1850] = {.count = 1, .reusable = true}, SHIFT(895),
  [1852] = {.count = 1, .reusable = true}, SHIFT(896),
  [1854] = {.count = 1, .reusable = false}, SHIFT(896),
  [1856] = {.count = 1, .reusable = true}, SHIFT(898),
  [1858] = {.count = 1, .reusable = true}, SHIFT(900),
  [1860] = {.count = 1, .reusable = true}, SHIFT(901),
  [1862] = {.count = 1, .reusable = false}, SHIFT(905),
  [1864] = {.count = 1, .reusable = true}, SHIFT(905),
  [1866] = {.count = 1, .reusable = true}, SHIFT(906),
  [1868] = {.count = 1, .reusable = true}, SHIFT(907),
  [1870] = {.count = 1, .reusable = true}, SHIFT(908),
  [1872] = {.count = 1, .reusable = true}, SHIFT(909),
  [1874] = {.count = 1, .reusable = true}, SHIFT(912),
  [1876] = {.count = 1, .reusable = false}, SHIFT(912),
  [1878] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [1880] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [1882] = {.count = 1, .reusable = true}, SHIFT(914),
  [1884] = {.count = 1, .reusable = true}, SHIFT(915),
  [1886] = {.count = 1, .reusable = false}, SHIFT(915),
  [1888] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [1890] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [1892] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [1894] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [1896] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [1898] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [1900] = {.count = 1, .reusable = true}, SHIFT(917),
  [1902] = {.count = 1, .reusable = false}, SHIFT(918),
  [1904] = {.count = 1, .reusable = false}, SHIFT(917),
  [1906] = {.count = 1, .reusable = true}, SHIFT(919),
  [1908] = {.count = 1, .reusable = true}, SHIFT(920),
  [1910] = {.count = 1, .reusable = true}, SHIFT(921),
  [1912] = {.count = 1, .reusable = false}, SHIFT(922),
  [1914] = {.count = 1, .reusable = false}, SHIFT(921),
  [1916] = {.count = 1, .reusable = true}, SHIFT(925),
  [1918] = {.count = 1, .reusable = true}, SHIFT(924),
  [1920] = {.count = 1, .reusable = true}, SHIFT(926),
  [1922] = {.count = 1, .reusable = true}, SHIFT(927),
  [1924] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 3),
  [1926] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 3),
  [1928] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [1930] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1932] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [1934] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [1936] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [1938] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [1940] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [1942] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [1944] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [1946] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [1948] = {.count = 1, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [1950] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(168),
  [1953] = {.count = 1, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [1955] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(170),
  [1958] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(170),
  [1961] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(171),
  [1964] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(171),
  [1967] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(172),
  [1970] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(169),
  [1973] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(173),
  [1976] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(17),
  [1979] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(18),
  [1982] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(174),
  [1985] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(20),
  [1988] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(21),
  [1991] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [1994] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(23),
  [1997] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(174),
  [2000] = {.count = 1, .reusable = true}, SHIFT(932),
  [2002] = {.count = 1, .reusable = false}, SHIFT(662),
  [2004] = {.count = 1, .reusable = true}, SHIFT(933),
  [2006] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [2008] = {.count = 1, .reusable = true}, SHIFT(935),
  [2010] = {.count = 1, .reusable = true}, SHIFT(936),
  [2012] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2014] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2016] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2018] = {.count = 1, .reusable = true}, SHIFT(937),
  [2020] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2022] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2024] = {.count = 1, .reusable = false}, SHIFT(939),
  [2026] = {.count = 1, .reusable = false}, SHIFT(940),
  [2028] = {.count = 1, .reusable = true}, SHIFT(942),
  [2030] = {.count = 1, .reusable = true}, SHIFT(943),
  [2032] = {.count = 1, .reusable = false}, SHIFT(944),
  [2034] = {.count = 1, .reusable = false}, SHIFT(942),
  [2036] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2038] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2040] = {.count = 1, .reusable = true}, SHIFT(945),
  [2042] = {.count = 1, .reusable = true}, SHIFT(946),
  [2044] = {.count = 1, .reusable = true}, SHIFT(947),
  [2046] = {.count = 1, .reusable = false}, SHIFT(948),
  [2048] = {.count = 1, .reusable = false}, SHIFT(947),
  [2050] = {.count = 1, .reusable = true}, SHIFT(959),
  [2052] = {.count = 1, .reusable = true}, SHIFT(961),
  [2054] = {.count = 1, .reusable = false}, SHIFT(963),
  [2056] = {.count = 1, .reusable = false}, SHIFT(964),
  [2058] = {.count = 1, .reusable = true}, SHIFT(965),
  [2060] = {.count = 1, .reusable = true}, SHIFT(966),
  [2062] = {.count = 1, .reusable = true}, SHIFT(967),
  [2064] = {.count = 1, .reusable = false}, SHIFT(968),
  [2066] = {.count = 1, .reusable = false}, SHIFT(967),
  [2068] = {.count = 1, .reusable = true}, SHIFT(970),
  [2070] = {.count = 1, .reusable = false}, SHIFT(972),
  [2072] = {.count = 1, .reusable = true}, SHIFT(972),
  [2074] = {.count = 1, .reusable = true}, SHIFT(971),
  [2076] = {.count = 1, .reusable = true}, SHIFT(973),
  [2078] = {.count = 1, .reusable = false}, SHIFT(975),
  [2080] = {.count = 1, .reusable = true}, SHIFT(975),
  [2082] = {.count = 1, .reusable = true}, SHIFT(974),
  [2084] = {.count = 1, .reusable = true}, SHIFT(976),
  [2086] = {.count = 1, .reusable = false}, SHIFT(978),
  [2088] = {.count = 1, .reusable = true}, SHIFT(978),
  [2090] = {.count = 1, .reusable = true}, SHIFT(977),
  [2092] = {.count = 1, .reusable = true}, SHIFT(979),
  [2094] = {.count = 1, .reusable = true}, SHIFT(980),
  [2096] = {.count = 1, .reusable = false}, SHIFT(980),
  [2098] = {.count = 1, .reusable = true}, SHIFT(983),
  [2100] = {.count = 1, .reusable = false}, SHIFT(983),
  [2102] = {.count = 1, .reusable = true}, SHIFT(986),
  [2104] = {.count = 1, .reusable = true}, SHIFT(987),
  [2106] = {.count = 1, .reusable = false}, SHIFT(987),
  [2108] = {.count = 1, .reusable = true}, SHIFT(990),
  [2110] = {.count = 1, .reusable = true}, SHIFT(991),
  [2112] = {.count = 1, .reusable = false}, SHIFT(992),
  [2114] = {.count = 1, .reusable = true}, SHIFT(993),
  [2116] = {.count = 1, .reusable = true}, SHIFT(994),
  [2118] = {.count = 1, .reusable = false}, SHIFT(995),
  [2120] = {.count = 1, .reusable = true}, SHIFT(996),
  [2122] = {.count = 1, .reusable = true}, SHIFT(997),
  [2124] = {.count = 1, .reusable = true}, SHIFT(998),
  [2126] = {.count = 1, .reusable = true}, SHIFT(999),
  [2128] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2130] = {.count = 1, .reusable = false}, SHIFT(996),
  [2132] = {.count = 1, .reusable = true}, SHIFT(992),
  [2134] = {.count = 1, .reusable = true}, SHIFT(1002),
  [2136] = {.count = 1, .reusable = false}, SHIFT(1002),
  [2138] = {.count = 1, .reusable = true}, SHIFT(1003),
  [2140] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [2142] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2144] = {.count = 1, .reusable = false}, SHIFT(1006),
  [2146] = {.count = 1, .reusable = false}, SHIFT(1007),
  [2148] = {.count = 1, .reusable = true}, SHIFT(1008),
  [2150] = {.count = 1, .reusable = true}, SHIFT(1009),
  [2152] = {.count = 1, .reusable = true}, SHIFT(1010),
  [2154] = {.count = 1, .reusable = false}, SHIFT(1011),
  [2156] = {.count = 1, .reusable = false}, SHIFT(1010),
  [2158] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2160] = {.count = 1, .reusable = false}, SHIFT(1015),
  [2162] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2164] = {.count = 1, .reusable = true}, SHIFT(1014),
  [2166] = {.count = 1, .reusable = true}, SHIFT(1016),
  [2168] = {.count = 1, .reusable = false}, SHIFT(1018),
  [2170] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2172] = {.count = 1, .reusable = true}, SHIFT(1017),
  [2174] = {.count = 1, .reusable = true}, SHIFT(1019),
  [2176] = {.count = 1, .reusable = false}, SHIFT(1021),
  [2178] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2180] = {.count = 1, .reusable = true}, SHIFT(1020),
  [2182] = {.count = 1, .reusable = true}, SHIFT(1022),
  [2184] = {.count = 1, .reusable = true}, SHIFT(1023),
  [2186] = {.count = 1, .reusable = false}, SHIFT(1023),
  [2188] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2190] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2192] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2194] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2196] = {.count = 1, .reusable = false}, SHIFT(1030),
  [2198] = {.count = 1, .reusable = false}, SHIFT(198),
  [2200] = {.count = 1, .reusable = false}, SHIFT(200),
  [2202] = {.count = 1, .reusable = false}, SHIFT(201),
  [2204] = {.count = 1, .reusable = false}, SHIFT(204),
  [2206] = {.count = 1, .reusable = false}, SHIFT(205),
  [2208] = {.count = 1, .reusable = false}, SHIFT(206),
  [2210] = {.count = 1, .reusable = false}, SHIFT(207),
  [2212] = {.count = 1, .reusable = false}, SHIFT(1035),
  [2214] = {.count = 1, .reusable = true}, SHIFT(1036),
  [2216] = {.count = 1, .reusable = false}, SHIFT(1038),
  [2218] = {.count = 1, .reusable = false}, SHIFT(1039),
  [2220] = {.count = 1, .reusable = true}, SHIFT(1041),
  [2222] = {.count = 1, .reusable = true}, SHIFT(1042),
  [2224] = {.count = 1, .reusable = false}, SHIFT(1043),
  [2226] = {.count = 1, .reusable = false}, SHIFT(1041),
  [2228] = {.count = 1, .reusable = true}, SHIFT(1044),
  [2230] = {.count = 1, .reusable = true}, SHIFT(1045),
  [2232] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2234] = {.count = 1, .reusable = false}, SHIFT(1047),
  [2236] = {.count = 1, .reusable = false}, SHIFT(1046),
  [2238] = {.count = 1, .reusable = true}, SHIFT(1058),
  [2240] = {.count = 1, .reusable = false}, SHIFT(565),
  [2242] = {.count = 1, .reusable = false}, SHIFT(1058),
  [2244] = {.count = 1, .reusable = false}, SHIFT(1060),
  [2246] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4, .alias_sequence_id = 5),
  [2248] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4, .alias_sequence_id = 5),
  [2250] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [2252] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [2254] = {.count = 1, .reusable = false}, SHIFT(1062),
  [2256] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 4),
  [2258] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 4),
  [2260] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [2262] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [2264] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [2266] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 1),
  [2268] = {.count = 1, .reusable = true}, SHIFT(1067),
  [2270] = {.count = 1, .reusable = false}, SHIFT(1067),
  [2272] = {.count = 1, .reusable = true}, SHIFT(578),
  [2274] = {.count = 1, .reusable = true}, SHIFT(579),
  [2276] = {.count = 1, .reusable = false}, SHIFT(1072),
  [2278] = {.count = 1, .reusable = true}, SHIFT(1073),
  [2280] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2282] = {.count = 1, .reusable = false}, SHIFT(1074),
  [2284] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2286] = {.count = 1, .reusable = false}, SHIFT(1078),
  [2288] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(215),
  [2291] = {.count = 1, .reusable = false}, SHIFT(1079),
  [2293] = {.count = 1, .reusable = false}, SHIFT(1080),
  [2295] = {.count = 1, .reusable = true}, SHIFT(1083),
  [2297] = {.count = 1, .reusable = false}, SHIFT(1083),
  [2299] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2301] = {.count = 1, .reusable = false}, SHIFT(1085),
  [2303] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2305] = {.count = 1, .reusable = true}, SHIFT(1088),
  [2307] = {.count = 1, .reusable = true}, SHIFT(1089),
  [2309] = {.count = 1, .reusable = false}, SHIFT(1091),
  [2311] = {.count = 1, .reusable = true}, SHIFT(1091),
  [2313] = {.count = 1, .reusable = true}, SHIFT(1090),
  [2315] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2317] = {.count = 1, .reusable = false}, SHIFT(1094),
  [2319] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1093),
  [2323] = {.count = 1, .reusable = false}, SHIFT(1096),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2327] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1097),
  [2331] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2333] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2335] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2337] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2341] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2343] = {.count = 1, .reusable = false}, SHIFT(1103),
  [2345] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2347] = {.count = 1, .reusable = false}, SHIFT(1104),
  [2349] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2351] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2353] = {.count = 1, .reusable = false}, SHIFT(1106),
  [2355] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [2357] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [2359] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2361] = {.count = 1, .reusable = false}, SHIFT(1108),
  [2363] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2365] = {.count = 1, .reusable = false}, SHIFT(1111),
  [2367] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2369] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2371] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2373] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [2375] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [2377] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2379] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2381] = {.count = 1, .reusable = false}, SHIFT(1119),
  [2383] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2385] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2387] = {.count = 1, .reusable = false}, SHIFT(1121),
  [2389] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2391] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2393] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2395] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2397] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(249),
  [2400] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(250),
  [2403] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(251),
  [2406] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(251),
  [2409] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(254),
  [2412] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(255),
  [2415] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(255),
  [2418] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 4),
  [2420] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 4),
  [2422] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2424] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2426] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(263),
  [2429] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(265),
  [2432] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(265),
  [2435] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(266),
  [2438] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(264),
  [2441] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(267),
  [2444] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(268),
  [2447] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(268),
  [2450] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2452] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2454] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2456] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2458] = {.count = 1, .reusable = false}, SHIFT(277),
  [2460] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(281),
  [2463] = {.count = 1, .reusable = false}, SHIFT(1137),
  [2465] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2467] = {.count = 1, .reusable = false}, SHIFT(1139),
  [2469] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2471] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2473] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2475] = {.count = 1, .reusable = false}, SHIFT(1145),
  [2477] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2479] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2481] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2483] = {.count = 1, .reusable = false}, SHIFT(1148),
  [2485] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2487] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2489] = {.count = 1, .reusable = false}, SHIFT(1150),
  [2491] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2493] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2495] = {.count = 1, .reusable = true}, SHIFT(1151),
  [2497] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2499] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2501] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2503] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2505] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2507] = {.count = 1, .reusable = true}, SHIFT(1157),
  [2509] = {.count = 1, .reusable = false}, SHIFT(1157),
  [2511] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2513] = {.count = 1, .reusable = false}, SHIFT(1158),
  [2515] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2517] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2519] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2521] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2523] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2525] = {.count = 1, .reusable = false}, SHIFT(1161),
  [2527] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2529] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2531] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2533] = {.count = 1, .reusable = false}, SHIFT(1164),
  [2535] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2537] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2539] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1168),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2547] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2549] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2551] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 4),
  [2553] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 4),
  [2555] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(308),
  [2558] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2560] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2562] = {.count = 1, .reusable = false}, SHIFT(1178),
  [2564] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2566] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2568] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2570] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2572] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2574] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2576] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2578] = {.count = 1, .reusable = false}, SHIFT(1187),
  [2580] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2582] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2584] = {.count = 1, .reusable = false}, SHIFT(1189),
  [2586] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2588] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2590] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2592] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2594] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2596] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2598] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2600] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2602] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2604] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2606] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2608] = {.count = 1, .reusable = false}, SHIFT(1197),
  [2610] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2612] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2614] = {.count = 1, .reusable = false}, SHIFT(1199),
  [2616] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2618] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(333),
  [2621] = {.count = 1, .reusable = false}, SHIFT(1202),
  [2623] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2625] = {.count = 1, .reusable = false}, SHIFT(1204),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2629] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2631] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2633] = {.count = 1, .reusable = false}, SHIFT(1210),
  [2635] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2637] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2639] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2641] = {.count = 1, .reusable = false}, SHIFT(1213),
  [2643] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2645] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2647] = {.count = 1, .reusable = false}, SHIFT(1215),
  [2649] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2651] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2653] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2657] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2659] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2661] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2663] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2665] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2667] = {.count = 1, .reusable = false}, SHIFT(1222),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2671] = {.count = 1, .reusable = false}, SHIFT(1223),
  [2673] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2675] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2677] = {.count = 1, .reusable = false}, SHIFT(1225),
  [2679] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(356),
  [2682] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2686] = {.count = 1, .reusable = false}, SHIFT(1228),
  [2688] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2690] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2692] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2694] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2696] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2698] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2700] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2702] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2704] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2706] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2708] = {.count = 1, .reusable = false}, SHIFT(1239),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2712] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2714] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2716] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2718] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2720] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2722] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2724] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2726] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2728] = {.count = 1, .reusable = false}, SHIFT(1246),
  [2730] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2732] = {.count = 1, .reusable = false}, SHIFT(1247),
  [2734] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2736] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2738] = {.count = 1, .reusable = false}, SHIFT(1249),
  [2740] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(379),
  [2743] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2745] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2747] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2749] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2755] = {.count = 1, .reusable = false}, SHIFT(1258),
  [2757] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2761] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2763] = {.count = 1, .reusable = false}, SHIFT(1261),
  [2765] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2767] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2769] = {.count = 1, .reusable = false}, SHIFT(1263),
  [2771] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2773] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2775] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2777] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2779] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2781] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2783] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2785] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2787] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2789] = {.count = 1, .reusable = false}, SHIFT(1270),
  [2791] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2793] = {.count = 1, .reusable = false}, SHIFT(1271),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2797] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2799] = {.count = 1, .reusable = false}, SHIFT(1273),
  [2801] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [2803] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [2805] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2807] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2809] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2811] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2815] = {.count = 1, .reusable = false}, SHIFT(1281),
  [2817] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2819] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2821] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2823] = {.count = 1, .reusable = false}, SHIFT(1284),
  [2825] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2827] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2829] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2831] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2833] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2837] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2839] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2841] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2843] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2845] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2847] = {.count = 1, .reusable = true}, SHIFT(1293),
  [2849] = {.count = 1, .reusable = false}, SHIFT(1293),
  [2851] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2853] = {.count = 1, .reusable = false}, SHIFT(1294),
  [2855] = {.count = 1, .reusable = true}, REDUCE(sym_string, 4),
  [2857] = {.count = 1, .reusable = false}, REDUCE(sym_string, 4),
  [2859] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2861] = {.count = 1, .reusable = true}, SHIFT(1296),
  [2863] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2865] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2867] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2869] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [2871] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [2873] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2875] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2877] = {.count = 1, .reusable = false}, SHIFT(1303),
  [2879] = {.count = 1, .reusable = false}, SHIFT(1304),
  [2881] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2883] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2885] = {.count = 1, .reusable = false}, SHIFT(1308),
  [2887] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2889] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2891] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2893] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2895] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2897] = {.count = 1, .reusable = false}, SHIFT(1313),
  [2899] = {.count = 1, .reusable = false}, SHIFT(1312),
  [2901] = {.count = 1, .reusable = false}, SHIFT(1324),
  [2903] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2905] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2907] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2909] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2911] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2913] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2915] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2919] = {.count = 1, .reusable = true}, SHIFT(1330),
  [2921] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2923] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2925] = {.count = 1, .reusable = false}, SHIFT(1334),
  [2927] = {.count = 1, .reusable = false}, SHIFT(1335),
  [2929] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2931] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2933] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2935] = {.count = 1, .reusable = false}, SHIFT(1339),
  [2937] = {.count = 1, .reusable = false}, SHIFT(1338),
  [2939] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2941] = {.count = 1, .reusable = false}, SHIFT(1343),
  [2943] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2945] = {.count = 1, .reusable = true}, SHIFT(1342),
  [2947] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2949] = {.count = 1, .reusable = false}, SHIFT(1346),
  [2951] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2953] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2955] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2957] = {.count = 1, .reusable = false}, SHIFT(1349),
  [2959] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2963] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2965] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2967] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2969] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2971] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2973] = {.count = 1, .reusable = false}, SHIFT(1353),
  [2975] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2977] = {.count = 1, .reusable = false}, SHIFT(1356),
  [2979] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2981] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2983] = {.count = 1, .reusable = false}, SHIFT(1360),
  [2985] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2987] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2989] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [2991] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(891),
  [2994] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(428),
  [2997] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(429),
  [3000] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(430),
  [3003] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(431),
  [3006] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(891),
  [3009] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(432),
  [3012] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(434),
  [3015] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(435),
  [3018] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(436),
  [3021] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(431),
  [3024] = {.count = 1, .reusable = true}, SHIFT(1363),
  [3026] = {.count = 1, .reusable = false}, SHIFT(1364),
  [3028] = {.count = 1, .reusable = true}, SHIFT(1364),
  [3030] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [3032] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [3034] = {.count = 1, .reusable = true}, SHIFT(1365),
  [3036] = {.count = 1, .reusable = false}, SHIFT(1366),
  [3038] = {.count = 1, .reusable = true}, SHIFT(1366),
  [3040] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 4),
  [3042] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 4),
  [3044] = {.count = 1, .reusable = true}, SHIFT(1367),
  [3046] = {.count = 1, .reusable = true}, SHIFT(1369),
  [3048] = {.count = 1, .reusable = true}, SHIFT(1370),
  [3050] = {.count = 1, .reusable = false}, SHIFT(1371),
  [3052] = {.count = 1, .reusable = true}, SHIFT(1371),
  [3054] = {.count = 1, .reusable = true}, SHIFT(1372),
  [3056] = {.count = 1, .reusable = false}, SHIFT(1373),
  [3058] = {.count = 1, .reusable = true}, SHIFT(1373),
  [3060] = {.count = 1, .reusable = true}, SHIFT(1374),
  [3062] = {.count = 1, .reusable = true}, SHIFT(1377),
  [3064] = {.count = 1, .reusable = true}, SHIFT(1378),
  [3066] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(458),
  [3069] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(459),
  [3072] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(459),
  [3075] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(460),
  [3078] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 4),
  [3080] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 4),
  [3082] = {.count = 1, .reusable = true}, SHIFT(1381),
  [3084] = {.count = 1, .reusable = true}, SHIFT(1383),
  [3086] = {.count = 1, .reusable = true}, SHIFT(1384),
  [3088] = {.count = 1, .reusable = true}, SHIFT(1385),
  [3090] = {.count = 1, .reusable = false}, SHIFT(1386),
  [3092] = {.count = 1, .reusable = false}, SHIFT(1385),
  [3094] = {.count = 1, .reusable = true}, SHIFT(1388),
  [3096] = {.count = 1, .reusable = false}, SHIFT(1390),
  [3098] = {.count = 1, .reusable = true}, SHIFT(1390),
  [3100] = {.count = 1, .reusable = true}, SHIFT(1389),
  [3102] = {.count = 1, .reusable = true}, SHIFT(1391),
  [3104] = {.count = 1, .reusable = false}, SHIFT(1393),
  [3106] = {.count = 1, .reusable = true}, SHIFT(1393),
  [3108] = {.count = 1, .reusable = true}, SHIFT(1392),
  [3110] = {.count = 1, .reusable = true}, SHIFT(1394),
  [3112] = {.count = 1, .reusable = false}, SHIFT(1396),
  [3114] = {.count = 1, .reusable = true}, SHIFT(1396),
  [3116] = {.count = 1, .reusable = true}, SHIFT(1395),
  [3118] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [3120] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [3122] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(925),
  [3125] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [3127] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(476),
  [3130] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(477),
  [3133] = {.count = 1, .reusable = true}, REDUCE(sym_command, 4),
  [3135] = {.count = 1, .reusable = false}, REDUCE(sym_command, 4),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1399),
  [3139] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [3141] = {.count = 1, .reusable = true}, SHIFT(1400),
  [3143] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1401),
  [3147] = {.count = 1, .reusable = false}, SHIFT(1403),
  [3149] = {.count = 1, .reusable = false}, SHIFT(1404),
  [3151] = {.count = 1, .reusable = true}, SHIFT(1405),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1406),
  [3155] = {.count = 1, .reusable = true}, SHIFT(1407),
  [3157] = {.count = 1, .reusable = false}, SHIFT(1408),
  [3159] = {.count = 1, .reusable = false}, SHIFT(1407),
  [3161] = {.count = 1, .reusable = true}, SHIFT(1410),
  [3163] = {.count = 1, .reusable = false}, SHIFT(1412),
  [3165] = {.count = 1, .reusable = true}, SHIFT(1412),
  [3167] = {.count = 1, .reusable = true}, SHIFT(1411),
  [3169] = {.count = 1, .reusable = true}, SHIFT(1413),
  [3171] = {.count = 1, .reusable = false}, SHIFT(1415),
  [3173] = {.count = 1, .reusable = true}, SHIFT(1415),
  [3175] = {.count = 1, .reusable = true}, SHIFT(1414),
  [3177] = {.count = 1, .reusable = true}, SHIFT(1416),
  [3179] = {.count = 1, .reusable = false}, SHIFT(1418),
  [3181] = {.count = 1, .reusable = true}, SHIFT(1418),
  [3183] = {.count = 1, .reusable = true}, SHIFT(1417),
  [3185] = {.count = 1, .reusable = true}, SHIFT(1419),
  [3187] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3189] = {.count = 1, .reusable = false}, SHIFT(1420),
  [3191] = {.count = 1, .reusable = true}, SHIFT(1423),
  [3193] = {.count = 1, .reusable = false}, SHIFT(1423),
  [3195] = {.count = 1, .reusable = true}, SHIFT(1426),
  [3197] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3199] = {.count = 1, .reusable = false}, SHIFT(1427),
  [3201] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3203] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3205] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3207] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(502),
  [3210] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(503),
  [3213] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(504),
  [3216] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(505),
  [3219] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(506),
  [3222] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(507),
  [3225] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(508),
  [3228] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(509),
  [3231] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(511),
  [3234] = {.count = 1, .reusable = false}, SHIFT(1430),
  [3236] = {.count = 1, .reusable = true}, SHIFT(1431),
  [3238] = {.count = 1, .reusable = false}, SHIFT(1432),
  [3240] = {.count = 1, .reusable = true}, SHIFT(1433),
  [3242] = {.count = 1, .reusable = true}, SHIFT(1435),
  [3244] = {.count = 1, .reusable = true}, SHIFT(1436),
  [3246] = {.count = 1, .reusable = false}, SHIFT(1438),
  [3248] = {.count = 1, .reusable = true}, SHIFT(1438),
  [3250] = {.count = 1, .reusable = true}, SHIFT(1437),
  [3252] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3254] = {.count = 1, .reusable = false}, SHIFT(1441),
  [3256] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3258] = {.count = 1, .reusable = true}, SHIFT(1440),
  [3260] = {.count = 1, .reusable = false}, SHIFT(1443),
  [3262] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3264] = {.count = 1, .reusable = true}, SHIFT(1442),
  [3266] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3268] = {.count = 1, .reusable = true}, SHIFT(1445),
  [3270] = {.count = 1, .reusable = true}, SHIFT(1446),
  [3272] = {.count = 1, .reusable = true}, SHIFT(1447),
  [3274] = {.count = 1, .reusable = true}, SHIFT(1448),
  [3276] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3278] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3280] = {.count = 1, .reusable = false}, SHIFT(1450),
  [3282] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3284] = {.count = 1, .reusable = false}, SHIFT(1451),
  [3286] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3288] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3290] = {.count = 1, .reusable = false}, SHIFT(1453),
  [3292] = {.count = 1, .reusable = true}, SHIFT(1454),
  [3294] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3296] = {.count = 1, .reusable = false}, SHIFT(1460),
  [3298] = {.count = 1, .reusable = false}, SHIFT(1461),
  [3300] = {.count = 1, .reusable = true}, SHIFT(1463),
  [3302] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3304] = {.count = 1, .reusable = false}, SHIFT(1465),
  [3306] = {.count = 1, .reusable = false}, SHIFT(1463),
  [3308] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3310] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3312] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3314] = {.count = 1, .reusable = false}, SHIFT(1469),
  [3316] = {.count = 1, .reusable = false}, SHIFT(1468),
  [3318] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3320] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3322] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3324] = {.count = 1, .reusable = false}, SHIFT(1481),
  [3326] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(537),
  [3329] = {.count = 1, .reusable = false}, SHIFT(1484),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3333] = {.count = 1, .reusable = false}, SHIFT(1486),
  [3335] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3337] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3339] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3341] = {.count = 1, .reusable = false}, SHIFT(1492),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3345] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3349] = {.count = 1, .reusable = false}, SHIFT(1495),
  [3351] = {.count = 1, .reusable = true}, SHIFT(1495),
  [3353] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3355] = {.count = 1, .reusable = false}, SHIFT(1497),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3359] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1498),
  [3363] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3367] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3369] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3371] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3373] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3375] = {.count = 1, .reusable = false}, SHIFT(1504),
  [3377] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3379] = {.count = 1, .reusable = false}, SHIFT(1505),
  [3381] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3383] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3385] = {.count = 1, .reusable = false}, SHIFT(1507),
  [3387] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3389] = {.count = 1, .reusable = false}, SHIFT(1508),
  [3391] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3393] = {.count = 1, .reusable = false}, SHIFT(1511),
  [3395] = {.count = 1, .reusable = false}, SHIFT(1512),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3401] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3403] = {.count = 1, .reusable = false}, SHIFT(1516),
  [3405] = {.count = 1, .reusable = false}, SHIFT(1515),
  [3407] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3409] = {.count = 1, .reusable = false}, SHIFT(1520),
  [3411] = {.count = 1, .reusable = true}, SHIFT(1520),
  [3413] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3415] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3417] = {.count = 1, .reusable = false}, SHIFT(1523),
  [3419] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3423] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3425] = {.count = 1, .reusable = false}, SHIFT(1526),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1527),
  [3433] = {.count = 1, .reusable = true}, SHIFT(1528),
  [3435] = {.count = 1, .reusable = false}, SHIFT(1528),
  [3437] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3439] = {.count = 1, .reusable = false}, SHIFT(1531),
  [3441] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3443] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3445] = {.count = 1, .reusable = false}, SHIFT(1535),
  [3447] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(562),
  [3450] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(563),
  [3453] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(564),
  [3456] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(565),
  [3459] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(566),
  [3462] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(567),
  [3465] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(568),
  [3468] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(569),
  [3471] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(565),
  [3474] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3476] = {.count = 1, .reusable = false}, SHIFT(1539),
  [3478] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [3480] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [3482] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [3484] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [3486] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [3488] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3490] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 2),
  [3492] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3494] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3496] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3498] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3500] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(578),
  [3503] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [3505] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [3507] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3509] = {.count = 1, .reusable = true}, SHIFT(1545),
  [3511] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3513] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3515] = {.count = 1, .reusable = false}, SHIFT(1553),
  [3517] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [3519] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [3521] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3523] = {.count = 1, .reusable = false}, SHIFT(1557),
  [3525] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3527] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3529] = {.count = 1, .reusable = false}, SHIFT(1561),
  [3531] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3533] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3535] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3537] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3539] = {.count = 1, .reusable = true}, SHIFT(1567),
  [3541] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3543] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3545] = {.count = 1, .reusable = false}, SHIFT(1570),
  [3547] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3549] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3551] = {.count = 1, .reusable = false}, SHIFT(1572),
  [3553] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3557] = {.count = 1, .reusable = false}, SHIFT(1574),
  [3559] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3561] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3565] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [3567] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [3569] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [3571] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [3573] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3577] = {.count = 1, .reusable = false}, SHIFT(1584),
  [3579] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3583] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3585] = {.count = 1, .reusable = false}, SHIFT(1587),
  [3587] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3589] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3591] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3597] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 5),
  [3599] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 5),
  [3601] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3603] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3605] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3607] = {.count = 1, .reusable = false}, SHIFT(1597),
  [3609] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3611] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3613] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3615] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3617] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3619] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3621] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3623] = {.count = 1, .reusable = false}, SHIFT(1606),
  [3625] = {.count = 1, .reusable = true}, SHIFT(1606),
  [3627] = {.count = 1, .reusable = true}, SHIFT(1607),
  [3629] = {.count = 1, .reusable = false}, SHIFT(1608),
  [3631] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3635] = {.count = 1, .reusable = false}, SHIFT(1610),
  [3637] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3639] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3641] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3643] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3645] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3647] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3649] = {.count = 1, .reusable = false}, SHIFT(1618),
  [3651] = {.count = 1, .reusable = false}, SHIFT(1619),
  [3653] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3655] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3657] = {.count = 1, .reusable = false}, SHIFT(1623),
  [3659] = {.count = 1, .reusable = false}, SHIFT(1621),
  [3661] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1625),
  [3665] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3667] = {.count = 1, .reusable = false}, SHIFT(1627),
  [3669] = {.count = 1, .reusable = false}, SHIFT(1626),
  [3671] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(692),
  [3674] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(693),
  [3677] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(693),
  [3680] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(694),
  [3683] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(694),
  [3686] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(695),
  [3689] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3691] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3693] = {.count = 1, .reusable = false}, SHIFT(1640),
  [3695] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3697] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3699] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3701] = {.count = 1, .reusable = true}, SHIFT(1645),
  [3703] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3705] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3707] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3709] = {.count = 1, .reusable = false}, SHIFT(1649),
  [3711] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3713] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3715] = {.count = 1, .reusable = false}, SHIFT(1651),
  [3717] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3719] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3721] = {.count = 1, .reusable = false}, SHIFT(1653),
  [3723] = {.count = 1, .reusable = true}, SHIFT(1653),
  [3725] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3727] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3731] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3733] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3735] = {.count = 1, .reusable = false}, SHIFT(1659),
  [3737] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3739] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3741] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3743] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3745] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3747] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3749] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3751] = {.count = 1, .reusable = false}, SHIFT(1668),
  [3753] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3755] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3757] = {.count = 1, .reusable = false}, SHIFT(1670),
  [3759] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3761] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3763] = {.count = 1, .reusable = false}, SHIFT(1672),
  [3765] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3767] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3769] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3771] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3775] = {.count = 1, .reusable = false}, SHIFT(1677),
  [3777] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3779] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3781] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3783] = {.count = 1, .reusable = true}, SHIFT(1682),
  [3785] = {.count = 1, .reusable = true}, SHIFT(1683),
  [3787] = {.count = 1, .reusable = true}, SHIFT(1684),
  [3789] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3791] = {.count = 1, .reusable = false}, SHIFT(1686),
  [3793] = {.count = 1, .reusable = true}, SHIFT(1686),
  [3795] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3797] = {.count = 1, .reusable = false}, SHIFT(1688),
  [3799] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3801] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3803] = {.count = 1, .reusable = false}, SHIFT(1690),
  [3805] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3807] = {.count = 1, .reusable = true}, SHIFT(1691),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3811] = {.count = 1, .reusable = true}, SHIFT(1693),
  [3813] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3815] = {.count = 1, .reusable = false}, SHIFT(1695),
  [3817] = {.count = 1, .reusable = true}, SHIFT(1696),
  [3819] = {.count = 1, .reusable = true}, SHIFT(1698),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3823] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3825] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3827] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3829] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3831] = {.count = 1, .reusable = false}, SHIFT(1704),
  [3833] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3835] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3837] = {.count = 1, .reusable = false}, SHIFT(1706),
  [3839] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3841] = {.count = 1, .reusable = true}, SHIFT(1707),
  [3843] = {.count = 1, .reusable = false}, SHIFT(1708),
  [3845] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3847] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3849] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3851] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3853] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3855] = {.count = 1, .reusable = false}, SHIFT(1713),
  [3857] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3859] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3861] = {.count = 1, .reusable = true}, SHIFT(1717),
  [3863] = {.count = 1, .reusable = true}, SHIFT(1718),
  [3865] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3867] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3869] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3871] = {.count = 1, .reusable = false}, SHIFT(1722),
  [3873] = {.count = 1, .reusable = true}, SHIFT(1722),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3877] = {.count = 1, .reusable = false}, SHIFT(1724),
  [3879] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3881] = {.count = 1, .reusable = true}, SHIFT(1725),
  [3883] = {.count = 1, .reusable = false}, SHIFT(1726),
  [3885] = {.count = 1, .reusable = true}, SHIFT(1726),
  [3887] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3889] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3891] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3893] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [3895] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3897] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3899] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [3901] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3903] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3905] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3907] = {.count = 1, .reusable = false}, SHIFT(1734),
  [3909] = {.count = 1, .reusable = false}, SHIFT(1735),
  [3911] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [3913] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [3915] = {.count = 1, .reusable = true}, SHIFT(1736),
  [3917] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3919] = {.count = 1, .reusable = true}, SHIFT(1738),
  [3921] = {.count = 1, .reusable = false}, SHIFT(1739),
  [3923] = {.count = 1, .reusable = false}, SHIFT(1738),
  [3925] = {.count = 1, .reusable = true}, SHIFT(1741),
  [3927] = {.count = 1, .reusable = false}, SHIFT(1743),
  [3929] = {.count = 1, .reusable = true}, SHIFT(1743),
  [3931] = {.count = 1, .reusable = true}, SHIFT(1742),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3935] = {.count = 1, .reusable = false}, SHIFT(1746),
  [3937] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3939] = {.count = 1, .reusable = true}, SHIFT(1745),
  [3941] = {.count = 1, .reusable = true}, SHIFT(1747),
  [3943] = {.count = 1, .reusable = false}, SHIFT(1749),
  [3945] = {.count = 1, .reusable = true}, SHIFT(1749),
  [3947] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3949] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3951] = {.count = 1, .reusable = true}, SHIFT(1751),
  [3953] = {.count = 1, .reusable = false}, SHIFT(1751),
  [3955] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3957] = {.count = 1, .reusable = false}, SHIFT(1754),
  [3959] = {.count = 1, .reusable = true}, SHIFT(1757),
  [3961] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3963] = {.count = 1, .reusable = false}, SHIFT(1758),
  [3965] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3967] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3969] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3971] = {.count = 1, .reusable = false}, SHIFT(1764),
  [3973] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3975] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [3977] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [3979] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3981] = {.count = 1, .reusable = false}, SHIFT(1766),
  [3983] = {.count = 1, .reusable = true}, SHIFT(1766),
  [3985] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [3987] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [3989] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3991] = {.count = 1, .reusable = false}, SHIFT(1768),
  [3993] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3995] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(867),
  [3998] = {.count = 1, .reusable = false}, SHIFT(1769),
  [4000] = {.count = 1, .reusable = true}, SHIFT(1770),
  [4002] = {.count = 1, .reusable = false}, SHIFT(1771),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1772),
  [4006] = {.count = 1, .reusable = true}, SHIFT(1774),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1775),
  [4010] = {.count = 1, .reusable = false}, SHIFT(1777),
  [4012] = {.count = 1, .reusable = true}, SHIFT(1777),
  [4014] = {.count = 1, .reusable = true}, SHIFT(1776),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1778),
  [4018] = {.count = 1, .reusable = false}, SHIFT(1780),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1780),
  [4022] = {.count = 1, .reusable = true}, SHIFT(1779),
  [4024] = {.count = 1, .reusable = false}, SHIFT(1782),
  [4026] = {.count = 1, .reusable = true}, SHIFT(1782),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4030] = {.count = 1, .reusable = true}, SHIFT(1783),
  [4032] = {.count = 1, .reusable = true}, SHIFT(1784),
  [4034] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4036] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4038] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4040] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 10),
  [4042] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 10),
  [4044] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4046] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4048] = {.count = 1, .reusable = true}, SHIFT(1790),
  [4050] = {.count = 1, .reusable = false}, SHIFT(1790),
  [4052] = {.count = 1, .reusable = true}, SHIFT(1791),
  [4054] = {.count = 1, .reusable = false}, SHIFT(1791),
  [4056] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4058] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4060] = {.count = 1, .reusable = false}, SHIFT(1793),
  [4062] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 11),
  [4064] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 11),
  [4066] = {.count = 1, .reusable = true}, SHIFT(1794),
  [4068] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 12),
  [4070] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 12),
  [4072] = {.count = 1, .reusable = true}, SHIFT(1795),
  [4074] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 5),
  [4076] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 5),
  [4078] = {.count = 1, .reusable = false}, SHIFT(1797),
  [4080] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4082] = {.count = 1, .reusable = true}, SHIFT(1798),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1799),
  [4086] = {.count = 1, .reusable = false}, SHIFT(1800),
  [4088] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4090] = {.count = 1, .reusable = true}, SHIFT(1801),
  [4092] = {.count = 1, .reusable = true}, SHIFT(1802),
  [4094] = {.count = 1, .reusable = true}, SHIFT(1803),
  [4096] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4098] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 5),
  [4100] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 5),
  [4102] = {.count = 1, .reusable = true}, SHIFT(1807),
  [4104] = {.count = 1, .reusable = false}, SHIFT(1808),
  [4106] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4108] = {.count = 1, .reusable = true}, SHIFT(1811),
  [4110] = {.count = 1, .reusable = true}, SHIFT(1812),
  [4112] = {.count = 1, .reusable = false}, SHIFT(1814),
  [4114] = {.count = 1, .reusable = true}, SHIFT(1814),
  [4116] = {.count = 1, .reusable = true}, SHIFT(1813),
  [4118] = {.count = 1, .reusable = true}, SHIFT(1815),
  [4120] = {.count = 1, .reusable = false}, SHIFT(1817),
  [4122] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4124] = {.count = 1, .reusable = true}, SHIFT(1816),
  [4126] = {.count = 1, .reusable = false}, SHIFT(1819),
  [4128] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4130] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4132] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4134] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4136] = {.count = 1, .reusable = true}, SHIFT(1822),
  [4138] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4140] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4142] = {.count = 1, .reusable = true}, REDUCE(sym_command, 5),
  [4144] = {.count = 1, .reusable = false}, REDUCE(sym_command, 5),
  [4146] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [4148] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [4150] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(937),
  [4153] = {.count = 1, .reusable = false}, SHIFT(1825),
  [4155] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4157] = {.count = 1, .reusable = false}, SHIFT(1827),
  [4159] = {.count = 1, .reusable = true}, SHIFT(1828),
  [4161] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4163] = {.count = 1, .reusable = true}, SHIFT(1831),
  [4165] = {.count = 1, .reusable = false}, SHIFT(1833),
  [4167] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4169] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4171] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4173] = {.count = 1, .reusable = false}, SHIFT(1836),
  [4175] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4177] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4179] = {.count = 1, .reusable = false}, SHIFT(1838),
  [4181] = {.count = 1, .reusable = true}, SHIFT(1838),
  [4183] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4185] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4187] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4189] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4191] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4193] = {.count = 1, .reusable = true}, SHIFT(1843),
  [4195] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4197] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4199] = {.count = 1, .reusable = false}, SHIFT(1845),
  [4201] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4203] = {.count = 1, .reusable = false}, SHIFT(1846),
  [4205] = {.count = 1, .reusable = true}, SHIFT(1847),
  [4207] = {.count = 1, .reusable = true}, SHIFT(1848),
  [4209] = {.count = 1, .reusable = false}, SHIFT(1848),
  [4211] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4213] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4215] = {.count = 1, .reusable = false}, SHIFT(1851),
  [4217] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4219] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4221] = {.count = 1, .reusable = true}, SHIFT(1855),
  [4223] = {.count = 1, .reusable = true}, SHIFT(1856),
  [4225] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4227] = {.count = 1, .reusable = true}, SHIFT(1858),
  [4229] = {.count = 1, .reusable = true}, SHIFT(1859),
  [4231] = {.count = 1, .reusable = false}, SHIFT(1860),
  [4233] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4235] = {.count = 1, .reusable = true}, SHIFT(1861),
  [4237] = {.count = 1, .reusable = false}, SHIFT(1862),
  [4239] = {.count = 1, .reusable = true}, SHIFT(1862),
  [4241] = {.count = 1, .reusable = true}, SHIFT(1863),
  [4243] = {.count = 1, .reusable = false}, SHIFT(1864),
  [4245] = {.count = 1, .reusable = true}, SHIFT(1864),
  [4247] = {.count = 1, .reusable = true}, SHIFT(1865),
  [4249] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4251] = {.count = 1, .reusable = true}, SHIFT(1867),
  [4253] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 6),
  [4255] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 6),
  [4257] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4259] = {.count = 1, .reusable = true}, SHIFT(1870),
  [4261] = {.count = 1, .reusable = false}, SHIFT(1872),
  [4263] = {.count = 1, .reusable = false}, SHIFT(1873),
  [4265] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4267] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4269] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4271] = {.count = 1, .reusable = false}, SHIFT(1877),
  [4273] = {.count = 1, .reusable = false}, SHIFT(1876),
  [4275] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4277] = {.count = 1, .reusable = false}, SHIFT(1881),
  [4279] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4281] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4283] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4285] = {.count = 1, .reusable = false}, SHIFT(1884),
  [4287] = {.count = 1, .reusable = true}, SHIFT(1884),
  [4289] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4291] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4293] = {.count = 1, .reusable = false}, SHIFT(1887),
  [4295] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4297] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4299] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4301] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4303] = {.count = 1, .reusable = false}, SHIFT(1889),
  [4305] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4307] = {.count = 1, .reusable = false}, SHIFT(1892),
  [4309] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4311] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4313] = {.count = 1, .reusable = false}, SHIFT(1896),
  [4315] = {.count = 1, .reusable = false}, SHIFT(991),
  [4317] = {.count = 1, .reusable = false}, SHIFT(993),
  [4319] = {.count = 1, .reusable = false}, SHIFT(994),
  [4321] = {.count = 1, .reusable = false}, SHIFT(997),
  [4323] = {.count = 1, .reusable = false}, SHIFT(998),
  [4325] = {.count = 1, .reusable = false}, SHIFT(999),
  [4327] = {.count = 1, .reusable = false}, SHIFT(1000),
  [4329] = {.count = 1, .reusable = false}, SHIFT(1901),
  [4331] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4333] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4335] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4337] = {.count = 1, .reusable = false}, SHIFT(1905),
  [4339] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4341] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4343] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4345] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4347] = {.count = 1, .reusable = true}, SHIFT(1911),
  [4349] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4351] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4353] = {.count = 1, .reusable = false}, SHIFT(1914),
  [4355] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4357] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4359] = {.count = 1, .reusable = false}, SHIFT(1916),
  [4361] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4363] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4365] = {.count = 1, .reusable = false}, SHIFT(1918),
  [4367] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4369] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4371] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4373] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1036),
  [4376] = {.count = 1, .reusable = false}, SHIFT(1922),
  [4378] = {.count = 1, .reusable = true}, SHIFT(1923),
  [4380] = {.count = 1, .reusable = false}, SHIFT(1924),
  [4382] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4384] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4386] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4388] = {.count = 1, .reusable = false}, SHIFT(1930),
  [4390] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4392] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4394] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4396] = {.count = 1, .reusable = false}, SHIFT(1933),
  [4398] = {.count = 1, .reusable = true}, SHIFT(1933),
  [4400] = {.count = 1, .reusable = true}, SHIFT(1932),
  [4402] = {.count = 1, .reusable = false}, SHIFT(1935),
  [4404] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4406] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4408] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4410] = {.count = 1, .reusable = true}, SHIFT(1937),
  [4412] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4414] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4416] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4418] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4420] = {.count = 1, .reusable = true}, SHIFT(1942),
  [4422] = {.count = 1, .reusable = false}, SHIFT(1942),
  [4424] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4426] = {.count = 1, .reusable = false}, SHIFT(1943),
  [4428] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4430] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4432] = {.count = 1, .reusable = false}, SHIFT(1945),
  [4434] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4436] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4438] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [4440] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [4442] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [4444] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4446] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4448] = {.count = 1, .reusable = true}, SHIFT(1949),
  [4450] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4452] = {.count = 1, .reusable = false}, SHIFT(1952),
  [4454] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [4456] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4458] = {.count = 1, .reusable = false}, SHIFT(1954),
  [4460] = {.count = 1, .reusable = false}, SHIFT(1955),
  [4462] = {.count = 1, .reusable = false}, SHIFT(1956),
  [4464] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4466] = {.count = 1, .reusable = false}, SHIFT(1958),
  [4468] = {.count = 1, .reusable = false}, SHIFT(1959),
  [4470] = {.count = 1, .reusable = false}, SHIFT(1960),
  [4472] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4474] = {.count = 1, .reusable = false}, SHIFT(1962),
  [4476] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4478] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4480] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4482] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4484] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4486] = {.count = 1, .reusable = false}, SHIFT(1968),
  [4488] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4490] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [4492] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4494] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4496] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 13),
  [4498] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 13),
  [4500] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4502] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1985),
  [4505] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(87),
  [4508] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(88),
  [4511] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1986),
  [4514] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(90),
  [4517] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(91),
  [4520] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(92),
  [4523] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(93),
  [4526] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4528] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4530] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 14),
  [4532] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 14),
  [4534] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4536] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [4538] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [4540] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4542] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4544] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4546] = {.count = 1, .reusable = false}, SHIFT(1994),
  [4548] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4550] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4552] = {.count = 1, .reusable = false}, SHIFT(1996),
  [4554] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4556] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4558] = {.count = 1, .reusable = false}, SHIFT(1998),
  [4560] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4562] = {.count = 1, .reusable = true}, SHIFT(1999),
  [4564] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4566] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4568] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6),
  [4570] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6),
  [4572] = {.count = 1, .reusable = true}, SHIFT(2003),
  [4574] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4576] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4578] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4580] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1120),
  [4583] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1121),
  [4586] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1121),
  [4589] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1122),
  [4592] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4594] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4596] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4598] = {.count = 1, .reusable = false}, SHIFT(2012),
  [4600] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4602] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4604] = {.count = 1, .reusable = false}, SHIFT(2014),
  [4606] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4608] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4610] = {.count = 1, .reusable = false}, SHIFT(2016),
  [4612] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4614] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4616] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4618] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4620] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4622] = {.count = 1, .reusable = false}, SHIFT(2022),
  [4624] = {.count = 1, .reusable = false}, SHIFT(2023),
  [4626] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4628] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4630] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4632] = {.count = 1, .reusable = false}, SHIFT(2027),
  [4634] = {.count = 1, .reusable = false}, SHIFT(2026),
  [4636] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4638] = {.count = 1, .reusable = false}, SHIFT(2031),
  [4640] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4642] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4644] = {.count = 1, .reusable = true}, SHIFT(2032),
  [4646] = {.count = 1, .reusable = false}, SHIFT(2034),
  [4648] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4650] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4652] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4654] = {.count = 1, .reusable = false}, SHIFT(2037),
  [4656] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4658] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4660] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4662] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4664] = {.count = 1, .reusable = false}, SHIFT(2039),
  [4666] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4668] = {.count = 1, .reusable = false}, SHIFT(2042),
  [4670] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4672] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4674] = {.count = 1, .reusable = false}, SHIFT(2046),
  [4676] = {.count = 1, .reusable = true}, SHIFT(2049),
  [4678] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4680] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4682] = {.count = 1, .reusable = false}, SHIFT(2052),
  [4684] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4686] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4688] = {.count = 1, .reusable = false}, SHIFT(2054),
  [4690] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4692] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4694] = {.count = 1, .reusable = false}, SHIFT(2056),
  [4696] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4698] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4700] = {.count = 1, .reusable = true}, SHIFT(2058),
  [4702] = {.count = 1, .reusable = true}, SHIFT(2059),
  [4704] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4706] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4708] = {.count = 1, .reusable = true}, SHIFT(2062),
  [4710] = {.count = 1, .reusable = false}, SHIFT(2063),
  [4712] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4714] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4716] = {.count = 1, .reusable = false}, SHIFT(2065),
  [4718] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4720] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4722] = {.count = 1, .reusable = false}, SHIFT(2067),
  [4724] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4726] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4728] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4730] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4732] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4734] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4736] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4738] = {.count = 1, .reusable = false}, SHIFT(2074),
  [4740] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4742] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4744] = {.count = 1, .reusable = false}, SHIFT(2076),
  [4746] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4748] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4750] = {.count = 1, .reusable = false}, SHIFT(2078),
  [4752] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4754] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4756] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4758] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4760] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4762] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4764] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4766] = {.count = 1, .reusable = false}, SHIFT(2085),
  [4768] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4770] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4772] = {.count = 1, .reusable = false}, SHIFT(2087),
  [4774] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4776] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4778] = {.count = 1, .reusable = false}, SHIFT(2089),
  [4780] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4782] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4784] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4786] = {.count = 1, .reusable = true}, SHIFT(2092),
  [4788] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4790] = {.count = 1, .reusable = true}, SHIFT(2094),
  [4792] = {.count = 1, .reusable = true}, SHIFT(2095),
  [4794] = {.count = 1, .reusable = false}, SHIFT(2096),
  [4796] = {.count = 1, .reusable = true}, SHIFT(2096),
  [4798] = {.count = 1, .reusable = true}, SHIFT(2097),
  [4800] = {.count = 1, .reusable = false}, SHIFT(2098),
  [4802] = {.count = 1, .reusable = true}, SHIFT(2098),
  [4804] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4806] = {.count = 1, .reusable = false}, SHIFT(2100),
  [4808] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4810] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4812] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4814] = {.count = 1, .reusable = true}, SHIFT(2103),
  [4816] = {.count = 1, .reusable = true}, SHIFT(2104),
  [4818] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [4820] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4822] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [4824] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1300),
  [4827] = {.count = 1, .reusable = false}, SHIFT(2106),
  [4829] = {.count = 1, .reusable = true}, SHIFT(2107),
  [4831] = {.count = 1, .reusable = false}, SHIFT(2108),
  [4833] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4835] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4837] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4839] = {.count = 1, .reusable = false}, SHIFT(2114),
  [4841] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4843] = {.count = 1, .reusable = true}, SHIFT(2113),
  [4845] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4847] = {.count = 1, .reusable = false}, SHIFT(2117),
  [4849] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4851] = {.count = 1, .reusable = true}, SHIFT(2116),
  [4853] = {.count = 1, .reusable = false}, SHIFT(2119),
  [4855] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4857] = {.count = 1, .reusable = true}, SHIFT(2118),
  [4859] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4861] = {.count = 1, .reusable = true}, SHIFT(2121),
  [4863] = {.count = 1, .reusable = true}, SHIFT(2122),
  [4865] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4867] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4869] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4871] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4873] = {.count = 1, .reusable = false}, SHIFT(2126),
  [4875] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4877] = {.count = 1, .reusable = false}, SHIFT(2127),
  [4879] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4881] = {.count = 1, .reusable = true}, SHIFT(2129),
  [4883] = {.count = 1, .reusable = false}, SHIFT(2129),
  [4885] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 15),
  [4887] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 15),
  [4889] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [4891] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [4893] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 16),
  [4895] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 16),
  [4897] = {.count = 1, .reusable = true}, SHIFT(2130),
  [4899] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 17),
  [4901] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 17),
  [4903] = {.count = 1, .reusable = true}, SHIFT(2131),
  [4905] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 18),
  [4907] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 18),
  [4909] = {.count = 1, .reusable = true}, SHIFT(2132),
  [4911] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4913] = {.count = 1, .reusable = true}, SHIFT(2134),
  [4915] = {.count = 1, .reusable = false}, SHIFT(2135),
  [4917] = {.count = 1, .reusable = true}, SHIFT(2136),
  [4919] = {.count = 1, .reusable = true}, SHIFT(2138),
  [4921] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4923] = {.count = 1, .reusable = true}, SHIFT(2140),
  [4925] = {.count = 1, .reusable = true}, SHIFT(2141),
  [4927] = {.count = 1, .reusable = true}, SHIFT(2142),
  [4929] = {.count = 1, .reusable = true}, SHIFT(2143),
  [4931] = {.count = 1, .reusable = false}, SHIFT(2144),
  [4933] = {.count = 1, .reusable = true}, SHIFT(2144),
  [4935] = {.count = 1, .reusable = true}, SHIFT(2145),
  [4937] = {.count = 1, .reusable = false}, SHIFT(2146),
  [4939] = {.count = 1, .reusable = true}, SHIFT(2146),
  [4941] = {.count = 1, .reusable = true}, SHIFT(2147),
  [4943] = {.count = 1, .reusable = false}, SHIFT(2148),
  [4945] = {.count = 1, .reusable = true}, SHIFT(2148),
  [4947] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 10),
  [4949] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 10),
  [4951] = {.count = 1, .reusable = true}, SHIFT(2149),
  [4953] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4955] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 11),
  [4957] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 11),
  [4959] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4961] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4963] = {.count = 1, .reusable = true}, SHIFT(2151),
  [4965] = {.count = 1, .reusable = true}, SHIFT(2152),
  [4967] = {.count = 1, .reusable = true}, SHIFT(2154),
  [4969] = {.count = 1, .reusable = true}, SHIFT(2155),
  [4971] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1372),
  [4974] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1373),
  [4977] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1373),
  [4980] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1374),
  [4983] = {.count = 1, .reusable = true}, SHIFT(2157),
  [4985] = {.count = 1, .reusable = true}, SHIFT(2158),
  [4987] = {.count = 1, .reusable = false}, SHIFT(2159),
  [4989] = {.count = 1, .reusable = true}, SHIFT(2160),
  [4991] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4993] = {.count = 1, .reusable = true}, SHIFT(2163),
  [4995] = {.count = 1, .reusable = true}, SHIFT(2164),
  [4997] = {.count = 1, .reusable = true}, SHIFT(2165),
  [4999] = {.count = 1, .reusable = true}, SHIFT(2166),
  [5001] = {.count = 1, .reusable = true}, SHIFT(2167),
  [5003] = {.count = 1, .reusable = false}, SHIFT(2168),
  [5005] = {.count = 1, .reusable = true}, SHIFT(2168),
  [5007] = {.count = 1, .reusable = true}, SHIFT(2169),
  [5009] = {.count = 1, .reusable = false}, SHIFT(2170),
  [5011] = {.count = 1, .reusable = true}, SHIFT(2170),
  [5013] = {.count = 1, .reusable = true}, SHIFT(2171),
  [5015] = {.count = 1, .reusable = false}, SHIFT(2172),
  [5017] = {.count = 1, .reusable = true}, SHIFT(2172),
  [5019] = {.count = 1, .reusable = true}, SHIFT(2173),
  [5021] = {.count = 1, .reusable = true}, SHIFT(2174),
  [5023] = {.count = 1, .reusable = false}, SHIFT(2175),
  [5025] = {.count = 1, .reusable = true}, SHIFT(2176),
  [5027] = {.count = 1, .reusable = true}, SHIFT(2178),
  [5029] = {.count = 1, .reusable = true}, SHIFT(2179),
  [5031] = {.count = 1, .reusable = true}, SHIFT(2180),
  [5033] = {.count = 1, .reusable = true}, SHIFT(2181),
  [5035] = {.count = 1, .reusable = true}, SHIFT(2182),
  [5037] = {.count = 1, .reusable = true}, SHIFT(2183),
  [5039] = {.count = 1, .reusable = false}, SHIFT(2184),
  [5041] = {.count = 1, .reusable = true}, SHIFT(2184),
  [5043] = {.count = 1, .reusable = true}, SHIFT(2185),
  [5045] = {.count = 1, .reusable = false}, SHIFT(2186),
  [5047] = {.count = 1, .reusable = true}, SHIFT(2186),
  [5049] = {.count = 1, .reusable = true}, SHIFT(2187),
  [5051] = {.count = 1, .reusable = false}, SHIFT(2188),
  [5053] = {.count = 1, .reusable = true}, SHIFT(2188),
  [5055] = {.count = 1, .reusable = true}, SHIFT(2189),
  [5057] = {.count = 1, .reusable = true}, SHIFT(2190),
  [5059] = {.count = 1, .reusable = true}, SHIFT(2191),
  [5061] = {.count = 1, .reusable = true}, SHIFT(2192),
  [5063] = {.count = 1, .reusable = true}, SHIFT(2193),
  [5065] = {.count = 1, .reusable = false}, SHIFT(2194),
  [5067] = {.count = 1, .reusable = true}, SHIFT(2194),
  [5069] = {.count = 1, .reusable = true}, SHIFT(2195),
  [5071] = {.count = 1, .reusable = false}, SHIFT(2196),
  [5073] = {.count = 1, .reusable = true}, SHIFT(2196),
  [5075] = {.count = 1, .reusable = true}, SHIFT(2197),
  [5077] = {.count = 1, .reusable = false}, SHIFT(2198),
  [5079] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5081] = {.count = 1, .reusable = true}, SHIFT(2199),
  [5083] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5085] = {.count = 1, .reusable = true}, SHIFT(2201),
  [5087] = {.count = 1, .reusable = true}, SHIFT(2202),
  [5089] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1458),
  [5092] = {.count = 1, .reusable = false}, SHIFT(2203),
  [5094] = {.count = 1, .reusable = true}, SHIFT(2204),
  [5096] = {.count = 1, .reusable = false}, SHIFT(2205),
  [5098] = {.count = 1, .reusable = true}, SHIFT(2206),
  [5100] = {.count = 1, .reusable = true}, SHIFT(2208),
  [5102] = {.count = 1, .reusable = true}, SHIFT(2209),
  [5104] = {.count = 1, .reusable = false}, SHIFT(2211),
  [5106] = {.count = 1, .reusable = true}, SHIFT(2211),
  [5108] = {.count = 1, .reusable = true}, SHIFT(2210),
  [5110] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5112] = {.count = 1, .reusable = false}, SHIFT(2214),
  [5114] = {.count = 1, .reusable = true}, SHIFT(2214),
  [5116] = {.count = 1, .reusable = true}, SHIFT(2213),
  [5118] = {.count = 1, .reusable = false}, SHIFT(2216),
  [5120] = {.count = 1, .reusable = true}, SHIFT(2216),
  [5122] = {.count = 1, .reusable = true}, SHIFT(2215),
  [5124] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5126] = {.count = 1, .reusable = true}, SHIFT(2218),
  [5128] = {.count = 1, .reusable = true}, SHIFT(2219),
  [5130] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5132] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5134] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5136] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5138] = {.count = 1, .reusable = false}, SHIFT(2223),
  [5140] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5142] = {.count = 1, .reusable = false}, SHIFT(2224),
  [5144] = {.count = 1, .reusable = true}, SHIFT(2225),
  [5146] = {.count = 1, .reusable = true}, SHIFT(2226),
  [5148] = {.count = 1, .reusable = false}, SHIFT(2226),
  [5150] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 7),
  [5152] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 7),
  [5154] = {.count = 1, .reusable = true}, SHIFT(2228),
  [5156] = {.count = 1, .reusable = true}, SHIFT(2229),
  [5158] = {.count = 1, .reusable = true}, SHIFT(2230),
  [5160] = {.count = 1, .reusable = false}, SHIFT(2231),
  [5162] = {.count = 1, .reusable = true}, SHIFT(2231),
  [5164] = {.count = 1, .reusable = true}, SHIFT(2232),
  [5166] = {.count = 1, .reusable = false}, SHIFT(2233),
  [5168] = {.count = 1, .reusable = true}, SHIFT(2233),
  [5170] = {.count = 1, .reusable = true}, SHIFT(2234),
  [5172] = {.count = 1, .reusable = false}, SHIFT(2235),
  [5174] = {.count = 1, .reusable = true}, SHIFT(2235),
  [5176] = {.count = 1, .reusable = true}, SHIFT(2236),
  [5178] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5180] = {.count = 1, .reusable = true}, SHIFT(2238),
  [5182] = {.count = 1, .reusable = true}, SHIFT(2239),
  [5184] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5186] = {.count = 1, .reusable = true}, SHIFT(2241),
  [5188] = {.count = 1, .reusable = false}, SHIFT(2242),
  [5190] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5192] = {.count = 1, .reusable = true}, SHIFT(2245),
  [5194] = {.count = 1, .reusable = true}, SHIFT(2246),
  [5196] = {.count = 1, .reusable = true}, SHIFT(2247),
  [5198] = {.count = 1, .reusable = true}, SHIFT(2248),
  [5200] = {.count = 1, .reusable = true}, SHIFT(2249),
  [5202] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5204] = {.count = 1, .reusable = false}, SHIFT(2251),
  [5206] = {.count = 1, .reusable = true}, SHIFT(2251),
  [5208] = {.count = 1, .reusable = true}, SHIFT(2252),
  [5210] = {.count = 1, .reusable = false}, SHIFT(2253),
  [5212] = {.count = 1, .reusable = true}, SHIFT(2253),
  [5214] = {.count = 1, .reusable = true}, SHIFT(2254),
  [5216] = {.count = 1, .reusable = false}, SHIFT(2255),
  [5218] = {.count = 1, .reusable = true}, SHIFT(2255),
  [5220] = {.count = 1, .reusable = true}, SHIFT(2256),
  [5222] = {.count = 1, .reusable = true}, SHIFT(2257),
  [5224] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4),
  [5226] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [5228] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [5230] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 3),
  [5232] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [5234] = {.count = 1, .reusable = true}, SHIFT(2258),
  [5236] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [5238] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [5240] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [5242] = {.count = 1, .reusable = true}, SHIFT(2260),
  [5244] = {.count = 1, .reusable = true}, SHIFT(2263),
  [5246] = {.count = 1, .reusable = true}, SHIFT(2264),
  [5248] = {.count = 1, .reusable = true}, SHIFT(2265),
  [5250] = {.count = 1, .reusable = false}, SHIFT(2266),
  [5252] = {.count = 1, .reusable = true}, SHIFT(2267),
  [5254] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5256] = {.count = 1, .reusable = true}, SHIFT(2269),
  [5258] = {.count = 1, .reusable = true}, SHIFT(2270),
  [5260] = {.count = 1, .reusable = true}, SHIFT(2271),
  [5262] = {.count = 1, .reusable = false}, SHIFT(2272),
  [5264] = {.count = 1, .reusable = false}, SHIFT(2267),
  [5266] = {.count = 1, .reusable = true}, SHIFT(2275),
  [5268] = {.count = 1, .reusable = true}, SHIFT(2276),
  [5270] = {.count = 1, .reusable = false}, SHIFT(2277),
  [5272] = {.count = 1, .reusable = true}, SHIFT(2278),
  [5274] = {.count = 1, .reusable = true}, SHIFT(2279),
  [5276] = {.count = 1, .reusable = true}, SHIFT(2280),
  [5278] = {.count = 1, .reusable = true}, SHIFT(2281),
  [5280] = {.count = 1, .reusable = true}, SHIFT(2282),
  [5282] = {.count = 1, .reusable = false}, SHIFT(2283),
  [5284] = {.count = 1, .reusable = false}, SHIFT(2278),
  [5286] = {.count = 1, .reusable = true}, SHIFT(2285),
  [5288] = {.count = 1, .reusable = false}, SHIFT(2287),
  [5290] = {.count = 1, .reusable = false}, SHIFT(2288),
  [5292] = {.count = 1, .reusable = true}, SHIFT(2290),
  [5294] = {.count = 1, .reusable = true}, SHIFT(2291),
  [5296] = {.count = 1, .reusable = false}, SHIFT(2292),
  [5298] = {.count = 1, .reusable = false}, SHIFT(2290),
  [5300] = {.count = 1, .reusable = true}, SHIFT(2293),
  [5302] = {.count = 1, .reusable = true}, SHIFT(2294),
  [5304] = {.count = 1, .reusable = true}, SHIFT(2295),
  [5306] = {.count = 1, .reusable = false}, SHIFT(2296),
  [5308] = {.count = 1, .reusable = false}, SHIFT(2295),
  [5310] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5312] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [5314] = {.count = 1, .reusable = false}, SHIFT(2308),
  [5316] = {.count = 1, .reusable = true}, SHIFT(2309),
  [5318] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5320] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5322] = {.count = 1, .reusable = false}, SHIFT(2311),
  [5324] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5326] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5328] = {.count = 1, .reusable = false}, SHIFT(2313),
  [5330] = {.count = 1, .reusable = false}, SHIFT(2314),
  [5332] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5334] = {.count = 1, .reusable = true}, SHIFT(2315),
  [5336] = {.count = 1, .reusable = true}, SHIFT(2316),
  [5338] = {.count = 1, .reusable = true}, SHIFT(2317),
  [5340] = {.count = 1, .reusable = false}, SHIFT(2317),
  [5342] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5344] = {.count = 1, .reusable = true}, SHIFT(1960),
  [5346] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(1544),
  [5349] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [5351] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [5353] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [5355] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3),
  [5357] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5359] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5361] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 19),
  [5363] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 19),
  [5365] = {.count = 1, .reusable = true}, SHIFT(2331),
  [5367] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5369] = {.count = 1, .reusable = true}, SHIFT(2335),
  [5371] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 20),
  [5373] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 20),
  [5375] = {.count = 1, .reusable = true}, SHIFT(2336),
  [5377] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5381] = {.count = 1, .reusable = true}, SHIFT(2339),
  [5383] = {.count = 1, .reusable = true}, SHIFT(2342),
  [5385] = {.count = 1, .reusable = true}, SHIFT(2343),
  [5387] = {.count = 1, .reusable = true}, SHIFT(2344),
  [5389] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1616),
  [5392] = {.count = 1, .reusable = false}, SHIFT(2345),
  [5394] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5396] = {.count = 1, .reusable = false}, SHIFT(2347),
  [5398] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5400] = {.count = 1, .reusable = true}, SHIFT(2350),
  [5402] = {.count = 1, .reusable = true}, SHIFT(2351),
  [5404] = {.count = 1, .reusable = false}, SHIFT(2353),
  [5406] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5408] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5410] = {.count = 1, .reusable = true}, SHIFT(2354),
  [5412] = {.count = 1, .reusable = false}, SHIFT(2356),
  [5414] = {.count = 1, .reusable = true}, SHIFT(2356),
  [5416] = {.count = 1, .reusable = true}, SHIFT(2355),
  [5418] = {.count = 1, .reusable = false}, SHIFT(2358),
  [5420] = {.count = 1, .reusable = true}, SHIFT(2358),
  [5422] = {.count = 1, .reusable = true}, SHIFT(2357),
  [5424] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5426] = {.count = 1, .reusable = true}, SHIFT(2360),
  [5428] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5430] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5432] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5434] = {.count = 1, .reusable = true}, SHIFT(2364),
  [5436] = {.count = 1, .reusable = true}, SHIFT(2365),
  [5438] = {.count = 1, .reusable = false}, SHIFT(2365),
  [5440] = {.count = 1, .reusable = true}, SHIFT(2366),
  [5442] = {.count = 1, .reusable = false}, SHIFT(2366),
  [5444] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5446] = {.count = 1, .reusable = true}, SHIFT(2368),
  [5448] = {.count = 1, .reusable = false}, SHIFT(2368),
  [5450] = {.count = 1, .reusable = true}, SHIFT(2369),
  [5452] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5454] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5456] = {.count = 1, .reusable = true}, SHIFT(2372),
  [5458] = {.count = 1, .reusable = true}, SHIFT(2373),
  [5460] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5462] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5464] = {.count = 1, .reusable = true}, SHIFT(2376),
  [5466] = {.count = 1, .reusable = true}, SHIFT(2377),
  [5468] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5470] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5472] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5474] = {.count = 1, .reusable = true}, SHIFT(2381),
  [5476] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5478] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5480] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [5482] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [5484] = {.count = 1, .reusable = true}, SHIFT(2384),
  [5486] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5488] = {.count = 1, .reusable = false}, SHIFT(2386),
  [5490] = {.count = 1, .reusable = true}, SHIFT(2387),
  [5492] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5494] = {.count = 1, .reusable = true}, SHIFT(2390),
  [5496] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5498] = {.count = 1, .reusable = true}, SHIFT(2392),
  [5500] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5502] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5504] = {.count = 1, .reusable = false}, SHIFT(2395),
  [5506] = {.count = 1, .reusable = true}, SHIFT(2395),
  [5508] = {.count = 1, .reusable = true}, SHIFT(2396),
  [5510] = {.count = 1, .reusable = false}, SHIFT(2397),
  [5512] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5514] = {.count = 1, .reusable = true}, SHIFT(2398),
  [5516] = {.count = 1, .reusable = false}, SHIFT(2399),
  [5518] = {.count = 1, .reusable = true}, SHIFT(2399),
  [5520] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5522] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5524] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 16),
  [5526] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 16),
  [5528] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 17),
  [5530] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 17),
  [5532] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 18),
  [5534] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 18),
  [5536] = {.count = 1, .reusable = true}, SHIFT(2402),
  [5538] = {.count = 1, .reusable = true}, SHIFT(2403),
  [5540] = {.count = 1, .reusable = true}, SHIFT(2404),
  [5542] = {.count = 1, .reusable = false}, SHIFT(2405),
  [5544] = {.count = 1, .reusable = true}, SHIFT(2405),
  [5546] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5548] = {.count = 1, .reusable = false}, SHIFT(2407),
  [5550] = {.count = 1, .reusable = true}, SHIFT(2407),
  [5552] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5554] = {.count = 1, .reusable = false}, SHIFT(2409),
  [5556] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5558] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5560] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5562] = {.count = 1, .reusable = true}, SHIFT(2412),
  [5564] = {.count = 1, .reusable = true}, SHIFT(2415),
  [5566] = {.count = 1, .reusable = true}, SHIFT(2416),
  [5568] = {.count = 1, .reusable = true}, SHIFT(2417),
  [5570] = {.count = 1, .reusable = false}, SHIFT(2418),
  [5572] = {.count = 1, .reusable = true}, SHIFT(2418),
  [5574] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5576] = {.count = 1, .reusable = false}, SHIFT(2420),
  [5578] = {.count = 1, .reusable = true}, SHIFT(2420),
  [5580] = {.count = 1, .reusable = true}, SHIFT(2421),
  [5582] = {.count = 1, .reusable = false}, SHIFT(2422),
  [5584] = {.count = 1, .reusable = true}, SHIFT(2422),
  [5586] = {.count = 1, .reusable = true}, SHIFT(2423),
  [5588] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5590] = {.count = 1, .reusable = true}, SHIFT(2425),
  [5592] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5594] = {.count = 1, .reusable = true}, SHIFT(2427),
  [5596] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5598] = {.count = 1, .reusable = false}, SHIFT(2429),
  [5600] = {.count = 1, .reusable = true}, SHIFT(2429),
  [5602] = {.count = 1, .reusable = true}, SHIFT(2430),
  [5604] = {.count = 1, .reusable = false}, SHIFT(2431),
  [5606] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5608] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5610] = {.count = 1, .reusable = false}, SHIFT(2433),
  [5612] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5614] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5616] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5618] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5620] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5622] = {.count = 1, .reusable = true}, SHIFT(2438),
  [5624] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5626] = {.count = 1, .reusable = true}, SHIFT(2440),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5630] = {.count = 1, .reusable = false}, SHIFT(2442),
  [5632] = {.count = 1, .reusable = true}, SHIFT(2443),
  [5634] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5636] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5640] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5642] = {.count = 1, .reusable = true}, SHIFT(2449),
  [5644] = {.count = 1, .reusable = true}, SHIFT(2450),
  [5646] = {.count = 1, .reusable = false}, SHIFT(2451),
  [5648] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5650] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5652] = {.count = 1, .reusable = false}, SHIFT(2453),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5656] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5658] = {.count = 1, .reusable = false}, SHIFT(2455),
  [5660] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5662] = {.count = 1, .reusable = true}, SHIFT(2456),
  [5664] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5666] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 8),
  [5668] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 8),
  [5670] = {.count = 1, .reusable = true}, SHIFT(2458),
  [5672] = {.count = 1, .reusable = true}, SHIFT(2459),
  [5674] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5676] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5678] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5680] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5682] = {.count = 1, .reusable = false}, SHIFT(2465),
  [5684] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5686] = {.count = 1, .reusable = true}, SHIFT(2466),
  [5688] = {.count = 1, .reusable = false}, SHIFT(2467),
  [5690] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5692] = {.count = 1, .reusable = true}, SHIFT(2468),
  [5694] = {.count = 1, .reusable = false}, SHIFT(2469),
  [5696] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5698] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5700] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5702] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5704] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5706] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5708] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5710] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5712] = {.count = 1, .reusable = false}, SHIFT(2477),
  [5714] = {.count = 1, .reusable = true}, SHIFT(2478),
  [5716] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5718] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5720] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5722] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5724] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5726] = {.count = 1, .reusable = true}, SHIFT(2486),
  [5728] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5730] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5732] = {.count = 1, .reusable = false}, SHIFT(2490),
  [5734] = {.count = 1, .reusable = false}, SHIFT(2491),
  [5736] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5738] = {.count = 1, .reusable = true}, SHIFT(2494),
  [5740] = {.count = 1, .reusable = false}, SHIFT(2495),
  [5742] = {.count = 1, .reusable = false}, SHIFT(2493),
  [5744] = {.count = 1, .reusable = true}, SHIFT(2496),
  [5746] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5748] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5750] = {.count = 1, .reusable = false}, SHIFT(2499),
  [5752] = {.count = 1, .reusable = false}, SHIFT(2498),
  [5754] = {.count = 1, .reusable = true}, SHIFT(2511),
  [5756] = {.count = 1, .reusable = false}, SHIFT(2513),
  [5758] = {.count = 1, .reusable = false}, SHIFT(2514),
  [5760] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5762] = {.count = 1, .reusable = true}, SHIFT(2517),
  [5764] = {.count = 1, .reusable = false}, SHIFT(2518),
  [5766] = {.count = 1, .reusable = false}, SHIFT(2516),
  [5768] = {.count = 1, .reusable = true}, SHIFT(2519),
  [5770] = {.count = 1, .reusable = true}, SHIFT(2520),
  [5772] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5774] = {.count = 1, .reusable = false}, SHIFT(2522),
  [5776] = {.count = 1, .reusable = false}, SHIFT(2521),
  [5778] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5780] = {.count = 1, .reusable = false}, SHIFT(2536),
  [5782] = {.count = 1, .reusable = false}, SHIFT(2537),
  [5784] = {.count = 1, .reusable = true}, SHIFT(2538),
  [5786] = {.count = 1, .reusable = true}, SHIFT(2539),
  [5788] = {.count = 1, .reusable = true}, SHIFT(2540),
  [5790] = {.count = 1, .reusable = false}, SHIFT(2541),
  [5792] = {.count = 1, .reusable = false}, SHIFT(2540),
  [5794] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5796] = {.count = 1, .reusable = false}, SHIFT(2545),
  [5798] = {.count = 1, .reusable = true}, SHIFT(2545),
  [5800] = {.count = 1, .reusable = true}, SHIFT(2544),
  [5802] = {.count = 1, .reusable = true}, SHIFT(2546),
  [5804] = {.count = 1, .reusable = false}, SHIFT(2548),
  [5806] = {.count = 1, .reusable = true}, SHIFT(2548),
  [5808] = {.count = 1, .reusable = true}, SHIFT(2547),
  [5810] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5812] = {.count = 1, .reusable = false}, SHIFT(2551),
  [5814] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5816] = {.count = 1, .reusable = true}, SHIFT(2550),
  [5818] = {.count = 1, .reusable = true}, SHIFT(2552),
  [5820] = {.count = 1, .reusable = true}, SHIFT(2553),
  [5822] = {.count = 1, .reusable = false}, SHIFT(2553),
  [5824] = {.count = 1, .reusable = true}, SHIFT(2556),
  [5826] = {.count = 1, .reusable = false}, SHIFT(2556),
  [5828] = {.count = 1, .reusable = true}, SHIFT(2559),
  [5830] = {.count = 1, .reusable = true}, SHIFT(2560),
  [5832] = {.count = 1, .reusable = false}, SHIFT(2560),
  [5834] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5836] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [5838] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5840] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5842] = {.count = 1, .reusable = false}, SHIFT(2567),
  [5844] = {.count = 1, .reusable = true}, SHIFT(2567),
  [5846] = {.count = 1, .reusable = false}, SHIFT(2568),
  [5848] = {.count = 1, .reusable = false}, SHIFT(1961),
  [5850] = {.count = 1, .reusable = false}, SHIFT(2569),
  [5852] = {.count = 1, .reusable = false}, SHIFT(1964),
  [5854] = {.count = 1, .reusable = false}, SHIFT(1965),
  [5856] = {.count = 1, .reusable = false}, SHIFT(1966),
  [5858] = {.count = 1, .reusable = false}, SHIFT(1967),
  [5860] = {.count = 1, .reusable = false}, SHIFT(2570),
  [5862] = {.count = 1, .reusable = true}, SHIFT(2571),
  [5864] = {.count = 1, .reusable = true}, SHIFT(2572),
  [5866] = {.count = 1, .reusable = false}, SHIFT(2573),
  [5868] = {.count = 1, .reusable = true}, SHIFT(2574),
  [5870] = {.count = 1, .reusable = true}, SHIFT(2575),
  [5872] = {.count = 1, .reusable = true}, SHIFT(2576),
  [5874] = {.count = 1, .reusable = true}, SHIFT(2577),
  [5876] = {.count = 1, .reusable = true}, SHIFT(2578),
  [5878] = {.count = 1, .reusable = true}, SHIFT(2579),
  [5880] = {.count = 1, .reusable = true}, SHIFT(2580),
  [5882] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [5884] = {.count = 1, .reusable = true}, SHIFT(2584),
  [5886] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5888] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [5890] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [5892] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [5894] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4),
  [5896] = {.count = 1, .reusable = true}, SHIFT(2591),
  [5898] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5900] = {.count = 1, .reusable = true}, SHIFT(2595),
  [5902] = {.count = 1, .reusable = true}, SHIFT(2599),
  [5904] = {.count = 1, .reusable = true}, SHIFT(2600),
  [5906] = {.count = 1, .reusable = true}, SHIFT(2604),
  [5908] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 21),
  [5910] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 21),
  [5912] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 22),
  [5914] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 22),
  [5916] = {.count = 1, .reusable = true}, SHIFT(2605),
  [5918] = {.count = 1, .reusable = true}, SHIFT(2606),
  [5920] = {.count = 1, .reusable = false}, SHIFT(2607),
  [5922] = {.count = 1, .reusable = true}, SHIFT(2608),
  [5924] = {.count = 1, .reusable = true}, SHIFT(2610),
  [5926] = {.count = 1, .reusable = true}, SHIFT(2611),
  [5928] = {.count = 1, .reusable = true}, SHIFT(2612),
  [5930] = {.count = 1, .reusable = true}, SHIFT(2613),
  [5932] = {.count = 1, .reusable = true}, SHIFT(2614),
  [5934] = {.count = 1, .reusable = true}, SHIFT(2615),
  [5936] = {.count = 1, .reusable = false}, SHIFT(2616),
  [5938] = {.count = 1, .reusable = true}, SHIFT(2616),
  [5940] = {.count = 1, .reusable = true}, SHIFT(2617),
  [5942] = {.count = 1, .reusable = false}, SHIFT(2618),
  [5944] = {.count = 1, .reusable = true}, SHIFT(2618),
  [5946] = {.count = 1, .reusable = true}, SHIFT(2619),
  [5948] = {.count = 1, .reusable = false}, SHIFT(2620),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2620),
  [5952] = {.count = 1, .reusable = true}, SHIFT(2621),
  [5954] = {.count = 1, .reusable = true}, SHIFT(2622),
  [5956] = {.count = 1, .reusable = true}, SHIFT(2623),
  [5958] = {.count = 1, .reusable = true}, SHIFT(2624),
  [5960] = {.count = 1, .reusable = true}, SHIFT(2625),
  [5962] = {.count = 1, .reusable = false}, SHIFT(2626),
  [5964] = {.count = 1, .reusable = true}, SHIFT(2626),
  [5966] = {.count = 1, .reusable = true}, SHIFT(2627),
  [5968] = {.count = 1, .reusable = false}, SHIFT(2628),
  [5970] = {.count = 1, .reusable = true}, SHIFT(2628),
  [5972] = {.count = 1, .reusable = true}, SHIFT(2629),
  [5974] = {.count = 1, .reusable = false}, SHIFT(2630),
  [5976] = {.count = 1, .reusable = true}, SHIFT(2630),
  [5978] = {.count = 1, .reusable = true}, SHIFT(2631),
  [5980] = {.count = 1, .reusable = true}, SHIFT(2632),
  [5982] = {.count = 1, .reusable = true}, SHIFT(2633),
  [5984] = {.count = 1, .reusable = true}, SHIFT(2634),
  [5986] = {.count = 1, .reusable = true}, SHIFT(2635),
  [5988] = {.count = 1, .reusable = true}, SHIFT(2636),
  [5990] = {.count = 1, .reusable = true}, SHIFT(2637),
  [5992] = {.count = 1, .reusable = true}, SHIFT(2638),
  [5994] = {.count = 1, .reusable = true}, SHIFT(2639),
  [5996] = {.count = 1, .reusable = true}, SHIFT(2640),
  [5998] = {.count = 1, .reusable = true}, SHIFT(2641),
  [6000] = {.count = 1, .reusable = true}, SHIFT(2642),
  [6002] = {.count = 1, .reusable = true}, SHIFT(2643),
  [6004] = {.count = 1, .reusable = true}, SHIFT(2644),
  [6006] = {.count = 1, .reusable = true}, SHIFT(2645),
  [6008] = {.count = 1, .reusable = false}, SHIFT(2646),
  [6010] = {.count = 1, .reusable = true}, SHIFT(2646),
  [6012] = {.count = 1, .reusable = true}, SHIFT(2647),
  [6014] = {.count = 1, .reusable = false}, SHIFT(2648),
  [6016] = {.count = 1, .reusable = true}, SHIFT(2648),
  [6018] = {.count = 1, .reusable = true}, SHIFT(2649),
  [6020] = {.count = 1, .reusable = false}, SHIFT(2650),
  [6022] = {.count = 1, .reusable = true}, SHIFT(2650),
  [6024] = {.count = 1, .reusable = true}, SHIFT(2651),
  [6026] = {.count = 1, .reusable = true}, SHIFT(2652),
  [6028] = {.count = 1, .reusable = true}, SHIFT(2653),
  [6030] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 9),
  [6032] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 9),
  [6034] = {.count = 1, .reusable = true}, SHIFT(2654),
  [6036] = {.count = 1, .reusable = true}, SHIFT(2655),
  [6038] = {.count = 1, .reusable = true}, SHIFT(2656),
  [6040] = {.count = 1, .reusable = true}, SHIFT(2657),
  [6042] = {.count = 1, .reusable = true}, SHIFT(2659),
  [6044] = {.count = 1, .reusable = false}, SHIFT(2661),
  [6046] = {.count = 1, .reusable = false}, SHIFT(2662),
  [6048] = {.count = 1, .reusable = true}, SHIFT(2664),
  [6050] = {.count = 1, .reusable = true}, SHIFT(2665),
  [6052] = {.count = 1, .reusable = false}, SHIFT(2666),
  [6054] = {.count = 1, .reusable = false}, SHIFT(2664),
  [6056] = {.count = 1, .reusable = true}, SHIFT(2667),
  [6058] = {.count = 1, .reusable = true}, SHIFT(2668),
  [6060] = {.count = 1, .reusable = true}, SHIFT(2669),
  [6062] = {.count = 1, .reusable = false}, SHIFT(2670),
  [6064] = {.count = 1, .reusable = false}, SHIFT(2669),
  [6066] = {.count = 1, .reusable = true}, SHIFT(2682),
  [6068] = {.count = 1, .reusable = true}, SHIFT(2683),
  [6070] = {.count = 1, .reusable = false}, SHIFT(2684),
  [6072] = {.count = 1, .reusable = true}, SHIFT(2684),
  [6074] = {.count = 1, .reusable = true}, SHIFT(2685),
  [6076] = {.count = 1, .reusable = false}, SHIFT(2686),
  [6078] = {.count = 1, .reusable = true}, SHIFT(2686),
  [6080] = {.count = 1, .reusable = true}, SHIFT(2687),
  [6082] = {.count = 1, .reusable = true}, SHIFT(2689),
  [6084] = {.count = 1, .reusable = true}, SHIFT(2690),
  [6086] = {.count = 1, .reusable = true}, SHIFT(2691),
  [6088] = {.count = 1, .reusable = true}, SHIFT(2692),
  [6090] = {.count = 1, .reusable = true}, SHIFT(2693),
  [6092] = {.count = 1, .reusable = false}, SHIFT(2695),
  [6094] = {.count = 1, .reusable = false}, SHIFT(2696),
  [6096] = {.count = 1, .reusable = true}, SHIFT(2697),
  [6098] = {.count = 1, .reusable = true}, SHIFT(2698),
  [6100] = {.count = 1, .reusable = true}, SHIFT(2699),
  [6102] = {.count = 1, .reusable = false}, SHIFT(2700),
  [6104] = {.count = 1, .reusable = false}, SHIFT(2699),
  [6106] = {.count = 1, .reusable = true}, SHIFT(2702),
  [6108] = {.count = 1, .reusable = false}, SHIFT(2704),
  [6110] = {.count = 1, .reusable = true}, SHIFT(2704),
  [6112] = {.count = 1, .reusable = true}, SHIFT(2703),
  [6114] = {.count = 1, .reusable = true}, SHIFT(2705),
  [6116] = {.count = 1, .reusable = false}, SHIFT(2707),
  [6118] = {.count = 1, .reusable = true}, SHIFT(2707),
  [6120] = {.count = 1, .reusable = true}, SHIFT(2706),
  [6122] = {.count = 1, .reusable = true}, SHIFT(2708),
  [6124] = {.count = 1, .reusable = false}, SHIFT(2710),
  [6126] = {.count = 1, .reusable = true}, SHIFT(2710),
  [6128] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6130] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6132] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6134] = {.count = 1, .reusable = false}, SHIFT(2712),
  [6136] = {.count = 1, .reusable = true}, SHIFT(2715),
  [6138] = {.count = 1, .reusable = false}, SHIFT(2715),
  [6140] = {.count = 1, .reusable = true}, SHIFT(2718),
  [6142] = {.count = 1, .reusable = true}, SHIFT(2719),
  [6144] = {.count = 1, .reusable = false}, SHIFT(2719),
  [6146] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2263),
  [6149] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2264),
  [6152] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2265),
  [6155] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2266),
  [6158] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2267),
  [6161] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2268),
  [6164] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2269),
  [6167] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2270),
  [6170] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2271),
  [6173] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2272),
  [6176] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2267),
  [6179] = {.count = 1, .reusable = true}, SHIFT(2722),
  [6181] = {.count = 1, .reusable = false}, SHIFT(2724),
  [6183] = {.count = 1, .reusable = false}, SHIFT(2725),
  [6185] = {.count = 1, .reusable = true}, SHIFT(2726),
  [6187] = {.count = 1, .reusable = true}, SHIFT(2727),
  [6189] = {.count = 1, .reusable = true}, SHIFT(2728),
  [6191] = {.count = 1, .reusable = false}, SHIFT(2729),
  [6193] = {.count = 1, .reusable = false}, SHIFT(2728),
  [6195] = {.count = 1, .reusable = true}, SHIFT(2731),
  [6197] = {.count = 1, .reusable = false}, SHIFT(2733),
  [6199] = {.count = 1, .reusable = true}, SHIFT(2733),
  [6201] = {.count = 1, .reusable = true}, SHIFT(2732),
  [6203] = {.count = 1, .reusable = true}, SHIFT(2734),
  [6205] = {.count = 1, .reusable = false}, SHIFT(2736),
  [6207] = {.count = 1, .reusable = true}, SHIFT(2736),
  [6209] = {.count = 1, .reusable = true}, SHIFT(2735),
  [6211] = {.count = 1, .reusable = true}, SHIFT(2737),
  [6213] = {.count = 1, .reusable = false}, SHIFT(2739),
  [6215] = {.count = 1, .reusable = true}, SHIFT(2739),
  [6217] = {.count = 1, .reusable = true}, SHIFT(2738),
  [6219] = {.count = 1, .reusable = true}, SHIFT(2740),
  [6221] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6223] = {.count = 1, .reusable = false}, SHIFT(2741),
  [6225] = {.count = 1, .reusable = true}, SHIFT(2744),
  [6227] = {.count = 1, .reusable = false}, SHIFT(2744),
  [6229] = {.count = 1, .reusable = true}, SHIFT(2747),
  [6231] = {.count = 1, .reusable = true}, SHIFT(2748),
  [6233] = {.count = 1, .reusable = false}, SHIFT(2748),
  [6235] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2275),
  [6238] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2276),
  [6241] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2277),
  [6244] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2278),
  [6247] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2279),
  [6250] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2280),
  [6253] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2281),
  [6256] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2282),
  [6259] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2283),
  [6262] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2278),
  [6265] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2285),
  [6268] = {.count = 1, .reusable = false}, SHIFT(2751),
  [6270] = {.count = 1, .reusable = true}, SHIFT(2752),
  [6272] = {.count = 1, .reusable = false}, SHIFT(2753),
  [6274] = {.count = 1, .reusable = true}, SHIFT(2754),
  [6276] = {.count = 1, .reusable = true}, SHIFT(2756),
  [6278] = {.count = 1, .reusable = true}, SHIFT(2757),
  [6280] = {.count = 1, .reusable = false}, SHIFT(2759),
  [6282] = {.count = 1, .reusable = true}, SHIFT(2759),
  [6284] = {.count = 1, .reusable = true}, SHIFT(2758),
  [6286] = {.count = 1, .reusable = true}, SHIFT(2760),
  [6288] = {.count = 1, .reusable = false}, SHIFT(2762),
  [6290] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6292] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6294] = {.count = 1, .reusable = false}, SHIFT(2764),
  [6296] = {.count = 1, .reusable = true}, SHIFT(2764),
  [6298] = {.count = 1, .reusable = true}, SHIFT(2763),
  [6300] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6302] = {.count = 1, .reusable = true}, SHIFT(2766),
  [6304] = {.count = 1, .reusable = true}, SHIFT(2767),
  [6306] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6308] = {.count = 1, .reusable = true}, SHIFT(2769),
  [6310] = {.count = 1, .reusable = true}, SHIFT(2770),
  [6312] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6314] = {.count = 1, .reusable = false}, SHIFT(2771),
  [6316] = {.count = 1, .reusable = true}, SHIFT(2772),
  [6318] = {.count = 1, .reusable = false}, SHIFT(2772),
  [6320] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6322] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6324] = {.count = 1, .reusable = false}, SHIFT(2774),
  [6326] = {.count = 1, .reusable = true}, SHIFT(2776),
  [6328] = {.count = 1, .reusable = true}, SHIFT(2777),
  [6330] = {.count = 1, .reusable = true}, SHIFT(2778),
  [6332] = {.count = 1, .reusable = false}, SHIFT(2780),
  [6334] = {.count = 1, .reusable = false}, SHIFT(2781),
  [6336] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6338] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6340] = {.count = 1, .reusable = false}, SHIFT(2785),
  [6342] = {.count = 1, .reusable = false}, SHIFT(2783),
  [6344] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6346] = {.count = 1, .reusable = true}, SHIFT(2787),
  [6348] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6350] = {.count = 1, .reusable = false}, SHIFT(2789),
  [6352] = {.count = 1, .reusable = false}, SHIFT(2788),
  [6354] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2312),
  [6357] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2314),
  [6360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2314),
  [6363] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2315),
  [6366] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2313),
  [6369] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2316),
  [6372] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1961),
  [6375] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1962),
  [6378] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2317),
  [6381] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1964),
  [6384] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1965),
  [6387] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1966),
  [6390] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1967),
  [6393] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2317),
  [6396] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [6398] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [6400] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [6402] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [6404] = {.count = 1, .reusable = true}, SHIFT(2801),
  [6406] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [6408] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [6410] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [6412] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 5),
  [6414] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6416] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6418] = {.count = 1, .reusable = true}, SHIFT(2804),
  [6420] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6422] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6424] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6426] = {.count = 1, .reusable = true}, SHIFT(2815),
  [6428] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6430] = {.count = 1, .reusable = false}, SHIFT(2817),
  [6432] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6434] = {.count = 1, .reusable = true}, SHIFT(2818),
  [6436] = {.count = 1, .reusable = false}, SHIFT(2819),
  [6438] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6440] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6442] = {.count = 1, .reusable = false}, SHIFT(2821),
  [6444] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6446] = {.count = 1, .reusable = true}, SHIFT(2822),
  [6448] = {.count = 1, .reusable = true}, SHIFT(2823),
  [6450] = {.count = 1, .reusable = true}, SHIFT(2824),
  [6452] = {.count = 1, .reusable = true}, SHIFT(2825),
  [6454] = {.count = 1, .reusable = true}, SHIFT(2826),
  [6456] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6458] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6460] = {.count = 1, .reusable = true}, SHIFT(2829),
  [6462] = {.count = 1, .reusable = true}, SHIFT(2830),
  [6464] = {.count = 1, .reusable = true}, SHIFT(2831),
  [6466] = {.count = 1, .reusable = true}, SHIFT(2832),
  [6468] = {.count = 1, .reusable = false}, SHIFT(2834),
  [6470] = {.count = 1, .reusable = false}, SHIFT(2835),
  [6472] = {.count = 1, .reusable = true}, SHIFT(2836),
  [6474] = {.count = 1, .reusable = true}, SHIFT(2837),
  [6476] = {.count = 1, .reusable = true}, SHIFT(2838),
  [6478] = {.count = 1, .reusable = false}, SHIFT(2839),
  [6480] = {.count = 1, .reusable = false}, SHIFT(2838),
  [6482] = {.count = 1, .reusable = true}, SHIFT(2841),
  [6484] = {.count = 1, .reusable = false}, SHIFT(2843),
  [6486] = {.count = 1, .reusable = true}, SHIFT(2843),
  [6488] = {.count = 1, .reusable = true}, SHIFT(2842),
  [6490] = {.count = 1, .reusable = true}, SHIFT(2844),
  [6492] = {.count = 1, .reusable = false}, SHIFT(2846),
  [6494] = {.count = 1, .reusable = true}, SHIFT(2846),
  [6496] = {.count = 1, .reusable = true}, SHIFT(2845),
  [6498] = {.count = 1, .reusable = true}, SHIFT(2847),
  [6500] = {.count = 1, .reusable = false}, SHIFT(2849),
  [6502] = {.count = 1, .reusable = true}, SHIFT(2849),
  [6504] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6506] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6508] = {.count = 1, .reusable = true}, SHIFT(2851),
  [6510] = {.count = 1, .reusable = false}, SHIFT(2851),
  [6512] = {.count = 1, .reusable = true}, SHIFT(2854),
  [6514] = {.count = 1, .reusable = false}, SHIFT(2854),
  [6516] = {.count = 1, .reusable = true}, SHIFT(2857),
  [6518] = {.count = 1, .reusable = true}, SHIFT(2858),
  [6520] = {.count = 1, .reusable = false}, SHIFT(2858),
  [6522] = {.count = 1, .reusable = false}, SHIFT(2862),
  [6524] = {.count = 1, .reusable = true}, SHIFT(2862),
  [6526] = {.count = 1, .reusable = true}, SHIFT(2863),
  [6528] = {.count = 1, .reusable = true}, SHIFT(2864),
  [6530] = {.count = 1, .reusable = false}, SHIFT(2865),
  [6532] = {.count = 1, .reusable = true}, SHIFT(2865),
  [6534] = {.count = 1, .reusable = true}, SHIFT(2866),
  [6536] = {.count = 1, .reusable = true}, SHIFT(2867),
  [6538] = {.count = 1, .reusable = true}, SHIFT(2868),
  [6540] = {.count = 1, .reusable = true}, SHIFT(2869),
  [6542] = {.count = 1, .reusable = true}, SHIFT(2871),
  [6544] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2488),
  [6547] = {.count = 1, .reusable = false}, SHIFT(2873),
  [6549] = {.count = 1, .reusable = true}, SHIFT(2874),
  [6551] = {.count = 1, .reusable = false}, SHIFT(2875),
  [6553] = {.count = 1, .reusable = true}, SHIFT(2876),
  [6555] = {.count = 1, .reusable = true}, SHIFT(2878),
  [6557] = {.count = 1, .reusable = true}, SHIFT(2879),
  [6559] = {.count = 1, .reusable = false}, SHIFT(2881),
  [6561] = {.count = 1, .reusable = true}, SHIFT(2881),
  [6563] = {.count = 1, .reusable = true}, SHIFT(2880),
  [6565] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6567] = {.count = 1, .reusable = false}, SHIFT(2884),
  [6569] = {.count = 1, .reusable = true}, SHIFT(2884),
  [6571] = {.count = 1, .reusable = true}, SHIFT(2883),
  [6573] = {.count = 1, .reusable = false}, SHIFT(2886),
  [6575] = {.count = 1, .reusable = true}, SHIFT(2886),
  [6577] = {.count = 1, .reusable = true}, SHIFT(2885),
  [6579] = {.count = 1, .reusable = true}, SHIFT(2887),
  [6581] = {.count = 1, .reusable = true}, SHIFT(2888),
  [6583] = {.count = 1, .reusable = true}, SHIFT(2889),
  [6585] = {.count = 1, .reusable = true}, SHIFT(2890),
  [6587] = {.count = 1, .reusable = true}, SHIFT(2891),
  [6589] = {.count = 1, .reusable = true}, SHIFT(2892),
  [6591] = {.count = 1, .reusable = true}, SHIFT(2893),
  [6593] = {.count = 1, .reusable = false}, SHIFT(2893),
  [6595] = {.count = 1, .reusable = true}, SHIFT(2894),
  [6597] = {.count = 1, .reusable = false}, SHIFT(2894),
  [6599] = {.count = 1, .reusable = true}, SHIFT(2895),
  [6601] = {.count = 1, .reusable = true}, SHIFT(2896),
  [6603] = {.count = 1, .reusable = false}, SHIFT(2896),
  [6605] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2511),
  [6608] = {.count = 1, .reusable = false}, SHIFT(2897),
  [6610] = {.count = 1, .reusable = true}, SHIFT(2898),
  [6612] = {.count = 1, .reusable = false}, SHIFT(2899),
  [6614] = {.count = 1, .reusable = true}, SHIFT(2900),
  [6616] = {.count = 1, .reusable = true}, SHIFT(2902),
  [6618] = {.count = 1, .reusable = true}, SHIFT(2903),
  [6620] = {.count = 1, .reusable = false}, SHIFT(2905),
  [6622] = {.count = 1, .reusable = true}, SHIFT(2905),
  [6624] = {.count = 1, .reusable = true}, SHIFT(2904),
  [6626] = {.count = 1, .reusable = true}, SHIFT(2906),
  [6628] = {.count = 1, .reusable = false}, SHIFT(2908),
  [6630] = {.count = 1, .reusable = true}, SHIFT(2908),
  [6632] = {.count = 1, .reusable = true}, SHIFT(2907),
  [6634] = {.count = 1, .reusable = false}, SHIFT(2910),
  [6636] = {.count = 1, .reusable = true}, SHIFT(2910),
  [6638] = {.count = 1, .reusable = true}, SHIFT(2909),
  [6640] = {.count = 1, .reusable = true}, SHIFT(2911),
  [6642] = {.count = 1, .reusable = true}, SHIFT(2912),
  [6644] = {.count = 1, .reusable = true}, SHIFT(2913),
  [6646] = {.count = 1, .reusable = true}, SHIFT(2914),
  [6648] = {.count = 1, .reusable = true}, SHIFT(2915),
  [6650] = {.count = 1, .reusable = true}, SHIFT(2916),
  [6652] = {.count = 1, .reusable = true}, SHIFT(2917),
  [6654] = {.count = 1, .reusable = false}, SHIFT(2917),
  [6656] = {.count = 1, .reusable = true}, SHIFT(2918),
  [6658] = {.count = 1, .reusable = false}, SHIFT(2918),
  [6660] = {.count = 1, .reusable = true}, SHIFT(2919),
  [6662] = {.count = 1, .reusable = true}, SHIFT(2920),
  [6664] = {.count = 1, .reusable = false}, SHIFT(2920),
  [6666] = {.count = 1, .reusable = true}, SHIFT(2921),
  [6668] = {.count = 1, .reusable = true}, SHIFT(2922),
  [6670] = {.count = 1, .reusable = false}, SHIFT(2923),
  [6672] = {.count = 1, .reusable = true}, SHIFT(2924),
  [6674] = {.count = 1, .reusable = true}, SHIFT(2926),
  [6676] = {.count = 1, .reusable = true}, SHIFT(2927),
  [6678] = {.count = 1, .reusable = true}, SHIFT(2928),
  [6680] = {.count = 1, .reusable = true}, SHIFT(2929),
  [6682] = {.count = 1, .reusable = true}, SHIFT(2930),
  [6684] = {.count = 1, .reusable = true}, SHIFT(2931),
  [6686] = {.count = 1, .reusable = false}, SHIFT(2932),
  [6688] = {.count = 1, .reusable = true}, SHIFT(2932),
  [6690] = {.count = 1, .reusable = true}, SHIFT(2933),
  [6692] = {.count = 1, .reusable = false}, SHIFT(2934),
  [6694] = {.count = 1, .reusable = true}, SHIFT(2934),
  [6696] = {.count = 1, .reusable = true}, SHIFT(2935),
  [6698] = {.count = 1, .reusable = false}, SHIFT(2936),
  [6700] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6702] = {.count = 1, .reusable = true}, SHIFT(2937),
  [6704] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6706] = {.count = 1, .reusable = true}, SHIFT(2939),
  [6708] = {.count = 1, .reusable = false}, SHIFT(2941),
  [6710] = {.count = 1, .reusable = false}, SHIFT(2942),
  [6712] = {.count = 1, .reusable = true}, SHIFT(2943),
  [6714] = {.count = 1, .reusable = true}, SHIFT(2944),
  [6716] = {.count = 1, .reusable = true}, SHIFT(2945),
  [6718] = {.count = 1, .reusable = false}, SHIFT(2946),
  [6720] = {.count = 1, .reusable = false}, SHIFT(2945),
  [6722] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6724] = {.count = 1, .reusable = false}, SHIFT(2950),
  [6726] = {.count = 1, .reusable = true}, SHIFT(2950),
  [6728] = {.count = 1, .reusable = true}, SHIFT(2949),
  [6730] = {.count = 1, .reusable = true}, SHIFT(2951),
  [6732] = {.count = 1, .reusable = false}, SHIFT(2953),
  [6734] = {.count = 1, .reusable = true}, SHIFT(2953),
  [6736] = {.count = 1, .reusable = true}, SHIFT(2952),
  [6738] = {.count = 1, .reusable = true}, SHIFT(2954),
  [6740] = {.count = 1, .reusable = false}, SHIFT(2956),
  [6742] = {.count = 1, .reusable = true}, SHIFT(2956),
  [6744] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6746] = {.count = 1, .reusable = true}, SHIFT(2957),
  [6748] = {.count = 1, .reusable = true}, SHIFT(2958),
  [6750] = {.count = 1, .reusable = false}, SHIFT(2958),
  [6752] = {.count = 1, .reusable = true}, SHIFT(2961),
  [6754] = {.count = 1, .reusable = false}, SHIFT(2961),
  [6756] = {.count = 1, .reusable = true}, SHIFT(2964),
  [6758] = {.count = 1, .reusable = true}, SHIFT(2965),
  [6760] = {.count = 1, .reusable = false}, SHIFT(2965),
  [6762] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6, .alias_sequence_id = 1),
  [6764] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6766] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6768] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6),
  [6770] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6),
  [6772] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6),
  [6774] = {.count = 1, .reusable = true}, SHIFT(2968),
  [6776] = {.count = 1, .reusable = true}, SHIFT(2969),
  [6778] = {.count = 1, .reusable = true}, SHIFT(2972),
  [6780] = {.count = 1, .reusable = true}, SHIFT(2973),
  [6782] = {.count = 1, .reusable = true}, SHIFT(2976),
  [6784] = {.count = 1, .reusable = true}, SHIFT(2977),
  [6786] = {.count = 1, .reusable = true}, SHIFT(2978),
  [6788] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2659),
  [6791] = {.count = 1, .reusable = false}, SHIFT(2979),
  [6793] = {.count = 1, .reusable = true}, SHIFT(2980),
  [6795] = {.count = 1, .reusable = false}, SHIFT(2981),
  [6797] = {.count = 1, .reusable = true}, SHIFT(2982),
  [6799] = {.count = 1, .reusable = true}, SHIFT(2984),
  [6801] = {.count = 1, .reusable = true}, SHIFT(2985),
  [6803] = {.count = 1, .reusable = false}, SHIFT(2987),
  [6805] = {.count = 1, .reusable = true}, SHIFT(2987),
  [6807] = {.count = 1, .reusable = true}, SHIFT(2986),
  [6809] = {.count = 1, .reusable = true}, SHIFT(2988),
  [6811] = {.count = 1, .reusable = false}, SHIFT(2990),
  [6813] = {.count = 1, .reusable = true}, SHIFT(2990),
  [6815] = {.count = 1, .reusable = true}, SHIFT(2989),
  [6817] = {.count = 1, .reusable = false}, SHIFT(2992),
  [6819] = {.count = 1, .reusable = true}, SHIFT(2992),
  [6821] = {.count = 1, .reusable = true}, SHIFT(2991),
  [6823] = {.count = 1, .reusable = true}, SHIFT(2993),
  [6825] = {.count = 1, .reusable = true}, SHIFT(2994),
  [6827] = {.count = 1, .reusable = true}, SHIFT(2995),
  [6829] = {.count = 1, .reusable = true}, SHIFT(2996),
  [6831] = {.count = 1, .reusable = true}, SHIFT(2997),
  [6833] = {.count = 1, .reusable = true}, SHIFT(2998),
  [6835] = {.count = 1, .reusable = true}, SHIFT(2999),
  [6837] = {.count = 1, .reusable = false}, SHIFT(2999),
  [6839] = {.count = 1, .reusable = true}, SHIFT(3000),
  [6841] = {.count = 1, .reusable = false}, SHIFT(3000),
  [6843] = {.count = 1, .reusable = true}, SHIFT(3001),
  [6845] = {.count = 1, .reusable = true}, SHIFT(3002),
  [6847] = {.count = 1, .reusable = false}, SHIFT(3002),
  [6849] = {.count = 1, .reusable = true}, SHIFT(3003),
  [6851] = {.count = 1, .reusable = true}, SHIFT(3004),
  [6853] = {.count = 1, .reusable = true}, SHIFT(3006),
  [6855] = {.count = 1, .reusable = true}, SHIFT(3007),
  [6857] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2685),
  [6860] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2686),
  [6863] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2686),
  [6866] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2687),
  [6869] = {.count = 1, .reusable = true}, SHIFT(3009),
  [6871] = {.count = 1, .reusable = true}, SHIFT(3010),
  [6873] = {.count = 1, .reusable = true}, SHIFT(3011),
  [6875] = {.count = 1, .reusable = false}, SHIFT(3012),
  [6877] = {.count = 1, .reusable = true}, SHIFT(3013),
  [6879] = {.count = 1, .reusable = true}, SHIFT(3015),
  [6881] = {.count = 1, .reusable = true}, SHIFT(3016),
  [6883] = {.count = 1, .reusable = true}, SHIFT(3017),
  [6885] = {.count = 1, .reusable = true}, SHIFT(3018),
  [6887] = {.count = 1, .reusable = true}, SHIFT(3019),
  [6889] = {.count = 1, .reusable = true}, SHIFT(3020),
  [6891] = {.count = 1, .reusable = false}, SHIFT(3021),
  [6893] = {.count = 1, .reusable = true}, SHIFT(3021),
  [6895] = {.count = 1, .reusable = true}, SHIFT(3022),
  [6897] = {.count = 1, .reusable = false}, SHIFT(3023),
  [6899] = {.count = 1, .reusable = true}, SHIFT(3023),
  [6901] = {.count = 1, .reusable = true}, SHIFT(3024),
  [6903] = {.count = 1, .reusable = false}, SHIFT(3025),
  [6905] = {.count = 1, .reusable = true}, SHIFT(3025),
  [6907] = {.count = 1, .reusable = true}, SHIFT(3026),
  [6909] = {.count = 1, .reusable = true}, SHIFT(3027),
  [6911] = {.count = 1, .reusable = true}, SHIFT(3028),
  [6913] = {.count = 1, .reusable = true}, SHIFT(3029),
  [6915] = {.count = 1, .reusable = false}, SHIFT(3030),
  [6917] = {.count = 1, .reusable = true}, SHIFT(3031),
  [6919] = {.count = 1, .reusable = true}, SHIFT(3033),
  [6921] = {.count = 1, .reusable = true}, SHIFT(3034),
  [6923] = {.count = 1, .reusable = true}, SHIFT(3035),
  [6925] = {.count = 1, .reusable = true}, SHIFT(3036),
  [6927] = {.count = 1, .reusable = true}, SHIFT(3037),
  [6929] = {.count = 1, .reusable = true}, SHIFT(3038),
  [6931] = {.count = 1, .reusable = false}, SHIFT(3039),
  [6933] = {.count = 1, .reusable = true}, SHIFT(3039),
  [6935] = {.count = 1, .reusable = true}, SHIFT(3040),
  [6937] = {.count = 1, .reusable = false}, SHIFT(3041),
  [6939] = {.count = 1, .reusable = true}, SHIFT(3041),
  [6941] = {.count = 1, .reusable = true}, SHIFT(3042),
  [6943] = {.count = 1, .reusable = false}, SHIFT(3043),
  [6945] = {.count = 1, .reusable = true}, SHIFT(3043),
  [6947] = {.count = 1, .reusable = true}, SHIFT(3044),
  [6949] = {.count = 1, .reusable = true}, SHIFT(3045),
  [6951] = {.count = 1, .reusable = true}, SHIFT(3046),
  [6953] = {.count = 1, .reusable = true}, SHIFT(3047),
  [6955] = {.count = 1, .reusable = true}, SHIFT(3048),
  [6957] = {.count = 1, .reusable = false}, SHIFT(3049),
  [6959] = {.count = 1, .reusable = true}, SHIFT(3049),
  [6961] = {.count = 1, .reusable = true}, SHIFT(3050),
  [6963] = {.count = 1, .reusable = false}, SHIFT(3051),
  [6965] = {.count = 1, .reusable = true}, SHIFT(3051),
  [6967] = {.count = 1, .reusable = true}, SHIFT(3052),
  [6969] = {.count = 1, .reusable = false}, SHIFT(3053),
  [6971] = {.count = 1, .reusable = true}, SHIFT(3053),
  [6973] = {.count = 1, .reusable = true}, SHIFT(3054),
  [6975] = {.count = 1, .reusable = true}, SHIFT(3055),
  [6977] = {.count = 1, .reusable = true}, SHIFT(3056),
  [6979] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2778),
  [6982] = {.count = 1, .reusable = false}, SHIFT(3057),
  [6984] = {.count = 1, .reusable = true}, SHIFT(3058),
  [6986] = {.count = 1, .reusable = false}, SHIFT(3059),
  [6988] = {.count = 1, .reusable = true}, SHIFT(3060),
  [6990] = {.count = 1, .reusable = true}, SHIFT(3062),
  [6992] = {.count = 1, .reusable = true}, SHIFT(3063),
  [6994] = {.count = 1, .reusable = false}, SHIFT(3065),
  [6996] = {.count = 1, .reusable = true}, SHIFT(3065),
  [6998] = {.count = 1, .reusable = true}, SHIFT(3064),
  [7000] = {.count = 1, .reusable = true}, SHIFT(3066),
  [7002] = {.count = 1, .reusable = false}, SHIFT(3068),
  [7004] = {.count = 1, .reusable = true}, SHIFT(3068),
  [7006] = {.count = 1, .reusable = true}, SHIFT(3067),
  [7008] = {.count = 1, .reusable = false}, SHIFT(3070),
  [7010] = {.count = 1, .reusable = true}, SHIFT(3070),
  [7012] = {.count = 1, .reusable = true}, SHIFT(3069),
  [7014] = {.count = 1, .reusable = true}, SHIFT(3071),
  [7016] = {.count = 1, .reusable = true}, SHIFT(3072),
  [7018] = {.count = 1, .reusable = true}, SHIFT(3073),
  [7020] = {.count = 1, .reusable = true}, SHIFT(3074),
  [7022] = {.count = 1, .reusable = true}, SHIFT(3075),
  [7024] = {.count = 1, .reusable = true}, SHIFT(3076),
  [7026] = {.count = 1, .reusable = true}, SHIFT(3077),
  [7028] = {.count = 1, .reusable = false}, SHIFT(3077),
  [7030] = {.count = 1, .reusable = true}, SHIFT(3078),
  [7032] = {.count = 1, .reusable = false}, SHIFT(3078),
  [7034] = {.count = 1, .reusable = true}, SHIFT(3079),
  [7036] = {.count = 1, .reusable = true}, SHIFT(3080),
  [7038] = {.count = 1, .reusable = false}, SHIFT(3080),
  [7040] = {.count = 1, .reusable = true}, SHIFT(3081),
  [7042] = {.count = 1, .reusable = true}, SHIFT(3082),
  [7044] = {.count = 1, .reusable = true}, SHIFT(3083),
  [7046] = {.count = 1, .reusable = true}, SHIFT(3084),
  [7048] = {.count = 1, .reusable = false}, SHIFT(3085),
  [7050] = {.count = 1, .reusable = true}, SHIFT(3086),
  [7052] = {.count = 1, .reusable = true}, SHIFT(3088),
  [7054] = {.count = 1, .reusable = true}, SHIFT(3089),
  [7056] = {.count = 1, .reusable = true}, SHIFT(3090),
  [7058] = {.count = 1, .reusable = true}, SHIFT(3091),
  [7060] = {.count = 1, .reusable = true}, SHIFT(3092),
  [7062] = {.count = 1, .reusable = true}, SHIFT(3093),
  [7064] = {.count = 1, .reusable = false}, SHIFT(3094),
  [7066] = {.count = 1, .reusable = true}, SHIFT(3094),
  [7068] = {.count = 1, .reusable = true}, SHIFT(3095),
  [7070] = {.count = 1, .reusable = false}, SHIFT(3096),
  [7072] = {.count = 1, .reusable = true}, SHIFT(3096),
  [7074] = {.count = 1, .reusable = true}, SHIFT(3097),
  [7076] = {.count = 1, .reusable = false}, SHIFT(3098),
  [7078] = {.count = 1, .reusable = true}, SHIFT(3098),
  [7080] = {.count = 1, .reusable = true}, SHIFT(3099),
  [7082] = {.count = 1, .reusable = true}, SHIFT(3100),
  [7084] = {.count = 1, .reusable = true}, SHIFT(3103),
  [7086] = {.count = 1, .reusable = true}, SHIFT(3104),
  [7088] = {.count = 1, .reusable = true}, SHIFT(3105),
  [7090] = {.count = 1, .reusable = false}, SHIFT(3106),
  [7092] = {.count = 1, .reusable = true}, SHIFT(3106),
  [7094] = {.count = 1, .reusable = true}, SHIFT(3107),
  [7096] = {.count = 1, .reusable = false}, SHIFT(3108),
  [7098] = {.count = 1, .reusable = true}, SHIFT(3108),
  [7100] = {.count = 1, .reusable = true}, SHIFT(3109),
  [7102] = {.count = 1, .reusable = false}, SHIFT(3110),
  [7104] = {.count = 1, .reusable = true}, SHIFT(3110),
  [7106] = {.count = 1, .reusable = true}, SHIFT(3111),
  [7108] = {.count = 1, .reusable = true}, SHIFT(3112),
  [7110] = {.count = 1, .reusable = true}, SHIFT(3113),
  [7112] = {.count = 1, .reusable = true}, SHIFT(3114),
  [7114] = {.count = 1, .reusable = true}, SHIFT(3115),
  [7116] = {.count = 1, .reusable = true}, SHIFT(3116),
  [7118] = {.count = 1, .reusable = false}, SHIFT(3117),
  [7120] = {.count = 1, .reusable = true}, SHIFT(3117),
  [7122] = {.count = 1, .reusable = true}, SHIFT(3118),
  [7124] = {.count = 1, .reusable = false}, SHIFT(3119),
  [7126] = {.count = 1, .reusable = true}, SHIFT(3119),
  [7128] = {.count = 1, .reusable = true}, SHIFT(3120),
  [7130] = {.count = 1, .reusable = false}, SHIFT(3121),
  [7132] = {.count = 1, .reusable = true}, SHIFT(3121),
  [7134] = {.count = 1, .reusable = true}, SHIFT(3122),
  [7136] = {.count = 1, .reusable = true}, SHIFT(3123),
  [7138] = {.count = 1, .reusable = true}, SHIFT(3124),
  [7140] = {.count = 1, .reusable = true}, SHIFT(3125),
  [7142] = {.count = 1, .reusable = true}, SHIFT(3126),
  [7144] = {.count = 1, .reusable = true}, SHIFT(3127),
  [7146] = {.count = 1, .reusable = true}, SHIFT(3128),
  [7148] = {.count = 1, .reusable = true}, SHIFT(3129),
  [7150] = {.count = 1, .reusable = false}, SHIFT(3130),
  [7152] = {.count = 1, .reusable = true}, SHIFT(3131),
  [7154] = {.count = 1, .reusable = true}, SHIFT(3133),
  [7156] = {.count = 1, .reusable = true}, SHIFT(3134),
  [7158] = {.count = 1, .reusable = true}, SHIFT(3135),
  [7160] = {.count = 1, .reusable = true}, SHIFT(3136),
  [7162] = {.count = 1, .reusable = true}, SHIFT(3137),
  [7164] = {.count = 1, .reusable = true}, SHIFT(3138),
  [7166] = {.count = 1, .reusable = false}, SHIFT(3139),
  [7168] = {.count = 1, .reusable = true}, SHIFT(3139),
  [7170] = {.count = 1, .reusable = true}, SHIFT(3140),
  [7172] = {.count = 1, .reusable = false}, SHIFT(3141),
  [7174] = {.count = 1, .reusable = true}, SHIFT(3141),
  [7176] = {.count = 1, .reusable = true}, SHIFT(3142),
  [7178] = {.count = 1, .reusable = false}, SHIFT(3143),
  [7180] = {.count = 1, .reusable = true}, SHIFT(3143),
  [7182] = {.count = 1, .reusable = true}, SHIFT(3144),
  [7184] = {.count = 1, .reusable = true}, SHIFT(3145),
  [7186] = {.count = 1, .reusable = true}, SHIFT(3146),
  [7188] = {.count = 1, .reusable = true}, SHIFT(3147),
  [7190] = {.count = 1, .reusable = true}, SHIFT(3148),
  [7192] = {.count = 1, .reusable = false}, SHIFT(3149),
  [7194] = {.count = 1, .reusable = true}, SHIFT(3149),
  [7196] = {.count = 1, .reusable = true}, SHIFT(3150),
  [7198] = {.count = 1, .reusable = false}, SHIFT(3151),
  [7200] = {.count = 1, .reusable = true}, SHIFT(3151),
  [7202] = {.count = 1, .reusable = true}, SHIFT(3152),
  [7204] = {.count = 1, .reusable = false}, SHIFT(3153),
  [7206] = {.count = 1, .reusable = true}, SHIFT(3153),
  [7208] = {.count = 1, .reusable = true}, SHIFT(3154),
  [7210] = {.count = 1, .reusable = true}, SHIFT(3155),
  [7212] = {.count = 1, .reusable = true}, SHIFT(3156),
  [7214] = {.count = 1, .reusable = true}, SHIFT(3157),
  [7216] = {.count = 1, .reusable = true}, SHIFT(3158),
  [7218] = {.count = 1, .reusable = true}, SHIFT(3159),
  [7220] = {.count = 1, .reusable = true}, SHIFT(3160),
  [7222] = {.count = 1, .reusable = true}, SHIFT(3161),
  [7224] = {.count = 1, .reusable = true}, SHIFT(3162),
  [7226] = {.count = 1, .reusable = true}, SHIFT(3163),
  [7228] = {.count = 1, .reusable = true}, SHIFT(3164),
  [7230] = {.count = 1, .reusable = true}, SHIFT(3165),
  [7232] = {.count = 1, .reusable = false}, SHIFT(3166),
  [7234] = {.count = 1, .reusable = true}, SHIFT(3166),
  [7236] = {.count = 1, .reusable = true}, SHIFT(3167),
  [7238] = {.count = 1, .reusable = false}, SHIFT(3168),
  [7240] = {.count = 1, .reusable = true}, SHIFT(3168),
  [7242] = {.count = 1, .reusable = true}, SHIFT(3169),
  [7244] = {.count = 1, .reusable = false}, SHIFT(3170),
  [7246] = {.count = 1, .reusable = true}, SHIFT(3170),
  [7248] = {.count = 1, .reusable = true}, SHIFT(3171),
  [7250] = {.count = 1, .reusable = true}, SHIFT(3172),
  [7252] = {.count = 1, .reusable = true}, SHIFT(3173),
  [7254] = {.count = 1, .reusable = true}, SHIFT(3174),
  [7256] = {.count = 1, .reusable = true}, SHIFT(3175),
  [7258] = {.count = 1, .reusable = true}, SHIFT(3176),
  [7260] = {.count = 1, .reusable = true}, SHIFT(3177),
  [7262] = {.count = 1, .reusable = true}, SHIFT(3178),
  [7264] = {.count = 1, .reusable = true}, SHIFT(3179),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_word,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
